
<%@ page import="com.hp.mx.core.automation.*,
               com.hp.mx.startup.*,
               com.hp.mx.utilities.*,
               java.util.*,
               java.io.*"
         errorPage="handleJspError.jsp"
%>

<%@ page import="com.hp.mx.core.subjects.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>

<%
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    //
    // if the user isn't authorized.
    if ( !loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.DEBUG_PRIVILEGE))
    {
%>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
<%
    }
%>

<HTML>
<HEAD>


    <STYLE TYPE="text/css">
    <!--
        A.subSectionMenu {font-family:arial; font-size:10pt; font-weight:normal; background:#006699; color:white; text-align:right;}
    -->
    </STYLE>
</HEAD>

<%!
String compareStore = "";
String cname = "";
String componentName = "";

public void writeOneComponent(JspWriter out, Construction.Location loc, Hashtable theVisitedList)
{
    try
    {

        if (loc.getTruePath() != null)
        {
            ManagementAutomatable nextC = loc.getTruePath().getComponent();
            String str = nextC.ComponentName();
            String searchStr = str;
            if (theVisitedList.get(searchStr) != null)
            {
                return;
            }
            theVisitedList.put(searchStr,searchStr);

            if (str.equals(componentName))
            {
                out.print(nextC.getDetailHtml(false));
            }


            writeOneComponent(out, loc.getTruePath(),  theVisitedList);
        }

        if (loc.getFalsePath() != null)
        {
            ManagementAutomatable nextC = loc.getFalsePath().getComponent();
            String str = nextC.ComponentName();
            String searchStr = str;
            if (theVisitedList.get(searchStr) != null)
            {
                return;
            }
            theVisitedList.put(searchStr,searchStr);
            if (str.equals(componentName))
            {
                out.print(nextC.getDetailHtml(false));
            }

            writeOneComponent(out, loc.getFalsePath(), theVisitedList);
        }
    }
    catch (Exception ex)
    {
    }


}

%>


<%
    compareStore = request.getParameter("store");
    cname = request.getParameter("construction");
    componentName = request.getParameter("component");
    Hashtable  visited = new Hashtable();

    Hashtable allConstructions = ConstructionWrapper.getAllConstructions();
    Enumeration els = allConstructions.keys();
    while (els.hasMoreElements())
    {
        String store = (String) els.nextElement();
        if (store.equals(compareStore) == false)
            continue;
        Vector constructions = (Vector) allConstructions.get(store);
        Enumeration clist = constructions.elements();
        while (clist.hasMoreElements())
        {
            ConstructionWrapper c = (ConstructionWrapper) clist.nextElement();
            String name = c.getConstructionName();
            if (name.equals(cname))
            {

%>

<body>

<h2>Construction :
<%=name%>
</h2>

<table border="1" width="100%" cellspacing="1" cellpadding="3" height="54">
  <tr class=groupBoxHeader>
    <td width="14%"  height="19"><SPAN class=groupBoxHeader >Run Count</SPAN></td>
    <td width="14%" height="19"><SPAN class=groupBoxHeader >Time Started Run</SPAN></td>
    <td width="14%" height="19"><SPAN class=groupBoxHeader >Last Time Completed Run</SPAN></td>
    <td width="14%"  height="19"><SPAN class=groupBoxHeader >Elapsed Time</SPAN></td>
    <td width="14%"  height="19"><SPAN class=groupBoxHeader >Avg Run Time(ms)</SPAN></td>
    <td width="15%"  height="19"><SPAN class=groupBoxHeader >Longest Run(ms)</SPAN></td>
    <td width="7%"  height="19"><SPAN class=groupBoxHeader >Errors?</SPAN></td>
    <td width="8%" height="19"><SPAN class=groupBoxHeader >Running?</SPAN></td>
  </tr>

<%



                out.print("<tr class=groupBoxData>\n<td width=\"14%\" height=\"15\">");
                int runcount = c.getRunCount();
                out.print("" + runcount);

                long startedrun = c.getTimeStarted();
                out.print("</td>\n      <td width=\"14%\" height=\"15\">");
                if (startedrun == 0)
                    out.print("never");
                else
                {
                    Date d = new Date(startedrun);
                    out.print(d.toString());
                }
                out.print("</td>\n      <td width=\"14%\" height=\"15\">");
                long lastrun = c.getLastTimeRun();
                if (lastrun == 0)
                    out.print("never completed a run");
                else
                {
                    Date d = new Date(lastrun);
                    out.print(d.toString());
                }

                out.print("</td>\n      <td width=\"14%\" height=\"15\">");
                int elapsed = c.getElapsed();
                if (elapsed > 1000)
                    out.print("" + ((float)elapsed)/1000 + " (s)");
                else
                    out.print("" + elapsed + " (ms)");


                out.print("</td>\n      <td width=\"14%\" height=\"15\">");
                int avg = 0;
                if (runcount > 0)
                    avg = elapsed / runcount;
                out.print("" + avg);

                out.print("</td>\n      <td width=\"15%\" height=\"15\">");
                int longest = c.getLongestRun();
                out.print(""+longest);

                out.print("</td>\n      <td width=\"7%\" height=\"15\">");
                try
                {
                    if ( c.hasErrors() )
                         out.print("<font color=red><strong>yes("+c.getErrorCount()+")</strong></font>");
                    else
                        out.print("no");
                }
                catch (Exception e)
                {
                    out.print("Not Loaded");
                }


                out.print("</td>\n      <td width=\"8%\" height=\"15\">");
                try
                {
                    if (c.getIsLoaded())
                    {
                        if (c.amIRunning())
                            out.print("yes");
                        else
                            out.print("no");
                    }
                    else
                    {
                        out.print("Not Loaded");
                    }
                }
                catch (Exception e)
                {
                    out.print("Not Loaded");
                }
               out.print("</td>\n</tr></table>");


%>


<p>&nbsp;</p>

<table border="1" width="100%" cellspacing="1" cellpadding="3" height="54">
  <tr class=groupBoxHeader>
    <td width="14%" height="19"><SPAN class=groupBoxHeader >Queue Size</SPAN></td>
    <td width="14%" height="19"><SPAN class=groupBoxHeader >Max Queue Size</SPAN></td>
    <td width="25%" height="19"><SPAN class=groupBoxHeader >Component</SPAN></td>
    <td width="40%" height="19"><SPAN class=groupBoxHeader >Details</SPAN></td>
  </tr>
  <tr class=groupBoxData>
    <td width="14%" height="19">
<%
                out.print("" + c.getQueueSize());
%>
</td>
    <td width="14%" height="19">
<%
                out.print("" + c.getMaxQueueSize());
%>
</td>
    <td width="25%" height="15">
<%
                try
                {
                    out.print(c.getLocationStr());
                }
                catch (Exception e)
                {
                    out.print("&nbsp;");
                }
%>
</td>
    <td width="50%" height="15">
<%

                try
                {
                    if (c.GetDebugInfo().length() > 0)
                    {
                        out.print(c.GetDebugInfo());
                    }
                    else
                    {
                        out.print("none available");
                    }
                }
                catch (Exception e)
                {
                    out.print("&nbsp;");
                }

%>
</td>
  </tr>
</table>
<p>&nbsp;</p>
<strong>Details from the component...</strong>
<br>
<%
                    try
                    {
                        writeOneComponent(out, c.getConstruction().getStartLocation(), visited);
                    }
                    catch (Exception ex)
                    {
                        out.print("<tr><td>Exeption on trace "+ex+"</td></tr>");
                    }


            }
        }
    }
%>


</body>
</html>



