
<%@ page import="java.util.*,
                 com.hp.mx.startup.*"
%>
<%@ page import="com.hp.mx.core.tools.datacollection.plugin.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.core.subjects.*" %>
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>

<%
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    //
    // if the user isn't authorized.
    if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.DEBUG_PRIVILEGE))
    {
%>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
<%
    }

    // read the form data and act on it
    String testResult = "";
    if (request.getMethod().equalsIgnoreCase("POST"))
    {
        String fileName = request.getParameter("pluginFile");
        String op = request.getParameter("operation");
        if (fileName == null || fileName.equals("") || op == null ||
            (!op.equals("add") && !op.equals("remove")))
        {
            testResult = "Must supply a filename and select an operation!";
        }
        else
        {
            testResult = "Results for " + fileName + ", ";
            testResult += "operation " + op + ", ";

            DcPluginSupport dcpi = new DcPluginSupport();
            String problemText = null;
            try
            {
                if (op.equals("add"))
                {
                    dcpi.addDcDefinitions(fileName);
                }
                else if (op.equals("remove"))
                {
                    dcpi.removeDcDefinitions(fileName);
                }
                dcpi.commit();
            }
            catch (Exception e)
            {
                problemText = e.getMessage();
            }

            if (problemText == null)
            {
                testResult += "No problems reported.";
            }
            else
            {
                testResult += "Problem: " + problemText;
            }
        }

    }

%>

<HTML>
<HEAD>

<BR><BR>
<LINK REL=STYLESHEET TYPE="text/css" HREF="../StyleSheets/XeBaseStyles.css">
    <script language="JavaScript" src="../javascript/XeGlobalFunctions.js"></script>
    <script language="JavaScript" src="../javascript/XeHelp.js"></script>
    <script language="JavaScript" src="../javascript/layout.js"></script>

</HEAD>
<BODY>

<FORM name="piTest" action="dbgDcPluginTest.jsp" method="post">

<table width=100% border=1 cellspacing=0 cellpadding=1 align=CENTER bgcolor=#CCCCCC bordercolor=#000000>
<tr bgcolor=#006699>
    <th colspan=11 style='font-family:verdana; font-size:12pt; color:white'>
        Data Collection Plug-In Definitions Test
    </th>
</tr>
<tr>
    <td width='25%'>Definition XML filename:</td>
    <td><input size='80' type="text" value="" name="pluginFile"></td>
</tr>
</table>
<br>
<center>
Operation:
    <input type='radio' name='operation' id='add' value='add'> Add file
    <input type='radio' name='operation' id='remove' value='remove'> Remove file
</center>
<br>
<center>
    <input type="submit"  value="Process File">
</center>
</FORM>
<br>
<br>
<%=testResult%>

</BODY>
</HTML>
