
<%@ page info="HP Systems Insight Manager"%>
<%@ page import="com.hp.mx.core.controllers.AlertController" %>
<%@ page import="com.hp.mx.core.alertmanager.AlertObject" %>
<%@ page import="com.hp.mx.core.nodemanager.MxNode" %>
<%@ page import="com.hp.mx.core.alertmanager.AlertSeverity" %>
<%@ page import="com.hp.mx.core.alertmanager.AlertState" %>
<%@ page import="com.hp.mx.core.alertmanager.AlertTypeObject" %>
<%@ page import="com.hp.mx.core.tools.discovery.DiscoverTheCMSLocalHost" %>
<%@ page import="com.hp.mx.core.subjects.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>

<%
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    //
    // if the user isn't authorized.
    if ( !loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.DEBUG_PRIVILEGE))
    {
%>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
<%
    }

    boolean wasPost = false;
    String eventCnt = "25";
    if (request.getParameter( "eventCount" ) != null)
    {
        eventCnt = request.getParameter( "eventCount" );
        wasPost = true;
    }


%>

<HTML>
<HEAD>




<LINK REL=STYLESHEET TYPE="text/css" HREF="../StyleSheets/XeBaseStyles.css">
    <script language="JavaScript" src="../javascript/XeGlobalFunctions.js"></script>
    <script language="JavaScript" src="../javascript/XeHelp.js"></script>
    <script language="JavaScript" src="../javascript/layout.js"></script>



</HEAD>
<BODY>
This page will test how long it takes to add the number of device status change events/alerts
to the database. This uses the controller APIs directly.
<FORM name="myForm" action="dbgEventPerformanceTest.jsp" method="post">
<br>

    <table>
    <tr><td>Enter the number of events to create</td><td> <input type="text" value="<%=eventCnt %>"  name="eventCount"></td></tr>
    </table>

    <br>
        <input type="submit"  value="RUN">

</form>
<%
    if (wasPost)
    {
        %>
        Running Test...<br>
        <%
        try
        {
            AlertController ac = AlertController.getDefaultController();
            AlertObject oneAlert;
            AlertTypeObject devStatusChange ;
            MxNode theCms = DiscoverTheCMSLocalHost.getTheXeDevice();

            devStatusChange = ac.getAlertType("hp.nodestatus.unreachable");

            int cnt = Integer.parseInt(eventCnt);
            long stTime = System.currentTimeMillis();

            for (int i = 0; i < cnt; i++)
            {
                oneAlert = new AlertObject();
                oneAlert.setDeviceKey(theCms.getDeviceKey());
                oneAlert.setSeverity(AlertSeverity.CRITICAL);
                oneAlert.setAlertTypeObj(devStatusChange);
                oneAlert.setState(AlertState.ACTIVE.getEventStateId());
                ac.addAlert(oneAlert);

            }
            long et = System.currentTimeMillis();
            out.println("<br>It took ");
            out.print((et-stTime));
            out.print(" milliseconds ");

        }
        catch (Exception ex)
        {
            out.println(ex);
        }

    }
    %>
</BODY>
</HTML>

