
<%@ page info="HP Systems Insight Manager"
    import="com.hp.mx.database.*,
            java.sql.Connection,
              java.sql.ResultSet,
              java.sql.Statement"
%>
<%@ page import="com.hp.mx.core.subjects.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.utilities.*" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>

<%
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    //
    // if the user isn't authorized.
    if ( !loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.DEBUG_PRIVILEGE))
    {
%>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
<%
    }
%>

<HTML>
<HEAD>




<LINK REL=STYLESHEET TYPE="text/css" HREF="../StyleSheets/XeBaseStyles.css">
    <script language="JavaScript" src="../javascript/XeGlobalFunctions.js"></script>
    <script language="JavaScript" src="../javascript/XeHelp.js"></script>
    <script language="JavaScript" src="../javascript/layout.js"></script>


<script>
    document.styleSheets[0].addRule("TD", "{font-family:verdana; font-size:8pt}");


</script>

</HEAD>
<BODY>


<%
    Connection myConnection = null;
    Statement p = null;
    ResultSet  rSet = null;
    try
    {
        // Begin Database setup
        myConnection = DatabaseManager.getDefaultDatabase().getConnection("JSP Page: genxml for string table.jsp");

%>
    <form name="sqlForm" action="dbgGenXmlForStringTable.jsp" method="post">
    <table>
    <tr><td>Desired Resource Class</td><td> <input type="text" value=""  name="resClass"></td></tr>
    </table>
    Eg
        <%
            p = myConnection.createStatement();
            rSet = p.executeQuery("select DISTINCT(resourceClassName) from stringResource" );
            boolean haveone= false;
            while (rSet.next() )
            {
                if (haveone)
                {
                out.println(", ");
                }
                haveone=true;
                out.println(rSet.getString(1));
            }
            rSet.close();
            p.close();

        %>
<br>
    <input type="submit" value="Submit">

    </form>
    <%
        String theResClass = request.getParameter("resClass");
        String showAsXml = request.getParameter("showXml");
        String lang =  request.getParameter("lang");
        if (lang == null)
        {
            lang = "en";
        }
        if (theResClass != null)
        {
            theResClass = theResClass.trim();
            boolean specialcase = false;
            if (theResClass.equalsIgnoreCase("AllAlertTypes"))
            {
                theResClass = "AlertType";
                specialcase = true;
            }
            if (theResClass.equalsIgnoreCase("AllDeviceUrl"))
            {
                theResClass = "DeviceUrl";
                specialcase = true;
            }
            StringBuffer theSqlQuery = new StringBuffer();
            theSqlQuery.append("select RTRIM(resourceClassName), RTRIM(subclass), RTRIM(resourcename), RTRIM(language), RTRIM(largeValue) ");
            theSqlQuery.append(" from stringResource,stringtablelarge   where stringResource.id = stringtablelarge.id ");
            theSqlQuery.append(" and resourceClassName = '");
            theSqlQuery.append(theResClass);
            theSqlQuery.append("'");
            theSqlQuery.append(" and language='");
            theSqlQuery.append(lang);
            theSqlQuery.append("'");

            if (showAsXml == null)
            {
                out.print("Showing as property file, use &showXml=yes to see xml");
            }
            if (specialcase == false && theResClass.equalsIgnoreCase("AlertType"))
            {
                out.println("<strong>Filtered out mib data, use AllAlertTypes to get all..</strong><br><br>");
                theSqlQuery.append(" and resourcename in (select typeIdStr from noticeType where typeIdStr not like 'trap.%' )");
            }
            if (specialcase == false && theResClass.equalsIgnoreCase("DeviceUrl"))
            {
                out.println("<strong>Filtered out discovered webservers, use AllDeviceUrl to get all..</strong><br><br>");
                theSqlQuery.append(" and LOWER(subclass)  not like 'compaq.webserver.%' ");
            }
          // Continue accessing the database
            int dvcCount = 0;

            p = myConnection.createStatement();
            rSet = p.executeQuery(theSqlQuery.toString());

            // Display the result set in a table

                out.println("<code><br><br>");

            if (showAsXml != null)
            {
                out.println( MxStringFormatter.htmlSafe("<?xml version=\"1.0\" encoding=\"UTF-8\"?>"));
                out.println("<br>");
                out.println( MxStringFormatter.htmlSafe("<resourcestringlist>"));
            }



            // Next, display the results
            while (rSet.next())
            {
                if (showAsXml != null)
                {
                    out.println("<br>&nbsp&nbsp");
                    out.println(MxStringFormatter.htmlSafe("<resourcestring>"));
                    out.println("<br>&nbsp&nbsp&nbsp&nbsp");
                    out.print(MxStringFormatter.htmlSafe("<class>"));
                    out.print(MxStringFormatter.htmlSafe(rSet.getString(1)));
                    out.println(MxStringFormatter.htmlSafe("</class>"));
                    out.println("<br>&nbsp&nbsp&nbsp&nbsp");
                    out.print(MxStringFormatter.htmlSafe("<subclass>"));
                    out.print(MxStringFormatter.htmlSafe(rSet.getString(2)));
                    out.println(MxStringFormatter.htmlSafe("</subclass>"));
                    out.println("<br>&nbsp&nbsp&nbsp&nbsp");
                    out.print(MxStringFormatter.htmlSafe("<resourceName>"));
                    out.print(MxStringFormatter.htmlSafe(rSet.getString(3)));
                    out.println(MxStringFormatter.htmlSafe("</resourceName>"));
                    out.println("<br>&nbsp&nbsp&nbsp&nbsp");
                    out.print(MxStringFormatter.htmlSafe("<langlist>"));
                    out.println("<br>&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp");
                    out.print(MxStringFormatter.htmlSafe("<lang name=\""));
                    out.print(MxStringFormatter.htmlSafe(rSet.getString(4)));
                    out.print(MxStringFormatter.htmlSafe("\">"));
                    out.print(MxStringFormatter.htmlSafe(rSet.getString(5)));
                    out.println(MxStringFormatter.htmlSafe("</lang>"));
                    out.println("<br>&nbsp&nbsp&nbsp&nbsp");
                    out.println(MxStringFormatter.htmlSafe("</langlist>"));
                    out.println("<br>&nbsp&nbsp");
                    out.println(MxStringFormatter.htmlSafe("</resourcestring>"));
                }
                else
                {
                    out.print("stringtable.");
                    out.print(rSet.getString(1).replaceAll("[.]", "..").replaceAll(" ", "_"));
                    out.print(".");
                    out.print(rSet.getString(2).replaceAll("[.]", "..").replaceAll(" ", "_"));
                    out.print(".");
                    out.print(rSet.getString(3).replaceAll("[.]", "..").replaceAll(" ", "_"));
                    out.print("=");
                    out.print(rSet.getString(5));

                    out.print("<br>");
                }

            }
            if (showAsXml != null)
            {
                out.println("<br>");
                out.println(MxStringFormatter.htmlSafe("</resourcestringlist>"));

            }
            out.println("</code>");
        }
    }
    catch (Exception ex)
    {
        out.println("<span class=errorText>Exception occurred while trying to access the database..Bummer!</span><BR>");
        out.println(ex +"<BR>");
    }
    finally
    {
        try
        {
            // Database cleanup
            if (rSet != null)
                rSet.close();
            if (p != null)
                p.close();
        }
        catch (Exception ex)
        {
        }
        DatabaseManager.getDefaultDatabase().releaseConnection(myConnection);
    }

%>


<script>
    // Give focus to the text area when document loads
    document.sqlForm.resClass.focus()
</script>
</BODY>
</HTML>

