
<%@ page info="HP Systems Insight Manager"%>

<%@ page import="java.util.*" %>
<%@ page import="java.io.*" %>
<%@ page import="com.hp.mx.core.subjects.*" %>
<%@ page import="com.hp.mx.core.client.*" %>
<%@ page import="com.hp.mx.core.nodemanager.*" %>
<%@ page import="com.hp.mx.core.controllers.MxNodeController" %>
<%@ page import="com.hp.mx.core.objectmodel.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.utilities.xml.*" %>
<%@ page import="org.jdom.*" %>
<%@ page import="org.jdom.output.*" %>
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>

<%
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    //
    // if the user isn't authorized.
    if ( !loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.DEBUG_PRIVILEGE))
    {
%>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
<%
    }



%>


<%
    try
    {

        MxNodeController nodeCtlr = MxNodeController.getDefaultController();
        List nodes = nodeCtlr.getNodes();

        MxXMLNodeBinder binder = new MxXMLNodeBinder();


        String encoding = System.getProperty("file.encoding");
        String lineSeparator = System.getProperty("line.separator");


        XMLOutputter outputter = new XMLOutputter(Format.getRawFormat().
            setIndent("  ").setEncoding(encoding).setLineSeparator(lineSeparator));
        //
        // Output the XML data.
        //

        outputter.output(binder.marshal(nodes), out);


    }
    catch (Exception ex)
    {
        out.println(ex);
    }


    %>

