
<%@ page info="HP Systems Insight Manager Home Page"
import="java.util.*,
    com.hp.mx.startup.*,
    com.hp.mx.database.*,
    com.hp.mx.database.GlobalSettings,
    java.sql.*,
    com.hp.mx.portal.applet.utilities.CimXeDebugInfo"%>
    <jsp:useBean id="XEUtil" scope="session" class="com.hp.mx.portal.applet.utilities.XeJspUtil"/>

<%@ page import="com.hp.mx.core.subjects.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>

<%
    MxBean.jspInit(request, response);


    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    //
    // if the user isn't authorized.
    if ( !loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.DEBUG_PRIVILEGE))
    {
%>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
<%
    }
%>

<HTML>
<HEAD>


    <LINK REL=STYLESHEET TYPE="text/css" HREF="../StyleSheets/XeBaseStyles.css">
    <script language="JavaScript" src="../javascript/XeGlobalFunctions.js"></script>
    <script language="JavaScript" src="../javascript/XeHelp.js"></script>
    <script language="JavaScript" src="../javascript/layout.js"></script>

<script>
    var menuHidden = false;
    document.styleSheets[0].addRule("TD", "{font-family:arial; font-size:8pt}");

    function toggleMenu()
    {
        if (menuHidden)
            top.appframe.workspace.idWorkspace.cols = "170,*"
        else
            top.appframe.workspace.idWorkspace.cols = "0,*"

        menuHidden = !menuHidden
    }
</script>
    <div id=warning>
        <span style="color:maroon; font-weight:bold">
            This may take a little while (up to 2 minutes)...The browser may appear locked...but please be patient...

        </span>
    </div><BR>

<%
    CimXeDebugInfo xeInfo = new CimXeDebugInfo();
    xeInfo.init();
    int numTimeZones = xeInfo.getNumberOfTimeZones();
%>


<script>
    var numTzKnownByClient = false;

    function initPage()
    {

        if (numTzKnownByClient && document.xeDbgInfoApplet)
        {
            if (null == document.all.clientId0)
            {
                alert("initpage() says: null == document.all.clientId0");
            }
            else
            {
                document.all.item("clientJVM").innerHTML = document.xeDbgInfoApplet.getJvmLongDesc();
                document.all.item("clientLocale").innerHTML = document.xeDbgInfoApplet.getMyLocale();
                document.all.item("clientDefaultTz").innerHTML = document.xeDbgInfoApplet.getDefaultTimeZone();
                document.all.item("clientSupportsDST").innerHTML = document.xeDbgInfoApplet.defaultTimeZoneSupportsDst();
                document.all.item("clientInDST").innerHTML = document.xeDbgInfoApplet.defaultTimeZoneInDst();
                document.all.item("clientTime").innerHTML = document.xeDbgInfoApplet.getTime();

                for (x=0; x<numTz; x++)
                {
                    document.all.item("clientId" + x).innerHTML          = document.xeDbgInfoApplet.getTimeZoneId(x);
                    document.all.item("clientRawOffset" + x).innerHTML   = document.xeDbgInfoApplet.getTimeZoneRawOffset(x);
                    document.all.item("clientOffset" + x).innerHTML      = document.xeDbgInfoApplet.getTimeZoneOffset(x);
                    document.all.item("clientSupportsDst" + x).innerHTML = document.xeDbgInfoApplet.timeZoneSupportsDst(x);
                    document.all.item("clientInDst" + x).innerHTML       = document.xeDbgInfoApplet.timeZoneInDst(x);
                    document.all.item("clientShortTz" + x).innerHTML     = document.xeDbgInfoApplet.getShortTimeZoneName(x);
                    document.all.item("clientLongTz" + x).innerHTML      = document.xeDbgInfoApplet.getLongTimeZoneName(x);

                    // Highlight the client's default Time Zone
                    if (document.xeDbgInfoApplet.getDefaultTimeZone() == document.xeDbgInfoApplet.getTimeZoneId(x))
                        document.all.item("clientTzRow" + x).bgColor = "#FFFF00";

                }
                // Clear the warning
                var note = "<a href=\"#\" onClick=\"toggleMenu()\">Toggle</a> menu frame<BR>";
                note += "<span class=tinyText><B>NOTE:</B>";
                note += " The proper way to change the server Time Zone is to <B>(1)</B> Close all browsers, ";
                note += "<B>(2)</B> Stop the XE service, <B>(3)</B> Stop all SQL services, "
                note += "<B>(4)</B> Change the OS time Zone, <B>(5)</B> Restart SQL services, "
                note += "<B>(6)</B> Restart XE service, <B>(7)</B> Restart the browser.</span>"
                document.all.item("warning").innerHTML = note;
            }
        }
    }

    window.onload = initPage;

</script>
</head>
<body>


<script>
    startPage();

    ///////////////////////////////////////////////////////////////////////////
    // SERVER-SIDE TIME ZONE INFORMATION
    ///////////////////////////////////////////////////////////////////////////

    startSection("Server-side Time Zone Information");
</script>

    <table width=100% cellspacing=0 cellpadding=2>
    <tr valign="top">
        <td><b>Java Virtual Machine:</b></td>
        <td><%= xeInfo.getJvmLongDesc() %></td>
    </tr>
    <tr valign="top">
        <td><b>Locale:</b></td>
        <td><%=  xeInfo.getMyLocale()  %></td>
    </tr>
    <tr valign="top">
        <td><b>Time Zone Default:</b></td>
        <td><%= xeInfo.getDefaultTimeZone() %></td>
    </tr>
    <tr valign="top">
        <td><b>Time Zone supports DST?</b></td>
        <td><%= xeInfo.defaultTimeZoneSupportsDst() %></td>
    </tr>
    <tr valign="top">
        <td><b>Time Zone in DST?</b></td>
        <td><%= xeInfo.defaultTimeZoneInDst() %></td>
    </tr>
    <tr valign="top">
        <td><b>Current Time:</b></td>
        <td><%= xeInfo.getTime() %></td>
    </tr>
    <tr valign="top">
        <td><b>Detected Client-side Time Zone:</b></td>
        <td><%= XEUtil.getUserSession().getSessionsTimeZone().getID() %></td>
    </tr>

    </table>
<script>
    endSection();
    addVerticalSpacer();
    startSection("Server-side Time Zones Supported (Count = <%= numTimeZones %>)");
</script>

    <table width=100% border=1 bordercolor="#000000" cellspacing=0 cellpadding=1>
    <tr bgcolor="3399cc" valign="top" align="center">
        <th>ID</th>
        <th>Raw Offfset</th>
        <th>Offset</th>
        <th>Supports DST?</th>
        <th>In DST?</th>
        <th>Short Name</th>
        <th>Long Name</th>
    </tr>

<%
    for (int x=0; x<numTimeZones; x++)
    {

        // Set the table row background color
        String bgColor="#CCCCCC";
        if (x%2 == 0)
            bgColor="#FFFFFF";
        if (xeInfo.getDefaultTimeZone().equals(xeInfo.getTimeZoneId(x)))
            bgColor="#FFFF00";

        %>
        <tr  valign="top" align="center" bgcolor="<%= bgColor  %>">
            <td align="left"><%= xeInfo.getTimeZoneId(x) %></td>
            <td><%= xeInfo.getTimeZoneRawOffset(x) %></td>
            <td><%= xeInfo.getTimeZoneOffset(x) %></td>
            <td><%= xeInfo.timeZoneSupportsDst(x) %></td>
            <td><%= xeInfo.timeZoneInDst(x) %></td>
            <td><%= xeInfo.getShortTimeZoneName(x) %></td>
            <td><%= xeInfo.getLongTimeZoneName(x) %></td>
        </tr>
        <%

    }
%>
    </table>
<script>
    endSection();
    newColumn();

    ///////////////////////////////////////////////////////////////////////////
    // CLIENT-SIDE TIME ZONE INFORMATION
    ///////////////////////////////////////////////////////////////////////////

    startSection("Client-side Time Zone Information");
</script>

    <table width=100% cellspacing=0 cellpadding=2>
    <tr valign="top">
        <td><b>Java Virtual Machine:</b></td>
        <td id="clientJVM">Loading...</td>
    </tr>
    <tr valign="top">
        <td><b>Locale:</b></td>
        <td id="clientLocale">Loading...</td>
    </tr>
    <tr valign="top">
        <td><b>Time Zone Default:</b></td>
        <td id="clientDefaultTz">Loading...</td>
    </tr>
    <tr valign="top">
        <td><b>Time Zone supports DST?</b></td>
        <td id="clientSupportsDST">Loading...</td>
    </tr>
    <tr valign="top">
        <td><b>Time Zone in DST?</b></td>
        <td id="clientInDST">Loading...</td>
    </tr>
    <tr valign="top">
        <td><b>Current Time:</b></td>
        <td id="clientTime">Loading...</td>
    </tr>
    <tr valign="top">
        <td>&nbsp;</td>
        <td>&nbsp;</td>
    </tr>

    </table>
<script>
    endSection();
    addVerticalSpacer();
    startSection("Client-side Time Zones Supported (Count = <span id=clientNumTz></span>)");
</script>

    <table width=100% border=1 bordercolor="#000000" cellspacing=0 cellpadding=1>
    <tr bgcolor="3399cc" valign="top" align="center">
        <th>ID</th>
        <th>Raw Offfset</th>
        <th>Offset</th>
        <th>Supports DST?</th>
        <th>In DST?</th>
        <th>Short Name</th>
        <th>Long Name</th>
    </tr>

<script>

    var numTz = 0;
    if (top.hidden.document.emptyApplet)
    {
        // The applet for this page may not yet be loaded so we cannot use it to determine
        // the number of Time Zones it supports. (This number is needed to let the browser
        // generate, through JavaScript, the number of table rows for the client-side TZ
        // support table)  Instead, get he number of supported time zones from the Empty Applet
        // that is (should be) already loaded in the hidden frame.
        numTz = top.hidden.document.emptyApplet.getNumberOfTimeZones();
        numTzKnownByClient = true;
        document.all.item("clientNumTz").innerHTML = numTz;

        // We now know the number of time zones, so let the browser continue rendering the page
        // Display the rows, one for each client Time Zone
        for (x=0; x<numTz; x++)
        {
            // Set the table row background color
            var bgColor="#CCCCCC";
            if (x%2 == 0)
                bgColor="#FFFFFF";
            //if (xeInfo.getDefaultTimeZone().equals(xeInfo.getTimeZoneId(x)))
            //    bgColor="#FFFF00";

            document.writeln("<tr id=\"clientTzRow" + x + "\" valign='top' align='center' bgcolor='" + bgColor + "'>");
            document.writeln("<td id=\"clientId" + x + "\" align=\"left\">Loading...</td>");
            document.writeln("<td id=\"clientRawOffset" + x + "\">&nbsp;</td>");
            document.writeln("<td id=\"clientOffset" + x + "\">&nbsp;</td>");
            document.writeln("<td id=\"clientSupportsDst" + x + "\">&nbsp;</td>");
            document.writeln("<td id=\"clientInDst" + x + "\">&nbsp;</td>");
            document.writeln("<td id=\"clientShortTz" + x + "\">&nbsp;</td>");
            document.writeln("<td id=\"clientLongTz" + x + "\">&nbsp;</td>");
            document.writeln("</tr>");
        }
    }
</script>

    </table>
<script>
    endSection();
    endPage();
</script>

<script>
    var objectTag = "<OBJECT classid=\"<%= GlobalSettings.getProperty("java_plugin_classid", "") %>\" WIDTH=\"1\" HEIGHT=\"1\" NAME=\"xeDbgInfoApplet\" codebase=\"<%= GlobalSettings.getProperty("java_plugin_codebase", "") %>\" id=\"JavaBeansBridge_Object2\">";
    objectTag    += "<PARAM NAME=\"CODE\" VALUE=\"com.hp.mx.portal.applet.utilities.CimXeDebugInfo\" >";
    objectTag    += "<PARAM NAME=\"CODEBASE\" VALUE=\"<%= XEUtil.getAppletBasePathString() %>\" >";
    objectTag    += '<%= XEUtil.getAppletArchivePARAMs(false,false) %>';
    objectTag    += "<PARAM NAME=\"scriptable\" VALUE=\"true\" >";
    objectTag    += "<PARAM NAME=\"MAYSCRIPT\" VALUE=\"true\" >";
    objectTag    += "<PARAM NAME=\"type\" VALUE=\"<%= GlobalSettings.getProperty("java_plugin_param_type", "") %>\">";
    objectTag    += "<PARAM NAME=\"LocalJarsVersion\" VALUE=\"200\">";
    objectTag    += "<PARAM NAME=\"SessionId\" VALUE=\"<%= XEUtil.getUserSession().getId()%>\">";
    objectTag    += "</OBJECT>";
    XeGlobalWriteLine( objectTag );
</script>

<!--
<OBJECT
    classid="<%= GlobalSettings.getProperty("java_plugin_classid", "") %>"
    WIDTH=1
    HEIGHT=1
    NAME=xeDbgInfoApplet
    codebase=""<%= GlobalSettings.getProperty("java_plugin_codebase", "") %>"
    id=JavaBeansBridge_Object2>
    <PARAM NAME=CODE VALUE="com.hp.mx.portal.applet.Utility.CimXeDebugInfo" >
    <PARAM NAME=CODEBASE VALUE="<%= XEUtil.getAppletBasePathString() %>" >
    <%= XEUtil.getAppletArchivePARAMs() %>
    <PARAM NAME="scriptable" VALUE="true" >
    <PARAM NAME="MAYSCRIPT" VALUE="true" >
    <PARAM NAME="type" VALUE="<%= GlobalSettings.getProperty("java_plugin_param_type", "") %>">
    <PARAM NAME="URLsend" VALUE="PostSerializedData">
    <PARAM NAME="URLreceive" VALUE="GetSerializedData">
    <PARAM NAME="LocalJarsVersion" VALUE="200">
    <PARAM NAME="SessionId" VALUE="<%= XEUtil.getUserSession().getId()%>">

    </NOEMBED></EMBED>
</OBJECT>
-->

