<jsp:useBean id="XEUtil" scope="session" class="com.hp.mx.portal.applet.utilities.XeJspUtil"/>
<jsp:useBean id="mxdev" scope="session" class="com.hp.mx.portal.device.MxDeviceBean"/>
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>

<%@ page import="com.hp.mx.core.nodemanager.*,
                 java.util.*,
                 com.hp.mx.core.controllers.MxNodeController,
                com.hp.mx.core.daemon.MxCoreTransaction,
                java.sql.Statement,
                java.sql.Connection,
                java.sql.ResultSet,
                java.sql.DatabaseMetaData,
                java.sql.SQLException,
                 com.hp.mx.database.*,
                 com.hp.mx.core.taskmanager.*,
                 com.hp.mx.portal.applet.utilities.resources.*,
                 com.hp.mx.portal.help.*, com.hp.mx.core.utilities.*,com.hp.mx.utilities.*"
%>
<%@ page import="com.hp.mx.core.subjects.*" %>
<%@ page import="com.hp.mx.core.controllers.DiscoveryController" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.portal.device.*" %>

<%
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    //
    // if the user isn't authorized.
    if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.DEBUG_PRIVILEGE))
    {
%>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
<%
    }
%>

<HTML>
<HEAD>
</HEAD>
<Body>
<%

if (request.getParameter("delDevId") != null)
{
    try
    {
    int devId = Integer.parseInt(request.getParameter("delDevId") );
    MxNode devToDel = MxNodeController.getDefaultControllerNoEx().getNodeByKey(devId);
    if (devToDel != null)
    {
        MxNodeController.getDefaultControllerNoEx().deleteNode(new MxCoreTransaction() ,devToDel);
    }

%>

<script>
history.go(-1);
</script>
<%
    return;
    }
    catch (Exception ex)
    {
    }


}

if (request.getParameter("DiscoverDevId") != null)
{

                try
                {
                    int devId = Integer.parseInt(request.getParameter("DiscoverDevId") );
                    MxNode nodeToPing = MxNodeController.getDefaultControllerNoEx().getNodeByKey(devId);
                    if (nodeToPing != null)
                    {
                        DiscoveryController.getDefaultController().discoverASystem(new MxCoreTransaction(),
                        (MxNode)nodeToPing.clone(), true, DiscoveryController.DISC_SOURCE_OTHER, false);
                    }
                }
                catch (Exception ex)
                {
                    out.print("Error on send discovery  on node ");
                }
}
%>
<%!
    private String getStatusIcon(int iStatus)
    {
        if (iStatus == 0 )
        {
            return("../mxportal/images/unknown_15.gif");
        }
        else if ( iStatus == 1)
        {
            return("../mxportal/images/normal_15.gif");
        }
        else if ( iStatus == 2 )
        {
            return("../mxportal/images/warning_15.gif");
        }
        else if ( iStatus == 3)
        {
            return("../mxportal/images/minor_15.gif");
        }
        else if ( iStatus == 4)
        {
            return("../mxportal/images/major_15.gif");
        }
        else if ( iStatus == 5)
        {
            return("../mxportal/images/critical_15.gif");
        }
        else
        {
            return("../mxportal/images/info_15.gif");
        }
    }

%>

<head>
<title>All devices status info</title>
<LINK REL=STYLESHEET TYPE="text/css" HREF="../StyleSheets/XeBaseStyles.css">
    <script language="JavaScript" src="../javascript/XeGlobalFunctions.js"></script>
    <script language="JavaScript" src="../javascript/XeHelp.js"></script>
    <script language="JavaScript" src="../javascript/layout.js"></script>

  <STYLE TYPE="text/css">
<%
      String fs = GlobalSettings.getProperty("DebugDeviceTableFontSize", "10");
      out.println(".dbgSettingsTable{font-size:"+fs+"pt; font-family:arial; font-weight:normal; color:black; }");
      out.println(".dbgTableHdr{font-size:"+fs+"pt; font-family:arial; font-weight:bold; color:black; }");
%>
  </STYLE>
</head>

<body>
<P>
<%--<%= session.getValue("Body.Description") %> --%>
This is a list of all the current device status information in the system.
</p>
<hr size=4 width="100%" color="#006699">

<table class="dbgSettingsTable" BORDER="1" CELLSPACING="0" CELLPADDING="1" >
<tr class="dbgTableHdr">
  <td>
<%--  <%= session.getValue("Body.SettingsTable.Name") %> --%>
Name
  </td>
  <td>
<%--  <%= session.getValue("Body.SettingsTable.Address") %> --%>
Address
  </td>
  <td>
<%--  <%= session.getValue("Body.SettingsTable.DeviceStatus") %> --%>
  Overall Device Status
  </td>
  <td>
<%--  <%= session.getValue("Body.SettingsTable.DBStatus") %> --%>
Overall DB Status

  </td>
<%
//Query the database to get product name, contact, location
   MxNode d=null;

    Connection myConnection=null;
    Statement p =null;
    ResultSet  rSet = null;
    int  devkey=0;
    String devState=null;
    String dbDevName=null;
    int noticeId=0;


    DeviceStatusSource statusSrcMIBII     = NodeStatusSourceManager.getDefaultManager().getDeviceStatusSource(NodeStatusSourceManager.DEVICE_STATUS_SOURCE_SNMP);
    DeviceStatusSource statusSrcISAgents  = NodeStatusSourceManager.getDefaultManager().getDeviceStatusSource(NodeStatusSourceManager.DEVICE_STATUS_SOURCE_INSIGHTAGENT);
    DeviceStatusSource statusSrcPING      = NodeStatusSourceManager.getDefaultManager().getDeviceStatusSource(NodeStatusSourceManager.DEVICE_STATUS_SOURCE_PING);
    DeviceStatusSource statusSrcDMI       = NodeStatusSourceManager.getDefaultManager().getDeviceStatusSource(NodeStatusSourceManager.DEVICE_STATUS_SOURCE_DMI);
    DeviceStatusSource overall            = NodeStatusSourceManager.getDefaultManager().getDeviceStatusSource(NodeStatusSourceManager.DEVICE_STATUS_SOURCE_OVERALL);

    String tmpType = statusSrcMIBII.toString();
    if (tmpType.startsWith("compaq.hmma."))
        tmpType = tmpType.substring(12);
    out.println("<td title=\'" +tmpType +"\'>SNMP</td>");

    tmpType = statusSrcISAgents.toString();
    if (tmpType.startsWith("compaq.hmma."))
        tmpType = tmpType.substring(12);
    out.println("<td title=\'" +tmpType +"\'>Agent</td>");

    tmpType = statusSrcPING.toString();
    if (tmpType.startsWith("compaq.hmma."))
        tmpType = tmpType.substring(12);
    out.println("<td title=\'" +tmpType +"\'>Ping</td>");

    tmpType = statusSrcDMI.toString();
    if (tmpType.startsWith("compaq.hmma."))
        tmpType = tmpType.substring(12);
    out.println("<td title=\'" +tmpType +"\'>DMI</td>");

    out.println("<td>SSO</td>");
    out.println("<td>STE</td>");
    out.println("<td>SSL</td>");
    out.println("<td>trust</td>");
    out.println("<td>DC_Output Dump</td>");
    out.println("<td>Delete</td>");
    out.println("<td>rediscover</td>");
    out.println("<td>Device URL List</td>");
    out.println("</tr>\n");

try
{
myConnection=DatabaseManager.getDefaultDatabase().getConnection("testDeviceStatus");

p = myConnection.createStatement();
rSet = p.executeQuery("select devices.deviceKey, overallstatus, name from devices order by name ");

while(rSet.next())
   {
   devkey     = rSet.getInt(1);
   devState  = rSet.getString(2);
   dbDevName = rSet.getString(3);



    d = MxNodeController.getDefaultControllerNoEx().getNodeByKey(devkey);
    if(d==null)
    {
        out.print("<tr><td>null dev for id "+devkey+ " "+dbDevName+" </td>");
        out.print("<td><a href=testDeviceStatus.jsp?delDevId=");
        out.println(devkey+">delete</a></td>");

        out.print("</tr>");
        continue;
    }

//mxdev.initialize(d.getGuid().toString(), loginBean);
        NodeStatus curNodeStatus = NodeStatusManager.getDefaultManager().getNodeStatus(devkey);

        if (curNodeStatus == null)
        {
            out.print("<tr><td>null status for id "+devkey+  " "+dbDevName+"</td>");
            out.print("<td><a href=testDeviceStatus.jsp?delDevId=");
            out.println(d.getDeviceKey()+">delete</a></td>");

            out.print("</tr>");
            continue;
        }

        DeviceStatusType statType = (DeviceStatusType)curNodeStatus.getStatusValues().get(overall);
        String statImg;
        int i = Integer.parseInt(devState);
        DeviceStatusType overallDBstatus =  DeviceStatusType.getStatusTypeByNumVal(i);
        String info1= "";
        String statusStr = null;
        if (statType == null || i != statType.getStatusValue())
        {
            info1="******";
        }
        else
        {
            statusStr = statType.getLabel(Locale.getDefault());
        }

       if(statusStr==null || statType == null)
       {
             statusStr="";
             statImg="";
        }
       else
       {
             statImg="<img src=\'"+getStatusIcon(statType.getStatusNumValue())+"\'>";
       }

        out.println("<tr>");

        // dev page     /ui/frameDevice?Id=83 (Notice ID!!)
        // OR /ui/pageWbem?title=Device:%20SRVY-2-NT40&waplet=pageDeviceUrls&dId=95&hId=XE_DEVICE_LINKS
        //out.println("<td align=left valign=top><A href=\"/www/ui/frameDevice?Id="+noticeId+"\"><B>"+info1+d.getDeviceName()+"</B></A></td>");
            //mxportal/DevicePage/devicepage.jsp?nodeId=00000000864162de00000003000000af
        out.println("<td align=left valign=top><A href=\"/mxportal/DevicePage/devicepage.jsp?nodeId=");
        out.println(d.getGUID().toString());
        out.println("\"><B>");
        out.println(info1);
        out.println(d.getDeviceName());
        out.println("</B></A></td>");
        out.println("<td>"+d.getWorkingAddress()+" ["+(d.getIPAddressCount()+d.getIPXAddressCount())+"]</td>");
        out.println("<td valign=top>"+statImg+" "+statusStr+"</td>");
        statusStr = overallDBstatus.getLabel(Locale.getDefault());

               if(statusStr==null || statType == null)
                     {
                     statusStr="";
                     statImg="&nbsp";
                     }
               else
                     {
                     statImg="<img src=\'"  +getStatusIcon(statType.getStatusNumValue())+"\' alt=\'" + statusStr + "\'>";
                     }
        out.println("<td valign=top>"+statImg+" "+statusStr+"</td>");

        //********
        statType = (DeviceStatusType)curNodeStatus.getStatusValues().get(statusSrcMIBII);
               if(statType==null)
                     {
                     statusStr="";
                     statImg="&nbsp";
                     }
               else
                     {
                     statusStr = statType.getLabel(Locale.getDefault());

                     statImg="<img src=\'"  +getStatusIcon(statType.getStatusNumValue())+"\' alt=\'" + statusStr + "\'>";
                     }
          out.println("<td valign=top>"+statImg+"</td>");

        //********
        //statType = (DeviceStatusType)curNodeStatus.getStatusValues().get(statusSrcISAgents);
statType=null;
statType = NodeStatusManager.getDefaultManager().getNodeStatusType(devkey, statusSrcISAgents);

//String beanType  = mxdev.getDetailHWStatus(6);
               if(statType==null)
                     {
                     statusStr="";
                     statImg="&nbsp";
                     }
               else
                     {
                     statusStr = statType.getLabel(Locale.getDefault());
                     statImg="<img src=\'"  +getStatusIcon(statType.getStatusNumValue())+"\' alt=\'" + statusStr + "\'>";
                     }
          out.println("<td valign=top>"+statImg+"</td>");

        //********
        statType = (DeviceStatusType)curNodeStatus.getStatusValues().get(statusSrcPING);
               if(statType==null)
                     {
                     statusStr="";
                     statImg="";
                     }
               else
                     {
                     statusStr = statType.getLabel(Locale.getDefault());
                     statImg="<img src=\'"  +getStatusIcon(statType.getStatusNumValue())+"\' alt=\'" + statusStr + "\'>";
                     }
          out.println("<td valign=top>"+statImg+"</td>");

        //********
        statType = (DeviceStatusType)curNodeStatus.getStatusValues().get(statusSrcDMI);
               if(statType==null)
                     {

                     statusStr="";
                     statImg="&nbsp";
                     }
               else
                     {
                         statusStr = statType.getLabel(Locale.getDefault());

                     statImg="<img src=\'"  +getStatusIcon(statType.getStatusNumValue())+"\' alt=\'" + statusStr + "\'>";
                     }
          out.println("<td valign=top>"+statImg+"</td>");

          out.println("<td valign=top>"+d.getSsoSupport()+"</td>");
          out.println("<td valign=top>"+d.getSteSupport()+"</td>");
          if ( d.getSslEnabled() )
            statusStr="yes";
          else
            statusStr="no";
          out.println("<td valign=top>"+statusStr+"</td>");
          if (d.getTrustStatus() )
            statusStr="yes";
          else
            statusStr="no";
          out.println("<td valign=top>"+statusStr+"</td>");

        out.println("<td><a href=XeHdr.jsp?PageName=DataCollectionRep&dId="+d.getDeviceKey()+">Dc Report</a></td>");
        out.print("<td><a href=testDeviceStatus.jsp?delDevId=");
        out.println(d.getDeviceKey()+">delete</a></td>");
        out.print("<td><a href=testDeviceStatus.jsp?DiscoverDevId=");
        out.println(d.getDeviceKey()+">rediscover</a></td>");



        // Get the device url list, e.g. HMMO, etc.
        out.print("<td>");
        List durls = NodeUrlManager.getDefaultManager().getAllUrlsForANode(devkey);
        Iterator iter = durls.iterator();
        if (iter.hasNext())
        {
            while (iter.hasNext())
            {
                DeviceUrl durl = (DeviceUrl)iter.next();
                out.print( "<a href=\"");
                out.print( durl.getUrl()); // shouldn't need html encoding
                out.print("\" title=\"");
                out.print( durl.getUrlDescription()); // doesn't need html encoding
                out.print("\">");
                out.print( durl.getUrlName()); // shouldn't need html encoding, internal string
                out.print( "</a>");
                if (iter.hasNext())
                {
                    out.print(",");
                }
            }
        }
        else
        {
            out.print("&nbsp;");
        }
        out.print("</td>");


        out.println("</tr>\n");


   }
}
catch(SQLException e)
{
System.out.println("testdevstate "+e);
e.printStackTrace();
}
catch(Exception e)
{
System.out.println("testdevstate "+e);
e.printStackTrace();
}
finally
{
    try
    {
        if (rSet != null)
        {
            rSet.close();
        }
        if (p != null)
        {
            p.close();
        }
    }
    catch(SQLException s)
    {
    }
    try
       {
      DatabaseManager.getDefaultDatabase().releaseConnection(myConnection);
       }
    catch(SQLException s)
       {
       }
}
%>
</table>
</body>
</html>
