<%@ page import="java.util.*,
                 com.hp.mx.database.*,
                 com.hp.mx.portal.help.*"
%>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.core.subjects.*" %>
<%@ page import="com.hp.mx.core.nodemanager.*" %>
<%@ page import="com.hp.mx.core.controllers.*" %>

<%@ page import="com.hp.mx.core.toolmanager.filter.MxNameValueOperator" %>
<%@ page import="com.hp.mx.core.toolmanager.filter.MxFilterOperator_t" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>

<%
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    //
    // if the user isn't authorized.
    if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.DEBUG_PRIVILEGE))
    {
%>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
<%
    }

    // end required section.
%>
<html>
<head>
<title>Search for custom node fields</title>
</head>

<body>
<%
try
{

    String attr = "";
    String val = "";
    String attr2 = "";
    String val2 = "";
    String attr3 = "";
    String val3 = "";

    String attrB1 = "";
    String valB1 = "";
    String attrB2 = "";
    String valB2 = "";
    String attrB3 = "";
    String valB3 = "";


    if (request.getParameter("attr") != null)
    {
        attr = request.getParameter("attr");
        val = request.getParameter("attrVal");
        attr2 = request.getParameter("attr2");
        val2 = request.getParameter("attrVal2");
        attr3 = request.getParameter("attr3");
        val3 = request.getParameter("attrVal3");

        attrB1 = request.getParameter("attrB1");
        valB1 = request.getParameter("attrValB1");
        attrB2 = request.getParameter("attrB2");
        valB2 = request.getParameter("attrValB2");
        attrB3 = request.getParameter("attrB3");
        valB3 = request.getParameter("attrValB3");


        ArrayList myFilter = new ArrayList();
        ArrayList mySubFilter = new ArrayList();

        try
        {
            if (attr != null && attr.length() > 0)
            {
                mySubFilter.add(new MxNameValueOperator(attr, MxFilterOperator_t.OPERATOR_EQ ,val));
            }

            if (attr2 != null && attr2.length() > 0)
            {
                mySubFilter.add(new MxNameValueOperator(attr2, MxFilterOperator_t.OPERATOR_EQ ,val2));
            }

            if (attr3 != null && attr3.length() > 0)
            {
                mySubFilter.add(new MxNameValueOperator(attr3, MxFilterOperator_t.OPERATOR_EQ ,val3));
            }
            myFilter.add(mySubFilter);

            ArrayList mySubFilterB = new ArrayList();
            if (attrB1 != null && attrB1.length() > 0)
            {
                mySubFilterB.add(new MxNameValueOperator(attrB1, MxFilterOperator_t.OPERATOR_EQ ,valB1));
            }

            if (attrB2 != null && attrB2.length() > 0)
            {
                mySubFilterB.add(new MxNameValueOperator(attrB2, MxFilterOperator_t.OPERATOR_EQ ,valB2));
            }

            if (attrB3 != null && attrB3.length() > 0)
            {
                mySubFilterB.add(new MxNameValueOperator(attrB3, MxFilterOperator_t.OPERATOR_EQ ,valB3));
            }

            if (mySubFilterB.size() > 0)
            {
                myFilter.add(mySubFilterB);
            }


            long stTime = System.currentTimeMillis();
            List nodes = MxNodeController.getDefaultController().getFilterNodes(null, myFilter);
            long enTime = System.currentTimeMillis();
            out.print("Found node count = ");
            out.print(nodes.size());
            out.print( " in " );
            out.print( (enTime-stTime) );
            out.print( " ms ");
            out.print("<br>");
        }
        catch (Exception ex)
        {
            ex.printStackTrace();
        }
    }



%>
<P>
    <form name="nodeSearch" action="testSearchNodes.jsp" method="post">
    This will register the desired custom field ID <br><br>
    <table>
    <tr><td>Attr ID</td><td> <input type="text" value="<%=attr%>"  name="attr"></td></tr>
    <tr><td>value </td><td> <input type="text" value="<%=val%>" name="attrVal" ></td></tr>

    <tr><td>and Attr ID</td><td> <input type="text" value="<%=attr2%>"  name="attr2"></td></tr>
    <tr><td>value </td><td> <input type="text" value="<%=val2%>" name="attrVal2" ></td></tr>

    <tr><td>and Attr ID</td><td> <input type="text" value="<%=attr3%>"  name="attr3"></td></tr>
    <tr><td>value </td><td> <input type="text" value="<%=val3%>" name="attrVal3" ></td></tr>
<tr><td>OR</td><td></td></tr>
    <tr><td>Attr ID</td><td> <input type="text" value="<%=attrB1%>"  name="attrB1"></td></tr>
    <tr><td>value </td><td> <input type="text" value="<%=valB1%>" name="attrValB1" ></td></tr>

    <tr><td>and Attr ID</td><td> <input type="text" value="<%=attrB2%>"  name="attrB2"></td></tr>
    <tr><td>value </td><td> <input type="text" value="<%=valB2%>" name="attrValB2" ></td></tr>

    <tr><td>and Attr ID</td><td> <input type="text" value="<%=attrB3%>"  name="attrB3"></td></tr>
    <tr><td>value </td><td> <input type="text" value="<%=valB3%>" name="attrValB3" ></td></tr>
    </table>
    <br>
        <input type="submit"  value="Search">
    </FORM>

<%
}
catch (Exception ex)
{

}
%>
</body>
</html>
