<%@ page import="com.hp.mx.html.table.GUIDOTable,
                 com.hp.mx.html.table.TreeTable,
                 com.hp.mx.html.table.AttributeValueTable,
                 com.hp.mx.core.persistence.dataaccess.DataOperations,
                 com.hp.mx.core.persistence.databean.CIM_ComputerSystem,
                 java.util.*,
                 com.hp.mx.core.controllers.MpoController,
                 java.sql.Connection,
                 java.sql.Statement,
                 java.sql.ResultSet,
                 com.hp.mx.core.persistence.databean.CIM_NetworkPort,
                 com.hp.mx.core.persistence.dataaccess.IdentityProvider,
                 com.hp.mx.core.persistence.util.storage.BeanFinder,
                 java.io.File,
                 com.hp.mx.portal.ui.MxBean,
                 com.hp.mx.portal.res.MxResourceBean,
                 com.hp.mx.html.core.MxHtmlUtil,
                 com.hp.mx.core.persistence.util.storage.FCPort,
                 com.hp.mx.core.persistence.util.storage.Debug,
                 java.text.MessageFormat,
                 com.hp.mx.core.persistence.util.storage.InterconnectDevice,
                 com.hp.mx.core.persistence.dataaccess.DataAccessException"%>
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="resource" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="genSystemPage" class="com.hp.mx.portal.device.MxGenSystemPage"  scope="session" />
<jsp:useBean id="deviceBean" class="com.hp.mx.portal.device.MxDeviceBean" scope="session" />
<jsp:useBean id="deviceBundle" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<%
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    // setup resources.
    resource.init(loginBean, "StorageRelatedDevicePages");


    // keys to find system
    String durableName = deviceBean.getMxNode().getDurableName();
    int nodeID = deviceBean.getMxNode().getDeviceKey();

%><div class="systemPageGroup"><%

    genSystemPage.dumpDataCollectionLine(deviceBean, deviceBundle, loginBean, out);

    BeanFinder finder = new BeanFinder();

    String headers[] = { resource.getString("columnHeader.portNum"),        // port number
                         resource.getString("columnHeader.worldWideName"),  // WWN
                         resource.getString("columnHeader.portType"),        // port type
                         resource.getString("columnHeader.status"),        // port status
    };

    GUIDOTable gt = new GUIDOTable();
    MxResourceBean res = new MxResourceBean(loginBean.getLocale(), "com.hp.mx.html.table.resource.TableResources");
    gt.setResourceBundle(res.getBundle());

    try {

        gt.setHeaders(headers);
        InterconnectDevice ic = new InterconnectDevice(nodeID, durableName);
        List ports = new ArrayList(ic.getPorts());
        ArrayList rows = new ArrayList(ports.size());
        Iterator it = ports.iterator();

        while(it.hasNext()) {
            FCPort port = (FCPort) it.next();

            rows.add(new String[] {
                port.getPortNumber() + 
                    ((port.getName() != null && 
                      !port.getName().trim().equals("") && 
                      !port.getName().equals(port.getDataBean().getPermanentAddress())) ? 
                        " ("+port.getName()+")" : ""),
                MxHtmlUtil.encodeHtmlEntities(port.getWWN()),
                port.getPortTypeDisplayString(resource.getBundle()),
                port.getStatusHTML(resource.getString(port.getOperationalStatusResourceKey()))
            });
        }
        gt.setRows(rows);

    } catch(DataAccessException dae) {
        Debug.trace("No Data Found for Switch with NodeID = " + nodeID + "  Name = " + durableName);
    } catch(RuntimeException re) {
        Debug.getDebugSubsystem().panic(re);
    } catch(Error e) {
        Debug.getDebugSubsystem().panic(e);
        throw e;
    } finally {
        finder.close();
        out.print(gt.getHTML().toString());
    }

%>
</div>
