<%@ page import="java.util.LinkedHashMap,
                 com.hp.mx.core.persistence.util.storage.Common,
                 com.hp.mx.core.persistence.util.storage.GenericSMIData,
                 java.util.Iterator,
                 com.hp.mx.html.table.AttributeValueTable,
                 java.util.Map"%>
<jsp:useBean id="deviceBean" class="com.hp.mx.portal.device.MxDeviceBean" scope="session" />
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="drillDown" class="com.hp.mx.portal.core.MxDrillDown" scope="session" />
<jsp:useBean id="deviceBundle" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="deviceUtilBean" class="com.hp.mx.portal.device.MxDeviceUtilBean" scope="session" />


<div class="systemPageGroup">
<%
    AttributeValueTable avt = new AttributeValueTable(loginBean.getLocale(), AttributeValueTable.STYLE_GUIDO);
    Map map = new LinkedHashMap();

    for (int i=0; i<deviceBean.getAssociationSize(); i++ )
    {

        int associationKey = deviceBean.getAssociationKey(i);
        String associationType = deviceBean.getAssociationType(i);

        String link=null;
        String szDrilldown =drillDown.getDrillDownURL(loginBean, associationKey, deviceBean.getDeviceKey(), "DrillDownType-DeviceName");
        if ( szDrilldown == null)
            link = deviceBean.getAssociationInfo("ASSOCIATION_NAME", associationKey, null, deviceBundle);
        else
        {
            String szSubTitle = deviceBean.getAssociationInfo("ASSOCIATION_NAME", associationKey, null, deviceBundle)+" ("+
                                deviceBean.getAssociationInfo("ASSOCIATION_TYPE", associationKey, null, deviceBundle)+")";
            link = "<a href='javascript:MxPortalWorkspaceCreateUrlEx(\"" + deviceBundle.getString("SYSTEM_PAGE") + "\","+
                   "\""+szSubTitle+"\",\""+
                   szDrilldown +"\")'>" + deviceBean.getAssociationInfo("ASSOCIATION_NAME", associationKey, null, deviceBundle) +
                   "</a>";
        }
        String label = deviceBean.getAssociationInfo("ASSOCIATION_TYPE_NAME", associationKey, associationType, deviceBundle);
        deviceUtilBean.addValue(map, label, link);

        int oneUpAssociationKey = deviceBean.getOneLevelUpAssociationKey(associationKey);
        if (oneUpAssociationKey>0)
        {
            if (deviceBean.getAssociationInfo("ASSOCIATION_TYPE_NAME", oneUpAssociationKey, null, deviceBundle)!= null )
            {

                szDrilldown = drillDown.getDrillDownURL(loginBean, oneUpAssociationKey, "DrillDownType-DeviceName");
                if ( szDrilldown == null )
                    link = deviceBean.getAssociationInfo("ASSOCIATION_NAME", oneUpAssociationKey, null, deviceBundle);
                else
                {
                    String szSubTitle = deviceBean.getAssociationInfo("ASSOCIATION_NAME", oneUpAssociationKey, null, deviceBundle)+" ("+
                                deviceBean.getAssociationInfo("ASSOCIATION_TYPE", oneUpAssociationKey, null, deviceBundle)+")";

                    link = "<a href='javascript:MxPortalWorkspaceCreateUrlEx(\""+deviceBundle.getString("SYSTEM_PAGE")+"\","+
                            "\""+szSubTitle+"\",\""+
                            szDrilldown+"\")'>"+deviceBean.getAssociationInfo("ASSOCIATION_NAME", oneUpAssociationKey, null, deviceBundle) +
                            "</a>";
                }
                label = deviceBean.getAssociationInfo("ASSOCIATION_TYPE_NAME", oneUpAssociationKey, null, deviceBundle);
                deviceUtilBean.addValue(map, label, link);
            }
        }

        if ( associationType.indexOf("ToEnclosure") >= 0 )
    	{
        	if ( deviceBean.getSlot(associationKey)!=null )
        	{
            	deviceUtilBean.addValue(map, deviceBundle.getString("SLOT"), deviceBean.getSlot(associationKey));
        	}
        	if ( deviceBean.getDimension(associationKey) != null )
        	{
            	label = deviceBean.getSystemType()+" "+deviceBundle.getString("DIMENSION");
            	deviceUtilBean.addValue(map, label, deviceBean.getDimension(associationKey));
        	}
    	}
    }
    avt.setItems(map);
    out.println(avt.getHTML());
%>
</div>


