<%@ page import="java.util.LinkedHashMap,
                 com.hp.mx.core.persistence.util.storage.Common,
                 com.hp.mx.core.persistence.util.storage.GenericSMIData,
                 java.util.Iterator,
                 com.hp.mx.html.table.AttributeValueTable,
                 java.util.Map"%>
<jsp:useBean id="deviceBean" class="com.hp.mx.portal.device.MxDeviceBean" scope="session" />
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="drillDown" class="com.hp.mx.portal.core.MxDrillDown" scope="session" />
<jsp:useBean id="deviceBundle" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="deviceUtilBean" class="com.hp.mx.portal.device.MxDeviceUtilBean" scope="session" />


<div class="systemPageGroup">
<%
    AttributeValueTable avt = new AttributeValueTable(loginBean.getLocale(), AttributeValueTable.STYLE_GUIDO);
    Map map = new LinkedHashMap();

    int mpKey = deviceBean.hasMPRelation();
    if ( mpKey != 0 )
    {
        String szDrilldown = null;
        String link = null;
        String systemName=deviceBean.getMPInfo("MP_NAME", mpKey);
        if (systemName!=null )
        {
            szDrilldown =drillDown.getDrillDownURL(loginBean, mpKey, "DrillDownType-DeviceName");
            if ( szDrilldown == null )
                link = systemName;
            else
            {
                String szTitle = systemName + " ("+deviceBean.getMPInfo("MP_TYPE", mpKey)+")";
                link = "<a href='javascript:MxPortalWorkspaceCreateUrlEx(\""+
                    deviceBundle.getString("SYSTEM_PAGE")+"\","+"\""+szTitle+"\",\""+szDrilldown+
                    "\")'>"+systemName+"</a>";
            }
            deviceUtilBean.addValue(map, deviceBundle.getString("NAME"), link);
        }

        if ( deviceBean.getMPInfo("MP_IPADDRESS", mpKey)!=null)
        {
            if ( deviceBean.getMPUrl(mpKey) != null )
            {
                // if we don't have auth on it(no drilldown), we can not see SMH either.
                szDrilldown =drillDown.getDrillDownURL(loginBean, mpKey, "DrillDownType-DeviceName");
                if ( szDrilldown == null )
                    link = deviceBean.getMPInfo("MP_IPADDRESS", mpKey);
                else
                    link="<a href='"+deviceBean.getMPUrl(mpKey)+"' target='new_window'>"
                        +deviceBean.getMPInfo("MP_IPADDRESS", mpKey)+"</a>";
                deviceUtilBean.addValue(map, deviceBundle.getString("ADDRESS"), link);
            }
            else
                deviceUtilBean.addValue(map, deviceBundle.getString("ADDRESS"), deviceBean.getMPInfo("MP_IPADDRESS", mpKey));
        }

        if ( deviceBean.getMPInfo("MP_MODEL", mpKey)!=null )
            deviceUtilBean.addValue(map, deviceBundle.getString("MODEL"), deviceBean.getMPInfo("MP_MODEL", mpKey));

        avt.setItems(map);
        out.println(avt.getHTML());
    }
%>
</div>

