 <%
//
// $Source: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/DevicePage/devicepage.jsp,v $
// $Revision: 1.84.4.1 $
// $Date: 2005/09/14 22:10:04 $
//
%>

<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="org.jdom.Element"  %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="systemTabModel" class="com.hp.mx.portal.device.MxSystemPageTabModel" scope="session" />
<jsp:useBean id="xmlParsingBean" class="com.hp.mx.portal.device.MxXmlParsingBean" scope="session" />
<jsp:useBean id="actionList" class="com.hp.mx.portal.core.MxActionList" scope="session" />
<jsp:useBean id="deviceBean" class="com.hp.mx.portal.device.MxDeviceBean" scope="session" />

<%
    MxBean.jspInit(request, response);

    String nodeId = request.getParameter("nodeId" );
    String szSelected = request.getParameter("selection");
    String sIndex = request.getParameter("index");
    int tabIndex = 0;
    int nXmlErrorCode = 0;
    int nValidNodeErrorCode = 0;


    nValidNodeErrorCode = deviceBean.initialize(nodeId, loginBean);
    deviceBean.setActionList(actionList);

    if ( szSelected == null )
    {
        xmlParsingBean.init(nodeId, loginBean);
        nXmlErrorCode = xmlParsingBean.parseXmlFiles();
    }
%>

<html>
    <head>
        <SCRIPT src="/mxportal/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></SCRIPT>
        <script language="javascript" type="text/javascript">

        function tabClicked(selected, index)
        {
            var url ="";
            url = "devicepage.jsp?nodeId=<%=nodeId%>&selection="+selected+"&index="+index;
            document.location.href = url;
        }


        </script>
        <link type='text/css' rel='stylesheet' href='<%=deviceBean.getUrlBase()%>/DevicePage/css/MxDevice.css'>
        <link type='text/css' rel='stylesheet' href='<%=deviceBean.getUrlBase()%>/css/MxPortalEx.css'>

        <% MxHtmlUtil.dumpHeadBegin(out); %>
        <% systemTabModel.dumpHeadContent(out); %>
        <% MxHtmlUtil.dumpHeadEnd(out); %>
    </head>

    <body>
    <%
        if ( nValidNodeErrorCode > 0 )
        {
    %>
            <iframe name="SYSPAGE_WS" id="ID_WORKSPACE" frameborder="0" marginwidth="0" width="100%" height="800"
                src="xmlerror.jsp?NodeErrorCode=<%=nValidNodeErrorCode%>">
            </iframe>
    <%
        }
        else if ( nXmlErrorCode > 0 )
        {
    %>
            <iframe name="SYSPAGE_WS" id="ID_WORKSPACE" frameborder="0" marginwidth="0" width="100%" height="800"
                src="xmlerror.jsp?XmlErrorCode=<%=nXmlErrorCode%>">
            </iframe>
    <%
        }
        else
        {

            xmlParsingBean.calculateTabs();
            systemTabModel.load(xmlParsingBean.finalTabList, loginBean.getLocale());
            if ( szSelected==null)
            {
                systemTabModel.setMxTagSelectionId(xmlParsingBean.getFirstTabID());
                tabIndex = 0;
            }
            else
            {
                systemTabModel.setMxTagSelectionId(szSelected);
                for (int i=0; i<xmlParsingBean.finalTabList.size(); i++)
                {
                    Element tempTab = (Element) xmlParsingBean.finalTabList.get(i);
                    String tabID = tempTab.getAttributeValue("id");

                    if ( tabID.equals(szSelected) )
                    {
                        tabIndex=i;
                        break;
                    }
                }

            }
            systemTabModel.dumpTabs(out);

            if ( xmlParsingBean.getTabURL(tabIndex).indexOf("EventByNodeResults")>0 )
            {
    %>
            <iframe name="SYSPAGE_WS" id="ID_WORKSPACE" frameborder="0" marginwidth="0" width="100%" height="800"
            src="<%=xmlParsingBean.getTabURL(tabIndex)%>">
            </iframe>
    <%
            }
            else
            {
    %>
            <iframe name="SYSPAGE_WS" id="ID_WORKSPACE" frameborder="0" marginwidth="0" width="100%" height="0"
            src="<%=xmlParsingBean.getTabURL(tabIndex)%>&<%=request.getQueryString()%>">
            </iframe>
    <%
            }
        }
    %>

    <% MxHtmlUtil.dumpBodyEnd(out); %>
    </body>
</html>
