<%--
//$Source: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/actiononevents/ActionOnEvents_JobResults.jsp,v $
//$Revision: 1.26 $
//$Date: 2005/05/17 05:43:34 $
--%>

<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.html.table.*"%>
<%@ page import="com.hp.mx.core.subjects.*"%>
<%@ page import="com.hp.mx.portal.ui.*"%>
<%@ page import="com.hp.mx.portal.actiononevents.*"%>
<%@ page import="java.util.*"%>

<jsp:useBean id="aoneSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session"/>
<jsp:useBean id="aoneJobsSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session"/>
<jsp:useBean id="aoneResultsSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session"/>
<jsp:useBean id="aoneResultsTableView" class="com.hp.mx.html.table.MxTableView2" scope="session"/>
<jsp:useBean id="aoneResultsTableController" class="com.hp.mx.html.table.MxTableController" scope="session"/>
<jsp:useBean id="aoneResultsTableModel" class="com.hp.mx.portal.actiononevents.ActionOnEventsTableModel" scope="session"/>
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="aoneTaskBean" class="com.hp.mx.portal.actiononevents.ActionOnEventsManageBean" scope="session"/>

<%
    final int GUTTER_SPACING = 10;

    // REQUIRED: This line is required by Tomcat for i18n support.
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
    {
        return;
    }

    // Abort if the user isn't authorized.
    if ((!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.NOTIFICATION_SETTINGS_MODIFICATION_PRIVILEGE))
        || (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.EVENT_MODIFICATION_PRIVILEGE))
        || (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.TOOL_MODIFICATION_PRIVILEGE))
        || (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.SUBJECT_MODIFICATION_PRIVILEGE))
        )
    {
        %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
        <%
    }
%>
<%

    // setup the display of the Task List table model
    if (aoneResultsTableController.isFirstTime())
    {
        aoneTaskBean.getJobResultsTableColumnNames(aoneResultsTableModel);

        // set to only allow 1 row to be selected
        aoneResultsSelectionModel.setSelectionMode(MxTableSelectionModel.SINGLE_SELECTION);

        aoneResultsTableView.setId("ID_MY_RESULTS_TABLE");
        aoneResultsTableView.setOnSelectionChange("mySelectionChanged");
        aoneResultsTableView.setUrlHandler(request.getRequestURI());

        //--tableController.setTableModel(tableModel);
        aoneResultsTableController.setTableModelWithSorting(aoneResultsTableModel);

        // get the sorting table and tell it to sort alphabetically by Task Name
        MxTableSortingModel sortingModel = aoneResultsTableController.getSortingModelOrNull();
        // column #1 (Task Name), sortUp == true
        sortingModel.sortTable(0, true);

        aoneResultsTableController.setSelectionModel(aoneResultsSelectionModel);
        aoneResultsTableController.setTableView(aoneResultsTableView);
    }

    // do we need to abort?
    if (aoneResultsTableController.checkUrlForControllerMessages(request, out))
    {
        //out.write("<script>alert('controller msg');</script>");
        return;
    }

    // set the first row as the selected row - default action
//    aoneResultsSelectionModel.setSelectedIndex(0, true);

    aoneResultsTableModel.clearData();
    aoneResultsTableModel.fireTableDataChanged();

    aoneTaskBean.refreshJobResults(aoneJobsSelectionModel.getSelectedIndices()[0], aoneResultsTableModel);
    int numResults     = aoneResultsTableModel.getRowCount();
%>
<html>
<head>
    <title>
        ActionOnEvents_JobResults
    </title>
    <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/actiononevents/css/ActionOnEvents.css'>
    <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxBrowser.js'></script>
    <SCRIPT src="/mxportal/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></SCRIPT>
    <SCRIPT>MxPortalWorkspaceSetHelpTopic("<%=aoneTaskBean.getResString("JOB_RESULTS_PAGE_HELP")%>")</SCRIPT>
    <SCRIPT language="javascript">
    var REFRESH_TIMEOUT              = 10000; // 10 seconds
    var SELECTED_ROW_COLOR           = "66CCFF";
    var NETSCAPE_SCROLLBAR_WIDTH     = 36;
    </SCRIPT>
    <script language='javascript' type='text/javascript'>
        // resize the MxTable to be flush with the right browser edge
        function myResize()
        {
            var w = Math.max(0, MxBrowserGetBodyWidth(-NETSCAPE_SCROLLBAR_WIDTH, 0));
            MxTableSetWidth('ID_MY_RESULTS_TABLE', (w - <%=GUTTER_SPACING%>));
        }
        //
        // the function called when the selection changes on the <table>
        //
        function mySelectionChanged(szIdTable, iRow, bSelected)
        {
            if (bSelected)
            {
                selectTask(iRow);
            }
            else
            {
               var iframe = parent.document.getElementById("frmJobResultsDetails");
               iframe.contentWindow.document.location.replace("<%=aoneTaskBean.getResString("BLANK_PAGE_URL")%>");
            }
        }
    </script>
    <SCRIPT language="javascript">
    function selectTask(iRow)
    {
       var iframe = parent.document.getElementById("frmJobResultsDetails");
       iframe.contentWindow.document.location.replace("<%=aoneTaskBean.getResString("JOB_RESULT_DETAILS_PAGE_URL")%>");
    }
    </SCRIPT>
        <script language='javascript' >
        // set the height of the MxTable based on the number of rules
        function resize_h()
        {
            var numResults = <%=numResults%>;

            if (numResults < 1)
            {
                return;
            }

            var titleHeight  = MxTableGetHeadHeight('ID_MY_RESULTS_TABLE');
            var rowHeight    = 0;
            var maxDisplayed = 5;
            var divHeight    = titleHeight;

            if (numResults > 0)
            {
                rowHeight = MxTableGetRowHeight('ID_MY_RESULTS_TABLE', 0);
            }

            if (numResults < maxDisplayed)
            {
                divHeight += (rowHeight * numResults);
            }
            else
            {
                divHeight += (rowHeight * maxDisplayed);
            }
            MxTableSetHeight('ID_MY_RESULTS_TABLE', divHeight);
        }
        </script>
        <script language='javascript' type='text/javascript'>
        function myOnLoadHandler()
        {
            myResize(); // set width
            <%
            if (numResults > 0)
            {
                %>
                resize_h();
                <%
            }
            %>
            var pageHeight  = document.body.scrollHeight;
            var pageWidth  = document.body.scrollWidth;

            var w = Math.max(pageWidth, MxPortalGetWorkspaceFrame().scrollWidth);
            var marginWidth = parent.document.getElementById(this.name).marginWidth;

            parent.document.getElementById(this.name).style.height = pageHeight;
            parent.document.getElementById(this.name).style.width = (w - marginWidth);
            parent.setDisplayHeightAndWidth();
        }
        </script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% aoneResultsTableView.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</head>

<body onload="myOnLoadHandler()">
<TABLE cellpadding=10><tr><td>
    <HR class="rule">
    <table border="0" cellspacing="0" cellpadding="0">
      <tr>
        <td colspan="2" class="mxPageSubTitle">
            <%=aoneTaskBean.getResString("SUB_HEAD_JOB_DETAILS")%>
        </td>
      </tr>
    <table>
    <BR>
    <table border="0" cellpadding="1" cellspacing="0" style="width:100%">
      <tr>
        <td style="width:15%" nowrap>
            <b><%=aoneTaskBean.getResString("JOB_RESULTS_JOB_STATUS_LABEL")%>&nbsp;</b>
        </td>
        <td style="width:35%" nowrap>
            <%=aoneTaskBean.getJobStatus(aoneJobsSelectionModel.getSelectedIndices()[0])%>
        </td>
        <td style="width:15%" nowrap>
            <b>&nbsp;<%=aoneTaskBean.getResString("JOB_RESULTS_START_TIME_LABEL")%>&nbsp;</b>
        </td>
        <td style="width:35%" nowrap>
            <%=aoneTaskBean.getJobStartTime(aoneJobsSelectionModel.getSelectedIndices()[0])%>
        </td>
      </tr>
      <tr>
        <td nowrap><b><%=aoneTaskBean.getResString("JOB_RESULTS_JOB_ID_LABEL")%>&nbsp;</b></td>
        <td id="jobID" nowrap>
            <%=aoneTaskBean.getJobID(aoneJobsSelectionModel.getSelectedIndices()[0])%>
        </td>
        <td nowrap>
            <b>&nbsp;<%=aoneTaskBean.getResString("JOB_RESULTS_END_TIME_LABEL")%>&nbsp;</b>
        </td>
        <td nowrap>
            <%=aoneTaskBean.getJobEndTime(aoneJobsSelectionModel.getSelectedIndices()[0])%>
        </td>
      </tr>
      <tr>
        <td nowrap>
            <b><%=aoneTaskBean.getResString("JOB_RESULTS_RUN_BY_LABEL")%></b>
        </td>
        <td nowrap>
           <%=aoneTaskBean.getJobRunBy(aoneJobsSelectionModel.getSelectedIndices()[0])%>
        </td>
        <td nowrap>
            <b>&nbsp;<%=aoneTaskBean.getResString("JOB_RESULTS_DURATION_LABEL")%>&nbsp;</b>
        </td>
        <td nowrap>
            <%=aoneTaskBean.getJobDuration(aoneJobsSelectionModel.getSelectedIndices()[0])%>
        </td>
      </tr>
    </table>

    <br>

    <table border="0" cellspacing="0" cellpadding="0" style="width:100%">
      <tr>
        <td nowrap style="width:15%">
            <b><%=aoneTaskBean.getResString("JOB_RESULTS_SUMMARY_STATUS_LABEL")%>&nbsp;</b>
        </td>
        <td nowrap>
            <%=aoneTaskBean.getJobSummaryStatus(aoneJobsSelectionModel.getSelectedIndices()[0])%>
        </td>
      </tr>
    </table>

    <br>
<%
    if (numResults > 0)
    {
        %>
    <table border='0' cellpadding='0' cellspacing='0' style='width:100%'>
        <tr>
            <td style='width:50%' nowrap>
                <font class='tip'><%=aoneTaskBean.getResString("MANAGE_PROMPT_CLICK_4_JOB_RESULT_DETAILS")%></font>&nbsp;
            </td>
            <td id='totalTasks' style='width:50%' align='right' nowrap>
                <b><%=aoneTaskBean.getResString("NO_OF_JOB_RESULTS_LABEL")%></b>&nbsp;<%=numResults%>
            </td>
        </tr>
    </table>
    <%
        aoneResultsTableView.dumpWholeTable(out);
    }
    else
    {
        %>
        <DIV style='font-weight:bold;font-style:italic;color:red'>
            <%=aoneTaskBean.getResString("NO_JOB_RESULTS_TEXT")%>
        </DIV>
        <%
    }
%>
</td></tr></table>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</body>
</html>
