<%--
//$Source: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/actiononevents/ActionOnEvents_Jobs.jsp,v $
//$Revision: 1.24 $
//$Date: 2005/05/17 05:43:35 $
--%>

<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.html.table.*"%>
<%@ page import="com.hp.mx.core.subjects.*"%>
<%@ page import="com.hp.mx.portal.ui.*"%>
<%@ page import="com.hp.mx.portal.actiononevents.*"%>
<%@ page import="java.util.*"%>

<jsp:useBean id="aoneSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session"/>
<jsp:useBean id="aoneJobsSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session"/>
<jsp:useBean id="aoneJobsTableView" class="com.hp.mx.html.table.MxTableView2" scope="session"/>
<jsp:useBean id="aoneJobsTableController" class="com.hp.mx.html.table.MxTableController" scope="session"/>
<jsp:useBean id="aoneJobsTableModel" class="com.hp.mx.portal.actiononevents.ActionOnEventsTableModel" scope="session"/>
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="aoneTaskBean" class="com.hp.mx.portal.actiononevents.ActionOnEventsManageBean" scope="session"/>

<%
    final int GUTTER_SPACING = 10;

    // REQUIRED: This line is required by Tomcat for i18n support.
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
    {
        return;
    }

    // Abort if the user isn't authorized.
    if ((!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.NOTIFICATION_SETTINGS_MODIFICATION_PRIVILEGE))
        || (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.EVENT_MODIFICATION_PRIVILEGE))
        || (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.TOOL_MODIFICATION_PRIVILEGE))
        || (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.SUBJECT_MODIFICATION_PRIVILEGE))
        )
    {
        %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
        <%
    }
%>
<%

    // setup the display of the Task List table model
    if (aoneJobsTableController.isFirstTime())
    {
        aoneTaskBean.getJobsTableColumnNames(aoneJobsTableModel);

        // set to only allow 1 row to be selected
        aoneJobsSelectionModel.setSelectionMode(MxTableSelectionModel.SINGLE_SELECTION);

        aoneJobsTableView.setId("ID_MY_JOBS_TABLE");
        aoneJobsTableView.setOnSelectionChange("mySelectionChanged");
        aoneJobsTableView.setUrlHandler(request.getRequestURI());

        //--tableController.setTableModel(tableModel);
        aoneJobsTableController.setTableModelWithSorting(aoneJobsTableModel);

        // get the sorting table and tell it to sort down by JobId
        MxTableSortingModel sortingModel = aoneJobsTableController.getSortingModelOrNull();
        // column #1 (JobId), sortUp == false
        sortingModel.sortTable(0, false);

        aoneJobsTableController.setSelectionModel(aoneJobsSelectionModel);
        aoneJobsTableController.setTableView(aoneJobsTableView);
    }

    // do we need to abort?
    if (aoneJobsTableController.checkUrlForControllerMessages(request, out))
    {
        //out.write("<script>alert('controller msg');</script>");
        return;
    }

    // set the first row as the selected row - default action
    aoneJobsSelectionModel.setSelectedIndex(0, true);

    aoneJobsTableModel.clearData();
    aoneJobsTableModel.fireTableDataChanged();

    aoneTaskBean.refreshJobs(out, aoneSelectionModel.getSelectedIndices()[0], aoneJobsTableModel);
    int numJobs     = aoneJobsTableModel.getRowCount();
%>

<html>
    <head>
        <title>
            ActionOnEvents_Jobs
        </title>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/actiononevents/css/ActionOnEvents.css'>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxBrowser.js'></script>
        <SCRIPT src="/mxportal/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></SCRIPT>
        <SCRIPT>MxPortalWorkspaceSetHelpTopic("<%=aoneTaskBean.getResString("JOBS_PAGE_HELP")%>")</SCRIPT>
        <SCRIPT>
        var REFRESH_TIMEOUT              = 10000; // 10 seconds
        var SELECTED_ROW_COLOR           = "66CCFF";
        var NETSCAPE_SCROLLBAR_WIDTH     = 36;
        </SCRIPT>
        <script language='javascript' type='text/javascript'>
            // resize the MxTable to be flush with the right browser edge
            function myResize()
            {
                var w = Math.max(0, MxBrowserGetBodyWidth(-NETSCAPE_SCROLLBAR_WIDTH, 0));
                MxTableSetWidth('ID_MY_JOBS_TABLE', (w - <%=GUTTER_SPACING%>));

            }
            //
            // the function called when the selection changes on the <table>
            //
            function mySelectionChanged(szIdTable, iRow, bSelected)
            {
                if (bSelected)
                {
                    selectTask(iRow);
                }
                else
                {
                    var iframe = document.getElementById("frmJobResults");
                       iframe.contentWindow.document.location.replace("<%=aoneTaskBean.getResString("BLANK_PAGE_URL")%>");
                }
            }
            function setDisplayHeightAndWidth()
            {
                var pageHeight  = document.body.scrollHeight;
                var pageWidth  = document.body.scrollWidth;
                parent.setFrmDisplayHeight(pageHeight);
                parent.setFrmDisplayWidth(pageWidth);
            }
        </script>
        <SCRIPT>
        function selectTask(iRow)
        {
           var iframe = document.getElementById("frmJobResults");
           iframe.contentWindow.document.location.replace("<%=aoneTaskBean.getResString("JOB_RESULTS_PAGE_URL")%>");
        }
        </SCRIPT>
    <script language='javascript' >
    function resize_h()
    {
        var numJobs = <%=numJobs%>;

        if (numJobs < 1)
        {
            return;
        }

        var titleHeight  = MxTableGetHeadHeight('ID_MY_JOBS_TABLE');
        var rowHeight    = 0;
        var maxDisplayed = 5;
        var divHeight    = titleHeight;

        if (numJobs > 0)
        {
            rowHeight = MxTableGetRowHeight('ID_MY_JOBS_TABLE', 0);
        }

        if (numJobs < maxDisplayed)
        {
            divHeight += (rowHeight * numJobs);
        }
        else
        {
            divHeight += (rowHeight * maxDisplayed);
        }
        MxTableSetHeight('ID_MY_JOBS_TABLE', divHeight);
    }
    </script>
    <script language='javascript' type='text/javascript'>
    function myOnLoadHandler()
    {
        myResize(); // set width
        <%
        if (numJobs > 0)
        {
            %>
            resize_h();
            <%
        }
        %>
        setDisplayHeightAndWidth();
    }
    </script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% aoneJobsTableView.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</head>

<body onload="myOnLoadHandler()">
<TABLE cellpadding=10><tr><td>
    <HR class="rule">
    <table border="0" cellspacing="0" cellpadding="0">
      <tr>
        <td colspan="2" class="mxPageSubTitle">
            <%=aoneTaskBean.getResString("SUB_HEAD_TASK_DETAILS")%>
          &nbsp;&nbsp;<%=aoneTaskBean.getTaskName(aoneSelectionModel.getSelectedIndices()[0])%>
        </td>
      </tr>
    <table>
    <br>
    <table border="0" cellpadding="1" cellspacing="0" style="width:100%">
      <tr>
        <td style="width:15%" nowrap>
          <b><%=aoneTaskBean.getResString("TASK_RESULTS_OWNER_LABEL")%>&nbsp;</b>
          <%= aoneTaskBean.getTaskOwner(aoneSelectionModel.getSelectedIndices()[0])%></td>
        <td id="taskName" style="width:35%" nowrap></td>
        <td nowrap align="right">
          <b>&nbsp;<%=aoneTaskBean.getResString("TASK_RESULTS_LAST_MODIFIED_LABEL")%>&nbsp;</b>
          <%= aoneTaskBean.getTaskModifiedTime(aoneSelectionModel.getSelectedIndices()[0])%>
        </td>
      </tr>
    </table>
    <BR>
<%
    if (numJobs > 0)
    {
        %>
    <table border='0' cellpadding='0' cellspacing='0' style='width:100%'>
        <tr>
            <td style='width:50%' nowrap>
                <font class='tip'><%=aoneTaskBean.getResString("MANAGE_PROMPT_CLICK_4_JOB_RESULTS")%></font>&nbsp;
            </td>
            <td id='totalTasks' style='width:50%' align='right' nowrap>
                <b><%=aoneTaskBean.getResString("NO_OF_JOBS_LABEL")%></b>&nbsp;<%=numJobs%>
            </td>
        </tr>
    </table>
    <%
        aoneJobsTableView.dumpWholeTable(out);
    }
    else
    {
        %>
        <DIV style='font-weight:bold;font-style:italic;color:red'>
            <%=aoneTaskBean.getResString("NO_TASK_DETAILS_TEXT")%>
        </DIV>
        <%
    }
%>
</td></tr></table>

<iframe id="frmJobResults" name="frmJobResults" style="width:100%; height:10; position:relative; visibility:visible"
        scrolling="no" marginwidth="0"
        frameborder="0"
        src="<%=aoneTaskBean.getResString("BLANK_PAGE_URL")%>">
</iframe>
<iframe id="frmJobResultsDetails" name="frmJobResultsDetails" style="width:100%; height:10; position:relative; visibility:visible"
        scrolling="no" marginwidth="<%=GUTTER_SPACING%>"
        frameborder="0"
        src="<%=aoneTaskBean.getResString("BLANK_PAGE_URL")%>">
</iframe>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</body>
</html>
