<%--
//$Source: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/actiononevents/ActionOnEvents_Manage.jsp,v $
//$Revision: 1.45 $
//$Date: 2005/06/27 14:09:11 $
--%>

<%@ page import="com.hp.mx.html.core.*" %>
<%@page import="com.hp.mx.core.subjects.*"%>
<%@page import="com.hp.mx.portal.actiononevents.*"%>
<%@page import="com.hp.mx.portal.ui.*"%>
<%@page import="com.hp.mx.utilities.MxCMS"%>
<%@page import="com.hp.mx.html.table.*"%>
<%@page import="java.util.*"%>

<jsp:useBean id="aoneSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session"/>
<jsp:useBean id="aoneTableView" class="com.hp.mx.html.table.MxTableView2" scope="session"/>
<jsp:useBean id="aoneTableController" class="com.hp.mx.html.table.MxTableController" scope="session"/>
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="aoneTableModel" class="com.hp.mx.portal.actiononevents.ActionOnEventsTableModel" scope="session"/>
<jsp:useBean id="aoneTaskBean" class="com.hp.mx.portal.actiononevents.ActionOnEventsManageBean" scope="session"/>
<jsp:useBean id="aoneUIbean" scope="session" class="com.hp.mx.portal.actiononevents.ActionOnEventsUIBean" />

<%
    final int GUTTER_SPACING = 10;

    // REQUIRED: This line is required by Tomcat for i18n support.
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
    {
        return;
    }

    // Abort if the user isn't authorized.
    if ((!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.NOTIFICATION_SETTINGS_MODIFICATION_PRIVILEGE))
        || (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.EVENT_MODIFICATION_PRIVILEGE))
        || (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.TOOL_MODIFICATION_PRIVILEGE))
        || (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.SUBJECT_MODIFICATION_PRIVILEGE))
        )
    {
        %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
        <%
    }
%>
<%
    aoneTaskBean.initBean(out, loginBean);

    // setup the display of the Task List table model
    if (aoneTableController.isFirstTime())
    {
        aoneTaskBean.getColumnNames(aoneTableModel);

        // set to only allow 1 row to be selected
        aoneSelectionModel.setSelectionMode(MxTableSelectionModel.SINGLE_SELECTION);

        aoneTableView.setId("ID_MY_TABLE");
        aoneTableView.setOnSelectionChange("mySelectionChanged");
        aoneTableView.setUrlHandler(request.getRequestURI());

        //--aoneTableController.setTableModel(aoneTableModel);
        aoneTableController.setTableModelWithSorting(aoneTableModel);

        // get the sorting table and tell it to sort alphabetically by Task Name
        MxTableSortingModel sortingModel = aoneTableController.getSortingModelOrNull();
        // column #1 (Task Name), sortUp == true
        sortingModel.sortTable(0, true);

        aoneTableController.setSelectionModel(aoneSelectionModel);
        aoneTableController.setTableView(aoneTableView);
    }

    // do we need to abort?
    if (aoneTableController.checkUrlForControllerMessages(request, out))
    {
        //out.write("<script>alert('controller msg');</script>");
        return;
    }

    aoneTableModel.clearData();
    aoneTableModel.fireTableDataChanged();

    String taskName = request.getParameter("highlightTask");

    if (taskName == null)
    {
        taskName = "";
    }

    aoneTaskBean.refreshTasks(out, aoneTableModel);
    int numTasks     = aoneTableModel.getRowCount();

    // set the first row as the selected row - default action
    int selectedTask=-1;
    if (numTasks>0)
    {
        if (taskName.trim().equals(""))
        {
            aoneSelectionModel.setSelectedIndex(0, true);
            selectedTask=0;
        }
        else
        {
            for (int j=0;j<numTasks;j++)
            {
                if (aoneTaskBean.getTaskName(j).equals(taskName))
                {
                    aoneSelectionModel.setSelectedIndex(j, true);
                    selectedTask=j;
                }
            }
        }
    }

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();
    buttons.addMxTag(new MxDefaultTag("btnAdd", aoneTaskBean.getResString("NEW_BUTTON_LABEL"), "showAddPage()"));
    buttons.addMxTag(new MxDefaultTag("btnEdit", aoneTaskBean.getResString("EDIT_BUTTON_LABEL"), "showEditPage()"));
    buttons.addMxTag(new MxDefaultTag("btnCopy", aoneTaskBean.getResString("COPY_BUTTON_LABEL"), "showCopyPage()"));
    buttons.addMxTag(new MxDefaultTag("btnViewDefinition", aoneTaskBean.getResString("VIEW_DEFINITION_BUTTON_LABEL"), "showTaskDefinition()"));
    buttons.addMxTag(new MxDefaultTag("btnViewResults", aoneTaskBean.getResString("TASK_RESULTS_BUTTON_LABEL"), "showTaskResults()"));
    if (selectedTask>= 0)
	if (aoneTaskBean.isTaskEnabled(selectedTask))
       	    buttons.addMxTag(new MxDefaultTag("btnEnableDisable", aoneTaskBean.getResString("DISABLE_BUTTON_LABEL"), "showEnableDisablePage()"));
	else
       	    buttons.addMxTag(new MxDefaultTag("btnEnableDisable", aoneTaskBean.getResString("ENABLE_BUTTON_LABEL"), "showEnableDisablePage()"));

    else 	
       buttons.addMxTag(new MxDefaultTag("btnEnableDisable", aoneTaskBean.getResString("DISABLE_BUTTON_LABEL"), "showEnableDisablePage()"));


 
  

    buttons.addMxTag(new MxDefaultTag("btnDelete", aoneTaskBean.getResString("DELETE_BUTTON_LABEL"), "showDeletePage()"));
%>

<html>
    <head>
        <title>
        ActionOnEvents_Manage
        </title>
        <LINK type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/actiononevents/css/ActionOnEvents.css'>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxBrowser.js'></script>
        <SCRIPT src="/mxportal/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></SCRIPT>
        <SCRIPT>MxPortalWorkspaceSetHelpTopic("<%=aoneUIbean.getResString("MANAGE_PAGE_HELP")%>")</SCRIPT>
        <SCRIPT>
        var REFRESH_TIMEOUT              = 10000; // 10 seconds
        var SELECTED_ROW_COLOR           = "66CCFF";
        var NETSCAPE_SCROLLBAR_WIDTH     = 36;
        var currentRow = 0;
        </SCRIPT>
        <script language='javascript' type='text/javascript'>
            // resize the MxTable to be flush with the right browser edge
            function myResize()
            {
                var w = Math.max(0, MxBrowserGetBodyWidth(-NETSCAPE_SCROLLBAR_WIDTH, 0));
                MxTableSetWidth('ID_MY_TABLE', (w - <%=GUTTER_SPACING%>));
            }
            //
            // the function called when the selection changes
            //
            function mySelectionChanged(szIdTable, iRow, bSelected)
		{
                var iframe = document.getElementById("frmDisplay");
                iframe.contentWindow.document.location.replace("<%=aoneTaskBean.getResString("BLANK_PAGE_URL")%>");
                if (bSelected)
                {

                    currentRow = iRow;
                    ourButtonManager.enableButtonById('btnEdit');
                    ourButtonManager.enableButtonById('btnEnableDisable');
                    ourButtonManager.enableButtonById('btnDelete');
                    ourButtonManager.enableButtonById('btnCopy');
                    ourButtonManager.enableButtonById('btnViewDefinition');
                    ourButtonManager.enableButtonById('btnViewResults');
                    <%
                    if (MxCMS.isWindows())
                    {
                    %>
                    var enableDisable = MxTableGetValueAt('ID_MY_TABLE', iRow, 8);
                    <%
                    }
                    else
                    {
                    %>
                    var enableDisable = MxTableGetValueAt('ID_MY_TABLE', iRow, 7);
                    <%
                    }
                    %>

                    var regExp = new RegExp("<%=aoneTaskBean.getResString("LBL_TASK_DISABLED")%>");

                    if ( regExp.test( enableDisable ) )
                    {
                        ourButtonManager.setButtonLabelById('btnEnableDisable',  "<%=aoneTaskBean.getResString("ENABLE_BUTTON_LABEL")%>");
                    }
                    else
                    {
                    ourButtonManager.setButtonLabelById('btnEnableDisable',  "<%=aoneTaskBean.getResString("DISABLE_BUTTON_LABEL")%>");
                    }

                }
                else
                {

                    currentRow = -1;
                    ourButtonManager.disableButtonById('btnEdit');
                    ourButtonManager.disableButtonById('btnEnableDisable');
                    ourButtonManager.disableButtonById('btnDelete');
                    ourButtonManager.disableButtonById('btnCopy');
                    ourButtonManager.disableButtonById('btnViewDefinition');
                    ourButtonManager.disableButtonById('btnViewResults');
                }
//                selectTask(iRow);
            }
        </script>
        <SCRIPT language="javascript">
        function selectTask(iRow)
        {
           // set TimeOut to call the actual selectTask() function

           var iframe = document.getElementById("frmDisplay");
           iframe.contentWindow.document.location.replace("<%=aoneTaskBean.getResString("JOBS_PAGE_URL")%>");

            ourButtonManager.enableButtonById('btnEdit');
            ourButtonManager.enableButtonById('btnEnableDisable');
            ourButtonManager.enableButtonById('btnDelete');
            ourButtonManager.enableButtonById('btnCopy');
            ourButtonManager.enableButtonById('btnViewDefinition');
            ourButtonManager.enableButtonById('btnViewResults');


            <%
            if (MxCMS.isWindows())
            {
            %>
                var enableDisable = MxTableGetValueAt('ID_MY_TABLE', iRow, 8);
            <%
            }
            else
            {
            %>
                var enableDisable = MxTableGetValueAt('ID_MY_TABLE', iRow, 7);
            <%
            }
            %>

            var regExp = new RegExp("<%=aoneTaskBean.getResString("LBL_TASK_DISABLED")%>");

            if ( regExp.test( enableDisable ) )
            {
                ourButtonManager.setButtonLabelById('btnEnableDisable',  "<%=aoneTaskBean.getResString("ENABLE_BUTTON_LABEL")%>");
            }
            else
            {
                ourButtonManager.setButtonLabelById('btnEnableDisable',  "<%=aoneTaskBean.getResString("DISABLE_BUTTON_LABEL")%>");
            }
        }
        function setFrmDisplayHeight(pageHeight)
        {
            document.getElementById('frmDisplay').style.height =  pageHeight;
            document.body.style.height = document.body.scrollHeight;
        }
        function setFrmDisplayWidth(pageWidth)
        {
            var w = Math.max(pageWidth, MxPortalGetWorkspaceFrame().scrollWidth);
            var marginWidth = document.getElementById('frmDisplay').marginWidth;
            document.getElementById('frmDisplay').style.width =  (w - marginWidth);
        }
        function iframeLoaded()
        {
           var iframe = document.getElementById("frmDisplay");
           var h = iframe.contentWindow.document.body.scrollHeight;
           var w = iframe.contentWindow.document.body.scrollWidth;
           setFrmDisplayHeight(h);
           setFrmDisplayWidth(w);
        }
        </SCRIPT>
    <script language='javascript' >
    // set the height of the MxTable based on the number of rules
    function resize_h()
    {
        var titleHeight  = 0;
        var rowHeight    = 0;
        var maxDisplayed = 10;
        var numRules = <%=numTasks%>;
        var divHeight    = 0;

        if (numRules > 0)
        {
            rowHeight = MxTableGetRowHeight('ID_MY_TABLE', 0);
            titleHeight  = MxTableGetHeadHeight('ID_MY_TABLE');
        }

        divHeight    = titleHeight;

        if (numRules < maxDisplayed)
        {
            divHeight += (rowHeight * (numRules+1));
        }
        else
        {
            divHeight += (rowHeight * maxDisplayed);
        }
        MxTableSetHeight('ID_MY_TABLE', divHeight);
    }
    </script>
    <script language='javascript' type='text/javascript'>
    function myOnLoadHandler()
    {
        myResize(); // set width
        if (0 < <%=numTasks%>)
        {
            resize_h();
            ourButtonManager.enableButtonById('btnEdit');
            ourButtonManager.enableButtonById('btnEnableDisable');
            ourButtonManager.enableButtonById('btnDelete');
            ourButtonManager.enableButtonById('btnCopy');
            ourButtonManager.enableButtonById('btnViewDefinition');
            ourButtonManager.enableButtonById('btnViewResults');
        }
        else
        {
            ourButtonManager.disableButtonById('btnEdit');
            ourButtonManager.disableButtonById('btnEnableDisable');
            ourButtonManager.disableButtonById('btnDelete');
            ourButtonManager.disableButtonById('btnCopy');
            ourButtonManager.disableButtonById('btnViewDefinition');
            ourButtonManager.disableButtonById('btnViewResults');
        }
//        if (-1 != <%=selectedTask%>)
//        {
            currentRow = <%=selectedTask%>;
//            selectTask(<%//selectedTask%>);
//        }
    }
    </script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% buttons.dumpHeadContent(out); %>
<% aoneTableView.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</head>

<body onload="myOnLoadHandler()" onresize="myResize(), resize_h()">
<TABLE cellpadding='<%=GUTTER_SPACING%>'>
<TR><TD>
<%
if (numTasks > 0)
{
    %>
        <table border='0' cellpadding='0' cellspacing='0' style='width:100%'>
            <tr>
                <!--td style='width:50%' nowrap>
                    <font class='tip'><%=aoneTaskBean.getResString("MANAGE_PROMPT_CLICK_4_RESULTS")%></font>&nbsp;
                </td-->
                <td id='totalTasks' style='width:50%' align='right' nowrap>
                    <b><%=aoneTaskBean.getResString("NO_OF_TASKS_LABEL")%></b>&nbsp;<%=numTasks%>
                </td>
            </tr>
        </table>
<%
    aoneTableView.dumpWholeTable(out);
%>
<%
}
else
{
    %>
    <DIV style='font-weight:bold;font-style:italic;color:red'>
        <%=aoneTaskBean.getResString("NO_TASKS_TEXT")%>
    </DIV>
    <%
}
%>
</TD></TR>
</TABLE>
<%--HR class='rule'--%>
    <script language='javascript'>
        function showAddPage()
        {
                    document.getElementById('frmDisplay').src=
                    '<%=aoneTaskBean.getResString("NEW_PAGE_URL")%>'
                    + '?botframe=true&reqType=<%=aoneTaskBean.REQUEST_TYPE_NEW%>';
        }
        function showCopyPage()
        {
                    document.getElementById('frmDisplay').src=
                    '<%=aoneTaskBean.getResString("COPY_PAGE_URL")%>'
                    + '?botframe=true&reqType=<%=aoneTaskBean.REQUEST_TYPE_COPY%>';
        }
        function showTaskDefinition()
        {
            document.getElementById('frmDisplay').src=
                '<%=aoneTaskBean.getResString("SUMMARY_PAGE_URL")%>?botframe=true&reqType=' + '<%=aoneTaskBean.REQUEST_TYPE_SHOW_SUMMARY%>';
        }
        function showTaskResults()
        {
            if (-1 != currentRow)
            {
                selectTask(currentRow);
            }
        }
        function showEditPage()
        {
                    document.getElementById('frmDisplay').src=
                     '<%=aoneTaskBean.getResString("NAME_PAGE_URL")%>'
                     + '?reqType=<%=aoneTaskBean.REQUEST_TYPE_EDIT%>';
        }
        function showEnableDisablePage()
        {
                document.location= '<%=aoneTaskBean.getResString("UPDATE_CORE_PAGE_URL")%>'
                                        + '?reqType=<%=aoneTaskBean.REQUEST_TYPE_ENABLE_DISABLE%>';
        }
        function showDeletePage()
        {
            if ( true == confirm('<%=aoneTaskBean.getResString("DELETE_CONF_MSG")%>') )
            {
                ourButtonManager.disableButtonById('btnAdd');
                ourButtonManager.disableButtonById('btnEdit');
                ourButtonManager.disableButtonById('btnEnableDisable');
                ourButtonManager.disableButtonById('btnDelete');
                ourButtonManager.disableButtonById('btnCopy');
                ourButtonManager.disableButtonById('btnViewDefinition');
                ourButtonManager.disableButtonById('btnViewResults');

                document.location= '<%=aoneTaskBean.getResString("UPDATE_CORE_PAGE_URL")%>'
                                        + '?reqType=<%=aoneTaskBean.REQUEST_TYPE_DELETE%>';
            }
        }
    </script>
<div style="margin-top:15px">
    <% buttons.dumpButtons(out); %>
</div>

    <iframe    id="frmDisplay"
            name="frmDisplay"
            style="width:100%; height:10; position:relative; visibility:visible"
            scrolling="no" marginwidth="0"
            frameborder="0"
            src="<%=aoneTaskBean.getResString("BLANK_PAGE_URL")%>">
    </iframe>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</body>
</html>
