	var count = 0;

	function onViewChange(e)
	{
	    if (e.value != "")
	    {
	        document.location.replace(e.value);
	    }
	}

	function init() {
		var pageTitle = "Rack Overview";
		top.mainPage.getRightSideFrame().setTitle(pageTitle);
	}
	
	function selectEnclosure(num, name) {
		top.mainPage.getNavigationFrame().selectEnclosure(num, name);
	}
	
	function toggleEnclosureVisible(encId, expandImage)
	{
		var enclosure = document.getElementById(encId);
		var enclosurePadding = document.getElementById(encId + "Padding");
		if (enclosure != null){
			if (enclosure.style.display == 'none'){
				enclosure.style.display = 'block';
				expandImage.src = '../images/win_shrink.gif';
				enclosurePadding.style.display = 'none';				
			}
			else{
				enclosure.style.display = 'none';				
				expandImage.src = '../images/win_expand.gif';
				enclosurePadding.style.display = 'block';
			}
		}
	}	
	
	function toggleSectionVisible(encId, expandImage)
	{
		var enclosure = document.getElementById(encId);
		var enclosurePadding = document.getElementById(encId + "Padding");
		if (enclosure != null){
			if (enclosure.style.display == 'none'){
				enclosure.style.display = 'block';
				expandImage.src = '/mxportal/bladeime/skin/images/section_tree_contract.gif';
				enclosurePadding.style.display = 'none';				
			}
			else{
				enclosure.style.display = 'none';				
				expandImage.src = '/mxportal/bladeime/skin/images/section_tree_expand.gif';
				enclosurePadding.style.display = 'block';
			}
		}
	}	
	
	function displayEnclosure(url)
	{
		document.location.replace(url);
	}	

	function isBrowserGecko()
	{
		return (navigator.userAgent.toLowerCase().indexOf("gecko") >= 0);
	}

	function makeSelection(guid)
	{
		if (isBrowserGecko())
			makeSelectionMozilla(guid)
		else
			makeSelectionIE(guid);		
	}

	function makeSelectionIE(guid)
	{
		if (typeof(SelectDevice) != "undefined")
		{
			if (typeof(SelectDevice.length) == "undefined")
			{
				if (SelectDevice.value == guid)
				{
					SelectDevice.checked = true;
				}
			}
			else
			{
				for (var i=0;i<SelectDevice.length;i++)
				{
					if (SelectDevice[i].value == guid)
					{
						SelectDevice[i].checked = true;
					}
				}
			}
		}
	}

	function makeSelectionMozilla(guid)
	{
		inputNodeCollection = window.document.getElementsByTagName("input");

		for (var i=0; i<inputNodeCollection.length;i++) 
		{
			if (inputNodeCollection[i].name=="SelectDevice" && inputNodeCollection[i].value==guid)
			{
				inputNodeCollection[i].checked=true;
			}
		}
	}
	
	function applySelection(inputID)
	{
		if (isBrowserGecko())
			applySelectionMozilla(inputID)
		else
			applySelectionIE(inputID);
	}

	function applySelectionIE(inputID)
	{
		if (typeof(SelectDevice) != "undefined")
		{
			if (typeof(SelectDevice.length) == "undefined")
			{
				if (inputID.name == "allservers")
				{
					if (SelectDevice.id != 0 && SelectDevice.id != 9999)				
					{
						SelectDevice.checked = inputID.checked;
						globalSelectionIE(SelectDevice);
					}
				}
				else
				{
					if (SelectDevice.id == 0 || SelectDevice.id == 9999)
					{
						SelectDevice.checked = inputID.checked;
						globalSelectionIE(SelectDevice);
					}
				}
			}
			else
			{
				if (inputID.name == "allservers")
				{
					for (var i=0;i<SelectDevice.length;i++)
					{
						if (SelectDevice[i].id != 0 && SelectDevice[i].id != 9999)
						{
							SelectDevice[i].checked = inputID.checked;
							globalSelectionIE(SelectDevice[i]);
						}
					}
				}
				else
				{
					for (var i=0;i<SelectDevice.length;i++)
					{
						if (SelectDevice[i].id == 0 || SelectDevice[i].id == 9999)
						{
							SelectDevice[i].checked = inputID.checked;
							globalSelectionIE(SelectDevice[i]);
						}
					}
				}
			}
		}
	}

	function applySelectionMozilla(inputID)
	{
		inputNodeCollection = window.document.getElementsByTagName("input");

		if (inputID.name == "allservers")
		{
			for (var i=0; i<inputNodeCollection.length;i++) 
			{
				if (inputNodeCollection[i].name=="SelectDevice")
				{
					if (inputNodeCollection[i].id != 0 && inputNodeCollection[i].id != 9999)
					{
						inputNodeCollection[i].checked = inputID.checked;
						globalSelectionMozilla(inputNodeCollection[i]);
					}
				}
			}
		}
		else
		{
			for (var i=0; i<inputNodeCollection.length;i++) 
			{
				if (inputNodeCollection[i].name=="SelectDevice")
				{
					if (inputNodeCollection[i].id == 0 || inputNodeCollection[i].id == 9999)
					{
						inputNodeCollection[i].checked = inputID.checked;
						globalSelectionMozilla(inputNodeCollection[i]);
					}
				}
			}
		}
	}

	function globalSelection(inputID)
	{
		if (isBrowserGecko())
			globalSelectionMozilla(inputID)
		else
			globalSelectionIE(inputID);
	}

	function globalSelectionIE(inputID)
	{
		var count = 0;		
		if (typeof(SelectDevice) != "undefined")
		{
			if (typeof(SelectDevice.length) == "undefined")
			{
				if (SelectDevice.checked)
					count++;
			}
			else
			{
				for (var i=0;i<SelectDevice.length;i++)
				{
					if (SelectDevice[i].checked)
						count++;
				}
			}

			toggleNodeSelection(inputID,inputID.value,count);
		}
	}

	function globalSelectionMozilla(inputID)
	{
		var count = 0;
		inputNodeCollection = window.document.getElementsByTagName("input");

		for (var i=0; i<inputNodeCollection.length;i++) 
		{
			if (inputNodeCollection[i].name=="SelectDevice" && inputNodeCollection[i].checked)
			{
				count++;
			}
		}

		toggleNodeSelection(inputID,inputID.value,count);
	}

	function drillDown(url)
	{
		document.location.replace(url);
	}
