<%@ page import="java.util.*"%>

<%-- This is to include the MxBean Class--%>
<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.portal.ui.MxDateAndTime" %>
<%@ page import="com.hp.mx.portal.help.*" %>

<%-- Dont know if we need these--%>
<%@ page import="com.hp.mx.html.table.MxTableSortingModel" %>

<%-- Used to deal with parramaters--%>
<%@ page import="com.hp.mx.portal.clustermonitor.CMUtility" %>

<%-- This is to use the custom tag library that allows me to use MxTabs--%>
<!--<%@ taglib uri="/com/hp/mx/taglibs/" prefix="mxtag"%>-->

<%@ page import="com.hp.clustermonitor.portal.mscsDV.*"%>
<%@ page import="com.hp.clustermonitor.portal.nodeResource.*"%>

<%-- Creates Various beans --%>

<%-- Used for the recource file that contains all the text--%>
<jsp:useBean id="resObj" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<jsp:useBean id="mscsTableView" class="com.hp.clustermonitor.portal.mscsDV.MxTableViewCm" scope="session" />
<jsp:useBean id="mscsTableController" class="com.hp.mx.html.table.MxTableController" scope="session" />
<jsp:useBean id="mscsSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session" />

<%--  Custom Tab Control class that deals with the GUIDO appearance --%>
<jsp:useBean id="mscsTabCtrl" class="com.hp.clustermonitor.portal.mscsDV.MscsTabCtrlModel" scope="session" />

<%--  Custom Table class that outlines how deals with the appearance and data in the table--%>
<jsp:useBean id="mscsTableModel" class="com.hp.clustermonitor.portal.mscsDV.MscsTableModel" scope="session" />

<%--  Used to check if the current session is vaild--%>
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>

<%
    //Static Function That sets up some encoding stuff
    MxBean.jspInit(request, response);

    // check to see if the loginBean session has timed out
    if ( loginBean.checkLogoutConditionForWebPage(pageContext) == true){
        //This will create a blank html page
        return;
    }
    //loads the properties file
    resObj.init(loginBean, "CmMSCS");

    //get column widths from the url
    String[] widths = request.getParameterValues("widths");

    //This gets the sort coloum from the paramaters then tells the sorting model
    //Which column to sort on
    String szSortCol = request.getParameter(mscsTableController.URL_PARAM_SORT_COL);
    String szSortUp = request.getParameter(mscsTableController.URL_PARAM_SORT_UP);
    if (szSortCol != null && szSortUp != null){
      int iSortCol = Integer.parseInt(szSortCol);
      boolean bSortUp = szSortUp.equals("true");
      MxTableSortingModel sortingModel = mscsTableController.getSortingModelOrNull();
      sortingModel.sortTable(iSortCol, bSortUp);
    }
    else{
        MxTableSortingModel sortingModel = mscsTableController.getSortingModelOrNull();
        if(sortingModel != null){
            sortingModel.sortTable(MxTableSortingModel.ID_NONE, true);
        }
    }

    //Setting up paramaters for java classes
    String szUserName= loginBean.getUser();
    String szClusterName =request.getParameter("ClusterName");
    String szClusterAddress= request.getParameter("ClusterIp");

    final String tableID = "ID_CLUSTER_TABLE";

    //These are the minimum pararamter to run the page, if there not there just
    //Display nothing (this would only happen if it was manualy entered.)
    if( (szClusterName == null ) || (szClusterAddress == null)){
       return;
    }
    //Sets up the tablemodle

    //Adds another / if one exsist in the user or cluster name
    StringBuffer sbValues = new StringBuffer(400);
    StringBuffer szTemp = new StringBuffer(400);

    sbValues.append("&");
    sbValues.append("ClusterName=" );
    szTemp.append(szClusterName);
    int start=0;
    int b=0;
    while(b != -1){
      b = szTemp.indexOf("\\",start);
      if(b != -1){
         szTemp.insert(b,"\\");
      }
      start = b+2;
    }
    sbValues.append(szTemp);
    sbValues.append("&");
    sbValues.append("ClusterIp=" );
    szTemp = new StringBuffer(szClusterAddress);
    start=0;
    b=0;
    while(b != -1){
      b = szTemp.indexOf("\\",start);
      if(b != -1){
         szTemp.insert(b,"\\");
      }
      start = b+2;
    }
    sbValues.append(szTemp);


    String szSelected = request.getParameter("selection");
    //Defaults to CLuster
    if ( szSelected == null )
      szSelected = "CLUSTER";


    //Stuff ran the first time the page is encountered

      //Starts the cmxs (if not allready)
      NodeResourceTop startCmxs = new NodeResourceTop(loginBean.getXeUserSession());
      szUserName = startCmxs.setEvents(szClusterName);

    mscsTableModel.setParms(szUserName,szClusterName,szClusterAddress,loginBean.getLocale());

    if (mscsTableController.isFirstTime())
    {
      mscsTableView.setId(tableID);
      mscsTableView.setUrlHandler(request.getRequestURI());
      mscsTableController.setTableModelWithSorting(mscsTableModel);
      mscsTableController.setTableView(mscsTableView);
    }

   //Checks to see if anything went majorly wrong and does some other stuff
    if ( mscsTableController.checkUrlForControllerMessages(request, out) )
    {
        return;
    }

    //Loads the table from the cmxs
    mscsTableModel.loadTable(loginBean,resObj,szSelected);
    mscsTableView.setHeight("140");
    mscsTableView.setAdjustableColumn(mscsTableModel.getColumnCount());

    MxHtmlUtil.jspInit(request, response);
    MxTabs2 tabs = new MxTabs2();
    mscsTabCtrl.initTabs(request, tabs, loginBean.getLocale());
%>

<html>
  <head>
      <!-- This stuff adds some java script functions to the jsp page-->
    <SCRIPT src="/mxportal/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></SCRIPT>
    <script src="/mxportal/js/MxBrowser.js" language="JavaScript" type="text/javascript"></script>

<!--    <%mscsTableView.dumpTableHiddenPart(out);%>-->
    <script language="javascript" type="text/javascript">
    var sumOfWidths = 0;
    var lastColumnWidth = 0;
    var lastColumn =0;

    function initSize(event)
    {
            var j=0; //iterator through the columns
            var w =0; //width of the column
            var method= "default"; //are we getting the column size by default or through paramaters?
            var slideWidth; // original width of the slider.

            CellData = document.getElementsByName(j);  //gets all cells in column j (0)
            while (CellData.length != 0){
                w =0; // we try to see if the colum width for this row was set
                slideWidth = document.getElementById("slider" + j).offsetWidth;
                <%
                if(widths != null){
                      for(int col=0; col < widths.length; col++){
                %>
                <%if (col == 0) {%>
                    if( j == <%=col%> ){
                <%}else{%>
                   else if( j == <%=col%> ){
                <%}%>
                    w = <%=widths[col]%>;
                   method = "paramaters";
                   //If this is the sort column then expand it to show the arrow if it is too small
                   //alert(  document.getElementById(j).offsetWidth );
                   if(("<%=szSortCol%>" != "null") && ("<%=szSortCol%>" == j) && (w <document.getElementById(j).offsetWidth )){
                       w = document.getElementById(j).offsetWidth + slideWidth ;
                   }
                }
                <% }}%>
                //If no parameters were found for the row
               if(w==0){
                    w = document.getElementById(j).offsetWidth;
                    method = "default";
                }

                for (var i = 0; i < CellData.length; i++){
                  if(i == 0){
                   if(method == "default"){
                       CellData.item(i).style.width = w + slideWidth +2;
                     lastColumnWidth= w + slideWidth +2
                   }
                   else{
                     CellData.item(i).style.width = w ;
                     lastColumnWidth= w;
                   }
                  }
                  else{
                      if(method == "default"){
                          CellData.item(i).style.width = w + slideWidth +4;
                          lastColumnWidth= w + slideWidth +4
                    }
                    else{
                        CellData.item(i).style.width = w + 4;
                        lastColumnWidth= w + 4;
                    }
                  }
                }
                lastColumn = j;
            j++;
            CellData = document.getElementsByName(j);
        }//while
        document.getElementById("OUTER_TABLE").style.width = "95%";
        tableWidth = document.getElementById("OUTER_TABLE").offsetWidth;
        sumOfWidths = document.getElementById("Main_Table").offsetWidth;

        //Extends the last column to fit the table
        CellData = document.getElementsByName(lastColumn);
        if ( (tableWidth - sumOfWidths) > 3 ){
          CellData = document.getElementsByName(lastColumn);
          for (var i = 0; i < CellData.length; i++){
             if (i==0)
               CellData.item(i).style.width = (tableWidth-sumOfWidths) +lastColumnWidth -4;
             else
               CellData.item(i).style.width = (tableWidth-sumOfWidths) + lastColumnWidth;
          }
        }

    }//init size

    function createURL(selection,bKeepWidth)
    {
      var url ="";
      if (selection == "NODES"){
        url = "CmMSCS.jsp?selection=NODES<%=sbValues%>" ;
      }
      else if (selection == "NETWORK"){
        url = "CmMSCS.jsp?selection=NETWORK<%=sbValues%>" ;
      }
      else if (selection == "RESOURCES"){
        url = "CmMSCS.jsp?selection=RESOURCES<%=sbValues%>";
      }
      else if (selection == "CLUSTER"){
        url = "CmMSCS.jsp?selection=CLUSTER<%=sbValues%>" ;
      }
      if(bKeepWidth == true){
        url =  url + writeWidths();
      }
      return (url);
    }

   function createURLSort(szAddOn)
   {
       var url =createURL("<%=szSelected%>",true);
       url = url + szAddOn;
       document.location.href = url;
   }

   function tabClicked(selection)
   {
     var url =  createURL(selection, (selection == "<%=szSelected%>")?true : false);
     if((selection == "<%=szSelected%>") ==true ){
       url = url + "<%=mscsTableView.getSortUrl()%>";
     }
     document.location.href = url;
   }

   function myOnLoad()
   {
     initSize();
     myOnResize();
   }

    function myOnResize()
    {
        resize_w();
        resize_h();
    }

    function resize_w()
    {
      var w = Math.max(0, MxBrowserGetBodyWidth(-10, 5));
      var oMenu = document.getElementById("ID_EVENT");
      if ( oMenu != null )
        oMenu.style.width = w;
    }

    function resize_h()
    {
      var h_total = Math.max(0, MxBrowserGetBodyHeight(-35, 5));
      var h_top = document.getElementById("DEVICEPAGE_TOP").offsetHeight;
      var h = Math.max(0, h_total - h_top);
      var oMenu = document.getElementById("ID_EVENT");
      if ( oMenu != null )
        oMenu.style.height = h;
    }

 </script>

 <link type='text/css' rel='stylesheet' href='"/mxportal/DevicePage/css/MxDevice.css'>
 <link type='text/css' rel='stylesheet' href='"/mxportal/css/MxPortalEx.css'>

 <% MxHtmlUtil.dumpHeadBegin(out); %>
 <!--<% MxButton.dumpHeadContent(out); %>-->
 <% MxHtmlUtil.dumpHeadEnd(out); %>

 <link type='text/css'  rel='stylesheet' href='CmMxTable.css'>
 <!--<mxtag:MxTabs dumpHeadContent="true"/>-->
 <% mscsTableView.dumpHeadContent(out); %>
 <META HTTP-EQUIV="Refresh" CONTENT="10000; URL="createURL(szSelected,true)">
 <% MxHtmlUtil.dumpHeadBegin(out); %>
 <% tabs.dumpHeadContent(out); %>
 <% MxHtmlUtil.dumpHeadEnd(out); %>
 </head>

<body onLoad='myOnLoad();'  onResize='myOnResize()' onmouseup="setStartWidth();"  onmousemove="resizecol(event);">
 <% tabs.dumpTabs(out); %>
 <br><br>
 <div class="body-proxy" id="ID_BODY_PROXY" >
 <div id="DEVICEPAGE_TOP">
  <b>
   &nbsp;<%=resObj.getString(szSelected+"_TITLE")%>
   <% if(szClusterName != null){ %> <%=szClusterName%>
   <% }else{ %> Unable to get name <%}%>
  </b>
  <br>
  <table cellspacing="0" border="0" width="100%" id='OUTER_TABLE' name='OUTER_TABLE'>
   <tr>
    <td>
     <table border="1" cellpadding="0" cellspacing="0" style="border-collapse: collapse" bordercolor="#111111" width="100%" align="left">
      <tr>
       <td width="100%">
<!--
        <table border="1" cellpadding="0" cellspacing="0" style="border-collapse: collapse" bordercolor="#111111" width="100%" id="AutoNumber1">
          <tr>
              <td class='mxtable-header-noslider'><%=resObj.getString(szSelected+"_TITLE")%>
                  <% if(szClusterName != null){ %> <%=szClusterName%> <% }else{ %> Unable to get name <%}%>
              </td>
          </tr>
        </table>
        <table border="1" cellpadding="0" cellspacing="0" style="border-collapse: collapse" bordercolor="#111111" width="100%" id="AutoNumber2" height="17">
          <tr>
            <td style="font-family: arial,sans-serif; font-size: 10pt; padding-left: 5; padding-right: 5" valign="top" bgcolor="#006699"><font color="#FFFFFF"><%=resObj.getString(szSelected)%></font></font>&nbsp;</td>
          </tr>
        </table>
-->
        <% mscsTableView.dumpTableVisiblePart(out); %>
<!--
        <table border="1" cellpadding="0" cellspacing="0" style="border-collapse: collapse" bordercolor="#111111" width="100%">
          <tr>
           <td valign="top">
            <p>&nbsp;<%= mscsTableModel.getTimeStamp(resObj,loginBean.getLocale())%></p>
           </td>
          </tr>
        </table>
-->
       </td>
      </tr>
     </table>
    </td>
   </tr>
   <tr>
    <td align="middle">
      <p>&nbsp;<%= mscsTableModel.getTimeStamp(resObj,loginBean.getLocale())%></p>
    </td>
   </tr>
   <tr>
    <td width="100%">
        <span class="whiteSpacer"></span><br>
    </td>
   </tr>
   <tr>
    <td width="100%">
     <table border="1" cellpadding="0" cellspacing="0" style="border-collapse: collapse" bordercolor="#111111" id="AutoNumber3" width="100%" height="80" align="left">
      <tr>
        <td class='mxtable-header-noslider' height="17"><%=resObj.getString("PROBLEM_INFO")%>&nbsp;</td>
      </tr>
      <tr>
        <td valign="top" ><%=mscsTableModel.getProblem()%> </td>
      </tr>
    </table>
    </td>
   </tr>
  </table>
 </div>
 </div>
 <% MxHtmlUtil.dumpBodyEnd(out); %>
</body>
</html>
