<%@ page import="java.util.*"%>

<%-- This is to include the MxBean Class--%>
<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.portal.ui.MxDateAndTime" %>
<%@ page import="com.hp.mx.portal.help.*" %>

<%-- Used to deal with parramaters--%>
<%@ page import="com.hp.mx.portal.clustermonitor.CMUtility" %>

<%-- Node Resource java classes--%>
<%@ page import="com.hp.clustermonitor.portal.nodeResource.*"%>

<%-- Thresholds --%>
<%@ page import="com.hp.clustermonitor.portal.ThresholdData"%>
<%@ page import="com.hp.clustermonitor.cmx.properties.CmxThresholds"%>

<%-- Polling Stuff --%>
<%@ page import="com.hp.clustermonitor.portal.PollingData"%>
<%@ page import="com.hp.clustermonitor.portal.clusterResource.ClusterProperty"%>

<%-- Used for the recource file that contains all the text--%>
<jsp:useBean id="resourceObject" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="mscsProps"      class="com.hp.clustermonitor.portal.clusterResource.ClusterProperty" scope="session" />

<%--  Used to check if the current session is vaild--%>
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>

<%
    //Static Function That sets up some encoding stuff
    MxBean.jspInit(request, response);

    // check to see if the loginBean session has timed out
    if ( loginBean.checkLogoutConditionForWebPage(pageContext) == true){
        //This will create a blank html page
        return;
    }

    //loads the properties file
    resourceObject.init(loginBean, "CmNRSP");

    //Reads in the paramters for the page
    String szClusterName =request.getParameter("CLUSTERNAME");
    String szClusterIP = request.getParameter("CLUSTERIP");
    String szNodeName =request.getParameter("NODENAME");
    String szNodeIP = request.getParameter("NODEIP");
    String szCMX = request.getParameter("CMX");

    String url= new String();
    url ="CmNodeResourceBottom.jsp?CLUSTERNAME=";
    url+=szClusterName;
    url+="&CLUSTERIP=";
    url+= szClusterIP;
    url+="&NODENAME=";
    url+= szNodeName;
    url+="&NODEIP=";
    url+=szNodeIP;
    url+="&CMX=";
    url+=szCMX;

    //A abstact class that can be used regardless of the
    //the cmx choice
    //@TODO: name choices are too close, make them more distinct
    Thresholds threshold =null;
    Vector thresholds = null;

    //Do we save before loading?
    boolean bVaild = true;
    int saveError = 0; // no error
    boolean bLoadFailed = false;

    //english cmx choice
    String which = new String();

    if(szCMX.equals(("DISK"))){
       threshold = new DiskThresholds();
       which = "disk";
    }
    else if (szCMX.equals(("CPU"))){
       threshold = new CpuThresholds();
       which = "cpu";
    }
    else if (szCMX.equals(("SYSTEM"))){
      threshold = new SystemPolling();
      which = "system";
    }
    else{
      /**@todo Display invalid data page or popup?*/
      return;
    }
    //initilize variables
    threshold.initVariables();
    //Gets the all the data through the interconect engeine
    threshold.retrieveData(loginBean.getXeUserSession(),resourceObject,
                            szClusterName,szClusterIP,szNodeName,szNodeIP);


    if (threshold.wasDeviceDeletedOnLoad())
       bLoadFailed = true; // if so, don't check anything since we don't have any data
    else {

       thresholds = new Vector();
       if(which != "system"){
         //Gets the thresholds using the interconnect engine
         thresholds  = threshold.getThresholds();
       }
       //Do we have polling paramaters?
       String szMin = request.getParameter("min");
       String szSec = request.getParameter("sec");
       if(szMin != null){
         if(mscsProps.isPollingDataValid(szMin,szSec)){
           threshold.setPollingData(new PollingData(szMin,szSec));
         }
         else
             bVaild = false;
       }

       //Do we have threshold paramaters for saving?
       String test = request.getParameter("T0a");
       if(test != null){
         Vector params = new Vector();
         if(thresholds == null)
           /**@todo Display error*/
           return;
         //If so lets create a replica of the threshold vector
         for(int i =0; i<thresholds.size() ;i++){
           //Only used to get the name
           ThresholdData tData = (ThresholdData)thresholds.get(i);
           String res = tData.getResName();
           if(res == null || (res.equals("All"))){
             res = resourceObject.getString("ALL");
           }
           CmxThresholds cmxThresholds =
             new CmxThresholds(request.getParameter("T" + i + "d"),
                            request.getParameter("T" + i + "c"),
                            request.getParameter("T" + i + "b"),
                            request.getParameter("T" + i + "a"));

        //out.write("<!-- "+cmxThresholds.getCritical() +"," + cmxThresholds.getCriticalReset()+   " -->");

        //check to make sure it is vaild data
           if(! (cmxThresholds.isDataValid() ==0)){
             bVaild = false;
             break; //for the for loop
           }
           ThresholdData data = new ThresholdData(res,cmxThresholds);
           params.add(i,data);
           //If we are done and all went ok then save
           if(i==thresholds.size()-1){
             threshold.setSavedThresholds(params);
           }
         }
       }

       //Try to save the data we recived from pramaters
       saveError = threshold.save();
       }

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();

    MxTag okBtnTag = new MxDefaultTag("okBtn", resourceObject.getString("OK"), "okclick()");
    okBtnTag.setAttr(MxTag.TYPE, "submit");
    buttons.addMxTag(okBtnTag);
%>

<html>

<head>
    <script language="javascript" type="text/javascript">
      function myOnLoad(){

        <%if (which.equals("system")){%>
            //remove the threshold radio button
            document.getElementById("threshold").style.display= "none";
            //remove and only display the polling date
            document.getElementById("thresholdDate").style.display= "none";
            //Set the polling radio to checked
             document.getElementById("radio").checked = true;
        <%}else if( szClusterName.equals("All")){%>
           //Hide the polling data so that it only shows if the radio button is clicked
            document.getElementById("polling").style.display= "none";
            document.getElementById("pollingDate").style.display= "none";
        <%}%>
        <%if (!szClusterName.equals("All")){%>
          //Disable to radio buttons and remove the polling data
          document.getElementById("radio").disabled=true;
          document.getElementById("pollingDate").style.display= "none";
        <%}%>

        //The shouldnt be able to click ok till they changed something
        ourButtonManager.disableButtonById('okBtn');
      }

      //Switch between thresholds and polling
      function changeRadio(){
        if(document.getElementById("radio").checked){
          document.getElementById("thresholds").style.display= "none";
          document.getElementById("thresholdDate").style.display= "none";
          document.getElementById("polling").style.display= "";
          document.getElementById("pollingDate").style.display= "";
        }
        else{
          document.getElementById("polling").style.display= "none";
          document.getElementById("pollingDate").style.display= "none";
          document.getElementById("thresholds").style.display= "";
          document.getElementById("thresholdDate").style.display= "";
        }
      }

      //Detect if a key was pressed in a text box
      function detectChange(){
        ourButtonManager.enableButtonById('okBtn');
      }

      function okclick(){
        <%if( which == "system"){%>
            document.getElementById("form").submit();
        <%}else{%>
        var changed = false; //Have they changed 1 value?
        <%if(szClusterName.equals("All")){
          %>changed = true;<%
        }%>

        //Go through the threasholds and make sure at least 1 field has changed
      <% if (thresholds != null)
           for(int i =0; i <thresholds.size() ;i++){
              ThresholdData data = (ThresholdData)thresholds.get(i);
      %>
          var T<%=i%>a = document.getElementById('T<%=i%>a').value;
          var T<%=i%>b = document.getElementById('T<%=i%>b').value;
          var T<%=i%>c = document.getElementById('T<%=i%>c').value;
          var T<%=i%>d = document.getElementById('T<%=i%>d').value;
          if( T<%=i%>a != <%=data.getCritical()%> ||
              T<%=i%>b != <%=data.getCriticalReset()%> ||
              T<%=i%>c != <%=data.getWarning()%> ||
              T<%=i%>d != <%=data.getWarnReset()%>   ){
             changed = true;
          }
       <%}%>
       if(changed){
          // submit the form and reload the page to try to save
         document.getElementById("form").submit();
       }
       <%}%>
       //otherwize disable the ok button becasue nothing has changed
       ourButtonManager.disableButtonById('okBtn');
     }

    </script>
   <link type='text/css' rel='stylesheet' href='/mxportal/DevicePage/css/MxDevice.css'>
   <link type='text/css' rel='stylesheet' href='/mxportal/css/MxPortalEx.css'>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxButton.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</head>

<body onLoad='myOnLoad();'>
<% if (!bVaild){%>
  <script language="javascript" type="text/javascript">
  alert("<%=resourceObject.getString("INVALID_DATA")%> <%=resourceObject.getString("NOT_CHANGED")%>");
  </script>
<%}%>

<% if ((saveError != 0 && threshold.isDeviceDeleted() == true) || bLoadFailed == true ){%>
  <script language="javascript" type="text/javascript">
  alert("<%=resourceObject.getString("DeviceDeleted")%>");
  parent.frames[0].location.href="CmNodeResourceTop.jsp";
  parent.frames[1].location.href="/ui/jsp/DefaultCmxPropertySheet.htm";
  </script>
<%}%>

<% if (saveError != 0 && threshold.didSaveFail() == true){%>
  <script language="javascript" type="text/javascript">
  alert("<%=resourceObject.getString("UnableToSaveProperties")%>");
  </script>
<%}%>

<% if (bLoadFailed == false || (saveError != 0 && threshold.isDeviceDeleted() == true)){%>
<table border="0" style="border-collapse: collapse" width="100%" >
  <tr>
    <td width="14%" height="1px" valign="top">
       <table border="0" cellpadding="0" cellspacing="0">
         <tr>
           <td  valign="bottom" align="left"  height="25">
             <input type="radio" value="Polling" name="radio" id="radio" onClick="changeRadio()" ><b><%=resourceObject.getString("POLLING")%></b>
           </td>
         </tr>
         <tr name="threshold" id="threshold">
           <td   valign="bottom" align="left" height="25">
            <input type="radio" value="Threshold" name="radio" id="radio" onClick="changeRadio()" checked><b><%=resourceObject.getString("THRESHOLD")%></b>
           </td>
        </tr>
       </table>
    </td>
    <td width="86%">
    <div align="right">
    <FORM METHOD="POST" NAME="form" id="form" ACTION="<%=url%>">
      <%if(!which.equals("system")){%>
      <table border="0" cellpadding="0" cellspacing="0" width="100%" name="thresholds" id="thresholds">
        <tr>&nbsp;&nbsp;</tr>
        <tr>&nbsp;&nbsp;</tr>
        <tr>
          <td valign="bottom" height="21" align="left"  style="border-bottom: 1px solid #000000"><%=resourceObject.getString(szCMX)%></td>
          <td valign="bottom" height="21" align="right" style="border-bottom: 1px solid #000000"><%=resourceObject.getString("MAJOR")%></td>
          <td valign="bottom" height="21" align="right" style="border-bottom: 1px solid #000000"><%=resourceObject.getString("RESET")%></td>
          <td valign="bottom" height="21" align="right" style="border-bottom: 1px solid #000000"><%=resourceObject.getString("MINOR")%></td>
          <td valign="bottom" height="21" align="right" style="border-bottom: 1px solid #000000"><%=resourceObject.getString("RESET")%></td>
          <td valign="bottom" height="21" align="right"  width="14%" rowspan="1000">&nbsp;</td>
        </tr>
        <%
        thresholds = threshold.getThresholds();
        for(int i =0; i <thresholds.size() ;i++){
          ThresholdData data;
          data = (ThresholdData)thresholds.get(i);

          String res = data.getResName();
          if(res == null || res.equals("All")){
            res = resourceObject.getString("ALL");
          }
          %>
          <tr>
            <td height="25"  align="left" nowrap="nowrap" valign="center">
            <NOBR><%=res%></NOBR></td>
            <td  height="25" align="right">
             <input type="text" name="T<%=i%>a" id="T<%=i%>a" size="1" maxlength="3" style="text-align: right" ONKEYDOWN="detectChange(event)"
                 value="<%= data.getCritical()%>">
            </td>
            <td height="25" align="right">
             <input type="text" name="T<%=i%>b" id="T<%=i%>b" size="1" maxlength="3" style="text-align: right" ONKEYDOWN="detectChange(event)"
                 value="<%=data.getCriticalReset()%>">
            </td>
            <td height="25" align="right">
             <input type="text" name="T<%=i%>c" id="T<%=i%>c" size="1" maxlength="3" style="text-align: right" ONKEYDOWN="detectChange(event)"
                 value="<%=data.getWarning()%>">
            </td>
            <td height="25" align="right">
             <input type="text" name="T<%=i%>d" id="T<%=i%>d" size="1" maxlength="3" style="text-align: right" ONKEYDOWN="detectChange(event)"
                 value="<%= data.getWarnReset()%>">
            </td>
          </tr>
          <tr></tr>
        <%}%>

      </table>
      <%}%>
      <%if (szClusterName.equals("All")){%>
      <table border="0" cellpadding="0" cellspacing="0"  name="polling" id="polling" align="left">
        <%String valign="middle";
          if(which.equals("system")){
            valign="middle";
          %>
        <tr>
            <td height="2">&nbsp;</td>
        </tr>
        <%}%>
        <tr valign="middle">
         <%
          PollingData pData = threshold.getPollingData();
         %>
         <td valign="<%=valign%>" align="left" height="25" valign="middle"><%=resourceObject.getString("SETPOLL")%>&nbsp;</td>
         <td valign="<%=valign%>" align="left" height="25" valign="middle">
            <input type="text" name="min" id="min" size="1" maxlength="3" ONKEYDOWN="detectChange()" value="<%=pData.getMinutes()%>">&nbsp;
         </td>
         <td valign="<%=valign%>" align="left" height="25" valign="middle"><%=resourceObject.getString("MINUTES")%>&nbsp;</td>
         <td valign="<%=valign%>" align="left" height="25" valign="middle">
            <input type="text" name="sec" id="sec" size="1" maxlength="3" ONKEYDOWN="detectChange()" value="<%=pData.getSeconds()%>">&nbsp;
         </td>
         <td valign="<%=valign%>" align="left" height="25" valign="middle"><%=resourceObject.getString("SECONDS")%>&nbsp;</td>
        </tr>
      </table>
      <%}%>
    </form>
    </div>
    </td>
  </tr>
 </table>
 <br>
 <hr class='mx-hr'>
 <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" bordercolor="#111111" width="100%">
  <tr>
   <td>&nbsp;</td>
   <td align="left" valign="middle" name="thresholdDate" id="thresholdDate">
      <%=threshold.getSaved(resourceObject,loginBean.getLocale(),true)%>
   </td>
   <td align="left" valign="middle" name="pollingDate" id="pollingDate">
      <%=threshold.getSaved(resourceObject,loginBean.getLocale(),false)%>
   </td>
   <td align="right" valign="middle">
      <% buttons.dumpButtons(out); %>
   </td>
  </tr>
 </table>
<%}%>
<% MxHtmlUtil.dumpBodyEnd(out); %>

</body>
</html>
