<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.html.table.*"%>
<%@ page import="com.hp.mx.portal.ui.*"%>

<jsp:useBean id="manageKeysSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session"/>
<jsp:useBean id="manageKeysTableView" class="com.hp.mx.html.table.MxTableView2" scope="session"/>
<jsp:useBean id="manageKeysTableController" class="com.hp.mx.html.table.MxTableController" scope="session"/>
<jsp:useBean id="manageKeysTableModel" class="javax.swing.table.DefaultTableModel" scope="session"/>
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="lmBean" class="com.hp.mx.portal.lm.lmBean" scope="session"/>

<% MxBean.jspInit(request, response); %>
<jsp:setProperty name="lmBean" property="*" />

<%
    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;


    if (!loginBean.getMxUser().hasPrivilege(lmBean.getPrivRqd()))
    {
%>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
<%
    }


    lmBean.initBean(out, loginBean);

    if ( false == lmBean.isLibLoaded() )
    {
%>
        <script language='javascript' type='text/javascript'>
           document.location='<%=lmBean.getResString("URL_ILL_PAGE","lm_ill.jsp")%>';
        </script>
<%
    }

    if (manageKeysTableController.isFirstTime())
    {
        lmBean.getColumnNames(manageKeysTableModel);
        manageKeysSelectionModel.setSelectionMode(MxTableSelectionModel.SINGLE_SELECTION);
        manageKeysTableView.setId("ID_MK_TABLE");
        manageKeysTableView.setOnSelectionChange("mySelectionChanged");

        manageKeysTableView.setUrlHandler(request.getRequestURI());

        manageKeysTableController.setTableModelWithSorting(manageKeysTableModel);
        MxTableSortingModel sortingModel = manageKeysTableController.getSortingModelOrNull();
        sortingModel.sortTable(0, true);  //sort by first column
        manageKeysTableController.setSelectionModel(manageKeysSelectionModel);
        manageKeysTableController.setTableView(manageKeysTableView);
    }

    // do we need to abort?
    if (manageKeysTableController.checkUrlForControllerMessages(request, out))
    {
        //out.write("<script>alert('controller msg');</script>");
        return;
    }
    int titleHeight  = 20; //19;
    int rowHeight    = 19; //18;
    int maxDisplayed = 10;

    manageKeysTableModel.setRowCount(0);          //clear data
    manageKeysTableModel.fireTableDataChanged();
    lmBean.refreshKeys(manageKeysTableModel);     //fill up with data

    int numKeys = manageKeysTableModel.getRowCount();
    int limitKeys = numKeys ;
//    if (limitKeys > 12) limitKeys = 12 ;
//    if (numKeys > 0)
//    {
//        manageKeysSelectionModel.setSelectedIndex(0, true);
//    }

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();
    buttons.addMxTag(new MxDefaultTag("btnAddKey", lmBean.getResString("LBL_ADD_KEY","Add Key..."), "showAddKeyPage()"));
    buttons.addMxTag(new MxDefaultTag("btnAddKeyFile", lmBean.getResString("LBL_ADD_KEY_FILE","Add Key from File..."), "showAddKeyFilePage()"));
%>

    <html>
      <head>
        <title>
           License Manager - Manage Keys - main page
        </title>

        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxBrowser.js'></script>
        <script language="javascript" type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxPortalApi.js' ></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/lm/js/lm.js'></script>

        <script language='javascript' type='text/javascript'>

            var numKeys   = <%=numKeys%> ;
            var limitKeys = <%=limitKeys%> ;

            var REFRESH_TIMEOUT          = 10000; // 10 seconds
            var NETSCAPE_SCROLLBAR_WIDTH = 36;

            // set the help context.
            MxPortalWorkspaceSetHelpTopic('useTools_license_manageKeys_viewContents');

            function mySelectionChanged(szIdTable, iRow, bSelected)
            {
               selectKey(szIdTable, iRow);
            }

            function selectKey(szIdTable, iRow)
            {
               var bottomframe = document.getElementById('frm3Display');
               bottomframe.src = '<%=lmBean.getResString("URL_VIEW_KEY_PAGE","lm_mkViewKeys.jsp")%>';
            }

            function refreshList(sel)
            {
               document.location = '<%=lmBean.getResString("URL_MANAGE_PAGE","lm_mkManageKeys.jsp")%>'
                    + '?productType=' + sel.value;
               return true;
            }

            function showAddKeyPage()
            {
               var bottomframe = document.getElementById('frm3Display');
               bottomframe.contentWindow.document.location.replace("<%=lmBean.getResString("URL_ADD_KEY_PAGE","lm_mkAddKey.jsp")%>?reqType=<%=lmBean.REQUEST_TYPE_CLEAR%>");
            }

            function showAddKeyFilePage()
            {
               var bottomframe = document.getElementById('frm3Display');
               bottomframe.contentWindow.document.location.replace("<%=lmBean.getResString("URL_ADD_KEY_FILE_PAGE","lm_mkAddKeyFile.jsp")%>?reqType=<%=lmBean.REQUEST_TYPE_CLEAR%>");
            }

            function loadPage()
            {
                ourButtonManager.enableButtonById('btnAddKey');
                ourButtonManager.enableButtonById('btnAddKeyFile');
                document.location = "#MANAGE_PAGE_TOP";
            }

            function myResize()
            {
            }


            function setTableHeight()
            {
                  var keys          = numKeys ;
                  var iframe        = document.getElementById('DPI');
                  var rowHeight   = iframe.contentWindow.getCellHeight();
                  var titleHeight   = iframe.contentWindow.getTitleHeight();
                  // add 1 to the "numNodes" because the horizontal scroll bar will take 1 row
                  if (numKeys > 15)
                  {
                     keys = 15 ;
                  }
                     var tableHeight = (rowHeight * (keys + 1)) + titleHeight;
                     MxTableSetHeight('ID_MK_TABLE', tableHeight);
            }

        </script>

        <% MxHtmlUtil.dumpHeadBegin(out); %>
        <% buttons.dumpHeadContent(out); %>
        <% manageKeysTableView.dumpHeadContent(out); %>
        <% MxHtmlUtil.dumpHeadEnd(out); %>
    </head>

    <body onLoad='setTableHeight(), loadPage(), myResize()' onResize='myResize()'>
    <!--body onLoad='loadPage(), selectTask()' onResize='myResize()'-->
    <a name='MANAGE_PAGE_TOP'></a>
    <br>
<%
    if (numKeys > 0)
    {
%>
    <table border="0" cellpadding="0" cellspacing="0" style="width:100%">
       <tr>
          <td align="left">
             <b><%=lmBean.getResString("TXT_KEY_LIST","Key List")%></b>
          </td>
          <td id="totalTasks" align="right" nowrap>
             <b><%=lmBean.getResString("TXT_NO_OF_KEYS","Total:")%></b>
             &nbsp;<%=numKeys%>
          </td>
       </tr>
    </table>
    <br>
<%
       manageKeysTableView.dumpWholeTable(out);
    }
    else
    {
%>
       <center>
          <b><i><font color='red'>
             <%=lmBean.getResString("TXT_NO_KEYS","There are no keys to display.")%>
          </font></i></b>
       </center>
<%
    }
%>
    <br>
<div style="margin-top:15px">
    <% buttons.dumpButtons(out); %>
</div>

    <iframe id='frm3Display' style=' position:relative; visibility:visible; width:100%; height:5000;'
        scrolling='no' marginwidth='0' frameborder='0'
        src='<%=lmBean.getResString("URL_BLANK_PAGE","lm_blank.html")%>'>
    </iframe>

    <iframe id='DPI' name='DPI' style='position:relative; visibility:hidden; height:100'
                scrolling='no' marginwidth='0' frameborder='1' src='<%=MxOptions.URL_BASE%>/taskandjob/DPI.html'>
    </iframe>

    <% MxHtmlUtil.dumpBodyEnd(out); %>
    </body>
</html>
