<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*"%>
<%@ page import="com.hp.mx.portal.core.MxObjList"%>
<%@ page import="com.hp.mx.core.controllers.*"%>
<%@ page import="java.util.*"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxListToSystemNames"%>
<%@ page import="com.hp.mx.core.nodemanager.MxNode"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskWizardInstance"%>
<%@ page import="com.hp.mx.core.nodemanager.DeviceTypesIfc"%>

<jsp:useBean id="validateSelectionModelTwo" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session"/>
<jsp:useBean id="validateTableViewTwo" class="com.hp.mx.html.table.MxTableView2" scope="session"/>
<jsp:useBean id="validateTableControllerTwo" class="com.hp.mx.html.table.MxTableController" scope="session"/>
<jsp:useBean id="validateTableModelTwo" class="javax.swing.table.DefaultTableModel" scope="session"/>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="taskWizardBean" class="com.hp.mx.portal.taskandjob.MxTaskWizard" scope="session"/>
<jsp:useBean id="lmBean" class="com.hp.mx.portal.lm.lmBean" scope="session"/>

<% MxBean.jspInit(request, response); %>
<jsp:setProperty name="lmBean" property="*" />

<%
    if (loginBean.checkLogoutConditionForWebPage(pageContext)) return;

    // Get the Instance Data for this Task Wizard Instance
    String               timeStamp = request.getParameter("timeStamp");
    MxTaskWizardInstance inst      = (MxTaskWizardInstance)taskWizardBean.getInstance(timeStamp);

    if (!loginBean.getMxUser().hasPrivilege(lmBean.getPrivRqd()))
    {
%>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
<%
    }
    lmBean.initBean(out, loginBean);

    String reqMethod = request.getMethod() ;
    String reqType   = "there" ;
    if (null != request.getParameter("reqType"))
    {
       reqType = request.getParameter("reqType");
    }
    lmBean.myDebug( 0, "lm_validateLicense2 Method="+reqMethod+", reqType="+reqType, "" );

    int index = 0 ;
    int numTargets   = 0 ;

    lmBean.pNameCodeList[0] = lmBean.getPNameCode() ;
    lmBean.pVerCodeList[0]  = lmBean.getPVerCode()  ;
    lmBean.pNameList[0]     = lmBean.getPName()     ;
    lmBean.pVersionList[0]  = lmBean.getPVersion()  ;

    lmBean.pNameCodeList[1] = lmBean.getPNameCode2() ;
    lmBean.pVerCodeList[1]  = lmBean.getPVerCode2()  ;
    lmBean.pNameList[1]     = lmBean.getPName2()     ;
    lmBean.pVersionList[1]  = lmBean.getPVersion2()  ;

    lmBean.setIndexNum( lmBean.getIndexNum() + 1 ) ;
    lmBean.myDebug( 0, "lm_validateLicense2 licensed index="+lmBean.getIndexNum(), "" );

    if ( 1 == lmBean.getIndexNum() )
    {
       //put together the working list of initially unlicensed targets
       lmBean.myDebug( 0, "lm_validateLicense2, get target list first time", "" );

       lmBean.clearLicenseList();
       lmBean.clearJustLicensedList();
       lmBean.clearWorkList();
       lmBean.clearDisplayList();

       lmBean.clearLicenseList2();
       lmBean.clearJustLicensedList2();
       lmBean.clearWorkList2();
       lmBean.clearDisplayList2();

       lmBean.setMsgHeader(lmBean.getResString("MSG_VALIDATE_LICENSED_NODES","Licensed Nodes: "));
       lmBean.setLicensedNodes(lmBean.getMsgHeader() ) ;

        // mjbalunis - QUAKE API Changes - 12/08/2004
        //    isListSelected() is deprecated.  Move to a getSelectionType()
        if (inst.getSelectionType() == MxTaskWizardInstance.NODE_SELECTION)
       //if ( false == inst.isListSelected() )
       {
           // get an MxObjList containing the MxNode objects
           MxObjList oList = inst.getMxObjNodeList();

           for (index = 0; index < oList.size(); index++)
           {
               String aName = oList.get(index).getMxNode().getNameString();
               lmBean.processNodeTwo( aName );
           }

          //discrete list of targets
          //numTargets = inst.getNumNodesSelected();
          //for ( index=0; index<numTargets; index++ )
          //{
          //   String aName = inst.getNodeHostName(index);
          //   lmBean.processNode( aName );
          //}
       }
       else if (inst.getSelectionType() == MxTaskWizardInstance.QUERY_SELECTION)
       {
           // mjbalunis - QUAKE API Changes - 12/08/2004
           //   "int getListID()" has been removed and replaced with "int getSelectedListID()"; though this API is deprecated
           //   should move to "MxObjectID getSelectedQuery()"
          //String listName = "" ;
          //listName = inst.getListName() ; // this is not used
          int listID = 0 ;
          //listID = inst.getListID() ;
          listID = Integer.parseInt(inst.getSelectedListID());

          MxListToSystemNames names = new MxListToSystemNames(loginBean, listID);
          List systemNames = names.executeQuery();
          List fred = names.getSystemNames();
          ListIterator li = fred.listIterator(); //certList.listIterator();
          int listcnt = 0;
          for (int i=0; li.hasNext(); i++)
          {
             String aName = ( String ) li.next() ;
             try
             {
                MxNode dev   = MxNodeController.getDefaultControllerNoEx().getNodeByHostname(  aName );
                aName =dev.getDeviceName() ;
             }
             catch (Exception e)
             {
                lmBean.myDebug( 0, "lm_validateLicnese2 dsn translation exception, "+aName, "" );
             }
             lmBean.processNodeTwo( aName );
          }
       }
    }
    lmBean.myDebug( 0, "lm_validateLicense2 licensed index="+lmBean.getIndexNum(), "" );
    lmBean.myDebug( 0, "lm_validateLicense2 licensed nodes="+lmBean.getLicensedCount(), "" );

    int stat = lmBean.sLicenseAccountTwo() ;


    String availDisplayS = lmBean.getResString("MSG_UNLIMITED","No seat limit") ;
    if ( !lmBean.getAvail().equalsIgnoreCase("99999" ))
    {
         availDisplayS = lmBean.getAvail() ;
    }

    String availDisplayC = lmBean.getResString("MSG_UNLIMITED","No seat limit") ;
    if ( !lmBean.getAvail2().equalsIgnoreCase("99999" ))
    {
         availDisplayC = lmBean.getAvail2() ;
    }

    int numNodes = 0 ;


    if (validateTableControllerTwo.isFirstTime())
    {
        lmBean.getValidateColumnNamesTwo(validateTableModelTwo);
        validateTableViewTwo.setId("ID_TMLV2_TABLE");
        validateTableViewTwo.setOnSelectionChange("mySelectionChanged");

        validateTableViewTwo.setUrlHandler(request.getRequestURI());

//        validateTableControllerTwo.setTableModelWithSorting(validateTableModelTwo);
//        MxTableSortingModel sortingModel = validateTableControllerTwo.getSortingModelOrNull();
//        sortingModel.sortTable(0, true);  //sort by first column

        validateTableControllerTwo.setTableModel(validateTableModelTwo);
        validateTableControllerTwo.setSelectionModel(validateSelectionModelTwo);
        validateTableControllerTwo.setTableView(validateTableViewTwo);
    }
    // do we need to abort?
    if (validateTableControllerTwo.checkUrlForControllerMessages(request, out))  return;

    lmBean.refreshValidateTwo(validateTableModelTwo);     //fill up with data

    numNodes = validateTableModelTwo.getRowCount();
    //build the table to display

    int titleHeight  = 20; //19;
    int rowHeight    = 19; //18;
    int maxDisplayed = 10;

    String sExp    = "" ;
    int    iExp    = 0  ;
    String sRet    = "" ;
    int    iRet    = 0  ;

    if ( null != request.getParameter("reqType") )
    {
        reqType = request.getParameter("reqType");
    }

    if ( ( reqType.equalsIgnoreCase(lmBean.REQUEST_TYPE_APPLYLICENSE)    ) ||
         ( reqType.equalsIgnoreCase(lmBean.REQUEST_TYPE_APPLYLICENSETWO) ) )
    {
       if ( null != request.getParameter("iExp") )
       {
          sExp = request.getParameter("iExp");
          try
          {
             iExp = Integer.parseInt(sExp.trim());
          }
          catch (NumberFormatException e)
          {
             iExp = 0 ;
             lmBean.myDebug( 0, "lm_validateLicense2, license node error reporting expected.", "" );
          }
       }
       if ( null != request.getParameter("iRet") )
       {
          sRet = request.getParameter("iRet");
          try
          {
             iRet = Integer.parseInt(sRet.trim());
          }
          catch (NumberFormatException e)
          {
             iRet = 0 ;
             lmBean.myDebug( 0, "lm_validateLicense2, license node error reporting actual.", "" );
          }
       }
    }


%>
    <script language='javascript' type='text/javascript'>
            var nodeTypes = new Array(<%=numNodes%>);
<%
            ListIterator lin = lmBean.displayList.listIterator();
            for (int i=0; lin.hasNext(); i++)
            {
               String nodeType = (String) lin.next() ;
%>
               nodeTypes[<%=i%>] = '<%=nodeType%>' ;
<%
            }
%>
    </script>

    <html>
      <head>
        <title>
           ProLiant Essentials License Manager - License Validation Page for Plug-ins
        </title>

        <link href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css' rel='stylesheet' type='text/css'>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/taskandjob/css/taskAndJob.css'>

        <script language='javascript' type='text/javascript' src='/SessionReset.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/taskWizard.js'></script>
        <script language="javascript" type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxPortalApi.js' ></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxBrowser.js'></script>

        <script language='javascript' type='text/javascript'>

            // set the help context.
            var helpurl = '<%=lmBean.getHelpURL()%>' ;

            if ( 0 == helpurl.length)
            {
               var basehelpurl = '<%=lmBean.getBaseHelpURL()%>' ;
               MxPortalWorkspaceSetHelpTopic( basehelpurl );
            }
            else
            {
               var helpurl = '<%=lmBean.getHelpURL()%>' ;
               MxPortalWorkspaceSetHelpUrl( helpurl ) ;
            }

            var items      = 0 ;
            var newSeats   = 0 ;
            var availSeats = 0 ;

            var items1      = 0 ;
            var newSeats1   = 0 ;
            var availSeats1 = 0 ;

            var items2      = 0 ;
            var newSeats2   = 0 ;
            var availSeats2 = 0 ;

            var numNodes   = <%=numNodes%>;
            var numTargets = <%=numTargets%>;
            var index      = <%=index%>;

            var notLicensed = <%=lmBean.getNotLicensedCount()%>;
            var licensed    = <%=lmBean.getLicensedCount()%>;

            var avail  = <%=lmBean.getAvail()%>  ;
            var avail1 = <%=lmBean.getAvail()%>  ;
            var avail2 = <%=lmBean.getAvail2()%> ;

            var rUse1  = <%=lmBean.getRSeats()%>  ;
            var rUse2  = <%=lmBean.getRSeats2()%> ;

            var iExp = <%=iExp%> ;
            var iRet = <%=iRet%> ;

            var nodeLicense = new Array(<%=numNodes%>);

            for ( var i = 0; i < numNodes ; i++ )
            {
               nodeLicense[i] = 0 ;
            }

            function displayCustomButtons()
            {
                document.write("<td>");
                document.write( ourButtonManager.makeMxButton('customBtn1', '<%=lmBean.getResString("LBL_ADD_KEY","&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Add Key...&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;")%>', 'showAddKeyPage()') );
                document.write("</td>");
                ourButtonManager.initButtonById('customBtn1');

                document.write("<td>");
                document.write( ourButtonManager.makeMxButtonMed('customBtn2', '<%=lmBean.getResString("LBL_APPLYKEYS","&nbsp;&nbsp;Apply License&nbsp;&nbsp;")%>', 'applyLicense()', false, false, true) );
                document.write("</td>");
                ourButtonManager.initButtonById('customBtn2');
            }

            function showAddKeyPage()
            {
               var bottomframe = document.getElementById('frm3Display');
               bottomframe.contentWindow.document.location.replace('<%=lmBean.getResString("URL_ADD_KEY_TWO_PAGE","lm_mkAddKeyTwo.jsp")%>');
            }


            function applyLicense()
            {
                  //String sI = 'tm_configureScan2.jsp?reqType='+iSelected+'&reqName='+sDAT;
                  var sI = '<%=lmBean.getResString("URL_UPDATE_CORE_PAGE","lm_mkUpdateCore.jsp")%>?reqType=<%=lmBean.REQUEST_TYPE_APPLYLICENSETWO%>';
                  var nIndex = 1 ;
                  for ( cntr=1; cntr<=numNodes; cntr++)
                  {
                      var selNode = getWizardParameter(cntr);
                      removeWizardParameter( cntr ) ;
                      if (( selNode != null ) && ( selNode.length != 0 ))
                      {
                         sI = sI + "&n" + ("" + nIndex) + "=" + selNode ;
                         nIndex = nIndex + 1;
                      }
                  }
                  document.location = sI ;
                 return true ;
            }

            function mySelectionChanged(szIdTable, iRow, bSelected)
            {
               var nodeName   ;
               var licStatus  ;
               var nodeType   ;
               var nNodes     ;

               // items is the number of items selected.

               var removeMsgFlag = 0 ;

               if (( iRow >= 0 ) && ( iRow < numNodes))
               {
                  nodeName  = MxTableGetValueAt(szIdTable, iRow, 0);
                  licStatus = MxTableGetValueAt(szIdTable, iRow, 1);
                  nodeType  = MxTableGetValueAt(szIdTable, iRow, 3);

                  if ( ( -1 == licStatus.indexOf('<%=lmBean.getResString("MSG_LICno","Not licensed")%>')            )  &&
                       ( -1 == licStatus.indexOf('<%=lmBean.getResString("MSG_DEMOlic","Licensed with demo key")%>'))  &&
                       ( -1 == licStatus.indexOf('<%=lmBean.getResString("MSG_DEMOlicexp","Demo key expired.")%>')  )  )
                  {
                     if ( true == bSelected )
                     {
                        alert('<%=lmBean.getResString("MSG_LICserverUsed","This node is already licensed")%>');
                     }
                  }
                  else
                  {
                     if ( true == bSelected )
                     {
                        if ( 0 == nodeLicense[iRow] )
                        {
                           items = items + 1 ;
                           if ( ( -1 == nodeType.indexOf('<%=DeviceTypesIfc.DEVICE_PRODUCTTYPE_DESKTOP_STR%>')     )  &&
                                ( -1 == nodeType.indexOf('<%=DeviceTypesIfc.DEVICE_PRODUCTTYPE_PORTABLE_STR%>')    )  &&
                                ( -1 == nodeType.indexOf('<%=DeviceTypesIfc.DEVICE_PRODUCTTYPE_WORKSTATION_STR%>') ))
                           {
                              // server license
                              if ( (items1 + rUse1) > avail1 )
                             {
                                 alert('<%=lmBean.getResString("MSG_INSUFFLICSFULL","Insufficient number of server licenses")%>');
                             }
                             items1 = items1 + rUse1 ;
                             nodeLicense[iRow] = 1 ;  // using full
                           }
                           else
                           {
                              if ( (items2 + rUse2) > avail2 )
                              {
                                 if ( (items1 + rUse1) <= avail1 )
                                 {
                                    var msg= "<%=lmBean.getResString("MSG_INSUFFLICSCLIENT","Insufficient number of client licenses")%>" + "  " +
                                             "<%=lmBean.getResString("MSG_LICsomeclientFull","Some clients will be licensed using a server license.")%>" ;
                                    alert(msg) ;
                                    items1 = items1 + rUse1 ;
                                    nodeLicense[iRow] = 1 ; // using full
                                 }
                                 else
                                 {
                                    alert('<%=lmBean.getResString("MSG_INSUFFLICSCLIENT","Insufficient number of client licenses.")%>');
                                    items2 = items2 + rUse2 ;
                                    nodeLicense[iRow] = 2 ;  // using client
                                 }
                              }
                              else
                              {
                                 items2 = items2 + rUse2 ;
                                 nodeLicense[iRow] = 2 ;  // using client
                              }
                           }
                           saveWizardParameter( iRow+1, nodeName ) ;
                        }
                     }
                     else
                     {
                        items = items - 1 ;
                        if ( 1 == nodeLicense[iRow] )
                        {
                           items1 = items1 - rUse1 ;
                        }
                        else
                        {
                           items2 = items2 - rUse2 ;
                        }
                        removeWizardParameter( iRow+1 ) ;
                        nodeLicense[iRow] = 0 ;
                     }
                  }
               }
               else
               {
                  var alreadylicensedflag = 0 ;
                  var notenufclient       = 0 ;
                  var notenuffull         = 0 ;
                  var someclientfull      = 0 ;

                  for ( var i = 0; i < numNodes ; i++ )
                  {
                     if ( true == bSelected )
                     {
                         nodeName  = MxTableGetValueAt(szIdTable, i, 0);
                         licStatus = MxTableGetValueAt(szIdTable, i, 1);
                         nodeType  = MxTableGetValueAt(szIdTable, i, 3);

                        if ( ( -1 == licStatus.indexOf('<%=lmBean.getResString("MSG_LICno","Not licensed")%>')                    )  &&
                             ( -1 == licStatus.indexOf('<%=lmBean.getResString("MSG_DEMOlic","Licensed with demo key")%>') )  &&
                             ( -1 == licStatus.indexOf('<%=lmBean.getResString("MSG_DEMOlicexp","Demo key expired.")%>')    )  )
                        {
                            alreadylicensedflag = 1 ;
                        }
                        else
                        {
                            if ( ( -1 == nodeType.indexOf('<%=DeviceTypesIfc.DEVICE_PRODUCTTYPE_DESKTOP_STR%>')     )  &&
                                 ( -1 == nodeType.indexOf('<%=DeviceTypesIfc.DEVICE_PRODUCTTYPE_PORTABLE_STR%>')    )  &&
                                 ( -1 == nodeType.indexOf('<%=DeviceTypesIfc.DEVICE_PRODUCTTYPE_WORKSTATION_STR%>') ))
                            {
                               if ( 0 == nodeLicense[i] )
                               {
                                  if ( (items1 + rUse1) > avail1 )
                                  {
                                     notenuffull = 1 ;
                                  }
                                  items1 = items1 + rUse1 ;
                                  nodeLicense[i] = 1 ;  // using full
                                  saveWizardParameter( i+1, nodeName ) ;
                               }

                            }
                            else
                            {
                               if ( 0 == nodeLicense[i] )
                               {
                                  if ( (items2 + rUse2) > avail2 )
                                  {
                                     notenufclient = 1 ;
                                     if ( (items1 + rUse1) <= avail1 )
                                     {
                                        someclientfull = 1 ;
                                        items1 = items1 + rUse1 ;
                                       nodeLicense[i] = 1 ; // using full
                                    }
                                    else
                                    {
                                       items2 = items2 + rUse2 ;
                                       nodeLicense[i] = 2 ;  // using client
                                    }
                                  }
                                  else
                                  {
                                     items2 = items2 + rUse2 ;
                                     nodeLicense[i] = 2 ;  // using client
                                  }
                                  items=items+1;
                                  saveWizardParameter( i+1, nodeName ) ;
                               }
                            }
                        }
                     }
                     else
                     {
                        alreadylicensedflag = 0 ;
                        notenuffull         = 0 ;
                        someclientfull      = 0 ;
                        notenufclient       = 0 ;

                        items = 0 ; items1 = 0 ;  items2 = 0 ;
                        removeWizardParameter( i+1 ) ;
                        nodeLicense[i] = 0 ;
                     }
                   }
                   if ( 1 == alreadylicensedflag ) alert('<%=lmBean.getResString("MSG_LICsomeserverUsed","Some nodes are already licensed.")%>');
                   if ( 1 == someclientfull )
                   {
                      var msg= "<%=lmBean.getResString("MSG_INSUFFLICSCLIENT" ,"Insufficient number of client licenses.")%>" + "  " +
                               "<%=lmBean.getResString("MSG_LICsomeclientFull","Some clients will be licensed using a server license.")%>" ;
                      alert(msg) ;
                   }
                   else
                   {
                      if ( 1 == notenufclient       ) alert('<%=lmBean.getResString("MSG_INSUFFLICSCLIENT" ,"Insufficient number of client licenses.")%>');
                   }
                   if ( 1 == notenuffull ) alert('<%=lmBean.getResString("MSG_INSUFFLICSFULL"   ,"Insufficient number of server licenses")%>');
                }

                if ( 0 > items )
                {
                    items = 0 ;
                }
                if ( 0 > items1 )
                {
                    items1 = 0 ;
                }
                if ( 0 > items2 )
                {
                    items2 = 0 ;
                }

//                var msg = "item = "+items+",  item1 = "+items1+",  item2 = "+items2 ;
//                alert(msg);

//                if ( (( 0 < items1 ) || ( 0 < items2 ))           &&
//                     (( items1 + items2 ) <= ( avail1 + avail2 ))
//                   )
//                {
//                      enableButton(document.getElementById('customBtn2'), true);
//                }
//                else
//                {
//                      enableButton(document.getElementById('customBtn2'), false);
//                }

                var setApply = 0 ;

                if ( items1 > 0 )
                {
                   if ( items2 > 0 )
                   {
                      if ( ( items1 <= avail1 ) && (( items1 + items2 ) <= ( avail1 + avail2 )))
                      {
                         setApply = 1 ;
                      }
                   }
                   else
                   {
                       if ( items1 <= avail1 )
                       {
                          setApply = 1 ;
                       }
                   }
                }
                else
                {
                   if ( items2 > 0 )
                   {
                      if ( items2 <= avail2 )
                      {
                         setApply = 1 ;
                      }
                      else
                      {
                         if  (( items1 + items2 ) <= ( avail1 + avail2 ))
                         {
                             setApply = 1 ;
                         }
                      }
                   }
                }

                if (  1 == setApply )
                {
                      enableButton(document.getElementById('customBtn2'), true);
                }
                else
                {
                      enableButton(document.getElementById('customBtn2'), false);
                }

            }

            var error = <%=(request.getParameter("err") != null)%>;

            function prevButtonFunction()
            {
               if ( 0 == <%=lmBean.getPrevPage()%> )
               {
                  return true ;
               }
               jumpToWizardStep(<%=lmBean.getPrevPage()%> , <%=lmBean.getPrevStepNum()%>);
               return false ;
            }

            function nextButtonFunction()
            {
                  return true ;
            }


            function myResize()
            {
                var w = Math.max(0, MxBrowserGetBodyWidth(0, 0));
                MxTableSetWidth('ID_TMLV2_TABLE', w);
            }

            function setTableHeight()
            {
               if (numNodes > 0)
               {
                  var nodes       = numNodes ;
                  var iframe      = document.getElementById('DPI');
                  var rowHeight   = iframe.contentWindow.getCellHeight();
                  var titleHeight = iframe.contentWindow.getTitleHeight();
                  // add 1 to the "numNodes" because the horizontal scroll bar will take 1 row
                  if (numNodes > 15)
                  {
                     nodes = 15 ;
                  }
                     var tableHeight = (rowHeight * (nodes + 1)) + titleHeight;
                     MxTableSetHeight('ID_TMLV2_TABLE', tableHeight);
               }
            }

            function loadPage()
            {
                if ( licensed > 0 )
                {
                     ourButtonManager.enableButtonById('nextBtn');
                }
                else
                {
                     ourButtonManager.disableButtonById('nextBtn');
                }

                MxPortalWorkspaceSetSubtitleHtml('<%=lmBean.getLicensedNodes()%>');
                if ( iRet != iExp )
                {
                   alert('<%=lmBean.getResString("MSG_LICENSECLASH","Some selected nodes were not licensed as there are insufficient licenses to satisfy multiple user requests.")%>');
                }
            }
        </script>

        <% MxHtmlUtil.dumpHeadBegin(out); %>
        <% MxButton.dumpHeadContent(out); %>
        <% validateTableViewTwo.dumpHeadContent(out); %>
        <% MxHtmlUtil.dumpHeadEnd(out); %>
   </head>

   <body onLoad='setTableHeight(), loadPage(), myResize()' onResize='myResize()'>
<%
    if ((request.getMethod().equals("POST")) || ( 0 == lmBean.getDisplayCount() ))
    {    // IS THIS A POST?  Check data validity and redirect
       //we're done.  transfer the final list.
       lmBean.myDebug( 0, "lm_validate licensed="+lmBean.getLicensedNodes(), "" );

       String nextStepNumber = "" ;

       int iLicStepNumber  = lmBean.getStepNum()  ;

       int iNextStepNumber = lmBean.getIndexNum() ;

       if ( 1 == iNextStepNumber )
       {
          if ( 1 == lmBean.getNotLicensedCount() )
          {
             nextStepNumber = Integer.toString( iLicStepNumber + 1 ); //skipping licensing
          }
          else
          {
             nextStepNumber = Integer.toString( iLicStepNumber ); //licensing processed
          }
       }
       else
       {
           nextStepNumber = Integer.toString( iLicStepNumber + 1 ); //licensing processed
       }
%>
       <script language='javascript' type='text/javascript'>
           MxPortalWorkspaceSetSubtitleHtml('<%=lmBean.getLicensedNodes()%>');
           setWizardStepText('<%=lmBean.getResString("MSG_STEPDONE","Licensing step complete")%>');
           loadWizardNextStep( '<%=nextStepNumber%>' ) ;
       </script>
<%
    }
    else
    {    // THIS IS NOT A POST - Display normally
%>
       <%=lmBean.getResString("MSG_VALIDATE_DESCRIBE","Some of the selected target systems are unlicensed or licensed with demo keys.  Unlicensed systems cannot be included.")%>
       <br><br>
       <%=lmBean.getResString("MSG_VALIDATE_INSTRUCT","If there are more unlicensed systems than licenses available and you have one or more keys providing additional licenses for this product, use the <I>Add Key</I> or <I>Add Key from File</I> to add these licenses, as appropriate.")%>
       <table border="0" cellpadding="0" cellspacing="0" style="width:100%">
          <tr><td>&nbsp;</td></tr>
          <tr><td align="left" width="30%">
                <b>VPM Server Licenses Available:</b>&nbsp;<%=availDisplayS%>
          </td><td align="left" width="30%">
                <b>VPM Client Licenses Available:</b>&nbsp;<%=availDisplayC%>
          </td><td align="left" width="10%"><b>&nbsp;</b>
          </td><td id="totalTasks" align="right" width="30%">
             <b><%=lmBean.getResString("MSG_VALIDATE_NUMBER_WITHLIC","Licensed Systems:")%></b>
                    &nbsp;<%=lmBean.getLicensedCount()%>
         </td></tr>
       </table>
<%
       validateTableViewTwo.dumpWholeTable(out);
%>
       <br>
       <table width='100%'>
          <tr>
             <td >
                <script language='javascript' type='text/javascript'>
                   displayTaskWizardButtons(NO_SUBTITLE_UPDATE);
                </script>
             </td>
          </tr>
       </table>
       <br>

      <iframe id='frm3Display' style=' position:relative; visibility:visible; width:100%; height:5000;'
              scrolling='no' marginwidth='0' frameborder='0'
              src='<%=lmBean.getResString("URL_BLANK_PAGE","lm_blank.html")%>'>
      </iframe>

       <form id="frmDeployKey" name="frmDeployKey" action="lm_validateLicenseTW2.jsp" method="post">
              <select id='deployList' name='deployList' style='visibility:hidden' MULTIPLE></select>
       </form>

      <iframe id='DPI' name='DPI' style='position:relative; visibility:hidden; width:100%; height:100'
             scrolling='no' marginwidth='0' frameborder='1' src='<%=MxOptions.URL_BASE%>/taskandjob/DPI.html'>
       </iframe>

       <script language='javascript' type='text/javascript'>
            setFormSubmitName("frmDeployKey");
            setWizardStepText('<%=lmBean.getResString("MSG_VALIDATE_STEPDESC","License unlicensed systems (optional)")%>');
       </script>
<%
   }
%>

    <% MxHtmlUtil.dumpBodyEnd(out); %>
</body>
</html>
