<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="java.io.*" %>
<%@ page import="java.util.*" %>
<%@ page import="com.hp.mx.core.subjects.*" %>
<%@ page import="com.hp.mx.portal.ui.MxOptions" %>
<%@ page import="com.hp.mx.utilities.DebugOutput" %>
<%@ page import="com.hp.mx.utilities.DebugSubsystem" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="auditLogBean" class="com.hp.mx.portal.log.MxAuditLogBean" scope="session" />
<jsp:useBean id="rbAuditLog" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<script src="/mxportal/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
<script src="/SessionReset.js" language="JavaScript" type="text/javascript"></script>


<%
    MxBean.jspInit(request, response);
    DebugSubsystem myLog = DebugOutput.getDebugSubsystem("MxLogManager");
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.AUDIT_LOG_VIEW_PRIVILEGE))
    { %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
 <% }

  rbAuditLog.init(loginBean, "AuditLog");


  boolean validInput = true;
  String inputError = null;

  try{
    if( (request.getParameter("linecount") == null || Integer.parseInt(request.getParameter("linecount")) >= 1) &&
        (request.getParameter("lowerline") == null || Integer.parseInt(request.getParameter("lowerline")) >= 1) &&
        (request.getParameter("upperline") == null || Integer.parseInt(request.getParameter("upperline")) >= 1) )
     {

      if(request.getParameter("choice") != null && request.getParameter("choice").equals("latest") )
      {

        if(request.getParameter("linecount") != null)
        {
          auditLogBean.setLastEntries(Integer.parseInt(request.getParameter("linecount")));
        }

      }
      else if(request.getParameter("choice") != null && request.getParameter("choice").equals("betweenlines") )
      {
        if(Integer.parseInt(request.getParameter("lowerline")) > Integer.parseInt(request.getParameter("upperline")))
        {
          validInput = false;
          inputError = new String("lessThan");
        }
        else if(Integer.parseInt(request.getParameter("lowerline")) > auditLogBean.getLastEntryinLogFile())
        {  //4/13/2005 JCW fix bug 230357
          validInput = false;
          inputError = new String("outOfBound");
          DebugOutput.log(myLog, 15,"AuditLogViewerServer, the lower entry is bigger than the last entry in log file \n");
        }
        else if(request.getParameter("lowerline") != null && request.getParameter("upperline") != null)
        {
          auditLogBean.setBetweenEntries( Integer.parseInt( request.getParameter("lowerline") ) ,
                                          Integer.parseInt( request.getParameter("upperline") ) );
        }
      }
    }
    else
    {
      validInput = false;
      inputError = new String("outOfRange");
    }
  }
  catch(NumberFormatException nfe)
  {
    validInput = false;
    inputError = new String("nan");
  }
%>

<% if( validInput){ %>
<script language="JAVASCRIPT">
  MxPortalRefreshNavigationArea();
  document.location.href = "AuditLogViewerStart.jsp";
</script>
<%
   }
   else
   {
%>
<script language="JAVASCRIPT">
  MxPortalRefreshNavigationArea();
  document.location.href = "AuditLogViewerStart.jsp?inputError=<% out.write(inputError); %>";
</script>
<%}%>

