<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.MxOptions"%>
<%@ page import="com.hp.mx.portal.ui.MxBean" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="customizeBean" class="com.hp.mx.portal.monitor.MxCustomizeBean" scope="session"/>
<jsp:useBean id="rbMonitor" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<%
    MxBean.jspInit(request, response);

    if (loginBean.checkLogoutConditionForWebPage(pageContext) == true)
    {
        return;
    }

    //
    // new folder clears selection
    //
    customizeBean.setSelectedId("");

    MxButtons buttons = new MxButtons();
    buttons.addMxTag(new MxDefaultTag("okButton", rbMonitor.getString("button.ok"), "checkAndSubmit()"));
    buttons.addMxTag(new MxDefaultTag("cancelButton", rbMonitor.getString("button.cancel"), "closeSave('" + MxOptions.URL_BASE + "/home/MxBlank.html')"));
%>

<html>
    <head>
        <title></title>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/monitor/css/MxMonitorCustomize.css'>
        <script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
        <script src="<%=MxOptions.URL_BASE%>/monitor/js/MxMonitorCommon.js" language="JavaScript" type="text/javascript"></script>
        <script language="JAVASCRIPT" type="text/javascript">
            var blankNameErrMsg              = "<%=rbMonitor.getString("customize.emptyfield")%>";
            var invalidNameErrMsg            = "<%=rbMonitor.getString("customize.2invalidchar")%>";
            var exceedSQLMaxErrMsg           = "<%=rbMonitor.getString("customize.90folderexceedmax")%>";
            var listFolderAlreadyExistErrMsg = "<%=rbMonitor.getString("customize.71duplistfolder")%>";
            var branchtype                   = "<%=request.getParameter("branchtype")%>";
            var scatTemplate                 = "<%=request.getParameter("cattemp")%>";
            //======================================================================
            // OnLoad handler
            //======================================================================
            function onLoadNewListFolderPage()
            {
                if (branchtype == "sysbranch")
                {
                    MxPortalWorkspaceSetHelpTopic("monitor_lists_system_createFolder");
                }
                else if (branchtype == "evbranch")
                {
                    MxPortalWorkspaceSetHelpTopic("monitor_lists_event_createFolder");

                }

                resizeFrame(50, "ID_BODY_NEWLISTFOLDER");
                //
                // delay 150 milli-second to fix the timing issue in Mozilla
                //
                setTimeout('initFocus()', 150);
            }
            //======================================================================
            // Function to set focus
            //======================================================================
            function initFocus()
            {
                checkName();
                document.getElementById("cancelButton").focus();
                document.getElementById("cancelButton").blur();
            }
            //======================================================================
            // Set hidden variables before submitting form back to server.
            //======================================================================
            function setSelected()
            {
                var oCommand = document.getElementById("command");
                oCommand.value = "newlistfolder";
                var oSelBranchType = document.getElementById("selBranchType");
                oSelBranchType.value = branchtype;
                var oIsPublic = document.getElementById("isPublicFlag");
                var oPublicFlag = document.getElementById("publicFlag");

                if (oPublicFlag != null && oPublicFlag.checked)
                {
                    oIsPublic.value = "true";
                }
                else
                {
                    oIsPublic.value = "false";
                }

                var oListFolderTemplate= document.getElementById("listFolderTemplate");
                // get the value of the listfolder as template.
                oListFolderTemplate.value = scatTemplate;
            }
            //======================================================================
            // Check for empty and invalid characters before submitting form back
            // to server.  If valid, submit the form.
            //======================================================================
            function checkAndSubmit()
            {
                setSelected();
                var folderName = document.newListFolderForm.newListFolderName.value;
                var fullListFolderName;

                if (trim(folderName) == "")
                    alert(blankNameErrMsg);
                else
                {
                    fullListFolderName = scatTemplate + "|" + folderName;
                    if (fullListFolderName.length > 255)
                        alert(exceedSQLMaxErrMsg);
                    else
                        verifyName(folderName, scatTemplate);
                }
            }

            //======================================================================
            // Verify the new list folder name.
            //======================================================================
            function verifyName(inputName, parentName)
            {
                var inputParam=encodeURIComponent(inputName);
                var parentParam = encodeURIComponent(parentName);
                var URL = "<%=MxOptions.URL_BASE%>/monitor/CheckInvalidListFolderName.jsp?inputName=" + inputParam +
                            "&parentName="+parentParam;

                document.getElementById("commSpace").contentWindow.document.location.replace(URL);
            }

            //======================================================================
            // If error occurs in the input fields, display the error.
            //======================================================================
            function displayInputError(isCharOK, isFolderExist)
            {
                if (isCharOK == false )
                    alert(invalidNameErrMsg);
                else if (isFolderExist == true)
                    alert(listFolderAlreadyExistErrMsg);
            }

            //======================================================================
            // Submit the form to do database operation.
            //======================================================================
            function submitForm()
            {
                document.newListFolderForm.submit();
            }

            //======================================================================
            // If the folder name is blank, disable the OK button
            //======================================================================
            function checkName()
            {
                var folderName = document.newListFolderForm.newListFolderName.value;
                if (folderName == "")
                    changeOKButton(false);
                else
                    changeOKButton(true);
            }

            //======================================================================
            // Enable/Disable OK button
            //======================================================================
            function changeOKButton(enableFlag)
            {
                if (enableFlag == true)
                {
                    ourButtonManager.enableButtonById('okButton');
                }
                else
                {
                    ourButtonManager.disableButtonById('okButton');
                }
            }
        </script>
<%
    MxHtmlUtil.dumpHeadBegin(out);
    MxButton.dumpHeadContent(out);
    MxHtmlUtil.dumpHeadEnd(out);
%>
    </head>

    <body onLoad='onLoadNewListFolderPage()' onResize='resizeFrame(50, "ID_BODY_NEWLISTFOLDER")'>
        <div id="ID_BODY_NEWLISTFOLDER">
            <form method='POST' name='newListFolderForm' autocomplete='off' action='<%=MxOptions.URL_BASE%>/monitor/DoCustomizeOperations.jsp' onsubmit='return false'>
                <HR class='mx-hr'>
                <font class='mx-subheader-nosep'><%=rbMonitor.getString("customize.newlistfolder.title")%></font>
                <br><br>
                <table border='0' cellspacing='0' cellpadding='5'>
                    <tr>
                        <td><%=rbMonitor.getString("customize.name")%>&nbsp;</td>
                        <td ><input type="text" id='newListFolderName' name='newListFolderName' size='30' maxlength='70' value='' onKeyup='checkName()'></td>
                    </tr>
                    <tr>
                        <td colspan='2' style='padding-left:20'>
                            <script language="JAVASCRIPT">
                                if (<%= customizeBean.hasPubListModPriv() %>)
                                {
                                    document.write("<input type='checkbox' id='publicFlag' name='publicFlag' ENABLED>");
                                    document.write("<span id='publicText' class='enabled-text'>");
                                    document.write("<%=rbMonitor.getString("customize.publicstr")%>");
                                    document.write("</span>");
                                }
                            </script>
                        </td>
                    </tr>
                </table>

                <input type='hidden' id='command' name='command' value=''>
                <input type='hidden' id='isPublicFlag' name='isPublicFlag' value=''>
                <input type='hidden' id='selBranchType' name='selBranchType' value=''>
                <input type='hidden' id='listFolderTemplate' name='listFolderTemplate' value=''>

                <div style="margin-top:15px">
<%
    buttons.dumpButtons(out);
%>
                </div>

            </form>

            <IFRAME ID="commSpace" NAME="commSpace" SRC="<%=MxOptions.URL_BASE%>/home/MxBlank.html"
                        style="position:absolute; display:none" height="1" width="1"></IFRAME>
        </div>
<%
    MxHtmlUtil.dumpBodyEnd(out);
%>
    </body>
</html>
