<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="java.util.Enumeration" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="rbMonitor" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="customizeBean" class="com.hp.mx.portal.monitor.MxCustomizeBean" scope="session"/>
<jsp:useBean id="postCustomizeBean" class="com.hp.mx.portal.monitor.MxCustomizePostUI" scope="session" />

<%
    MxBean.jspInit(request, response);

    if (loginBean.checkLogoutConditionForWebPage(pageContext) == true)
    {
        return;
    }

    String inframe = request.getParameter("inframe");
    if (inframe.equals("customize"))
    {
        // HERE
        customizeBean.setSelectedItems(request.getParameterValues("selectedOption"));
    }
    else if (inframe.equals("treeview"))
    {
        customizeBean.initBean(loginBean);
        postCustomizeBean.initBean(loginBean);
    }

    MxButtons buttons = new MxButtons();

    buttons.addMxTag(new MxDefaultTag("ok_button", rbMonitor.getString("button.ok"), "checkAndSubmit('" + MxOptions.URL_BASE + "/monitor/CheckCollectionName.jsp')"));
    buttons.addMxTag(new MxDefaultTag("cancel_button", rbMonitor.getString("button.cancel"), "closeSave()"));
%>

<html>
    <head>
        <title></title>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/monitor/css/MxMonitorMenu.css'>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/monitor/css/MxMonitorCustomize.css'>
        <script src="/SessionReset.js" language="JavaScript" type="text/javascript"></script>
        <script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
        <script src="<%=MxOptions.URL_BASE%>/js/utilities.js" language="JavaScript" type="text/javascript"></script>
        <script src="<%=MxOptions.URL_BASE%>/monitor/js/SaveCollectionUtils.jsp" language="JavaScript" type="text/javascript"></script>
        <script language="JAVASCRIPT" type="text/javascript">
            // Set the help context
            resetHelpContext();
            function resetHelpContext()
            {
                MxPortalWorkspaceSetHelpTopic("monitor_search_saveAs");
            }
        </script>
<%
    customizeBean.getSelectedItemsArray(out);
    MxHtmlUtil.dumpHeadBegin(out);
    MxButton.dumpHeadContent(out);
    MxHtmlUtil.dumpHeadEnd(out);
%>
    </head>

    <body onLoad='onSaveLoad()'>
        <div id='saveDiv'>
            <form method='POST' name='saveForm' id='saveForm' autocomplete='off' action='<%=MxOptions.URL_BASE%>/monitor/DoSaveCollection.jsp' onSubmit='return false'>
                <HR class='mx-hr'>
                <table border="0" cellspacing="0" cellpadding="0">
                    <tr>
                        <td colspan='2'>
                            <font class='mx-subheader-nosep'><%=rbMonitor.getString("button.saveAs")%></font>
                            <br/><br/>
                        </td>
                    </tr>
                    <tr>
                        <td colspan="2"><%=rbMonitor.getString("REQ")%>&nbsp;*</td>
                    </tr>
                    <tr>
                        <td colspan="2">&nbsp;</td>
                    </tr>
                    <tr>
                        <td><%=rbMonitor.getString("customize.name")%>&nbsp;*&nbsp;</td>
                        <td>
                            <input name='colName' id='colName' type='text' style='width:150px' maxlength='70' onKeyup='checkBlankName()' onClick='setTimeout("checkBlankName()", 3000)' onPaste='setTimeout("checkBlankName()", 100)'>
                        </td>
                    </tr>
                    <tr>
                        <td colspan="2" style='height:10px'></td>
                    </tr>
                    <tr>
                        <td><%=rbMonitor.getString("customize.placein")%>&nbsp;&nbsp;&nbsp;</td>
                        <td>
                           <select id='parentCol' name='parentCol'>
<%
    customizeBean.dumpCollectionsOnlyInOptionBox(out, null, null);
%>
                            </select>
                        </td>
                    </tr>
                </table>

                <input type='hidden' id='inframe' name='inframe' value='<%=inframe%>'>

                <div style='margin-top:15px'>
<%
    buttons.dumpButtons(out);
%>
                </div>
            </form>

            <IFRAME ID="commSpace" NAME="commSpace" SRC="blank1.html" style="position:absolute; display:none" height=1 width=1></IFRAME>
        </div>
<%
    MxHtmlUtil.dumpBodyEnd(out);
%>
    </body>
</html>
