//======================================================================
//
// Function copied from MxTree UI component
//
//======================================================================

function testeval(event)
{
    var srcEl = getEventSrc(event);
    alert("srcEl in testevel = "+srcEl.getAttribute("id"));
}

//======================================================================
//======================================================================
function MxMenuToggle(szFn, szIdRoot, szId, nShow)
{
    var oRoot = document.getElementById(szIdRoot);
    var oDiv = document.getElementById('MXMENU_' + szId);

    if (oRoot == null || oDiv == null) return;

    var bShow = (oDiv.className == 'mxmenu-hide');
    if (nShow == 1) bShow = true;
    if (nShow == 2) bShow = false;

    oDiv.className = bShow ? 'mxmenu-show' : 'mxmenu-hide';

    // Change the display is done in the css file, very important

    // Change the image
    p_MxMenuSetImage("IMXMENU_" + szId, bShow);
}

function MxMenuExpandAll(szIdRoot)
{
    p_MxMenuDoAll(szIdRoot, true);
}

function MxMenuCollapseAll(szIdRoot)
{
    p_MxMenuDoAll(szIdRoot, false);
}

function MxMenuGetState(szIdRoot, szInnerClassName)
{
    var szList = "";

    var oDiv = document.getElementById(szIdRoot);
    var oMenus = oDiv.getElementsByTagName("DIV");
    for (var i = 0; i < oMenus.length; i++)
    {
        var oMenu = oMenus.item(i);
        if (oMenu.className == "mxmenu-cascade")
        {
            var oInner = document.getElementById('MXMENU_' + oMenu.id);
            if (oInner != null && oInner.className == szInnerClassName)
            {
                if (szList != "")
                    szList += ",";

                szList += oMenu.id;
            }
        }
    }

    return szList;
}

function MxMenuReopen(szIdRoot, szList)
{
    var szMenu = szList.split(",");
    for (var i = 0; i < szMenu.length; i++)
        MxMenuToggle("", szIdRoot, szMenu[i], 1);
}

//======================================================================
// private
//======================================================================
function p_MxMenuDoAll(szIdRoot, bShow)
{
    var oDiv = document.getElementById(szIdRoot);
    var oMenus = oDiv.getElementsByTagName("DIV");
    for (var i = 0; i < oMenus.length; i++)
    {
        var oMenu = oMenus.item(i);
        if (oMenu.className == "mxmenu-cascade")
            MxMenuToggle("", szIdRoot, oMenu.id, bShow ? 1 : 2);
    }
}

function p_MxMenuCallChangeHandler(szFn, szIdRoot)
{
    if (szFn != "")
        eval(szFn + "('" + szIdRoot + "')");
}

function p_MxMenuSetImage(szId, bShow)
{
    var oImg = document.getElementById(szId);
    if (oImg == null) return;

    if (bShow)
        oImg.src = oImg.src.replace
            ('/mxportal/monitor/img/menu_open.gif', '/mxportal/monitor/img/menu_close.gif');
    else
        oImg.src = oImg.src.replace(
            '/mxportal/monitor/img/menu_close.gif', '/mxportal/monitor/img/menu_open.gif');
}

