<%@ page import="com.hp.mx.portal.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="rbMonitor" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<%
    MxBean.jspInit(request, response);
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;
    rbMonitor.init(loginBean, "MxMonitor");
%>

// Localized error messages

// API functions for Save Search UI Pages

<!--script type="text/javascript" language="javascript"-->

///////////////////////////////////////////////////////////////////////
// Utility functions
///////////////////////////////////////////////////////////////////////
function trim(strText)
{
    while (strText.substring(0,1) == ' ')
        strText = strText.substring(1, strText.length);

    while (strText.substring(strText.length-1,strText.length) == ' ')
        strText = strText.substring(0, strText.length-1);

   return strText;
}
///////////////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////////////
function getFirstChildOfType(obj, szTag)
{
    if (obj == null)
        return null;

    var childrenByTags = obj.getElementsByTagName(szTag);
    if (childrenByTags != null && childrenByTags.length > 0)
        return childrenByTags.item(0);

    return null;
}
///////////////////////////////////////////////////////////////////////
// Page loading and management functions
///////////////////////////////////////////////////////////////////////
function setOKButton(state)
{
    var oButton = document.getElementById("ok_button");
    if (oButton != null)
    {
        if (state == "enabled")
        {
            ourButtonManager.enableButton(oButton);
        }
        else
        {
            ourButtonManager.disableButton(oButton);
        }
    }
}
///////////////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////////////
function resizeFrame()
{
    var oSelf = parent.document.getElementById("resultSpace");
    var h = document.getElementById("saveDiv").offsetHeight;
    oSelf.style.height = h + 50;
    if (parent.resizeFrame != null)
        parent.resizeFrame(50);
}
///////////////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////////////
function onSaveLoad()
{
    resizeFrame();
    init();
    if (parent.setOKButton != null)
        parent.setOKButton("enabled");
}
///////////////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////////////
function init()
{
    setOKButton("disabled");
    document.getElementById("cancel_button").focus();
    setTimeout('document.getElementById("colName").focus()', 100);
}
///////////////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////////////
function closeSave()
{
    parent.resetHelpContext();
    document.location.replace("blank.html");
}

///////////////////////////////////////////////////////////////////////
// Folder selection control functions
///////////////////////////////////////////////////////////////////////
function setSelected()
{
    var parentColBox = document.getElementById("parentCol");
    var parentCol = parentColBox.options[parentColBox.selectedIndex].value;

    var optionLen = selectedItems.length;

    for (var i = 0; i < optionLen; i++)
    {
        var optionName = "selectedOption";
        var oInput = document.createElement("INPUT");
        oInput.type = "HIDDEN";
        oInput.value = selectedItems[i];
        oInput.name = optionName;
        document.saveForm.appendChild(oInput);

    }
    var optionName = "command";
    var oInput = document.createElement("INPUT");
    oInput.type = "HIDDEN";
    oInput.value = "addnewcoll";
    oInput.name = optionName;
    document.saveForm.appendChild(oInput);
}
///////////////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////////////
function checkAndSubmit(baseURL)
{
    var colName = document.saveForm.colName.value;

    if (!isValidListName(colName))
    {
        var listNameInvalidErrMsg="<%=rbMonitor.getString("customize.invalidname")%>";
        alert(listNameInvalidErrMsg);
        setOKButton("enabled");
    } else
    {
        verifyNames(colName, baseURL);
    }
}
///////////////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////////////
function verifyNames(listName, baseURL)
{
    var encodedListName = encodeURIComponent(listName);

    var URL = baseURL + "?colName=" + encodedListName;

    document.getElementById("commSpace").contentWindow.document.location.replace(URL);
}
///////////////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////////////
function checkBlankName()
{
        if (trim(document.getElementById("colName").value) == "")
         setOKButton("disabled");
        else
         setOKButton("enabled");
}
///////////////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////////////
function throwNameError(isColNameOK)
{
    if (isColNameOK == false)
        alert("Collection name is not Okay, please select another name");

    setOKButton("enabled");
}
///////////////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////////////
function throwError(errorString)
{
    alert(errorString);
    setOKButton("enabled");
}
///////////////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////////////
function submitSaveForm()
{
    setSelected();
    if (parent.inframe == "customize")
        document.getElementById("inframe").value = "customize";
    document.saveForm.submit();
}
