<%--
//$Source: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/reporting/CopyReport.jsp,v $
//$Revision: 1.38 $
//$Date: 2005/06/01 22:20:21 $
--%>
<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*"%>
<%@ page import="com.hp.mx.portal.reporting.*"%>
<%@ page import="com.hp.mx.core.tools.reporting.*"%>
<%@ page import="com.hp.mx.core.subjects.*"%>
<%@ page import="com.hp.mx.core.subjects.usermanager.*"%>
<%@ page import="com.hp.mx.core.controllers.*"%>
<%@ page import="com.hp.mx.core.client.*"%>
<%@ page import="com.hp.mx.core.daemon.*"%>
<%@ page import="javax.servlet.jsp.*"%>
<%@ page import="java.sql.*"%>
<%@ page import="java.io.*"%>
<%@ page import="java.util.*"%>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="manageReportsSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session"/>
<jsp:useBean id="manageReportsTableModel" class="com.hp.mx.portal.reporting.ReportsManageTableModel" scope="session"/>
<jsp:useBean id="manageReportsBean" class="com.hp.mx.portal.reporting.ReportsManageBean" scope="session"/>
<jsp:useBean id="ReportsDisplayNames" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<%
    // Required by Tomcat for i18n support.
    MxBean.jspInit(request, response);

    // Abort the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    manageReportsBean.getResBundles(loginBean);
    ReportsDisplayNames.init(loginBean, "ReportsDefaultNames");

    String newReportName = "";

    // First, let's see if a "copyReport" has been requested
    try
    {
       String copyFlag = request.getParameter("copyReport");

       if ( copyFlag!=null && !copyFlag.equals("") )
       {
          newReportName = request.getParameter("ReportName");
          newReportName = newReportName.trim();

          if (!manageReportsBean.checkInvalidChars(newReportName))
             manageReportsBean.alert(out, manageReportsBean.getResString("MSG_REPORT_NAME_INVALID"));
          else if (manageReportsBean.checkForDuplicateName(newReportName))
             manageReportsBean.alert(out, manageReportsBean.getResString("MSG_REPORT_DUP_NAME"));
          else
          {
              if (manageReportsBean.copySelectedReport(manageReportsSelectionModel.getSelectedIndices()[0], newReportName, out))
              {
                  //manageReportsBean.showParentLocation(out, manageReportsBean.getResString("MANAGE_REPORTS_URL"));
                  // set the new report name in the bean.
                  manageReportsBean.setNewRptName(newReportName);
                  // Refresh the MxTable.
                  manageReportsBean.refreshTableModel(manageReportsTableModel, manageReportsSelectionModel);
                  // Remove the Copy Report page in the bottom frame & get out.
                  manageReportsBean.alert(out, manageReportsBean.getResString("MSG_REPORT_COPY_OK"));
                  int numReports = manageReportsTableModel.getRowCount();
%>
        <script>
            window.document.location.replace("<%=manageReportsBean.getResString("BLANK_PAGE_URL")%>");
            parent.autoRefresh(<%=numReports%>);
        </script>
<%
                  return;
              }
          }
       }
    }
    catch (Exception e)
    {
       manageReportsBean.alert(out, manageReportsBean.getResString("MSG_REPORT_COPY_FAIL"));
       System.out.println("Exception in CopyReport.jsp Copy Report function : " + e);
    }

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();

    MxTag btnOkTag = new MxDefaultTag("btnOK", manageReportsBean.getResString("BUTTON_OK"), "copyReport()");
    MxTag btnCancelTag = new MxDefaultTag("btnCancel", manageReportsBean.getResString("BUTTON_CANCEL"), "cancelCopy()");

    btnOkTag.setAttr(MxTag.DISABLED, "true");

    buttons.addMxTag(btnOkTag);
    buttons.addMxTag(btnCancelTag);
%>

<html>
<head>
    <title>Copy Report</title>
    <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxButton.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</HEAD>

<%
    String displayName = null;

    String reportName = manageReportsBean.getReportName(manageReportsSelectionModel.getSelectedIndices()[0]);
    //System.out.println("@@## Before getDisplayName(). report name to be copied is : " + reportName);
    if ((reportName != null) && (reportName.length() > 0) && !reportName.equalsIgnoreCase("null") )
    {
        displayName = ReportsDisplayNames.getDisplayName(reportName);
        if (displayName.length() > 70)
        {
           displayName = displayName.substring(0, 70) + "...";
           //System.out.println("@@## report name is now: " + displayName);
        }
    }

%>

<BODY>
<HR class='mx-hr'>

<!-- Header -->
<table border='0' cellspacing='0' cellpadding='0'>
<tr><td><font class="mx-subheader-nosep"><%=manageReportsBean.getResString("COPY_REPORT_LABEL")%></font>
<font class="mx-subheader-nosep"><%=displayName%></font>
</td></tr>
</table>
<!-- End Header -->


<FORM ID="frmCopyReport" NAME="frmCopyReport" METHOD="POST">
    <SCRIPT>
        <%@include file="js/CopyReport.js"%>
    </SCRIPT>

    <BR>
    <p>
    <script language='javascript'>
        function copyReport()
        {
            var newRptName = document.frmCopyReport.newReportName.value;
/*
            //The report name is now validated using invalidCharCheck.checkString().
            if (!checkName(newRptName))
            {
                document.frmCopyReport.newReportName.focus();
                return false;
            }
*/
            document.location= '<%=manageReportsBean.getResString("COPY_REPORT_URL")%>'
                            + '?copyReport=y' + '&ReportName=' + encodeURIComponent(newRptName);
            return true;
        }

        function cancelCopy()
        {
            document.location= '<%=manageReportsBean.getResString("BLANK_PAGE_URL")%>';
        }

        function updateOKButton()
        {
            var rName = document.frmCopyReport.newReportName.value;
            if ((rName.length > 0) && (rName.valueOf() != " "))
            {
                ourButtonManager.enableButtonById('btnOK');
            }
            else
            {
                ourButtonManager.disableButtonById('btnOK');
                document.frmCopyReport.newReportName.focus();
            }
        }
    </script>
    <table border="0" style="border:0px;background:white;margin:0;font:10 pt arial;">
        <tr>
            <td nowrap style="FONT-SIZE: 10pt; FONT-FAMILY: arial,sans-serif; FONT-WEIGHT: bold;"><b><%=manageReportsBean.getResString("REPORT_NAME_LABEL")%></b></td>
            <td nowrap><INPUT TYPE="text" style ="WIDTH: 450px" id="newReportName" name="newReportName" MAXLENGTH=150 value="<%=newReportName%>" onKeyup="updateOKButton()"></td>
        </tr>
    </table>

    <div style="margin-top;15px">
        <% buttons.dumpButtons(out); %>
    </div>

    <SCRIPT>
        document.getElementById('newReportName').focus();
    </SCRIPT>
</FORM>
<SCRIPT language="javascript">
        var pageHeight  = document.body.scrollHeight;
        //alert("CopyRepot height = "+pageHeight); IE return value= 172, Mozilla returns 119, cause bug 247605
        parent.setFrmDisplayHeight(pageHeight+50);
        updateOKButton();
</SCRIPT>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</BODY>
</HTML>
