<%--
//$Source: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/reporting/ManageReports.jsp,v $
//$Revision: 1.46 $
//$Date: 2005/05/09 21:04:55 $
--%>

<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.html.table.*"%>
<%@ page import="com.hp.mx.portal.ui.*"%>
<%@ page import="com.hp.mx.portal.reporting.ReportsManageTableModel"%>
<%@ page import="com.hp.mx.portal.reporting.*"%>
<%@ page import="com.hp.mx.core.tools.reporting.*"%>
<%@ page import="com.hp.mx.core.subjects.*"%>
<%@ page import="com.hp.mx.core.subjects.usermanager.*"%>
<%@ page import="com.hp.mx.core.controllers.*"%>
<%@ page import="com.hp.mx.core.client.*"%>
<%@ page import="com.hp.mx.core.daemon.*"%>
<%@ page import="com.hp.mx.core.toolmanager.*"%>
<%@ page import="com.hp.mx.core.taskmanager.*"%>
<%@ page import="javax.swing.table.AbstractTableModel"%>
<%@ page import="com.hp.mx.core.tools.reporting.*"%>
<%@ page import="javax.servlet.jsp.*"%>
<%@ page import="java.sql.*"%>
<%@ page import="java.io.*"%>
<%@ page import="java.util.*"%>
<%@ page import="com.hp.mx.core.tools.reporting.format.formatIfc"%>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>

<jsp:useBean id="manageReportsSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session"/>
<jsp:useBean id="manageReportsTableView" class="com.hp.mx.html.table.MxTableView2" scope="session"/>
<jsp:useBean id="manageReportsTableController" class="com.hp.mx.html.table.MxTableController" scope="session"/>
<jsp:useBean id="manageReportsTableModel" class="com.hp.mx.portal.reporting.ReportsManageTableModel" scope="session"/>

<jsp:useBean id="manageReportsBean" class="com.hp.mx.portal.reporting.ReportsManageBean" scope="session"/>

<html>
<head>
<%
    // Required by Tomcat for i18n support.
    MxBean.jspInit(request, response);

    // Abort the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    // snapoff=true is passed to this file if it is opened in a separate
    // window.  we need to pass this onto ReportsWizard.jsp so that it gets
    // passed into targetSelection.jsp
    String snapOff = request.getParameter("snapoff");

    // First, let's see if a "deleteReport" has been requested
    try
    {
       String deleteFlag = request.getParameter("deleteReport");
       if ( deleteFlag!=null && !deleteFlag.equals("") )
       {
          manageReportsBean.deleteSelectedReport(manageReportsSelectionModel.getSelectedIndices()[0]);
       }
    }
    catch (Exception e)
    {
       System.out.println("Exception in ManageReports.jsp Delete Report function: " + e);
    }

    // THE ACTUAL "Manage Reports" PAGE:

    MxUser sessionUser = loginBean.getMxUser();
    boolean hasReportModPrivilege = false;

    if (sessionUser.hasPrivilege(MxSubjectPrivilege.REPORT_MODIFICATION_PRIVILEGE))
       hasReportModPrivilege = true;

       manageReportsBean.initBean(out, loginBean);

    // setup the display of the reports table model
    if (manageReportsTableController.isFirstTime())
    {
        manageReportsBean.getColumnNames(manageReportsTableModel);

        // set to only allow 1 row to be selected
        manageReportsSelectionModel.setSelectionMode(MxTableSelectionModel.SINGLE_SELECTION);

        manageReportsTableView.setId("ID_REPORTS_TABLE");
        manageReportsTableView.setOnSelectionChange("mySelectionChanged");
        manageReportsTableView.setUrlHandler(request.getRequestURI());

        manageReportsTableController.setTableModelWithSorting(manageReportsTableModel);

        // get the sorting table and tell it to sort alphabetically by Report Name
        MxTableSortingModel sortingModel = manageReportsTableController.getSortingModelOrNull();
        // column #1 (Report Name), sortUp == true
        sortingModel.sortTable(0, true);

        manageReportsTableController.setSelectionModel(manageReportsSelectionModel);
        manageReportsTableController.setTableView(manageReportsTableView);
    }

    // do we need to abort?
    if (manageReportsTableController.checkUrlForControllerMessages(request, out))
    {
        //out.write("<script>alert('controller msg');</script>");
        return;
    }

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();

    MxTag btnRunTag = new MxDefaultTag("btnRun", manageReportsBean.getResString("BUTTON_RUNREPORT"), "showReportsResultPage()");
    MxTag btnCopyTag = new MxDefaultTag("btnCopy", manageReportsBean.getResString("BUTTON_COPY"), "showCopyReportPage()");
    MxTag btnNewTag = new MxDefaultTag("btnNew", manageReportsBean.getResString("BUTTON_NEW"), "showNewReportPage()");
    MxTag btnEditTag = new MxDefaultTag("btnEdit", manageReportsBean.getResString("BUTTON_EDIT"), "showEditReportPage()");
    MxTag btnDeleteTag = new MxDefaultTag("btnDelete", manageReportsBean.getResString("BUTTON_DELETE"), "confirmDelete()");

    btnCopyTag.setAttr(MxTag.DISABLED, "true");
    btnNewTag.setAttr(MxTag.DISABLED, "true");
    btnEditTag.setAttr(MxTag.DISABLED, "true");
    btnDeleteTag.setAttr(MxTag.DISABLED, "true");

    buttons.addMxTag(btnRunTag);
    buttons.addMxTag(btnCopyTag);
    buttons.addMxTag(btnNewTag);
    buttons.addMxTag(btnEditTag);
    buttons.addMxTag(btnDeleteTag);
%>

    <title>Manage Reports</title>
    <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
    <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxPortalApi.js'></script>
    <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxBrowser.js'></script>
    <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js'></script>
<%
    manageReportsTableModel.clearData();
    manageReportsTableModel.fireTableDataChanged();

    manageReportsBean.refreshTableModel(manageReportsTableModel);

    // set the first row as the selected row - default action
    manageReportsSelectionModel.setSelectedIndexShim(0, true);

    int numReports     = manageReportsTableModel.getRowCount();
%>

    <SCRIPT language='javascript'>
            var REFRESH_TIMEOUT              = 10000; // 10 seconds
            var NETSCAPE_SCROLLBAR_WIDTH     = 36;
            var TITLE_HEIGHT_MULTIPLIER      = 1.25;  // 25% more than a rowHeight

            // set the help context.
            MxPortalWorkspaceSetHelpTopic("feature_report");
    </SCRIPT>
    <script language='javascript' type='text/javascript'>
            function autoRefresh(totalReports)
            {
                // Need to set table height in case all reports are deleted or num reports is less than maxDisplayed.
                setTableHeight(totalReports);
                // tell the table to update its content
                MxTableRefreshInPlace('ID_REPORTS_TABLE');
                // Grayout/de-activate/activate buttons accordingly
                selectReport();
            }

            // resize the width
            function resize_w()
            {
                var w = Math.max(0, MxBrowserGetBodyWidth(-NETSCAPE_SCROLLBAR_WIDTH, 0));
                MxTableSetWidth('ID_REPORTS_TABLE', w-10); //get rid of horizontal scroll bar on Mozilla JCW 10/20/1003
            }

            // This page will hold the value of the "rowHeight" used to properly set
            // the height of the MxTable based off of the Font DPI
            var rowHeight = 0;
            // set the Table height based off of a CELL height given the users font size (DPI)
            function setTableHeight(nReports)
            {
                var iframe = document.getElementById('DPI');
                // save the "rowHeight"
                rowHeight  = iframe.contentWindow.getCellHeight();

                var maxDisplayed = 17;
                var titleHeight  = rowHeight * TITLE_HEIGHT_MULTIPLIER;
                var divHeight    = (rowHeight * ((nReports < maxDisplayed) ? nReports : maxDisplayed)) + titleHeight;

                MxTableSetHeight('ID_REPORTS_TABLE', divHeight);
            }

            function loadPage()
            {
                //setTimeout("loadPage()", REFRESH_TIMEOUT);
                setTimeout("myResize()", 500);
                // resize the width (fill rows to the end) when reloading the page.
                resize_w();
            }

            // resize the MxTable to be flush with the right browser edge
            function myResize()
            {
                resize_w();
            }
            //
            // the function called when the selection changes on the <table>
            //
            function mySelectionChanged(szIdTable, iRow, bSelected)
            {
                // tell our Bean about the current report selected
                selectReport();
                var bottomFrame = document.getElementById("frm2Display");
                bottomFrame.contentWindow.document.location.replace("<%=manageReportsBean.getResString("BLANK_PAGE_URL")%>");
            }
            function setFrmDisplayHeight(pageHeight)
            {
                document.getElementById('frm2Display').style.height =  pageHeight;
            }
            function getFrmDisplayHeight()
            {
                //alert("ManageReport height = "+document.body.scrollHeight);
                return document.body.scrollHeight;
            }
    </script>
    <script language="javascript">
            function selectReport()
            {
               // Enable the buttons if user has REPORT_MOD_PRIVILEGE; disable otherwise.
               if (<%=hasReportModPrivilege%>)
               {
                    ourButtonManager.enableButtonById('btnRun');
                    ourButtonManager.enableButtonById('btnCopy');
                    ourButtonManager.enableButtonById('btnNew');
                    ourButtonManager.enableButtonById('btnEdit');
                    ourButtonManager.enableButtonById('btnDelete');
               }
               else
               {
                    ourButtonManager.disableButtonById('btnCopy');
                    ourButtonManager.disableButtonById('btnNew');
                    ourButtonManager.disableButtonById('btnEdit');
                    ourButtonManager.disableButtonById('btnDelete');
               }
            }
    </script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxButton.dumpHeadContent(out); %>
<% manageReportsTableView.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</head>

    <!-- Nimbus Portal UI is responsible for displaying the header -->

<body onLoad='loadPage(), setTableHeight(<%=numReports%>)' onResize='myResize()'>

<%
    manageReportsTableView.dumpWholeTable(out);
%>
        <br>

<INPUT TYPE=hidden id=tableRowNum name=tableRowNum>
    <script language='javascript'>
        function showReportsResultPage()
        {
            var rFormat = 0;
            if (document.getElementById("HTMLFormat").checked == true)
               rFormat = <%=formatIfc.JSPFORMAT%>;
            else if (document.getElementById("CSVFormat").checked == true)
                    rFormat = <%=formatIfc.CSVFORMAT%>;
            else if (document.getElementById("XMLFormat").checked == true)
                    rFormat = <%=formatIfc.XMLFORMAT%>;

            var iframe = document.getElementById("frm2Display");
            iframe.contentWindow.document.location.replace("<%=manageReportsBean.getResString("REPORTS_TRANSIENT_URL")%>?reportsResult=y&reportFormat=" + rFormat);
        }
        function showCopyReportPage()
        {
            var iframe = document.getElementById("frm2Display");
            iframe.contentWindow.document.location.replace("<%=manageReportsBean.getResString("COPY_REPORT_URL")%>");
        }
        function showNewReportPage()
        {
            var iframe = document.getElementById("frm2Display");
            iframe.contentWindow.document.location.replace("<%=manageReportsBean.getResString("REPORTS_WIZARD_URL")%>?rFunction=new&bReportMenu=false&snapoff=<%=snapOff%>");
        }
        function showEditReportPage()
        {
            var iframe = document.getElementById("frm2Display");
            iframe.contentWindow.document.location.replace("<%=manageReportsBean.getResString("REPORTS_WIZARD_URL")%>?rFunction=edit&bReportMenu=false&snapoff=<%=snapOff%>");
        }
        function confirmDelete()
        {
            // Confirmation: "Are you sure you want to delete?"
            if ( true == confirm("<%=manageReportsBean.getResString("CONFIRM_DELETE")%>") )
            {
                document.location= '<%=manageReportsBean.getResString("MANAGE_REPORTS_URL")%>'
                            + '?deleteReport=y';
            }
            return;
        }
    </script>

  <strong><%=manageReportsBean.getResString("STRING_PREFERRED_FORMAT") %></strong><br>
  <table width="50%" style="BORDER-RIGHT: gray 0px solid; BORDER-TOP: gray 0px solid; BORDER-LEFT: gray 0px solid; WIDTH: 100%; BORDER-BOTTOM: gray 0px solid" background="white" border=0>
  <tr><td style="FONT-WEIGHT: bold; FONT-SIZE: smaller">
  <input type="radio" name="reportFormat" id="HTMLFormat" value="0" CHECKED onClick= "selectReport()">
  <label for="reportFormat"><%=manageReportsBean.getResString("STRING_HTML_FORMAT")%></label><br>
  <input type="radio" name="reportFormat" id="XMLFormat" value="1" onClick= "selectReport()">
  <label for="reportFormat"><%=manageReportsBean.getResString("STRING_XML_FORMAT")%></label><br>
  <input type="radio" name="reportFormat" id="CSVFormat" value="2" onClick= "selectReport()">
  <label for="reportFormat"><%=manageReportsBean.getResString("STRING_CSV_FORMAT")%></label>
  </td></tr></table>

<br>

    <div style="margin-top:15px">
        <% buttons.dumpButtons(out); %>
    </div>

    <SCRIPT language='javascript'>
        if (<%=hasReportModPrivilege%>)
        {
           if (<%=numReports%> > 0)
           {
                ourButtonManager.enableButtonById('btnRun');
                ourButtonManager.enableButtonById('btnCopy');
                ourButtonManager.enableButtonById('btnNew');
                ourButtonManager.enableButtonById('btnEdit');
                ourButtonManager.enableButtonById('btnDelete');
           }
           else
           {
                ourButtonManager.disableButtonById('btnRun');
                ourButtonManager.disableButtonById('btnCopy');
                ourButtonManager.enableButtonById('btnNew');
                ourButtonManager.disableButtonById('btnEdit');
                ourButtonManager.disableButtonById('btnDelete');
           }
        }
        else
        {
           if (<%=numReports%> > 0)
           {
                ourButtonManager.enableButtonById('btnRun');
           }
           else
           {
                ourButtonManager.disableButtonById('btnRun');
           }

                ourButtonManager.disableButtonById('btnCopy');
                ourButtonManager.disableButtonById('btnNew');
                ourButtonManager.disableButtonById('btnEdit');
                ourButtonManager.disableButtonById('btnDelete');
        }
    </SCRIPT>

<br>
    <iframe id="frm2Display" style="width:100%; height:70; position:relative; visibility:visible"
            scrolling="no" marginwidth="0"
            frameborder="0"
            src="<%=manageReportsBean.getResString("BLANK_PAGE_URL")%>">
    </iframe>
    <iframe id='DPI' name='DPI' style='position:relative; visibility:hidden; width:100%; height:100'
            scrolling='no' marginwidth='0' frameborder='1' src='<%=MxOptions.URL_BASE%>/taskandjob/DPI.html'>
    </iframe>

<% MxHtmlUtil.dumpBodyEnd(out); %>

    </body>
</html>
