<%--
//$Source: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/reporting/ReportsConfig.jsp,v $
//$Revision: 1.108 $
//$Date: 2005/06/01 22:20:21 $
--%>

<%@ page import="com.hp.mx.html.core.*" %>
<%@ page info="Nimbus Reporting Config Page"
    import="
        java.util.*,
        javax.swing.tree.*,
        java.net.URLEncoder,
        com.hp.mx.core.tools.reporting.MxReportException,
        com.hp.mx.core.tools.reporting.ReportUtil,
        com.hp.mx.core.reportmanager.reportConstant,
        com.hp.mx.core.reportmanager.MxReport,
        com.hp.mx.core.reportmanager.MxReportName,
        com.hp.mx.core.reportmanager.MxInvalidReportNameException,
        com.hp.mx.core.client.MxQueryClient,
        com.hp.mx.core.client.MxCollectionClient,
        com.hp.mx.core.client.MxReportClient,
        com.hp.mx.core.subjects.MxSubjectPrivilege,
        com.hp.mx.core.objectmodel.MxObjectID,
        com.hp.mx.core.collectionmanager.MxCollection,
        com.hp.mx.core.tools.reporting.format.formatIfc,
        com.hp.mx.core.querymanager.Query,
        com.hp.mx.portal.ui.MxBean,
        com.hp.mx.portal.ui.MxOptions,
        com.hp.mx.portal.taskandjob.MxSystemListCreator,
        com.hp.mx.portal.taskandjob.MxCollectionCreator,
        com.hp.mx.portal.taskandjob.MxCollectionExpander,
        com.hp.mx.portal.taskandjob.MxListToSystemNames,
        com.hp.mx.utilities.MxStringFormatter,
        com.hp.mx.utilities.DebugOutput,
        com.hp.mx.core.objectmodel.MxGUID,
        com.hp.mx.core.collectionmanager.MxUndefinedCollectionException,
        com.hp.mx.utilities.DebugSubsystem"
%>
<%@ page import="java.net.URLEncoder"%>

<jsp:useBean id="reportsConfigBean" class="com.hp.mx.portal.reporting.ReportsConfigBean" scope="session" />
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="manageReportsBean" class="com.hp.mx.portal.reporting.ReportsManageBean" scope="session"/>
<jsp:useBean id="manageReportsTableModel" class="com.hp.mx.portal.reporting.ReportsManageTableModel" scope="session"/>
<jsp:useBean id="manageReportsSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session"/>
<jsp:useBean id="taskWizardBean" class="com.hp.mx.portal.taskandjob.MxTaskWizard" scope="session"/>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskWizardInstance"%>
<%
    DebugSubsystem reportDebug = DebugOutput.getDebugSubsystem("Reports");
    DebugOutput.log(reportDebug, 15,"*********************reportsConfig start point*************");
    //This line is required by Tomcat for il8n support
    MxBean.jspInit(request, response);

    // This aborts the page if the session is invalid
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    String               timeStamp  = request.getParameter("timeStamp");
    MxTaskWizardInstance inst       = (MxTaskWizardInstance)taskWizardBean.getInstance(timeStamp);
%>

<jsp:setProperty name="reportsConfigBean" property="*" />

<html>
<HEAD>
    <title>Report Config Page</title>
    <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
    <script language="javascript" type="text/javascript"src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" ></script>

  <%
     DebugOutput.log(reportDebug, 15,"*********************reportsConfig start 2 *************");
     String str = reportsConfigBean.getUpdatedAttributes();
     if (reportsConfigBean.getReportMenu() == true) // from reports menu
         {
           // init manageReportsBean
           manageReportsBean.initBean(out, loginBean);
         }
     // Setup selection information if this page from report wizard
     String treeURL = "ReportsTreeView.jsp";
     int wizardFlag = 0;
     Random random = new Random();
     String repName = "";
     int selectionType = 0;
     int currentSelectionType = 0;
     MxObjectID selectionID=null;
     MxObjectID currentSelectionID=null;
     MxSystemListCreator listCreator = new MxSystemListCreator(loginBean);
     MxCollectionCreator collectionCreator = new MxCollectionCreator(loginBean);
     MxCollectionClient collectionClient = loginBean.getCollectionClient();
     MxReportClient reportClient = loginBean.getReportClient();
     MxCollectionExpander expander = new MxCollectionExpander(loginBean);
     MxQueryClient queryClient = loginBean.getQueryClient();

     //String repDispName = request.getParameter("RName");
     //if ((repDispName != null ) &&(repDispName.length() > 0))
          //repName = MxStringFormatter.htmlSafe(repDispName);
     repName = request.getParameter("RName");
     DebugOutput.log(reportDebug, 15,"reportsConfig (94)repName = "+repName+"\n" );
     /******** Run report ******************/
     if (request.getParameter("runReportFlag") != null)
     {
       boolean runCheck = true;
       boolean dynamic = false;
        if ((repName != null) && (repName.length() > 0) && !repName.equalsIgnoreCase("null") )
       {
       boolean isReportNameValid = true; // = reportsConfigBean.InvalidChar(repName); // return false if invalid char exists
        try {
            isReportNameValid = reportsConfigBean.IsReportNameValid(repName); // return false if invalid char exists
        } catch (MxInvalidReportNameException e) {
             DebugOutput.log(reportDebug, 15,"reportsConfig Invalid report name = "+repName + "; error=" + e.getMessage());
             reportsConfigBean.alert(out, reportsConfigBean.getResString("ERR_INVALID_REPORT_NAME"));  //.getLocalizedMessage());
             isReportNameValid = false;
        }
       if (isReportNameValid == false)
         {
//           reportsConfigBean.alert(out, MxReportException.REPORT_ERR_INVALID_CHAR);
           DebugOutput.log(reportDebug, 15,"reportsConfig invalid char code = "+MxReportException.REPORT_ERR_INVALID_CHAR);
           runCheck = false;
         }
        }
       DebugOutput.log(reportDebug, 15,"reportsConfig runReportFlag up(97) Selection type="+reportsConfigBean.getCurrentSelectionType());
       // create dynamic query at run report when the selection new and type is node_selection or mixed_selection
       if ((runCheck == true) && ((reportsConfigBean.getCurrentSelectionType() == MxTaskWizardInstance.NODE_SELECTION) ||
            (reportsConfigBean.getCurrentSelectionType() == MxTaskWizardInstance.MIXED_SELECTION))&&
             (reportsConfigBean.isNewSelection() == true))
         {
           runCheck = reportsConfigBean.createDynamicQuery(inst.getMxObjNodeList(),out);
           dynamic = true;
         }
       if ((runCheck == true) && (reportsConfigBean.getCurrentSelectionID() == null))
        {
          reportsConfigBean.alert(out, MxReportException.REPORT_ERR_INVALID_TARGET);
          DebugOutput.log(reportDebug, 15,"reportsConfig invalid target selection \n ");
          runCheck = false;
        }

        if (runCheck == true)
        {
        StringBuffer runStr = new StringBuffer();
        int reportFormat = reportsConfigBean.getReportFormat();
        if (reportFormat == formatIfc.JSPFORMAT)
            runStr.append("ReportsResult.jsp");
        else
            runStr.append(manageReportsBean.getResString("CSV_LINK_URL"));

        String itemIDList = null;
        String itemsList = reportsConfigBean.getItemList();
        try
        {
            itemIDList = itemsList;
            DebugOutput.log(DebugOutput.getDebugSubsystem("Reports"),20,"itemsIDList =  " + itemIDList);
        }
        catch (Exception e)
        {
        }

        runStr.append("?qId=0");
        runStr.append("&itms="+ itemIDList);
        runStr.append("&itmT=" + reportConstant.TYPE_ITEMID_INT);
        runStr.append("&vO="+ reportsConfigBean.getViewOption());
        runStr.append("&rF="+ reportFormat);
        runStr.append("&rName="+URLEncoder.encode(repName, "UTF-8"));
        if ((reportsConfigBean.getCurrentSelectionType() == MxTaskWizardInstance.NODE_SELECTION) ||
            (reportsConfigBean.getCurrentSelectionType() == MxTaskWizardInstance.QUERY_SELECTION))
        {
           if (reportsConfigBean.validateQuery(out, reportsConfigBean.getCurrentSelectionID()) == true)
               runStr.append("&qT="+reportConstant.QUERYTYPE_MXQUERY_GUID);
           else
               runCheck = false;
        }
        else if (reportsConfigBean.getCurrentSelectionType() == MxTaskWizardInstance.COLLECTION_SELECTION)
        {
           if (reportsConfigBean.validateCollection(out, reportsConfigBean.getCurrentSelectionID()) == true)
              runStr.append("&qT="+reportConstant.QUERYTYPE_MXCOLLECTION_GUID);
           else
               runCheck = false;
        }
        else if (reportsConfigBean.getCurrentSelectionType() == MxTaskWizardInstance.MIXED_SELECTION)
        {
           if (dynamic == true)  // dynamic mix generate dynamic query
              runStr.append("&qT="+reportConstant.QUERYTYPE_MXQUERY_GUID);
           else
              {
               if (reportsConfigBean.validateCollection(out, reportsConfigBean.getCurrentSelectionID()) == true)
                   runStr.append("&qT="+reportConstant.QUERYTYPE_MXCOLLECTION_GUID);
               else
                   runCheck = false;
             }
        }
        if (runCheck == true)
         {
        runStr.append("&qG="+reportsConfigBean.getCurrentSelectionID());
        DebugOutput.log(reportDebug, 15,"\n *************reportsConfig runString="+runStr+"\n");
        out.println("<script>");
        out.println(" var rWin = window.open('" + runStr.toString() + "','_blank');" );
        out.println("rWin.focus();");
        out.println("MxPortalTrackPopup(rWin);");
        out.println("</script>");
         }
      }
     }
     /******** Check if caller is ReportWizard  ******************/
     if (request.getParameter("fromWizard") != null)
     {
     wizardFlag = 1;
     reportsConfigBean.setRunFlag(0);
     if (reportsConfigBean.getEdit()  == true)
        wizardFlag = 2;
     String sObj = request.getParameter("saveButtonUp");  // save button to be enabled
     if ((sObj != null) && (sObj.length() > 0) && !sObj.equalsIgnoreCase("null") )
         reportsConfigBean.setSaveButtonStatus(3);
     else
         reportsConfigBean.setSaveButtonStatus(0);
     DebugOutput.log(reportDebug, 15,"ReportsConfig saveButtonStatus ="+reportsConfigBean.getSaveButtonStatus()+ "\n\n");

     // setup report item list and view option information
     String iList = request.getParameter("Itms");
     if ((iList != null) && (iList.length() > 0) && !iList.equalsIgnoreCase("null") )
           reportsConfigBean.setItemIdList(iList);
     else
           reportsConfigBean.setItemIdList("");
     String vOption = request.getParameter("vO");
     if ((vOption != null) && (vOption.length() > 0) && !vOption.equalsIgnoreCase("null")  )
        reportsConfigBean.setViewOption(Integer.parseInt(vOption));
     else
        reportsConfigBean.setViewOption(0);

     String rFormat = request.getParameter("rF");
     if ((rFormat != null) && (rFormat.length() > 0) && !rFormat.equalsIgnoreCase("null")  )
        reportsConfigBean.setReportFormat(Integer.parseInt(rFormat));
     else
        reportsConfigBean.setReportFormat(0);

     /******** Setup selection ******************/
     String bNewSelection = request.getParameter("bNewSelection");
     DebugOutput.log(reportDebug, 15,"ReportsConfig bNewSelection="+bNewSelection+" \n\n");
     reportsConfigBean.setNewSelection(false);

     // getSelectionType may return NO_SELECTION(0), QUERY_SELECTION(1),NODE_SELECTION(2),MIXED_SELECTION(3),COLLECTION_SELECTION (single collection selected)
     currentSelectionType = inst.getSelectionType();
     reportsConfigBean.setCurrentSelectionType(currentSelectionType);
     DebugOutput.log(reportDebug, 15,"ReportsConfig (249) currentSelectionType="+currentSelectionType);
     if ((bNewSelection != null) && (bNewSelection.compareToIgnoreCase("true") == 0) && !bNewSelection.equalsIgnoreCase("null"))
      {
       reportsConfigBean.setNewSelection(true);
       DebugOutput.log(reportDebug, 15,"ReportsConfig (253)  bNewSelection="+bNewSelection+" \n\n");
       String queryString= null;
      if (currentSelectionType == MxTaskWizardInstance.QUERY_SELECTION)
         {
           currentSelectionID = inst.getSelectedQueryID();  // return MxObjectId
           if (currentSelectionID != null)
           {
             DebugOutput.log(reportDebug, 15,"ReportsConfig (258) select query id = "+currentSelectionID.toString());
             reportsConfigBean.setCurrentSelectionID(currentSelectionID);
           }
           else
            {
             DebugOutput.log(reportDebug, 15,"ReportsConfig (258) select query id is null \n ");
             reportsConfigBean.setCurrentSelectionID(null);
           }

          }
       else if (currentSelectionType == MxTaskWizardInstance.COLLECTION_SELECTION)  // single collection
         {
           currentSelectionID = inst.getSelectedMxCollectionID();  // return MxObjectId
            if (currentSelectionID != null)
           {
            DebugOutput.log(reportDebug, 15,"ReportsConfig (264) select mxcollection id = "+currentSelectionID.toString());
            reportsConfigBean.setCurrentSelectionID(currentSelectionID);
           }
           else
           {
            DebugOutput.log(reportDebug, 15,"ReportsConfig (264) select mxcollection id is null \n ");
            reportsConfigBean.setCurrentSelectionID(null);
           }
         }
      }
     else // selection -- no change
     {
        selectionID = reportsConfigBean.getSelectionID();
        if (selectionID != null)
        {
          currentSelectionID = selectionID;
          reportsConfigBean.setCurrentSelectionID(currentSelectionID);
        }
     }
     reportsConfigBean.setupPrivilege();
     }
     else
       DebugOutput.log(reportDebug, 15,"reportsConfig, redisplay reportconfig page, Not from wizard ");

     /******** setup report name information ******************/
     if ((repName != null) && (repName.length() > 0) && !repName.equalsIgnoreCase("null") )
     {
          reportsConfigBean.setReportName(repName.trim());
          DebugOutput.log(reportDebug, 15,"reportsConfig(273) reportname= "+repName);
     }
     else
     {
        reportsConfigBean.setReportName("");
        DebugOutput.log(reportDebug, 15,"reportsConfig do not have reportname as input");
     }

     // set up i18n report display name
     repName = reportsConfigBean.getReportName();
     String reportNameDisp = manageReportsBean.getReportDisplayName(repName);
     if ((reportNameDisp != null) && (reportNameDisp.length() > 70))
     {
       reportNameDisp = reportNameDisp.substring(0, 70) + "...";
     }
     DebugOutput.log(reportDebug, 15,"reportsConfig localized reportName "+reportNameDisp);

     // set up Save Button status
     String sObj = request.getParameter("saveButtonDown");  // save button to be disabled
     if ((sObj != null) && (sObj.length() > 0) && !sObj.equalsIgnoreCase("null"))
     {
        reportsConfigBean.setSaveButtonStatus(1);
        DebugOutput.log(reportDebug, 15,"reportsConfig (304) set savebutton disabled");
     }
     DebugOutput.log(reportDebug, 15,"reportsConfig (297)save button status? ="+reportsConfigBean.getSaveButtonStatus());

     /******** take care of save process ******************/
     try
     {
       String strSave = request.getParameter("saveReportFlag");
       String rString = "";

       if ( (strSave!=null) && (strSave.length() > 0 ) && !strSave.equalsIgnoreCase("null"))
       {
          boolean bContinue= true;
          DebugOutput.log(reportDebug, 15,"reportsConfig (317) save value = "+strSave+"  reportname="+repName);
          if (strSave.compareToIgnoreCase("saveReport") == 0) // first try
          {
              boolean isReportNameValid = true;
              boolean bReportNameExists = false;
              reportsConfigBean.setSaveButtonStatus(0);
              if ((repName != null) && (repName.length() > 0))
              {
                // isReportNameValid = reportsConfigBean.InvalidChar(repName); // return false if invalid char exists
                try {
                    isReportNameValid = reportsConfigBean.IsReportNameValid(repName); // return false if invalid char exists
                } catch (MxInvalidReportNameException e) {
                     DebugOutput.log(reportDebug, 15,"reportsConfig Invalid report name = "+repName + "; error=" + e.getMessage());
                     reportsConfigBean.alert(out, reportsConfigBean.getResString("ERR_INVALID_REPORT_NAME"));  //.getLocalizedMessage());
                     isReportNameValid = false;
                }
                 if (isReportNameValid == false)
                 {
//                     reportsConfigBean.alert(out, MxReportException.REPORT_ERR_INVALID_CHAR);
                     DebugOutput.log(reportDebug, 15,"reportsConfig invalid char code = "+MxReportException.REPORT_ERR_INVALID_CHAR);
                     bContinue = false;
                 }
                 else
                 {
                     try {
                        bReportNameExists = reportsConfigBean.isReportInExistance(repName);    // return true if report exists
                    } catch (MxInvalidReportNameException e) {
                        DebugOutput.log(reportDebug, 15,"reportsConfig Invalid report name = "+repName + "; error=" + e.getMessage());

                    }
                    DebugOutput.log(reportDebug, 15,"reportsConfig isNameExist = "+bReportNameExists);
                   if (bReportNameExists == false)
                   {
                       strSave = "addReport";  //create a new report
                   }
                   else
                   {
                     rString = "ReportsConfig.jsp?RName=";
                     DebugOutput.log(reportDebug, 15,"reportsConfig duplicate report="+repName+ " originame ="+reportsConfigBean.getDupName());
                     bContinue = false;
                     // display the confirmation box
   %>
   <script language="JavaScript" type="text/javascript">
                     var bContinue = confirm("<%=reportsConfigBean.getResString("STRING_REPORT_SAVE_CONFIRM")%> \""+"<%=reportsConfigBean.getDupName()%>" +"\"? ");
                     if (bContinue == true)
                     {
                       location.replace("<%=rString%>"+encodeURIComponent("<%=repName%>")+"&saveReportFlag=updateReport&timeStamp=<%=timeStamp%>");
                     }
                     else
                     {
                       location.replace("<%=rString%>"+encodeURIComponent("<%=repName%>")+"&timeStamp=<%=timeStamp%>");
                     }
    </script>
   <%
                   }
                 }
               }
           }
               if (bContinue == true)
               {
                 DebugOutput.log(reportDebug, 15,"reportsConfig (340) start do save work save ="+strSave);

                 repName = reportsConfigBean.getReportName().trim();
                 selectionType = reportsConfigBean.getSelectionType();
                 currentSelectionType = reportsConfigBean.getCurrentSelectionType();
                 DebugOutput.log(reportDebug, 15,"\n reportsConfig saveString Selectiontype="+selectionType+" currentSelectionTpe="+currentSelectionType+"\n\t");

                 // if selectionID = null, currentSelectionID = node/collection) go create hidden one, do save
                 // if selectionID = null, currentSelectionID = existed MxObjectID, do save
                 // if selectionID = hidden obj (query/collection), delete this one, create a new MxObjectID use currentSelection info, do save
                 // if selectionID = existed MxObjectID, use currentSelectionID or create a new MxObjectID, do save

                 if ((selectionType != currentSelectionType)
                        ||((selectionID != null) && (currentSelectionID != null) && (selectionID != currentSelectionID))
                        ||(currentSelectionID == null))
                 {
                   if ((reportsConfigBean.getCurrentSelectionType() ==  MxTaskWizardInstance.MIXED_SELECTION) ||
                        (reportsConfigBean.getCurrentSelectionType() ==  MxTaskWizardInstance.NODE_SELECTION))
                   {
                     bContinue = reportsConfigBean.createNewSelection(inst.getMxObjNodeList(),out);
                   }
                   else if (reportsConfigBean.getCurrentSelectionType() ==  MxTaskWizardInstance.QUERY_SELECTION)
                  {
                     DebugOutput.log(reportDebug, 15,
                          "ReportsConfig current selection type = query \n");
                     if (reportsConfigBean.getCurrentSelectionID() == null)
                     {
                      currentSelectionID = inst.getSelectedQueryID();
                      reportsConfigBean.setCurrentSelectionID(currentSelectionID);
                     }
                  }
                  else if (reportsConfigBean.getCurrentSelectionType() == MxTaskWizardInstance.COLLECTION_SELECTION)
                 {
                   DebugOutput.log(reportDebug, 15, "ReportsConfigBean:createNewSelection) current selection type = single mxcollection \n");
                   if (reportsConfigBean.getCurrentSelectionID() == null)
                    {
                        currentSelectionID = inst.getSelectedMxCollectionID();  // return MxObjectId
                        reportsConfigBean.setCurrentSelectionID(currentSelectionID);
                    }
                 }
                 }
                 if (reportsConfigBean.getCurrentSelectionID() == null)
                 {
                   reportsConfigBean.alert(out, MxReportException.REPORT_ERR_INVALID_TARGET);
                   DebugOutput.log(reportDebug, 15,"reportsConfig/save invalid target selection \n ");
                   bContinue = false;
                 }
                 // revalidate query, collcetion and mix
                 if (bContinue == true)
                 {
                   if ((reportsConfigBean.getCurrentSelectionType() == MxTaskWizardInstance.NODE_SELECTION) ||
                          (reportsConfigBean.getCurrentSelectionType() == MxTaskWizardInstance.QUERY_SELECTION))
                    {
                     bContinue = reportsConfigBean.validateQuery(out, reportsConfigBean.getCurrentSelectionID());
                    }
                    else if ((reportsConfigBean.getCurrentSelectionType() == MxTaskWizardInstance.COLLECTION_SELECTION)
                           || (reportsConfigBean.getCurrentSelectionType() == MxTaskWizardInstance.MIXED_SELECTION))
                       {
                        bContinue = reportsConfigBean.validateCollection(out, reportsConfigBean.getCurrentSelectionID());
                       }
                 }
                 if (bContinue == true)
                 {
                 String tStr = reportsConfigBean.getUpdatedAttributes();

                 if (strSave.compareToIgnoreCase("updateReport") == 0)  // update the existing report
                 {
                     if (reportsConfigBean.reportUpdate(out) ==  true)
                     {
                     // clean up old selection
                     if ((reportsConfigBean.isNewSelection() == true) && (reportsConfigBean.getSelectionID()!= null))
                        {
                         reportsConfigBean.cleanupOldSelction(out);
                        }
                     reportsConfigBean.setSaveButtonStatus(2);
                     DebugOutput.log(reportDebug, 15,"reportsConfig set save success");
                     reportsConfigBean.alert(out, reportsConfigBean.REPORT_SAVE_SUCCESS);
                     reportsConfigBean.setNewSelection(false);
                     reportsConfigBean.setSelectionType(currentSelectionType);
                     reportsConfigBean.setSelectionID(currentSelectionID);
                     DebugOutput.log(reportDebug, 15,"reportsConfig after update success \n");
                     selectionID = reportsConfigBean.getSelectionID();
                     if (selectionID != null)
                        DebugOutput.log(reportDebug, 15,"reportsConfig selectionid = "+selectionID.toString()+"\n");
                     else
                        DebugOutput.log(reportDebug, 15,"reportsConfig selectionid = null  \n ");
                     String tempStr = reportsConfigBean.getUpdatedAttributes();
                     // update manage report page if the caller is report manage page
                     if (reportsConfigBean.getReportMenu() == false)
                     {
                         manageReportsBean.setNewRptName(repName);
                         manageReportsBean.refreshTableModel(manageReportsTableModel,manageReportsSelectionModel);
                     }
                     }
                 }
                 else
                 {
                     // Assuming it's a "addReport".
                     DebugOutput.log(reportDebug, 15,"reportsConfig  do addreport work");
                     reportsConfigBean.setNewReportName(repName);
                     String tempStr = reportsConfigBean.getUpdatedAttributes();
                     int reportId = reportsConfigBean.reportAdd(out);  // add new report
                     if (reportId > 0)
                     {
                       // clean up old selection
                       if ((reportsConfigBean.isNewSelection() == true) && (reportsConfigBean.getSelectionID()!= null))
                        {
                         reportsConfigBean.cleanupOldSelction(out);
                        }
                       reportsConfigBean.setSaveButtonStatus(2);
                       DebugOutput.log(reportDebug, 15,"reportsConfig set save success");
                       reportsConfigBean.alert(out,reportsConfigBean.REPORT_SAVE_SUCCESS);
                       reportsConfigBean.setReportId(reportId);
                       reportsConfigBean.setNewSelection(false);
                       reportsConfigBean.setSelectionType(currentSelectionType);
                       reportsConfigBean.setSelectionID(currentSelectionID);
                       DebugOutput.log(reportDebug, 15,"reportsConfig  after add report success \n");
                       reportsConfigBean.getUpdatedAttributes();
                       // update manage report page if the caller is report manage page
                       if (reportsConfigBean.getReportMenu() == false)
                       {
                         manageReportsBean.setNewRptName(repName);
                         manageReportsBean.refreshTableModel(manageReportsTableModel,manageReportsSelectionModel);
                       }
                       strSave = "0";
                       rString = "ReportsConfig.jsp?RName=";
  %>
  <script language="JavaScript" type="text/javascript">
                      if ((<%=reportsConfigBean.getSaveButtonStatus() %> == 2) && (<%=reportsConfigBean.getEdit() %> == true))
                      {
                       var e = parent.document.getElementById("wizTitle");
                       if (e != null)
                           e.innerHTML =  "<%=reportsConfigBean.getResString("STRING_REPORT_EDIT") %>"
                       var e = parent.document.getElementById("wizTitle1");
                       if (e != null)
                           e.innerHTML = "  "+"<%=reportNameDisp%>";
                       }
                       location.replace("<%=rString%>"+encodeURIComponent("<%=repName%>")+"&timeStamp=<%=timeStamp%>");
   </script>
   <%
                    }
                  }
                 }
               }
               } //end bNewSelection = true with an existing selection
             }
             catch (Exception e){}
             int numReports = manageReportsTableModel.getRowCount();
             // make sure to display report name correctly
             DebugOutput.log(reportDebug, 15,"reportsConfig (496) reportName "+repName+"\n");
             repName = MxStringFormatter.htmlSafe(repName);
   %>

<script>
            if (parent.autoRefresh != null)
            {
                 parent.autoRefresh(<%=numReports%>);
            }
            if (parent.parent.autoRefresh != null)
            {
               parent.parent.autoRefresh(<%=numReports%>);
            }
</script>


<script language='javascript' type='text/javascript'>
<%@include file="js/ReportsConfigFunctions.js"%>
<%@include file="js/CopyReport.js"%>
// fix for #255934
<%@include file="../js/MxPortalApi.js"%>
</SCRIPT>
<script language='javascript' type='text/javascript'>

     var iReportItemSelectCount =<%=reportsConfigBean.getItemCount()%>;
     var sReportItemSelectString ="<%=reportsConfigBean.getItemList()%>"; // common separated item Id String e.g. 3,5,7,23
     var sReportItemIdSelectString ="<%=reportsConfigBean.getItemIdList()%>";
     var reportUrl = "";
     var iFirst = <%=wizardFlag%>; // 0= not first, 1= first time, 2= edit first time

    function reportLoad()
    {
     // update the step text string
     var e = parent.document.getElementById("wizStep");

     if (e != null)
        e.innerHTML =  "<%=reportsConfigBean.getResString("STRING_REPORT_STEP2") %>";
     // Update the subtitle only when this page is accessed from report/new menu
     if (<%=reportsConfigBean.getReportMenu()%> == true)
      { // update the subtitle if it is first time or use go prev and change query
       if ((iFirst > 0) || ((iFirst == 0) && (<%=reportsConfigBean.isNewSelection()%> == true)))
        {
       var html = null;
       var nodes = "<%=inst.getSelectedNodesString()%>";
       if (nodes != "")
       {
        // set the selected nodes in the tool description area
        if (nodes.indexOf(",") != -1)
          html = "<%=reportsConfigBean.getResString("STRING_REPORT_TARGETS")%>" + ":&nbsp;" + nodes;
        else
          html = "<%=reportsConfigBean.getResString("STRING_REPORT_TARGET")%>" + ":&nbsp;" + nodes;
        MxPortalWorkspaceSetSubtitleHtml(html);
       }
       }
      }
      if (<%=reportsConfigBean.getItemCount()  %> > 0)
       {
         setReportItemSelectInfo("<%=reportsConfigBean.getItemList()%>","<%=reportsConfigBean.getItemIdList()%>", <%=reportsConfigBean.getItemCount()  %>,0)
       }
      else
        iFirst = 0;

      if ( <%= reportsConfigBean.getRunFlag()%> == 0)
        document.getElementById('reportName').focus();
    }

</script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxButton.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</head>
<BODY onLoad = "reportLoad()">
<FORM ID="reportsConfigForm" NAME="reportsConfigForm" METHOD="POST">

<table border="0" style="border:0px;background:white;margin:0;">
 <tr>
  <td nowrap><strong><%=reportsConfigBean.getResString("STRING_REPORT_NAME")%></strong></td>
  <td nowrap>
    <INPUT TYPE=text onKeyUp='reportNameChange()'
         onClick='setTimeout("reportNameChange()", 3000)' onPaste='setTimeout("reportNameChange()", 300)'
         NAME="reportName" ID="reportName" MAXLENGTH =150 style ="WIDTH: 580px" value="<%=repName%>" >
    </td></tr>
</table>

<br>
<strong><%=reportsConfigBean.getResString("STRING_REPORT_DATA") %></strong><br>
<table width="100%" border ="0" cellspacing = "0" cellpadding = "4">
<tr valign="top">
<td width="40%">
  <IFRAME WIDTH="100%" HEIGHT="300" SRC="<%=treeURL %>"></IFRAME>
</td>

<td>
  <strong><%=reportsConfigBean.getResString("STRING_PREFERRED_LAYOUT") %></strong><br>
  <table width="50%" style="BORDER-RIGHT: gray 0px solid; BORDER-TOP: gray 0px solid; BORDER-LEFT: gray 0px solid; WIDTH: 100%; BORDER-BOTTOM: gray 0px solid" background="white" border=0>
  <tr><td style="FONT-WEIGHT: bold; FONT-SIZE: smaller">
  <input type="radio" name="viewOption" id="viewOptionAgg" value="0" onClick= "enableReportsConfigButtons()">
  <label for="viewOption"><%=reportsConfigBean.getResString("STRING_REPORT_AGGREGATED")%></label><br>
  <input type="radio" name="viewOption" id="viewOptionSingle" value="1" onClick= "enableReportsConfigButtons()">
  <label for="viewOption"><%=reportsConfigBean.getResString("STRING_REPORT_SINGLE")%></label>
  </td></tr></table>
  <br>
  <strong><%=reportsConfigBean.getResString("STRING_PREFERRED_FORMAT") %></strong><br>
  <table width="50%" style="BORDER-RIGHT: gray 0px solid; BORDER-TOP: gray 0px solid; BORDER-LEFT: gray 0px solid; WIDTH: 100%; BORDER-BOTTOM: gray 0px solid" background="white" border=0>
  <tr><td style="FONT-WEIGHT: bold; FONT-SIZE: smaller">
  <input type="radio" name="reportFormat" id="HTMLFormat" value="0" CHECKED onClick= "enableReportsConfigButtons()">
  <label for="reportFormat"><%=manageReportsBean.getResString("STRING_HTML_FORMAT")%></label><br>
  <input type="radio" name="reportFormat" id="XMLFormat" value="1" onClick= "enableReportsConfigButtons()">
  <label for="reportFormat"><%=manageReportsBean.getResString("STRING_XML_FORMAT")%></label><br>
  <input type="radio" name="reportFormat" id="CSVFormat" value="2" onClick= "enableReportsConfigButtons()">
  <label for="reportFormat"><%=manageReportsBean.getResString("STRING_CSV_FORMAT")%></label>
  </td></tr></table>
</td>
</tr>
</table>
<br>


<%
    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();

    MxTag prevTag = new MxDefaultTag("Prev", reportsConfigBean.getResString("BUTTON_PREV_LABEL"), "prevButtonClick()");
    prevTag.setAttr(MxTag.TYPE, "submit");
    buttons.addMxTag(prevTag);

    if (reportsConfigBean.getReportMenu() ==  false)
    {
        MxTag cancelTag = new MxDefaultTag("", reportsConfigBean.getResString("BUTTON_CANCEL_LABEL"), "cancelButtonClick()");
        cancelTag.setAttr(MxTag.TYPE, "submit");
        buttons.addMxTag(cancelTag);
    }

    MxTag runReportTag = new MxDefaultTag("RunReport", reportsConfigBean.getResString("BUTTON_RUN_REPORT"), "runButtonClick()");
    runReportTag.setAttr(MxTag.DISABLED, "true");
    runReportTag.setAttr(MxTag.TYPE, "submit");
    buttons.addMxTag(runReportTag);

    MxTag saveReportTag = new MxDefaultTag("SaveReport", reportsConfigBean.getResString("BUTTON_SAVE_REPORT"), "saveButtonClick()");
    saveReportTag.setAttr(MxTag.DISABLED, "true");
    saveReportTag.setAttr(MxTag.TYPE, "submit");
    buttons.addMxTag(saveReportTag);
%>

<div style="margin-top:15px">
    <% buttons.dumpButtons(out); %>
</div>

<script language='javascript' type='text/javascript'>
  if (<%=reportsConfigBean.getViewOption()%> == 0)  // aggregate view
     document.getElementById("viewOptionAgg").checked = true;
  else
     document.getElementById("viewOptionSingle").checked = true;

  if (<%=reportsConfigBean.getReportFormat()%> == <%=formatIfc.JSPFORMAT%>)
     document.getElementById("HTMLFormat").checked = true;
  else if (<%=reportsConfigBean.getReportFormat()%> == <%=formatIfc.XMLFORMAT%>)
          document.getElementById("XMLFormat").checked = true;
       else
          document.getElementById("CSVFormat").checked = true;
</script>
<br>

 <input type="hidden" name="itemList" id ="itemList" value="<%=reportsConfigBean.getItemIdList()%>" >
 <input type="hidden" name="newSelection" id ="newSelection" value="<%=reportsConfigBean.isNewSelection()%>" >
 <input type="hidden" name="saveButtonStatus" id ="saveButtonStatus" value="<%=reportsConfigBean.getSaveButtonStatus()%>" >
 <input type="hidden" name="runFlag" id ="runFlag" value="<%=reportsConfigBean.getRunFlag()%>" >

</FORM>
<IFRAME ID="commSpace" NAME="commSpace" SRC="blank.html" style="position:absolute; visibility:hidden" height="1" width="1"></IFRAME>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</body>
</html>

<%--
//
//$Log: ReportsConfig.jsp,v $
//Revision 1.108  2005/06/01 22:20:21  yeh
//just shows error message not include report name which conatins script invalid char
//
//Revision 1.107  2005/05/26 14:43:09  wuje
//Fixed bug 230650. Added validatequery and validatecollection call.
//
//Revision 1.106  2005/05/19 17:30:08  yeh
//call IsReportNameValid
//
//Revision 1.105  2005/05/17 16:08:34  wuje
//Check invalidchar for report name  when it is not null.
//
//Revision 1.104  2005/05/16 19:44:15  wuje
//Fixed invalid char check problem.
//
//Revision 1.103  2005/05/13 21:49:09  wuje
//Removed reportitemmanager.
//
//Revision 1.102  2005/05/12 20:29:33  wuje
//Added error --REPORT_ERR_INVALID_TARGET
//
//Revision 1.101  2005/04/29 19:48:59  paynev
//Fixed issue #233469: use ReportsConfigBean's STRING_PREFERRED_FORMAT instead of
//the one from ManageReportsBean.
//
//Revision 1.100  2005/04/21 19:27:36  wuje
//Fixed bug233469. Removed space before "?" for save report dialog box.
//
//Revision 1.99  2005/04/21 03:49:34  farley
//detabbed, for maintainability
//
//Revision 1.98  2005/04/20 19:35:34  yeh
//use item id list, fix invalid report name
//
//Revision 1.97  2005/04/08 19:03:33  wuje
//Fixed bug 230392. Show the original report name in the duplicate report dialog box.
//
//Revision 1.96  2005/03/22 19:12:01  wuje
//Moved the code to cleanup old selection after add/update report successfully.
//
//Revision 1.95  2005/03/09 17:14:38  wuje
//Pass itemid string instead of itemGUID string between reportwizard and report config page.
//
//Revision 1.94  2005/02/24 22:33:31  wuje
//Fixed reporting save twice bug.
//
//Revision 1.93  2005/02/23 23:13:18  wuje
//Fixed bug of change collection target as another collection and save report again
//
//Revision 1.92  2005/02/18 18:12:09  wuje
//Move some java code from reportconfig.jsp to reportcongifbean.java..
//
//Revision 1.91  2005/02/15 23:10:48  balunis
//Since all consumers of MxSystemListCreator are either creating a Dynamic or Hidden query, the parameters for "hidden", "personal" and "category" have been removed from all query creating APIs.
//
//Revision 1.90  2005/02/03 20:03:25  wuje
//Remove test code for remove collection.
//
//Revision 1.89  2005/02/01 00:42:21  wuje
//Check for remove collection sucees or not.
//
//Revision 1.88  2005/01/28 21:06:37  wuje
//Change the input parameter for isCollectioninReport().
//
//Revision 1.87  2005/01/28 18:32:57  wuje
//Add COLLECTION_SELECTION.
//
//Revision 1.86  2005/01/26 23:34:49  farley
//MxLoginBean: "C t l r" renamed to "C l i e n t"
//
//Revision 1.85  2005/01/26 03:21:11  farley
//style sheet cleanup
//
//Revision 1.84  2005/01/26 03:07:18  farley
//removed undefined class reference
//
//Revision 1.83  2005/01/25 22:42:53  wuje
//Add alert when create query has problem and stop to run or save report.
//
//Revision 1.82  2005/01/25 22:17:49  wuje
//Add alert when create query has problem.
//
//Revision 1.81  2005/01/24 20:48:58  wuje
//Change the call to varify the query still associate with other report.
//
//Revision 1.80  2005/01/21 23:05:52  paynev
//Fixed bug where report name is null: changed ReportsConfig URL parameter
//to use RName label instead of the original ReportName to match the parameter
//from ReportWizard.
//
//Revision 1.79  2005/01/21 20:03:27  farley
//detab
//
//Revision 1.78  2005/01/20 17:25:32  paynev
//Minor change to 2 URL labels.
//
//Revision 1.77  2005/01/19 23:38:07  paynev
//Added code to convert itemList to itemIDList to pass to URL. Small changes
//to the parameter labels in the URL.
//
//Revision 1.76  2005/01/19 02:13:20  farley
//detab
//
//Revision 1.75  2005/01/18 23:20:16  yeh
//shorten parameters name and use items ID
//
//Revision 1.74  2005/01/17 22:46:11  wuje
//Add hidden query/collection stuff.
//
//Revision 1.73  2005/01/13 23:36:55  farley
//i18n
//
//Revision 1.72  2005/01/13 22:54:07  paynev
//Added reportFormat support. Save reportFormat info to the bean, and check the
//appropriate radio button when coming back to this page.
//
//Revision 1.71  2005/01/12 23:25:54  farley
//changes for GUIDO
//
//Revision 1.70  2005/01/12 20:30:53  farley
//detab
//
//Revision 1.69  2005/01/11 01:46:19  wuje
//Added MxCollection stuff.
//
//Revision 1.68  2005/01/07 23:56:26  paynev
//Added code to pass the reportFormat to URL to run report.
//
//Revision 1.67  2005/01/06 22:55:51  wuje
//Fixed jspc compile errors.
//
//Revision 1.66  2005/01/06 22:48:57  wuje
//Fixed jspc compile errors.
//
//Revision 1.65  2005/01/06 21:53:00  wuje
//Checkin quake code.
//
//Revision 1.64  2004/12/21 16:39:21  paynev
//Updated to use getQueryId() instead of getID().
//
//Revision 1.63  2004/12/20 22:32:56  paynev
//Updated to use new APIs for Add Report & Update Report features.
//
//Revision 1.62  2004/12/08 23:49:58  balunis
//Quake changes for Task Wizard target selection
//
//Revision 1.61  2004/11/23 21:53:19  wuje
//Fixed bug 267348. Multiuser with dynamic query, user1 delete report, user2 save the same report will cause http error.
//
//Revision 1.60  2004/11/12 22:10:24  paynev
//Updated to support the new TreeView.
//
//Revision 1.59  2004/09/23 20:08:36  paynev
//Use report format related strings from ReportsManage.properties instead of
//ReportsConfig.properties.
//
//Revision 1.58  2004/09/20 19:34:14  paynev
//Added the report format radio buttons and the new high level category dropdown
//box for the new UI enhancements in Quake.
//
//Revision 1.57  2004/09/16 19:58:10  urreat
//GUIDO: removed ourButtonManager instantiation and initialization as proper instantiation is now included through MxHtmlUtil java calls
//
//Revision 1.56  2004/09/15 00:23:47  urreat
//GUIDO: fixed typo
//
//Revision 1.55  2004/09/10 01:32:25  urreat
//GUIDO: new buttons
//
//Revision 1.54  2004/09/03 14:40:15  wuje
//Fixed bug 261474. Close all reporting windows during logout.
//
//Revision 1.53  2004/07/16 23:28:13  balunis
//Merged 4.2 revision 1.52.2.2.  Adding Task Wizard multiple window support. (for Montero)
//
//Revision 1.52.2.2  2004/07/16 18:58:52  balunis
//A cleaner fix for #255932.  Actions that use the Target Selection Page should encode the "btn2Text" before sending it to the Target Selection Page.
//
//Revision 1.52.2.1  2004/07/15 21:40:51  balunis
//Adding Task Wizard multiple window support. (for Montero)
//
//Revision 1.51  2004/05/18 21:12:53  wuje
//Use the correct report name to the reporName field.
//
//Revision 1.50  2004/04/06 20:26:56  wuje
//Use MxResourceBean to access the resource string.
//
//Revision 1.49  2004/04/02 18:36:21  wuje
//Fixed bug 253864.  Type report name with Japanese Chararcter will enable the save button if some report item is selected.
//
//Revision 1.48  2004/03/05 20:20:10  wuje
//Added URLencode to runfile url string.
//
//Revision 1.47  2004/03/05 00:45:20  wuje
//Fixed bug 251394 enter different case report name will not create a new report in Unix and Linux..
//
//Revision 1.46  2004/02/27 00:16:21  wuje
//Conditionally update subtitle.
//
//Revision 1.45  2004/02/26 00:18:02  wuje
//Fixed localization bug.
//
//Revision 1.43  2004/02/24 01:04:39  wuje
//Use queryId instead of query name.
//
//Revision 1.42  2004/02/20 23:10:01  wuje
//Added code for localization.
//
//Revision 1.41  2004/02/18 18:45:49  wuje
//Add out as parameter for save and add report procedure.
//
//Revision 1.40  2004/02/16 22:48:56  wuje
//Use reportUtil.instance().
//Remove query information.
//
//Revision 1.39  2004/02/02 23:50:17  wuje
//Fixed 249796.
//
//Revision 1.38  2004/01/30 19:12:35  wuje
//Fixed bug 251023, radio button does not get selected in Mozilla 1.5.
//bug 249796 -- input "<script>hello</scirpt>"  as report name, mess the display.
//
//Revision 1.37  2003/11/12 21:22:55  wuje
//Fixed bug 248933. Edit a report, delete report name and run report, The title still show the old report name.
//
//Revision 1.36  2003/11/10 19:50:00  wuje
//Fixed bug 248709 change suttitle description to target selection only when the reporting page access from report menu.
//
//Revision 1.35  2003/11/06 22:50:47  wuje
//fixed bug 245967. IE error after redisplay reporting tree.
//
//Revision 1.34  2003/10/30 20:09:21  paynev
//Fixed a boundary problem in the report table page where the table is not updated correctly
//when all reports are deleted.  Add a parameter (numReports) to the auto Refresh() call.
//
//Revision 1.33  2003/10/23 23:07:40  wuje
//Fixed the bug 243506.
//
//Revision 1.32  2003/10/21 21:20:37  wuje
//Fixed bug access saved report have HTTP error shows.
//
//Revision 1.31  2003/10/17 16:04:49  wuje
//Fixed the dynamic query being delete by other report bug.
//
//Revision 1.30  2003/10/06 21:09:30  wuje
//Added reporting associated query check for remove query.
//
//Revision 1.29  2003/10/03 20:40:28  wuje
//Use dynamic query in reporting.
//
//Revision 1.28  2003/09/30 21:24:12  wuje
//Added target nodes/list information to step 2 reporting pages. bug 245891
//
//Revision 1.27  2003/09/24 20:53:47  wuje
//Fixed the report result page displays behind the nimbus page.. Bug 246099
//
//Revision 1.26  2003/09/22 22:07:12  wuje
//Fixed save report bugs. 245580, 245582...
//
//Revision 1.25  2003/09/22 14:56:18  wuje
//Fixed report save bugs.
//
//Revision 1.24  2003/09/22 13:40:45  wuje
//Fixed couple report save bugs. 245580,245582...
//
--%>
