<%--
//+
//
// Copyright 2002 Compaq Information Technologies Group, L.P.
//
// Author: Virginia Payne
//
// Description: for ReportsSQLQueries.jsp (Reports SQL queries page)
//
// $ProjectName: j:/maple/coreWap.pj $
// $Header: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/reporting/ReportsSQLQueries.jsp,v 1.29 2005/04/04 20:18:50 paynev Exp $
//-
--%>

<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*"%>
<%@ page import="com.hp.mx.portal.help.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.util.List"%>
<%@ page import="com.hp.mx.core.nodemanager.*"%>
<%@ page import="com.hp.mx.startup.*"%>
<%@ page import="com.hp.mx.database.*"%>
<%@ page import="com.hp.mx.utilities.*"%>
<%@ page import="com.hp.mx.security.*"%>
<%@ page import="com.hp.mx.core.subjects.*"%>
<%@ page import="com.hp.mx.core.tools.reporting.*"%>
<%@ page import="com.hp.mx.core.tools.reporting.format.*"%>
<%@ page import="com.hp.mx.core.tools.reporting.reportGenerator"%>
<%@ page import=" com.hp.mx.core.reportmanager.MxReport"%>
<%@ page import=" com.hp.mx.core.reportmanager.MxCategory"%>
<%@ page import=" com.hp.mx.core.reportmanager.reportConstant"%>
<%@ page import="com.hp.mx.core.subjects.usermanager.*"%>
<%@ page import="javax.servlet.jsp.*"%>
<%@ page import="java.sql.*"%>
<%@ page import="java.io.*"%>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="ReportsManage" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="ReportsDisplayNames" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<%
    // REQUIRED: This line is required by Tomcat for i18n support.
    MxBean.jspInit(request, response);

   // REQUIRED: This aborts the page if the session is invalid.
   if (loginBean.checkLogoutConditionForWebPage(pageContext))
       return;

   // setup resources.
   ReportsManage.init(loginBean, "ReportsManage");
   ReportsDisplayNames.init(loginBean, "ReportsDefaultNames");

   String queryId = request.getParameter("qID");
   String queryGUID = request.getParameter("qG");
   String queryType = request.getParameter("qT");
   String templateId = request.getParameter("rId");
   String itemsList = request.getParameter("itms");
   String itemListType = request.getParameter("itmT");
   String strReportFormat = request.getParameter("rF");
   int reportFormat = Integer.parseInt(strReportFormat);
   String viewOption = request.getParameter("vO");
   String sortOrders = request.getParameter("s");
   String sortColumns = request.getParameter("sC");

   //
   String templateName = request.getParameter("rName");

   // Temp: display values:
   //out.println("QueryId received is: " + queryId);
   //out.println("<br>");
   //out.println("QueryName received is: " + queryName);
   //out.println("<br>");
   //out.println("TemplateId received is: " + templateId);
   //out.println("<br>");
   //out.println("templateName received is: " + templateName);
   //out.println("<br>");
   //out.println("itemsList received is: " + itemsList);
   //out.println("<br>");
   //out.println("viewOption received is: " + viewOption);
   //out.println("<br>");
   //out.println("sortOrders received is: " + sortOrders);
   //out.println("<br>");
   //out.println("sortColumns received is: " + sortColumns);
   //out.println("<br>");

   // if there is no query ID, set it to 9999
   if ((queryId == null) ||  (queryId.equals("")))
      queryId = "9999";
   if ((templateId == null) || (templateId.equals("")))
      templateId = "-1";
   // Get the display name in case the name is a default report name (therefore could be localized)
   String displayName = null;
   if ((templateName == null) || (templateName.equals("")))
   {
      templateName = ReportsManage.getString("UNNAMED_REPORT_LABEL");
      displayName = templateName;
   }
   else
       displayName = ReportsDisplayNames.getDisplayName(templateName);

   MxButtons buttons = new MxButtons();
   buttons.clearMxTags();
   buttons.addMxTag(new MxDefaultTag("", ReportsManage.getString("BUTTON_CLOSE_WINDOW"), "window.close()" ));
%>

<html>
<HEAD>
    <TITLE><%=ReportsManage.getString("REPORTS_SQL_QUERIES_TITLE")%></TITLE>
    <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxPortalApi.js'></script>
    <STYLE TYPE="text/css">
<!--
TR { font-size:8pt; vertical-align:text-top}
-->
    </STYLE>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxPortalRender.dumpHeadContent(out); %>
<% buttons.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</HEAD>

<body class="body-flush-fit-scrolling-nobackground">
<%MxPortalRender.dumpTitleHtml(displayName, out);%>

<table style="margin:10">

<tr>
<td>

<SCRIPT language="JavaScript">
    MxPortalWorkspaceSetHelpTopic("feature_report_showSQL");
</SCRIPT>

<%
   MxUser loginUser = loginBean.getMxUser();

   MxReport rObj = new MxReport();
   rObj.setReportId(Integer.parseInt(templateId));
   rObj.setName(templateName);
   rObj.setReportName(templateName);
   rObj.setQueryId(Integer.parseInt(queryId));
   rObj.setQueryType(Integer.parseInt(queryType));
//   rObj.setQueryType(reportConstant.QUERYTYPE_MXQUERY_GUID);
   rObj.setQueryName(queryGUID);
   rObj.setViewOption(Integer.parseInt(viewOption));
   rObj.setItemListType(Integer.parseInt(itemListType));
//   rObj.setItemListType(reportConstant.TYPE_MXGUID_STR);
   rObj.setItemList(itemsList);
   // Generate the report tables
   reportGenerator reportG = null;
   int format= formatIfc.JSPFORMAT;
//   int format= formatIfc.CSVFORMAT;
//   int format= formatIfc.XMLFORMAT;
   System.out.println("ReportResult: templateId = "+templateId+"  Name= "+templateName+ "formatType=" + format);
   System.out.println("ReportResult: before generate report table");
   try {
       reportG = new reportGenerator(rObj, reportFormat, loginBean.getMxUser(),
                     loginBean.getLocale(), loginBean.getTimeZone());
   if (sortColumns ==null || sortColumns.equals(""))
       reportG.setOrderList(null);
   else
       reportG.setOrderList(sortColumns);
   if (sortOrders ==null || sortOrders.equals(""))
       reportG.setAscList(null);
   else
       reportG.setAscList(sortOrders);
   reportG.initialize();
   List sqlList=null;
   List categoryList=null;
   sqlList = reportG.getSqlStmtForEachCategory();
   categoryList = reportG.getCategoryList();
   // Display the SQL statements with title for each table.
   String strCategory = null;

   if (sqlList != null)
   {
        int size = sqlList.size();
        for (int i=0; i< size; i++) {
            MxCategory cat = (MxCategory) categoryList.get(i);
            strCategory = (String)cat.getNameString();
            out.println(ReportsManage.getString("SQL_QUERY_LABEL") + " " + strCategory);
            out.println("<br>");
            out.println("<br>");
            String strContent = (String)sqlList.get(i);
            out.println(strContent);
            out.println("<br>");
            out.println("<br>");

        }
   }
   else
     out.println(ReportsManage.getString("MSG_NULL_SQL_VECTOR"));
   } catch (Exception e) {
   }

%>

</table>

<div style="margin-top:15px; margin-right:15px">
    <% buttons.dumpButtons(out); %>
</div>

<%-- H.Tokita rQm255360
            <input class="mx-button" type="BUTTON" style='width:95' onclick="window.close()" value=<%=ReportsManage.getString("BUTTON_CLOSE_WINDOW")%>>
--%>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</body>
</html>
