<%@ page import="java.util.*" %>
<%@ page import="javax.swing.tree.*" %>
<%@ page import="javax.swing.tree.TreeModel" %>
<%@ page import="javax.swing.tree.DefaultTreeModel" %>
<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.html.tree.*" %>

<%@ page import="com.hp.mx.portal.core.*" %>
<%@ page import="com.hp.mx.portal.tree.MxTreeDataModel" %>
<%@ page import="com.hp.mx.portal.ui.*" %>

<%@ page import="com.hp.mx.core.querymanager.Query" %>
<%@ page import="com.hp.mx.core.tools.reporting.*" %>
<%@ page import="com.hp.mx.utilities.DebugSubsystem" %>
<%@ page import="com.hp.mx.core.subjects.MxSubjectPrivilege" %>
<%@ page import="com.hp.mx.utilities.DebugOutput" %>
<%@ page import="com.hp.mx.utilities.DebugSubsystem" %>
<%@ page import="com.hp.mx.portal.ui.MxOptions" %>
<%@ page import="com.hp.mx.portal.ui.MxBean" %>
<%@ page import="com.hp.mx.core.reportmanager.MxItem" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="reportsConfigBean" class="com.hp.mx.portal.reporting.ReportsConfigBean" scope="session" />


<jsp:useBean id="treeData" class="com.hp.mx.core.tools.reporting.ReportItemTreeBuilder" scope="session" />
<jsp:useBean id="ReportsConfigTreeView" class="com.hp.mx.html.tree.MxTreeView" scope="session" />
<jsp:useBean id="ReportsConfigExpansionModel" class="com.hp.mx.html.tree.MxDefaultTreeExpansionModel" scope="session" />
<jsp:useBean id="ReportsConfigTreeController" class="com.hp.mx.html.tree.MxTreeController" scope="session" />
<jsp:useBean id="ReportsConfigSelectionModel" class="com.hp.mx.html.tree.MxTreeSelectionModel" scope="session" />

<%
    //This line is required by Tomcat for il8n support
    MxBean.jspInit(request, response);

    // This aborts the page if the session is invalid
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    // The SERVER-SIDE debug level
    DebugSubsystem reportDebug = DebugOutput.getDebugSubsystem("Reports");
    DebugOutput.log(reportDebug, 15," ************ReportsTreeView starts here  ******************");
    DebugOutput.log(reportDebug, 15, " itemcount ="+ reportsConfigBean.getItemCount()+ " list = "+reportsConfigBean.getItemIdList()+"\n\n");

    int selCount = 0;
    String selIdString = "";
    String selString = "";
    int iSelItemCount = 0;
    String sSelItemString="";
    String sSelItemIdString="";
    MxItem itemObj = null;

    if (ReportsConfigTreeController.checkUrlForControllerMessages(request, out))
    {
       if (request.getParameter(MxTreeController.URL_PARAM_SELECTION) != null)
       {
       selCount = ReportsConfigSelectionModel.getSelectionCount();
       DebugOutput.log(reportDebug, 15, "!!!@@@$$$%%%% inside iFrame. selCount = " + selCount);

       if (selCount > 0)
       {
          TreePath[] paths = ReportsConfigSelectionModel.getSelectionPaths();
          TreePath currentPath = null;

           // Iterate over the list of paths whose selections have changed
           for (int i = 0; i < paths.length; i++)
           {
               currentPath = paths[i];

               // Get the last object in the path, which is the node of interest
               DefaultMutableTreeNode treeNode = (DefaultMutableTreeNode) currentPath.getLastPathComponent();
               MxDefaultTag tag = (MxDefaultTag)treeNode.getUserObject();
               // build the comma separated string of unique item names for the selected items
               itemObj = (MxItem) tag.getAttrObject("MxItem");
               if (itemObj != null)
               {
                  //selString += itemObj.getGUID().toString();
                  selIdString += itemObj.getItemId();
                  selString += itemObj.getItemId();
//                  selString += itemObj.getGUID().toString();
                  //DebugOutput.log(reportDebug, 15, "!!!@@@$$$%%%% inside path loop. selString = " + selString+"\n");
                  //DebugOutput.log(reportDebug, 15, "  idString="+selIdString+"\n");
                  if (i < paths.length -1)
                  {
                     selString += ",";
                     selIdString += ",";
                  }
               }
           }
           DebugOutput.log(reportDebug, 15, "!!!@@@$$$%%%% selString = " + selString+"\n");
           DebugOutput.log(reportDebug, 15, "  idString="+selIdString+"\n");
       }
       else
       {
          DebugOutput.log(reportDebug, 15, "!!!@@@$$$%%%% SELECTION COUNT = 0. selString = " + selString);
       }


       reportsConfigBean.setItemCount(selCount);
       reportsConfigBean.setItemList(selString);
       reportsConfigBean.setItemIdList(selIdString);
       iSelItemCount = selCount;
       sSelItemString= selString;
       sSelItemIdString= selIdString;
       DebugOutput.log(reportDebug, 15," ReportsTreeView before call setreportitem selectinfo \n");
       out.write("<script>");
       out.write("parent.parent.setReportItemSelectInfo('" + selString +"',' "+selIdString+"', " + selCount + ", 1);");
       out.write("</script>");
       DebugOutput.log(reportDebug, 15," ReportsTreeView after call setreportitem selectinfo \n");

       } //it's an MxTreeController.URL_PARAM_SELECTION
       return;
    }

    ReportUtil rUtil = ReportUtil.instance();
    int uPrivilege= 0;
    if (loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.REPORT_VIEW_SECURED_DATA_PRIVILEGE))
    {
        uPrivilege = MxSubjectPrivilege.REPORT_VIEW_SECURED_DATA_PRIVILEGE.getPrivilegeCode();
    }
    DebugOutput.log(reportDebug, 15," ReportsTreeView user privilege = " + uPrivilege);

    iSelItemCount = reportsConfigBean.getItemCount();
    sSelItemString= reportsConfigBean.getItemList();
    sSelItemIdString= reportsConfigBean.getItemIdList();

    //sSelItemString= reportsConfigBean.getItemList();
    //DebugOutput.log(reportDebug, 15," ReportsTreeView: gotCountFromBbean. iSelItemCount = " + iSelItemCount);
    DebugOutput.log(reportDebug, 15," ReportsTreeView: gotSelStringFromBean. sSelItemString = " + sSelItemString+" idString="+sSelItemIdString+"\n");

    TreeModel myTreeModel;

    if (ReportsConfigTreeController.isFirstTime())
    {
        ReportsConfigTreeView.setId("ID_MY_TREE");
        ReportsConfigTreeView.setUrlHandler(request.getRequestURI());

        // Nimbus pages will use loginBean.getLocale() here:
        ReportsConfigTreeController.setLocale(request.getLocale());
     }
        //myTreeModel = treeData.buildTree(uPrivilege, loginBean.getLocale());
     myTreeModel = treeData.getTreeModel();
     ReportsConfigTreeController.setTreeModel(myTreeModel);
     ReportsConfigTreeController.setExpansionModel(ReportsConfigExpansionModel);
     ReportsConfigTreeController.setSelectionModel(ReportsConfigSelectionModel);
     ReportsConfigSelectionModel.setExtendedSelectionMode(MxTreeSelectionModel.MULTI_CONTAINER_SELECTION);
     ReportsConfigTreeController.setTreeView(ReportsConfigTreeView);

    //myTreeModel = ReportsConfigTreeController.getTreeModel();
     ReportsConfigExpansionModel.clearExpansion();
     ReportsConfigSelectionModel.clearSelection();
     ReportsConfigTreeView.setOnChange("mySelectionChanged");
%>

<HTML>
<HEAD>
<TITLE></TITLE>
<script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
<link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>

<script type='text/javascript' language='JavaScript'>

function LoadPage()
{
   if (<%=iSelItemCount%> > 0)
   {
      parent.setReportItemSelectInfo("<%=sSelItemString%>","<%=sSelItemIdString%>", <%=iSelItemCount%>, 1);
   }
}

function mySelectionChanged(treeID, itemId, selectionState)
{
    //Remove focus from the reportName field every time the user selects something in the TreeView.
    var rNameObj = parent.document.getElementById("reportName");
    if (rNameObj != null)
    {
        rNameObj.focus();
        rNameObj.blur();
    }
}



</script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% ReportsConfigTreeView.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>
</HEAD>

<BODY onload="LoadPage()">
<table>
<tr>
<td valign="top">

<%
   if (myTreeModel != null)
   {
      treeData.setReportSelectedItems(sSelItemString, iSelItemCount, ReportsConfigTreeController, ReportsConfigSelectionModel, myTreeModel);
      ReportsConfigTreeView.dumpExpansionButtons(out);
      out.println("<br>");
      ReportsConfigTreeView.dumpTree(out);
   }
%>
</td>
</tr>
</table>
<% MxHtmlUtil.dumpBodyEnd(out); %>
</BODY>
</HTML>
