<%--
//$Source: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/reporting/js/ReportsConfigFunctions.js,v $
//$Revision: 1.38 $
//$Date: 2005/05/16 19:45:34 $
--%>


 /*************************************************************
  * Set Report Item Selection and Count in ReportsItemTree
  * Edit report first time has to disable save button, enable the save button for the rest of operation
  * Remember the save button disable/enable status when clicking prev/next button
  *************************************************************/
  function setReportItemSelectInfo(iString, itemIdString, count, tree)
   {
    iReportItemSelectCount = count;
    sReportItemSelectString = iString;
    sReportItemIdSelectString = itemIdString;
    if (tree == 1)
     {
       if (<%=reportsConfigBean.isNewSelection()%> == true) // new query
        {
          iFirst = 0;
          enableReportsConfigButtons();
        }
       else if (<%=reportsConfigBean.getEdit()%> == true)
        {
           enableReportsConfigButtons();
         }
       else if (iFirst == 0)  // function new, not from wizard
          {
            if (<%=reportsConfigBean.getSaveButtonStatus()%> == 3)
              {
               document.getElementById("saveButtonStatus").value = 0;
              }
            enableReportsConfigButtons();
          }
       else if (iFirst == 1)   // function new, from wizard
            enableReportsConfigButtons();

        // set to ReportsConfigBean itemList
        var rListObj = document.getElementById("itemList");
        if (rListObj != null)
        {
            rListObj.value = iString;
        }
      }
      return;
    }

  /*************************************************************
  * Get Report Item Selection Count from ReportsItemTree
  *************************************************************/
  function getReportItemSelectCount()
     {
        return iReportItemSelectCount;
     }

  /*************************************************************
  * Get Report Item Selection String
  *************************************************************/
  function getReportItemSelectString()
     {
       return sReportItemSelectString;
     }

  /*************************************************************
  * Set Report Item Selection String
  *************************************************************/
  function setReportItemSelectString(iString)
     {
        sReportItemSelectString = iString;
        return ;
     }

 /*************************************************************
  * Report name field changes
  *************************************************************/
  function reportNameChange()
     {
        rName = document.getElementById("reportName").value;
        enableReportsConfigButtons();
        document.getElementById("reportName").focus();
     }

  /*************************************************************
  * disable/enable the run/save buttons
  *************************************************************/
  function enableReportsConfigButtons()  //disable/enable the run/save buttons
     {
    var rButtonObj = document.getElementById("RunReport");
    var sButtonObj = document.getElementById("SaveReport");
    var reportNameObj = document.getElementById("reportName");
    var rObj = document.getElementById("saveButtonStatus");
    var rName = "";

    if (iFirst == 1)  //void enable the save button at init time
        {
            iFirst = 0;
        }
    else if (iFirst == 2)   // edit first time, enable the run button, enable/disable save button according the flag
        {
            iFirst = 0;
            ourButtonManager.enableButton(rButtonObj);
            if (rObj != null)
            {
              if (rObj.value == 3)
              {
                rObj.value = 0;
                ourButtonManager.enableButton(sButtonObj);
              }
              else if (rObj.value == 1)
              {
                rObj.value = 0;
                ourButtonManager.disableButton(sButtonObj);
               }
             }
            return;
        }


    if (reportNameObj != null)
        rName = trimLeadingSpace(reportNameObj.value);
    if (rName == "")
        {
        ourButtonManager.disableButton(sButtonObj);
        if (iReportItemSelectCount > 0)
          {
            ourButtonManager.enableButton(rButtonObj);
          }
        else
          {
            ourButtonManager.disableButton(rButtonObj);
          }
        if (rObj != null)
           rObj.value = 0;
        }
    else  // with report name
        {
         if (iReportItemSelectCount >0)  //bReportItemSelected == true)
            {
            ourButtonManager.enableButton(rButtonObj);

            if (<%=reportsConfigBean.getModReportPriv()%> == true)
            {
                if ((<%=reportsConfigBean.getEdit()%> == true) && (rObj.value == 0))
                {
                        ourButtonManager.enableButton(sButtonObj);
                 }
                else
                {
                 if (rObj != null) // saveButtonStatus
                  {
                      if ((rObj.value == 2) || (rObj.value == 1))
                      {
                          rObj.value = 0;
                          ourButtonManager.disableButton(sButtonObj);
                      }
                      else
                      {
                        ourButtonManager.enableButton(sButtonObj);
                       }
                   }
                 }
                 if (rObj != null)
                  {
                      if (rObj.value == 3)
                      {
                          rObj.value = 0;
                          ourButtonManager.enableButton(sButtonObj);
                       }
                  }
             }
         }
        else
       {
            ourButtonManager.disableButton(rButtonObj);
            ourButtonManager.disableButton(sButtonObj);
        }
    }
    if (rObj != null)
        rObj.value = 0;
    return;
     }

  /*************************************************************
  * Run button onClick function
  *************************************************************/
  function runButtonClick()
  {
    var rNameObj = document.getElementById("reportName");
    var rName = "";
    if (rNameObj.value != "")
   {
    //rName = encodeURIComponent(htmlSafe(trimLeadingSpace(rNameObj.value)));
    rName = encodeURIComponent(trimLeadingSpace(rNameObj.value));
    var rDispName = trimLeadingSpace(rNameObj.value);
    if (!checkName(rDispName))
    {
      rNameObj.focus();
      var actionStr = "ReportsConfig.jsp?RName=" + rName + "&timeStamp=<%=timeStamp%>";
      document.getElementById('reportsConfigForm').action = actionStr;
      return false;
    }
    }
    var rObj = document.getElementById("runFlag"); // setup runflag
    if (rObj != null)
        rObj.value = 1;

    runStr = "ReportsConfig.jsp?RName="+rName+"&timeStamp=<%=timeStamp%>";
    runStr += "&runReportFlag=1";
    if (document.getElementById("SaveReport").disabled == true)
        runStr += "&saveButtonDown=1";
    //alert ("runbuttonclick str="+runStr+"\n");
    document.getElementById('reportsConfigForm').action = runStr;
    return;
     }
  /*************************************************************
   * Save button onClick function
   *************************************************************/
   function saveButtonClick()
      {
        var rNameObj = document.getElementById("reportName");
//        var rName = encodeURIComponent(htmlSafe(trimLeadingSpace(rNameObj.value)));
        var rName = encodeURIComponent(trimLeadingSpace(rNameObj.value));
        var rDispName = trimLeadingSpace(rNameObj.value);
        if (!checkName(rDispName))
            {
                rNameObj.focus();
                var actionStr = "ReportsConfig.jsp?RName="+rName+"&timeStamp=<%=timeStamp%>";
                document.getElementById('reportsConfigForm').action = actionStr;
                return false;
            }
       reportUrl = "ReportsConfig.jsp?RName="+rName+"&saveReportFlag=saveReport&timeStamp=<%=timeStamp%>";   // create report
       // reset run flag
        var rObj = document.getElementById("runFlag");
        if (rObj != null)
            rObj.value = 0;
        //alert ("savebuttonclick str="+reportUrl+"\n");
        document.getElementById('reportsConfigForm').action=reportUrl;
        return;
    }
  /*************************************************************
   * Previous button onClick function
   *************************************************************/
   function prevButtonClick()
     {
        var e = parent.document.getElementById("wizStep");
        if (e != null)
           e.innerHTML = "<%=reportsConfigBean.getResString("STRING_REPORT_STEP1_V") %>";
        // Update subtitle
        if (document.getElementById("viewOptionAgg").checked == true)
            parent.setViewOption(0);
        else
           parent.setViewOption(1);

        // Save the Report Format:
        var rFormat = 0;
        if (document.getElementById("HTMLFormat").checked == true)
            rFormat = <%=formatIfc.JSPFORMAT%>;
        else if (document.getElementById("CSVFormat").checked == true)
                 rFormat = <%=formatIfc.CSVFORMAT%>;
        else if (document.getElementById("XMLFormat").checked == true)
                 rFormat = <%=formatIfc.XMLFORMAT%>;
        parent.setReportFormat(rFormat);

        var rNameObj =  document.getElementById("reportName");
        var rName = htmlSafe(trimLeadingSpace(rNameObj.value));
        parent.setReportName(rName);
        //parent.setItemList(sReportItemSelectString);
        parent.setItemList(sReportItemIdSelectString);
        //alert("prev key item string= "+sReportItemIdSelectString);
        parent.setPrev(true);
        parent.setNewSelection(<%=reportsConfigBean.isNewSelection()%>);
        if (document.getElementById("SaveReport").disabled == false)
        {
            parent.setSaveButtonUp(true);
        }
        else if (document.getElementById("SaveReport").disabled == true)
        {
            if (iReportItemSelectCount >0)
               parent.setSaveButtonDown(true);
        }

        var str = '<%=MxOptions.URL_BASE%>/taskandjob/targetSelection.jsp?btn2Text=<%= URLEncoder.encode( reportsConfigBean.getResString("BUTTON_NEXT_LABEL"), "UTF-8") %>&btn2Function=parent.gotoReportWizard()&listType=systemLists&timeStamp=<%=timeStamp%>&prev=1';
        document.getElementById('reportsConfigForm').action=str;
        return;
     }
  /*************************************************************
   * Cancel button onClick function
   *************************************************************/
   function cancelButtonClick()
  {
    parent.parent.scrollTo(0, 0);
    parent.document.location.href="/mxportal/home/MxBlank.html";
    // Update subtitle
    var html ="<%=reportsConfigBean.getResString("STRING_REPORT_DESCRIPTION")%>" + ":&nbsp;";
    if (<%=reportsConfigBean.getReportMenu()%> == true)
       html += "<%=reportsConfigBean.getResString("STRING_REPORT_DESCRIPTION_NEW")%>";
    else
       html += "<%=reportsConfigBean.getResString("STRING_REPORT_DESCRIPTION_MANAGE")%>";
    MxPortalWorkspaceSetSubtitleHtml(html);
  }

  /*************************************************************
   * Trim leading space for input string function
   *************************************************************/
  function trimLeadingSpace(inputString)
  {

   if (typeof inputString != "string")
   {
      return inputString;
   }
   var retValue = inputString;
   var ch = retValue.substring(0, 1);
   while ((ch == ' ') || (ch.charCodeAt(0) == 0x3000))  //0x2121  0x3000  # IDEOGRAPHIC SPACE
   {
      retValue = retValue.substring(1, retValue.length);
      ch = retValue.substring(0, 1);
   }
   ch = retValue.substring(retValue.length-1, retValue.length);
   while ((ch == ' ') || (ch.charCodeAt(0) == 0x3000))
  {
      retValue = retValue.substring(0, retValue.length-1);
      ch = retValue.substring(retValue.length-1, retValue.length);
   }
   return retValue;
  }

  /*************************************************************
   * encoding for htmlSafe string function
   *************************************************************/
    function htmlSafe(rName)
    {
    var newName = rName.replace(/&/gi, "&amp;").replace(/</gi,"&lt;").replace(/>/gi,"&gt;").replace(/\"/gi,"&#34;").replace(/\'/gi,"&#39;");
    return newName;
    }

///////////////////////////////////////////////////////////////////////////////

//
//$Log: ReportsConfigFunctions.js,v $
//Revision 1.38  2005/05/16 19:45:34  wuje
//Fixed invalid char check problem.
//
//Revision 1.37  2005/05/10 21:45:26  wuje
//Fixed run report potential bug.
//
//Revision 1.36  2005/03/09 17:15:58  wuje
//Pass itemid string instead of itemGUID string between reportwizard and report config page.
//
//Revision 1.35  2005/01/20 17:24:16  paynev
//Modified prevButtonClicked() to save the reportFormat.
//
//Revision 1.34  2005/01/19 00:09:43  yeh
//shorten reportname to rname
//
//Revision 1.33  2005/01/17 23:20:54  wuje
//Remove query stuff and add selection stuff.
//
//Revision 1.32  2005/01/12 20:45:07  farley
//detab
//
//Revision 1.31  2004/12/20 21:42:51  paynev
//Modified SaveButtonClick().
//
//Revision 1.30  2004/09/10 01:30:56  urreat
//GUIDO: new buttons
//
//Revision 1.29  2004/07/16 23:40:29  balunis
//Merged 4.2 revision 1.28.4.2.  Adding Task Wizard multiple window support. (for Montero)
//
//Revision 1.28.4.2  2004/07/16 18:59:47  balunis
//A cleaner fix for #255932.  Actions that use the Target Selection Page should encode the "btn2Text" before sending it to the Target Selection Page.
//
//Revision 1.28.4.1  2004/07/15 21:41:48  balunis
//Adding Task Wizard multiple window support. (for Montero)
//
//Revision 1.28  2004/04/02 19:15:32  wuje
//Fixed the white space keycode problem.
//
//Revision 1.27  2004/03/24 22:06:52  wuje
//Prevent create empty report name in Japanese OS.
//
//Revision 1.26  2004/02/27 00:14:22  wuje
//Removed unused update subtitle code
//
//Revision 1.25  2004/02/25 23:52:35  wuje
//Fixed localization bug.
//
//Revision 1.24  2004/02/16 22:53:19  wuje
//Fixed bug 252031 -- Run failed when no report name is entered.
//
//Revision 1.23  2004/02/02 23:49:41  wuje
//Fixed 249796.
//
//Revision 1.22  2004/01/30 19:10:45  wuje
//Fixed bug 251023, radio button does not get selected in Mozilla 1.5.
//bug 249796 -- input "<script>hello</scirpt>"  as report name, mess the display.
//
//Revision 1.21  2003/10/29 22:30:39  wuje
//Fixed bug 248195. Run button resized during enable/disable process.
//
//Revision 1.20  2003/10/23 19:22:31  wuje
//Fixed the bug 243506.
//
//Revision 1.19  2003/10/21 21:22:11  wuje
//Fixed bug 247481 "Next >" do not internationalized.
//
//Revision 1.18  2003/10/08 20:00:39  wuje
//Fixed bug 247071, Next >
//
//Revision 1.17  2003/10/06 21:10:02  wuje
//Flip the single view and aggregated view position.
//
//Revision 1.16  2003/10/03 20:40:19  wuje
//Use dynamic query in reporting.
//
//Revision 1.15  2003/09/30 21:24:53  wuje
//Added target nodes/list information to step 2 reporting pages. bug 245891
//
//Revision 1.14  2003/09/25 21:39:38  wuje
//Fixed single view/aggregated view bug.
//
//Revision 1.13  2003/09/24 20:56:21  wuje
//Fixed the report result page displays behind the nimbus page.. Bug 246099
//
//Revision 1.12  2003/09/24 18:15:59  wuje
//Filter event list from select target for reporting. bug # 245646.
//
//Revision 1.11  2003/09/22 22:09:31  wuje
//Fixed save report bugs. 245580, 245582...
//
//Revision 1.10  2003/09/22 13:34:54  wuje
//Fixed couple report save bugs. 245580,245582...
//
//Revision 1.9  2003/08/26 20:19:19  paynev
//Fix a crash problem in Report result page because the query name has a trailing blank.
//Modified runButtonClick():  removed the blank space before the double quote for the query name
//in the URL.
//
//Also added CVS Logging infor for this js file.
//
//
