<%@ page import="com.hp.mx.portal.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="rbsearch" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<%
    MxBean.jspInit(request, response);
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;
    rbsearch.init(loginBean, "MxSearch");
%>

// Global variable for criteria line count
var lines = 0;

////////////////////////////////////////////////////////////////////
// API functions for Search UI Pages
// Included in
// AdvancedSystemsSearch.jsp
// AdvancedEventSearch.jsp
// AdvancedClusterSearch.jsp
////////////////////////////////////////////////////////////////////

/*******************************************************************
// Load the localization strings from the resource bean.
// We load these here as variables for use in the js file below
*******************************************************************/
var sAnd = "<%=rbsearch.getString("and")%>";
var sOr = "<%=rbsearch.getString("or")%>";
var sWhere = "<%=rbsearch.getString("where")%>";
var sAnyText = "<%=rbsearch.getString("any")%>";
var sAdd = "<%=rbsearch.getString("button.add")%>";
var sDelete = "<%=rbsearch.getString("button.delete")%>";
var ipErrMsg = "<%=rbsearch.getString("ipErrMsg")%>";
var ipMaxErrMsg = "<%=rbsearch.getString("ipMaxErrMsg")%>";
var ipMinErrMsg = "<%=rbsearch.getString("ipMinErrMsg")%>";

// Error message strings for pop-ups
var dateErrMsg = "<%=rbsearch.getString("dateErrMsg")%>";
var timeErrMsg = "<%=rbsearch.getString("timeErrMsg")%>";
var numErrMsg = "<%=rbsearch.getString("numErrMsg")%>";
var daysLabel = "<%=rbsearch.getString("days")%>";
var memLabel = "<%=rbsearch.getString("MB")%>";
var swfwErrMsg = "<%=rbsearch.getString("swfwErrMsg")%>";
var hierErrMsg = "<%=rbsearch.getString("hierErrMsg")%>";
var blankNameErrMsg = "<%=rbsearch.getString("blankNameErrMsg")%>";
var listNameDupErrMsg = "<%=rbsearch.getString("listNameExistsErrMsg")%>";
var listNameInvalidErrMsg = "<%=rbsearch.getString("listNameInvalidErrMsg")%>";
var blankSelectErrMsg = "<%=rbsearch.getString("blankSelectErrMsg")%>";
var blankInputErrMsg = "<%=rbsearch.getString("blankInputErrMsg")%>";
var invalidValueStringMsg = "<%=rbsearch.getString("invalidValueStringMsg")%>";
var invalidWhiteSpaceMsg = "<%=rbsearch.getString("invalidWhiteSpaceMsg")%>";
var invalidValueErrMsgA = "<%=rbsearch.getString("invalidValueErrMsgA")%>";
var invalidValueErrMsgB = "<%=rbsearch.getString("invalidValueErrMsgB")%>";
var VCServerNotConnectedErr = "<%=rbsearch.getString("VCServerNotConnectedErrMsg")%>";
var invalidAllSystemsErrMsg = "<%=rbsearch.getString("invalidAllSystemsErrMsg")%>";
var invalidAllEventsErrMsg = "<%=rbsearch.getString("invalidAllEventsErrMsg")%>";
var invalidAllClustersErrMsg = "<%=rbsearch.getString("invalidAllClustersErrMsg")%>";
var badAOECriteriaErrMsg = "<%=rbsearch.getString("badAOECriteriaErrMsg")%>";
var tooManyAOECriteriaErrMsg = "<%=rbsearch.getString("tooManyAOECriteriaErrMsg")%>";
var tooManyEventCriteriaErrMsg = "<%=rbsearch.getString("tooManyEventCriteriaErrMsg")%>";
var dupEventCritErrMsg = "<%=rbsearch.getString("dupEventCritErrMsg")%>";
var isPreInstalledListWarning = "<%=rbsearch.getString("isPreInstalledListWarning")%>";

/*******************************************************************
// Define the various value format inner HTML
//
// These are used when the inner html of the value table cells
// are changed to accomodate the various criteria value formats
*******************************************************************/
var StringValHTML = "<input type='TEXT' name='stringVal' id='stringVal' maxlength='90' style='width:150px' onChange='clearWorkSpace()'>";
var NumericValHTML = "<input type='TEXT' name='numVal' id='numVal' style='width:50px' value='32' onBlur='checkNumeric(this)' maxlength='10'> " + memLabel;
var NumericRangeValHTML = NumericValHTML + "&nbsp;&nbsp;" + sAnd + "&nbsp;&nbsp;" + NumericValHTML;
var IPValHTML = "<input type='text' name='oct1' id='oct1' style='width:30px' maxlength='3' value='0' onBlur='checkIPOctet(this, 0)'>."
                    + "<input type='text' name='oct2' id='oct2' style='width:30px' maxlength='3' value='0' onBlur='checkIPOctet(this, 1)'>."
                    + "<input type='text' name='oct3' id='oct3' style='width:30px' maxlength='3' value='0' onBlur='checkIPOctet(this, 2)'>."
                    + "<input type='text' name='oct4' id='oct4' style='width:30px' maxlength='3' value='1' onBlur='checkIPOctet(this, 3)'>";
var TimeValHTML = "<input type='text' name='date' id='date' style='width:70px' maxlength='15' value='"
                    + todaysDate + "' onBlur='checkDate(this)' onFocus='setButtons(\"disabled\")' onClick='setButtons(\"disabled\")'>"
                    + "&nbsp;<input type='text' name='time' id='time' style='width:50px' maxlength='15' value='"
                    + currentTime + "' onBlur='checkTime(this)' onFocus='setButtons(\"disabled\")' onClick='setButtons(\"disabled\")'>"
                    + ampmHTML + " " + timeZone;
var TimeTomorrowValHTML = "<input type='text' name='date' id='date' style='width:70px' maxlength='20' value='"
                    + tomorrowsDate + "' onBlur='checkDate(this)' onClick='setButtons(\"disabled\")'>"
                    + "&nbsp;<input type='text' name='time' id='time' style='width:50px' maxlength='5' value='"
                    + currentTime + "' onBlur='checkTime(this)' onClick='setButtons(\"disabled\")'>"
                    + ampmHTML + " " + timeZone;
var TimeRangeValHTML = TimeValHTML + "&nbsp;&nbsp;" + sAnd + "<br>" + TimeTomorrowValHTML;
var IPRangeValHTML = IPValHTML + "&nbsp;&nbsp;" + sAnd + "<br>" + IPValHTML;
var DaysValHTML = "<input type='text' name='days' id='days' style='width:40px' maxlength='4' value='1' onBlur='checkNumeric(this)'>&nbsp;"
                    + daysLabel;
var SelectHTML = "<select name='value' id='value' style='width:200px' onMouseOver='autoSizeBox(this)' onBlur='fixSizeBox(this)' onChange='checkIsNotAll(getFirstChildOfType(this.parentNode.previousSibling.previousSibling, \"SELECT\"), getFirstChildOfType(this.parentNode.previousSibling, \"SELECT\") ,this.parentNode, \"false\")'></select>";

/*******************************************************************
// Declare globals for retrieving hierarchical HTML from the server
*******************************************************************/
var oHierSpanToUpdate;
var swfwSelectErr = false;
var hierSelectErr = false;
var blankSelectErr = false;
var blankInputErr = false;
var invalidInputErr = false;
var invalidAllErr = false;
var invalidWhiteSpaceErr = false;
var invalidNumErr = false;
var invalidIPErr = false;
var ipMaxErr = false;
var ipMinErr = false;
var invalidTimeErr = false;

/*******************************************************************
// Declare globals for error checking the time input on the server
*******************************************************************/
var oTimeInputToCheck;
var oDateInputToCheck;
var oValueInputToCheck;

/*******************************************************************
// Declare global for sizing frame width when loaded in customize
*******************************************************************/
var currentWidth = 0;
var currentIframe;

/*******************************************************************
// Declare global for storing the value of a criteria box
// in case a duplicate event type box is selected
*******************************************************************/
var clickedCriteriaValue;

////////////////////////////////////////////////////////////////////
// Page loading and management functions
////////////////////////////////////////////////////////////////////

/*******************************************************************
// onLoad handler for search pages
*******************************************************************/
function onSearchLoad()
{
    // Execute the initialization function loaded by the search bean
    init();

    // Resize the iframe in which the page is loaded to eliminated dual
    // scroll bars
    resizeWidth(20);
    resizeFrame(50);

    // Load the initial width for width calculation in the customize UI
    // in order to eliminated dual horizontal scroll bars
    currentWidth = document.getElementById("searchDiv").offsetWidth;

    // Hide the loading message
    if (edit != "null" && parent.hideLoadingMsg != null)
        parent.hideLoadingMsg();

    // If loaded in the customize UI, focus on the buttons to jump the
    // screen scroll and bring the search UI into full view
    if (inframe == "customize")
        initFocus();
}

/*******************************************************************
// Scrolls the right side of the portal to bring the search page
// into full view
*******************************************************************/
function initFocus()
{
    // Look for a blank name, and initialize the buttons accordingly
    if (edit == "customize")
        checkBlankName();

    // Focus on the cancel button to scroll the search page into view
    document.getElementById("cancel_button").focus();

    // Blur from the button to avoid accidental cancel
    document.getElementById("cancel_button").blur();

    // The disable cycling of the save as button is here only for
    // an IE problem with dual focus in the frame and parent page.
    setOKButton("disabled");
    setOKButton("enabled");
}

/*******************************************************************
// Returns the available height in the results iframe
*******************************************************************/
function getAvailableHeight()
{
    // Get the total height
    var workspaceHeight = Math.max(0, MxDomGetBodyHeight());

    // Subtract the search html height
    var criteriaDivHeight = document.getElementById("criteriaDiv").offsetHeight;

    // We reserve the right to fudge
    var fudgeHeight = 30;

    var availableHeight = workspaceHeight - criteriaDivHeight - fudgeHeight;
    return availableHeight;
}

/*******************************************************************
// Returns the available width in the results iframe
*******************************************************************/
function getAvailableWidth()
{
    // Get the total height
    var workspaceWidth = Math.max(0, MxBrowserGetBodyWidth(0, 0));

    // Just return this value, since there is no width taken up by
    // the search div
    var searchDivWidth = 0;

    // We reserve the right to fudge
    var fudgeWidth = 50;

    var availableWidth = workspaceWidth - searchDivWidth - fudgeWidth;
    return availableWidth;
}

/*******************************************************************
// Resizes the iframe height of the results iframe
*******************************************************************/
function setIframeHeight(height)
{
    document.getElementById("resultSpace").style.height = height;
}

/*******************************************************************
// Resizes the iframe width of the results iframe
*******************************************************************/
function setIframeWidth(width)
{
    document.getElementById("resultSpace").style.width = width;
}

/*******************************************************************
// Resizes the iframe height the search page is loaded into,
// if we're in the customize UI
*******************************************************************/
function resizeFrame(offset)
{
    if (inframe == "customize" || inframe == "events" || inframe == "systems")
    {
        var oSelf = parent.document.getElementById("operationSpace");
        if (inframe == "events" || inframe =="systems")
        {
            oSelf = parent.document.getElementById("resultSpace");
            if (parent.resizeSearchFrame != null)
                 parent.resizeSearchFrame();
        }
        var h = document.getElementById("searchDiv").offsetHeight;
        oSelf.style.height = h + offset;
    }
    if (inframe != "customize" && inframe != "events" && inframe != "systems")
    {
        // Now resize the iframe if we're not in the customize or alerts page
        if (currentIframe == "view")
        {
            setIframeHeight(Math.max(300, getAvailableHeight()));
            setIframeWidth(Math.max(0, getAvailableWidth()));
        }
    }
}

/*******************************************************************
// Resizes the iframe width the search page is loaded into,
// if we're in the customize UI
*******************************************************************/
function resizeWidth(offset)
{
    if (inframe == "customize" || inframe == "events" || inframe == "systems")
    {
        if (inframe == "events" || inframe == "systems")
        {
            var oSelf = parent.document.getElementById("resultSpace");

            if (parent.resizeSearchFrame != null)
                parent.resizeSearchFrame();

            var w = document.getElementById("searchDiv").offsetWidth;
            oSelf.style.width = w + offset;
        }
        else
        {
            parent.setMinWidth(document.getElementById("tabCriteria").offsetWidth);
        }
    }
}

/*******************************************************************
// Checks for any auto-sized SELECT fields
*******************************************************************/
function anyAutoSized()
{
    var oSelectors = document.getElementsByTagName("select");
    for (var i = 0; i < oSelectors.length; i++)
    {
        var oSelect = oSelectors.item(i);
        if (oSelect.offsetWidth > 200)
            return true;
    }

    return false;
}

/*******************************************************************
// Resets the iframe width the search page is loaded into to it's
// original width, if we're in the customize UI
*******************************************************************/
function resetWidth()
{
    if (inframe == "customize" || inframe == "events" || inframe == "systems")
    {
        if (anyAutoSized())
            return;

        if (inframe == "events" || inframe == "systems")
        {
            var oSelf         = parent.document.getElementById("resultSpace");
            oSelf.style.width = Math.max(parent.document.body.offsetWidth, currentWidth);
        }
        else
        {
            parent.setMinWidth(document.getElementById("tabCriteria").offsetWidth);
        }
    }
}

/*******************************************************************
// Validates the list name for an edit operation
// Proceeds to call submitSaveForm if successful
*******************************************************************/
function checkAndSubmit(type, bIsPreInstalledList)
{
    // If this is a pre-installed list, pop-up a warning
    if (bIsPreInstalledList)
    {
        if (!confirm(isPreInstalledListWarning))
            return;
    }

    // Get the list name
    var listName = document.getElementById("name").value;

    // Double check the blank name
    if (listName == "" || trim(listName) == "")
    {
        alert(blankNameErrMsg);
        return;
    }

    // Check to see if it is a valid list name
    // The validation function is found in utilities.js
    // This function mirrors the java class
    if (!isValidListName(listName))
       alert(listNameInvalidErrMsg);
    else
    {
        if (listName != queryName)
        {
            var baseURL = "CheckListName.jsp";
            verifyNames(listName, baseURL, type);
        }
        else
            submitSaveForm(type);
    }
}

/*******************************************************************
// Verifies list name for save edit operation
// The category parameter is ignored for this operation, and is
// included because the same name checking is used for the save
// operations
*******************************************************************/
function verifyNames(listName, baseURL, type)
{
    var encodedListName = encodeURIComponent(listName);
    var URL = baseURL + "?listName=" + encodedListName;
    URL += "&type=" + type;

    document.getElementById("HierCommSpace").contentWindow.document.location.replace(URL);
}

/*******************************************************************
// Collapses the edit page when the cancel button is pushed
*******************************************************************/
function closeSave()
{
    parent.setHelpTopics();

    if (inframe == "customize")
    {
        parent.clearSubwindow();
    }

    document.location.replace("blank.html");
}

function clearWorkSpace()
{
    if (inframe != "events" && inframe != "systems")
        setOKButton("enabled");
    var oResultSpace = document.getElementById("resultSpace");
    var oButton = document.getElementById("go_button");

    if (oResultSpace.offsetHeight != 1 && oButton != null)
    {
        if (oButton.disabled != true)
        {
            oButton.focus();
            oButton.blur();
        }
        oResultSpace.contentWindow.document.location.replace("blank.html");
        oResultSpace.style.height = 1;
    }
}

function hideResultSpace()
{
    currentIframe = "none";
    document.getElementById("resultSpace").src = "blank.html";
    document.getElementById("resultSpace").style.height = 1;
}

function showResultSpace()
{
    document.getElementById("resultSpace").style.height = 350;
}

function setOKButton(state)
{
    oButton = document.getElementById("ok_button");
    if (oButton != null)
    {
        if (state == "enabled")
        {
            ourButtonManager.enableButton(oButton);
        }
        else
        {
            ourButtonManager.disableButton(oButton);
        }
    }
}

function setButtons(state)
{
    oOKButton = document.getElementById("ok_button");
    oGoButton = document.getElementById("go_button");

    if (oOKButton != null)
    {
        if (state == "enabled")
        {
            ourButtonManager.enableButton(oOKButton);
        }
        else
        {
            ourButtonManager.disableButton(oOKButton);
        }
    }

    if (oGoButton != null)
    {
        if (state == "enabled")
        {
            ourButtonManager.enableButton(oGoButton);
        }
        else
        {
            ourButtonManager.disableButton(oGoButton);
        }
    }
}

function prepCriteria(type)
{
    // Sort and load the criteria
    sortTable(document.getElementById("tabCriteria"));
    checkJoins();
    loadCriteria();

    // See if any error flags were tripped
    var bOK = true;
    if (swfwSelectErr == true)
    {
        alert(swfwErrMsg);
        bOK = false;
    }
    if (hierSelectErr == true)
    {
        alert(hierErrMsg);
        bOK = false;
    }
    if (blankSelectErr == true)
    {
        alert(blankSelectErrMsg);
        bOK = false;
    }
    if (blankInputErr == true)
    {
        alert(blankInputErrMsg);
        bOK = false;
    }
    if (invalidInputErr == true)
    {
        alert(invalidValueStringMsg);
        bOK = false;
    }
    if (invalidAllErr == true)
    {
        if (type == "System")
            alert(invalidAllSystemsErrMsg);
        else if (type == "Event")
            alert(invalidAllEventsErrMsg);
        else if (type == "Cluster")
            alert(invalidAllClustersErrMsg);
        bOK = false;
    }
    if (invalidWhiteSpaceErr == true)
    {
        alert(invalidWhiteSpaceMsg);
        bOK = false;
    }
    if (invalidNumErr == true || invalidIPErr == true || ipMaxErr == true || ipMinErr == true)
        bOK = false;

    // Clear the error flags
    swfwSelectErr = false;
    hierSelectErr = false;
    blankSelectErr = false;
    blankInputErr = false;
    invalidInputErr = false;
    invalidAllErr = false;
    invalidWhiteSpaceErr = false;
    invalidNumErr = false;
    invalidIPErr = false;
    ipMaxErr = false;
    ipMinErr = false;

    // Return the error state
    return bOK;
}

function loadResults(type)
{
    // Set the global current iframe variable
    currentIframe = "view";

    var bOK = prepCriteria(type);
    if (bOK == true)
    {
        //showResultSpace();
        var oForm = document.getElementById("SearchForm");
        oForm.action = "Run" + type + "Search.jsp";
        oForm.submit();
    }
    resizeFrame(50);
}

function submitSaveForm(type)
{
    loadSave(type);
}

function loadSave(type)
{
    // Set the global current iframe variable
    currentIframe = "save";

    // Disable the OK button
    setOKButton("disabled");

    var bOK = prepCriteria(type);
    if (bOK == true)
    {
        var oForm = document.getElementById("SearchForm");
        if (edit == "customize")
        {
            resizeFrame(50);
            var encodedName = encodeURIComponent(document.getElementById("name").value);
            oForm.action = "DoSaveEdit" + type + "Search.jsp?name=" + encodedName + "&queryId=" + queryId;
        }
        else
        {
            oForm.action = "Save" + type + "Search.jsp";
            if (inframe != "null")
                oForm.action += "?inframe=" + inframe;
        }
        oForm.submit();
    }
    else
        setOKButton("enabled");
}

function loadActionOnEventsCriteria(type)
{
    var bOK = prepCriteria(type);
    var sType;

    if (type == "Event")
        sType = "events";
    else
        sType = "systems";

    if (bOK == true)
    {
        var oForm = document.getElementById("SearchForm");

        // Add the hidden field to signal adding systems criteria to the events for
        // Action on events
        var oInput;
        oInput = document.createElement("INPUT");
        oInput.type = "HIDDEN";
        oInput.name = "inframe";
        oInput.value = sType;
        oForm.appendChild(oInput);
        oForm.action = "LoadActionOnEventsCriteria.jsp";
        oForm.submit();
    }

    return bOK;
}

///////////////////////////////////////////////////////////////////////
// Utility functions
///////////////////////////////////////////////////////////////////////
function trim(strText)
{
    while (strText.substring(0,1) == ' ')
        strText = strText.substring(1, strText.length);

    while (strText.substring(strText.length-1,strText.length) == ' ')
        strText = strText.substring(0, strText.length-1);

   return strText;
}

function getFirstChildOfType(obj, szTag)
{
    var childrenByTags = obj.getElementsByTagName(szTag);
    if (childrenByTags != null && childrenByTags.length > 0)
        return childrenByTags.item(0);

    return null;
}

function getFirstParentOfType(obj, szTag)
{
    if (obj == null)
        return null;
    var nextParent = obj.parentNode;
    while (nextParent != null)
    {
        if (nextParent.tagName == szTag)
            return nextParent;
        nextParent = nextParent.parentNode;
    }

    return null;
}

function getNextSiblingOfType(obj, szTag)
{
    if (obj == null)
        return null;
    var nextSib = obj.nextSibling;
    while (nextSib != null)
    {
        if (nextSib.tagName == szTag)
            return nextSib;
        nextSib = nextSib.nextSibling
    }

    return null;
}

function getPreviousSiblingOfType(obj, szTag)
{
    if (obj == null)
        return null;
    var prevSib = obj.previousSibling;
    while (prevSib != null)
    {
        if (prevSib.tagName == szTag)
            return prevSib;
        prevSib = prevSib.previousSibling
    }

    return null;
}

function stripZeros(num)
{
    while (num.charAt(0) == "0")
    {
        newTerm = num.substring(1, num.length);
        num = newTerm;
    }
    if (num == "")
    num = "0";
    return num;
}

function setSelectOption(oSelectBox, value)
{
    var selCnt = oSelectBox.length;
    var optCnt = 0;
    for (optCnt = 0; optCnt < selCnt; optCnt++)
    {
        if (oSelectBox.options[optCnt].text == value)
            oSelectBox.options[optCnt].selected = true;
        else
            oSelectBox.options[optCnt].selected = false;
    }
}

function setSelectOptionById(oSelectBox, id)
{
    var selCnt = oSelectBox.length;
    var optCnt = 0;
    for (optCnt = 0; optCnt < selCnt; optCnt++)
    {
        if (oSelectBox.options[optCnt].id == id)
            oSelectBox.options[optCnt].selected = true;
        else
            oSelectBox.options[optCnt].selected = false;
    }
}

function setOptionsList(hierOptHTML, isLeaf, sSetTag)
{
    oHierSpanToUpdate.innerHTML = hierOptHTML;
    if (isLeaf == false)
    {
        oParentRow = oHierSpanToUpdate.parentNode.parentNode;
        oNextRow = oParentRow.nextSibling;
        while(oNextRow != null)
        {
            oNextCell = oNextRow.lastChild;
            oNextValueSelect = oNextCell.lastChild;
            if (oNextValueSelect.id != "subCrit") oNextValueSelect = oNextValueSelect.nextSibling;
            oNextValueSelect.innerHTML = "<select style='width:200px'></select>";
            oNextRow = oNextRow.nextSibling;
        }
    }
    if (sSetTag != null && sSetTag != "")
        setSelectOptionById(oHierSpanToUpdate.firstChild, sSetTag);
}

function storeClickedCriteria(oSelectBox)
{
    if (oSelectBox == null)
        return;
    clickedCriteriaValue = oSelectBox.options[oSelectBox.selectedIndex].text;
}

function checkForDuplicateET(oCritBox)
{
    var critValue = oCritBox.options[oCritBox.selectedIndex].id;
    if (critValue == "CriteriaByEventType")
    {
        if (document.getElementById("ID_EVENT_TYPE_INCLUDE_FRAME") != null ||
            document.getElementById("ID_EVENT_TYPE_EXCLUDE_FRAME") != null)
            return true;
    }
    return false;
}

function checkForDuplicateIncludeET(oCritBox)
{
    var critValue = oCritBox.options[oCritBox.selectedIndex].id;
    if (critValue == "CriteriaByEventType")
    {
        if (document.getElementById("ID_EVENT_TYPE_INCLUDE_FRAME") != null)
            return true;
    }
    return false;
}

function checkForDuplicateExcludeET(oCritBox)
{
    var critValue = oCritBox.options[oCritBox.selectedIndex].id;

    if (critValue == "CriteriaByEventType")
    {
        if (document.getElementById("ID_EVENT_TYPE_EXCLUDE_FRAME") != null)
            return true;
    }
    return false;
}

///////////////////////////////////////////////////////////////////////
// Error checking and input sizing functions
///////////////////////////////////////////////////////////////////////
function autoSizeBox(oSelectBox)
{
    var bNodeListOpen = false;
    if (document.getElementById("resultSpace").offsetHeight > 1 &&
        document.getElementById("resultSpace").contentWindow.document.getElementById("cancel_button") == null)
        bNodeListOpen = true;
    // If a select box becomes active, see if it has been sized already
    if (oSelectBox.style.width != "auto" &&
        oSelectBox.offsetWidth < 201)// && !bNodeListOpen)
    {
        // Set the width to auto
        oSelectBox.style.width = "auto";

        // If the width is narrower, go to a standard width plus on pixel
        // This way, we know whether it is already active if we mouse over again
        // Mainly to address varying event handling in Redhat 8.0
        if (oSelectBox.offsetWidth < 200)
           oSelectBox.style.width = "201px";
        resizeWidth(20);
        oSelectBox.focus();
    }
}

function fixSizeBox(oSelectBox)
{
    var bNodeListOpen = false;
    if (document.getElementById("resultSpace").offsetHeight > 1 &&
        document.getElementById("resultSpace").contentWindow.document.getElementById("ID_PRINT_BUTTON") != null)
        bNodeListOpen = true;

    // If the width is greater than 200px, we know it has been active, and
    // we need to close it
    if (oSelectBox.offsetWidth > 200)// && !bNodeListOpen)
    {
        var xPos = document.body.scrollLeft;
        if (inframe == "customize")
            xPos = parent.document.body.scrollLeft;
        if (xPos != 0 && inframe != "events" && inframe != "systems")
        {
            document.getElementById("go_button").focus();
            document.getElementById("go_button").blur();
        }
        oSelectBox.style.width = "200px";
        resetWidth();
    }
}

function updateCurrentWidth()
{
    currentWidth = document.getElementById("searchDiv").offsetWidth;
}

function checkBlankName()
{
    if (trim(document.getElementById("name").value) == "")
        setOKButton("disabled");
    else
        setOKButton("enabled");
}

function checkNumeric(oNum)
{
    clearWorkSpace();
    var numVal = oNum.value;
    numVal = stripZeros(numVal);

    if (isNaN(numVal))
    {
        alert (numErrMsg);
        oNum.value = 1;
        oNum.focus();
    }
    else
        oNum.value = numVal;
}

function checkIPOctet(oOct, iOctNo)
{
    clearWorkSpace();

    // Get this octet
    var sIpVal = oOct.value;
    ipVal = stripZeros(sIpVal);

    // Get the full IP this octet is part of
    var sOct0;
    var sOct1;
    var sOct2;
    var sOct3;

    switch (iOctNo)
    {
        case 0:
        {
            sOct0 = oOct.value;
            sOct1 = oOct.nextSibling.nextSibling.value;
            sOct2 = oOct.nextSibling.nextSibling.nextSibling.nextSibling.value;
            sOct3 = oOct.nextSibling.nextSibling.nextSibling.nextSibling.nextSibling.nextSibling.value;
        }
        break;
        case 1:
        {
            sOct0 = oOct.previousSibling.previousSibling.value;
            sOct1 = oOct.value;
            sOct2 = oOct.nextSibling.nextSibling.value;
            sOct3 = oOct.nextSibling.nextSibling.nextSibling.nextSibling.value;
        }
        break;
        case 2:
        {
            sOct0 = oOct.previousSibling.previousSibling.previousSibling.previousSibling.value;
            sOct1 = oOct.previousSibling.previousSibling.value;
            sOct2 = oOct.value;
            sOct3 = oOct.nextSibling.nextSibling.value;
        }
        break;
        case 3:
        {
            sOct0 = oOct.previousSibling.previousSibling.previousSibling.previousSibling.previousSibling.previousSibling.value;;
            sOct1 = oOct.previousSibling.previousSibling.previousSibling.previousSibling.value;
            sOct2 = oOct.previousSibling.previousSibling.value;
            sOct3 = oOct.value;
        }
        break;
        default:
        ;
    }

    var iOct0 = stripZeros(sOct0);
    var iOct1 = stripZeros(sOct1);
    var iOct2 = stripZeros(sOct2);
    var iOct3 = stripZeros(sOct3);

    if (ipVal > 255 || ipVal < 0 || isNaN(ipVal) || sIpVal.indexOf(".") >= 0)
    {
        alert (ipErrMsg);
        oOct.value = 0;
        oOct.focus();
    }
    else if (iOct0 == 255 && iOct1 == 255 && iOct2 == 255 && iOct3 == 255)
    {
        alert (ipMaxErrMsg);
        if (iOctNo == 3)
            oOct.value = 1;
        else
            oOct.value = 0;
    }
    else if (iOct0 == 0 && iOct1 == 0 && iOct2 == 0 && iOct3 == 0)
    {
        alert (ipMinErrMsg);
        if (iOctNo == 3)
            oOct.value = 1;
        else
            oOct.value = 0;
    }
    else
        oOct.value = ipVal;
}

function checkIPOctets(sOct0, sOct1, sOct2, sOct3)
{
    var iOct0 = stripZeros(sOct0);
    var iOct1 = stripZeros(sOct1);
    var iOct2 = stripZeros(sOct2);
    var iOct3 = stripZeros(sOct3);

    if (iOct0 > 255 || iOct0 < 0 || isNaN(iOct0) || iOct0.indexOf(".") >= 0)
    {
        invalidIPErr = true;
    }
    else if (iOct1 > 255 || iOct1 < 0 || isNaN(iOct1) || iOct1.indexOf(".") >= 0)
    {
        invalidIPErr = true;
    }
    else if (iOct2 > 255 || iOct2 < 0 || isNaN(iOct2) || iOct2.indexOf(".") >= 0)
    {
        invalidIPErr = true;
    }
    else if (iOct3 > 255 || iOct3 < 0 || isNaN(iOct3) || iOct3.indexOf(".") >= 0)
    {
        invalidIPErr = true;
    }
    else if (iOct0 == 255 && iOct1 == 255 && iOct2 == 255 && iOct3 == 255)
    {
        ipMaxErr = true;
    }
    else if (iOct0 == 0 && iOct1 == 0 && iOct2 == 0 && iOct3 == 0)
    {
        ipMinErr = true;
    }
}

function checkDate(oDateInput)
{
    clearWorkSpace();
    oDateInputToCheck = oDateInput;
    oTimeInputToCheck = oDateInput.nextSibling.nextSibling;
    oAmpm = oTimeInputToCheck.nextSibling.nextSibling;

    // Disable the inputs until the error checking is complete
    oDateInputToCheck.disabled = true;
    oTimeInputToCheck.disabled = true;
    setOKButton("disabled");

    // Assemble the date/time string for checking
    var sDateTimeString = oDateInput.value + " " + currentTime;
    //if (oAmpm != null) sDateTimeString += " " + oAmpm.options[oAmpm.selectedIndex].text;
    // rQm:256039 (BTS:794)
    // Mikio Kubota 2004/5/10
    if (oAmpm != null && oAmpm.options != null) sDateTimeString += " " + oAmpm.options[oAmpm.selectedIndex].text;
    var sURL = "CheckDateTime.jsp?dateString=" + sDateTimeString;
    document.getElementById("HierCommSpace").contentWindow.document.location.replace(sURL);
}

function checkTime(oTimeInput)
{
    clearWorkSpace();
    oTimeInputToCheck = oTimeInput;
    oDateInputToCheck = oTimeInput.previousSibling.previousSibling;
    oAmpm = oTimeInputToCheck.nextSibling.nextSibling;

    // Disable the inputs until the error checking is complete
    oDateInputToCheck.disabled = true;
    oTimeInputToCheck.disabled = true;

    var sDateTimeString = todaysDate + " " + oTimeInput.value;
    //if (oAmpm != null) sDateTimeString += " " + oAmpm.options[oAmpm.selectedIndex].text;
    // rQm:256039 (BTS:794)
    // Mikio Kubota 2004/5/17
    if (oAmpm != null && oAmpm.options != null) sDateTimeString += " " + oAmpm.options[oAmpm.selectedIndex].text;
    var sURL = "CheckDateTime.jsp?timeString=" + sDateTimeString;
    document.getElementById("HierCommSpace").contentWindow.document.location.replace(sURL);
}

function checkValueString(string)
{
    if (!isValidSearchString(string) && string != "")
        alert(invalidValueStringMsg);
}

function checkListName(string)
{
    if (!isValidListName(string) && string != "")
        alert(listNameInvalidErrMsg);
}

function throwDateTimeErr(bOK, type)
{
    oDateInputToCheck.disabled = false;
    oTimeInputToCheck.disabled = false;
    if (!bOK)
    {
        if (type == "time")
        {
            alert(timeErrMsg);
            oTimeInputToCheck.value = currentTime;
            oTimeInputToCheck.focus();
        }
        else if (type == "date")
        {
            alert(dateErrMsg);
            oDateInputToCheck.value = todaysDate;
            oDateInputToCheck.focus();
        }
    }
}

function throwInvalidValueMessage(value)
{
    var errMsg = invalidValueErrMsgA + value + invalidValueErrMsgB;
    alert(errMsg);
}

function throwBadAOECriteriaMessage()
{
    alert(badAOECriteriaErrMsg);
}

function throwMaxCriteriaErrMsg(sMsgType)
{
    if (sMsgType == "list")
        alert(tooManyEventCriteriaErrMsg);
    else
        alert(tooManyAOECriteriaErrMsg);
}

function throwDuplicateETError()
{
    alert(dupEventCritErrMsg);
}

function addInvalidValueToValueBox(oRow, sValue)
{
    var oValBox = oRow.firstChild.nextSibling.nextSibling.nextSibling.firstChild;
    var oInvalidOption = document.createElement("OPTION");
    oInvalidOption.text = sValue;
    oInvalidOption.innerHTML = sValue;
    oInvalidOption.value = -1;
    oValBox.appendChild(oInvalidOption);
    oInvalidOption.selected = true;
    oValBox.insertBefore(oInvalidOption, oValBox.options[0]);
}

function checkVCStatus()
{
    if (isVCRepositoryConnected == false)
        alert(VCServerNotConnectedErr);
}

///////////////////////////////////////////////////////////////////////
// Functions for managing criteria table and cells
///////////////////////////////////////////////////////////////////////
function extractValue(oValCell)
{
    var sValue = "";
    var oValBox = getFirstChildOfType(oValCell, "SELECT");
    var oValText = getFirstChildOfType(oValCell, "INPUT");
    if (oValBox != null && oValBox.id != "ampm")
    {
        // The value box might be present as part of date/time
        // but the am/pm box may not be there depending on locale
        // So the date time case is handled in the next block
        if (oValBox.length > 0)
            sValue = oValBox.options[oValBox.selectedIndex].text;
        else
            blankSelectErr = true;
    }
    else if (oValText != null)
    {
        if (oValText.id == "stringVal")
        {
            sValue = oValText.value;
            if (sValue == "")
                blankInputErr = true;
            else if (trim(sValue) == "")
                invalidWhiteSpaceErr = true;
            else if (!isValidSearchString(sValue))
                invalidInputErr = true;
        }
        else if (oValText.id == "oct1")
        {
            var oct1 = oValText;
            var oct2 = oValText.nextSibling.nextSibling;
            var oct3 = oct2.nextSibling.nextSibling;
            var oct4 = oct3.nextSibling.nextSibling;
            checkIPOctets(oct1.value, oct2.value, oct3.value, oct4.value);
            sValue = oct1.value + "." + oct2.value + "." + oct3.value + "." + oct4.value;

            // See if this is a range by looking for a second octet
            if (oct4.nextSibling != null)
            {
                var oct5 = oct4.nextSibling.nextSibling.nextSibling;
                var oct6 = oct5.nextSibling.nextSibling;
                var oct7 = oct6.nextSibling.nextSibling;
                var oct8 = oct7.nextSibling.nextSibling;
                checkIPOctets(oct5.value, oct6.value, oct7.value, oct8.value);
                sValue += "-" + oct5.value + "." + oct6.value + "." + oct7.value + "." + oct8.value;
            }
        }
        else if (oValText.id == "date")
        {
            var dateString = oValText.value;
            var timeString = oValText.nextSibling.nextSibling.value;
            sValue = dateString + " " + timeString;
            if (oValBox != null)
            {
                var AMPM = oValBox.options[oValBox.selectedIndex].text;
                sValue += " " + AMPM
            }

            // See if this is a range by looking for a second date/time input
            if (oValBox != null && oValBox.nextSibling.nextSibling != null)
            {
                oValText = oValBox.nextSibling.nextSibling.nextSibling;
                dateString = oValText.value;
                timeString = oValText.nextSibling.nextSibling.value;
                oValBox = oValCell.lastChild.previousSibling;
                AMPM = "";
                if (oValBox != null)
                    AMPM = oValBox.options[oValBox.selectedIndex].text;

                sValue += "-" + dateString + " " + timeString + " " + AMPM;
            }
            else if (oValBox == null && oValText.nextSibling.nextSibling.nextSibling.nextSibling != null)
            {
                oValText = oValText.nextSibling.nextSibling.nextSibling.nextSibling.nextSibling;
                dateString = oValText.value;
                timeString = oValText.nextSibling.nextSibling.value;
                sValue += "-" + dateString + " " + timeString;
            }
        }
        else if (oValText.id == "days")
        {
            sValue = oValText.value;
        }
        else if (oValText.id == "numVal")
        {
            sValue = oValText.value;
            if (isNaN(sValue))
                invalidNumErr = true;

            // See if this is a range
            if (oValText.nextSibling.nextSibling != null)
            {
                if (isNaN(oValText.nextSibling.nextSibling.value))
                    invalidNumErr = true;
                sValue += "-" + oValText.nextSibling.nextSibling.value;
            }
        }
    }
    return sValue;
}

function injectValue(oValCell, sValue, sAmpmMin, sAmpmMax)
{
    var oValBox = getFirstChildOfType(oValCell, "SELECT");
    var oValText = getFirstChildOfType(oValCell, "INPUT");
    if (oValBox != null && oValBox.id != "ampm")
    {
        // The value box might be present as part of date/time
        // but the am/pm box may not be there depending on locale
        // So the date time case is handled in the next block
        setSelectOption(oValBox, sValue);
    }
    else if (oValText != null)
    {
        if (oValText.id == "stringVal")
            oValText.value = sValue;
        else if (oValText.id == "days")
            oValText.value = sValue;
        else if (oValText.id == "numVal")
        {
            var sMemRange = sValue.split("-");
            oValText.value = sMemRange[0];

            // See if this is a range; if so, assign the value to the other box
            if (sMemRange[1] != null)
                oValText.nextSibling.nextSibling.value = sMemRange[1];
        }
        else if (oValText.id == "date")
        {
            var oDateText = oValText;
            var oTimeText = oDateText.nextSibling.nextSibling;
            // #256047 var oAmpmBox = oTimeText.nextSibling.nextSibling;
            // oAmpmBox is null on Japanese environment.
            // there is not AMPM on Japanese env.
            var oAmpmBox;
            if (oValBox != null ) {
                oAmpmBox = oTimeText.nextSibling.nextSibling;
            } else {
                oAmpmBox = null;
            }
            // mikubota

            // Get the first of two date times
            var sDateTimeRange = sValue.split("-");
            var sDateTime = sDateTimeRange[0].split(" ");
            oDateText.value = sDateTime[0];
            oTimeText.value = sDateTime[1];

            // Set the am/pm
            if (oAmpmBox != null && sAmpmMin == "am")
            {
                oAmpmBox.options[0].selected = true;
                oAmpmBox.options[1].selected = false;
            }
            else if (oAmpmBox != null)
            {
                oAmpmBox.options[0].selected = false;
                oAmpmBox.options[1].selected = true;
            }

            // If there's a max range, set it's values
            // #256047
            //if (oAmpmBox.nextSibling.nextSibling != null)
            if (oAmpmBox != null && oAmpmBox.nextSibling.nextSibling != null)
            {
                oDateText = oAmpmBox.nextSibling.nextSibling.nextSibling;
                oTimeText = oDateText.nextSibling.nextSibling;
                oAmpmBox = oTimeText.nextSibling.nextSibling;

                sDateTime = sDateTimeRange[1].split(" ");
                oDateText.value = sDateTime[0];
                oTimeText.value = sDateTime[1];

                // Set the am/pm
                if (oAmpmBox != null && sAmpmMax == "am")
                {
                    oAmpmBox.options[0].selected = true;
                    oAmpmBox.options[1].selected = false;
                }
                else if (oAmpmBox != null)
                {
                    oAmpmBox.options[0].selected = false;
                    oAmpmBox.options[1].selected = true;
                }
            }
        }
        else if (oValText.id == "oct1")
        {
            var oct1 = oValText;
            var oct2 = oValText.nextSibling.nextSibling;
            var oct3 = oct2.nextSibling.nextSibling;
            var oct4 = oct3.nextSibling.nextSibling;

            // Get the first IP if this is a range
            var sRange = sValue.split("-");
            var sParseOcts = sRange[0].split(".");
            oct1.value = sParseOcts[0];
            oct2.value = sParseOcts[1];
            oct3.value = sParseOcts[2];
            oct4.value = sParseOcts[3];

            if (sRange[1] != null)
            {
                // If this is an IP range, fill in the second IP
                var oct5 = oct4.nextSibling.nextSibling.nextSibling;
                var oct6 = oct5.nextSibling.nextSibling;
                var oct7 = oct6.nextSibling.nextSibling;
                var oct8 = oct7.nextSibling.nextSibling;

                sParseOcts = sRange[1].split(".");
                oct5.value = sParseOcts[0];
                oct6.value = sParseOcts[1];
                oct7.value = sParseOcts[2];
                oct8.value = sParseOcts[3];
            }
        }
    }
}

function swapRows(oTableBody, oCurrRow, oNextRow)
{
    oTableBody.removeChild(oNextRow);
    oTableBody.insertBefore(oNextRow, oCurrRow);
}

function copyDateTimeCell(oSrcCell, oDestCell)
{
    // Get the source and destination date time input fields
    var oSrcDateText = getFirstChildOfType(oSrcCell, "INPUT");
    var oSrcTimeText = oSrcDateText.nextSibling.nextSibling;
    var oSrcAmpmBox = oSrcTimeText.nextSibling.nextSibling;

    var oDestDateText = getFirstChildOfType(oDestCell, "INPUT");
    var oDestTimeText = oDestDateText.nextSibling.nextSibling;
    var oDestAmpmBox = oDestTimeText.nextSibling.nextSibling;

    // Copy the values from the source to the destination
    oDestDateText.value = oSrcDateText.value;
    oDestTimeText.value = oSrcTimeText.value;
    if (oSrcAmpmBox != null)
        oDestAmpmBox.selectedIndex = oSrcAmpmBox.selectedIndex;

    // See if this is a range by looking for a second date/time input
    if (oSrcAmpmBox != null && oSrcAmpmBox.nextSibling.nextSibling != null)
    {
        oSrcDateText = oSrcAmpmBox.nextSibling.nextSibling.nextSibling;
        oSrcTimeText = oSrcDateText.nextSibling.nextSibling;
        oSrcAmpmBox = oSrcTimeText.nextSibling.nextSibling;

        oDestDateText = oDestAmpmBox.nextSibling.nextSibling.nextSibling;
        oDestTimeText = oDestDateText.nextSibling.nextSibling;
        oDestAmpmBox = oDestTimeText.nextSibling.nextSibling;

        // Copy the values from the source to the destination
        oDestDateText.value = oSrcDateText.value;
        oDestTimeText.value = oSrcTimeText.value;
        if (oSrcAmpmBox != null)
            oDestAmpmBox.selectedIndex = oSrcAmpmBox.selectedIndex;
    }
    else if (oSrcAmpmBox == null && oSrcDateText.nextSibling.nextSibling.nextSibling.nextSibling != null)
    {
        oSrcDateText = oSrcDateText.nextSibling.nextSibling.nextSibling.nextSibling.nextSibling;
        oSrcTimeText = oSrcDateText.nextSibling.nextSibling;
        oSrcAmpmBox = oSrcTimeText.nextSibling.nextSibling;

        oDestDateText = oDestDateText.nextSibling.nextSibling.nextSibling.nextSibling.nextSibling;
        oDestTimeText = oDestDateText.nextSibling.nextSibling;
        oDestAmpmBox = oDestTimeText.nextSibling.nextSibling;

        // Copy the values from the source to the destination
        oDestDateText.value = oSrcDateText.value;
        oDestTimeText.value = oSrcTimeText.value;
        if (oSrcAmpmBox != null)
            oDestAmpmBox.selectedIndex = oSrcAmpmBox.selectedIndex;
    }
}

function copyHierSelectBoxIndices(oSrcTableBody, oDestTableBody)
{
    // Step through the table cells in bot src and destination table bodies.
    // looking for select boxes, or select boxes in spans. When found, set
    // the selected index of the dest select box to that of the src box.

    // Assume there will be either a single select box in a span, a
    // single select box, or one of each in a given cell
    var oSrcRow = oSrcTableBody.firstChild;
    var oDestRow = oDestTableBody.firstChild;
    var oSrcCell;
    var oDestCell;
    var oSrcBox;
    var oDestBox;
    var oSrcSpan;
    var oDestSpan;
    var i = 0;

    // Iterate through the rows
    while (oDestRow != null && i < 10)
    {
        // The select boxes are in the second cell of a given row
        oSrcCell = oSrcRow.lastChild;
        oDestCell = oDestRow.lastChild;

        // Find the leading select box, if found
        oSrcBox = getFirstChildOfType(oSrcCell, "SELECT");
        oDestBox = getFirstChildOfType(oDestCell, "SELECT");
        if (oSrcBox != null && oDestBox != null)
            oDestBox.selectedIndex = oSrcBox.selectedIndex;

        // Find the leading or trailing span, which contains the select, if found
        oSrcSpan = getFirstChildOfType(oSrcCell, "SPAN");
        oSrcBox = getFirstChildOfType(oSrcSpan, "SELECT");

        oDestSpan = getFirstChildOfType(oDestCell, "SPAN");
        oDestBox = getFirstChildOfType(oDestSpan, "SELECT");
        if (oSrcBox != null && oDestBox != null)
            oDestBox.selectedIndex = oSrcBox.selectedIndex;

        oSrcRow = oSrcRow.nextSibling;
        oDestRow = oDestRow.nextSibling;
        i++;
    }
}

function sortTable(oTable)
{
    // Implement a bubble sort for the table.
    var oTableBody = getFirstChildOfType(oTable, "TBODY");
    var oFirstRow = getFirstChildOfType(oTableBody, "TR");
    var bSwapped = true;
    var bJustSwapped = false;
    var oNextRow;
    var oCurrRow;
    var oDelRow;
    var oHierTableBody;
    var oCurrCompCell;
    var oCurrValCell;
    var oCurrInclCell;
    var oNextCompCell;
    var oNextValCell;
    var oNextInclCell;
    var oCurrCrit;
    var oCurrComp;
    var oCurrIncl;
    var oCurrValBox;
    var oCurrValSelect;
    var oCurrValInput;
    var selectIndex;
    var oNextCrit;
    var oNextComp;
    var oNextIncl;

    // Temporarily get rid of the "where" cell
    oCell = oFirstRow.firstChild;
    oFirstRow.firstChild.id = "critRow";
    oFirstRow.firstChild.innerHTML = sAnd + "&nbsp;";

    // Loop through the table, swapping records, until no swaps occur
    while (bSwapped == true && lines > 1)
    {
        // Set the swapped flag
        bSwapped = false;
        oCurrRow = getFirstChildOfType(oTableBody, "TR");
        oNextRow = oCurrRow.nextSibling;

        // Loop through the table, swapping rows as necessary.
        while (oNextRow.id != "addRow")
        {
            // Proceed to get the selections; get the criteria
            oCurrCrit = oCurrRow.firstChild.nextSibling.firstChild;
            oNextCrit = oNextRow.firstChild.nextSibling.firstChild;

            // Get the selections for the current row comparator
            if (oCurrRow.id == "SWFWCritRow")
            {
                // Get the comp and include value for the SW/FW case
                oHierTableBody = oCurrCrit.nextSibling.firstChild.firstChild;
                oCurrValCell = oHierTableBody.lastChild.lastChild;
                oCurrComp = oCurrValCell.firstChild.firstChild;
                oCurrInclCell = oHierTableBody.lastChild.previousSibling.lastChild;
                oCurrIncl = oCurrInclCell.firstChild;
            }
            else if (oCurrRow.id == "hierCritRow")
            {
                // Get the comp value for the simple hierarchical case
                oHierTableBody = oCurrCrit.nextSibling.firstChild.firstChild;
                oCurrCompCell = oHierTableBody.firstChild.lastChild;
                oCurrComp = oCurrCompCell.firstChild;
            }
            else if (oCurrRow.id =="treeCritRow")
            {
                oCurrComp = getNextSiblingOfType(oCurrCrit, "SELECT");
            }
            else
            {
                // Otherwise, this is a standard row
                oCurrComp = oCurrRow.firstChild.nextSibling.nextSibling.firstChild;
            }

            // Get the selections for the next row's comparator
            if (oNextRow.id == "SWFWCritRow")
            {
                // Get the comp and include value for the SW/FW case
                oHierTableBody = oNextCrit.nextSibling.firstChild.firstChild;
                oNextValCell = oHierTableBody.lastChild.lastChild;
                oNextComp = oNextValCell.firstChild;
                oNextInclCell = oHierTableBody.lastChild.previousSibling.lastChild;
                oNextIncl = oNextInclCell.firstChild;
            }
            else if (oNextRow.id == "hierCritRow")
            {
                // Get the comp value for the simple hierarchical case
                oHierTableBody = oNextCrit.nextSibling.firstChild.firstChild;
                oNextCompCell = oHierTableBody.firstChild.lastChild;
                oNextComp = oNextCompCell.firstChild;
            }
            else if (oNextRow.id =="treeCritRow")
            {
                oNextComp = getNextSiblingOfType(oNextCrit, "SELECT");
            }
            else
            {
                // Otherwise, this is a standard row
                oNextComp = oNextRow.firstChild.nextSibling.nextSibling.firstChild;
            }

            // If the current criteria option is greater than the next one,
            // or the criteria are the same, but comparators are different,
            // or the criteria and comparators are the same, but the criteria
            // are sw/fw, and the include/exclude are different, sort
            // swap the rows
            if ((oCurrCrit.selectedIndex > oNextCrit.selectedIndex) ||
                (oCurrCrit.selectedIndex == oNextCrit.selectedIndex &&
                 oCurrComp.selectedIndex > oNextComp.selectedIndex) ||
                (oCurrRow.id == "SWFWCritRow" &&
                 oCurrCrit.selectedIndex == oNextCrit.selectedIndex &&
                 oCurrIncl.selectedIndex > oNextIncl.selectedIndex))
            {
                if(oCurrCrit.selectedIndex == oNextCrit.selectedIndex
                   && oCurrComp.selectedIndex > oNextComp.selectedIndex
                   && !isExclusion(oCurrComp[oCurrComp.selectedIndex].text))
                {
                    oCurrRow.firstChild.innerHTML = sOr + "&nbsp;";
                }
                else
                {
                    oCurrRow.firstChild.innerHTML = sAnd + "&nbsp;";
                }
                swapRows(oTableBody, oCurrRow, oNextRow);
                bSwapped = true;
                bJustSwapped = true;
            }

            // Move on to the next pair of rows
            if (bJustSwapped)
            {
                oNextRow = oCurrRow.nextSibling;
                bJustSwapped = false;
            }
            else
            {
                oCurrRow = oNextRow;
                oNextRow = oNextRow.nextSibling;
            }
        }
    }

    // Change the first join cell back
    oFirstRow = getFirstChildOfType(oTableBody, "TR");
    oFirstRow.firstChild.id = "where";
    oFirstRow.firstChild.innerHTML = "&nbsp;" + sWhere + "&nbsp;";
}

function checkJoins()
{
    // Iterate through the table and correct "and" and "or" text
    var oTable = document.getElementById("tabCriteria")
    var oTableBody = getFirstChildOfType(oTable, "TBODY");
    var oFirstRow = getFirstChildOfType(oTableBody, "TR");
    var oHierTableBody;
    var oCurrValCell;
    var oCurrRow;
    var oCurrCompCell;
    var oCurrCrit;
    var oCurrInclCell;
    var oCurrIncl;
    var oCurrComp;
    var sCurrCrit;
    var i = 0;
    var isOr = false;

    // Process the first row: get the criteria select box
    oCurrRow = oFirstRow;
    oCurrCrit = oCurrRow.firstChild.nextSibling.firstChild;

    // Find the first criteria name, and put it in a new string array
    var selectedCriteria = new Array(oCurrCrit.options[oCurrCrit.selectedIndex].text);

    // Set the current row to the next row
    oCurrRow = oCurrRow.nextSibling;

    // Loop through the table, checking for join corrections.
    // If the criteria already exists, or the comparator is an exclude, the join should
    // be an 'and', otherwise, it should be an 'or'
    while (oCurrRow != null && oCurrRow.id != "addRow")
    {
        // Proceed to get the selections; get the criteria
        oCurrCrit = oCurrRow.firstChild.nextSibling.firstChild;
        sCurrCrit = oCurrCrit.options[oCurrCrit.selectedIndex].text;

        // See if this criteria has already been selected
        for (i = 0; i < selectedCriteria.length; i++)
        {
            if (selectedCriteria[i] == sCurrCrit)
                isOr = true;
        }

        // If the criteria was not found, add it to the array
        // Otherwise, check the comparator to see if it is an exclude
        if (isOr == false)
            selectedCriteria.push(sCurrCrit);
        else
        {
            // Get the selections for the current row comparator
            if (oCurrRow.id == "SWFWCritRow")
            {
                // Get the comp value for the SW/FW case
                oHierTableBody = oCurrCrit.nextSibling.firstChild.firstChild;
                oCurrValCell = oHierTableBody.lastChild.lastChild;
                oCurrComp = oCurrValCell.firstChild.firstChild;
                oCurrInclCell = oHierTableBody.lastChild.previousSibling.lastChild;
                oCurrIncl = oCurrInclCell.firstChild;
            }
            else if (oCurrRow.id == "hierCritRow")
            {
                // Get the comp value for the simple hierarchical case
                oHierTableBody = oCurrCrit.nextSibling.firstChild.firstChild;
                oCurrCompCell = oHierTableBody.firstChild.lastChild;
                oCurrComp = oCurrCompCell.firstChild;
            }
            else
            {
                // Otherwise, this is a standard row
                oCurrComp = oCurrRow.firstChild.nextSibling.nextSibling.firstChild;
            }
            // If this is not a sw/fw row, check if the comparator is an exclude
            // If it is, the join text should be an "and"
            // Otherwise, if this is a sw/fw row,
            // make the same test for the include/exclude field.
            if (oCurrRow.id != "SWFWCritRow")
            {
                if (!isExclusion(oCurrComp.options[oCurrComp.selectedIndex].text))
                    isOr = true;
                else
                    isOr = false;
            }
            else
            {
                if (!isExclusion(oCurrIncl.options[oCurrIncl.selectedIndex].text))
                    isOr = true;
                else
                    isOr = false;
            }
        }

        // Set the join cell text as required
        if (isOr == true)
            oCurrRow.firstChild.innerHTML = sOr + "&nbsp;";
        else
            oCurrRow.firstChild.innerHTML = sAnd + "&nbsp;";

        // Move on to the next row
        oCurrRow = oCurrRow.nextSibling;
        isOr = false;
    }
}

function addRow(bIsLoadForEdit, valHtml)
{
    var oRow;
    var oCritCell;
    var oCompCell;
    var oValCell;
    var oDelCell;

    lines++;
    var oTableBody = document.getElementById("tabCriteriaBody");
    var oFirstRow = getFirstChildOfType(oTableBody, "TR");
    var oAddRow = null;

    // Delete the "add" button
    if(oFirstRow)
    {
        oAddRow = oTableBody.lastChild;
        oTableBody.removeChild(oAddRow);
    }
    oNewRow = document.createElement("TR");
    oRow = oTableBody.appendChild(oNewRow);
    oRow.id = "critRow";

    if(lines == 1)
    {
        oNewCell = document.createElement("TD");
        oCell = oRow.appendChild(oNewCell);
        oCell.id = "where";
        oCell.innerHTML = "&nbsp;" + sWhere + "&nbsp;";
        oCell.style.paddingTop = "4px";
        oCell.align = "right";
    }
    else
    {
        oNewCell = document.createElement("TD");
        oCell = oRow.appendChild(oNewCell);
        oCell.id = "and";
        oCell.innerHTML = sAnd + "&nbsp;";
        oCell.style.paddingTop = "4px";
        oCell.align = "right";
        var oFirstDelCell = oFirstRow.lastChild;
        oFirstDelCell.innerHTML = ourButtonManager.makeMxButtonMed('', sDelete, 'javascript:delRow(this.parentNode.parentNode)', true, false, false);
    }

    oNewCell = document.createElement("TD");
    oCritCell = oRow.appendChild(oNewCell);
    oCritCell.id = "criteriaCell";
    oCritCell.innerHTML = InitCriteriaBoxHTML;

    oNewCell = document.createElement("TD");
    oCompCell = oRow.appendChild(oNewCell);
    oCompCell.id = "compCell";
    oCompCell.innerHTML = InitCompBoxHTML;

    oNewCell = document.createElement("TD");
    oValCell = oRow.appendChild(oNewCell);
    oValCell.id = "valueCell";
    if (valHtml == "")
    {
        oValCell.innerHTML = InitValBoxHTML;
    }
    else
    {
        oValCell.innerHTML = InitEmptyValBoxHTML;
        var oValBox = getFirstChildOfType(oValCell, "SELECT");
        oValBox.options[0].text = valHtml;
    }

    if(lines != 1)
    {
        oNewCell = document.createElement("TD");
        oDelCell = oRow.appendChild(oNewCell);
        oDelCell.id = "deleteCell";
        oDelCell.innerHTML = ourButtonManager.makeMxButtonMed('', sDelete, 'javascript:delRow(this.parentNode.parentNode)', true, false, false);
    }
    else
    {
        oNewCell = document.createElement("TD");
        oDelCell = oRow.appendChild(oNewCell);
    }

    // Re-Add the "add" button
    oNewRow = document.createElement("TR");
    oAddRow = oTableBody.appendChild(oNewRow);
    oAddRow.id = "addRow";
    oNewCell = document.createElement("TD");
    oAddRow.appendChild(oNewCell);
    oNewCell = document.createElement("TD");
    oAddRow.appendChild(oNewCell);
    oNewCell = document.createElement("TD");
    oAddRow.appendChild(oNewCell);
    oNewCell = document.createElement("TD");
    oAddRow.appendChild(oNewCell);
    oNewCell = document.createElement("TD");
    var oAddCell = oAddRow.appendChild(oNewCell);
    oAddCell.id = "addCell";
    oAddCell.innerHTML = ourButtonManager.makeMxButtonMed('', sAdd, 'javascript:addRow(false, "")', true, false, false);

    if (!bIsLoadForEdit)
    {
        ourButtonManager.init();
        clearWorkSpace();
        resizeFrame(50);
        checkJoins();
    }

    return oRow;
}

function delRow(oRow)
{
    var oTableBody = document.getElementById("tabCriteriaBody");
    var oFirstRow = getFirstChildOfType(oTableBody, "TR");

    // Delete the row
    oTableBody.removeChild(oRow);
    lines--;

    // Get the new first row
    var oFirstRow = getFirstChildOfType(oTableBody, "TR");

    oWhereCell = oFirstRow.firstChild;
    oWhereCell.innerHTML = "&nbsp;" + sWhere + "&nbsp;";
    oWhereCell.id = "where";
    if(lines == 1)
    {
        var oFirstDelCell;
        if (oFirstRow.id == "critRow")
           oFirstDelCell = oFirstRow.firstChild.nextSibling.nextSibling.nextSibling.nextSibling;
        else
           oFirstDelCell = oFirstRow.firstChild.nextSibling.nextSibling;
        oFirstDelCell.innerHTML = "";
    }

    checkJoins();
    clearWorkSpace();
    resizeFrame(50);
}

function setRowValues(oRow, sCriteria, sComp, sValue, bOr, sAmpmMin, sAmpmMax)
{
    var oCritBox = oRow.firstChild.nextSibling.firstChild;
    var oCompBox;
    var oValCell;
    var oAndOr = oRow.firstChild;

    if (bOr == "true")
        oAndOr.innerHTML = sOr + "&nbsp;"

    setSelectOption(oCritBox, sCriteria);
    oRow = updateCompBox(oCritBox);
    oCompBox = oRow.firstChild.nextSibling.nextSibling.firstChild;
    setSelectOption(oCompBox, sComp);
    updateValueBox(oCompBox);
    oValCell = oRow.firstChild.nextSibling.nextSibling.nextSibling;
    injectValue(oValCell, sValue, sAmpmMin, sAmpmMax);

}

function setRowValuesByIndex(oRow, iCrit, sComp, iValue, bOr)
{
    var oCritBox = oRow.firstChild.nextSibling.firstChild;
    var oCompBox;
    var oValCell;
    var oAndOr = oRow.firstChild;

    if (bOr == "true")
        oAndOr.innerHTML = sOr + "&nbsp;"

    //setSelectOption(oCritBox, sCriteria);
    oCritBox.selectedIndex = iCrit;
    oRow = updateCompBox(oCritBox);
    oCompBox = oRow.firstChild.nextSibling.nextSibling.firstChild;
    setSelectOption(oCompBox, sComp);
    updateValueBox(oCompBox);
    oValCell = oRow.firstChild.nextSibling.nextSibling.nextSibling;
    var oValBox = getFirstChildOfType(oValCell, "SELECT");
    oValBox.selectedIndex = iValue;
}

function setSystemNameValueByIndex(oRow, iValue, bOr)
{
    var oValCell = oRow.firstChild.nextSibling.nextSibling.nextSibling;
    var oValBox = getFirstChildOfType(oValCell, "SELECT");
    var oAndOr = oRow.firstChild;

    if (bOr == "true")
        oAndOr.innerHTML = sOr + "&nbsp;"

    oValBox.selectedIndex = iValue;
}

function getNextSubSelect(oCritBox, sTagId, oNextSpan, isSimple, sType, sSetTag)
{
    oHierSpanToUpdate = oNextSpan;
    var sBaseURL = "";

    // Clear the workspace
    clearWorkSpace();

    if (sType == "systems")
         sBaseURL = "UpdateSysHierSelections.jsp?tagId=";
    else if (sType == "events" && inframe == "events")
         sBaseURL = "UpdateAOEventHierSelections.jsp?tagId=";
    else if (sType == "systems" && inframe == "systems")
         sBaseURL = "UpdateAOEventHierSelections.jsp?tagId=";
    else if (sType == "events" && (inframe == "null" || inframe == "customize"))
         sBaseURL = "UpdateEventHierSelections.jsp?tagId=";
    else if (sType == "clusters")
         sBaseURL = "UpdateClusterHierSelections.jsp?tagId=";
    var isLeaf = "false";
    if (isSimple == "true" && oNextSpan.nextSibling == null)
        isLeaf = "true";
    else if (oNextSpan.parentNode.parentNode.nextSibling == null) isLeaf = "true";
    var selectedCriteria = oCritBox.options[oCritBox.selectedIndex].id;
    var URL = sBaseURL + sTagId + "&selectedCriteria=" + selectedCriteria + "&isLeaf=" + isLeaf;
    if (sSetTag != null && sSetTag != "")
         URL += "&sSetTag=" + sSetTag;

    document.getElementById("HierCommSpace").contentWindow.document.location.replace(URL);
}

function getSWFWSelectBoxHTML(type, criteria, sysTypeTag, OSTag, SWFWTypeTag, SWFWTag)
{
    var sBaseURL = "";
    if (type == "systems")
         sBaseURL = "GetSysHierBoxHTML.jsp?";
    else if (type == "events" && inframe == "events")
         sBaseURL = "GetAOEventHierBoxHTML.jsp?";
    else if (type == "systems" && inframe == "systems")
         sBaseURL = "GetAOEventHierBoxHTML.jsp?";
    else if (type == "events" && (inframe == "null" || inframe == "customize"))
         sBaseURL = "GetEventHierBoxHTML.jsp?";
    else if (type == "clusters")
         sBaseURL = "GetClusterHierBoxHTML.jsp?";
    var URL = sBaseURL + "sysTypeTag=" + sysTypeTag;
    URL += "&criteriaName=" + criteria;
    URL += "&OSTag=" + OSTag;
    URL += "&SWFWTypeTag=" + SWFWTypeTag;
    URL += "&SWFWTag=" + SWFWTag;
    document.getElementById("HierCommSpace").contentWindow.document.location.replace(URL);
}


function setSimpleHierarchicalValues(oRow, sCritDBName, sCriteria, sComp, sSubCritTag, sValTag, sValHTML, isSelect)
{
    var oNewRow = convertToHierarchicalDisplay(oRow, sCritDBName, sCriteria, "false");
    var oCritBox = oNewRow.firstChild.nextSibling.firstChild;
    var oHierTableBody = oCritBox.nextSibling.firstChild.firstChild;
    var oCompBox = oHierTableBody.firstChild.firstChild.nextSibling.firstChild;
    var oSubCritSpan = oHierTableBody.firstChild.lastChild.lastChild;
    var oSubCritBox = oSubCritSpan.firstChild;
    var oValSpan = oHierTableBody.lastChild.lastChild.firstChild;

    setSelectOption(oCompBox, sComp);

    if (isSelect == "true")
    {
        setSelectOptionById(oSubCritBox, sSubCritTag);
        oValSpan.innerHTML = sValHTML;
        setSelectOptionById(oValSpan.firstChild, sValTag);
    }
    else
    {
        oNewRow = updateSubCritValBox(oCritBox, oCompBox);
        oNewRow.firstChild.nextSibling.nextSibling.nextSibling.firstChild.value = sSubCritTag;
    }
}

function setSWFWHierarchicalValues(oRow, sCritDBName, sCriteria, sComp, sIncl,
                                   sVerTag, sAny, sSWFWTag, sVerHTML,
                                   sSWFWTypeTag, sSWFWHTML, sOSTag, sSWFWTypeHTML,
                                   sSysTag, sOSHTML)
{
    // Set the swfw criteria selection, and load the hierarchical display
    var oNewRow = convertToHierarchicalDisplay(oRow, sCritDBName, sCriteria, "true")
    var oCritBox = oNewRow.firstChild.nextSibling.firstChild;
    var oHierTableBody = oCritBox.nextSibling.firstChild.firstChild;

    // Set the comparator and the exclude
    var oValCell = oHierTableBody.lastChild.lastChild;
    oComp = oValCell.firstChild.firstChild;
    setSelectOption(oComp, sComp);

    var oInclCell = oHierTableBody.lastChild.previousSibling.lastChild;
    oIncl = oInclCell.firstChild;
    setSelectOption(oIncl, sIncl);

    // Set the hierarchical levels
    var oSysRow = oHierTableBody.firstChild;
    var oOSRow = oSysRow.nextSibling;
    var oSWFWTypeRow = oOSRow.nextSibling;
    var oSWFWRow = oSWFWTypeRow.nextSibling;
    var oVerRow = oSWFWRow.nextSibling;

    var oSysBox = oSysRow.lastChild.lastChild.firstChild;
    setSelectOptionById(oSysBox, sSysTag);

    // Set the span HTML, and set the tag values
    var oOSSpan = oOSRow.lastChild.lastChild;
    oOSSpan.innerHTML = sOSHTML;
    setSelectOptionById(oOSSpan.firstChild, sOSTag);

    var oSWFWTypeSpan = oSWFWTypeRow.lastChild.lastChild;
    oSWFWTypeSpan.innerHTML = sSWFWTypeHTML;
    setSelectOptionById(oSWFWTypeSpan.firstChild, sSWFWTypeTag);

    var oSWFWSpan = oSWFWRow.lastChild.lastChild;
    oSWFWSpan.innerHTML = sSWFWHTML;
    setSelectOptionById(oSWFWSpan.firstChild, sSWFWTag);

    var oVerSpan = oVerRow.lastChild.lastChild;
    oVerSpan.innerHTML = sVerHTML;
    if (sVerTag != "")
        setSelectOptionById(oVerSpan.firstChild, sVerTag);
}

function convertToHierarchicalDisplay(oRow, sCritSelection, sCriteria, isSWFW)
{
    // Clear the current row contents
    var oTableBody = document.getElementById("tabCriteriaBody");
    var oFirstRow = getFirstChildOfType(oTableBody, "TR");
    var oNewRow = document.createElement("TR");
    if (isSWFW == "true")
        oNewRow.id = "SWFWCritRow";
    else
        oNewRow.id = "hierCritRow";

    if(oRow.rowIndex == 0)
    {
        oNewCell = document.createElement("TD");
        oCell = oNewRow.appendChild(oNewCell);
        oCell.id = "where";
        oCell.innerHTML = "&nbsp;" + sWhere + "&nbsp;";
        oCell.style.paddingTop = "4px";
        oCell.align = "right";
    }
    else
    {
        oNewCell = document.createElement("TD");
        oCell = oNewRow.appendChild(oNewCell);
        oCell.id = "and";
        oCell.innerHTML = sAnd + "&nbsp;";
        oCell.style.paddingTop = "4px";
        oCell.align = "right";
    }

    oNewCell = document.createElement("TD");
    oCritCell = oNewRow.appendChild(oNewCell);
    oCritCell.id = "criteriaCell";
    oCritCell.colSpan = "3";
    oCritCell.innerHTML = InitCriteriaBoxHTML + "<span id='subHierTable' name='subHierTable'>" + getHierCritHTML(sCritSelection) + "</span>";

    // Set the value of the first cell
    var oCritBox = getFirstChildOfType(oCritCell, "SELECT");
    setSelectOption(oCritBox, sCriteria);

    // Add the delete button
    if(lines != 1)
    {
        oNewCell = document.createElement("TD");
        oDelCell = oNewRow.appendChild(oNewCell);
        oDelCell.id = "deleteCell";
        oDelCell.innerHTML = ourButtonManager.makeMxButtonMed('', sDelete, 'javascript:delRow(this.parentNode.parentNode)', true, false, false);
    }
    else
    {
        oNewCell = document.createElement("TD");
        oDelCell = oNewRow.appendChild(oNewCell);
        oDelCell.id = "deleteCell";
    }
    oTableBody.insertBefore(oNewRow, oRow);
    oTableBody.removeChild(oRow);
    resizeFrame(50);
    resizeWidth(20);
    updateCurrentWidth();

    ourButtonManager.init();

    // Recheck the joins
    checkJoins();

    return oNewRow;
}

function convertToNonHierarchicalDisplay(oRow, sCritSelection, sCriteria, isWrapper)
{
    // Clear the current row contents
    var oTableBody = document.getElementById("tabCriteriaBody");
    var oFirstRow = getFirstChildOfType(oTableBody, "TR");
    var oNewRow = document.createElement("TR");
    oNewRow.id = "critRow";

    if(oRow.rowIndex == 0)
    {
        oNewCell = document.createElement("TD");
        oCell = oNewRow.appendChild(oNewCell);
        oCell.id = "where";
        oCell.innerHTML = "&nbsp;" + sWhere + "&nbsp;";
        oCell.style.paddingTop = "4px";
        oCell.align = "right";
    }
    else
    {
        oNewCell = document.createElement("TD");
        oCell = oNewRow.appendChild(oNewCell);
        oCell.id = "and";
        oCell.innerHTML = sAnd + "&nbsp;";
        oCell.style.paddingTop = "4px";
        oCell.align = "right";
    }

    oNewCell = document.createElement("TD");
    oCritCell = oNewRow.appendChild(oNewCell);
    oCritCell.id = "criteriaCell";
    oCritCell.innerHTML = InitCriteriaBoxHTML;

    // Create the new comparator box.
    // If we are converting a display for the wrapper case of a hierachical
    // display, clone the existing comparator box. Otherwise, create a new one.
    oNewCell = document.createElement("TD");
    oCompCell = oNewRow.appendChild(oNewCell);
    oCompCell.id = "compCell";
    if (isWrapper == "true")
    {
        var oOldCritBox = oRow.firstChild.nextSibling.firstChild;
        var oHierTableBody = oOldCritBox.nextSibling.firstChild.firstChild;
        var oOldCompBox = oHierTableBody.firstChild.lastChild.firstChild;
        oCompCell.appendChild(oOldCompBox.cloneNode(true));
        oCompCell.firstChild.selectedIndex = oOldCompBox.selectedIndex;
        oCompBox = oCompCell.firstChild;
        oCompBox.onchange = new Function ("updateSubCritValBox(this.parentNode.previousSibling.firstChild, this)");
    }
    else
    {
        oCompCell.innerHTML = InitCompBoxHTML;
    }

    oNewCell = document.createElement("TD");
    oValCell = oNewRow.appendChild(oNewCell);
    oValCell.id = "valueCell";
    if (isWrapper == "true")
        oValCell.innerHTML = StringValHTML;
    else
        oValCell.innerHTML = InitValBoxHTML;

    if(lines != 1)
    {
        oNewCell = document.createElement("TD");
        oDelCell = oNewRow.appendChild(oNewCell);
        oDelCell.id = "deleteCell";
        oDelCell.innerHTML = ourButtonManager.makeMxButtonMed('', sDelete, 'javascript:delRow(this.parentNode.parentNode)', true, false, false);
    }
    else
    {
        oNewCell = document.createElement("TD");
        oDelCell = oNewRow.appendChild(oNewCell);
        oDelCell.id = "deleteCell";
    }

    // Set the selection to the selected criteria and update the other select boxes
    var oCritBox = getFirstChildOfType(oCritCell, "SELECT");
    setSelectOption(oCritBox, sCriteria);

    if (isWrapper != "true")
        updateCompBox(oCritBox);

    oTableBody.insertBefore(oNewRow, oRow);
    oTableBody.removeChild(oRow);

    resizeFrame(50);
    resizeWidth(20);
    updateCurrentWidth();

    ourButtonManager.init();

    // Recheck the joins
    checkJoins();

    return oNewRow;
}

function convertToTreeDisplay(oRow, sCritSelection, sCriteria, bIsInclude, sComp, bIsEdit)
{
    // Clear the current row contents
    var oTableBody = document.getElementById("tabCriteriaBody");
    var oFirstRow = getFirstChildOfType(oTableBody, "TR");
    var oNewRow = document.createElement("TR");
    var oCell;
    var oNewCell;
    var oCritCell;
    var oCompCell;
    var oValCell;

    oNewRow.id = "treeCritRow";

    // Set the text in front of the criteria row
    if(oRow.rowIndex == 0)
    {
        oNewCell = document.createElement("TD");
        oCell = oNewRow.appendChild(oNewCell);
        oCell.id = "where";
        oCell.innerHTML = "&nbsp;" + sWhere + "&nbsp;";
        oCell.style.paddingTop = "4px";
        oCell.align = "right";
    }
    else
    {
        oNewCell = document.createElement("TD");
        oCell = oNewRow.appendChild(oNewCell);
        oCell.id = "and";
        oCell.innerHTML = sAnd + "&nbsp;";
        oCell.style.paddingTop = "4px";
        oCell.align = "right";
    }

    // Create the criteria select
    oNewCell = document.createElement("TD");
    oCritCell = oNewRow.appendChild(oNewCell);
    oCritCell.id = "criteriaCell";
    oCritCell.colSpan = "3";
    oCritCell.innerHTML = InitCriteriaBoxHTML + "&nbsp;<select name='comparator' id='comparator' onChange='setTreeIframe(this)'></select>";

    // Set the options of the comparator box
    var oCritBox = getFirstChildOfType(oCritCell, "SELECT");
    var oCompBox = getNextSiblingOfType(oCritBox, "SELECT");
    setTreeCompBox(oCompBox, sCritSelection);

    // Set the include if specified
    setSelectOption(oCompBox, sComp);

    var treeSrc = "IncludeETTreeView.jsp";
    var treeFrame = "ID_EVENT_TYPE_INCLUDE_FRAME";
    if (!bIsInclude)
    {
        treeSrc = "ExcludeETTreeView.jsp";
        treeFrame = "ID_EVENT_TYPE_EXCLUDE_FRAME";
    }

    if (bIsEdit)
        treeSrc += "?edit=true";
    if (inframe == "events" && bIsEdit)
        treeSrc += "&inframe=events";
    else if (inframe == "systems" && bIsEdit)
        treeSrc += "&inframe=systems";
    else if (inframe == "events")
        treeSrc += "?inframe=events";
    else if (inframe == "systems")
        treeSrc += "?inframe=systems";
    var treeHTML = "<IFRAME ID='" + treeFrame + "' SRC='" + treeSrc + "' style='padding-top:5px' frameborder=0 height='510' width='400'></IFRAME>";
    oCritCell.innerHTML += "<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" + treeHTML;

    // Set the value of the first cell
    var oCritBox = getFirstChildOfType(oCritCell, "SELECT");
    setSelectOption(oCritBox, sCriteria);
    oCritBox.vAlign ="top";

    // Add the delete button
    if(lines != 1)
    {
        oNewCell = document.createElement("TD");
        oDelCell = oNewRow.appendChild(oNewCell);
        oDelCell.id = "deleteCell";
        oDelCell.innerHTML = ourButtonManager.makeMxButtonMed('', sDelete, 'javascript:delRow(this.parentNode.parentNode)', true, false, false);
    }
    else
    {
        oNewCell = document.createElement("TD");
        oDelCell = oNewRow.appendChild(oNewCell);
        oDelCell.id = "deleteCell";
    }
    oTableBody.insertBefore(oNewRow, oRow);
    oTableBody.removeChild(oRow);
    resizeFrame(50);
    resizeWidth(20);
    updateCurrentWidth();

    ourButtonManager.init();

    // Recheck the joins
    checkJoins();

    return oNewRow;
}

function setTreeIframe(oCompBox)
{
    var sComp = oCompBox.options[oCompBox.selectedIndex].text;
    var oIframe = getNextSiblingOfType(oCompBox, "IFRAME");

    var szId = "ID_EVENT_TYPE_INCLUDE_FRAME";
    var szIframeSrc = "IncludeETTreeView.jsp";

    if (isExclusion(sComp))
    {
        szId = "ID_EVENT_TYPE_EXCLUDE_FRAME";
        szIframeSrc = "ExcludeETTreeView.jsp";
    }
    if (inframe == "events")
        szIframeSrc += "?inframe=events";
    else if (inframe == "systems")
        szIframeSrc += "?inframe=systems";

    oIframe.id = szId;
    oIframe.src = szIframeSrc;
}

function loadCriteria()
{
    // Iterate through the table to create input field objects, and append to
    // the form object.
    // Names are in the form of numbered criteria, comparators, or values.
    // Eg: crit1, comp1, val1, etc.
    // Note that the values being passed are the database object names.
    // Also keep a running count of criteria, and pass this as well.
    var oBody = document.getElementById("searchDiv");
    var oOldForm = document.getElementById("SearchForm");
    var oForm = document.createElement("FORM");
    oForm.target = "resultSpace";
    oForm.id = "SearchForm";
    oForm.name = "SearchForm";
    oForm.method = "POST";
    oBody.insertBefore(oForm, oOldForm);
    oBody.removeChild(oOldForm);

    var iCritCnt = 0;
    var oTableBody = document.getElementById("tabCriteriaBody");
    var oHierTableBody;
    var oCurrRow = getFirstChildOfType(oTableBody, "TR");
    var oCritBox;
    var oCompBox;
    var oInclBox;
    var oValBox;
    var oParentBox;
    var oCompCell;
    var oValCell;
    var oValParentCell;
    var oInput;
    var sCrit;
    var sIncl;
    var sComp;
    var sVal;
    var sParent;

    while (oCurrRow.id != "addRow")
    {
        // The criteria box is in the same place no matter what type
        oCritBox = oCurrRow.firstChild.nextSibling.firstChild;
        if (oCritBox) sCrit = oCritBox.options[oCritBox.selectedIndex].id;
        else sCrit = "";

        // If this is a SW/FW row,
        if ( oCurrRow.id == "SWFWCritRow")
        {
            // First get the table cells where the hierarchical values are stored
            oHierTableBody = oCritBox.nextSibling.firstChild.firstChild;
            oValCell = oHierTableBody.lastChild.lastChild;
            oValParentCell = oHierTableBody.lastChild.previousSibling.lastChild;

            // Use these to get the select boxes
            oCompBox = oValCell.firstChild.firstChild;
            oValBox = oCompBox.parentNode.nextSibling.nextSibling.firstChild;
            oInclBox = oValParentCell.firstChild;
            oParentBox = oInclBox.nextSibling.nextSibling.firstChild;

            // Now extract the values from the selections
            sComp = oCompBox.options[oCompBox.selectedIndex].text;
            if (oValBox.options[0] != null)
                sVal = oValBox.options[oValBox.selectedIndex].id;
            else
            {
                swfwSelectErr = true;
                return;
            }
            sIncl = oInclBox.options[oInclBox.selectedIndex].text;
            if (oParentBox.options[0].value != "")
                sParent = oParentBox.options[oParentBox.selectedIndex].id;
            else
            {
                swfwSelectErr = true;
                return;
            }

            // If the value cell selected is the "any" case, set the value to the parent id
            if (oValBox != null)
            {
                if (oValBox.selectedIndex == 0)
                {
                    sVal = sParent;
                    sComp = "none";
                }
            }
        }
        // Else if this is a hierarchical row,
        else if (oCurrRow.id == "hierCritRow")
        {
            // First get the table cells where the hierarchical values are stored
            oHierTableBody = oCritBox.nextSibling.firstChild.firstChild;
            oCompCell = oHierTableBody.firstChild.lastChild;
            oValCell = oHierTableBody.lastChild.lastChild;
            oValParentCell = oHierTableBody.lastChild.previousSibling.lastChild;

            // Use these to get the select boxes
            oCompBox = oCompCell.firstChild;
            oValBox = oValCell.firstChild.firstChild;
            oParentBox = getFirstChildOfType(oValParentCell.lastChild, "SELECT");
            oParentInput = getFirstChildOfType(oValParentCell.lastChild, "INPUT");

            // Now extract the values from the selections
            sComp = oCompBox.options[oCompBox.selectedIndex].text;

            if (oParentBox != null)
            {
                if (oParentBox.selectedIndex != 0)
                {
                    sParent = oParentBox.options[oParentBox.selectedIndex].id;
                    if (oValBox.options[0] != "")
                    {
                        // If the value cell selected is the "any" case, create an "any" flag
                        // input, and pass back the parent id
                        if (oValBox.selectedIndex == 0)
                            sVal = oParentBox.options[oParentBox.selectedIndex].id;
                        else
                            sVal = oValBox.options[oValBox.selectedIndex].id;
                    }
                    else
                    {
                        hierSelectErr = true;
                        return;
                    }
                }
                else
                {
                    hierSelectErr = true;
                    return;
                }
            }
            else if (oParentInput != null) sParent = oParentInput.value;

            sIncl = "";
            addCriteriaToForm(oForm, iCritCnt, sCrit, sComp, sVal, sIncl);
        }
        // This is a standard row
        else if (oCurrRow.id != "treeCritRow")
        {
            oCompBox = oCurrRow.firstChild.nextSibling.nextSibling.firstChild;
            oValCell = oCurrRow.firstChild.nextSibling.nextSibling.nextSibling;
            oValBox = oValCell.firstChild;

            if (oCompBox)
                sComp = oCompBox.options[oCompBox.selectedIndex].text;
            else
                sComp = "";
            if (oValBox)
                sVal = extractValue(oValCell);
            else
                sVal = "";
            if (oValBox.id == "days")
                sIncl = "days";
            else
                sIncl = "";
        }

        if (sVal == sAnyText && oCurrRow.id != "hierCritRow" && oCurrRow.id != "SWFWCritRow")
        {
            if (lines == 1)
            {
                oInput = document.createElement("INPUT");
                oInput.type = "HIDDEN";
                oInput.value = "true";
                oInput.name = "isAll";
                oForm.appendChild(oInput);
            }
            else
            {
                invalidAllErr = true;
            }
        }
        else if (sVal != sAnyText && oCurrRow.id != "treeCritRow")
        {
            addCriteriaToForm(oForm, iCritCnt, sCrit, sComp, sVal, sIncl);
            iCritCnt++;
        }
        oCurrRow = oCurrRow.nextSibling;
    }

    // Detect the presence of any event type trees and add the input fields
    // to the form
    if (document.getElementById("ID_EVENT_TYPE_INCLUDE_FRAME") != null)
    {
        oInput = document.createElement("INPUT");
        oInput.type = "HIDDEN";
        oInput.value = "true";
        oInput.name = "EventTypeIncludeTree";
        oForm.appendChild(oInput);
    }
    if (document.getElementById("ID_EVENT_TYPE_EXCLUDE_FRAME") != null)
    {
        oInput = document.createElement("INPUT");
        oInput.type = "HIDDEN";
        oInput.value = "true";
        oInput.name = "EventTypeExcludeTree";
        oForm.appendChild(oInput);
    }

    // Add the criteria count input field
    oInput = document.createElement("INPUT");
    oInput.type = "HIDDEN";
    oInput.name = "critCnt";
    oInput.value = iCritCnt;
    oForm.appendChild(oInput);
}

function addCriteriaToForm(oForm, iCritCnt, sCrit, sComp, sVal, sIncl)
{
    oInput = document.createElement("INPUT");
    oInput.type = "HIDDEN";
    oInput.value =sCrit;
    oInput.name = "crit" + iCritCnt;
    oForm.appendChild(oInput);

    oInput = document.createElement("INPUT");
    oInput.type = "HIDDEN";
    oInput.value =sComp;
    oInput.name = "comp" + iCritCnt;
    oForm.appendChild(oInput);

    oInput = document.createElement("INPUT");
    oInput.type = "HIDDEN";
    oInput.value =sVal;
    oInput.name = "val" + iCritCnt;
    oForm.appendChild(oInput);

    oInput = document.createElement("INPUT");
    oInput.type = "HIDDEN";
    oInput.value =sIncl;
    oInput.name = "incl" + iCritCnt;
    oForm.appendChild(oInput);
}
