<%
//
// $Source: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/security/trustedCertificateListDetails.jsp,v $
// $Revision: 1.23 $
// $Date: 2005/05/07 03:20:14 $
//
%>

<%@ page info="Trusted System Certificate Table"%>
<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.utilities.DebugOutput" %>
<%@ page import="com.hp.mx.utilities.DebugSubsystem" %>
<%@ page import="com.hp.mx.core.subjects.MxSubjectPrivilege" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="myTableSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session"/>
<jsp:useBean id="myBean" class="com.hp.mx.portal.security.TrustedCertificateBean" scope="session"/>
<jsp:useBean id="myBundle" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<%!
    /** **********************************************************************
     * The debug object
     ************************************************************************ */
    public DebugSubsystem groupConfigurationDebug =
        DebugOutput.getDebugSubsystem("Keystore");
    public String srcTableDomId = "ID_MY_SRC_CERTIFICATE_TABLE";
%>
<%
    // REQUIRED: This line is required by Tomcat for i18n support.
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    // This aborts the page if the user isn't authorized.
    if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.SECURITY_MODIFICATION_PRIVILEGE))
    {%>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
  <%}

   int status=0;
    // Set up the resource file
    myBundle.init(loginBean, "TrustedCertificate");
    myBean.initBean(out, loginBean, myTableSelectionModel);


  if (request.getMethod().equals("POST"))
    {
        // save the file...
        int returnStatus = myBean.processDetailsPost(request,  out);
        if (returnStatus == 99)
        {
        out.print("<script>alert('"+myBundle.getString("tcert.error.importcert3")+" "+myBundle.getString("tcert.error.importcert4")+"');</script>");
        }

        else if (returnStatus!=0)
        {

        out.print("<script>alert('"+myBundle.getString("tcert.error.importcert2")+"');</script>");
        }
        // need this next line because of bug in Mozilla on Linux and HP-UX
        out.print("<script>top.location.reload();</script>");
}

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();
    buttons.addMxTag(new MxDefaultTag("btnOK", myBundle.getString("tcert.ok.button"), "checkfilename();"));
    buttons.addMxTag(new MxDefaultTag("btnCancel", myBundle.getString("tcert.cancel.button"), "parent.location.href='trustedCertificateList.jsp'"));
%>
<html>
<head>
    <TITLE><%= myBundle.getString("page.tcert.title") %></TITLE>
    <script language="JavaScript" type="text/javascript" src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js"></script>
    <script language='JavaScript' type='text/javascript'>
    MxPortalWorkspaceSetHelpTopic("admin_cert_trusted_import");
    function doUpload()
    {
       document.CertForm.action = "trustedCertificateListDetails.jsp?uploadFile=true";
       document.CertForm.submit();
    }
    function checkfilename()
    {
       var filename = document.CertForm.selectFileBtn.value;
       tempfn = stripLeadingAndTrailingSpaces(filename);
       if ( tempfn.length == 0)
       {
            alert("<%=myBundle.getString("tcert.error.importcert")%>");
            return false;
       }
       doUpload();
    }
    function stripLeadingSpaces(str)
{
    if (str == null)
        return "";

    while (str.charAt(0) == " " && str.length > 0)
        str = str.substring(1, str.length)

    return str;
}


function stripTrailingSpaces(str)
{
    if (str == null)
        return "";

    while (str.charAt(str.length-1) == " " && str.length > 0)
        str = str.substring(0, str.length - 1)

    return str;
}

function stripLeadingAndTrailingSpaces(str)
{
    return stripLeadingSpaces(stripTrailingSpaces(str));
}


    </script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxPortalRender.dumpHeadContent(out); %>
<% buttons.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

    </head>
    <body>
    <hr class="mx-hr">
    <font class='subwindow-header'><%=myBundle.getString("tcert.import.title")%></font>
    <p><%=myBundle.getString("tcert.import.description")%></p>
    <form action="trustedCertificatesListDetails.jsp" method="POST" name="CertForm" ENCTYPE="multipart/form-data" >
    <table border=0 borderColor='#000000'
        marginwidth=0 marginheight=0
        cellPadding=1 cellSpacing=0 width="100%">
    <tr>
    <td align="right">
    <%=myBundle.getString("tcert.import.prompt")%>&nbsp;
    </td>
    <td align="left">
    <input type="file" size="30" style="width:250; height:24" name="selectFileBtn" id="selectFileBtn" >&nbsp;&nbsp;</input>
    <BR>
    </td>
    </tr>
    </table>
    <p>
    <%= myBundle.getString("page.general.instructions") %>
    </p>
    </form>
    <div style="margin-top:15px">
        <% buttons.dumpButtons(out); %>
    </div>

<%  if (request.getMethod().equals("POST"))
    {
        //refresh the table
        out.print(" <script language=\"JavaScript\" type=\"text/javascript\">");
        out.print("parent.location.href=\"trustedCertificateList.jsp\"");
        out.print("</script> ");
    }
%>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</body>
</html>
