<%@ page import="java.util.*" %>
<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.MxLoginBean" %>
<%@ page import="com.hp.mx.portal.ui.MxOptions" %>
<%@ page import="com.hp.mx.portal.ui.MxBean" %>
<%@ page import="com.hp.mx.core.nodegroupmanager.MxNodeGroup" %>
<%@ page import="com.hp.mx.core.objectmodel.MxObjectID"%>
<%@ page import="com.hp.mx.core.subjects.usermanager.MxUser" %>
<%@ page import="com.hp.mx.core.subjects.MxSubjectPrivilege" %>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskWizardInstance"%>


<jsp:useBean id="authUI" class="com.hp.mx.portal.settings.MxAuthUI" scope="session" />
<jsp:useBean id="userUI" class="com.hp.mx.portal.settings.MxUserUI" scope="session" />
<jsp:useBean id="toolboxUI" class="com.hp.mx.portal.settings.MxToolBoxUI" scope="session" />
<jsp:useBean id="nodeUI" class="com.hp.mx.portal.settings.MxNodeUI" scope="session" />
<jsp:useBean id="groupUI" class="com.hp.mx.portal.settings.MxGroupUI" scope="session" />
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="rbsettings" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="taskWizardBean" class="com.hp.mx.portal.taskandjob.MxTaskWizard" scope="session"/>

<%
    // For localization [i18n]
    MxBean.jspInit(request, response);

    // This aborts the page if the session is invalid
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    // Are we adding or deleting a node?
    String objectIdToAdd  = request.getParameter("addObjId");
    String objectIdToRemove  = request.getParameter("deleteObjId");
    if (objectIdToAdd != null)
    {
        // A system/group was checked - add it
        groupUI.addSystemsToAuthorizationSelection(objectIdToAdd);
        return;
    }
    else if (objectIdToRemove != null)
    {
        // A system/group was unchecked - delete it
        groupUI.removeSystemsFromAuthorization(objectIdToRemove);
        return;
    }

    String timeStamp  = request.getParameter("timeStamp");
    MxTaskWizardInstance inst = (MxTaskWizardInstance)taskWizardBean.getInstance(timeStamp);

    // Save the new selections as dynamic queries
    boolean groupMayBeUpdated = groupUI.holdSystemsForAuthorization(loginBean, inst, rbsettings);
    inst.getSelectionBean().clearEverything();  // Clear the slections for potential next time
%>
<html>

<head>
    <title></title>
    <script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
    <script src="/SessionReset.js" language="JavaScript" type="text/javascript"></script>
</head>
<body>
    <div id="group_domContainer" style="overflow: auto; height: 102px; width:300px;display:none;" >
        <select size="5" name="availableNodesOrGroups" style="width:100%" id="group" onChange="setAuthButtons()" multiple>
            <% groupUI.ListCollections(loginBean, out, "", rbsettings.getBundle(), nodeUI.LIST_MODE_OPTIONS); %>
        </select>
    </div>
    <div style="overflow: auto; height: 102px; width:300px;display:block;" class="insetBorder" id="updatedGroupList">
        <% groupUI.ListCollections(loginBean, out, "", rbsettings.getBundle(), nodeUI.LIST_MODE_CHECKBOX); %>
    </div>
    <script language="JAVASCRIPT" type="text/javascript">
        parent.scrollMe(-400);
        parent.document.getElementById("nodeOrGroupList").innerHTML = document.getElementById("updatedGroupList").innerHTML;
        parent.document.getElementById("group_domContainer").innerHTML = document.getElementById("group_domContainer").innerHTML;

        var nodesAndGroups = parent.document.getElementById("nodeOrGroupList");
        if (nodesAndGroups != null)
        {
            <% groupUI.autocheckSystemGroupsAndNodes(out, rbsettings); %>
        }

        var groupMayBeUpdated = <%= groupMayBeUpdated %>;
        if (groupMayBeUpdated)
        {
            alert("<%= rbsettings.getString("auth.updatedGroup") %>");
        }
    </script>
</body>
</html>
