<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.MxLoginBean" %>
<%@ page import="com.hp.mx.portal.ui.MxOptions" %>
<%@ page import="com.hp.mx.portal.ui.MxBean" %>
<%@ page import="com.hp.mx.core.subjects.usermanager.MxUser" %>
<%@ page import="com.hp.mx.core.subjects.MxSubjectPrivilege" %>

<jsp:useBean id="authUI" class="com.hp.mx.portal.settings.MxAuthUI" scope="session" />
<jsp:useBean id="authTableModel" class="com.hp.mx.portal.settings.MxAuthTableModel" scope="session" />
<jsp:useBean id="authSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session" />
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="rbsettings" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="groupUI" class="com.hp.mx.portal.settings.MxGroupUI" scope="session" />

<%  // Set Necessary HTTP header attributes (for localization and caching)
    MxBean.jspInit(request, response);
    if(loginBean.checkLogoutConditionForWebPage(pageContext))
        return;
%>
<%  if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.TOOL_AUTHORIZATION_PRIVILEGE))
    { %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
<%  } %>
<%
    rbsettings.init(loginBean, "MxSettings");
%>

<html>

<head>
<title>Required Field</title>
<link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
<link type='text/css' rel='stylesheet' href='css/MxAuth.css'>
<script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
<script src="/SessionReset.js" language="JavaScript" type="text/javascript"></script>
<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>
</head>

<body>
<%    String cmd = new String(request.getParameter("command"));
    int    doAddRet = 0;
    String addErr   = "false";

    String selectedAuthSrc = request.getParameter("copy_auth_src");
    if(selectedAuthSrc == null)
        selectedAuthSrc = "";

    boolean addMode = false;

    // System.out.println("command = " + cmd);
    if (cmd.equals("add"))
    {
        addMode = true;
        //System.out.println("Calling user auth add method");
        doAddRet = authUI.DoAddAuth(loginBean, request, groupUI);
        if(doAddRet != 0)
        {
            addErr="true";
        }
        else
        {
%>
            <script language="JAVASCRIPT" type="text/javascript">
            MxPortalManageMenuRefresh();
            </script>
<%      }
    }

    if (cmd.equals("delete"))
    {
        //System.out.println("Calling user auth delete method");
        int doDeleteRet = authUI.DoDeleteAuths(loginBean, authSelectionModel, authTableModel);
        if(doDeleteRet != 0)
        {
%>
            <script language="JAVASCRIPT" type="text/javascript">
            alert("<%=rbsettings.getString("auth.deleteerr")%>");
            </script>
<%      }
        else
        {
%>
            <script language="JAVASCRIPT" type="text/javascript">
            MxPortalManageMenuRefresh();
            </script>
<%      }
    }

    // If the apply button was pushed from the add page,
    // load up the field values using the node bean properties
    // and reload the page. Either way, refresh the navigation area
    String applyFlag = request.getParameter("apply");

    if(addErr.equals("true"))
    {
        // PATH: Add error
        %>
        <script language="JAVASCRIPT" type="text/javascript">
            document.location.href = "AuthStart.jsp?addMode=true&error=true&errorCode=<%=doAddRet%>&apply=true&controlPage=AuthServer.jsp&selectedAuthSrc=" + "<%=request.getParameter("selectedAuthSrc") %>";
        </script>
        <%
    }
    else if(applyFlag != null && applyFlag.equals("true"))
    {
        // PATH: Add Apply
        // reset the bean here via jsp:setProperty
        %>
        <jsp:setProperty name="authUI" property="*" />
        <script language="JAVASCRIPT" type="text/javascript">
            document.location.href = "AuthStart.jsp?addMode=true&apply=true&controlPage=AuthServer.jsp&selectedAuthSrc=" + "<%=selectedAuthSrc %>";
        </script>
        <%
    }
    else
    {
        // PATH: Add OK
        // PATH: Delete
        %>
        <script language="JAVASCRIPT" type="text/javascript">
            <% if (!addMode) out.print("parent."); %>document.location.href = "AuthStart.jsp";
        </script>
        <%
    }
%>
</body>

</html>
