<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.MxLoginBean" %>
<%@ page import="com.hp.mx.portal.ui.MxOptions" %>
<%@ page import="com.hp.mx.portal.ui.MxBean" %>
<%@ page import="com.hp.mx.core.subjects.usermanager.MxUser" %>
<%@ page import="com.hp.mx.core.subjects.MxSubjectPrivilege" %>
<%@ page import="com.hp.mx.utilities.DebugOutput" %>
<%@ page import="com.hp.mx.utilities.DebugSubsystem" %>

<jsp:useBean id="authSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session" />
<jsp:useBean id="authTableModel" class="com.hp.mx.portal.settings.MxAuthTableModel" scope="session" />
<jsp:useBean id="authGroupSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session" />
<jsp:useBean id="authGroupTableModel" class="com.hp.mx.portal.settings.MxAuthTableModel" scope="session" />
<jsp:useBean id="authNodeSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session" />
<jsp:useBean id="authNodeTableModel" class="com.hp.mx.portal.settings.MxAuthTableModel" scope="session" />
<jsp:useBean id="authToolboxSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session" />
<jsp:useBean id="authToolboxTableModel" class="com.hp.mx.portal.settings.MxAuthTableModel" scope="session" />
<jsp:useBean id="authUserSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session" />
<jsp:useBean id="authUserTableModel" class="com.hp.mx.portal.settings.MxAuthTableModel" scope="session" />
<jsp:useBean id="nodeUI" class="com.hp.mx.portal.settings.MxNodeUI" scope="session" />
<jsp:useBean id="groupUI" class="com.hp.mx.portal.settings.MxGroupUI" scope="session" />
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="rbsettings" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<%!
    /** The debug object */
    public DebugSubsystem authDebug = DebugOutput.getDebugSubsystem("MxGroupUI");
%>
<%  // Set Necessary HTTP header attributes (for localization and caching)
    MxBean.jspInit(request, response);
    if(loginBean.checkLogoutConditionForWebPage(pageContext))
        return;
%>
<% if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.NODE_GROUP_MODIFICATION_PRIVILEGE))
   { %>
       <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
<% } %>
<%
    rbsettings.init(loginBean, "MxSettings");

    // Get proper selectionmodel/tablemodel for filtered views
    String model = request.getParameter("szModel");

    com.hp.mx.html.table.MxDefaultTableSelectionModel selectionModel = authSelectionModel;
    com.hp.mx.portal.settings.MxAuthTableModel tableModel = authTableModel;

    if ( model != null )
    {
        if (model.equals("group"))
        {
            selectionModel = authGroupSelectionModel;
            tableModel = authGroupTableModel;
        }
        else if (model.equals("node"))
        {
            selectionModel = authNodeSelectionModel;
            tableModel = authNodeTableModel;
        }
        else if (model.equals("toolbox"))
        {
            selectionModel = authToolboxSelectionModel;
            tableModel = authToolboxTableModel;
        }
        else if (model.equals("user"))
        {
            selectionModel = authUserSelectionModel;
            tableModel = authUserTableModel;
        }
        else if (model.equals("all"))
        {
            selectionModel = authSelectionModel;
            tableModel = authTableModel;
        }
    }


// Reset the bean AFTER call to updateAuthGroup()
// so it can commit the updated system groups.
//    groupUI.resetBean();

    // Are we processing this page?
    String errorMessage = "";
    if (request.getMethod().equals("POST"))
    {
        if (request.getParameter("updateNow") != null)
        {
            if (!groupUI.updateAuthGroup(loginBean, selectionModel, tableModel))
            {
                errorMessage = rbsettings.getString("auth.update.error");
            }
            else
            {
            %>
                <script language="JavaScript" type="text/javascript">
                    window.parent.scrollTo(0,0);
                </script>
            <%
                groupUI.resetBean();
                return;
            }
        }
    }
    groupUI.resetBean();

%>
<%
    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();

    MxTag okButtonTag = new MxDefaultTag("okButton", rbsettings.getString("button.updateContents"), "");
    okButtonTag.setAttr(MxTag.TYPE, "submit");
    buttons.addMxTag(okButtonTag);
    buttons.addMxTag(new MxDefaultTag("cancelButton", rbsettings.getString("button.cancel"), "cancelUpdate()"));
    buttons.setMxTagSelectionId("okButton");
%>
<html>

<head>
<title></title>
<link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
<link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/settings/css/MxAuth.css'>
<script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
<script src="/SessionReset.js" language="JavaScript" type="text/javascript"></script>
<script language="JavaScript" type="text/javascript">
MxPortalWorkspaceSetHelpTopic("admin_auth_updateAuth");
    function cancelUpdate()
    {
        document.location.replace("<%=MxOptions.URL_BASE%>/home/MxBlank.html");
        window.parent.scrollTo(0,0);
    }

    function showSystems(ctlSelect)
    {
        var targetEl = document.getElementById("systemGroupNodes");

        if (ctlSelect.value == "changes")
        {
            var src = document.getElementById("changedMembers");
            targetEl.innerHTML = src.innerHTML;
        }
        else if (ctlSelect.value == "current")
        {
            var src = document.getElementById("currentMembers");
            targetEl.innerHTML = src.innerHTML;
        }
        else if (ctlSelect.value == "updated")
        {
            var src = document.getElementById("updatedMembers");
            targetEl.innerHTML = src.innerHTML;
        }
    }

</script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% buttons.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</head>

<body>
    <a name="topOfPage"><hr id="pageStart"></a>

    <form method="POST" action="AuthUpdate.jsp?updateNow" autocomplete="off" style="border:0px;padding:0px;margin:0px" name="authForm">
        <input type="hidden" name="szModel" value="<%= model %>">
        <div class="subwindow-header"><%=rbsettings.getString("auth.updateTitle")%></div><br />
        <%=rbsettings.getString("auth.update.helptext")%>
        <br>&nbsp;
<%
    if (!errorMessage.equals(""))
    {
        out.println("<div class='errorTextBold'>");
        out.println(errorMessage);
        out.println("</div><br>");
    }
%>
        <table><tr valign="top"><td>
            <% // SHOW CONTROL %>
            <%= rbsettings.getString("auth.update.show.label") %>
            <select size="1" name="whatToShow" onChange="showSystems(this)">
                <option value="changes" selected><%=rbsettings.getString("auth.update.show.changes")%></option>
                <option value="current"><%=rbsettings.getString("auth.update.show.current")%></option>
                <option value="updated"><%=rbsettings.getString("auth.update.show.updated")%></option>
            </select><br><br>
        </td><td>

            <div style="overflow:auto;height:200;width:250px;text-align:left;display:block;" class="insetBorder" id="systemGroupNodes" align="center">
                <% groupUI.listSystemGroupChanges(loginBean, out, selectionModel, tableModel, rbsettings, true); %>
            </div>
        </td></tr></table>

        <div style="margin-top:15px">
            <% buttons.dumpButtons(out); %>
        </div>

    </form>

    <iframe
        id='AuthUpdateWkSpace'
        name='AuthUpdateWkSpace'
        style='position:relative; visibility:visible; width:100%; height:900'
        scrolling='no'
        marginwidth='0'
        frameborder='0'
        src='<%=MxOptions.URL_BASE%>/home/MxBlank.html'>
    </iframe>

    <div id="changedMembers" style="display:none">
        <% groupUI.listSystemGroupChanges(loginBean, out, selectionModel, tableModel, rbsettings, false); %>
    </div>

    <div id="currentMembers" style="display:none">
        <% groupUI.listSystemGroupContents(loginBean, out, selectionModel, tableModel, rbsettings); %>
    </div>

    <div id="updatedMembers" style="display:none">
        <% groupUI.listSystemGroupUpdatedContents(loginBean, out, selectionModel, tableModel, rbsettings); %>
    </div>

    <% MxHtmlUtil.dumpBodyEnd(out); %>

</body>

</html>
