<%
//
// $Source: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/settings/AutoDiscovery.jsp,v $
// $Revision: 1.28 $
// $Date: 2005/05/12 21:38:18 $
//
%>
<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="java.util.*"%>
<%@ page import="com.hp.mx.portal.help.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.core.subjects.*" %>
<%@ page import="com.hp.mx.core.taskmanager.*" %>
<%@ page import="com.hp.mx.utilities.MxCMS" %>
<%@ page import="java.util.Calendar"%>
<%@ page import="com.hp.mx.portal.ui.MxDateAndTime"%>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="autoDiscoveryBean" class="com.hp.mx.portal.discovery.AutoDiscoveryBean" scope="session" />
<jsp:useBean id="autoDiscoveryListBean" class="com.hp.mx.portal.discovery.AutoDiscoveryList" scope="session"/>
<%
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    // Is the user authorized?
    if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.NODE_MODIFICATION_PRIVILEGE))
    {
        %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
        <%
        return;
    }

    // Maintain the mode
    String mode = "new";
    if (request.getParameter("mode") != null)
    {
        mode = request.getParameter("mode");
    }

    // Initialize the bean and set the page title
    String subHeader="";
    if (mode.equalsIgnoreCase("edit"))
    {
        // Edit existing discovery task
        String discoveryId = request.getParameter("discoveryId");
        int[] selRows = autoDiscoveryListBean.getMyTasksSelectionModel().getSelectedIndices();
        int selRow = selRows[0];
        String taskId = autoDiscoveryListBean.getTaskID().toString();
        boolean success = autoDiscoveryBean.initialize(taskId.toString(), loginBean);
        if (!success)
        {
            // Load a "discovery task deleted page/message
            %><jsp:forward page="AutoDiscoveryError.jsp" /><%
        }
        else
        {
            subHeader = autoDiscoveryBean.getResourceString("auto.page.label.edit");
        }
    }
    else
    {
        // NEW discovery task
        autoDiscoveryBean.initialize(null, loginBean);
        subHeader = autoDiscoveryBean.getResourceString("auto.page.label.new");
    }

    autoDiscoveryBean.clearAllErrorMessages();

    int     needsConfPopup = 0;
    Calendar cal = Calendar.getInstance(loginBean.getTimeZone(), loginBean.getLocale());
    MxDateAndTime dateAndTime = new MxDateAndTime(loginBean.getLocale(),
                                                  loginBean.getTimeZone(),
                                                  cal.getTime());
    // Handle buttons
    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();
    MxTag btnOK = new MxDefaultTag("btnOK", autoDiscoveryBean.getResourceString("auto.page.button.OK"), "");
    btnOK.setAttr(MxTag.TYPE, "submit");
    buttons.addMxTag(btnOK);

    MxTag btnCancelTag = new MxDefaultTag("btnCancel", autoDiscoveryBean.getResourceString("auto.page.button.cancel"), "cancel()");
    buttons.addMxTag(btnCancelTag);
%>



<html>
    <head>
        <title></title>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
        <STYLE TYPE="text/css">
            .indented{margin-left:12px;}
            .indented2{margin-left:24px;}
        </STYLE>
        <script src="<%=MxOptions.URL_BASE%>/js/utilities.js" language="JavaScript" type="text/javascript"></script>
        <script language='JavaScript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxPortalApi.js'></script>

        <script language='JavaScript' type='text/javascript'>

        function isIPChecked()
        {
            if(document.ConfigForm.discoveryEnabledCheckBox.checked == true &&
               document.ConfigForm.ipCheckbox.checked == true &&
               document.ConfigForm.inclusionTextBox.value == "")
            {
                alert("<%= autoDiscoveryBean.getResourceString("auto.page.error.inclusion.missing")%>");
                return false;
            }
            else
                return true;
        }

        function validateAll()
        {
            if ( validateIP() == false)
            {
                return false;
            }
            if (isIPChecked() == false )
            {
                return false;
            }
            if (validateInterval() == false)
            {
                return false;
            }
            if (checkIpState() == false)
            {
                return false;
            }
            if (validateDOM() == false)
            {
                return false;
            }
            return true;
        }

        function validateInterval()
        {
            if (document.ConfigForm.discoveryEnabledCheckBox.checked == true)
            {
                 if (document.ConfigForm.intervalType.value == <%= ScheduleIntervals.INTERVAL_MINUTES %>  &&
                     document.ConfigForm.interval.value < 15)
                 {
                     alert ("<%= autoDiscoveryBean.getResourceString("auto.page.error.intervalTooSmall")%>");
                     return false;
                 }
                 if (document.ConfigForm.interval.value  < 1)
                 {
                     alert(" <%=autoDiscoveryBean.getResourceString("auto.page.error.intervalgtzero")%>" );
                     hilite( document.ConfigForm.interval );
                     return false;
                 }


                 return validateNumFieldConfig(document.ConfigForm.interval,  '<%=autoDiscoveryBean.getResourceString("auto.page.error.interval")%>' );
            }
            return true;
        }

        function validateDOM()
        {
            if (document.ConfigForm.discoveryEnabledCheckBox.checked == true &&
                document.ConfigForm.intervalType.value == <%= ScheduleIntervals.INTERVAL_MONTHLY %>)
            {
                 if (document.ConfigForm.intervalDOM.value < 1 || document.ConfigForm.intervalDOM.value > 31)
                 {
                     alert ("<%= autoDiscoveryBean.getResourceString("auto.page.error.dom.range")%>");
                     return false;
                 }

                return validateNumFieldConfig(document.ConfigForm.intervalDOM,  '<%=autoDiscoveryBean.getResourceString("auto.page.error.dom")%>' );
            }
            return true;
        }

        function  noSpaces( str )
        {
            for ( var i = 0; i < str.length; i++ )
            {
                if ( str.charAt(i) == ' ' )
                {
                   return false;
                }
            }
            return true;  // There are no spaces
        }

        // Validate the for empty fields and correct syntax used for snmp config settings
        function validateNumFieldConfig( field, nameStr  )
        {
            var rc = true;
            // Check for invalid network timeout

            var onechar = field.value.substring(0,1)

            if ((field.value.length == 0) )
            {
                alert(nameStr+  " <%=autoDiscoveryBean.getResourceString("auto.page.error.notblank")%>");
                hilite( field );
                return false;
            }

            if ( checkNumber( field, nameStr  ) == false)
            {
                hilite( field );
                return false;
            }

            // Check for a valid Network timeout & Retries
            if (noSpaces( field.value ) == false )
            {
                alert( nameStr+" <%=autoDiscoveryBean.getResourceString("auto.page.error.nospaces")%>" );
                hilite( field );
                return false;
            }


            return true;
        }


        // Check for valid numbers
        function checkNumber( field, settingName  )
        {
            inputStr = field.value;
            for (var i=0; i < inputStr.length; i++)
            {
                var oneChar = inputStr.charAt(i);
                if (oneChar < "0" || oneChar > "9")
                {
                    alert( settingName + " <%=autoDiscoveryBean.getResourceString("auto.page.error.mustbenumb")%>" );
                    hilite( field );
                    return false;
                }
            }
        }

        function hilite( editWindow )
        {
            editWindow.focus();
            editWindow.select();
            return true;
        }

        function validateIP()
        {
            var pass = true;

            if ( !validateIPString(document.ConfigForm.inclusionTextBox.value) )
            {
                alert("<%= autoDiscoveryBean.getResourceString("auto.page.error.inclusion.contents")%>");
                pass = false;
            }
            return pass;
        }

        function validateIPString( str )
        {
            var i, chr;

            for ( i = 0; i < str.length; ++i )
            {
                chr = str.charCodeAt(i);
                //            1            0             #              $             -                                                                                                                                 _
                if (((chr >= 48)&&(chr <= 57))|| (chr == 35) || (chr == 36)|| (chr == 42)|| (chr == 32)|| (chr == 10)|| (chr == 13)|| (chr == 9) || (chr == 45) || (chr == 46) || (chr == 58) || (chr == 64) || (chr == 95) ||((chr >= 65)&&(chr <= 90)) || ((chr >= 97)&&(chr <= 122)))
                {
                    continue;
                }
                else
                {
                    // alert(chr);
                    return false;
                }
            }

            return true;
        }

        function checkIpState()
        {
            <%
            if (MxCMS.isWindows())
            {
            %>
                if (document.ConfigForm.ipxCheckbox.checked == false &&
                    document.ConfigForm.ipCheckbox.checked == false)
                {
                    alert("<%= autoDiscoveryBean.getResourceString("auto.page.error.needProto.ipipx")%>");
                    return false;
                }
            <%
            }
            else
            {
            %>
                if (document.ConfigForm.ipCheckbox.checked == false)
                {
                    alert("<%= autoDiscoveryBean.getResourceString("auto.page.error.needProto.ip")%>");
                    return false;
                }
            <%
            }
            %>
            return true;
        }

        function updateLastRun(strVal)
        {
            el = document.getElementById("elLastRun");
            if (el != null)
            {
                el.innerHTML = strVal;
            }
        }

        function updateNextRun(strVal)
        {
            el = document.getElementById("elNextRun");
            if (el != null)
            {
                el.innerHTML = strVal;
            }
        }


        function markFormAsChanged()
        {
            bSettingsChanged=true;
            setButtonStates();
        }

        function handleIPCheckChange()
        {
            if (document.ConfigForm.ipCheckbox.checked)
            {
                 document.ConfigForm.inclusionTextBox.disabled = false;
            }
            else
            {
                document.ConfigForm.inclusionTextBox.disabled = true;
            }
        }

        function handleEnableDisableChanges()
        {
            if (document.ConfigForm.discoveryEnabledCheckBox.checked)
            {
                 document.ConfigForm.interval.disabled = false;
                 document.ConfigForm.intervalType.disabled = false;
                 if (document.ConfigForm.intervalTime != null)
                 {
                     document.ConfigForm.intervalTime.disabled = false;
                 }
                 if (document.ConfigForm.intervalDOW != null)
                 {
                     document.ConfigForm.intervalDOW.disabled = false;
                 }
                 if (document.ConfigForm.intervalDOM != null)
                 {
                     document.ConfigForm.intervalDOM.disabled = false;
                 }
                 if (document.ConfigForm.intervalAMPM != null)
                 {
                     document.ConfigForm.intervalAMPM.disabled = false;
                 }

            }
            else
            {
                 document.ConfigForm.interval.disabled = true;
                 document.ConfigForm.intervalType.disabled = true;

                 if (document.ConfigForm.intervalTime != null)
                 {
                     document.ConfigForm.intervalTime.disabled = true;
                 }
                 if (document.ConfigForm.intervalDOW != null)
                 {
                     document.ConfigForm.intervalDOW.disabled = true;
                 }
                 if (document.ConfigForm.intervalDOM != null)
                 {
                     document.ConfigForm.intervalDOM.disabled = true;
                 }
                 if (document.ConfigForm.intervalAMPM != null)
                 {
                     document.ConfigForm.intervalAMPM.disabled = true;
                 }

            }
        }

        function setButtonStates()
        {
            if ((document.ConfigForm.discoveryName.value.length > 0) &&
            (document.ConfigForm.inclusionTextBox.value.length > 0))
            {
                ourButtonManager.enableButtonById('btnOk');
            }
            else
            {
                ourButtonManager.disableButtonById('btnOk');
            }
        }

        function cancel()
        {
            document.location.replace("<%=MxOptions.URL_BASE%>/home/MxBlank.html");
        }

        function init()
        {
            pageLoaded = true;
            displayMorePeriodical();
            handleEnableDisableChanges();
            handleIPCheckChange();
            setDisplayHeightAndWidth();
            giveFocus("inclusionTextBox");
        }

        function setDisplayHeightAndWidth()
        {
            var pageHeight  = document.body.scrollHeight;
            var pageWidth  = document.body.scrollWidth;
            parent.setFrmDisplayHeight(pageHeight);
            //parent.setFrmDisplayWidth(pageWidth);
        }

        function cleanup()
        {
        }

        /////////////////////////////////////////////////
        // displayMorePeriodical()
        /////////////////////////////////////////////////
        function displayMorePeriodical()
        {
            var td = document.getElementById("morePeriodical");

            var select    = document.getElementById("intervalType");
            var listIndex = select.value;

            switch (listIndex)
            {
                case '<%= ScheduleIntervals.INTERVAL_MINUTES %>':  // minutes
                    td.innerHTML = "&nbsp;";
                    break;

                case '<%= ScheduleIntervals.INTERVAL_HOURS %>':  // hours
                    td.innerHTML = "&nbsp;";
                    break;

                case '<%= ScheduleIntervals.INTERVAL_DAYS %>':  // days
                    td.innerHTML = "&nbsp;<%= autoDiscoveryBean.getResourceString("auto.page.label.at") %>&nbsp;"+
                                   "<input id='intervalTime' name='intervalTime' type='text' size='5' value='<%=autoDiscoveryBean.getIntervalTimeStr() %>' maxlength='5'>"
                    <%
                        if (dateAndTime.getUseAMPM() == true)
                        {
                    %>

                                   +"<select id='intervalAMPM' name='intervalAMPM' size='1'>" +
                                   "<option value='AM' <%=autoDiscoveryBean.getIsAmChecked() %>><%= autoDiscoveryBean.getResourceString("auto.page.ampm.am") %></option>" +
                                   "<option value='PM' <%=autoDiscoveryBean.getIsPmChecked() %>><%= autoDiscoveryBean.getResourceString("auto.page.ampm.pm") %></option>" +
                                   "</select>";
                    <%
                        }
                    %>
                    break;

                case '<%= ScheduleIntervals.INTERVAL_WEEKLY %>':  // weeks
                    td.innerHTML = "&nbsp;<%= autoDiscoveryBean.getResourceString("auto.page.label.on") %>&nbsp;<select id='intervalDOW' name='intervalDOW' size='1'>" +
                                   "<option value='<%= Calendar.SUNDAY %>' <%= autoDiscoveryBean.getIntervalDOWSelStr(Calendar.SUNDAY)%>><%= autoDiscoveryBean.getResourceString("auto.page.dow.sun") %></option>" +
                                   "<option value='<%= Calendar.MONDAY %>' <%= autoDiscoveryBean.getIntervalDOWSelStr(Calendar.MONDAY)%>><%= autoDiscoveryBean.getResourceString("auto.page.dow.mon") %></option>" +
                                   "<option value='<%= Calendar.TUESDAY %>' <%= autoDiscoveryBean.getIntervalDOWSelStr(Calendar.TUESDAY)%>><%= autoDiscoveryBean.getResourceString("auto.page.dow.tue") %></option>" +
                                   "<option value='<%= Calendar.WEDNESDAY %>' <%= autoDiscoveryBean.getIntervalDOWSelStr(Calendar.WEDNESDAY)%>><%= autoDiscoveryBean.getResourceString("auto.page.dow.wed") %></option>" +
                                   "<option value='<%= Calendar.THURSDAY %>' <%= autoDiscoveryBean.getIntervalDOWSelStr(Calendar.THURSDAY)%>><%= autoDiscoveryBean.getResourceString("auto.page.dow.thu") %></option>" +
                                   "<option value='<%= Calendar.FRIDAY %>' <%= autoDiscoveryBean.getIntervalDOWSelStr(Calendar.FRIDAY)%>><%= autoDiscoveryBean.getResourceString("auto.page.dow.fri") %></option>" +
                                   "<option value='<%= Calendar.SATURDAY %>' <%= autoDiscoveryBean.getIntervalDOWSelStr(Calendar.SATURDAY)%>><%= autoDiscoveryBean.getResourceString("auto.page.dow.sat") %></option>" +
                                   "</select>" +
                                   "&nbsp;<%= autoDiscoveryBean.getResourceString("auto.page.label.at") %>&nbsp;" +
                                   "<input id='intervalTime' name='intervalTime' type='text' size='5' value='<%=autoDiscoveryBean.getIntervalTimeStr() %>' maxlength='5'>"
                    <%
                        if (dateAndTime.getUseAMPM() == true)
                        {
                    %>
                                   +"<select name='intervalAMPM' size='1'>" +
                                   "<option value='AM' <%=autoDiscoveryBean.getIsAmChecked() %>><%= autoDiscoveryBean.getResourceString("auto.page.ampm.am") %></option>" +
                                   "<option value='PM' <%=autoDiscoveryBean.getIsPmChecked() %>><%= autoDiscoveryBean.getResourceString("auto.page.ampm.pm") %></option>" +
                                   "</select>";
                    <%
                        }
                    %>

                    break;

                case '<%= ScheduleIntervals.INTERVAL_MONTHLY %>':  // months
                    td.innerHTML = "&nbsp;<%= autoDiscoveryBean.getResourceString("auto.page.label.onday") %>&nbsp;<input id='intervalDOM'  name='intervalDOM' type='text' size='2' maxlength='2' value='<%=autoDiscoveryBean.getIntervalDOM() %>'>" +
                                   "&nbsp;<%= autoDiscoveryBean.getResourceString("auto.page.label.at") %>&nbsp;<input id='intervalTime' name='intervalTime' type='text' size='5' value='<%=autoDiscoveryBean.getIntervalTimeStr() %>'>"
                    <%
                        if (dateAndTime.getUseAMPM() == true)
                        {
                    %>
                                   + "<select intervalAMPM name='intervalAMPM' size='1'>" +
                                   "<option value='AM' <%=autoDiscoveryBean.getIsAmChecked() %>><%= autoDiscoveryBean.getResourceString("auto.page.ampm.am") %></option>" +
                                   "<option value='PM' <%=autoDiscoveryBean.getIsPmChecked() %>><%= autoDiscoveryBean.getResourceString("auto.page.ampm.pm") %></option>" +
                                   "</select>";
                    <%
                        }
                    %>
                    break;
            }
        }

        function cancel()
        {
            MxPortalWorkspaceSetHelpTopic("admin_discovery_configAuto");
            location.href="<%= MxOptions.URL_BASE %>/home/MxBlank2.html";
        }

        </script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxPortalRender.dumpHeadContent(out); %>
<% buttons.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</head>

<body  onLoad="init()" onUnload="cleanup()">
<%
    ///////////////////////////////////////////////////////////////////////////
    // IS THIS A POST?
    ///////////////////////////////////////////////////////////////////////////
    if (request.getMethod().equals("POST"))
    {
        autoDiscoveryBean.clearAllErrorMessages();
        boolean success = autoDiscoveryBean.processPost(request);
        if (success)
        {
            %>
            <script language='JavaScript' type='text/javascript'>
                var okToContinue = true;
                <%
                if (autoDiscoveryBean.isRangeTooLarge())
                {
                    %>okToContinue = confirm("<%= autoDiscoveryBean.getBigRangeWarningMessage() %>");<%
                }
                %>

                if (okToContinue)
                {
                    parent.location.href="AutoDiscoveryList.jsp?refresh=1";
                }
                </script>

                <%
                if (!autoDiscoveryBean.isRangeTooLarge())
                {
                    %></body><%
                    return;
                }
                %>
            <%
        }
    }
%>

    <hr>
    <div class='subwindow-header'>
         <%= subHeader %>
    </div><BR>

    <%
        if (autoDiscoveryBean.hasErrorMessages())
        {
            // Display plurally-correct label
            if (autoDiscoveryBean.getErrorMessageList().size() == 1)
            {
                %><div class="errorTextBold"><%= autoDiscoveryBean.getResourceString("discovery.general.error.label.single") %></div><%
            }
            else
            {
                %><div class="errorTextBold"><%= autoDiscoveryBean.getResourceString("discovery.general.error.label.multiple") %></div><%
            }

            autoDiscoveryBean.displayErrorMessagesInHtml(out);
        }
    %>

    <form action="AutoDiscovery.jsp?mode=<%= mode %>" method="POST" name="ConfigForm" onSubmit="return validateAll()">
    <input type="Checkbox" name="chkBoxApplyAndExe" style="display:none">
    <input type="Checkbox" name="stopDiscovery" style="display:none">

    <!-- NAME -->
    <div class="required_label"><%= autoDiscoveryBean.getResourceString("auto.page.label.required")%> *</div>
    <span style="font-weight:bold;"><%= autoDiscoveryBean.getResourceString("auto.page.label.name")%></span> <span class="required">*</span>
    <input type="text" size="32" maxlength="<%=autoDiscoveryBean.MAX_DISCOVERY_NAME_LENGTH%>" id="discoveryName" name="discoveryName" value="<jsp:getProperty name="autoDiscoveryBean" property="discoveryName" />" onMouseUp="setButtonStates()" onKeyUp="setButtonStates()" onChange="setButtonStates()"><br/><br/>

    <!-- SCHEDULE AND STATUS -->
    <div style="font-weight:bold;"><%= autoDiscoveryBean.getResourceString("auto.page.label.schedule")%></div>
    <div class="indented">
        <input type="checkbox" name="discoveryEnabledCheckBox" id="id_discoveryCheckBox" onClick="handleEnableDisableChanges()"  value="ON" <%= autoDiscoveryBean.getTaskCheckStr() %> >
        <LABEL class=sizeTen for="id_discoveryCheckBox"><%= autoDiscoveryBean.getResourceString("auto.page.cb.enableSchedule") %></LABEL><br>

        <table border='0' cellspacing='0' cellpadding='0' style='width:100%'>
            <tr>
              <td nowrap><input id='interval' name='interval' type='text' size='3' value='<%= autoDiscoveryBean.getInterval()%>' maxlength='3'></td>
              <td nowrap>
                <select id='intervalType' name='intervalType' onChange='displayMorePeriodical()'>
                   <option value='<%= ScheduleIntervals.INTERVAL_HOURS %>' <%= autoDiscoveryBean.getIsIntervalTypeSelected( ScheduleIntervals.INTERVAL_HOURS) %>><%= autoDiscoveryBean.getResourceString("auto.page.schedule.hours") %></option>
                   <option value='<%= ScheduleIntervals.INTERVAL_DAYS %>' <%= autoDiscoveryBean.getIsIntervalTypeSelected( ScheduleIntervals.INTERVAL_DAYS) %>><%= autoDiscoveryBean.getResourceString("auto.page.schedule.days") %></option>
                   <option value='<%= ScheduleIntervals.INTERVAL_WEEKLY %>' <%= autoDiscoveryBean.getIsIntervalTypeSelected( ScheduleIntervals.INTERVAL_WEEKLY) %>><%= autoDiscoveryBean.getResourceString("auto.page.schedule.weeks") %></option>
                   <option value='<%= ScheduleIntervals.INTERVAL_MONTHLY %>' <%= autoDiscoveryBean.getIsIntervalTypeSelected( ScheduleIntervals.INTERVAL_MONTHLY) %>><%= autoDiscoveryBean.getResourceString("auto.page.schedule.months") %></option>
                 </select>
               </td>
               <td id='morePeriodical' nowrap style='width:100%'></td>
            </tr>
        </table>
    </div><br/>

    <!-- CONFIGURATION -->
    <div style="font-weight:bold;"><%= autoDiscoveryBean.getResourceString("auto.page.label.configuration")%></div>
    <div class="indented">
        <%
        if (MxCMS.isWindows())
        {
        %>
            <input type="checkbox" name="ipxCheckbox" id="id_ipxCheckbox" value="ON" <%= autoDiscoveryBean.IPXEnabledCBStr() %> >
            <LABEL for="id_ipxCheckbox"><%= autoDiscoveryBean.getResourceString("auto.page.cb.protocols.ipx") %></LABEL><br>
        <%
        }
        %>
        <input type="checkbox" name="ipCheckbox" onClick="handleIPCheckChange()" id="id_ipCheckbox" value="ON" <%= autoDiscoveryBean.IPPingEnabledCBStr() %> >
        <LABEL for="id_ipCheckbox"><%= autoDiscoveryBean.getResourceString("auto.page.cb.protocols.ping") %></LABEL><br>
        <br/>


        <!-- PING INCLUSION RANGE -->
        <div style="font-weight:bold;" class="indented2"><%= autoDiscoveryBean.getResourceString("auto.page.label.ping") %> <span class="required">*</span></div>
        <div class="indented2">
            <%
            if (autoDiscoveryBean.isRangeTooLarge())
            {
                %><div class='errorTextBold'><%= autoDiscoveryBean.getBigRangeWarningMessage() %></div><%
            }
            %>
            <textarea name="inclusionTextBox" id="inclusionTextBox" onChange="markFormAsChanged()" style="WIDTH: 300px;HEIGHT: 120px"  wrap="off" onMouseUp="setButtonStates()" onKeyUp="setButtonStates()"><%=autoDiscoveryBean.getIpInclusionRangeStr() %></textarea>
        </div>
    </div><br>

    <!-- DISPLAY BUTTONS -->
    <div style="margin-top:15px">
        <% buttons.dumpButtons(out); %>
    </div>
    </form>

    <script language='JavaScript' type='text/javascript'>setButtonStates();</script>

    <% MxHtmlUtil.dumpBodyEnd(out); %>

  </body>
</html>
