<%--
//$Source: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/settings/ConfigPagerModemPort.jsp,v $
//$Revision: 1.22 $
//$Date: 2005/02/01 21:02:14 $
--%>
<%@ page import="com.hp.mx.html.core.*" %>
<%@page import="com.hp.mx.core.subjects.*"%>
<%@page import="com.hp.mx.portal.ui.*"%>
<%@page import="com.hp.mx.utilities.MxCMS"%>
<%@page import="com.hp.mx.database.GlobalSettings"%>
<%@page import="java.util.*"%>

<jsp:useBean id="configNotiSettingsBean" scope="session" class="com.hp.mx.portal.settings.ConfigNotificationSettings" />
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<%
    // REQUIRED: This line is required by Tomcat for i18n support.
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    // Abort if the user isn't authorized.
    if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.NOTIFICATION_SETTINGS_MODIFICATION_PRIVILEGE))
    {
        %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
        <%
    }
%>
<%
//+
//This page sets the following properties in config/globalsettings.props
//
//CommPort=COM1
//-

    boolean updated = false;
    boolean updateFailed = false;

    String modemComPort = "COM1";

    configNotiSettingsBean.initBean(out, loginBean);

    // This option is available only on windows
    if (!MxCMS.isWindows())
    {
        out.write(configNotiSettingsBean.getResString("MSG_INVALID_CMS_OS"));
        return;
    }

    String reqType = "";

    if (null != request.getParameter("reqType"))
    {
        reqType = request.getParameter("reqType");
    }

    String parentURL = "";

    if (null != request.getParameter("parentURL"))
    {
        parentURL = request.getParameter("parentURL");
    }

    if (reqType.equalsIgnoreCase("set"))
    {
        if (null != request.getParameter("modemComPort"))
        {
            modemComPort = request.getParameter("modemComPort");
            try
            {
                GlobalSettings.setProperty("CommPort", modemComPort);
                updated = true;
            }
            catch(Throwable t)
            {
                updateFailed = true;
                t.printStackTrace();
                configNotiSettingsBean.alert(out, configNotiSettingsBean.getResString("MSG_MODEM_SETTINGS_UPDATE_FAILED"));
                configNotiSettingsBean.replaceLocation(out,
                            configNotiSettingsBean.getResString("URL_CONFIG_PAGER_MODEM_PAGE")
                            + "?parentURL=" + parentURL);
                return;
            }
            if (!parentURL.trim().equals(""))
            {
                if (updated)
                {
                    configNotiSettingsBean.alert(out, configNotiSettingsBean.getResString("MSG_MODEM_SETTINGS_UPDATED"));
                }
                configNotiSettingsBean.replaceParentLocation(out, parentURL);
                return;
            }
        }
    }

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();
    buttons.addMxTag(new MxDefaultTag("btnNext", configNotiSettingsBean.getResString("LBL_OK"), "nextPage()"));
%>
<html>
<head>
    <title>
    ConfigPagerModemPort
    </title>
    <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
    <link type='text/css' rel='stylesheet' href='/mxportal/actiononevents/css/ActionOnEvents.css'>

    <SCRIPT src="/mxportal/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></SCRIPT>
    <SCRIPT>MxPortalWorkspaceSetHelpTopic("<%=configNotiSettingsBean.getResString("HELP_ID_PAGER_MODEM")%>")</SCRIPT>

    <SCRIPT language="javascript">
    function thisPageOnLoad()
    {
        document.location="#MODEM_PAGE_TOP";
    }
    </SCRIPT>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% buttons.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</head>
<body onload="thisPageOnLoad()">
<A NAME="MODEM_PAGE_TOP"></A>
<P>
<%
    if (!parentURL.trim().equals(""))
    {
%>
    <HR class="rule">
    <BR>
     <SPAN class='mxPageSubTitle'>
        <STRONG>
            <%=configNotiSettingsBean.getResString("LBL_EDIT_MODEM_SETTINGS")%>
        </STRONG>
    </SPAN>
    <P>
<%
    }
%>
<BR>
<FORM id=frmNotification
    class="window-border-table"
    name=frmNotification method=get>
  <TABLE cellSpacing=2 cellPadding=2 border=0>

    <TR>
      <TD noWrap align=left>
        <%=configNotiSettingsBean.getResString("LBL_MODEM_COM_PORT")%>:&nbsp;
        </TD><TD align=left>
        <SELECT id="modemComPort" size=1
                name="modemComPort">
                <%
                String port = GlobalSettings.getProperty("CommPort", "COM1");
                for (int i=1; i<16; i++)
                {
                    String opt = "COM" + i;
                    if (opt.equalsIgnoreCase(port))
                    {
                        out.write("<OPTION SELECTED VALUE='" + opt + "'>" + opt + "</OPTION>");
                    }
                    else
                    {
                        out.write("<OPTION VALUE='" + opt + "'>" + opt + "</OPTION>");
                    }
                }
                %>
        </SELECT>
        </TD>
    </TR>
  </TABLE>
  <INPUT TYPE="HIDDEN" NAME="reqType" ID="reqType" VALUE="">
  <INPUT TYPE="HIDDEN" NAME="parentURL" ID="parentURL" VALUE="<%=parentURL%>">
</FORM>
<BR>
<!--HR class="rule"-->
<P>
<SCRIPT>
    function nextPage()
    {
        document.getElementById('reqType').value="set";
        document.frmNotification.action="<%=configNotiSettingsBean.getResString("URL_CONFIG_PAGER_MODEM_PAGE")%>";
        document.frmNotification.submit();
    }
    function cancelChanges()
    {
        if ( true == confirm('<%=configNotiSettingsBean.getResString("MSG_CANCEL_CONF")%>') )
        {
            <%
            if (parentURL.trim().equals(""))
            {
                %>
                document.location="<%=configNotiSettingsBean.getResString("URL_CONFIG_PAGER_MODEM_PAGE")%>";
                <%
            }
            else
            {
            %>
                parent.document.location="<%=parentURL%>";
            <%
            }
            %>
        }
    }
</SCRIPT>

<div style="margin-top:15px">
    <% buttons.dumpButtons(out); %>
</div>

<%
        if (updated)
        {
            configNotiSettingsBean.alert(out, configNotiSettingsBean.getResString("MSG_MODEM_SETTINGS_UPDATED"));
        }
%>
<%-- need the following <BR> tags to display the full page in mozilla
---- ommitting these causes the bottom buttons to be truncated when
---- the page is rendered in the iframe on the manage page
--%>
<BR>
<BR>
<BR>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</body>
</html>
