<%--
//$Source: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/settings/ConfigSMTPHost.jsp,v $
//$Revision: 1.24 $
//$Date: 2005/02/23 22:45:40 $
--%>
<%@ page import="com.hp.mx.html.core.*" %>
<%@page import="com.hp.mx.core.subjects.*"%>
<%@page import="com.hp.mx.portal.ui.*"%>
<%@page import="com.hp.mx.database.GlobalSettings"%>
<%@page import="java.util.*"%>
<%@page import="java.net.*"%>
<%@page import="com.hp.mx.utilities.DebugSubsystem"%>
<%@page import="com.hp.mx.utilities.DebugOutput"%>

<jsp:useBean id="configNotiSettingsBean" scope="session" class="com.hp.mx.portal.settings.ConfigNotificationSettings" />
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<%
    // REQUIRED: This line is required by Tomcat for i18n support.
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
    {
        return;
    }

    // Abort if the user isn't authorized.
    if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.NOTIFICATION_SETTINGS_MODIFICATION_PRIVILEGE))
    {
        %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
        <%
    }

    DebugSubsystem myDebug = DebugOutput.getDebugSubsystem("ActionOnEvents");
%>
<%
//+
//This page sets the following properties in config/globalsettings.props
//
//EmailFromAddress
//EmailHostName
//EmailLogin
//EmailRequiresAuth
//-
    boolean updated = false;
    boolean updateFailed = false;
    boolean updateHost = false;
    boolean updateEmail = false;
    String emailHostName = "";
    String emailFromAddress = "";

    String svrRequiresAuth="no";
    String useSecurePwdAuth="no";
    boolean emailRequiresAuth = false;
    String emailLogin = "";
    String emailPassword="";

    configNotiSettingsBean.initBean(out, loginBean);

    String reqType = "";

    if (null != request.getParameter("reqType"))
    {
        reqType = request.getParameter("reqType");
    }

    String parentURL = "";

    if (null != request.getParameter("parentURL"))
    {
        parentURL = request.getParameter("parentURL");
    }

    if (reqType.equalsIgnoreCase("set"))
    {
        if (null != request.getParameter("emailHostName"))
        {
            emailHostName = request.getParameter("emailHostName");

            try
            {
                InetAddress [] ips = InetAddress.getAllByName(emailHostName);

                for (int i=0; i < ips.length; i++)
                {
                    String name = ips[i].getCanonicalHostName();
                    if (name.toUpperCase().startsWith(emailHostName.toUpperCase()))
                    {
                        emailHostName = name;
                    }
                }
                updateHost=true;
            }
            catch (Throwable t)
            {
                updateHost=false;
                configNotiSettingsBean.alert(out, configNotiSettingsBean.getResString("MSG_INVALID_HOST"));
                configNotiSettingsBean.replaceLocation(out,
                            configNotiSettingsBean.getResString("URL_CONFIG_EMAIL_PAGE")
                            + "?parentURL=" + parentURL);
                return;
            }
        }
        if (null != request.getParameter("emailFromAddress"))
        {
            emailFromAddress = request.getParameter("emailFromAddress");
            if (!emailFromAddress.matches(".+@.+"))
            {
                configNotiSettingsBean.alert(out, configNotiSettingsBean.getResString("MSG_INVALID_EMAIL_ADDRESS"));
                updateEmail=false;
                configNotiSettingsBean.replaceLocation(out,
                            configNotiSettingsBean.getResString("URL_CONFIG_EMAIL_PAGE")
                            + "?parentURL=" + parentURL);
                return;
            }
            else
            {
                updateEmail=true;
            }
        }
        if (null != request.getParameter("svrRequiresAuth"))
        {
            svrRequiresAuth = request.getParameter("svrRequiresAuth");
            if (svrRequiresAuth.trim().equalsIgnoreCase("on"))
            {
                emailRequiresAuth = true;
                if (null != request.getParameter("emailLogin"))
                {
                    emailLogin = request.getParameter("emailLogin");
                    if (emailLogin.trim().equals(""))
                    {
                        configNotiSettingsBean.alert(out, configNotiSettingsBean.getResString("MSG_INVALID_EMAIL_LOGIN"));
                        updateEmail=false;
                        configNotiSettingsBean.replaceLocation(out,
                                    configNotiSettingsBean.getResString("URL_CONFIG_EMAIL_PAGE")
                                    + "?parentURL=" + parentURL);
                        return;
                    }
                }
                else
                {
                    configNotiSettingsBean.alert(out, configNotiSettingsBean.getResString("MSG_INVALID_EMAIL_LOGIN"));
                    updateEmail=false;
                    configNotiSettingsBean.replaceLocation(out,
                                configNotiSettingsBean.getResString("URL_CONFIG_EMAIL_PAGE")
                                + "?parentURL=" + parentURL);
                    return;
                }
                if (null != request.getParameter("emailPassword"))
                {
                    emailPassword = request.getParameter("emailPassword");
                    if (emailPassword.trim().equals(""))
                    {
                        configNotiSettingsBean.alert(out, configNotiSettingsBean.getResString("MSG_INVALID_EMAIL_PASSWORD"));
                        updateEmail=false;
                        configNotiSettingsBean.replaceLocation(out,
                                    configNotiSettingsBean.getResString("URL_CONFIG_EMAIL_PAGE")
                                    + "?parentURL=" + parentURL);
                        return;
                    }
                }
                else
                {
                    configNotiSettingsBean.alert(out, configNotiSettingsBean.getResString("MSG_INVALID_EMAIL_PASSWORD"));
                    updateEmail=false;
                    configNotiSettingsBean.replaceLocation(out,
                                configNotiSettingsBean.getResString("URL_CONFIG_EMAIL_PAGE")
                                + "?parentURL=" + parentURL);
                    return;
                }
            }
            else
            {
                emailRequiresAuth = false;
            }
        }
        if (updateHost && updateEmail)
        {
            try
            {
                GlobalSettings.setProperty("EmailHostName", emailHostName);
                GlobalSettings.setProperty("EmailFromAddress", emailFromAddress);
                if (emailRequiresAuth)
                {
                    GlobalSettings.setProperty("EmailRequiresAuth", "true");
                    GlobalSettings.setProperty("EmailLogin", emailLogin);
                    configNotiSettingsBean.updateEmailPassword(emailPassword);
                }
                else
                {
                    GlobalSettings.setProperty("EmailRequiresAuth", "false");
                    GlobalSettings.setProperty("EmailLogin", "");
                    configNotiSettingsBean.removeEmailPassword();
                }
                updated = true;
            }
            catch(Throwable t)
            {
                updateFailed = true;
                t.printStackTrace();
                configNotiSettingsBean.replaceLocation(out,
                            configNotiSettingsBean.getResString("URL_CONFIG_EMAIL_PAGE")
                            + "?parentURL=" + parentURL);
                return;
            }
        }
        if (!parentURL.trim().equals(""))
        {
            if (updated)
            {
                configNotiSettingsBean.alert(out, configNotiSettingsBean.getResString("MSG_EMAIL_SETTINGS_UPDATED"));
            }
            configNotiSettingsBean.replaceParentLocation(out, parentURL);
            return;
        }
    }

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();
    buttons.addMxTag(new MxDefaultTag("btnNext", configNotiSettingsBean.getResString("LBL_OK"), "nextPage()"));
%>
<html>
<head>
    <title>
    ConfigSMTPHost
    </title>
    <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
    <link type='text/css' rel='stylesheet' href='/mxportal/actiononevents/css/ActionOnEvents.css'>

    <SCRIPT src="/mxportal/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></SCRIPT>
    <SCRIPT>MxPortalWorkspaceSetHelpTopic("<%=configNotiSettingsBean.getResString("HELP_ID_EMAIL_HOST")%>")</SCRIPT>

    <SCRIPT language="javascript">
    function thisPageOnLoad()
    {
        document.location="#SMTP_PAGE_TOP";
        togglePasswordFields();
    }

    function togglePasswordFields()
    {
        var bRequiresAuth = false;
        bRequiresAuth = document.getElementById("svrRequiresAuth").checked;

        if (bRequiresAuth)
        {
            document.getElementById("lblLogin").disabled = false;
            document.getElementById("lblPassword").disabled = false;
            document.getElementById("lblSecureAuth").disabled = false;

            document.getElementById("emailLogin").disabled = false;
            document.getElementById("emailPassword").disabled = false;
            document.getElementById("useSecurePwdAuth").disabled = false;
        }
        else
        {
            document.getElementById("emailLogin").value = "";
            document.getElementById("emailPassword").value = "";
            document.getElementById("useSecurePwdAuth").checked = false;

            document.getElementById("lblLogin").disabled = true;
            document.getElementById("lblPassword").disabled = true;
            document.getElementById("lblSecureAuth").disabled = true;

            document.getElementById("emailLogin").disabled = true;
            document.getElementById("emailPassword").disabled = true;
            document.getElementById("useSecurePwdAuth").disabled = true;
        }
    }
    </SCRIPT>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% buttons.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</head>
<body onload="thisPageOnLoad()">
<A NAME="SMTP_PAGE_TOP"></A>
<P>
<%
    if (!parentURL.trim().equals(""))
    {
%>
    <HR class="rule">
    <BR>
     <SPAN class='mxPageSubTitle'>
        <STRONG>
            <%=configNotiSettingsBean.getResString("LBL_EDIT_SMTP_SETTINGS")%>
        </STRONG>
    </SPAN>
    <P>
<%
    }
%>
<BR>
    <FORM   id="frmNotification"
            class="window-border-table"
            name=frmNotification method=POST>
        <TABLE style="margin:0px;border:0px;padding:0px">
        <TR>
            <TD noWrap><%=configNotiSettingsBean.getResString("LBL_SMTP_HOST")%>:&nbsp;</TD>
            <TD noWrap>
                <INPUT  id="emailHostName"
                        name="emailHostName"
                        size=35
                        value="<%=GlobalSettings.getProperty("EmailHostName", "")%>">
            </TD>
        </TR>
        <TR>
            <TD noWrap><%=configNotiSettingsBean.getResString("LBL_MGMT_SERVER_EMAIL")%>:</TD>
            <TD noWrap>
                <INPUT  id="emailFromAddress"
                        name="emailFromAddress"
                        size=35
                        value="<%=GlobalSettings.getProperty("EmailFromAddress", "")%>">
            </TD>
        </TR>
        </TABLE>
        <br />
        <table style="margin:0px;border:0px;padding:0px">
            <TR>
                <TD noWrap><%=configNotiSettingsBean.getResString("LBL_SERVER_REQUIRES_AUTH")%>:
                </TD>
                <TD noWrap>
                    <%
                    if (GlobalSettings.getProperty("EmailRequiresAuth", "false").equalsIgnoreCase("true"))
                    {
                        %>
                        <INPUT  checked type=checkbox id="svrRequiresAuth"
                        <%
                    }
                    else
                    {
                        %>
                        <INPUT  type=checkbox id="svrRequiresAuth"
                        <%
                    }
                    %>
                        name="svrRequiresAuth"
                        onclick="togglePasswordFields()"
                        >
                </TD>
            </TR>
        </table>
        <blockquote>
            <table style="margin:0px;border:0px;padding:0px">
                <tr>
                    <TD id="lblLogin" noWrap><%=configNotiSettingsBean.getResString("LBL_EMAIL_AUTH_ACCOUNT_NAME")%>:
                    </TD>
                    <TD noWrap>
                        <INPUT  id="emailLogin"
                                name="emailLogin"
                                size=35
                                value="<%=GlobalSettings.getProperty("EmailLogin", "")%>">
                    </TD>
                </TR>
                <TR>
                    <TD id="lblPassword" noWrap><%=configNotiSettingsBean.getResString("LBL_EMAIL_AUTH_PASSWORD")%>:
                    </TD>
                    <TD noWrap>
                        <INPUT  id="emailPassword"
                                name="emailPassword"
                                type="password"
                                size=35
                                value="">
                    </TD>
                </TR>
            </table>
            <table>
                <TR>
                    <TD id="lblSecureAuth" style="visibility:hidden" noWrap><%=configNotiSettingsBean.getResString("LBL_USE_SECURE_PWD_AUTH")%>:</TD>
                    <TD noWrap>
                        <INPUT  style="visibility:hidden"
                                type=checkbox
                                id="useSecurePwdAuth"
                                name="useSecurePwdAuth"
                                value="<%=GlobalSettings.getProperty("EmailUseSecurePasswordAuthentication", "")%>">
                    </TD>
                </TR>
            </table>
        </blockquote>
        <INPUT TYPE="HIDDEN" NAME="reqType" ID="reqType" VALUE="">
        <INPUT TYPE="HIDDEN" NAME="parentURL" ID="parentURL" VALUE="<%=parentURL%>">
    </FORM>
    <BR>
    <!--HR class="rule"-->
    <P>
    <SCRIPT language="javascript">
        function nextPage()
        {
            var mailHost = document.getElementById('emailHostName').value;
            mailHost = mailHost.replace(/^\s*/, '').replace(/\s*$/, ''); // trim string
            var mailFrom = document.getElementById('emailFromAddress').value;
            mailFrom = mailFrom.replace(/^\s*/, '').replace(/\s*$/, ''); // trim string

            if ( 0 == mailHost.length )
            {
                alert( "<%=configNotiSettingsBean.getResString("MSG_INVALID_HOST")%>" );
                return false;
            }

            if ( 0 == mailFrom.length )
            {
                alert( "<%=configNotiSettingsBean.getResString("MSG_INVALID_EMAIL_ADDRESS")%>" );
                return false;
            }

            document.getElementById('reqType').value="set";
            document.frmNotification.action="<%=configNotiSettingsBean.getResString("URL_CONFIG_EMAIL_PAGE")%>";
            document.frmNotification.submit();
        }
        function cancelChanges()
        {
            if ( true == confirm('<%=configNotiSettingsBean.getResString("MSG_CANCEL_CONF")%>') )
            {
            <%
            if (parentURL.trim().equals(""))
            {
                %>
                document.location="<%=configNotiSettingsBean.getResString("URL_CONFIG_EMAIL_PAGE")%>";
                <%
            }
            else
            {
            %>
                parent.document.location="<%=parentURL%>";
            <%
            }
            %>
            }
        }
    </SCRIPT>

<div style="margin-top:15px">
    <% buttons.dumpButtons(out); %>
</div>

<%
        if (updated)
        {
            configNotiSettingsBean.alert(out, configNotiSettingsBean.getResString("MSG_EMAIL_SETTINGS_UPDATED"));
        }
%>
<%-- need the following <BR> tags to display the full page in mozilla
---- ommitting these causes the bottom buttons to be truncated when
---- the page is rendered in the iframe on the manage page
--%>
<BR>
<BR>
<BR>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</body>
</html>
