<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.MxLoginBean" %>
<%@ page import="com.hp.mx.portal.ui.MxOptions" %>
<%@ page import="com.hp.mx.portal.ui.MxBean" %>
<%@ page import="com.hp.mx.core.objectmodel.MxObjectID" %>
<%@ page import="com.hp.mx.core.subjects.usermanager.MxUser" %>
<%@ page import="com.hp.mx.core.subjects.MxSubjectPrivilege" %>
<%@ page import="com.hp.mx.html.core.MxHtmlUtil" %>

<jsp:useBean id="groupUI" class="com.hp.mx.portal.settings.MxGroupUI" scope="session" />
<jsp:useBean id="nodeGroupTableModel" class="com.hp.mx.portal.settings.MxNodeGroupTableModel" scope="session" />
<jsp:useBean id="nodeGroupSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session" />
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="nodeUI" class="com.hp.mx.portal.settings.MxNodeUI" scope="session" />
<jsp:useBean id="rbsettings" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<%  // Set Necessary HTTP header attributes (for localization and caching)
    MxBean.jspInit(request, response);
    if(loginBean.checkLogoutConditionForWebPage(pageContext))
        return;
%>
<%  if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.NODE_GROUP_MODIFICATION_PRIVILEGE))
    { %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
<%  } %>
<%
    String errorFlag = request.getParameter("error");
    if (errorFlag == null)
    {
        errorFlag = "";
    }
    if ( ! errorFlag.equals("true") )
    {
        groupUI.resetBean();
    }

    int[] groupIndex = nodeGroupSelectionModel.getSelectedIndices();
    // Used later to store GUID;
    String groupGUID = "";

    boolean isAllNodesGroup  = false;
    boolean isCMSGroup       = false;
    if (null != groupIndex && groupIndex.length > 0)
    {
        MxObjectID groupID = nodeGroupTableModel.getObjectID(groupIndex[0]);
        groupGUID = groupID.getGUID().toString();

        String allnodesID = groupUI.getAllNodesGroupId(loginBean);
        String cmsID = groupUI.getCMSGroupId(loginBean);
        if ( groupGUID.equals( allnodesID) )
        {
            isAllNodesGroup = true;
        }
        else if ( groupGUID.equals( cmsID) )
        {
            isCMSGroup = true;
        }
        else
        {
            groupUI.LoadGroup(loginBean, groupID);
        }
    }
    rbsettings.init(loginBean, "MxSettings");

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();

    MxTag okButtonTag = new MxDefaultTag("okButton", rbsettings.getString("button.ok"), "postMemberNodes()");
    okButtonTag.setAttr(MxTag.TYPE, "submit");
    buttons.addMxTag(okButtonTag);

    buttons.addMxTag(new MxDefaultTag("cancelButton", rbsettings.getString("button.cancel"), "cancelEdit()"));

    buttons.setMxTagSelectionId("okButton");

    MxButtons vertButtons = new MxButtons();
    vertButtons.clearMxTags();
    vertButtons.addMxTag(new MxDefaultTag("addButton", ">>", "addToNodeList()"));
    vertButtons.addMxTag(new MxDefaultTag("removeButton", "<<", "removeFromNodeList()"));
    vertButtons.setVerticalAligned(true);
%>

<html>

<head>
<title></title>
<link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
<link type='text/css' rel='stylesheet' href='css/MxAuth.css'>
<script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
<script src="/SessionReset.js" language="JavaScript" type="text/javascript"></script>
<script language="JAVASCRIPT">
MxPortalWorkspaceSetHelpTopic("admin_auth_modifyGroup");

function resetScroll()
{
    window.parent.scrollTo(0,0);
}

function cancelEdit()
{
    resetScroll();
    parent.document.location.href="GroupStart.jsp";
}

function loadMemberNodeList(nodeString)
{
    // Parse through the list, and for each matching group name, turn on the selection
    var nodeList = nodeString.split("|");
    // Find out how many groups there are
    var noOfNodes = nodeList.length;

    for(var i = 0; i < noOfNodes; i++)
    {
        var nodeToAdd = nodeList[i];

        // Loop through the group list to find a match. When found, turn select on
        var availableBox = document.groupForm.available_nodes;
        var nodeBox = document.groupForm.node_list;
        var optCnt = 0;
        var availCnt = availableBox.length;

        // Loop through the available list
        // Add selected elements to the add list
        for (optCnt = 0; optCnt < availCnt; optCnt++)
        {
          if(availableBox.options[optCnt].text == nodeToAdd)
          {
              // Turn on the selection
              availableBox.options[optCnt].selected = true;
          }
        }
    }

    // Then move the selected groups to the members box
    addToNodeList();
}

function addToNodeList()
{
    // Set up the select box elements and the option counter
    var availableBox = document.groupForm.available_nodes;
    var nodeBox = document.groupForm.node_list;
    var optCnt = 0;
    var availCnt = availableBox.length;

    // Loop through the available list
    // Add selected elements to the add list
    for (optCnt = 0; optCnt < availCnt; optCnt++)
    {
          if(availableBox.options[optCnt].selected == true)
          {
              // Create a new option object
              var newNodeOption = new Option((availableBox.options[optCnt].text), (availableBox.options[optCnt].value));

              // Add this element to the end of the group list box
              nodeBox.options[nodeBox.length] = newNodeOption;
          }
    }

    // Loop through to remove the selected items from the available list
    for (optCnt = 0; optCnt < availCnt; optCnt++)
    {
          if(availableBox.options[optCnt].selected == true)
          {
              // Remove the selected option from the available list
              availableBox.options[optCnt] = null;
              optCnt--;
              availCnt--;
          }
    }

    // Now check the buttons
    checkButtons();
}

function removeFromNodeList()
{
    // Set up the select box elements and the option counter
    var availableBox = document.groupForm.available_nodes;
    var nodeBox = document.groupForm.node_list;
    var optCnt = 0;
    var nodeCnt = nodeBox.length;

    // Loop through the group list
    // Add selected elements to the available list
    for (optCnt = 0; optCnt < nodeCnt; optCnt++)
    {
          if(nodeBox.options[optCnt].selected == true)
          {
              // Create a new option object
              var newNodeOption = new Option((nodeBox.options[optCnt].text), (nodeBox.options[optCnt].value));

              // Add this element to the end of the group list box
              availableBox.options[availableBox.length] = newNodeOption;
          }
    }
    // Remove selected elements from group list
    for (optCnt = 0; optCnt < nodeCnt; optCnt++)
    {
          if(nodeBox.options[optCnt].selected == true)
          {
              // Remove the selected option from the available list
              nodeBox.options[optCnt] = null;
              optCnt--;
              nodeCnt--;
          }
    }

    // Now check the buttons
    checkButtons();
}

function postMemberNodes()
{
    // Loop through to concat the group names together

    var optCnt = 0;
    var nodeBox = document.groupForm.node_list;
    var nodeCnt = nodeBox.length;
    var nodeList = "";

    if(nodeCnt != 0)
    {
      nodeList = nodeBox.options[0].text;

      for (optCnt = 1; optCnt < nodeCnt; optCnt++)
      {
          nodeList = nodeList + "|" + nodeBox.options[optCnt].text;
      }
    }
    // Add the string to the url for posting
    document.groupForm.nodeAddList.value = nodeList;
    resetScroll();
}

function checkName()
{
    if(document.groupForm.name.value != "")
    {
        ourButtonManager.enableButtonById('okButton');
    }
    else
    {
        ourButtonManager.disableButtonById('okButton');
    }
}

function checkButtons()
{
    // Loop through the available node box and the member node boxes and
    // see if they have anything selected. If no selections, disable the appropriate button
    var availableBox = document.groupForm.available_nodes;
    var availableCnt = availableBox.length;
    ourButtonManager.disableButtonById('addButton');

    for (var i = 0; i < availableCnt; i++)
    {
        if (availableBox.options[i].selected == true)
        {
            ourButtonManager.enableButtonById('addButton');
        }
    }

    var memberBox = document.groupForm.node_list;
    var memberCnt = memberBox.length;
    ourButtonManager.disableButtonById('removeButton');

    for (i = 0; i < memberCnt; i++)
    {
        if (memberBox.options[i].selected == true)
        {
            ourButtonManager.enableButtonById('removeButton');
        }
    }
}

function init()
{
    // Now load up the edit field values with the data loaded into the beans
    document.groupForm.name.value = "<%=MxHtmlUtil.encodeJScriptSafeEntities(groupUI.getName())%>";
    document.groupForm.description.value = "<%=MxHtmlUtil.encodeJScriptSafeEntities(groupUI.getDescription())%>";

    // Load the member node list
    var nodeString = "<%=MxHtmlUtil.encodeJScriptSafeEntities(groupUI.getNodeAddList())%>"
    loadMemberNodeList(nodeString);


    // Prevent the All Managed Systems group or CMS group fields from being edited
<%  if ( isAllNodesGroup || isCMSGroup )
    {
%>
        document.groupForm.name.disabled = "true";
        document.groupForm.name.className = "disabled-text";
        document.groupForm.description.disabled = "true";
        document.groupForm.description.className = "disabled-text";

        document.groupForm.available_nodes.disabled = "true";
        document.groupForm.available_nodes.className = "disabled-text";
        document.groupForm.node_list.disabled = "true";
        document.groupForm.node_list.className = "disabled-text";

        ourButtonManager.disableButtonById('okButton');
<%  }
    else
    {
%>
        document.groupForm.name.focus();
<%  }
%>
    checkButtons();
}

</script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% buttons.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</head>
<%  if ( isAllNodesGroup || isCMSGroup )
    {
%>
<body>
  <hr>
  <font class="subwindow-header"><%=rbsettings.getString("group.edittitle")%></font>
  <br><br>
    <div align="center"><font class="errorTextBold"><%=rbsettings.getString("group.editerr.notallowed")%></font>
    </div>
  <br>
</body>
<%  }
    else
    {
%>
<body onLoad="init();">

<form method="POST" autocomplete="off" style="border:0px;padding:0px;margin:0px" name="groupForm" action="GroupServer.jsp">

  <hr>
    <table border="0" width="100%">
      <tr>
        <td align="left"><font class="subwindow-header"><%=rbsettings.getString("group.edittitle")%></font></td>
        <td align="right"><%=rbsettings.getString("lastmodified")%> <jsp:getProperty name='groupUI' property='lastModified' /></td>
      </tr>
    </table>
<%  if( errorFlag.equals("true") )
    {
        String errorCodeStr = request.getParameter("errorCode");
        String errorCodeMsg = groupUI.getEditErrorMessageByCode(errorCodeStr,rbsettings);
        String errorMessage = groupUI.getErrorMessage();

        if (errorMessage != null || errorCodeMsg != null)
        {
            out.println("<hr>");
            if (errorCodeMsg != null)
            {
                out.println("<div align='center'>");
                out.println("<font class='errorTextBold'>");
                out.println(errorCodeMsg);
                out.println("</font>");
                out.println("</div>");
            }
            if (errorMessage != null)
            {
                out.println("<div align='center'>");
                out.println("<font class='errorText'>");
                out.println(errorMessage);
                out.println("</font>");
                out.println("</div>");
            }
            out.println("<hr>");
        }
    }
%>
  <br>&nbsp;<span class="required_label"><%=rbsettings.getString("required")%>*</span>
  <br><br>
  <div align="center">
    <center>
    <table border="0" width="100%">
      <tr>
        <td width="10%">
  <font class="input-field"><%=rbsettings.getString("group.name")%> </font><span class="required">*</span></td>
        <td width="90%"><input type="text" name="name" size="20" onKeyup="checkName()" onBlur="checkName()"></td>
      </tr>
      <tr>
        <td width="10%"><font class="input-field"><%=rbsettings.getString("group.description")%>&nbsp;</font>

        </td>
        <td width="90%"><input type="text" name="description" size="60">

        </td>
      </tr>
    </table>
    </center>
  </div>
  <br>
  <font class="section-header"><%=rbsettings.getString("group.modify")%></font><br><br>

  <div align="left" style="margin-left:30px">
    <table border="0" width="90%">
      <tr>
        <td width="60%" valign="middle" align="left" colspan=2>
      <p align="left"><font class="listbox-header"><%=rbsettings.getString("group.available")%></font>
        <td width="40%" valign="middle" align="left"><font class="listbox-header"><%=rbsettings.getString("group.members")%></font></td>
      </tr>
      <tr>
        <td width="45%" valign="middle" align="center">
          <select size="5" name="available_nodes" style="width:100%" onChange="checkButtons()" multiple>
            <% nodeUI.ListNodes(loginBean, out, "", "no", rbsettings.getBundle(), nodeUI.LIST_MODE_OPTIONS); %>
          </select></td>
        <td width="10%" valign="middle" align="center">
          <% vertButtons.dumpButtons(out); %>
        </td>
        <td width="45%" valign="middle" align="center"><select size="5" name="node_list" style="width:100%" onChange="checkButtons()" multiple></select></td>
      </tr>
    </table>
  </div>

<input type="hidden" name="command" value="edit">
<input type="hidden" name="GroupGUID" value=<%=groupGUID %>>
<input type="hidden" name="nodeAddList">

<div style="margin-top:15px">
    <% buttons.dumpButtons(out); %>
</div>

</form>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</body>
<%  } // isAllNodesGroup || isCMSGroup
%>
</html>
