<%--
//$Source: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/settings/EditSnmpTrap.jsp,v $
//$Revision: 1.32 $
//$Date: 2005/03/15 15:47:30 $
--%>
<%@ page import="com.hp.mx.html.core.*" %>
<%@page import="com.hp.mx.core.subjects.*"%>
<%@page import="com.hp.mx.portal.ui.*"%>
<%@page import="com.hp.mx.utilities.ApiUtility"%>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="snmpBean" class="com.hp.mx.portal.settings.EditSnmpTrapUI" scope="session"/>
<%
    // REQUIRED: This line is required by Tomcat for i18n support.
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
    {
        return;
    }

    // Abort if the user isn't authorized.
    if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.NOTIFICATION_SETTINGS_MODIFICATION_PRIVILEGE))
    {
        %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
        <%
    }
%>

<jsp:setProperty name="snmpBean" property="*" />

<%
    // init bean if this is the first pass
    if (snmpBean.isFirstTime())
    {
         snmpBean.initBean(out, loginBean);
    }

    // update trap info and reload page if "OK"
    // button was clicked in previous pass
    if(request.getParameter("selectedMibName") != null)
    {
        snmpBean.setSelectedMibName(request.getParameter("selectedMibName"));
    }
    if(request.getParameter("selectedTrapInMib") != null)
    {
//      snmpBean.alert(out, "Request header selectedTrapInMib:"+request.getParameter("selectedTrapInMib"));
        snmpBean.setSelectedTrapInMib(request.getParameter("selectedTrapInMib"));
    }


    if( null != request.getParameter( "updateTrap" ))
    {

//      snmpBean.alert(out,"updateTrap");
        if (request.getParameter( "updateTrap" ).equalsIgnoreCase("YES"))
        {

            if(request.getParameter("trapServiceEnable") != null)
            {
                snmpBean.setTrapServiceEnable(request.getParameter("trapServiceEnable"));
//              snmpBean.alert(out,"setTrapServiceEnable:"+request.getParameter("trapServiceEnable"));
            }
            if(request.getParameter("trapType") != null)
            {
                snmpBean.setTrapType(request.getParameter("trapType"));
//              snmpBean.alert(out, "setTrapType:" + request.getParameter("trapType"));
            }
            if(request.getParameter("trapCategory") != null)
            {
                snmpBean.setTrapCategory(request.getParameter("trapCategory"));
//              snmpBean.alert(out,"setTrapCategory:"+ request.getParameter("trapCategory"));
            }
            if(request.getParameter("trapSeverity") != null)
            {
                snmpBean.setTrapSeverity(request.getParameter("trapSeverity"));
//              snmpBean.alert(out, "setTrapSeverity:"+request.getParameter("trapSeverity"));
            }

            if(request.getParameter("trapDescription") != null)
            {
                snmpBean.setTrapDescription(request.getParameter("trapDescription"));
//              snmpBean.alert(out, "setTrapDescription:"+request.getParameter("trapDescription"));
            }

//             snmpBean.setSelectedTrapInMib(request.getParameter("selectedTrapInMib"));
//             snmpBean.alert(out,"trapServiceEnable:"+snmpBean.getTrapServiceEnable()+
//                              "  trapType:"+snmpBean.getTrapType()+
//                              "  trapCategory:" +snmpBean.getTrapCategory()+
//                              "  trapSeverity:" +snmpBean.getTrapSeverity()+" ");
             snmpBean.update();
             snmpBean.replaceLocation(out, snmpBean.getResString("URL_EDIT_TRAP_PAGE"));
             return;
        }
    }

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();
    MxTag tag = new MxDefaultTag("btnAdd", snmpBean.getResString("OK_BTN"), "updateTrap()");
%>
<HTML>
<HEAD>
    <TITLE>
        EditSnmpTrap
    </TITLE>
    <link type='text/css' rel='stylesheet' href='/mxportal/css/MxPortalEx.css'>
    <SCRIPT src="/mxportal/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></SCRIPT>
    <SCRIPT>MxPortalWorkspaceSetHelpTopic("<%=snmpBean.getResString("HELP_ID_EDIT_TRAP")%>")</SCRIPT>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% buttons.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</HEAD>
<BODY>

<FORM id="frmEdit" name="frmEdit" action='<%=snmpBean.getResString("URL_EDIT_TRAP_PAGE")%>'>
<TABLE border=0 borderColor='#000000'
    marginwidth=0 marginheight=0
    cellPadding=1 cellSpacing=0 width="100%">
    <TR>
        <TD style="WIDTH: 20%" width="20%"><strong><%=snmpBean.getResString("LABEL_MIB_NAME")%></strong></TD>
        <TD style="WIDTH: 80%" width="80%">
        <select id="selectedMibName" name="selectedMibName"
            size="1" style="width:200px"
            onChange="document.getElementById('frmEdit').submit()">
        <%
            String mib = snmpBean.getSelectedMibName();
            String selectedMib = "";
            snmpBean.getMibList();
            for (int i = 0; i < snmpBean.getMibCount(); i++)
            {
                String opt = snmpBean.getMib(i);
                if ( opt.equalsIgnoreCase(mib) )
                {
                    out.write("<OPTION SELECTED VALUE='" + opt + "'>" + opt + "</OPTION>");
                    selectedMib= opt;
                }
                else
                {
                    out.write("<OPTION VALUE='" + opt + "'>" + opt + "</OPTION>");
                }
            }
            if(selectedMib=="")
            {
                if( snmpBean.getMibCount() > 0 )
                {
                    selectedMib = snmpBean.getMib(0);
                    snmpBean.setSelectedMibName(selectedMib);
                }
            }
//                  snmpBean.alert(out,"selected Mib is:"+ selectedMib);
        %>
        </select>
          <SCRIPT language="javascript">

                document.getElementById('selectedMibName').value
                        = "<%=snmpBean.getSelectedMibName().trim()%>";
            </SCRIPT>
        </TD>
    </TR>
    <TR>
        <td style="WIDTH: 20%" width="20%"><strong><%=snmpBean.getResString("LABEL_TRAP_NAME")%></strong></td>
        <td>
            <select name="selectedTrapInMib"
                id="selectedTrapInMib"
                size="1" style="width:200px"
                onChange="document.getElementById('frmEdit').submit()">
            <%
                String trap = snmpBean.getSelectedTrapInMib();
//                snmpBean.alert(out, "Form selected Trap:"+trap);
                String selectedTrap = "";
                for (int i = 0; i < snmpBean.getTrapCount(); i++)
                {
                    String opt = snmpBean.getTrap(i);
//                    snmpBean.alert(out,"opt is:" + opt);
                    if ( opt.equalsIgnoreCase(trap) )
                    {
                        out.write("<OPTION SELECTED VALUE='" + opt + "'>" + opt + "</OPTION>");
                        selectedTrap =opt;
                    }
                    else
                    {
                        out.write("<OPTION VALUE='" + opt + "'>" + opt + "</OPTION>");
                    }

                }
//                snmpBean.alert(out,"selectedTap after loop:" +selectedTrap);
                if(selectedTrap =="")
                {

                    if (snmpBean.getTrapCount() >= 1 )
                    {
                        selectedTrap =snmpBean.getTrap(0);
//                        snmpBean.alert(out,"selectedTrap set to 0 which is:" +selectedTrap);

                    }
                }

//                  snmpBean.alert(out,"Set Selected Trap to:"+ selectedTrap);
                snmpBean.setSelectedTrapInMib(selectedTrap);

            %>

            </select>

            <SCRIPT language="javascript">

                document.getElementById('selectedTrapInMib').value
                        = "<%=snmpBean.getSelectedTrapInMib().trim()%>";
            </SCRIPT>
        </td>
    </TR>
        <TR>
        <td style="WIDTH: 20%" width="20%" valign='top'><strong><%=snmpBean.getResString("LABEL_TYPE")%></strong></td>
        <td>
            <INPUT type=text style="width:50%"
                id="trapType" name="trapType"
                value="<%=snmpBean.getTrapType()%>">
        </td>
    </TR>
    <TR>
        <td style="WIDTH: 20%" width="20%" valign='top'><strong><%=snmpBean.getResString("LABEL_DESCRIPTION")%></strong></td>
        <td>
            <textarea rows=6 cols=42
                id="trapDescription"
                name="trapDescription"
                style="width:50%"><%=snmpBean.getTrapDescription()%></textarea>
        </td>
    </TR>
    <TR>
        <td style="WIDTH: 20%" width="20%" valign='top'><strong><%=snmpBean.getResString("LABEL_ENABLE_TRAP")%></strong></td>
        <td>
            <SELECT name="trapServiceEnable"
                id="trapServiceEnable"
                size=1 style="width:50%">
                <%
                if (snmpBean.getTrapCount() > 0)
                {
//                  snmpBean.alert(out,"1st getTrapServiceEnable:"+snmpBean.getTrapServiceEnable());
                    if (snmpBean.getTrapServiceEnable().equalsIgnoreCase("true"))
                    {
                        %>
                        <OPTION SELECTED VALUE="true"><%=snmpBean.getResString("TEXT_YES")%></OPTION>
                        <OPTION VALUE="false"><%=snmpBean.getResString("TEXT_NO")%></OPTION>
                        <%
                    }
                    else
                    {
                        %>
                        <OPTION VALUE="true"><%=snmpBean.getResString("TEXT_YES")%></OPTION>
                        <OPTION SELECTED VALUE="false"><%=snmpBean.getResString("TEXT_NO")%></OPTION>
                        <%
                    }
                }
                else
                {
                    %>
                    //<OPTION SELECTED> </OPTION>
                    <%
                }
//                  snmpBean.alert(out,"2nd getTrapServiceEnable:"+snmpBean.getTrapServiceEnable());
                %>
            </SELECT>
        </td>
    </TR>

    <TR>
        <td style="WIDTH: 20%" width="20%" valign='top'><strong><%=snmpBean.getResString("LABEL_CATEGORY")%></strong></td>
        <td>
            <select name="trapCategory"
                id="trapCategory"
                size="1"
                style="width:50%">
                <%
                if (snmpBean.getTrapCount() > 0)
                {
                    // refresh list in case a new mib with a new category was added
                    snmpBean.getCategoryList();
                    String cat = snmpBean.getTrapCategory().trim();
//                    snmpBean.alert(out,"1st getTrapCategory:"+cat);
                    for (int i = 0; i < snmpBean.getCategoryCount(); i++)
                    {
                        String opt = snmpBean.getCategory(i).trim();
                        String optLabel = ApiUtility.getAString("AlertTypeCategory", "label", opt, loginBean.getLocale().getLanguage(), opt);

                        if ( opt.equalsIgnoreCase(cat) )
                        {
                            out.write("<OPTION SELECTED VALUE='" + opt + "'>" + optLabel + "</OPTION>");
                        }
                        else
                        {
                            out.write("<OPTION VALUE='" + opt + "'>" + optLabel + "</OPTION>");
                        }
                    }
                }
                else
                {
                    %>
                    <OPTION SELECTED> </OPTION>
                    <%
                }
//                snmpBean.alert(out,"2nd getTrapCategory:"+cat);
                %>
            </select>
        </td>
    </TR>
    <TR>
        <td style="WIDTH: 20%" width="20%" ><strong><%=snmpBean.getResString("LABEL_SEVERITY")%></strong></td>
        <td>
            <SELECT name="trapSeverity" id="trapSeverity"
                size=1
                style="width:50%">
                <%
                if (snmpBean.getTrapCount() > 0)
                {
                    if (snmpBean.getTrapSeverity().equalsIgnoreCase("100"))
                    {
                    %>
                        <OPTION SELECTED VALUE="100"><%=snmpBean.getResString("TEXT_INFORMATIONAL")%></OPTION>
                    <%
                    }
                    else
                    {
                    %>
                        <OPTION VALUE="100"><%=snmpBean.getResString("TEXT_INFORMATIONAL")%></OPTION>
                    <%
                    }
                    %>

                    <%
                    if (snmpBean.getTrapSeverity().equalsIgnoreCase("2"))
                    {
                    %>
                        <OPTION SELECTED VALUE="2"><%=snmpBean.getResString("TEXT_WARNING")%></OPTION>
                    <%
                    }
                    else
                    {
                    %>
                        <OPTION VALUE="2"><%=snmpBean.getResString("TEXT_WARNING")%></OPTION>
                    <%
                    }
                    %>

                    <%
                    if (snmpBean.getTrapSeverity().equalsIgnoreCase("3"))
                    {
                    %>
                        <OPTION SELECTED VALUE="3"><%=snmpBean.getResString("TEXT_MINOR")%></OPTION>
                    <%
                    }
                    else
                    {
                    %>
                        <OPTION VALUE="3"><%=snmpBean.getResString("TEXT_MINOR")%></OPTION>
                    <%
                    }
                    %>

                    <%
                    if (snmpBean.getTrapSeverity().equalsIgnoreCase("4"))
                    {
                    %>
                        <OPTION SELECTED VALUE="4"><%=snmpBean.getResString("TEXT_MAJOR")%></OPTION>
                    <%
                    }
                    else
                    {
                    %>
                        <OPTION VALUE="4"><%=snmpBean.getResString("TEXT_MAJOR")%></OPTION>
                    <%
                    }
                    %>

                    <%
                    if (snmpBean.getTrapSeverity().equalsIgnoreCase("5"))
                    {
                    %>
                        <OPTION SELECTED VALUE="5"><%=snmpBean.getResString("TEXT_CRITICAL")%></OPTION>
                    <%
                    }
                    else
                    {
                    %>
                        <OPTION VALUE="5"><%=snmpBean.getResString("TEXT_CRITICAL")%></OPTION>
                    <%
                    }
                }
                else
                {
                    %>
                    <OPTION SELECTED </OPTION>
                    <%
                }
                    %>

<%--
                <OPTION VALUE="100"><%=snmpBean.getResString("TEXT_INFORMATIONAL")%></OPTION>
                <OPTION VALUE="2"><%=snmpBean.getResString("TEXT_INFORMATIONAL")%></OPTION>
                <OPTION VALUE="3"><%=snmpBean.getResString("TEXT_MINOR")%></OPTION>
                <OPTION VALUE="4"><%=snmpBean.getResString("TEXT_MAJOR")%></OPTION>
                <OPTION VALUE="5"><%=snmpBean.getResString("TEXT_CRITICAL")%></OPTION>\
--%>
            </SELECT>
            <SCRIPT language="javascript">
                document.getElementById('trapSeverity').value
                        = "<%=snmpBean.getTrapSeverity().trim()%>";
            </SCRIPT>
        </td>
    </TR>
</TABLE>
<INPUT type="HIDDEN" name="updateTrap" id="updateTrap" value="NO">
</FORM>
<SCRIPT language="javascript">
        function updateTrap()
        {
            document.getElementById('frmEdit').action = '<%=snmpBean.getResString("URL_EDIT_TRAP_PAGE")%>';
            document.getElementById('updateTrap').value="YES";
            document.getElementById('frmEdit').submit();
        }
</SCRIPT>

<%
    if (0 == snmpBean.getTrapCount())
    {
        //set Button to disabled
        tag.setAttr(MxTag.DISABLED, "true");
    }
    buttons.addMxTag(tag);
%>

<div style="margin-top:15px">
    <% buttons.dumpButtons(out); %>
</div>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</BODY>
</HTML>
