<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.MxLoginBean" %>
<%@ page import="com.hp.mx.portal.ui.MxOptions" %>
<%@ page import="com.hp.mx.portal.ui.MxBean" %>
<%@ page import="com.hp.mx.portal.ui.MxDateAndTime" %>
<%@ page import="com.hp.mx.html.table.MxTableSortingModel" %>
<%@ page import="com.hp.mx.core.subjects.usermanager.MxUser" %>
<%@ page import="com.hp.mx.core.subjects.MxSubjectPrivilege" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="rbsettings" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="nodeUI" class="com.hp.mx.portal.settings.MxNodeUI" scope="session" />
<jsp:useBean id="authUI" class="com.hp.mx.portal.settings.MxAuthUI" scope="session" />
<jsp:useBean id="authNodeReportTableModel" class="com.hp.mx.portal.settings.MxAuthTableModel" scope="session" />
<jsp:useBean id="authNodeReportTableView" class="com.hp.mx.html.table.MxTableView2" scope="session" />
<jsp:useBean id="authTableNodeReportController" class="com.hp.mx.html.table.MxTableController" scope="session" />
<jsp:useBean id="authNodeReportSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session" />

<%  // Set Necessary HTTP header attributes (for localization and caching)
    MxBean.jspInit(request, response);
    if(loginBean.checkLogoutConditionForWebPage(pageContext))
        return;
%>
<%  if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.TOOL_AUTHORIZATION_PRIVILEGE))
    { %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
<%  } %>
<%
    String allNodes     = request.getParameter("allNodes");
    String selectedNode = request.getParameter("selectedNode");
    String printable    = request.getParameter("printable");
    boolean reportAll    = false;
    if( ( allNodes != null && allNodes.equals("true") ) ||
        ( selectedNode != null && selectedNode.equals("none") ) )
    {
        reportAll = true;
    }

    rbsettings.init(loginBean, "MxSettings");
%>
<%
    if ( authTableNodeReportController.isFirstTime() )
    {
        authNodeReportTableView.setId("ID_AUTH_NODE_REPORT_TABLE");
        authNodeReportTableView.setUrlHandler(request.getRequestURI());
        authTableNodeReportController.setTableModelWithSorting(authNodeReportTableModel);
        authTableNodeReportController.setTableView(authNodeReportTableView);
    }
    if ( authTableNodeReportController.checkUrlForControllerMessages(request, out) )
    {
        return;
    }
    // Get the date and time when report is generated.
    MxDateAndTime currentTime = new MxDateAndTime( loginBean.getLocale(),
                                                   loginBean.getTimeZone()
                                                 );
    String currentTimeOfDay = currentTime.getCurrentDateTimeFormatString(
                                          MxDateAndTime.DATE_TIME_FULL_FORMAT);
    // Load the table
    authNodeReportTableModel.setAddUrlHref(false);
    if (reportAll)
    {
        authNodeReportTableModel.loadAllNodeAuths(loginBean,rbsettings);
    }
    else
    {
        authNodeReportTableModel.loadNodeAuths(selectedNode,loginBean,rbsettings);
    }
    MxTableSortingModel sortable = authTableNodeReportController.getSortingModelOrNull();
    if (null != sortable)
    {
        // Sort on the nodes (third column)
        sortable.sortTable(2,true);
    }

    if (printable == null)
    {
        authNodeReportTableView.setHeight("150px");
        authNodeReportTableView.setWidth("600px");
    }
    else
    {
        authNodeReportTableView.setHeight(null);
        authNodeReportTableView.setWidth(null);
    }

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();
    buttons.addMxTag(new MxDefaultTag("B6", rbsettings.getString("button.viewprintable") + "...", "openPrintable()"));
%>
<html>

<head>
<title><%=rbsettings.getString("auth.report")%></title>
<link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
<link type='text/css' rel='stylesheet' href='css/MxAuth.css'>
<script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
<script src="/SessionReset.js" language="JavaScript" type="text/javascript"></script>
<script language="JAVASCRIPT">
MxPortalWorkspaceSetHelpTopic("admin_auth_reportAuth");

function loadAllTable()
{
    document.location.replace("ReportNodeAuth.jsp?allNodes=true&selectedNode=<%=selectedNode%>");
}

function loadNodeTable()
{
    document.location.replace("ReportNodeAuth.jsp?selectedNode=<%=selectedNode%>");
}

function openPrintable()
{
    var url;
    if(document.authForm.reportoption[0].checked == true)
    {
      url = "ReportNodeAuth.jsp?printable=yes&allNodes=true&selectedNode=<%=selectedNode%>";
    }
    else
    {
      url = "ReportNodeAuth.jsp?printable=yes&selectedNode=<%=selectedNode%>";
    }
    reportWindow = window.open(url, "nodeAuthReport", "menubar=1, titlebar=1, toolbar=1, scrollbars=1, resizable=1");
    reportWindow.focus();
}

</script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% buttons.dumpHeadContent(out); %>
<% authNodeReportTableView.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</head>

<body>

<form method="POST" action="AuthServer.jsp" name="authForm">
<%  if (printable == null)
    {
%>
    <hr>
    <table border="0" width="100%" cellpadding=0>
<%
    }
    else
    {
%>
    <table border="0" cellpadding=0>
    <tr><td align="right">
        &nbsp;<br><br>
    </td></tr>
<%
    }
%>

    <tr>
    <td><font class="subwindow-header"><%=rbsettings.getString("auth.report")%>
<%  if (printable != null)
    {
        if (reportAll)
        {
%>
        <%=rbsettings.getString("authnode.reportforall")%></td>
<%
        }
        else
        {
%>
        <%=rbsettings.getString("authnode.reportforone")%> &quot;<%=nodeUI.nameForID(loginBean, selectedNode) %>&quot;</td>
<%
        }
    }
    else {}
%>
    </font>

<%  if (printable != null)
    {
%>
    </tr><tr><td align="left"><br>
<%
    }
    else
    {
%>
    <td align="right">
<%
    }
    out.print( "<font class='section-header'>" );
    out.print( rbsettings.getString("auth.report.asof") );
    out.print( "</font> " );
    out.println( currentTimeOfDay );
%>
    </td>
    </tr>
    </table>
    <br>
<%  if (printable == null)
    {
%>
    <table border="0" width="100%" cellpadding=0>
      <tr>
        <td valign="middle" align="left" width="20%"><%=rbsettings.getString("auth.for")%></td>
        <td align="left" width="80%">
<%      if (reportAll)
        {
%>
             <input type="radio" name="reportoption" value="V1" onClick="loadAllTable()" checked><%=rbsettings.getString("authnode.reportall")%></td>
<%      }
        else
        {
%>
             <input type="radio" name="reportoption" value="V1" onClick="loadAllTable()"><%=rbsettings.getString("authnode.reportall")%></td>
<%
        }
%>
      </tr>
      <tr>
        <td></td>
        <td>
<%      if (reportAll)
        {
%>
             <input type="radio" name="reportoption" value="V2" onClick="loadNodeTable()"><%=rbsettings.getString("authnode.reportone")%> &quot;<%=nodeUI.nameForID(loginBean, selectedNode) %>&quot;</td>
<%      }
        else
        {
%>
             <input type="radio" name="reportoption" value="V2" onClick="loadNodeTable()" checked><%=rbsettings.getString("authnode.reportone")%> &quot;<%=nodeUI.nameForID(loginBean, selectedNode) %>&quot;</td>
<%
        }
%>
        <td>
        </td>
      </tr>
    </table>
    <br>
<%
    }
    if (authNodeReportTableModel.getRowCount() > 0)
    {
%>
    <div id="reportTable">
    <% authNodeReportTableView.dumpTableVisiblePart(out); %>
    </div>
<%  }
    else
    {
%>
    <div id="reportTable" align="center" style="width=600px;height=150px">
    <br><br><br><b><%=rbsettings.getString("auth.no.auths.match")%></b><br>
    </div>
<%  }
    if (printable == null)
    {
%>
    <hr>
    <div style="margin-top:15px">
        <% buttons.dumpButtons(out); %>
    </div>
<%
    }
%>

</form>
<% authNodeReportTableView.dumpTableHiddenPart(out); %>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</body>

</html>
