<%--
//$Source: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/settings/SysTypMgr_Edit.jsp,v $
//$Revision: 1.22 $
//$Date: 2005/07/07 20:54:28 $
--%>
<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.html.table.*"%>
<%@ page import="com.hp.mx.portal.ui.*"%>
<%@ page import="com.hp.mx.portal.settings.*"%>
<%@ page import="com.hp.mx.core.tools.identification.systypmgr.*"%>
<%@ page import="com.hp.mx.core.subjects.*"%>
<%@ page import="com.hp.mx.core.subjects.usermanager.*"%>
<%@ page import="com.hp.mx.core.controllers.*"%>
<%@ page import="com.hp.mx.core.client.*"%>
<%@ page import="com.hp.mx.core.daemon.*"%>
<%@ page import="com.hp.mx.utilities.simenum.*"%>
<%@ page import="javax.swing.table.DefaultTableModel"%>
<%@ page import="java.util.*"%>

<%@ page import="com.hp.mx.core.nodemanager.NodeTypeMapper"%>
<%@ page import="com.hp.mx.core.nodemanager.NodeSubTypeMapper"%>

<jsp:useBean id="stmSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session"/>
<jsp:useBean id="stmBean" scope="session" class="com.hp.mx.portal.settings.SysTypMgrUI" />
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>

<%
    // REQUIRED: This line is required by Tomcat for i18n support.
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
    {
        return;
    }

    // Abort if the user isn't authorized.
    if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.NODE_MODIFICATION_PRIVILEGE))
    {
        %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
        <%
    }
%>
<jsp:setProperty name="stmBean" property="*" />
<%
    stmBean.initBean(out, loginBean);

    int [] selectedRows = stmSelectionModel.getSelectedIndices();

    if (selectedRows.length != 0)
    {
        if (!stmBean.readRule(selectedRows[0]))
        {
            stmBean.alert(out, stmBean.getResString("ERR_RULE_NOT_FOUND"));
            stmBean.replaceParentLocation(out, stmBean.getResString("URL_MANAGE_PAGE"));
            return;
        }
    }
    else
    {
        stmBean.alert(out, stmBean.getResString("ERR_PAGE_LOADING_PLEASE_WAIT"));
        stmBean.replaceParentLocation(out, stmBean.getResString("URL_MANAGE_PAGE"));
        return;
    }

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();
    buttons.addMxTag(new MxDefaultTag("btnApply", stmBean.getResString("LBL_OK"), "editRule()"));
    buttons.addMxTag(new MxDefaultTag("btnCancel", stmBean.getResString("LBL_CANCEL"), "cancelEdit()"));

    MxTag launchTag = new MxDefaultTag("btnTestUrl", stmBean.getResString("LBL_TEST_URL"), "return launchURL(document.getElementById('url').value)");

%>
<html>
<head>
        <title>
            System Type Manager - Manage Rules
        </title>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/settings/css/SysTypMgr.css'>
        <%--script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/settings/js/SysTypMgr.js'></script--%>

        <SCRIPT>
            <%@include file="js/SysTypMgr.js"%>
        </SCRIPT>

        <SCRIPT src="/mxportal/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></SCRIPT>
        <SCRIPT>MxPortalWorkspaceSetHelpTopic("<%=stmBean.getResString("HELP_ID_EDIT")%>")</SCRIPT>

        <script language="javascript">
<%
        String pType = "";

        if (null != request.getParameter("productType"))
        {
            pType = request.getParameter("productType");
        }
%>
        function cancelEdit()
        {
            document.location = '<%=stmBean.getResString("URL_BLANK_PAGE")%>';
        }
        function editRule()
        {
            var url = document.frmSTM.url.value;
            var rulePriority = document.frmSTM.rulePriority.value;

            if (!checkPriority(rulePriority))
            {
                document.frmSTM.rulePriority.focus();
                return false;
            }

            //alert("url=" + url);

            if (0 == url.length)
            {
                document.frmSTM.url.value=' ';
            }

            document.frmSTM.action = '<%=stmBean.getResString("URL_UPDATE_CORE_PAGE")%>?reqType=<%=stmBean.REQUEST_TYPE_EDIT%>&productType=<%=pType%>';
            document.frmSTM.submit();
            return true;

        }
        </script>
<title>
    SysTypMgr_Edit
</title>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% buttons.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</head>
<body>
<A NAME="EDIT_PAGE_TOP"></A>
<hr class="mx-hr">
    <span class='mxPageSubTitle'>
            <%=stmBean.getResString("TXT_EDIT_RULE_COLON")%>
            &nbsp;<%=stmBean.getDevName()%>
    </span>
<BR>
<div style="width:100%; margin-top:15px">
<blockquote>
<P>
<FORM name="frmSTM" method="POST">
    <table align="left" border=0 borderColor='#000000'
        marginwidth=0 marginheight=0
        cellPadding=1 cellSpacing=0 width="100%">
    <tr>
        <td><%=stmBean.getResString("LBL_PDCT_NAME")%></td>
        <td><%=stmBean.getDevName()%></td>
      </tr>

      <tr><td>&nbsp;</td><td></td></tr>

      <tr>
        <td><%=stmBean.getResString("LBL_SYSOID")%></td>
          <td><%=stmBean.getSysOID()%></td>
      </tr>

        <tr>
            <td>&nbsp;</td>
          <td><%=stmBean.getResString("LBL_COMPARE_RULE")%>
              &nbsp;&nbsp;
            <%
                if (stmBean.getSysOIDRule().equals(Integer.toString(stmBean.COMPARE_RULE_STARTS_WITH)))
                {
                    out.write(stmBean.getResString("LBL_RULE_STARTS_WITH"));
                }
                else
                {
                    out.write(stmBean.getResString("LBL_RULE_MATCH"));
                }
            %>
          </td>
      </tr>
      <tr>
        <td><%=stmBean.getResString("LBL_MIB_OID")%></td>
        <td><%=stmBean.getOid()%></td>
      </tr>
      <tr>
          <td><%=stmBean.getResString("LBL_OBJ_VALUE")%></td>
          <td><%=stmBean.getOidVal()%></td>
      </tr>

      <tr>
        <td>&nbsp;</td>
         <td><%=stmBean.getResString("LBL_DATA_TYPE")%>
            <%
                if (stmBean.getDataType().equals(Integer.toString(stmBean.DATA_TYPE_INTEGER)))
                {
                    out.write(stmBean.getResString("LBL_DATA_TYPE_INTEGER"));
                }
                else
                {
                    out.write(stmBean.getResString("LBL_DATA_TYPE_STRING"));
                }
            %>
         </td>
        </tr>

        <tr>
            <td>&nbsp;</td>
          <td><%=stmBean.getResString("LBL_COMPARE_RULE")%>
            <%
                if (stmBean.getOidRule().equals(Integer.toString(stmBean.COMPARE_RULE_STARTS_WITH)))
                {
                    out.write(stmBean.getResString("LBL_RULE_STARTS_WITH"));
                }
                else if (stmBean.getOidRule().equals(Integer.toString(stmBean.COMPARE_RULE_CONTAINS)))
                {
                    out.write(stmBean.getResString("LBL_RULE_CONTAINS"));
                }
                else if (stmBean.getOidRule().equals(Integer.toString(stmBean.COMPARE_RULE_MATCH)))
                {
                    out.write(stmBean.getResString("LBL_RULE_MATCH"));
                }
                else if (stmBean.getOidRule().equals(Integer.toString(stmBean.COMPARE_RULE_ENDS_WITH)))
                {
                    out.write(stmBean.getResString("LBL_RULE_ENDS_WITH"));
                }
                else if (stmBean.getOidRule().equals(Integer.toString(stmBean.COMPARE_RULE_ANY_VALUE)))
                {
                    out.write(stmBean.getResString("LBL_RULE_ANY_VALUE"));
                }
                else
                {
                    out.write(stmBean.getResString("LBL_RULE_ANY_VALUE"));
                }
            %>
          </td>
      </tr>

    <TR><TD>&nbsp;</TD><td></td></TR>
      <tr>
        <td><%=stmBean.getResString("LBL_PRIORITY")%></td>
        <td><INPUT TEXT name=rulePriority id=rulePriority
              value='<%=stmBean.getRulePriority()%>'
              size=1 style='HEIGHT: 22px; WIDTH: 50px'
              title="">
        </td>
      </tr>
    <tr>
        <td><%=stmBean.getResString("LBL_SYS_TYPE")%></td>
        <td>
        <SELECT name=devType id="devType"
                size=1
                title=''>
            <%
                 NodeTypeMapper ntm = NodeTypeMapper.getDefaultMapper();
                 List productTypes = ntm.getLocalizedList(loginBean.getLocale());
                 ListIterator li = productTypes.listIterator();
                 String szOrd="";
                 String szPtype="";
                 while (li.hasNext())
                 {
                     MxDisplayableEnum dispe = (MxDisplayableEnum) li.next();
                     szPtype = dispe.getDisplayStrValue();
                     szOrd = Integer.toString(dispe.getOrdinal());

                     if (szOrd.equalsIgnoreCase(stmBean.getDevType()))
                     {
                         out.write("<OPTION SELECTED VALUE='"
                                  + szOrd
                                  + "'>"
                                  + szPtype
                                  + "</OPTION>");
                     }
                     else
                     {
                         out.write("<OPTION VALUE='"
                                  + szOrd
                                  + "'>"
                                  + szPtype
                                  + "</OPTION>");
                     }
                 }
            %>
          </SELECT></td>
      </tr>
    <tr>
        <td><%=stmBean.getResString("LBL_SUB_TYPE")%></td>
        <td>
        <SELECT name=devSubType id="devSubType"
                size=1
                title='' >
            <%
                 try
                 {
                     NodeSubTypeMapper nstm = NodeSubTypeMapper.getDefaultMapper();
                     List productSubTypes = nstm.getLocalizedList(loginBean.getLocale());
                     ListIterator stli = productSubTypes.listIterator();
                     String szSubTypeOrd="";
                     String szSubType="";
                     while (stli.hasNext())
                     {
                         MxDisplayableEnum stdispe = (MxDisplayableEnum) stli.next();
                         szSubType = stdispe.getDisplayStrValue();
                         szSubTypeOrd = Integer.toString(stdispe.getOrdinal());

                         if (szSubTypeOrd.equalsIgnoreCase(stmBean.getDevSubType()))
                         {
                             out.write("<OPTION SELECTED VALUE='"
                                      + szSubTypeOrd
                                      + "'>"
                                      + szSubType
                                      + "</OPTION>");
                         }
                         else
                         {
                             out.write("<OPTION VALUE='"
                                      + szSubTypeOrd
                                      + "'>"
                                      + szSubType
                                      + "</OPTION>");
                         }
                     }
                 }
                 catch(Throwable t)
                 {
                     t.printStackTrace();
                 }
            %>
          </SELECT></td>
      </tr>


      <tr>
        <td><%=stmBean.getResString("LBL_URL")%></td>
        <td>
            <table style="position:relative;left:-2px" border=0 cellpadding=0>
              <tr>
                <td>

                    <INPUT TEXT name=url id="url"
                    size=1 style='HEIGHT: 22px; WIDTH: 250px'
                    value='<%=stmBean.getUrl()%>'
                    title="">
                    &nbsp;&nbsp;&nbsp;
                </td>
                <td>
                    <% MxButton.dumpButton(launchTag, out); %>
                </td>
              </tr>
            </table>
        </td>
     </td>
      </tr>
   </table>
</form>
</P>
</blockquote>
</div>
<div style="margin-top:15px">
    <% buttons.dumpButtons(out); %>
</div>

    <SCRIPT language="javascript">
        document.getElementById('rulePriority').focus();
        //document.location="#EDIT_PAGE_TOP";
    </SCRIPT>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</body>
</html>
