<%--
//$Source: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/settings/SysTypMgr_GetOIDResponse.jsp,v $
//$Revision: 1.19 $
//$Date: 2005/06/13 17:56:40 $
--%>
<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.core.subjects.*"%>
<%@ page import="com.hp.mx.core.subjects.usermanager.*"%>
<%@page import="com.hp.mx.portal.ui.*"%>
<%@page import="java.util.*"%>
<%@page import="java.net.*"%>
<%@page import="com.hp.mx.portal.settings.SysTypMgrUI"%>
<%@page import="com.hp.mx.core.tools.identification.systypmgr.*"%>
<%@page import="com.hp.mx.core.protocol.snmp.MibVariable"%>
<jsp:useBean id="stmBean" scope="session" class="com.hp.mx.portal.settings.SysTypMgrUI" />
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<%
    // REQUIRED: This line is required by Tomcat for i18n support.
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
    {
        return;
    }

    // Abort if the user isn't authorized.
    if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.NODE_MODIFICATION_PRIVILEGE))
    {
        %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
        <%
    }
%>
<jsp:setProperty name="stmBean" property="*" />
<%
    stmBean.getResBundles(loginBean);
    String queryOIDVal = "";
    String queryOIDType = "";
    String errMsg = "";

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();
    buttons.addMxTag(new MxDefaultTag("btnGet", stmBean.getResString("LBL_OK"), "updateOidVal()"));
    buttons.addMxTag(new MxDefaultTag("btnCancel", stmBean.getResString("LBL_CANCEL"), "cancelGet()"));

    MxTag getMibTag = new MxDefaultTag("btnGetMibVar", stmBean.getResString("LBL_GET_RESPONSE"), "getMibVar()");
%>

<html>
<head>
    <title>
    SysTypMgr_GetOIDResponse
    </title>
    <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
    <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/settings/css/SysTypMgr.css'>
    <SCRIPT>
        <%@include file="js/SysTypMgr.js"%>
    </SCRIPT>

    <SCRIPT src="/mxportal/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></SCRIPT>
    <SCRIPT>MxPortalWorkspaceSetHelpTopic("<%=stmBean.getResString("HELP_ID_GETOIDRESPONSE")%>")</SCRIPT>

    <SCRIPT language="javascript">
    function thisFrameOnLoad()
    {
        parent.iframeLoaded('frmQueryDisplay');
        document.location="#GET_OID_RESPONSE_PAGE_TOP";
    }
    function cancelGet()
    {

        parent.document.getElementById('frmDisplay').contentWindow.document.location='<%=stmBean.getResString("URL_NEW_PAGE")%>?reqType=dontclear';
        document.location='<%=stmBean.getResString("URL_BLANK_PAGE")%>';
    }
    function getMibVar()
    {
        var s = document.getElementById('snmpCommunity').value;
        s = s.replace(/^\s*/, '').replace(/\s*$/, ''); // trim string

        if (!checkOID(document.getElementById('queryOID').value))
        {
            document.getElementById('queryOID').focus();
            return false;
        }

        if ( 0 == s.length )
        {
            alert ('<%=stmBean.getResString("MSG_MISSING_COMMUNITY_STRING")%>');
            document.getElementById('snmpCommunity').focus();
            return false;
        }

        var ipAddress = document.getElementById('targetIP').value;
        ipAddress = ipAddress.replace(/^\s*/, '').replace(/\s*$/, ''); // trim spaces

        if ( 0 == ipAddress.length )
        {
            alert('<%=stmBean.getResString("MSG_MISSING_IP")%>');
            document.getElementById('targetIP').focus();
            return false;
        }

        document.frmSTM.action = '<%=stmBean.getResString("URL_GET_OID_RESPONSE")%>?queryOID='
                                    + document.getElementById('queryOID');
        document.frmSTM.submit();
    }
    </SCRIPT>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% buttons.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</head>
<body onload="thisFrameOnLoad()">
<A NAME="GET_OID_RESPONSE_PAGE_TOP"></A>
<hr class="mx-hr">
<BR>
<span class='mxPageSubTitle'>
        <%=stmBean.getResString("TXT_GET_OID_RESPONSE_COLON")%>
</span>
<BR>
<FORM name="frmSTM" method="GET" action=""
        width="100%"
        MARGINWIDTH=0
        MARGINHEIGHT=0
        BORDER=0>
    <blockquote>
        <%=stmBean.getResString("TXT_GET_OID_RESPONSE_PROMPT")%>
        <BR>
        <BR>
        <BR>
        <%
            String queryOID = STMRule_t.SYSTEM_OBJECT_IDENTIFIER; //"1.3.6.1.2.1.1.2"; // default to sys oid
            try
            {
                if (null != request.getParameter("queryOID"))
                    queryOID = request.getParameter("queryOID");
            }
            catch (Throwable t)
            {
                t.printStackTrace();
                queryOID = STMRule_t.SYSTEM_OBJECT_IDENTIFIER;
            }

            String targetIP = "";
            try
            {
                targetIP = stmBean.getTargetIP();
                if (null != request.getParameter("queryOID"))
                {
                    InetAddress ina = InetAddress.getByName(targetIP);
                    ina.getHostAddress();
                }
            }
            catch (Throwable t)
            {
                if (t instanceof java.net.UnknownHostException)
                {
                    stmBean.alert(out, stmBean.getResString("MSG_INVALID_TARGET"));
                    stmBean.replaceLocation(out, stmBean.getResString("URL_GET_OID_RESPONSE"));
                    return;
                }
                targetIP = "";
            }

            String snmpCommunity = "public";
            try
            {
                if (null != request.getParameter("snmpCommunity"))
                    snmpCommunity = request.getParameter("snmpCommunity");
            }
            catch (Throwable t)
            {
                snmpCommunity = "public";
            }
        %>
        <TABLE align="center" border=0 cellPadding=0 cellSpacing=0 width="100%">
        <TR ><TD>
            <table width="100%">
            <tr >
                <td><%=stmBean.getResString("LBL_RESPONSE_OID")%></td>
                <td><INPUT TEXT NAME="queryOID" ID="queryOID"
                                value='<%=queryOID%>'
                                size=25
                                >
                </td>
            </tr>
            <tr >
                <td><%=stmBean.getResString("LBL_RESPONSE_COMM_STR")%></td>
                <td><INPUT TEXT NAME="snmpCommunity" id="snmpCommunity"
                                value='<%=snmpCommunity%>'
                                size=25
                                >
                </td>
            </tr>
            <tr >
                <td><%=stmBean.getResString("LBL_RESPONSE_IP")%></td>
                <td><INPUT TEXT NAME="targetIP" id="targetIP"
                                value='<%=targetIP%>'
                                size=25
                                >
                </td>
            </tr>
            <tr>
            <tr>
                <td>&nbsp;</td>
                <td>
                    <table cellpadding=0 border=0 style="position:relative;left:-2px">
                      <tr>
                        <td>
                            <% MxButton.dumpButton(getMibTag, out); %>
                        </td>
                      </tr>
                    </table>
                </td>
            </tr>
            </table>
            <BR>
                <DIV id='divMsg' align=center>
                    <strong>
                    <%=stmBean.getResString("TXT_RESPONSE_PLEASE_WAIT")%>
                    </strong>
                </DIV>
            <BR>
            <table>
            <tr >
                <td><%=stmBean.getResString("LBL_RESPONSE_DATA_TYPE")%></td>
                <td><DIV id='queryOIDType'>&nbsp;</DIV></td>
            </tr>
            <tr >
                <td><%=stmBean.getResString("LBL_RESPONSE_VAL")%></td>
                <td><DIV id='queryOIDVal'>&nbsp;</DIV></td>
            </tr>
            </table>
        </TD></TR>
        </TABLE>
    </blockquote>
    <blockquote>
        <SCRIPT language="javascript">
            function updateOidVal()
            {
                <%if (queryOID.equals(STMRule_t.SYSTEM_OBJECT_IDENTIFIER))
                {
                    %>
//                    parent.document.getElementById('frmDisplay').contentWindow.document.getElementById('sysOID').value
//                                = document.getElementById("queryOIDVal").innerHTML;
                    var sysoid = document.getElementById("queryOIDVal").innerHTML;
                    sysoid = escape(sysoid);
                    parent.document.getElementById('frmDisplay').contentWindow.document.location='<%=stmBean.getResString("URL_NEW_PAGE")%>?reqType=dontclear&sysOID=' + sysoid;
                    <%
                }
                else
                {
                    %>
//                    parent.document.getElementById('frmDisplay').contentWindow.document.getElementById('oidVal').value
//                                = document.getElementById("queryOIDVal").innerHTML;
                    var oidVal = document.getElementById("queryOIDVal").innerHTML;
                    oidVal = escape(oidVal);
                    parent.document.getElementById('frmDisplay').contentWindow.document.location='<%=stmBean.getResString("URL_NEW_PAGE")%>?reqType=dontclear&oidVal=' + oidVal;
                    <%
                }
                %>
                //parent.document.getElementById('oidType').value = document.getElementById("queryOIDType").innerHTML;
                document.location='<%=stmBean.getResString("URL_BLANK_PAGE")%>';
            }
        </SCRIPT>
    </blockquote>
<div style="margin-top:15px">
    <% buttons.dumpButtons(out); %>
</div>
</FORM>
<%
    out.flush();
    try
    {
        if (!targetIP.trim().equals(""))
        {
            String numericIP = "";
            InetAddress ina = InetAddress.getByName(targetIP);
            numericIP = ina.getHostAddress();
            SnmpOidResponse resp = SnmpOidResponse.getOidResponse(queryOID, numericIP, snmpCommunity);
            queryOIDVal=resp.getValue();
            queryOIDType=resp.getType();

            if (queryOIDVal.startsWith("ERROR"))
            {
                errMsg="<B><I><FONT COLOR=\"red\">" + stmBean.getResString("MSG_SNMP_GET_FAILED") + "</FONT></I></B>";
                queryOIDVal="";
                queryOIDType="";
            }
            else
            {
                errMsg="";
            }
        }
    }
    catch(Throwable t)
    {
        t.printStackTrace();
    }
%>
    <SCRIPT>
        document.getElementById("queryOIDVal").innerHTML = '<%=queryOIDVal%>';
        document.getElementById("queryOIDType").innerHTML = '<%=queryOIDType%>';
        document.getElementById("divMsg").innerHTML = '<%=errMsg%>';
    </SCRIPT>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</BODY>
</HTML>
