<%--
//$Source: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/settings/SysTypMgr_New.jsp,v $
//$Revision: 1.26 $
//$Date: 2005/06/13 17:56:40 $
--%>
<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.html.table.*"%>
<%@ page import="com.hp.mx.portal.ui.*"%>
<%@ page import="com.hp.mx.portal.settings.*"%>
<%@ page import="com.hp.mx.core.tools.identification.systypmgr.*"%>
<%@ page import="com.hp.mx.core.subjects.*"%>
<%@ page import="com.hp.mx.core.subjects.usermanager.*"%>
<%@ page import="com.hp.mx.core.controllers.*"%>
<%@ page import="com.hp.mx.core.client.*"%>
<%@ page import="com.hp.mx.core.daemon.*"%>
<%@ page import="com.hp.mx.utilities.simenum.*"%>
<%@ page import="javax.swing.table.DefaultTableModel"%>
<%@ page import="java.util.*"%>
<%@ page import="com.hp.mx.core.nodemanager.NodeTypeMapper"%>
<%@ page import="com.hp.mx.core.nodemanager.NodeSubTypeMapper"%>

<jsp:useBean id="stmBean" scope="session" class="com.hp.mx.portal.settings.SysTypMgrUI" />
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>

<%
    // REQUIRED: This line is required by Tomcat for i18n support.
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
    {
        return;
    }

    // Abort if the user isn't authorized.
    if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.NODE_MODIFICATION_PRIVILEGE))
    {
        %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
        <%
    }
%>
<%


    String reqType = "";

    stmBean.initBean(out, loginBean);

    if (null != request.getParameter("reqType"))
    {
        reqType = request.getParameter("reqType");
    }

    if (!reqType.equalsIgnoreCase("dontclear"))
    {
        stmBean.clearData();
    }

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();
    buttons.addMxTag(new MxDefaultTag("btnAdd", stmBean.getResString("LBL_OK"), "addRule()"));
    buttons.addMxTag(new MxDefaultTag("btnCancel", stmBean.getResString("LBL_CANCEL"), "cancelAdd()"));

    MxTag launchTag = new MxDefaultTag("btnTestUrl", stmBean.getResString("LBL_TEST_URL"), "return launchURL(document.getElementById('url').value)");
    MxTag getFromSysTag1 = new MxDefaultTag("btnGetSysOID", stmBean.getResString("LBL_QUERY_SYSTEM"), "showReqFrame(this, '"+ stmBean.getResString("URL_GET_OID_RESPONSE") +"?queryOID="+ STMRule_t.SYSTEM_OBJECT_IDENTIFIER +"')");
    MxTag getFromMibTag = new MxDefaultTag("btnGetMibOID", stmBean.getResString("LBL_QUERY_MIB"), "showReqFrame(this, '"+ stmBean.getResString("URL_GET_OID") +"')");
    MxTag getFromSysTag2 = new MxDefaultTag("btnGetOIDVal", stmBean.getResString("LBL_QUERY_SYSTEM"), "showReqFrame(this, '"+ stmBean.getResString("URL_GET_OID_RESPONSE") +"?queryOID=' + document.getElementById('oid').value)");

%>
<jsp:setProperty name="stmBean" property="*" />
<html>
<head>
        <title>
            System Type Manager - New Rule
        </title>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/settings/css/SysTypMgr.css'>

        <SCRIPT>
            <%@include file="js/SysTypMgr.js"%>
        </SCRIPT>

        <SCRIPT src="/mxportal/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></SCRIPT>
        <SCRIPT>MxPortalWorkspaceSetHelpTopic("<%=stmBean.getResString("HELP_ID_NEW")%>")</SCRIPT>

        <SCRIPT language="javascript">
<%
        String pType = "";

        if (null != request.getParameter("productType"))
        {
            pType = request.getParameter("productType");
        }
%>
        function thisFrameOnLoad()
        {
            parent.iframeLoaded('frmDisplay');
            document.getElementById('sysOID').focus();
        }
        function showReqFrame(btn, url)
        {
            parent.document.getElementById('frmQueryDisplay').src=url;
        }
        function cancelAdd()
        {
            parent.document.location='<%=stmBean.getResString("URL_MANAGE_PAGE")%>?productType=<%=pType%>&highlightLastSelected=true';
            document.location = '<%=stmBean.getResString("URL_BLANK_PAGE")%>';
        }
        function addRule()
        {
            var devName = document.frmSTM.devName.value;
            var rulePriority = document.frmSTM.rulePriority.value;
            var sysOid = document.frmSTM.sysOID.value;
            var oid = document.frmSTM.oid.value;

            if (!checkSysOID(sysOid))
            {
                document.frmSTM.sysOID.focus();
                return false;
            }

            if (!checkOID(oid))
            {
                document.frmSTM.oid.focus();
                return false;
            }

            if (document.frmSTM.oid.value.length == 0)
            {
                document.frmSTM.oid.value = ' ';
            }

            if (149 < document.frmSTM.oidVal.value.length)
            {
                alert ("<%=stmBean.getResString("MSG_OID_VAL_TOO_LONG")%>");
                document.frmSTM.oidVal.focus();
                return false;
            }

            if (document.frmSTM.oidVal.value.length == 0)
            {
                document.frmSTM.oidVal.value = ' ';
            }

            if (!checkPriority(rulePriority))
            {
                document.frmSTM.rulePriority.focus();
                return false;
            }

            if (!checkName(devName))
            {
                document.frmSTM.devName.focus();
                return false;
            }

            if (!checkURL(document.frmSTM.url.value))
            {
                document.frmSTM.url.focus();
                return false;
            }

            if (document.frmSTM.url.value.length == 0)
            {
                document.frmSTM.url.value = ' ';
            }

            document.frmSTM.action = '<%=stmBean.getResString("URL_UPDATE_CORE_PAGE")%>?reqType=<%=stmBean.REQUEST_TYPE_NEW%>&productType=<%=pType%>';
            document.frmSTM.submit();
            return true;

        }
        </script>
<TITLE>
SysTypMgr_New
</TITLE>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% buttons.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</HEAD>
<BODY onload="thisFrameOnLoad()">
<!--A NAME="NEW_PAGE_TOP"></A-->
<HR class="mx-hr">
    <SPAN class='mxPageSubTitle'>
            <%=stmBean.getResString("TXT_ADD_RULE_COLON")%>
    </SPAN>
<P>
    <div class="required_label"><%=stmBean.getResString("TXT_REQUIRED_FIELD")%></div>
<BR>
        <%=stmBean.getResString("TXT_CRITERIA")%>
<FORM name="frmSTM" method="POST">
    <blockquote>
    <table align="center" border=0 borderColor='#000000'
        marginwidth=0 marginheight=0
        cellPadding=1 cellSpacing=0 width="100%">
      <tr>
        <td><%=stmBean.getResString("LBL_SYSOID")%><span class="required_label">*</span>&nbsp;</td>
        <td>
            <!-- GETSYSOID -->
            <table cellpadding=0 border=0 style="position:relative;left:-2px">
              <tr>
                <td>
                    <INPUT TEXT name=sysOID id=sysOID
                            size=1 style='HEIGHT: 22px; WIDTH: 250px'
                            value='<%=stmBean.getSysOID()%>'>
                    &nbsp;&nbsp;&nbsp;
                </td>
                <td>
                  <% MxButton.dumpButton(getFromSysTag1, out); %>
                </td>
              </tr>
            </table>
            <!-- End GETSYSOID -->
        </td>
      </tr>
      <tr>
         <td>&nbsp;</td>
         <td><%=stmBean.getResString("LBL_COMPARE_RULE")%><span class="required_label">*</span>&nbsp;
            <SELECT size=1 name=sysOIDRule id="sysOIDRule"
                title="">
                <%if (stmBean.getSysOIDRule().equals(Integer.toString(stmBean.COMPARE_RULE_STARTS_WITH)))
                {
                %>
                    <OPTION SELECTED VALUE="<%=stmBean.COMPARE_RULE_STARTS_WITH%>">
                <%
                }
                else
                {
                %>
                    <OPTION VALUE="<%=stmBean.COMPARE_RULE_STARTS_WITH%>">
                <%
                }
                %>
                    <%=stmBean.getResString("LBL_RULE_STARTS_WITH")%>
                </OPTION>
                <%if (stmBean.getSysOIDRule().equals(Integer.toString(stmBean.COMPARE_RULE_MATCH)))
                {
                %>
                    <OPTION SELECTED VALUE="<%=stmBean.COMPARE_RULE_MATCH%>">
                <%
                }
                else
                {
                %>
                    <OPTION VALUE="<%=stmBean.COMPARE_RULE_MATCH%>">
                <%
                }
                %>
                    <%=stmBean.getResString("LBL_RULE_MATCH")%>
                </OPTION>
            </SELECT>
        </td>
      </tr>
    <tr><td>&nbsp;</td></tr>
      <tr>
        <td><%=stmBean.getResString("LBL_MIB_OID")%>&nbsp;</td>
        <td>
            <!-- GETMIBOID -->
            <table cellpadding=0 border=0 style="position:relative;left:-2px">
              <tr>
                <td>
                   <INPUT TEXT name=oid id=oid
                    size=1 style='HEIGHT: 22px; WIDTH: 250px'
                    value='<%=stmBean.getOid()%>'>
                   &nbsp;&nbsp;&nbsp;

                </td>
                <td>
                  <% MxButton.dumpButton(getFromMibTag, out); %>
                </td>
              </tr>
            </table>
            <!-- End GETMIBOID -->
        </td>
      </tr>
      <tr>
          <td><%=stmBean.getResString("LBL_OBJ_VALUE")%>&nbsp;</td>
        <td>
            <!-- GETMIBOIDVAL -->
            <table cellpadding=0 border=0 style="position:relative;left:-2px">
              <tr>
                <td>
                  <INPUT TEXT name=oidVal id=oidVal
                            size=1 style='HEIGHT: 22px; WIDTH: 250px'
                            value='<%=stmBean.getOidVal()%>'>
                   &nbsp;&nbsp;&nbsp;
                </td>
                <td>
                  <% MxButton.dumpButton(getFromSysTag2, out); %>
                </td>
              </tr>
            </table>
            <!-- End GETMIBOIDVAL -->
        </td>
      </tr>
      <tr>
         <td>&nbsp;</td>
         <td><%=stmBean.getResString("LBL_DATA_TYPE")%>&nbsp;&nbsp;&nbsp;
            &nbsp;&nbsp;&nbsp;&nbsp;
            <SELECT size=1 name=dataType id="dataType"
                title="">
                <%if (stmBean.getDataType().equals(Integer.toString(stmBean.DATA_TYPE_STRING)))
                {
                %>
                    <OPTION SELECTED VALUE="<%=stmBean.DATA_TYPE_STRING%>">
                <%
                }
                else
                {
                %>
                    <OPTION VALUE="<%=stmBean.DATA_TYPE_STRING%>">
                <%
                }
                %>
                    <%=stmBean.getResString("LBL_DATA_TYPE_STRING")%>
                </OPTION>
                <%if (stmBean.getDataType().equals(Integer.toString(stmBean.DATA_TYPE_INTEGER)))
                {
                %>
                    <OPTION SELECTED VALUE="<%=stmBean.DATA_TYPE_INTEGER%>">
                <%
                }
                else
                {
                %>
                    <OPTION VALUE="<%=stmBean.DATA_TYPE_INTEGER%>">
                <%
                }
                %>
                    <%=stmBean.getResString("LBL_DATA_TYPE_INTEGER")%>
                </OPTION>
            </SELECT></td>
        </tr>
        <tr>
            <td>&nbsp;</td>
          <td><%=stmBean.getResString("LBL_COMPARE_RULE")%>&nbsp;
            <SELECT size=1 name=oidRule id="oidRule"
                title="">
                <%if (stmBean.getOidRule().equals(Integer.toString(stmBean.COMPARE_RULE_STARTS_WITH)))
                {
                %>
                    <OPTION SELECTED VALUE="<%=stmBean.COMPARE_RULE_STARTS_WITH%>">
                <%
                }
                else
                {
                %>
                    <OPTION VALUE="<%=stmBean.COMPARE_RULE_STARTS_WITH%>">
                <%
                }
                %>
                    <%=stmBean.getResString("LBL_RULE_STARTS_WITH")%>
                </OPTION>
                <%if (stmBean.getOidRule().equals(Integer.toString(stmBean.COMPARE_RULE_CONTAINS)))
                {
                %>
                    <OPTION SELECTED VALUE="<%=stmBean.COMPARE_RULE_CONTAINS%>">
                <%
                }
                else
                {
                %>
                    <OPTION VALUE="<%=stmBean.COMPARE_RULE_CONTAINS%>">
                <%
                }
                %>
                    <%=stmBean.getResString("LBL_RULE_CONTAINS")%>
                </OPTION>
                <%if (stmBean.getOidRule().equals(Integer.toString(stmBean.COMPARE_RULE_MATCH)))
                {
                %>
                    <OPTION SELECTED VALUE="<%=stmBean.COMPARE_RULE_MATCH%>">
                <%
                }
                else
                {
                %>
                    <OPTION VALUE="<%=stmBean.COMPARE_RULE_MATCH%>">
                <%
                }
                %>
                    <%=stmBean.getResString("LBL_RULE_MATCH")%>
                </OPTION>
                <%if (stmBean.getOidRule().equals(Integer.toString(stmBean.COMPARE_RULE_ENDS_WITH)))
                {
                %>
                    <OPTION SELECTED VALUE="<%=stmBean.COMPARE_RULE_ENDS_WITH%>">
                <%
                }
                else
                {
                %>
                    <OPTION VALUE="<%=stmBean.COMPARE_RULE_ENDS_WITH%>">
                 <%
                }
                %>
                   <%=stmBean.getResString("LBL_RULE_ENDS_WITH")%>
                </OPTION>
                <%if (stmBean.getOidRule().equals(Integer.toString(stmBean.COMPARE_RULE_ANY_VALUE)))
                {
                %>
                    <OPTION SELECTED VALUE="<%=stmBean.COMPARE_RULE_ANY_VALUE%>">
                <%
                }
                else
                {
                %>
                    <OPTION VALUE="<%=stmBean.COMPARE_RULE_ANY_VALUE%>">
                <%
                }
                %>
                    <%=stmBean.getResString("LBL_RULE_ANY_VALUE")%>
                </OPTION>
            </SELECT></td>
      </tr>
      <tr>
        <td><%=stmBean.getResString("LBL_PRIORITY")%>&nbsp;</td>
        <td><INPUT TEXT name=rulePriority id=rulePriority value='<%=stmBean.getRulePriority()%>'
              size=1 style='HEIGHT: 22px; WIDTH: 50px'>
        </td>
      </tr>
    </table>
</blockquote>
    <%=stmBean.getResString("TXT_PROPS")%>
<blockquote>
    <table align="center" border=0 borderColor='#000000'
        marginwidth=0 marginheight=0
        cellPadding=1 cellSpacing=0 width="100%">
    <tr>
        <td><%=stmBean.getResString("LBL_SYS_TYPE")%><span class="required_label">*</span>&nbsp;</td>
        <td>
        <SELECT name=devType
                    id="devType" size=1
                    title='' >
            <%
                 NodeTypeMapper ntm = NodeTypeMapper.getDefaultMapper();
                 List productTypes = ntm.getLocalizedList(loginBean.getLocale());
                 ListIterator li = productTypes.listIterator();
                 String szOrd="";
                 String szPtype="";
                 while (li.hasNext())
                 {
                     MxDisplayableEnum dispe = (MxDisplayableEnum) li.next();
                     szPtype = dispe.getDisplayStrValue();
                     szOrd = Integer.toString(dispe.getOrdinal());
                     if (stmBean.getDevType().equalsIgnoreCase(szOrd))
                     {
                         out.write("<OPTION SELECTED VALUE='"
                                  + szOrd
                                  + "'>"
                                  + szPtype
                                  + "</OPTION>");
                     }
                     else
                     {
                         out.write("<OPTION VALUE='"
                                  + szOrd
                                  + "'>"
                                  + szPtype
                                  + "</OPTION>");
                     }
                 }
            %>
        </SELECT>
        </td>
      </tr>
    <tr>
        <td><%=stmBean.getResString("LBL_SUB_TYPE")%>&nbsp;</td>
        <td>
        <SELECT name=devSubType id="devSubType"
                    size=1
                    title=''>
            <%
                 try
                 {
                     NodeSubTypeMapper nstm = NodeSubTypeMapper.getDefaultMapper();
                     List productSubTypes = nstm.getLocalizedList(loginBean.getLocale());
                     ListIterator stli = productSubTypes.listIterator();
                     String szSubTypeOrd="";
                     String szSubType="";
                     while (stli.hasNext())
                     {
                        MxDisplayableEnum stdispe = (MxDisplayableEnum) stli.next();
                        szSubType = stdispe.getDisplayStrValue();
                        szSubTypeOrd = Integer.toString(stdispe.getOrdinal());
                        if (stmBean.getDevSubType().equalsIgnoreCase(szSubTypeOrd))
                        {
                             out.write("<OPTION SELECTED VALUE='"
                                      + szSubTypeOrd
                                      + "'>"
                                      + szSubType
                                      + "</OPTION>");
                         }
                         else
                         {
                             out.write("<OPTION VALUE='"
                                      + szSubTypeOrd
                                      + "'>"
                                      + szSubType
                                      + "</OPTION>");
                         }
                     }
                 }
                 catch(Throwable t)
                 {
                     t.printStackTrace();
                 }
            %>
        </SELECT></td>
    </tr>
    <tr>
        <td><%=stmBean.getResString("LBL_PDCT_NAME")%><span class="required_label">*</span>&nbsp;</td>
        <td><INPUT TEXT name=devName id=devName
              size=1 style="HEIGHT: 22px; WIDTH: 250px"
              value='<%=stmBean.getDevName()%>'></td>
    </tr>
    <tr>
        <td><%=stmBean.getResString("LBL_URL")%>&nbsp;</td>
        <td>
            <table border=0 cellpadding=0 style="position:relative;left:-2px">
              <tr>
                <td>
                  <INPUT TEXT name=url id="url"
                  size=1 style='HEIGHT: 22px; WIDTH: 250px '
                  value='<%=stmBean.getUrl()%>'>
                  &nbsp;&nbsp;&nbsp;
                </td>
                <td>
                  <% MxButton.dumpButton(launchTag, out); %>
                </td>
               </tr>
            </table>

        </td>
     </tr>
   </table>
</blockquote>
</FORM>
<!--hr class='rule'-->
<div style="margin-top:15px">
    <% buttons.dumpButtons(out); %>
</div>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</BODY>
</HTML>
