<%--
//$Source: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/settings/SysTypMgr_UpdateCore.jsp,v $
//$Revision: 1.16 $
//$Date: 2005/07/07 20:54:28 $
--%>
<%@ page import="com.hp.mx.portal.ui.*"%>
<%@page import="com.hp.mx.portal.settings.SysTypMgrUI"%>
<%@ page import="com.hp.mx.core.subjects.*"%>
<%@ page import="com.hp.mx.core.subjects.usermanager.*"%>
<%@ page import="com.hp.mx.core.tools.identification.systypmgr.SNMPRule"%>

<jsp:useBean id="stmBean" scope="session" class="com.hp.mx.portal.settings.SysTypMgrUI" />
<jsp:useBean id="stmSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session"/>
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>

<%
    // REQUIRED: This line is required by Tomcat for i18n support.
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
    {
        return;
    }

    // Abort if the user isn't authorized.
    if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.NODE_MODIFICATION_PRIVILEGE))
    {
        %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
        <%
    }
%>

<jsp:setProperty name="stmBean" property="*" />

<%
    stmBean.initBean(out, loginBean);

    String reqType = "";
    if (null != request.getParameter("reqType"))
    {
        reqType = request.getParameter("reqType");
    }

    String pType = "";

    if (null != request.getParameter("productType"))
    {
        pType = request.getParameter("productType");
    }

    if (reqType.equalsIgnoreCase(stmBean.REQUEST_TYPE_NEW))
    {
        try
        {
            if (stmBean.createRule(out))
            {
                if (pType.equals(Integer.toString(stmBean.ALL_PDCT_TYPES)))
                {
                    %>
                    <SCRIPT>
                        parent.document.location='<%=stmBean.getResString("URL_MANAGE_PAGE")%>'
                                                    + '?highlightLastSelected=true'
                                                    + '&productType=<%=pType%>';
                    </SCRIPT>
                    <%
                }
                else
                {
                    %>
                    <SCRIPT>
                        parent.document.location='<%=stmBean.getResString("URL_MANAGE_PAGE")%>'
                                                    + '?highlightLastSelected=true';
                    </SCRIPT>
                    <%
                }
                return;
            }
            else
            {
            %>
                <SCRIPT>
                    document.location='<%=stmBean.getResString("URL_NEW_PAGE")%>?reqType=dontclear';
                </SCRIPT>
            <%
                return;
            }
        }
        catch (Throwable t)
        {
            stmBean.alert(out, stmBean.getResString("MSG_ADD_CANCELLED"));
            %>
                <SCRIPT>
                    document.location='<%=stmBean.getResString("URL_NEW_PAGE")%>?reqType=dontclear';
                </SCRIPT>
            <%
                return;
        }
    }
    else if (reqType.equalsIgnoreCase(stmBean.REQUEST_TYPE_EDIT))
    {
        try
        {
            if (stmBean.modifyRule(out, stmSelectionModel.getSelectedIndices()[0]))
            {
                out.write("<SCRIPT>"
                    + "document.location='" + stmBean.getResString("URL_BLANK_PAGE")
                    + "';"
                    + "</SCRIPT>");
                return;
            }
            else
            {
                // check if the rule hasn't been deleted
                // and redisplay edit page
                // fixes issue #239734
                SNMPRule snmpRule = new SNMPRule();

                if (null != snmpRule.getRule(stmBean.getDevName()))
                {
                %>
                    <SCRIPT>
                        document.location='<%=stmBean.getResString("URL_EDIT_PAGE")%>';
                    </SCRIPT>
                <%
                    return;
                }
                else
                {
                    out.write("<SCRIPT>"
                              + "document.location='" + stmBean.getResString("URL_BLANK_PAGE")
                              + "';"
                              + "</SCRIPT>");
                    return;
                }
            }
        }
        catch (Throwable t)
        {
            stmBean.alert(out, stmBean.getResString("ERR_RMI"));
        }
        out.write("<SCRIPT>"
                  + "document.location='" + stmBean.getResString("URL_BLANK_PAGE")
                  + "';"
                  + "</SCRIPT>");
        return;
    }
    else if (reqType.equalsIgnoreCase(stmBean.REQUEST_TYPE_DELETE))
    {
        try
        {
            /*
            * Get the row number of the selected task from the selection model object
            */
            int [] selectedRows = stmSelectionModel.getSelectedIndices();

            if (selectedRows.length != 0)
            {
                stmBean.deleteRule(out, selectedRows[0]);
            }
            else
            {
                stmBean.alert(out, stmBean.getResString("ERR_RMI"));
            }
        }
        finally
        {
            %>
            <SCRIPT>
                document.location='<%=stmBean.getResString("URL_MANAGE_PAGE")%>'
                                        + '?productType=<%=pType%>';
            </SCRIPT>
            <%
            return;
        }
    }
%>
