<%@ page import="com.hp.mx.html.core.*" %>
<%@page import="com.hp.mx.core.subjects.*"%>
<%@page import="com.hp.mx.portal.ui.*"%>
<%@page import="com.hp.mx.portal.actiononevents.*"%>
<%@page import="com.hp.mx.utilities.MxCMS"%>
<%@page import="com.hp.mx.portal.search.MxEventSearchUI"%>
<%@page import="java.util.*"%>

<jsp:useBean id="ftwAoneUIbean" scope="session" class="com.hp.mx.portal.actiononevents.ActionOnEventsUIBean" />
<jsp:useBean id="ftwUIbean" scope="session" class="com.hp.mx.portal.settings.FirstTimeWizardUIBean"/>
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<%
    // REQUIRED: This line is required by Tomcat for i18n support.
    MxBean.jspInit(request, response);

    ftwUIbean.getResBundles(loginBean);
    ftwAoneUIbean.getResBundles(loginBean);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
    {
        return;
    }

    // Abort if the user isn't authorized.
    if ((!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.NOTIFICATION_SETTINGS_MODIFICATION_PRIVILEGE))
        || (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.EVENT_MODIFICATION_PRIVILEGE))
        || (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.TOOL_MODIFICATION_PRIVILEGE))
        || (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.SUBJECT_MODIFICATION_PRIVILEGE))
        )
    {
        %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
        <%
    }

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();
    MxTag btnBackTag = new MxDefaultTag("btnBack", ftwUIbean.getResString("BUTTON_PREV_LABEL"), "prevPage()");
    MxTag btnNextTag = new MxDefaultTag("btnNext", ftwUIbean.getResString("BUTTON_NEXT_LABEL"), "nextPage()");
    btnBackTag.setAttr(MxTag.DISABLED, "false");
    btnNextTag.setAttr(MxTag.DISABLED, "false");
    buttons.addMxTag(btnBackTag);
    buttons.addMxTag(btnNextTag);

    MxButtons buttons2 = new MxButtons();
    buttons2.clearMxTags();
    buttons2.addMxTag(new MxDefaultTag("btnView", ftwAoneUIbean.getResString("BUTTON_VIEW_LABEL"), "viewQuery()"));
    buttons2.setSecondary();
    buttons2.setLeftAligned(true);
%>

<jsp:setProperty name="ftwUIbean" property="*"/>

<HTML>
<HEAD>
    <meta http-equiv="content-type" content="text/html; charset=UTF-8">
    <TITLE>
    <%=ftwUIbean.getResString("EVENT_HANDLING_LABEL")%>
    </TITLE>
    <LINK type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
    <LINK type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/actiononevents/css/ActionOnEvents.css'>
    <SCRIPT type='text/javascript' language='JavaScript' src='<%=MxOptions.URL_BASE%>/actiononevents/js/ActionOnEventsUtil.js'></SCRIPT>
    <SCRIPT src="/mxportal/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></SCRIPT>
    <SCRIPT>MxPortalWorkspaceSetHelpTopic("admin_events_newRule")</SCRIPT>

<%  ftwAoneUIbean.restoreSelections(out, loginBean); %>

    <SCRIPT language="javascript">
    function myOnLoadHandler()
    {
       restoreSelections();
    }

    function nextPage()
    {
       if (validateActions())
       {
          document.getElementById('frmNotification').action='<%=ftwUIbean.getResString("SUMMARY_PAGE_URL")%>';
          document.getElementById('frmNotification').submit();
       }
    }

    function prevPage()
    {
        document.getElementById('frmNotification').action='<%=ftwUIbean.getResString("EMAIL_PAGE_URL")%>';
        document.getElementById('frmNotification').submit();
    }

    function iframeLoaded()
    {
       var iframe = document.getElementById("frmDisplay");
       var h = iframe.contentWindow.document.body.scrollHeight;
       iframe.style.height = h;
       var w = iframe.contentWindow.document.body.scrollWidth;
       iframe.style.width = w;
       scrollBy(0, h);
    }

    function viewQuery()
    {
        var iframe = document.getElementById("frmDisplay");
        var queryId = document.getElementById("queryId").value;
        var idx = document.getElementById("queryId").selectedIndex;
        var queryName = document.getElementById("queryId").options[idx].text;

        iframe.src = "<%=ftwUIbean.getResString("VIEW_QUERY_PAGE_URL")%>?queryId="
                        + queryId + "&queryName=" + encodeURIComponent(queryName);
    }
    function selectionChanged()
    {
        var iframe = document.getElementById("frmDisplay");
        iframe.src = "<%=ftwAoneUIbean.getResString("BLANK_PAGE_URL")%>";
    }

    </SCRIPT>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% buttons.dumpHeadContent(out); %>
<% buttons2.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</HEAD>
<BODY LEFTMARGIN=0 onload="myOnLoadHandler()">
<A NAME="NAME_PAGE_TOP"></A>

<FORM ID="frmNotification" NAME="frmNotification" METHOD="POST" width="100%">
    <TABLE width='100%' border='0' cellspacing='0' cellpadding='0'>
    <TR valign='top'>
        <TD>
            <%int currentTab = 7;%>
            <%@include file="FirstTimeWizard_DrawTabs.txt"%>
        </TD>
        <TD style='padding-left:12px;' align='left' width='100%'>
            <TABLE  class="top-border-table" cellspacing='0' cellpadding='0' WIDTH="100%">
            <TR><TD>
                <FONT class="mxPageSubTitle">
                   <%=ftwUIbean.getResString("EVENT_HANDLING_LABEL")%>
                </FONT>
                <br>
                <%=ftwUIbean.getResString("EVENT_LINK")%>
                <p>
                <%=ftwUIbean.getResString("EVENT_HANDLING_MAIN_TEXT")%>
                <p>
                <p>
                <b><%=ftwUIbean.getResString("TASK_NAME_LABEL")%></b> &nbsp;  <%=ftwAoneUIbean.getTaskName()%>
                <br><br>
                <TABLE border="0"
                    cellspacing="0" cellpadding="0"
                    style="border:0px;background:white;margin:0;">
                    <!--Next Segment-->
                    <TR>
                        <TD align='left' nowrap>
                        <b><%=ftwUIbean.getResString("CRITERIA_LABEL")%></b>&nbsp;&nbsp;
                        </TD>

                        <TD nowrap>
                            <%=ftwAoneUIbean.getResString("EVENT_LIST_LABEL")%> &nbsp;
                        </TD>
                        <TD nowrap>
                            <SELECT size=1 width=35
                                onchange="selectionChanged()"
                                id='queryId' name='queryId'>
                                <%ActionOnEventsUtil.getEventQueryList(out, loginBean, ftwAoneUIbean.getQueryId());%>
                            </SELECT>
                            &nbsp;
                        </TD>
                        <td nowrap>
                            <% buttons2.dumpButtons(out); %>
                        </td>
                    </tr>
                </TABLE>
                <br>
                <%@include file="ftw_ActionDetail.txt"%>
            </TD></TR>
            </TABLE>
        </TD>
    </TR>
    </TABLE>
    <!-- End Data -->

   <input type='hidden' name='isAll' value="any">
   <input type='hidden' name='inframe' value="systems">
   <input type='hidden' name='incl0' value="">

</FORM>

<div style="margin-top:15px">
    <% buttons.dumpButtons(out); %>
</div>

    <iframe id="frmDisplay"
            style="width:100%; height:25; position:relative; visibility:visible"
            scrolling="auto" marginwidth="0"
            frameborder="0"
            onload="iframeLoaded()"
            src="<%=ftwAoneUIbean.getResString("BLANK_PAGE_URL")%>">
    </iframe>


<%-- need the following <BR> tags to display the full page in mozilla
---- ommitting these causes the bottom buttons to be truncated when
---- the page is rendered in the iframe on the manage page
--%>
<BR>
<BR>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</BODY>
</HTML>
