<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.core.subjects.*"%>
<%@ page import="com.hp.mx.portal.ui.*"%>
<%@ page import="com.hp.mx.portal.actiononevents.*"%>
<%@ page import="com.hp.mx.portal.search.MxEventSearchUI"%>
<%@ page import="java.util.*"%>
<%@ page import="com.hp.mx.database.GlobalSettings"%>


<jsp:useBean id="ftwProtoSettings" class="com.hp.mx.portal.settings.ProtocolSettingsBean" scope="session" />
<jsp:useBean id="protSetResBndl" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="ftwAutoDiscoveryBean" class="com.hp.mx.portal.discovery.AutoDiscoveryBean" scope="session" />
<jsp:useBean id="ftwUIbean" scope="session" class="com.hp.mx.portal.settings.FirstTimeWizardUIBean"/>
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="ftwAoneUIbean" scope="session" class="com.hp.mx.portal.actiononevents.ActionOnEventsUIBean" />

<%
    // REQUIRED: This line is required by Tomcat for i18n support.
    MxBean.jspInit(request, response);


    ftwUIbean.getResBundles(loginBean);

    // setup resources.
    protSetResBndl.init(loginBean, "ProtocolSettings");

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
    {
        return;
    }

    // Abort if the user isn't authorized.
    if ((!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.NOTIFICATION_SETTINGS_MODIFICATION_PRIVILEGE))
        || (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.EVENT_MODIFICATION_PRIVILEGE))
        || (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.TOOL_MODIFICATION_PRIVILEGE))
        || (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.SUBJECT_MODIFICATION_PRIVILEGE))
        )
    {
        %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
        <%
    }

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();
    MxTag btnCancelTag = new MxDefaultTag("btnCancel", ftwUIbean.getResString("BUTTON_CANCEL_LABEL"), "cancelWizard()");
    MxTag btnNextTag = new MxDefaultTag("btnNext", ftwUIbean.getResString("BUTTON_NEXT_LABEL"), "nextPage()");
    btnCancelTag.setAttr(MxTag.DISABLED, "false");
    btnNextTag.setAttr(MxTag.DISABLED, "false");
    buttons.addMxTag(btnCancelTag);
    buttons.addMxTag(btnNextTag);

    String referer = request.getHeader("referer");
    if (referer.indexOf(ftwUIbean.getResString("INTRODUCTION_PAGE_URL")) != -1)
    {
        //clear the doNotLaunch variables
        ftwUIbean.setDoNotLaunch("off");
    }
%>

<jsp:setProperty name="ftwUIbean" property="*"/>

<HTML>
<HEAD>
    <meta http-equiv="content-type" content="text/html; charset=UTF-8">
    <TITLE>
        Introduction
    </TITLE>
    <LINK type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
    <LINK type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/actiononevents/css/ActionOnEvents.css'>
    <SCRIPT type='text/javascript' language='JavaScript' src='<%=MxOptions.URL_BASE%>/actiononevents/js/ActionOnEventsUtil.js'></SCRIPT>

    <SCRIPT src="/mxportal/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></SCRIPT>
    <SCRIPT>MxPortalWorkspaceSetHelpTopic("admin_firstTimeWizard")</SCRIPT>

<%
    // Do the following initialization only once at begining of wizard
    if ((referer.indexOf(ftwUIbean.getResString("START_PAGE_URL")) != -1)||
        (referer.indexOf(ftwUIbean.getResString("AUTOSTART_PAGE_URL")) != -1))
    {
        //initialize beans
        ftwUIbean.initBean(out, loginBean, "new");
        ftwProtoSettings.initialize(loginBean, protSetResBndl, request );
        ftwAutoDiscoveryBean.initialize("SystemAutoDiscovery", loginBean);
        ftwAutoDiscoveryBean.clearAllErrorMessages();

        //initialize Event Handling settings
        if (ftwAoneUIbean.isTaskNameExist(loginBean, ftwUIbean.getResString("SYSTEM_EVENT_HANDLER")))
        {
            //save task to bean
            ftwAoneUIbean.initBean(out, loginBean, "edit");

            //clear out these values since ftw does not support them
            ftwAoneUIbean.setSendPage("off");
            ftwAoneUIbean.setLaunchApp("off");
            ftwAoneUIbean.setAssignEvent("off");
            ftwAoneUIbean.setForwardTrap("off");
            ftwAoneUIbean.setLogEvent("off");
            ftwAoneUIbean.setClearEvent("off");
            ftwAoneUIbean.setTimeFilter("");
            ftwAoneUIbean.setTimeFilterDisplayName("");
            ftwAoneUIbean.setTaskStatus("Enabled");
            ftwAoneUIbean.setWizardMode(Integer.toString(ActionOnEventsUIBean.WIZARD_MODE_SELECT_EVENT_LIST));
        }
        else
        {
            ftwAoneUIbean.initBean(out, loginBean, "new");
            ftwAoneUIbean.setTaskName(ftwUIbean.getResString("SYSTEM_EVENT_HANDLER"));
            ftwAoneUIbean.setSendMail("on");
        }
    }
%>

    <SCRIPT language="javascript">
    function myOnLoadHandler()
    {
    }
    </SCRIPT>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% buttons.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</HEAD>
<BODY LEFTMARGIN=0 onload="myOnLoadHandler()">
<A NAME="NAME_PAGE_TOP"></A>

<%
    /////////////////////////////////////////////////////////////////////////////////
    // IS THIS A POST?  If so, CANCEL button was pressed...set flag and close wizard.
    /////////////////////////////////////////////////////////////////////////////////
    if (request.getMethod().equals("POST"))
    {
        if ( ftwUIbean.getDoNotLaunch().equals("on") )
        {
            GlobalSettings.setProperty("showFtw", "false");
        }
        else
        {
            GlobalSettings.setProperty("showFtw", "true");
        }
%>
        <SCRIPT>MxPortalWorkspaceClose()</SCRIPT>
        </BODY>
        return;
<%
    }
%>

<FORM ID="frmNotification" NAME="frmNotification" METHOD="POST"
    class="mxForm" width="100%">
    <TABLE width='100%' border='0' cellspacing='0' cellpadding='0'>
    <TR valign='top'>
        <TD>
            <%
            int currentTab = 1;
            %>
            <%@include file="FirstTimeWizard_DrawTabs.txt"%>
        </TD>
        <TD style='padding-left:12px;' align='left' width='100%'>
            <TABLE  class="top-border-table"
                    WIDTH="100%">
                <TR><TD>
                    <B>
                    <FONT class="mxPageSubTitle">
                        <%=ftwUIbean.getResString("INTRODUCTION_LABEL")%>
                    </FONT>
                    </B>
                    <p>
                    <%=ftwUIbean.getResString("INTRODUCTION_MAIN_TEXT")%>
                    <p>

                    <br><br><br><br><br>
                    <input type="checkbox" id="id_doNotLaunch" value="on" name="doNotLaunch" <%= ftwUIbean.getDoNotLaunchStr() %>>
                    <LABEL for="id_doNotLaunch"><%=ftwUIbean.getResString("DO_NOT_LAUNCH")%></LABEL><br>
                    <br><br>
                </TD></TR>
            </TABLE>
        </TD>
    </TR>
    </TABLE>
    <!-- End Data -->

    <SCRIPT>
    function nextPage()
    {
        document.getElementById('frmNotification').action='<%=ftwUIbean.getResString("WBEM_PAGE_URL")%>';
        document.getElementById('frmNotification').submit();
    }

    function cancelWizard()
    {
        // Pop up a confirmation box
        if (confirm("<%=ftwUIbean.getResString("MSG_OK_EXIT")%>"))
        {
            document.getElementById('frmNotification').action='<%=ftwUIbean.getResString("INTRODUCTION_PAGE_URL")%>';
            document.getElementById('frmNotification').submit();
        }
    }
    </SCRIPT>

</FORM>

<div style="margin-top:15px">
    <% buttons.dumpButtons(out); %>
</div>

<%-- need the following <BR> tags to display the full page in mozilla
---- ommitting these causes the bottom buttons to be truncated when
---- the page is rendered in the iframe on the manage page
--%>
<BR>
<BR>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</BODY>
</HTML>
