<%
//
// $Source: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/settings/systemLinkConfig.jsp,v $
// $Revision: 1.13 $
// $Date: 2005/02/01 21:02:15 $
//
%>

<!-- ---------------------------------------------------------------------- -->
<!--  Put all your Java imports here -->
<!-- ---------------------------------------------------------------------- -->

<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.html.table.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.utilities.DebugOutput" %>
<%@ page import="com.hp.mx.utilities.DebugSubsystem" %>
<%@ page import="java.util.*" %>
<%@ page import="com.hp.mx.portal.ui.MxBean" %>
<%@ page import="com.hp.mx.database.GlobalSettings" %>
<%@ page import="com.hp.mx.portal.security.ServerCertificateBean" %>
<%@ page import="com.hp.mx.core.subjects.MxSubjectPrivilege" %>
<%@ page import="com.hp.mx.utilities.MxPathProperty" %>
<%@ page import="com.hp.mx.utilities.MxPathPropertyIfc" %>
<%@ page import="java.io.File" %>

<!-- ---------------------------------------------------------------------- -->
<!--  Put all your taglib imports here -->
<!-- ---------------------------------------------------------------------- -->

<!-- ---------------------------------------------------------------------- -->
<!--  Create all your beans here -->
<!-- ---------------------------------------------------------------------- -->

<!--  REQUIRED: This bean is used (later) to verify that this page is allowed to run -->
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />

<!-- My uniquely named beans -->
<jsp:useBean id="slc_BundleBean" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<!-- ---------------------------------------------------------------------- -->
<!--  Put one block of initialization Java code here -->
<!--  In general, keep Java code to a minimum. Put Java code into JavaBeans. -->
<!-- ---------------------------------------------------------------------- -->

<%
    // REQUIRED: Set necessary HTTP header attributes (for localization and page caching)
    MxBean.jspInit( request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    // This aborts the page if the user isn't authorized.
    if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.SECURITY_MODIFICATION_PRIVILEGE))
    {%>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
  <%}

    // Init the resource bundle
    slc_BundleBean.init(loginBean, "SystemLinkConfig");
%>
<%! String linkConfig = GlobalSettings.getProperty( GlobalSettings.DEVICE_LINK_FORMAT, GlobalSettings.DLF_DEFAULT); %>
<%
    if (request.getMethod().equalsIgnoreCase("POST"))
    {
        linkConfig = request.getParameter("systemLinkFormat");
        GlobalSettings.setProperty(GlobalSettings.DEVICE_LINK_FORMAT, linkConfig);

        // show acknowledgement of changed setting
        out.print( "<script>alert(\"" + slc_BundleBean.getString("syslinkcfg.settingchanged"));
        if (linkConfig.equalsIgnoreCase(GlobalSettings.DLF_DNS_STRING))
            out.print( slc_BundleBean.getString("syslinkcfg.dns"));
        else if (linkConfig.equalsIgnoreCase(GlobalSettings.DLF_IP_STRING))
            out.print( slc_BundleBean.getString("syslinkcfg.ip"));
        else
            out.print( slc_BundleBean.getString("syslinkcfg.name"));
        out.println( "\");</script>");
    }

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();
    buttons.addMxTag(new MxDefaultTag("btnOk", slc_BundleBean.getString("syslinkcfg.ok"), "document.getElementById('configForm').submit();"));
%>

<!-- ---------------------------------------------------------------------- -->
<!--  From here on, this is a well-formed HTML file -->
<!-- ---------------------------------------------------------------------- -->

<HTML>

<!-- ---------------------------------------------------------------------- -->
<!--  The HEAD block contains meta tags, the TITLE, style sheet links, -->
<!--  JavaScript links, and JavaScript code. -->
<!-- ---------------------------------------------------------------------- -->

<head>

<!-- ---------------------------------------------------------------------- -->
<!--  Most pages can get away with no title, because they are displayed -->
<!--  inside of a frame. -->
<!-- ---------------------------------------------------------------------- -->

<!-- ---------------------------------------------------------------------- -->
<!--  Any additional JavaScript links go here -->
<!-- ---------------------------------------------------------------------- -->

    <!--  COMMONLY USED: This includes the browser-based portal API -->
    <script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
    <script src="<%=MxOptions.URL_BASE%>/js/utilities.js" language="JavaScript" type="text/javascript"></script>

<!-- ---------------------------------------------------------------------- -->
<!--  Put all additional JavaScript here -->
<!-- ---------------------------------------------------------------------- -->

<script language='JavaScript' type='text/javascript'>
   MxPortalWorkspaceSetHelpTopic("admin_security_systemLinkConfiguration");
</script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxPortalRender.dumpHeadContent(out); %>
<% buttons.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</HEAD>

<!-- ---------------------------------------------------------------------- -->
<!--  The BODY block begins here -->
<!-- ---------------------------------------------------------------------- -->

<BODY>

<%= slc_BundleBean.getString("syslinkcfg.instructions") %>

<blockquote>
<form action="systemLinkConfig.jsp" method="POST" id="configForm">
  <table cellpadding="1"><tr><td>

  <input type="radio" name="systemLinkFormat" value="<%= GlobalSettings.DLF_NAME_STRING %>" id="dlf<%= GlobalSettings.DLF_NAME_STRING %>" >
  <label for="dlf<%= GlobalSettings.DLF_NAME_STRING %>"><%= slc_BundleBean.getString("syslinkcfg.name") %></label><br>

  <input type="radio" name="systemLinkFormat" value="<%= GlobalSettings.DLF_IP_STRING %>" id="dlf<%= GlobalSettings.DLF_IP_STRING %>" >
  <label for="dlf<%= GlobalSettings.DLF_IP_STRING %>"><%= slc_BundleBean.getString("syslinkcfg.ip") %></label><br>

  <input type="radio" name="systemLinkFormat" value="<%= GlobalSettings.DLF_DNS_STRING %>" id="dlf<%= GlobalSettings.DLF_DNS_STRING %>" >
  <label for="dlf<%= GlobalSettings.DLF_DNS_STRING %>"><%= slc_BundleBean.getString("syslinkcfg.dns") %></label><br>

  </table>
</form>
<script>
   document.getElementById('dlf<%= linkConfig %>').checked = 'true';
</script>
</blockquote>
<br>

<div style="margin-top:15px">
    <% buttons.dumpButtons(out); %>
</div>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</BODY>
</HTML>
