<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*, com.hp.mx.portal.taskandjob.InitialPSPInstall.InitialPSPInstallCommandToolParameters"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskWizardInstance"%>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="pspResourceSettings" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="initialPSPInstallBean" class="com.hp.mx.portal.taskandjob.InitialPSPInstall.InitialPSPInstallBean" scope="session" />
<jsp:useBean id="taskWizardBean" class="com.hp.mx.portal.taskandjob.MxTaskWizard" scope="session"/>

<%
    MxBean.jspInit(request, response);

    // Get the Instance Data for this Task Wizard Instance
    String               timeStamp = request.getParameter("timeStamp");
    MxTaskWizardInstance inst      = (MxTaskWizardInstance)taskWizardBean.getInstance(timeStamp);
%>

<html>
    <head>
        <title><%= pspResourceSettings.getString("panel4.title") %></title>
        </title>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/taskandjob/css/taskAndJob.css'>
        <link href="<%= MxOptions.URL_BASE %>/css/MxPortalEx.css" rel="stylesheet" type="text/css">
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/taskWizard.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxPortalApi.js'></script>
        <script language='javascript'> MxPortalWorkspaceSetHelpTopic("useTools_psp_install");</script>
        <script language='javascript' type='text/javascript'>
        function retrieveSupportPack()
        {
            var iframe = document.getElementById("wait");
            iframe.contentWindow.document.location.replace("InitialPSPInstallCPP4Wait.jsp");
        }

        function finishValidate(errorCode)
        {
            if (errorCode == 0)
            {
                enableButtons();
            }
        }

        function enableButtons()
        {
            ourButtonManager.enableButtonById('runNowBtn');
            ourButtonManager.enableButtonById('scheduleBtn');
        }

        function runNowButtonFunction()
        {
            //document.taskParamSaveForm.submit();
            return true;
        }

        function scheduleButtonFunction()
        {
            return runNowButtonFunction();
        }

        </script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxButton.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

    </head>

    <body>
    <%
    ///////////////////////////////////////////////////////////////////////////
    // IS THIS A POST?  Check data validity and redirect
    ///////////////////////////////////////////////////////////////////////////
    if (request.getMethod().equals("POST"))
    {
        // Set the task user parameters
        InitialPSPInstallCommandToolParameters ctp = initialPSPInstallBean.getTaskUserParameters();
        inst.setTaskUserParameters(ctp);
    %>
        <script>loadWizardNextStep();</script>
    <%
    }
    ///////////////////////////////////////////////////////////////////////////
    // THIS IS NOT A POST - Display normally
    ///////////////////////////////////////////////////////////////////////////
    else
    {
        %>



        <script>
            setWizardStepText('<%= pspResourceSettings.getString("panel4.title") %>');
        </script>

        <!-- frame for hidden actions -->
        <iframe id='action' name='action' style='display:none; width:100%; height:120'
                scrolling='no' marginwidth='0' frameborder='0' src='InitialPSPInstallGetSupportPack.jsp'>
        </iframe>

        <!-- frame for wait icon -->
        <iframe id='wait' name='wait' style='width:100%; height:120'
                scrolling='no' marginwidth='0' frameborder='0' src='<%=MxOptions.URL_BASE%>/home/MxBlank.html'>
        </iframe>

        <form id="taskParamSaveForm" name="taskParamSaveForm" action="InitialPSPInstallCPP4.jsp" method="post">
        <input type='hidden' id='timeStamp' name='timeStamp' value='<%=timeStamp%>'>
        </form>
        <script>
            setFormSubmitName("taskParamSaveForm")
        </script>



        <script language='javascript' type='text/javascript'>
            displayTaskWizardButtons(); // display Prev/Schedule/Run Now buttons
            // disable the "Run Now" and "Schedule" buttons
            ourButtonManager.disableButtonById('runNowBtn');
            ourButtonManager.disableButtonById('scheduleBtn');
            retrieveSupportPack();
        </script>
    <%
    }
    %>

<% MxHtmlUtil.dumpBodyEnd(out); %>

    </body>
</html>
