<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.core.controllers.VCRepositoryController"%>
<%@ page import="com.hp.mx.portal.ui.*"%>


<jsp:useBean id="initialPSPInstallBean" class="com.hp.mx.portal.taskandjob.InitialPSPInstall.InitialPSPInstallBean" scope="session" />
<jsp:useBean id="pspResourceSettings" class="com.hp.mx.portal.res.MxResourceBean" scope="page" />
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>

<%
    MxBean.jspInit(request, response);
%>

<head>
    <meta http-equiv="Refresh" content="5">
    <link href="<%= MxOptions.URL_BASE %>/css/MxPortalEx.css" rel="stylesheet" type="text/css">
<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxButton.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>
</head>
<body>
    <%
    pspResourceSettings.init(loginBean, "InitialPSPInstall");

    out.println(pspResourceSettings.getString("panel4.explain"));
    %>

    <br><br><br>

    <%
        int status = initialPSPInstallBean.getSupportPackDownloadStatus();
        int percentComplete = initialPSPInstallBean.getPercentDownloadComplete();
        if (percentComplete >= 0 && percentComplete < 100)
        {
            // In process of downloading, display percent complete
            out.println("<b>"+ pspResourceSettings.getString("panel4.percentComplete") +
                        "</b>&nbsp; " + Integer.toString(percentComplete) + "%");
        }
        else
        {
            // Download failed or completed, display status and notify parent
            if (status != VCRepositoryController.PSPDOWNLOAD_SUCCESS && status != VCRepositoryController.PSPDOWNLOAD_IN_PROGRESS)
            {
                out.println("<font class='errorTextBold'>");
                out.println(pspResourceSettings.getString("downloadStatus"+status));
                out.println("</font>");
            }
            else
                out.println(pspResourceSettings.getString("downloadStatus"+status));

            out.println("<script>parent.finishValidate("+status+")</script>");
        }
    %>
</body>
