<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="MpAddUserBean" class="com.hp.mx.portal.taskandjob.MpTools.MpAddUser.MxMpAddUser" scope="session"/>
<jsp:useBean id="taskWizardBean" class="com.hp.mx.portal.taskandjob.MxTaskWizard" scope="session"/>


<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*"%>

<%@ page import="com.hp.mx.portal.res.MxResourceBean"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskWizardInstance"%>
<%@ page import="com.hp.mx.portal.taskandjob.MpTools.MpAddUser.MxMpAddUserCommandToolParameters"%>
<%@ page import="com.hp.mx.portal.ui.MxBean"%>
<%@ page import="com.hp.mx.portal.ui.MxOptions"%>

<%
    // set header info
    MxBean.jspInit(request, response);

    // check to see if the loginBean session has timed out
    if (loginBean.checkLogoutConditionForWebPage(pageContext) == true)
    {
        return;
    }

    String timeStamp=request.getParameter("timeStamp");
    MxTaskWizardInstance inst=(MxTaskWizardInstance) taskWizardBean.getInstance(timeStamp);
    // is this a task edit?
    boolean editTask = (request.getParameter("edit") != null);

    if ((MpAddUserBean.isFirstTime() == true) || (editTask == true))
    {
        // initialize the Bean (resource bundle, etc)
        MpAddUserBean.initialize(loginBean, (MxMpAddUserCommandToolParameters)inst.getTaskUserParameters());
    }

    // get the resource bundle for localized string display
    MxResourceBean rb = MpAddUserBean.getRB();

    // use this value to populate the password fields.  If it is the default, "abfd98%"
    // we don't set the value.  This default value is used to disguise the length
    String passwordValue = "";

%>
<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC
    "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
    <title></title>
    <link rel="stylesheet" type="text/css" href='<%=MxOptions.URL_BASE%>/taskandjob/css/taskAndJob.css'/>
    <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/taskWizard.js'>
    </script>
    <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js'>
    </script>
    <script src="../../js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
    </script>
    <script language='javascript' type='text/javascript'>
    // username and password values
    var loginid        = null;
    var password        = null;
    var passwordConfirm = null;
    /////////////////////////////////////
    // checkRequiredFields()
    /////////////////////////////////////
    function checkRequiredFields()
    {
        var enableButton = true;
        if (document.getElementById("loginid").value == '')
        {
            enableButton = false;
        }

        // if all passes, then enable the Next button
        // else, disable it
        enableWizardButtons(enableButton);
    }
    /////////////////////////////////////
    // enableWizardButtons()
    /////////////////////////////////////
    function enableWizardButtons(enable)
    {
        // enable or disable the "Schedule" button
        enableButton(document.getElementById("scheduleBtn"), false);
        // enable or disable the "Run Now" button
        enableButton(document.getElementById("runNowBtn"), enable);
    }
    /////////////////////////////////////
    // scheduleButtonFunction()
    /////////////////////////////////////
    function scheduleButtonFunction()
    {
        if(document.getElementById("loginid").value=="Admin"){
                    var return_value = confirm('<%=rb.getString("USR_DELETE_ADMIN1")%>' + '\n'+ '<%=rb.getString("USR_DELETE_ADMIN2")%>' + '\n' +'<%=rb.getString("PROMPT_CONTINUE")%>');
                      if ( return_value == false ){
                          setReloadOnError(false);
                          checkRequiredFields();
                          return false;
                      }
        }

        setReloadOnError(false);
        return true;

    }
    /////////////////////////////////////
    // runNowButtonFunction()
    /////////////////////////////////////
    function runNowButtonFunction()
    {
        return scheduleButtonFunction();
    }
    /////////////////////////////////////
    // setFocus()
    /////////////////////////////////////
    function setFocus()
    {
        var field = document.getElementById('loginid');

        if ((field != null) && (field.disabled == false))
        {
            field.focus();
        }
    }
    </script>
<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxButton.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>
</head>

    <body>
<%
    ///////////////////////////////////////////////////////////////////////////
    // IS THIS A post?  Check data validity and redirect
    ///////////////////////////////////////////////////////////////////////////
    if (request.getMethod().equals("POST") == true)
    {
        // Check if the password is the default. If it is, don't save it off

 %>

    <jsp:setProperty name="MpAddUserBean" property="loginid" value="<%=request.getParameter(\"loginid\")%>"/>
<%

        if (MpAddUserBean.isLoginUserInfoValid() == true)
        {

            MpAddUserBean.setArgumentValues();
            MxMpAddUserCommandToolParameters params = MpAddUserBean.getToolParameters();
            inst.setTaskUserParameters(params);

            // User data is valid, go to the next wizard step
            %>
    <script language='javascript' type='text/javascript'>
    loadWizardNextStep();
    </script>
            <%
        }
        else
        {
            // User data is invalid, redisplay the same wizard step
            %>

    <script language='javascript' type='text/javascript'>
    loadWizardCurrentStep();
    </script>
            <%
        }
    }

    ///////////////////////////////////////////////////////////////////////////
    // THIS IS NOT A post - Display normally
    ///////////////////////////////////////////////////////////////////////////
    else
    {
 %>

    <script language='javascript' type='text/javascript'>
    setWizardStepText('<%=rb.getString("WIZARD_TITLE_DELETE")%>');
    </script>
    <script language="JavaScript">
            MxPortalWorkspaceSetHelpTopic("useTools_mgmtProc_deleteUser") ;
    </script>

   <form id="deleteUserForm" name="changeUserForm" action="MpDeleteUserCPP1.jsp" method="post">
        <table cellpadding='0' cellspacing='0' border='0' style="white-space: nowrap;">
            <tr>
                <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                <td>
                    <span style="color:#FF0000; font-size:10px;"><%=rb.getString("REQUIRED_FIELD")%>&nbsp;*</span>
                </td>
            </tr>
            <tr>
                <td height="17px" colspan="3" ></td>
            </tr>
        </table>


        <table border="0"  cellspacing="0" cellpadding="0" style="white-space: nowrap;">
            <tr>
                <td rowspan="40">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                <td height="17px" colspan="2"><%=rb.getString("LOGINID")%><span style="color:#FF0000;">&nbsp;*</span>&nbsp;&nbsp;</td>
                <td><input type="text" id="loginid" name="loginid" value="" size="20"  onkeyup='checkRequiredFields()' /></td>
            </tr>
       </table>
     <input type='hidden' id='timeStamp' name='timeStamp' value='<%=timeStamp%>' />
      </form>
    <br/>
    <br/>

    <script language='javascript' type='text/javascript'>
    setFormSubmitName("deleteUserForm")
    // display Previous/Next
    displayTaskWizardButtons();
    // set the focus to the 'username' field
    setFocus();
    // check required fieldsto allow page advancement
    checkRequiredFields();
    </script>
<%
    }
%>

    </body>
<% MxHtmlUtil.dumpBodyEnd(out); %>
</html>
