<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="tasksBean" class="com.hp.mx.portal.taskandjob.MxTaskAndJob" scope="session"/>

<%@ page import="com.hp.mx.html.core.MxButton"%>
<%@ page import="com.hp.mx.html.core.MxHtmlUtil"%>
<%@ page import="com.hp.mx.html.table.MxTableController"%>
<%@ page import="com.hp.mx.html.table.MxTableView2"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobResourceBundle"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobInstance"%>
<%@ page import="com.hp.mx.portal.ui.MxBean"%>
<%@ page import="com.hp.mx.portal.ui.MxOptions"%>

<%
    // set header info
    MxBean.jspInit(request, response);

    // check to see if the loginBean session has timed out
    if (loginBean.checkLogoutConditionForWebPage(pageContext) == true)
    {
        return;
    }

    // attempt to get "timeStamp" param.  if found, get Instance and check for Table Messages
    // if no timeStamp, then initialze All Jobs
    String               taskAndJobTimeStamp = request.getParameter("taskAndJobTimeStamp");
    MxTaskAndJobInstance inst                = null;
    MxTableController    jobsTableController = null;
    MxTableView2         jobsTableView       = null;
    String               select              = null;
    String               hidden              = null;

    if (taskAndJobTimeStamp != null)
    {
        inst                = (MxTaskAndJobInstance)tasksBean.getInstance(taskAndJobTimeStamp);
        jobsTableController = inst.getJobsTableController();

        // if this page was loaded just to give the table controller a message, then don't
        // continue processing this page
        if (jobsTableController.checkUrlForControllerMessages(request, out) == true)
        {
            return;
        }
    }
    else
    {
        // generate a new timeStamp for this Instance
        taskAndJobTimeStamp = tasksBean.getNewTimeStamp();

        // By default, we want to have the first Task selected
        //
        // If we are being displayed as the result of a user creating a Task, then we will have
        // the newly ceated Task selected.
        //
        // If we are being displayed as the result of a user clicking on the Lauching Task from the
        // Job List, then we will have the Launching Task selected.
        //
        select              = request.getParameter("select");
        hidden              = request.getParameter("hidden");
        // first time this page is displayed, we can initialize MxTaskAndJob
        inst                = tasksBean.initializeAllJobs(loginBean, select, taskAndJobTimeStamp);
        jobsTableController = inst.getJobsTableController();
        jobsTableView       = inst.getJobsTableView();
    }

    int totalNumJobs = inst.getTotalNumJobs();
    int numJobs      = inst.getNumJobs();

    // resource bundle
    MxTaskAndJobResourceBundle rb = inst.getRB();

    StringBuffer total = new StringBuffer(50);
    total.append(numJobs);

    if (totalNumJobs != numJobs)
    {
        total.append(" ");
        total.append(rb.getString("OF"));
        total.append(" ");
        total.append(totalNumJobs);
    }
%>

<html>
    <head>
        <title></title>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/taskandjob/css/taskAndJob.css'>
        <script language='javascript' type='text/javascript' src='/SessionReset.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxBrowser.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxPortalApi.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/allTasks.js'></script>
        <script language='javascript' type='text/javascript'>
            // to allow scrollbars to appear when horizontal scrolling is needed
            var IFRAME_TOP = true;
            var minWidth   = 0;
            // we won't request another refresh until the previous request was answered
            var refreshed = true;
            // used by child pages
            var hidden    = '<%=hidden%>';
            // set the help topic html file
            MxPortalWorkspaceSetHelpTopic('<%=tasksBean.getAllJobsHelpID()%>');
            // set the Tool Description for the Task Results page
            MxPortalWorkspaceSetSubtitleHtml('<%=rb.getString("JOB_LIST_DESCRIPTION")%>');
            // our refresh rate for the currently selected JOB
            var refreshTimeout = REFRESH_TIMEOUT;
            ///////////////////////////////
            // refresh all pages
            ///////////////////////////////
            function autoRefresh(reset)
            {
                // set the timer to go off again
                if ((reset != null) && (reset == true))
                {
                    setTimeout("autoRefresh(true)", refreshTimeout);
                }
                // don't send another request until the previous request has completed
                if (refreshed == false)
                {
                    return;
                }
                // set to false, the refresh page sets this back to true when it is complete
                refreshed = false;
                // tell the table to update its content
                if (<%=hidden%> == null)
                {
                    MxTableRefreshInPlace('ID_MY_TABLE');
                }
                // update the Number of Jobs displayed & divHeight of MxTable
                var iframe = document.getElementById('update');
                var url    = '<%=MxOptions.URL_BASE%>/taskandjob/updateAllJobs.jsp?taskAndJobTimeStamp=<%= taskAndJobTimeStamp %>'
                iframe.contentWindow.document.location.replace(url);
                // check for the ** fullJobResults.jsp ** page.  If it's present
                // call its autoRefresh() function
                iframe = document.getElementById('jobResults');
                if ((iframe != null) && (iframe.contentWindow.autoRefresh != null))
                {
                    iframe.contentWindow.autoRefresh();
                }
            }
            ///////////////////////////////
            // resize the MxTable to be flush with the right browser edge
            ///////////////////////////////
            function myResize()
            {
                if (<%=hidden%> == null)
                {
                    var w = Math.max(minWidth, MxBrowserGetBodyWidth(-NETSCAPE_SCROLLBAR_WIDTH, 0));
                    MxTableSetWidth('ID_MY_TABLE', w);

                    var windowWidth = MxPortalGetWorkspaceFrame().offsetWidth - NETSCAPE_SCROLLBAR_WIDTH;
                    var newWidth    = (minWidth >= windowWidth) ? minWidth : '100%';
                    // set width of our <iframe>
                    document.getElementById('totalTable').style.width  = newWidth;
                    document.getElementById('buttonDiv').style.width = newWidth;

                    setTimeout('myResize()', RESIZE_TIMEOUT);
                }
            }
            ///////////////////////////////
            // the function called when the selection changes on the MxTable
            ///////////////////////////////
            function mySelectionChanged(szIdTable, iRow, bSelected)
            {
                // zero out minWidth
                minWidth = 0;
                // disable the Stop and Delete buttons - selectJob.jsp
                // will enable the appropriate ones for the newly
                // selected Job
                ourButtonManager.disableButtonById('btnStop');
                ourButtonManager.disableButtonById('btnDelete');
                // set TimeOut to call the selectJob() function - need
                // the MxTable to perform its actions
                setTimeout("selectJob(JOB_FORMAT_FULL, <%= taskAndJobTimeStamp %>, true)", ACTION_TIMEOUT);
            }
            // This page will hold the value of the "rowHeight" used to properly set
            // the height of the Tables based off of the Font DPI
            var rowHeight     = 0;
            var iconRowHeight = 0;
            var titleHeight   = 0;
            ///////////////////////////////
            // set the Table height based off of a CELL height given the users font size (DPI)
            ///////////////////////////////
            function setTableHeight()
            {
                var iframe     = document.getElementById('DPI');
                rowHeight      = iframe.contentWindow.getCellHeight();
                iconRowHeight  = iframe.contentWindow.getCellHeightWithIcons();
                titleHeight    = iframe.contentWindow.getTitleHeight();

                if (<%=hidden%> == null)
                {
                    var rowsDisplayed = <%=numJobs%>;

                    if ((rowsDisplayed < JOB_LIST_MIN_DISPLAYED) && (rowsDisplayed > 0))
                    {
                        rowsDisplayed = JOB_LIST_MIN_DISPLAYED;
                    }

                    if (rowsDisplayed > JOB_LIST_MAX_DISPLAYED)
                    {
                        rowsDisplayed = JOB_LIST_MAX_DISPLAYED;
                    }

                    var divHeight = (iconRowHeight * rowsDisplayed) + titleHeight;
                    MxTableSetHeight('ID_MY_TABLE', divHeight);
                }
            }
            ///////////////////////////////
            // myOnLoad()
            ///////////////////////////////
            function myOnLoad()
            {
                myResize();
                setTableHeight();
                selectJob(JOB_FORMAT_FULL, <%= taskAndJobTimeStamp %>);
                setTimeout("autoRefresh(true)", refreshTimeout);
            }
            ///////////////////////////////
            // removeInstance()
            ///////////////////////////////
            function removeInstance()
            {
                document.getElementById("action").contentWindow.document.location.replace("<%= MxOptions.URL_BASE %>/taskandjob/removeTaskAndJobInstance.jsp?taskAndJobTimeStamp=<%= taskAndJobTimeStamp %>");
            }
        </script>
<%
    MxHtmlUtil.dumpHeadBegin(out);
    MxButton.dumpHeadContent(out);
    jobsTableView.dumpHeadContent(out);
    MxHtmlUtil.dumpHeadEnd(out);
%>
    </head>

    <body onLoad='myOnLoad()' onUnload='removeInstance()'>
<%
    if (hidden == null)
    {
%>
        <!-- <table> to display 'tip' and totol Jobs displayed -->
        <table id='totalTable' border='0' cellpadding='0' cellspacing='0' style='width:100%'>
            <tr>
                <td id='tip' style='width:50%' nowrap>
                    <font class='info'><%=rb.getString("TASK_RESULTS_TIP")%></font>&nbsp;
                </td>
                <td id='total' style='width:50%' align='right' nowrap>
                    <b><%=rb.getString("TOTAL")%>:</b>&nbsp;<%=total.toString()%>
                </td>
            </tr>
        </table>

        <div id='listDiv' style='width:100%'>
<%
    jobsTableView.dumpWholeTable(out);
%>
        </div>
        <div id='textDiv' align='center' style='width:100%'>
            <font class='note'>
                <script language='javascript' type='text/javascript'>
                    document.write('<i><b><%=rb.getString("EMPTY_JOBS")%></b></i>');
                </script>
            </font>
        </div>

        <table id="buttonDiv" border="0" cellpadding="0" cellspacing="0" style="width:100%">
            <tr>
                <td>
                    <table border="0" cellpadding="0" cellspacing="0" align="right">
                        <tr>
                            <td>
                                <script language="javascript" type="text/javascript">
                                    document.write(ourButtonManager.makeMxButton('btnStop', '<%=rb.getString("STOP_BUTTON")%>', 'stopSelectedJob(JOB_FORMAT_FULL, "<%=taskAndJobTimeStamp%>")'));
                                    ourButtonManager.initButtonById('btnStop');
                                    ourButtonManager.disableButtonById('btnStop');
                                </script>
                            </td>
                            <td>
                                <script language="javascript" type="text/javascript">
                                    document.write(ourButtonManager.makeMxButton('btnDelete', '<%=rb.getString("DELETE_BUTTON")%>', 'deleteSelectedJob(JOB_FORMAT_FULL, "<%=taskAndJobTimeStamp%>")'));
                                    ourButtonManager.initButtonById('btnDelete');
                                    ourButtonManager.disableButtonById('btnDelete');
                                </script>
                            </td>
                        </tr>
                    </table>
                </td>
            </tr>
        </table>
<%
    } // end (hidden == null)
%>
        <iframe id='jobResults' name='jobResults' style='position:relative; visibility:hidden; width:100%; height:0'
                scrolling='no' marginwidth='0' frameborder='0' src='<%=MxOptions.URL_BASE%>/home/MxBlank.html'>
        </iframe>

        <iframe id='DPI' name='DPI' style='position:relative; visibility:hidden; width:0; height:0'
                scrolling='no' marginwidth='0' frameborder='0' src='<%=MxOptions.URL_BASE%>/taskandjob/DPI.html'>
        </iframe>
        <iframe id='selectJob' name='selectJob' style='position:relative; visibility:hidden; width:0; height:0'
                scrolling='no' marginwidth='0' frameborder='0' src='<%=MxOptions.URL_BASE%>/home/MxBlank.html'>
        </iframe>
        <iframe id='update' name='update' style='position:relative; visibility:hidden; width:0; height:0'
                scrolling='no' marginwidth='0' frameborder='0' src='<%=MxOptions.URL_BASE%>/home/MxBlank.html'>
        </iframe>
        <iframe id='stopJob' name='stopJob' style='position:relative; visibility:hidden; width:0; height:0'
                scrolling='no' marginwidth='0' frameborder='0' src='<%=MxOptions.URL_BASE%>/home/MxBlank.html'>
        </iframe>
        <iframe id='deleteJob' name='deleteJob' style='position:relative; visibility:hidden; width:0; height:0'
                scrolling='no' marginwidth='0' frameborder='0' src='<%=MxOptions.URL_BASE%>/home/MxBlank.html'>
        </iframe>
        <iframe id='action' name='action' style='position:relative; visibility:hidden; width:0; height:0'
                scrolling='no' marginwidth='0' frameborder='0' src='<%=MxOptions.URL_BASE%>/home/MxBlank.html'>
        </iframe>

        <script language='javascript' type='text/javascript'>
            // from a "Run Now" task.  If we were told to hide the table (hidden != null)
            // then select the job so the task instance results are shown faster.  Otherwise,
            // set the table height
            if (<%=hidden%> == null)
            {
                // if there are no jobs, explain it in text
                displayEmptyTable((<%=totalNumJobs%> == 0), this);
                MxTableSetHeight('ID_MY_TABLE', TABLE_TITLE_DEFAULT_HEIGHT);
            }
        </script>
<%
    MxHtmlUtil.dumpBodyEnd(out);
%>
    </body>
</html>
