<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="tasksBean" class="com.hp.mx.portal.taskandjob.MxTaskAndJob" scope="session"/>

<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobMessages"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobResourceBundle"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobInstance"%>
<%@ page import="com.hp.mx.portal.ui.MxBean"%>
<%@ page import="com.hp.mx.portal.ui.MxOptions"%>

<%
    // set header info
    MxBean.jspInit(request, response);

    // check to see if the loginBean session has timed out
    if (loginBean.checkLogoutConditionForWebPage(pageContext) == true)
    {
        return;
    }

    String                     taskAndJobTimeStamp = request.getParameter("taskAndJobTimeStamp");
    MxTaskAndJobInstance       inst                = (MxTaskAndJobInstance)tasksBean.getInstance(taskAndJobTimeStamp);
    MxTaskAndJobMessages       messages            = inst.getMessages();
    MxTaskAndJobResourceBundle rb                  = inst.getRB();

    StringBuffer opt1Msg = new StringBuffer(100);
    StringBuffer opt2Msg = new StringBuffer(100);

    opt1Msg.append("<b>");
    opt1Msg.append(rb.getString("PRINT_TEXT_1"));
    opt1Msg.append("</b> ");
    opt1Msg.append(rb.getString("PRINT_TEXT_2"));

    opt2Msg.append("<b>");
    opt2Msg.append(rb.getString("PRINT_TEXT_3"));
    opt2Msg.append("</b> ");
    opt2Msg.append(rb.getString("PRINT_TEXT_4"));

    messages.setMessageType(MxTaskAndJobMessages.MSG_TYPE_OPTION);
    messages.setMessage(opt1Msg.toString());
    messages.setMessage(opt2Msg.toString());
%>

<html>
    <head>
        <title></title>
        <script language='javascript' type='text/javascript' src='/SessionReset.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js'></script>
        <script language='javascript' type='text/javascript'>
            // the ID to the window - allows us to call the js functions within that window
            var windowID = askOption(<%= taskAndJobTimeStamp %>);
            setTimeout("checkForAnswer()", ACTION_TIMEOUT);
            //
            function checkForAnswer()
            {
                if (windowID.closed == true)
                {
                    windowID = 0;
                    return;
                }

                if ((windowID.isOkButtonClicked != null) && (windowID.isOkButtonClicked() == true))
                {
                    // get the option that was selected --> CURRENT or ALL
                    var type = 'multi';

                    if (windowID.getSelectedOption() == 0) // option 0 == CURRENT
                    {
                        type = 'single';
                    }

                    windowID.close();

                    // print the report
                    window.open('printReport.jsp?type=' + type + '&taskAndJobTimeStamp=<%= taskAndJobTimeStamp %>',
                                'PrintReport',
                                'top=50,left=50,width=800,height=600,scrollbars=yes', true);
                }
                else
                {
                    setTimeout("checkForAnswer()", ACTION_TIMEOUT);
                }
            }
        </script>
    </head>

    <body>
    </body>
</html>
