<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="tasksBean" class="com.hp.mx.portal.taskandjob.MxTaskAndJob" scope="session"/>

<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobResourceBundle"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobInstance"%>
<%@ page import="com.hp.mx.portal.ui.MxBean"%>
<%@ page import="com.hp.mx.portal.ui.MxOptions"%>

<%
    // set header info
    MxBean.jspInit(request, response);

    // check to see if the loginBean session has timed out
    if (loginBean.checkLogoutConditionForWebPage(pageContext) == true)
    {
        return;
    }

    String               taskAndJobTimeStamp = request.getParameter("taskAndJobTimeStamp");
    MxTaskAndJobInstance inst                = (MxTaskAndJobInstance)tasksBean.getInstance(taskAndJobTimeStamp);

    String                     jobFormat = request.getParameter("jobFormat");
    String                     jobID     = inst.getSelectedJobID();
    MxTaskAndJobResourceBundle rb        = inst.getRB();

    StringBuffer msgRunning = new StringBuffer(200);
    StringBuffer msgDelete  = new StringBuffer(200);

    msgRunning.append(rb.getString("DELETE_JOB_1"));
    msgRunning.append(" ");
    msgRunning.append(jobID);
    msgRunning.append(" ");
    msgRunning.append(rb.getString("DELETE_JOB_2"));
    msgRunning.append("  ");
    msgRunning.append(rb.getString("DELETE_JOB_3"));

    msgDelete.append(rb.getString("DELETE_JOB_4"));
    msgDelete.append(" ");
    msgDelete.append(jobID);
    msgDelete.append(rb.getString("DELETE_JOB_5"));

    // is the job currently running?
    boolean jobRunning = inst.isSelectedJobRunning();
%>

<html>
    <head>
        <title></title>
        <script language='javascript' type='text/javascript' src='/SessionReset.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js'></script>
        <script language='javascript' type='text/javascript'>
            // ask confirm question or display error message
            if (<%=jobRunning%> == true)
            {
                alert("<%=msgRunning.toString()%>");
                // can't delete?  Re-enable the delete button
                parent.ourButtonManager.enableButtonById('btnDelete');
                parent.deleteOpen = false;
            }
            else
            {
                var answer = confirm("<%=msgDelete.toString()%>");

                if (answer == true)
                {
                    // disable these buttons while we delete the job
                    parent.ourButtonManager.disableButtonById('btnStop');
                    parent.ourButtonManager.disableButtonById('btnDelete');

                    var iframe = null;

                    // set taskInstanceResult/jobResults frame to MxBlank.html
                    if (<%=jobFormat%> == JOB_FORMAT_BASIC)
                    {
                        iframe = parent.parent.document.getElementById('taskInstanceResults');
                    }
                    else
                    {
                        iframe = parent.document.getElementById('jobResults');
                    }

                    // set iframe to MxBlank.html
                    iframe.contentWindow.document.location.replace('<%=MxOptions.URL_BASE%>/home/MxBlank.html');
                    iframe.style.visibility = 'hidden';

                    // do the delete
                    document.location.replace('<%=MxOptions.URL_BASE%>/taskandjob/deleteJob.jsp?taskAndJobTimeStamp=<%= taskAndJobTimeStamp %>');
                }
                else
                {
                    // cancelled the delete?  Re-enable the delete button
                    parent.ourButtonManager.enableButtonById('btnDelete');
                    parent.deleteOpen = false;
                }
            }
        </script>
    </head>

    <body>
    </body>
</html>
