<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="tasksBean" class="com.hp.mx.portal.taskandjob.MxTaskAndJob" scope="session"/>

<%@ page import="com.hp.mx.portal.ui.MxBean"%>
<%@ page import="com.hp.mx.portal.ui.MxOptions"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobMessages"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobInstance"%>

<%
    // set header info
    MxBean.jspInit(request, response);

    // check to see if the loginBean session has timed out
    if (loginBean.checkLogoutConditionForWebPage(pageContext) == true)
    {
        return;
    }

    String               taskAndJobTimeStamp = request.getParameter("taskAndJobTimeStamp");
    MxTaskAndJobInstance inst                = (MxTaskAndJobInstance)tasksBean.getInstance(taskAndJobTimeStamp);

    // delete the currently selected Task
    boolean success = inst.deleteTask();
%>

<html>
    <head>
        <title></title>
        <script language='javascript' type='text/javascript' src='/SessionReset.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js'></script>
        <script language='javascript' type='text/javascript'>
<%
    // if we fail to delete the Task - we can re-enable the "Delete" button
    // otherwise, leave it disabled until the next has ben selected
    if (success == false)
    {
        MxTaskAndJobMessages msg = inst.getMessages();
%>
        // pop-up error message
        alert("<%=msg.getMessage()%>");
        // re-enable the buttons
        parent.ourButtonManager.enableButtonById('btnRun');
        parent.ourButtonManager.enableButtonById('btnEdit');
        parent.ourButtonManager.enableButtonById('btnDelete');
<%
    }
    else
    {
%>
        parent.autoRefresh(false);
<%
    }
%>
        // either way, the delete window has been closed
        parent.deleteOpen = false;

        </script>
    </head>

    <body>
    </body>
</html>
