<%--
//$Source: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/taskandjob/diskThreshParameters.jsp,v $
//$Revision: 1.13 $
//$Date: 2005/05/06 21:44:33 $
--%>
<!-- ---------------------------------------------------------------------- -->
<!--  Java imports                                                                       -->
<!-- ---------------------------------------------------------------------- -->
<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.help.*"%>
<%@ page import="com.hp.mx.core.tools.diskthresh.DiskThresholdDataModel"%>
<%@ page import="com.hp.mx.core.subjects.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskWizardInstance"%>
<!-- ---------------------------------------------------------------------- -->
<!--  Create all beans                                                                -->
<!-- ---------------------------------------------------------------------- -->
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="taskWizardBean" class="com.hp.mx.portal.taskandjob.MxTaskWizard" scope="session"/>

<jsp:useBean id="diskThreshResBndl" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="diskThresh" class="com.hp.mx.portal.taskandjob.DiskThreshBean" scope="session" />

<%
    MxBean.jspInit(request, response);
    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    // Get the Instance Data for this Task Wizard Instance
    String               timeStamp = request.getParameter("timeStamp");
    MxTaskWizardInstance inst      = (MxTaskWizardInstance)taskWizardBean.getInstance(timeStamp);

    diskThreshResBndl.init(loginBean, "DiskThreshold");

    // setup bean
    diskThresh.initialize(loginBean, diskThreshResBndl);

    if ( inst.isFirstTime() )
    {
        DiskThresholdDataModel diskThreshDataModel = null;
        if ( inst.getTaskUserParameters() == null )
        {
            diskThreshDataModel = new DiskThresholdDataModel();
            inst.setTaskUserParameters( diskThreshDataModel );
        }
        else // edit
        {
            diskThreshDataModel = (DiskThresholdDataModel)inst.getTaskUserParameters();
        }
        diskThresh.setConfigObj(diskThreshDataModel);

        diskThresh.clearAllErrorMessages();
    }
    else
    {
        DiskThresholdDataModel diskThreshDataModel = (DiskThresholdDataModel) inst.getTaskUserParameters();
        diskThresh.setConfigObj(diskThreshDataModel);
    }

%>

<html>
  <head>
    <title><%=diskThreshResBndl.getString("title")%></title>
    <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/taskandjob/css/taskAndJob.css'>
    <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxPortalApi.js'></script>
    <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js'></script>
    <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/taskWizard.js'></script>

    <script language='javascript' type='text/javascript'>

    MxPortalWorkspaceSetHelpTopic("useTools_diskThresholds_set"); //** get right topic


    function validateAll()
    {
        if (checkNumber(document.ConfigForm.critical) == false)
        {
            alert(" <%=diskThreshResBndl.getString("error.critmustbenumb")%>" );
            hilite( theForm.critical );
            return false;
        }

    }
    // Check for valid numbers
    function checkNumber( field )
    {
        // Check for valid numbers
        inputStr = field.value;
        for (var i=0; i < inputStr.length; i++)
        {
            var oneChar = inputStr.charAt(i);
            if (oneChar < "0" || oneChar > "9")
            {
                return false;
            }
        }


        var x = parseInt( field.value );
        if ( (x < 0) || (x > 100) )
        {
            return false;
        }
    }

    function hilite( editWindow )
    {
        editWindow.focus();
        editWindow.select();
        return true;
    }
    </script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxPortalRender.dumpHeadContent(out); %>
<% MxButton.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

  </head>

  <body >
<%
    ///////////////////////////////////////////////////////////////////////////
    // IS THIS A POST?  Check data validity and redirect
    ///////////////////////////////////////////////////////////////////////////
    if (request.getMethod().equalsIgnoreCase("POST"))
    {
        System.out.println("Interval is "+request.getParameter("agentPollInterval"));
        // Pull data from parameters and store in taskArgs...
%>
        <jsp:setProperty name="diskThresh" property="*" />
<%

        if (diskThresh.updateConfigObj() )
        {
            // User data is valid, go to the next wizard step
            inst.setTaskUserParameters(diskThresh.getConfigObj() );
%>
            <script>
                loadWizardNextStep();
            </script>
<%
            return;
        }
        else
        {
            //
            // User data is invalid, redisplay the same wizard step
            %>
            <script>
                 loadWizardCurrentStep();
            </script>
            <%
        }
    }

    ///////////////////////////////////////////////////////////////////////////
    // THIS IS NOT A POST - Display normally
    ///////////////////////////////////////////////////////////////////////////
    else
    {

        if (diskThresh.hasErrorMessages() )
        {
            diskThresh.displayErrorMessagesInHtml(out);
        }


%>
        <form method="post" id="SetDiskThreshold"  onSubmit="return validateAll()"  name="SetDiskThreshold" action="">

            <table>
      <tr align="left" valign="center">
        <td>
            <%=diskThreshResBndl.getString("critprompt")%>
        </td><td>
            <input TYPE="text" NAME="critical" MAXLENGTH="3"
            VALUE="<jsp:getProperty name="diskThresh" property="critical" />"
            SIZE="3">
        </td>
      </tr>
      <tr align="left" valign="center">
        <td>
            <%=diskThreshResBndl.getString("critresprompt")%>
        </td><td>
            <input TYPE="text" NAME="criticalReset" MAXLENGTH="3"
            VALUE="<jsp:getProperty name="diskThresh" property="criticalReset" />"
            SIZE="3">
        </td>
      </tr>
      <tr align="left" valign="center">
        <td>
            <%=diskThreshResBndl.getString("warnprompt")%>
        </td><td>
            <input TYPE="text" NAME="warning" MAXLENGTH="3"
            VALUE="<jsp:getProperty name="diskThresh" property="warning" />"
            SIZE="3">
        </td>
      </tr>
      <tr align="left" valign="center">
        <td>
            <%=diskThreshResBndl.getString("warnresprompt")%>
        </td><td>
            <input TYPE="text" NAME="warningReset" MAXLENGTH="3"
            VALUE="<jsp:getProperty name="diskThresh" property="warningReset" />"
            SIZE="3">
        </td>
      </tr>
        <tr align="left" valign="center">
        <td>
            <%=diskThreshResBndl.getString("intervalprompt")%>
        </td><td>
            <input TYPE="text" NAME="agentPollInterval" MAXLENGTH="5"
            VALUE="<jsp:getProperty name="diskThresh" property="agentPollInterval" />"
            SIZE="5">
        </td>
      </tr>
</table>





            <input type='hidden' id='timeStamp' name='timeStamp' value='<%=timeStamp%>'>
        </form>
        <script language='javascript' type='text/javascript'>
            setWizardStepText("<%=diskThreshResBndl.getString("steptext")%>");
            displayTaskWizardButtons()
            setFormSubmitName('SetDiskThreshold');
        </script>
<%
    }
%>

<% MxHtmlUtil.dumpBodyEnd(out); %>

  </body>
</html>
