<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="tasksBean" class="com.hp.mx.portal.taskandjob.MxTaskAndJob" scope="session"/>

<%@ page import="com.hp.mx.core.jobmanager.MxDefaultJobFormatter"%>
<%@ page import="com.hp.mx.html.core.MxHtmlUtil"%>
<%@ page import="com.hp.mx.html.table.MxTableController"%>
<%@ page import="com.hp.mx.html.table.MxTableView2"%>
<%@ page import="com.hp.mx.html.table.MxTableSortingModel"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobResourceBundle"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobInstance"%>
<%@ page import="com.hp.mx.portal.ui.MxBean"%>
<%@ page import="com.hp.mx.portal.ui.MxOptions"%>

<%
    // set header info
    MxBean.jspInit(request, response);

    // check to see if the loginBean session has timed out
    if (loginBean.checkLogoutConditionForWebPage(pageContext) == true)
    {
        return;
    }

    String                taskAndJobTimeStamp = request.getParameter("taskAndJobTimeStamp");
    MxTaskAndJobInstance  inst                = null;
    MxDefaultJobFormatter formatter           = null;

    if ((taskAndJobTimeStamp == null) || (taskAndJobTimeStamp.equalsIgnoreCase("null") == true))
    {
        inst                = (MxTaskAndJobInstance)tasksBean.initializeDefaultFormatter(loginBean);
        taskAndJobTimeStamp = tasksBean.DEFAULT_FORMATTER;
        formatter           = (MxDefaultJobFormatter)inst.getJobFormatter();
        formatter.setTimeStamp(taskAndJobTimeStamp);
        formatter.initialize(request.getParameter("jobID"), loginBean.getLocale(), loginBean.getTimeZone(), loginBean.getMxUser(), request.getParameter("msgType"));
    }
    else
    {
        inst      = (MxTaskAndJobInstance)tasksBean.getInstance(taskAndJobTimeStamp);
        formatter = (MxDefaultJobFormatter)inst.getJobFormatter();
    }

    MxTableController tableController = formatter.getJobTargetTableController();
    MxTableView2      tableView       = formatter.getJobTargetTableView();

    // do we need to abort?
    if (tableController.checkUrlForControllerMessages(request, out))
    {
        return;
    }

    MxTaskAndJobResourceBundle rb = formatter.getRB();

    // get numTargets from default formatter
    int numTargets = formatter.getNumTargets();
%>

<html>
    <head>
        <title></title>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/taskandjob/css/taskAndJob.css'>
        <script language='javascript' type='text/javascript' src='/AutoRefreshingSessionReset.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxBrowser.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxPortalApi.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js'></script>
        <script language='javascript' type='text/javascript'>
            var timeStamp = '<%=taskAndJobTimeStamp%>';
            ////////////////////////////////////////////////
            // selectTarget()
            ////////////////////////////////////////////////
            function selectTarget(userSelect)
            {
                // if 'userSelect' == true, then allow the selectJob.jsp file
                // to reset the Session Timeout value
                if (userSelect == null)
                {
                    userSelect = false;
                }

                // tell MxTaskAndJob what TaskJob is selected
                var url = '<%=MxOptions.URL_BASE%>/taskandjob/selectTarget.jsp?userSelect=' + userSelect + '&taskAndJobTimeStamp=<%=taskAndJobTimeStamp%>';
                parent.document.getElementById('selectTarget').contentWindow.document.location.replace(url);
            }
            ////////////////////////////////////////////////
            // mySelectionChanged()
            ////////////////////////////////////////////////
            function mySelectionChanged(szIdTable, iRow, bSelected)
            {
                // set TimeOut to call the selectTarget() function - need
                // the MxTable to perform its actions
                setTimeout('selectTarget(true)', ACTION_TIMEOUT);
            }
            ////////////////////////////////////////////////
            // setTableHeight()
            ////////////////////////////////////////////////
            function setTableHeight()
            {
                var iframe        = parent.document.getElementById('DPI');
                var rowsDisplayed = <%=numTargets%>;

                if ((rowsDisplayed < TARGET_LIST_MIN_DISPLAYED) && (rowsDisplayed > 0))
                {
                    rowsDisplayed = TARGET_LIST_MIN_DISPLAYED;
                }

                if (rowsDisplayed > TARGET_LIST_MAX_DISPLAYED)
                {
                    rowsDisplayed = TARGET_LIST_MAX_DISPLAYED;
                }

                var divHeight = (iframe.contentWindow.getCellHeightWithIcons() * rowsDisplayed) + iframe.contentWindow.getTitleHeight();
                MxTableSetHeight('ID_MY_TABLE', divHeight);
            }
            //////////////////////////////
            // setOurIFrameHeight()
            //////////////////////////////
            function setOurIFrameHeight()
            {
                var iframe = parent.document.getElementById(this.name);

                if (iframe == null)
                {
                    return;
                }

                iframe.style.height = document.getElementById('scrollDiv').scrollHeight;
            }
            ////////////////////////////////////////////////
            // setOurIFrameWidth()
            ////////////////////////////////////////////////
            function setOurIFrameWidth()
            {
                var minWidth = 0;

                if (<%=request.getParameter("taskAndJobTimeStamp")%> != null)
                {
                    minWidth = getIframeTop(this).minWidth;
                }

                var windowWidth = MxPortalGetWorkspaceFrame().offsetWidth - NETSCAPE_SCROLLBAR_WIDTH;
                var newWidth    = (minWidth >= windowWidth) ? minWidth : '100%';
                // set width of our <iframe>
                parent.document.getElementById(this.name).style.width = newWidth;

                setTimeout('setOurIFrameWidth()', RESIZE_TIMEOUT);
            }
            ////////////////////////////////////////////////
            // myOnLoad()
            ////////////////////////////////////////////////
            function myOnLoad()
            {
                selectTarget(false);
                setTableHeight();
                setOurIFrameHeight();
                // get the width our element takes up
                var element    = document.getElementById('summaryTable');
                var myMinWidth = element.offsetWidth;
                // attempt to set this as the minimum (there may
                // already be a larger value that is the minimum)
                if (<%=request.getParameter("taskAndJobTimeStamp")%> != null)
                {
                    setMinWidth(myMinWidth);
                }
                // set our results table to 100% to use all available space
                element.style.width = '100%';
                // normal startup procedures
                setOurIFrameWidth();
                myResize();
            }
            ////////////////////////////////////////////////
            // myResize()
            ////////////////////////////////////////////////
            function myResize()
            {
                MxTableSetWidth("ID_MY_TABLE", MxDomGetBodyWidth());
                document.getElementById('totalsTable').style.width = MxDomGetBodyWidth();
            }
        </script>
<%
    MxHtmlUtil.dumpHeadBegin(out);
    tableView.dumpHeadContent(out);
    MxHtmlUtil.dumpHeadEnd(out);
%>
    </head>

    <body onLoad='myOnLoad()' onResize='myResize()'>

        <div id="scrollDiv">

            <table id='summaryTable' border='0' cellspacing='0' cellpadding='0'>
                <tr><td>&nbsp;</td></tr>
                <tr>
                    <td nowrap>
                        <b><%= rb.getString("SUMMARY_STATUS") %>:&nbsp;</b><%= formatter.getTaskSummary() %>
                    <td>
                </tr>
            </table>

            <br>

            <table id='totalsTable' border='0' cellpadding='0' cellspacing='0' style='width:100%'>
                <tr>
                    <td style='width:50%' nowrap>
                        <font class='info'><%=rb.getString("TARGETS_TIP")%></font>&nbsp;
                    </td>
                    <td id='totalTargets' style='width:50%' align='right' nowrap>
                        <b><%=rb.getString("TOTAL")%>:</b>&nbsp;<%=numTargets%>
                    </td>
                </tr>
            </table>
<%
    tableView.dumpWholeTable(out);
%>
        </div>
<%
    MxHtmlUtil.dumpBodyEnd(out);
%>
    </body>
</html>
