<%--
//$Source: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/taskandjob/myToolsManage.jsp,v $
//$Revision: 1.34 $
//$Date: 2005/06/08 20:00:14 $
--%>
<!-- ---------------------------------------------------------------------- -->
<!--  Put all your Java imports here -->
<!-- ---------------------------------------------------------------------- -->
<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="javax.swing.table.AbstractTableModel" %>
<%@ page import="com.hp.mx.utilities.DebugOutput" %>
<%@ page import="com.hp.mx.utilities.DebugSubsystem" %>
<%@ page import="com.hp.mx.html.table.*" %>
<%@ page import="com.hp.mx.core.objectmodel.MxObjectID" %>
<%@ page import="com.hp.mx.core.toolmanager.*" %>
<%@ page import="com.hp.mx.core.client.*" %>


<!-- ---------------------------------------------------------------------- -->
<!--  Create all your beans here -->
<!-- ---------------------------------------------------------------------- -->
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="myToolsRbSettings" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="myCustomToolsUIBean" class="com.hp.mx.portal.taskandjob.MyCustomToolsUIBean" scope="session" />
<jsp:useBean id="debugBean" class="com.hp.mx.portal.ui.MxBean" scope="session" />
<jsp:useBean id="myCustomToolsTableView" class="com.hp.mx.html.table.MxTableView2" scope="session"/>
<jsp:useBean id="myCustomToolsController" class="com.hp.mx.html.table.MxTableController" scope="session"/>
<jsp:useBean id="myCustomToolsTableSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session"/>

<!-- ---------------------------------------------------------------------- -->
<!--  Put one block of initialization Java code here -->
<!--  In general, keep Java code to a minimum. Put Java code into JavaBeans. -->
<!-- ---------------------------------------------------------------------- -->
<%!
    public String myToolsTableDomId = "ID_MY_APPLICATIONLAUNCH_TOOLS_TABLE";
    public DebugSubsystem myCustomToolsDebug = DebugOutput.getDebugSubsystem("AppLaunch");
    public String url = MxOptions.URL_BASE+"/settings/Blank.html";
%>

<%
    // REQUIRED: This line is required by Tomcat for i18n support.
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    // Do we need to abort?
    if (myCustomToolsController.checkUrlForControllerMessages(request, out)) return;


    // EXAMPLE: follow references to this bean for i18n support using resource bundles
    myToolsRbSettings.init(loginBean, "MyCustomTools");

    // Initialize the bean if we are not POSTing
    if (!request.getMethod().equals("POST"))
    {
        myCustomToolsUIBean.initialize(loginBean, myToolsRbSettings);
    }

    // Setup the display of the source system list
    if (myCustomToolsController.isFirstTime())
    {
        myCustomToolsTableSelectionModel.setSelectionMode(MxTableSelectionModel.MULTIPLE_INTERVAL_SELECTION);
        myCustomToolsTableView.setId(myToolsTableDomId);
        myCustomToolsTableView.setOnSelectionChange("mySelectionChanged");
        myCustomToolsTableView.setUrlHandler(request.getRequestURI());
    }

    AbstractTableModel tableModel = myCustomToolsUIBean.getMyToolsTableModel();
    myCustomToolsController.setTableModelWithSorting(tableModel);
    myCustomToolsController.setSelectionModel(myCustomToolsTableSelectionModel);
    myCustomToolsController.setTableView(myCustomToolsTableView);

    url = MxOptions.URL_BASE+"/settings/Blank.html";

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();
    buttons.addMxTag(new MxDefaultTag("btnNew", myToolsRbSettings.getString("myCustomTools.manage.NEW_BTN"), "newTool()"));
    buttons.addMxTag(new MxDefaultTag("btnEdit", myToolsRbSettings.getString("myCustomTools.manage.EDIT_BTN"), "showEditPage()"));
    buttons.addMxTag(new MxDefaultTag("btnRun", myToolsRbSettings.getString("myCustomTools.manage.RUNNOW_SCHEDULE_BTN"), "runTool()"));
    buttons.addMxTag(new MxDefaultTag("btnDelete", myToolsRbSettings.getString("myCustomTools.manage.DELETE_BTN"), "deleteTool()"));
%>

<html>
  <head>
    <link href="<%= MxOptions.URL_BASE %>/css/MxPortalEx.css" rel="stylesheet" type="text/css">
    <script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
    <script src="<%=MxOptions.URL_BASE%>/js/MxBrowser.js" language="JavaScript" type="text/javascript"></script>
    <script src="<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js" type="text/javascript" language="JavaScript" ></script>
    <script src="<%=MxOptions.URL_BASE%>/js/utilities.js" type="text/javascript" language="JavaScript" ></script>

    <script language="javascript">
        var selectedRow = null;
        /////////////////////////////////////////////////
        // showEditPage()
        /////////////////////////////////////////////////
        function showEditPage()
        {
            var el = document.getElementById("clickedBtnName");
            if (el != null)
            {
               el.value = "Edit";
            }
            document.myCustomToolsForm.submit();
        }


        function runTool()
        {
            var el = document.getElementById("clickedBtnName");
            if (el != null)
            {
              el.value = "RunNow";
            }
            document.myCustomToolsForm.submit();
        }

        function newTool()
        {
            var el = document.getElementById("clickedBtnName");
            if (el != null)
            {
               el.value = "New";
            }
            var iFrame1 = document.getElementById("toolDetailInfo");
            if (iFrame1 != null)
            {
                iFrame1.contentWindow.document.location.replace("myToolsNew.jsp?mode=newFromList");

            }
        }

        function deleteTool()
        {
            var aSel = MxTableGetSelections("<%= myToolsTableDomId %>");
            if (aSel.length == 0)
            {
                alert("<%= myToolsRbSettings.getString("myCustomTools.error.noToolSelection") %>");
                return;
            }

            var proceed = false;
            if (aSel.length == 1)
            {
                proceed = confirm ("<%= myToolsRbSettings.getString("myCustomTools.msg.delete1") %>")
            }
            else
            {
                proceed = confirm ("<%= myToolsRbSettings.getString("myCustomTools.msg.delete2") %>")
            }

            if (proceed)
            {
                var el = document.getElementById("clickedBtnName");
                if (el != null)
                {
                   el.value = "Delete";
                }
                ourButtonManager.disableButtonById('btnDelete');
                document.myCustomToolsForm.submit();
            }
        }

        // The function called to perform selection change
        function mySelectionChanged(szIdTable, iRow, bSelected)
        {
            selectedRow = iRow;
            var aSel = MxTableGetSelections(szIdTable);
            setButtonsState(aSel.length);
            resetBottomPane();
        }

        function resetBottomPane()
        {
            var el = document.getElementById("toolDetailInfo");
            if (el != null)
            {
               el.src= "<%=MxOptions.URL_BASE%>/settings/Blank.html";
            }
        }

        function setButtonsState(length)
        {
          // Set the buttons:
          if (length == 0)
          {
            ourButtonManager.enableButtonById('btnNew');
            ourButtonManager.disableButtonById('btnEdit');
            ourButtonManager.disableButtonById('btnRun');
            ourButtonManager.disableButtonById('btnDelete');
          }
          else if (length == 1)
          {
            ourButtonManager.enableButtonById('btnNew');
            ourButtonManager.enableButtonById('btnEdit');
            ourButtonManager.enableButtonById('btnRun');
            ourButtonManager.enableButtonById('btnDelete');
          }
          else if (length > 1)
          {
            ourButtonManager.enableButtonById('btnNew');
            ourButtonManager.disableButtonById('btnEdit');
            ourButtonManager.disableButtonById('btnRun');
            ourButtonManager.enableButtonById('btnDelete');
          }
        }

        function myOnLoad()
        {
           // EXAMPLE (DO NOT ACCIDENTALLY COPY THE TOPIC): This sets the help context.
           MxPortalWorkspaceSetHelpTopic("useTools_manageTools");
           MxPortalManageMenuRefresh();
           setButtonsState(<%=myCustomToolsTableSelectionModel.getSelectedIndices().length%>);
           setTimeout("myOnResize()", 500);
        }

        function myOnResize()
        {
           resize_w();
        }

        function resize_w()
        {
           var w = Math.max(0, MxBrowserGetBodyWidth(0, 0));
           MxTableSetWidth("<%= myToolsTableDomId %>", w-50);
        }
    </script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% buttons.dumpHeadContent(out); %>
<% myCustomToolsTableView.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

  </head>

  <body onLoad="myOnLoad()" onResize="myOnResize()">
    <%
    String refreshParam = request.getParameter("refresh");
    boolean refreshMode = (refreshParam != null);
    myCustomToolsDebug.log(10, " refreshMode= " + refreshMode);

    if (!refreshMode)
    {
       myCustomToolsUIBean.clearAllErrorMessages();
    }

    ///////////////////////////////////////////////////////////////////////////
    // IS THIS A POST?  Check data validity and redirect
    ///////////////////////////////////////////////////////////////////////////
    //debugBean.displayJspParamsHtml(request, out);
    //debugBean.displayJspParamsToConsole(request);
    if (request.getMethod().equals("POST"))
    {
        myCustomToolsDebug.log(20, "myToolsManage.jsp: PROCESSING POST...");

        String clickedBtnNameValue = "";

        // YES! Read the source system name from the user entry field
        clickedBtnNameValue = request.getParameter("clickedBtnName");
        myCustomToolsDebug.log(20, "    clickedBtnName " + clickedBtnNameValue);
        if (clickedBtnNameValue.equalsIgnoreCase("RunNow"))
        {
           // Figure out the selected row tool id
           int selectedRow [] = myCustomToolsTableSelectionModel.getSelectedIndices();
           myCustomToolsDebug.log(20, "myToolsManage.jsp: Selected Row " + selectedRow.length);

           MxObjectID toolId = myCustomToolsUIBean.getToolId(selectedRow[0]);
           String htmlTitle = myCustomToolsUIBean.getToolNameFromId(toolId);
           url = MxOptions.URL_BASE+"/taskandjob/runTaskWizard.jsp?id="+toolId;
           %>
           <script language="javascript">
             MxPortalWorkspaceSetTitleHtml('<%=htmlTitle%>');
             document.location.replace("<%=url%>");
           </script>
           <%
           return;
        }
        else if (clickedBtnNameValue.equalsIgnoreCase("Edit"))
        {
           int selectedRow [] = myCustomToolsTableSelectionModel.getSelectedIndices();
           myCustomToolsDebug.log(20, "myToolsManage.jsp: EDIT : Selected Row " + selectedRow.length);
           MxObjectID toolId = myCustomToolsUIBean.getToolId(selectedRow[0]);
           if (toolId != null)
           {
               url = "myToolsNew.jsp?mode=edit&toolID="+ toolId;
               myCustomToolsDebug.log(10, " URL TO REPLACE TO while editing " + url);
           }
           else
            {
                out.println("<script>");
                out.println("    MxPortalManageMenuRefresh();");
                out.println("    document.location.replace('myToolsManage.jsp?refresh=true');");
                out.println("</script>");
                return;
            }
        }
        else if (clickedBtnNameValue.equalsIgnoreCase("Delete"))
        {
           int selectedRow [] = myCustomToolsTableSelectionModel.getSelectedIndices();
           myCustomToolsUIBean.deleteTool(selectedRow);
           myCustomToolsDebug.log(10, "Tool deleted!  (success=" + myCustomToolsUIBean.isDataValid() + ") About to refresh menu...");
           out.println("<script>");
           out.println("    MxPortalManageMenuRefresh();");
           if (myCustomToolsUIBean.isDataValid())
           {
                myCustomToolsTableSelectionModel.setAllIndicesSelected(false);
           }
           // Need to refresh the table...tool may have been deleted
           out.println("    document.location.replace('myToolsManage.jsp?refresh=true');");
           out.println("</script>");
           return;
        }
    }

    // Display any error messages
    if (myCustomToolsUIBean.hasErrorMessages())
    {
        // Display plurally-correct label
        if (myCustomToolsUIBean.getErrorMessageList().size() == 1)
        {
            %><div class="errorTextBold"><%= myToolsRbSettings.getString("myCustomToolsError.label.single")%>:</div><%
        }
        else
        {
            %><div class="errorTextBold"><%= myToolsRbSettings.getString("myCustomToolsError.label.multiple")%>:</div><%
        }

        // Finally, display the error message(s)
        myCustomToolsUIBean.displayErrorMessagesInHtml(out);

        myCustomToolsUIBean.clearAllErrorMessages();
    }

    ///////////////////////////////////////////////////////////////////////////
    // THIS IS NOT A POST - Display normally
    ///////////////////////////////////////////////////////////////////////////
    %>
    <!-- <table> to display 'tip' and total Devices displayed -->
    <table border='0' cellpadding='0' cellspacing='0' width="100%">
      <tr>
         <td id='totalCustomTools' width="50%" align='right' nowrap>
            <b><%=myToolsRbSettings.getString("myCustomTools.manage.Total")%>:</b>&nbsp;<%=myCustomToolsUIBean.getRowCount()%>
         </td>
      </tr>
    </table>
       <%
             // DISPLAY THE LIST OF Custom commands FOR THIS TOOL
             myCustomToolsTableView.dumpWholeTable(out);
             myCustomToolsTableView.setHeight("150");
       %>
    <br>
       <div style="margin-top:15px">
            <% buttons.dumpButtons(out); %>
       </div>
        <form id="myCustomToolsForm" name="myCustomToolsForm" action="myToolsManage.jsp" method="post">
          <input type="hidden" id="clickedBtnName" name="clickedBtnName">
        </form>
    <br>
    <iframe id="toolDetailInfo" style="width:100%; height:800; position:relative; visibility:visible"
            scrolling="no" marginwidth="0" frameborder="0" src="<%=url%>">
    </iframe>
    <br>

<% MxHtmlUtil.dumpBodyEnd(out); %>

  </body>
</html>
