<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="tasksBean" class="com.hp.mx.portal.taskandjob.MxTaskAndJob" scope="session"/>

<%@ page import="com.hp.mx.html.core.MxButton"%>
<%@ page import="com.hp.mx.html.core.MxHtmlUtil"%>
<%@ page import="com.hp.mx.core.jobmanager.MxDefaultJobFormatter"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobInstance"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxJobList"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxJobData"%>
<%@ page import="com.hp.mx.portal.ui.MxBean"%>
<%@ page import="com.hp.mx.portal.ui.MxOptions"%>

<%
    // set header info
    MxBean.jspInit(request, response);

    // check to see if the loginBean session has timed out
    if (loginBean.checkLogoutConditionForWebPage(pageContext) == true)
    {
        return;
    }

    String                taskAndJobTimeStamp = request.getParameter("taskAndJobTimeStamp");
    MxTaskAndJobInstance  inst                = (MxTaskAndJobInstance)tasksBean.getInstance(taskAndJobTimeStamp);
    MxDefaultJobFormatter formatter           = (MxDefaultJobFormatter)inst.getJobFormatter();
    MxJobList             jobList             = new MxJobList(MxJobData.JOB_FORMAT_PRINT, loginBean);

    jobList.addJob(formatter.getJobID());
    jobList.selectJob(0);

    String type = request.getParameter("type");
%>

<html>
    <head>
        <title></title>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/taskandjob/css/taskAndJob.css'>
        <script language='javascript' type='text/javascript' src='/SessionReset.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js'></script>
<%
    MxHtmlUtil.dumpHeadBegin(out);
    MxButton.dumpHeadContent(out);
    MxHtmlUtil.dumpHeadEnd(out);
%>
    </head>

    <body>
<%
    jobList.dumpSelectedJobResultInfo(out);
    formatter.dumpSelectedPrintOutput(out, type);

    MxHtmlUtil.dumpBodyEnd(out);
%>
    </body>
</html>
