<%
//
// $Source: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/taskandjob/replicateAgentCfgSource.jsp,v $
// $Revision: 1.45 $
// $Date: 2005/05/06 21:44:33 $
//
%>

<%@ page info="Replicate Agent Settings - Source system selection"%>

<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.core.nodemanager.MxNode" %>
<%@ page import="com.hp.mx.core.controllers.MxNodeController" %>
<%@ page import=" com.hp.mx.core.tools.groupconfiguration.GCTaskModel" %>
<%@ page import="com.hp.mx.html.table.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.security.DetermineTrustStatus" %>
<%@ page import="com.hp.mx.utilities.DebugOutput" %>
<%@ page import="com.hp.mx.utilities.DebugSubsystem" %>
<%@ page import="com.hp.mx.core.nodemanager.MxNodeName" %>
<%@ page import="java.util.*" %>
<%@ page import="javax.swing.table.AbstractTableModel" %>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskWizardInstance"%>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="taskWizardBean" class="com.hp.mx.portal.taskandjob.MxTaskWizard" scope="session" />
<jsp:useBean id="gcBean" class="com.hp.mx.portal.taskandjob.GroupCfgBean" scope="session"/>
<jsp:useBean id="gcTableSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session"/>
<jsp:useBean id="gcTableView" class="com.hp.mx.html.table.MxTableView2" scope="session"/>
<jsp:useBean id="gcController" class="com.hp.mx.html.table.MxTableController" scope="session"/>
<jsp:useBean id="gcBundle" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<%!
    /** **********************************************************************
     * The debug object
     ************************************************************************ */
    public DebugSubsystem groupConfigurationDebug =
        DebugOutput.getDebugSubsystem("gcBean");

    public String srcTableDomId = "ID_MY_GC_SRC_DVC_TABLE";
%>
<%
    groupConfigurationDebug.log(5, "[replicateAgentCfgSource.jsp] Page loading ****************************************");
    // REQUIRED: This line is required by Tomcat for i18n support.
    MxBean.jspInit(request, response);

    // REQUIRED: Abort the page & redirect if the session has timed out
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
    {
        return;
    }

    // Get the Instance Data for this Task Wizard Instance
    String               timeStamp = request.getParameter("timeStamp");
    MxTaskWizardInstance inst      = (MxTaskWizardInstance)taskWizardBean.getInstance(timeStamp);

    // Set up the resource file
    gcBundle.init(loginBean, "ReplicateAgentSettings");

    // Do we need to abort?
    if (gcController.checkUrlForControllerMessages(request, out)) return;

    // Reset the bean
    if ( inst.isFirstTime() && !gcBean.isEditMode())
    {
        groupConfigurationDebug.log(5, "[replicateAgentCfgSource.jsp] Resetting bean");
        gcBean.resetBean(true);
    }

    // This will only happen if we're re-entering this page after the user
    // hits the Last Update button
    String rowToUpdate = request.getParameter("updateSelectedRow");
    int onEnterSelectedDeviceKey = 0;
    boolean refreshMode = false;
    if (rowToUpdate != null && !rowToUpdate.equals(""))
    {
        groupConfigurationDebug.log(5, "[replicateAgentCfgSource.jsp] PROCESSING REFRESH");
        onEnterSelectedDeviceKey = gcBean.getSelectedDeviceKey();
        refreshMode = true;
        groupConfigurationDebug.log(5, "[replicateAgentCfgSource.jsp]onEnterSelectedDeviceKey=" + onEnterSelectedDeviceKey);
        MxNode dev = MxNodeController.getDefaultControllerNoEx().getNodeByKey(onEnterSelectedDeviceKey);
        // Update the trust status of this system in the database
        if (dev != null)
        {
            DetermineTrustStatus.makeTrustRequest(dev);
        }
    }

    // Initialize the bean (only when NOT posting) and we are NOT here
    // from the Task Wizard's PREV button
    boolean viaPrevious = (request.getParameter("prev") != null);
    if (!viaPrevious && !request.getMethod().equals("POST"))
    {
        groupConfigurationDebug.log(5, "[replicateAgentCfgSource.jsp] Initialize the Bean (Mmmmm....Beans....)");
        if (!gcBean.initialize(loginBean, (GCTaskModel)inst.getTaskUserParameters()))
        {
            // If it failed, it's because there are no CIMOM systems identified
            %><jsp:forward page="replicateAgentCfgError.jsp?gcError=GCSourceError.noPossibleSources&wiz=1" /><%
        }
    }


    // Setup the display of the source system list
    if (gcController.isFirstTime())
    {
        groupConfigurationDebug.log(5, "[replicateAgentCfgSource.jsp] First Time initialization of table view and controller");
        gcTableSelectionModel.setSelectionMode(MxTableSelectionModel.SINGLE_SELECTION);
        gcTableView.setId(srcTableDomId);
        gcTableView.setOnSelectionChange("mySelectionChanged");
        gcTableView.setUrlHandler(request.getRequestURI());
        gcController.setSelectionModel(gcTableSelectionModel);
        gcController.setTableView(gcTableView);
    }

    AbstractTableModel tableModel = gcBean.getGcDevsTableModel();
    gcController.setTableModelWithSorting(tableModel);

    MxDateAndTime curTime = new MxDateAndTime(loginBean.getLocale(), loginBean.getTimeZone());
%>
<HTML>
<HEAD>
    <TITLE><%= gcBundle.getString("page.srcPick.title") %></TITLE>
    <link href='<%= MxOptions.URL_BASE %>/taskandjob/css/taskAndJob.css' rel='stylesheet' type='text/css'>
    <script src='<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js' language='JavaScript' type='text/javascript'></script>
    <script src='<%=MxOptions.URL_BASE%>/taskandjob/js/taskWizard.js' language='JavaScript' type='text/javascript'></script>
    <script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
    <script src="<%=MxOptions.URL_BASE%>/js/MxBrowser.js" language="JavaScript" type="text/javascript"></script>
    <script src="<%=MxOptions.URL_BASE%>/js/utilities.js" language="JavaScript" type="text/javascript"></script>
    <script language="JavaScript" type="text/javascript">
        MxPortalWorkspaceSetHelpTopic("useTools_replicateAgentSettings");
    </script>
    <%
    //JavaScript functions to make sure that a user enters valid characaters
    // for a device search.
    %>
    <script language="JavaScript" type="text/javascript">
        function isSystemNameEmpty(sysName)
        {
            if ((sysName == null) || (sysName == ""))
                return true;
            else
                return false;
        }

        function validate(e)
        {
            var charCode = e.which;
            if (charCode == null)
               charCode = event.keyCode;
            if (charCode == 13)
            {
                btnNext = document.getElementById("nextBtn");
                if (btnNext != null)
                {
                    btnNext.click();
                }
            }

            return isValidSystemNameChar(charCode);
        }
    </script>

    <script language="JavaScript" type="text/javascript">

        // The function called to perform selection change
        function mySelectionChanged(szIdTable, iRow, bSelected)
        {
            // Disable the button
            ourButtonManager.disableButtonById('nextBtn');

            // Update the bean with
            var iframe = document.getElementById("action");
            var url = "replicateAgentCfgBeanUpdater.jsp?rowSelected=" + iRow;
            iframe.contentWindow.document.location.replace(url);
        }

        //this function doesn't appear to be used....
        function enableNextButton()
        {
            ourButtonManager.enableButtonById('nextBtn');
        }

        var nextClickedOnce = false;
        function nextButtonFunction()
        {
            var readyToProceed = true;
            var rbName = document.getElementById("radByName");
            var rbList = document.getElementById("radByList");
            nextClickedOnce = true;

            ourButtonManager.disableButtonById('nextBtn');
            ourButtonManager.disableButtonById('prevBtn');

            if ((rbName!= null) && rbName.checked)
            {
                var nodeName = document.getElementById("sourceSystemName").value;
                if (isSystemNameEmpty(nodeName))
                {
                    setReloadOnError(false);
                    readyToProceed = false;
                    displaySrcNameError("<%= gcBundle.getString("GCSourceError.noNameEntered") %>");
                    //enableElement("nextBtn");
                    ourButtonManager.enableButtonById('prevBtn');
                    giveFocus("sourceSystemName");
                }
                else if (!isValidSystemName(nodeName))
                {
                    setReloadOnError(false);
                    readyToProceed = false;
                    displaySrcNameError("<%= gcBundle.getString("GCSourceError.invalidSourceName") %>");
                    //enableElement("nextBtn");
                    ourButtonManager.enableButtonById('prevBtn');
                    giveFocus("sourceSystemName");
                }

            }
            else if ((rbList!= null) && rbList.checked)
            {
                setReloadOnError(false);
            }
            return readyToProceed;
        }

        function showListFirstTime(state)
        {
            elListDiv = document.getElementById("srcSystemList");
            if (elListDiv != null)
                elListDiv.style.display = state ? "block" : "none";

            // Enable/Disable source input field
            elSrcSys = document.getElementById("sourceSystemName");
            elSrcSys.disabled = state;

            elRefreshDiv = document.getElementById("refreshLabel");
            if (elRefreshDiv != null)
                elRefreshDiv.style.display = state ? "block" : "none";

        }

        function showList(state)
        {
            showListFirstTime(state);
            if (nextClickedOnce)
            {
                if (state)
                {
                    displaySrcNameError("");
                }
                else
                {
                    if (isSystemNameEmpty(document.getElementById("sourceSystemName").value))
                       displaySrcNameError("<%= gcBundle.getString("GCSourceError.noNameEntered") %>");
                }
            }
        }

        function displaySrcNameError(msg)
        {
            elErr = document.getElementById("nameErrorField");
            if (elErr != null)
               elErr.innerHTML = msg;
        }

        function setAgentTrust(rowNum)
        {
            window.open("webAgentTrustCfg.htm?rowNum=" + rowNum, "webAgentTrustCfg", "width=800,height=600,status=yes,resizable=yes,menubar=no,toolbar=no")
        }

        // This function is called by the agent cfg popup window (webAgentTrustCfg.jsp)
        function updateTrust(launchedWindow, deviceIdToUpdate)
        {
            launchedWindow.close();

            var el = document.getElementById("deviceIdToUpdate");
            if (el != null)
               el.value=deviceIdToUpdate;

            el = document.getElementById("updateTable");
            if (el != null)
               el.value = "true";

            var myForm = document.getElementById("gcSrcSystemForm");
            if (el != null)
                myForm.submit();
        }

        function refreshTable()
        {
            location.replace(location.href + "&updateSelectedRow=1&entryOrList=list");
        }
    </script>
    <script language="JavaScript" type="text/javascript">
        function myOnLoad()
        {
            setTimeout("myOnResize()", 500);
        }

        function myOnResize()
        {
            resize_w();
        }

        function resize_w()
        {
            var w = Math.max(0, MxBrowserGetBodyWidth(0, 0));
            MxTableSetWidth("<%= srcTableDomId %>", w);
        }
    </script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxButton.dumpHeadContent(out); %>
<% gcTableView.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</HEAD>

<BODY onLoad="myOnLoad()" onResize="myOnResize()">
    <% // hidden <iframe> for actions %>
    <iframe id='action' name='action' style='display:none; width:100%; height:100'
            scrolling='no' marginwidth='0' frameborder='1' src='<%=MxOptions.URL_BASE%>/home/MxBlank.html'>
    </iframe>

    <%
    // DISPLAY BEAN AND JSP PROPERTIES
    if (groupConfigurationDebug.check(20))
    {
        gcBean.displayBeanPropsHtml(out);
        out.println("<BR>");
        gcBean.displayJspParamsHtml(request, out);
        gcBean.displayJspParamsToConsole(request);
    }

    ///////////////////////////////////////////////////////////////////////////
    // IS THIS A POST?  Check data validity and redirect
    ///////////////////////////////////////////////////////////////////////////
    if (request.getMethod().equals("POST"))
    {
        groupConfigurationDebug.log(5, "[replicateAgentCfgSource.jsp] PROCESSING HTTP POST");
        gcBean.clearAllErrorMessages();
        gcBean.processPost(request, out, gcTableSelectionModel, tableModel);
    }
    else
    {
        ///////////////////////////////////////////////////////////////////////////
        // THIS IS NOT A POST - Display normally
        ///////////////////////////////////////////////////////////////////////////
        groupConfigurationDebug.log(5, "[replicateAgentCfgSource.jsp] PROCESSING HTTP GET (Page displaying normally)");
        %>
        <script language="JavaScript" type="text/javascript">setWizardStepText("<%= gcBundle.getString("page.srcPick.taskWizHeader") %>");</script>
        <%
            // Display any error messages
            if (gcBean.hasErrorMessages())
            {
                // Display plurally-correct label
                if (gcBean.getErrorMessageList().size() == 1)
                {
                    %><div class="errorTextBold"><%= gcBundle.getString("GCSourceError.label.single")%>:</div><%
                }
                else
                {
                    %><div class="errorTextBold"><%= gcBundle.getString("GCSourceError.label.multiple")%>:</div><%
                }

                // Finally, display the error message(s)
                gcBean.displayErrorMessagesInHtml(out);
            }

            // PRESELECT THE SOURCE SYSTEM ROW
            // (AND SAVE THE PROPER RADIO BUTTON SETTING)
            int index = gcBean.getSelectedRowIndex();
            groupConfigurationDebug.log(5, "[replicateAgentCfgSource.jsp] Handling source system preselection method...initializing index to " + index);
            String entryOrList = gcBean.getEntryOrList();
            String srcSysNameFromTaskModel = gcBean.getSourceSystemName();
            groupConfigurationDebug.log(5, "[replicateAgentCfgSource.jsp] srcSysNameFromTaskModel = " + srcSysNameFromTaskModel);
            if (refreshMode)
            {
                index = gcBean.getIndexFromDeviceKey(onEnterSelectedDeviceKey);
                groupConfigurationDebug.log(5, "[replicateAgentCfgSource.jsp]...REFRESH...index=" + index);
                String paramEntryMethod = request.getParameter("entryOrList");
                if ((paramEntryMethod != null) && !paramEntryMethod.equals(""))
                {
                    entryOrList = paramEntryMethod;
                }
            }
            else if (srcSysNameFromTaskModel != null)
            {
                index = gcBean.getIndexFromDeviceName(srcSysNameFromTaskModel);
                groupConfigurationDebug.log(5, "[replicateAgentCfgSource.jsp]...LOAD FROM TASK MODEL (PREV MODE)...index=" + index);
            }
            else if (gcBean.isEditMode())
            {
                // Get the selected device key from the saved task info
                int selDvcKey = gcBean.getSourceSystemId();
                index = gcBean.getIndexFromDeviceKey(selDvcKey);
                groupConfigurationDebug.log(5, "[replicateAgentCfgSource.jsp]...EDIT MODE...index=" + index);
            }
            if (index < 0)
            {
                index = 0;
            }
            else
            {
                gcBean.selectSourceDeviceRow(index);
            }

            groupConfigurationDebug.log(5, "[replicateAgentCfgSource.jsp] Preselecting row index = " + index);
            groupConfigurationDebug.log(5, "[replicateAgentCfgSource.jsp] ... entryOrList = " + entryOrList);
            gcTableSelectionModel.setSelectedIndex(index, true);
        %>

        <form action="replicateAgentCfgSource.jsp" method="post" name="gcSrcSystemForm" id="gcSrcSystemForm">
            <input type="hidden" value="" name="updateTable" id="updateTable">
            <input type="hidden" value="" name="deviceIdToUpdate" id="deviceIdToUpdate">
            <input type="radio" name="nameMethod" value="entry" id="radByName" onClick="showList(false)" <%= entryOrList.equalsIgnoreCase("entry") ? "checked" : "" %>><label for="radByName"><%= gcBundle.getString("page.srcPick.radio.byName") %>: </label>
            <input type="text" size="16" name="sourceSystemName" id="sourceSystemName" maxlength="<%=MxNodeName.MAXIMUM_NODE_NAME_LENGTH%>" value="<%= gcBean.getSourceSystemName() %>">
            <span class="errorTextBold" id="nameErrorField"></span><BR>
            <input type="radio" name="nameMethod" value="list" id="radByList" onClick="showList(true)" <%= entryOrList.equalsIgnoreCase("list") ? "checked" : "" %>><label for="radByList"><%= gcBundle.getString("page.srcPick.radio.fromList") %></label><br><br>
            <input type='hidden' id='timeStamp' name='timeStamp' value='<%=timeStamp%>'>
        </form>
        <table width="100%" border="0" cellspacing="0" cellpadding="0" id="refreshLabel">
        <tr>
            <td align="right">
                <a href="javascript:refreshTable()"><%= gcBundle.getString("tree.label.lastRefresh") %></a>:
                <%= curTime.getCurrentDateTimeStringSIMFormat() %>
            </td>
        </tr>
        </table>
        <div id="srcSystemList" style="width:100%; <%= gcBean.getEntryOrList().equals("list") ? "" : "display:none;" %>">
        <%
            // DISPLAY THE LIST OF SOURCE SYSTEM CANDIDATES FOR THIS TOOL
            gcTableView.setHeight("225");
            gcTableView.dumpWholeTable(out);
        %>
        </div>
        <br>
        <script>
            setFormSubmitName("gcSrcSystemForm");
            displayTaskWizardButtons();

            // Display the list if the proper radio button is selected
            showListFirstTime(radioSelected("radByList"));
        </script>

        <%
        if (!gcBean.isDataValid())
        {
            %>
            <script>giveFocus("sourceSystemName");</script>
            <%
        }
    }
        %>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</BODY>
</HTML>
