<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="switchFWInstallResourceSettings" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="ussBean" class="com.hp.mx.core.tools.swmaintenance.UpdateSystemSoftwareBean" scope="session" />

<%
    // set up the resource file
    switchFWInstallResourceSettings.init(loginBean, "SwitchFWInstallPanel");

    String fileLocation = request.getParameter("logfile");

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();

    buttons.addMxTag(new MxDefaultTag("", switchFWInstallResourceSettings.getString("CloseButton"), "window.close()"));
%>

<html>
<head>
    <link type="text/css" rel="stylesheet" href="<%=MxOptions.URL_BASE%>/css/MxMessageBox.css">
    <link href="<%= MxOptions.URL_BASE %>/css/MxPortalEx.css" rel="stylesheet" type="text/css">
    <style type="text/css">
      .msgbox-title
      {
        cursor: default;
      }
    </style>

    <script>
    function linkToParent(id)
    {
        window.opener.MxPortalWorkspaceCreate(id);
        window.close();
    }
    </script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxButton.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</head>
<body style="font-style:normal;">
<h2 class="msgbox-title"><%= switchFWInstallResourceSettings.getString("Title") %></h2>
<script>window.resizeTo(700, 700);</script>
<p>
    <%
    StringBuffer str = new StringBuffer(100);
    if (ussBean.findLogFile(fileLocation))
    {
        str.append(switchFWInstallResourceSettings.getString("Explain1"));
        str.append("<br><b>");
        str.append(fileLocation);
        str.append("</b></p>");
        out.println(str.toString());
    %>
        <textarea name="fileContents" id="fileContents" wrap="off" cols="72" rows="15"><% ussBean.readFileData(fileLocation, out); %></textarea>
    <%
    }
    else
    {
        str.append(switchFWInstallResourceSettings.getString("ExplainNoFile"));
        str.append("</p>");
        out.println(str.toString());
    }
    %>
</p>

<div style="margin-top:15px">
    <% buttons.dumpButtons(out); %>
</div>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</body>
</html>
