<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="tasksBean" class="com.hp.mx.portal.taskandjob.MxTaskAndJob" scope="session"/>

<%@ page import="com.hp.mx.core.jobmanager.MxDefaultJobFormatter"%>
<%@ page import="com.hp.mx.html.core.MxButton"%>
<%@ page import="com.hp.mx.html.core.MxHtmlUtil"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobInstance"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobResourceBundle"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobTabsModel"%>
<%@ page import="com.hp.mx.portal.ui.MxBean"%>
<%@ page import="com.hp.mx.portal.ui.MxOptions"%>

<%
    // set header info
    MxBean.jspInit(request, response);

    // check to see if the loginBean session has timed out
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
    {
        return;
    }

    String                     taskAndJobTimeStamp = request.getParameter("taskAndJobTimeStamp");
    MxTaskAndJobInstance       inst                = (MxTaskAndJobInstance)tasksBean.getInstance(taskAndJobTimeStamp);
    MxDefaultJobFormatter      formatter           = (MxDefaultJobFormatter)inst.getJobFormatter();
    MxTaskAndJobResourceBundle rb                  = formatter.getRB();

    boolean displayHeader      = (request.getParameter("hdr") != null);
    boolean displayFilesCopied = (request.getParameter("files") != null);
    String  selectedTab        = request.getParameter("tab");

    // select the tab
    if (selectedTab != null)
    {
        // set the selected TAB
        formatter.selectTab(selectedTab);
    }

    // get the file copy count on this tool.  If > 0 and targetCount > 1, list
    // a "Files Copied" section for targets - else have "target result"
    // display status (files copied) and exit code
    int fileCopyCount = formatter.getFileCopyCount();

    // pageNum for stdout/stderr viewing
    String pageNumStr = request.getParameter("pageNum");
    // if we don't have a page specified - set to first page (0-500 lines)
    if (pageNumStr == null)
    {
        pageNumStr = "0";
    }

    formatter.setPageNum(Integer.parseInt(pageNumStr));

    // the tabs to display
    MxTaskAndJobTabsModel tabs = formatter.getMxTabs();
%>

<html>
    <head>
        <title></title>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/taskandjob/css/taskAndJob.css'>
        <script language='javascript' type='text/javascript' src='/AutoRefreshingSessionReset.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxPortalApi.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js'></script>
        <script language='javascript' type='text/javascript'>
            var timeStamp = '<%=taskAndJobTimeStamp%>';
            /////////////////////////////////
            // viewPrintableReport()
            /////////////////////////////////
            function viewPrintableReport()
            {
                var type = null;
                // if this is an MSA task that we are looking at, don't ask user
                // print question - pass "msa" as the "type"
                if (<%= formatter.isTaskMSA() %> == true)
                {
                    type = 'msa';
                }
                else if (<%= formatter.getNumTargets() %> == 1)
                {
                    type = 'single';
                }

                if (type == null)
                {
                    var iframe = parent.document.getElementById('printReport');
                    var url    = '<%=MxOptions.URL_BASE%>/taskandjob/askPrintOption.jsp?taskAndJobTimeStamp=<%= taskAndJobTimeStamp %>';
                    iframe.contentWindow.document.location.replace(url);
                }
                else
                {
                    window.open('<%=MxOptions.URL_BASE%>/taskandjob/printReport.jsp?type=' + type + "&taskAndJobTimeStamp=<%= taskAndJobTimeStamp %>",
                                'PrintReport',
                                'top=50,left=50,width=800,height=600,scrollbars=yes', true);
                }
            }
            ////////////////////////////////////////////////
            // setOurIFrameWidth()
            ////////////////////////////////////////////////
            function setOurIFrameWidth()
            {
                var minWidth = 0;

                if ('<%=request.getParameter("taskAndJobTimeStamp")%>' != '<%=tasksBean.DEFAULT_FORMATTER%>')
                {
                    minWidth = getIframeTop(this).minWidth;
                }

                var windowWidth = MxPortalGetWorkspaceFrame().offsetWidth - NETSCAPE_SCROLLBAR_WIDTH;
                var newWidth    = (minWidth >= windowWidth) ? minWidth : '100%';
                // set width of our <iframe>
                parent.document.getElementById(this.name).style.width = newWidth;
                setTimeout('setOurIFrameWidth()', RESIZE_TIMEOUT);
            }
            //////////////////////////////
            // setOurIFrameHeight()
            //////////////////////////////
            function setOurIFrameHeight()
            {
                var iframe = parent.document.getElementById(this.name);

                if (iframe == null)
                {
                    return;
                }

                iframe.style.height = document.getElementById('scrollDiv').scrollHeight + 30;
            }
            ////////////////////////////////////////////////
            // myOnLoad()
            ////////////////////////////////////////////////
            function myOnLoad()
            {
                setOurIFrameHeight();
                // get the width our element takes up
                var element    = document.getElementById('outputTable');
                var myMinWidth = element.offsetWidth;

                if (<%=displayHeader%> == true)
                {
                    var element2   = document.getElementById('targetInfo');
                    var e2Width    = element2.offsetWidth;

                    if (e2Width > myMinWidth)
                    {
                        element2.style.width = myMinWidth;
                    }
                }

                if ('<%=request.getParameter("taskAndJobTimeStamp")%>' != '<%=tasksBean.DEFAULT_FORMATTER%>')
                {
                    setMinWidth(myMinWidth);
                }

                setOurIFrameWidth();
            }
        </script>
<%
    MxHtmlUtil.dumpHeadBegin(out);
    tabs.dumpHeadContent(out);
    MxButton.dumpHeadContent(out);
    MxHtmlUtil.dumpHeadEnd(out);
%>
    </head>

    <body onload='myOnLoad()'>

        <div id="scrollDiv">
<%
    if (displayHeader == true)
    {
%>
            <hr id='hr'/>
<%
    }
    else
    {
%>
            <br id='br'/>
<%
    }

    if (displayHeader == true)
    {
%>
            <table id='titleTable' border='0' cellpadding='0' cellspacing='0'>
                <tr>
                    <td nowrap>
                        <font class='mx-subheader-nosep'><%= rb.getString("TARGET_TITLE") %></font>
                    </td>
                </tr>
            </table>

            <br id='br'/>

            <table id='nameTable' border='0' cellpadding='0' cellspacing='0'>
                <tr>
                    <td nowrap><b><%= rb.getString("TARGET_NAME_LOWER") %>:</b>&nbsp;</td>
                    <td><%= formatter.getSelectedTargetName() %></td>
                </tr>
            </table>

            <table id='targetInfo' border='0' cellpadding='0' cellspacing='0'>
                <tr>
                    <td nowrap><b><%=rb.getString("EXIT_CODE_LOWER")%>:</b>&nbsp;</td>
                    <td style='width:33%' nowrap><%= formatter.getSelectedTargetExitCode() %></td>
                    <td style='width:33%' nowrap>
<%
    // if there is file copy information - display it
    if (fileCopyCount > 0)
    {
        %><b>&nbsp;<%=rb.getString("FILES_COPIED_LOWER")%>:</b>&nbsp;<%= formatter.getSelectedTargetFileCopyCount() %>/<%= fileCopyCount %>&nbsp;<%
    }
    else
    {
        %>&nbsp;<%
    }
%>
                    </td>
                    <td style='width:33%' align='right' nowrap><b><%= rb.getString("STATUS") %>:</b>&nbsp;</td>
                    <td nowrap><%= formatter.getSelectedTargetStatus() %></td>
                </tr>
                <tr>
                    <!-- this field is here to align with the "Target Name" -->
                    <td nowrap style='visibility:hidden'><b><%= rb.getString("TARGET_NAME_LOWER") %>:</b>&nbsp;</td>
                </tr>
            </table>
<%
    } // END OF ==> if (displayHeader == true)
%>
            <table id='outputTable' border='0' cellpadding='0' cellspacing='0'>
                <tr>
                    <td colspan='3'>
<%
    tabs.dumpTabs(out);
%>
                    </td>
                </tr>
                <tr>
                    <td colspan='3'>
                        <textarea name='output' id='output' style='background-color:#E6E6E6' rows='<%= formatter.TEXTAREA_ROWS %>'
                                  cols='<%= formatter.TEXTAREA_COLUMNS + 1 %>' readonly='1' wrap='off'>
<%
    formatter.dumpSelectedOutput(out);
%>
                        </textarea>
                    </td>
                </tr>
                <tr>
                    <td colspan='3'>&nbsp;</td>
                </tr>
                <tr>
                    <td colspan='1' nowrap>
<%
    formatter.dumpTargetOutputPagingNumbers(out);
%>
                    </td>
                    <td colspan='1'>
<%
    formatter.dumpTargetOutputPagingButtons(out);
%>
                    </td>
                    <td colspan='1'>
                        <table border="0" cellpadding="0" cellspacing="0" align="right">
                            <tr>
                                <td>
                                    <script language="javascript" type="text/javascript">
                                        document.write(ourButtonManager.makeMxButton('viewPrintBtn', '<%=rb.getString("VIEW_PRINT_BUTTON")%>', 'viewPrintableReport()'));
                                        ourButtonManager.initButtonById('viewPrintBtn');
                                    </script>
                                </td>
                            </tr>
                        </table>
                    </td>
                </tr>
            </table>

            <br/>

        </div>
<%
    MxHtmlUtil.dumpBodyEnd(out);
%>
    </body>
</html>
