<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="tasksBean" class="com.hp.mx.portal.taskandjob.MxTaskAndJob" scope="session"/>

<%@ page import="com.hp.mx.html.core.MxHtmlUtil"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobInstance"%>
<%@ page import="com.hp.mx.portal.ui.MxBean"%>
<%@ page import="com.hp.mx.portal.ui.MxOptions"%>

<%
    // set header info
    MxBean.jspInit(request, response);

    // check to see if the loginBean session has timed out
    if (loginBean.checkLogoutConditionForWebPage(pageContext) == true)
    {
        return;
    }

    String               taskAndJobTimeStamp = request.getParameter("taskAndJobTimeStamp");
    MxTaskAndJobInstance inst                = (MxTaskAndJobInstance)tasksBean.getInstance(taskAndJobTimeStamp);
    boolean              firstTime           = (request.getParameter("firstTime") != null);
%>

<html>
    <head>
        <title></title>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/taskandjob/css/taskAndJob.css'>
        <script language='javascript' type='text/javascript' src='/AutoRefreshingSessionReset.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxPortalApi.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js'></script>
        <script language='javascript' type='text/javascript'>
            //////////////////////////////
            // setOurIFrameHeight()
            //////////////////////////////
            function setOurIFrameHeight()
            {
                var iframe = parent.document.getElementById(this.name);

                if (iframe == null)
                {
                    return;
                }

                iframe.style.height = document.getElementById('scrollDiv').scrollHeight;
                parent.setOurIFrameHeight();
            }
            ////////////////////////////////////////////////
            // setOurIFrameWidth()
            ////////////////////////////////////////////////
            function setOurIFrameWidth()
            {
                var minWidth    = getIframeTop(this).minWidth;
                var windowWidth = MxPortalGetWorkspaceFrame().offsetWidth - NETSCAPE_SCROLLBAR_WIDTH;
                var newWidth    = (minWidth >= windowWidth) ? minWidth : '100%';
                // set width of our <iframe>
                parent.document.getElementById(this.name).style.width = newWidth;

                setTimeout('setOurIFrameWidth()', RESIZE_TIMEOUT);
            }
            ////////////////////////////////////////////////
            // myOnLoad()
            ////////////////////////////////////////////////
            function myOnLoad()
            {
                // normal startup procedures
                setOurIFrameWidth();
                // the switchFrames() function will call the setOurIFrameHeight() for updates (! firstTime)
                if (<%=firstTime%> == true)
                {
                    setOurIFrameHeight();
                }
                // redraw to display immediately
                redrawElement(document.getElementById('scrollDiv'));
            }
        </script>
<%
    MxHtmlUtil.dumpHeadBegin(out);
    MxHtmlUtil.dumpHeadEnd(out);
%>
    </head>

    <body onload="myOnLoad()">

        <div id="scrollDiv">
<%
    inst.dumpJobFormatter(out);
%>
        </div>
<%
    MxHtmlUtil.dumpBodyEnd(out);
%>
    </body>
</html>
