<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="tasksBean" class="com.hp.mx.portal.taskandjob.MxTaskAndJob" scope="session"/>

<%@ page import="com.hp.mx.html.core.MxButton"%>
<%@ page import="com.hp.mx.html.core.MxHtmlUtil"%>
<%@ page import="com.hp.mx.html.table.MxTableView2"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobResourceBundle"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobInstance"%>
<%@ page import="com.hp.mx.portal.ui.MxBean"%>
<%@ page import="com.hp.mx.portal.ui.MxOptions"%>

<%
    // set header info
    MxBean.jspInit(request, response);

    // check to see if the loginBean session has timed out
    if (loginBean.checkLogoutConditionForWebPage(pageContext) == true)
    {
        return;
    }

    String               taskAndJobTimeStamp = request.getParameter("taskAndJobTimeStamp");
    MxTaskAndJobInstance inst                = (MxTaskAndJobInstance)tasksBean.getInstance(taskAndJobTimeStamp);

    MxTableView2 jobsTableView = inst.getJobsTableView();

    int totalNumJobs = inst.getTotalNumJobs();
    int numJobs      = inst.getNumJobs();

    MxTaskAndJobResourceBundle rb = inst.getRB();

    StringBuffer total = new StringBuffer(50);
    total.append(numJobs);

    if (totalNumJobs != numJobs)
    {
        total.append(" ");
        total.append(rb.getString("OF"));
        total.append(" ");
        total.append(totalNumJobs);
    }
%>

<html>
    <head>
        <title></title>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/taskandjob/css/taskAndJob.css'>
        <script language='javascript' type='text/javascript' src='/AutoRefreshingSessionReset.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxPortalApi.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/allTasks.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/timeFilters.js'></script>
        <script language='javascript' type='text/javascript'>
            ////////////////////////////////////////////////
            // selectTaskJob.jsp to set this value
            // need to store the Selected Task Job ID
            var selectedJobID = null;
            //////////////////////////////////////////
            var refreshOk = true;
            ////////////////////////////////////////////////
            // autoRefresh()
            ////////////////////////////////////////////////
            function autoRefresh()
            {
                if (refreshOk == false)
                {
                    return;
                }
                // tell the table to update its content
                MxTableRefreshInPlace('ID_MY_TABLE');
                // update the Number of Jobs displayed & divHeight of MxTable
                var iframe = document.getElementById('update');
                var updateURL = '<%=MxOptions.URL_BASE%>/taskandjob/updateTaskResults.jsp?taskAndJobTimeStamp=<%= taskAndJobTimeStamp %>';
                iframe.contentWindow.document.location.replace(updateURL);
                // check for the ** taskInstanceResults.jsp ** page.  If it's present
                // call its autoRefresh() function
                iframe = parent.document.getElementById('taskInstanceResults');
                if ((iframe != null) && (iframe.contentWindow.autoRefresh != null))
                {
                    iframe.contentWindow.autoRefresh();
                }
            }
            ////////////////////////////////////////////////
            // mySelectionChanged()
            ////////////////////////////////////////////////
            function mySelectionChanged(szIdTable, iRow, bSelected)
            {
                // disable the Stop and Delete buttons - selectTaskJob.jsp
                // will enable the appropriate ones for the newly
                // selected Job
                ourButtonManager.disableButtonById('btnStop');
                ourButtonManager.disableButtonById('btnDelete');
                // tell our Bean about the current TaskJob selected
                setTimeout("selectJob(JOB_FORMAT_BASIC, <%= taskAndJobTimeStamp %>, true)", ACTION_TIMEOUT);
            }
            ////////////////////////////////////////////////
            // setTableHeight()
            ////////////////////////////////////////////////
            function setTableHeight()
            {
                var top           = getIframeTop(this);
                var rowsDisplayed = <%=numJobs%>;

                if ((rowsDisplayed < TASK_JOB_LIST_MIN_DISPLAYED) && (rowsDisplayed > 0))
                {
                    rowsDisplayed = TASK_JOB_LIST_MIN_DISPLAYED;
                }

                if (rowsDisplayed > TASK_JOB_LIST_MAX_DISPLAYED)
                {
                    rowsDisplayed = TASK_JOB_LIST_MAX_DISPLAYED;
                }

                var divHeight = (top.iconRowHeight * rowsDisplayed) + top.titleHeight;
                MxTableSetHeight('ID_MY_TABLE', divHeight);
            }
            ////////////////////////////////////////////////
            // setTableWidth()
            ////////////////////////////////////////////////
            function setTableWidth()
            {
                MxTableSetWidth('ID_MY_TABLE', TASK_JOBS_TABLE_WIDTH);
            }
            //////////////////////////////
            // setOurIFrameHeight()
            //////////////////////////////
            function setOurIFrameHeight()
            {
                var iframe = parent.document.getElementById(this.name);

                if (iframe == null)
                {
                    return;
                }

                iframe.style.height = document.getElementById('scrollDiv').scrollHeight;
                redrawElement(iframe);
            }
            ////////////////////////////////////////////////
            // setOurIFrameWidth()
            ////////////////////////////////////////////////
            function setOurIFrameWidth()
            {
                var minWidth    = getIframeTop(this).minWidth;
                var windowWidth = MxPortalGetWorkspaceFrame().offsetWidth - NETSCAPE_SCROLLBAR_WIDTH;
                var newWidth    = (minWidth >= windowWidth) ? minWidth : '100%';
                // set width of our <iframe>
                parent.document.getElementById(this.name).style.width = newWidth;

                setTimeout('setOurIFrameWidth()', RESIZE_TIMEOUT);
            }
            ////////////////////////////////////////////////
            // myOnLoad()
            ////////////////////////////////////////////////
            function myOnLoad()
            {
                // get the width our element takes up
                var element1   = document.getElementById('taskResultTable');
                var element2   = document.getElementById('taskInstanceTable');
                var myMinWidth = (element1.offsetWidth > element2.offsetWidth) ? element1.offsetWidth : element2.offsetWidth;
                // attempt to set this as the minimum (there may
                // already be a larger value that is the minimum)
                setMinWidth(myMinWidth);
                // set our results table to 100% to use all available space
                element1.style.width = '100%';
                // normal startup procedures
                setTableHeight();
                setTableWidth();
                setOurIFrameWidth();
                setOurIFrameHeight();
                selectJob(JOB_FORMAT_BASIC, <%=taskAndJobTimeStamp%>);
            }
        </script>
<%
    MxHtmlUtil.dumpHeadBegin(out);
    MxButton.dumpHeadContent(out);
    jobsTableView.dumpHeadContent(out);
    MxHtmlUtil.dumpHeadEnd(out);
%>
    </head>

    <body onLoad='myOnLoad()'>

        <div id='scrollDiv'>

            <hr class='mx-hr'/>

            <table id='taskResultsHeader' border='0' cellspacing='0' cellpadding='0'>
                <tr>
                    <td><font class='mx-subheader-nosep'><%=rb.getString("TASK_RESULTS_TITLE")%></font></td>
                </tr>
            </table>

            <table id='taskResultTable' border='0' cellpadding='0' cellspacing='0'>
                <tr>
                    <td id='taskResultInfo' nowrap>
<%
    inst.dumpTaskResultInfo(out);
%>
                    </td>
                </tr>
            </table>

            <br id='br'/>

            <!-- if there are no jobs, then hide this table and buttons.  Display text. -->
            <table id='taskInstanceHeader' border='0' cellpadding='0' cellspacing='0' style='width:400'>
                <tr>
                    <td id='tip' nowrap style='width:50%'>
                        <font class='info'><%=rb.getString("TASK_RESULTS_TIP")%></font>
                    </td>
                    <td id='total' nowrap align='right' style='width:50%'>
                        <b><%=rb.getString("TOTAL")%>:</b>&nbsp;<%=total.toString()%>
                    </td>
                </tr>
            </table>

            <table id="taskInstanceTable" border="0" cellspacing="0" cellpadding="0">
                <tr>
                    <td valign='top'>
                        <div id='listDiv' style='width:420; overflow:auto'>
<%
    jobsTableView.dumpWholeTable(out);
%>
                        </div>
                        <div id='textDiv' align='center' style='width:420; overflow:auto'>
                            <font class='note'>
                                <script language='javascript' type='text/javascript'>
                                    document.write('<i><b><%=rb.getString("EMPTY_TASK_JOBS")%></b></i>');
                                </script>
                            </font>
                        </div>
                    </td>
                    <td id='buttonDiv' valign='top'>
                        <table border="0" cellpadding="0" cellspacing="0">
                            <tr>
                                <td>
                                    <script language="javascript" type="text/javascript">
                                        document.write(ourButtonManager.makeMxButton('btnStop', '<%=rb.getString("STOP_BUTTON")%>', 'stopSelectedJob(JOB_FORMAT_BASIC, "<%=taskAndJobTimeStamp%>")'));
                                        ourButtonManager.initButtonById('btnStop');
                                        ourButtonManager.disableButtonById('btnStop');
                                    </script>
                                </td>
                            </tr>
                            <tr>
                                <td style="height:5px">
                                </td>
                            </tr>
                            <tr>
                                <td>
                                    <script language="javascript" type="text/javascript">
                                        document.write(ourButtonManager.makeMxButton('btnDelete', '<%=rb.getString("DELETE_BUTTON")%>', 'deleteSelectedJob(JOB_FORMAT_BASIC, "<%=taskAndJobTimeStamp%>")'));
                                        ourButtonManager.initButtonById('btnDelete');
                                        ourButtonManager.disableButtonById('btnDelete');
                                    </script>
                                </td>
                            </tr>
                        </table>
                    </td>
                </tr>
            </table>

        </div> <!-- end scroll height -->

        <iframe id='update' name='update' style='position:relative; visibility:hidden; width:100%; height:0'
                scrolling='no' marginwidth='0' frameborder='0' src='<%=MxOptions.URL_BASE%>/home/MxBlank.html'>
        </iframe>
        <iframe id='selectJob' name='selectJob' style='position:relative; visibility:hidden; width:100%; height:0'
                scrolling='no' marginwidth='0' frameborder='0' src='<%=MxOptions.URL_BASE%>/home/MxBlank.html'>
        </iframe>
        <iframe id='stopJob' name='stopJob' style='position:relative; visibility:hidden; width:100%; height:0'
                scrolling='no' marginwidth='0' frameborder='0' src='<%=MxOptions.URL_BASE%>/home/MxBlank.html'>
        </iframe>
        <iframe id='deleteJob' name='deleteJob' style='position:relative; visibility:hidden; width:100%; height:0'
                scrolling='no' marginwidth='0' frameborder='0' src='<%=MxOptions.URL_BASE%>/home/MxBlank.html'>
        </iframe>

        <script language='javascript' type='text/javascript'>
            // if there are no jobs for this task, explain it in text
            displayEmptyTable((<%= totalNumJobs %> == 0), this);
        </script>
<%
    MxHtmlUtil.dumpBodyEnd(out);
%>
    </body>
</html>
