<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.core.subjects.MxSubjectPrivilege" %>

<jsp:useBean id="wmiproxyUI" class="com.hp.mx.portal.wmiproxyconfig.WmiProxyConfigManageBean" scope="session" />
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="wmiproxyRes" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="WmiselectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session"/>

<% MxBean.jspInit(request, response); %>
<jsp:setProperty name="wmiproxyUI" property="*" />

<%
    if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.SECURITY_MODIFICATION_PRIVILEGE ) ) { %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" /> <% } %>
<% if(loginBean.checkLogoutConditionForWebPage(pageContext)) return;
    wmiproxyRes.init(loginBean, "WmiProxyConfigUI");
    wmiproxyUI.getResBundles(loginBean);
    int [] row = WmiselectionModel.getSelectedIndices();
    if  (row.length >0)
        wmiproxyUI.setSelectedProxies(row);

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();

    MxTag okButtonTag = new MxDefaultTag("okButton", wmiproxyRes.getString("button.ok"), "");
    okButtonTag.setAttr(MxTag.TYPE, "submit");
    buttons.addMxTag(okButtonTag);

    buttons.addMxTag(new MxDefaultTag("cancelButton", wmiproxyRes.getString("button.cancel"), "cancelEdit()"));
%>



<html>

<head>
<title></title>
 <link href="<%=MxOptions.URL_BASE%>/css/MxPortalEx.css" rel="stylesheet" type="text/css">
<script language="JavaScript" type="text/javascript" src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" ></script>
<script src="/SessionReset.js" language="JavaScript" type="text/javascript"></script>
<script>
    <%@include file='js/WmiProxyConfigUtil.js' %>
</script>
<script language="JAVASCRIPT">
MxPortalWorkspaceSetHelpTopic("admin_protocols_setting_WMIMapperProxyEdit");

function resetScroll()
{
    window.parent.scrollTo(0,0);
}

function cancelEdit()
{
        resetScroll();
        parent.document.location.href="WmiProxyStart.jsp";
}

function checkAll()
{
        if(document.wmiForm.wmiPort.value != "" )
        {
            ourButtonManager.enableButtonById('okButton');
        }
        else
        {
            ourButtonManager.disableButtonById('okButton');
        }
}
</script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% buttons.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</head>

<body onLoad="document.wmiForm.wmiPort.focus();">

<form method="POST" autocomplete="off" style="border:0px;padding:0px;margin:0px" name="wmiForm" action="WmiProxyServer.jsp?command=edit" onSubmit="return errorCheck()">
  <hr class="mx-hr">
    <table border="0" width="100%">
      <tr>
        <td align="left"><font class="mx-subheader-nosep"><%=wmiproxyRes.getString("wmi.title.edit")%>: <%=wmiproxyUI.getWmiName()%></font></td>
      </tr>
      <tr>
        <td></td>
      <tr>
    </table>
 <br>
        <input type="hidden" name="wmiName">

    <table cellSpacing=2 cellPadding=2>
      <tr>
        <td noWrap><font class="input-field"><%=wmiproxyRes.getString("wmi.label.port")%>&nbsp;</font>

        </td>
        <td noWrap>

         <input type="text" name="wmiPort" align=left size="5" maxlength="5" onBlur="checkAll()">

        </td>
      </tr>
    </table>

  <div style="margin-top:15px">
    <% buttons.dumpButtons(out); %>
  </div>
<input type="hidden" name="command" value="edit">
</form>
<script language="JAVASCRIPT">

    // Now load up the edit field values with the data loaded into the beans
    document.wmiForm.wmiName.value = "<%=wmiproxyUI.getWmiName()%>";
    document.wmiForm.wmiPort.value = "<%=wmiproxyUI.getWmiPort()%>";
//    document.wmiForm.wmiName.disabled = true;

</script>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</body>

</html>
