<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.html.table.*"%>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.core.subjects.MxSubjectPrivilege" %>

<%@ page import="com.hp.mx.portal.wmiproxyconfig.WmiProxyConfigTableModel"%>
<%@ page import="com.hp.mx.portal.wmiproxyconfig.*"%>
<%@ page import="com.hp.mx.core.wmiproxymanager.*"%>
<%@ page import="com.hp.mx.core.controllers.*"%>
<%@ page import="com.hp.mx.core.client.*"%>
<%@ page import="com.hp.mx.core.daemon.*"%>
<%@ page import="javax.swing.table.AbstractTableModel"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.SimpleDateFormat"%>
<%@ page import="java.util.*"%>

<jsp:useBean id="wmiproxyUI" class="com.hp.mx.portal.wmiproxyconfig.WmiProxyConfigManageBean" scope="session" />
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="wmiproxyRes" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="WmiselectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session"/>


<%
    MxBean.jspInit(request, response);
    if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.SECURITY_MODIFICATION_PRIVILEGE ) ) { %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" /> <% } %>
<% if(loginBean.checkLogoutConditionForWebPage(pageContext)) return;
    wmiproxyRes.init(loginBean, "WmiProxyConfigUI");
    wmiproxyUI.getResBundles(loginBean);
%>

<html>

<head>
<title>Required Field</title>
 <link href="<%=MxOptions.URL_BASE%>/css/MxPortalEx.css" rel="stylesheet" type="text/css">
<script language="JavaScript" type="text/javascript" src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" ></script>
<script src="/SessionReset.js" language="JavaScript" type="text/javascript"></script>
<script>
    <%@include file='js/WmiProxyConfigUtil.js' %>
</script>
<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>
</head>

<body>
<%  String cmd = new String(request.getParameter("command"));
//        System.out.println("command = " + cmd);
        int doAddRet = 0;
        int doEditRet = 0;

        // If the apply button was pushed from the add page,
        // load up the field values using the node bean properties
        // and reload the page
        // If there is an edit error, tell the start page to reload
        // the edit page
        String applyFlag = request.getParameter("apply");
        String editErr = "false";

    if (cmd.equals("add"))
    {
            // Call Add wmiproxy
            doAddRet = wmiproxyUI.DoAddWmiProxy(loginBean, request, wmiproxyRes.getBundle());
            if(doAddRet == 1)
            {
%>
              <script language="JAVASCRIPT">
                alert("<%=wmiproxyRes.getString("wmi.errmsg.addproxy")%>");
              </script>
<%          }
            if(doAddRet == 2)
            {
              applyFlag = "true";
%>
              <script language="JAVASCRIPT">
                alert("<%=wmiproxyRes.getString("wmi.errmsg.duplicate")%>");
              </script>
<%          }
            if(doAddRet == 3)
            {
              applyFlag = "true";
%>
              <script language="JAVASCRIPT">
                alert("<%=wmiproxyRes.getString("wmi.errmsg.invalidname")%>");
              </script>
<%          }
            else if(doAddRet ==4)
            {
              applyFlag = "true";
%>
              <script language="JAVASCRIPT">
                alert("<%=wmiproxyRes.getString("wmi.errmsg.dnslookup")%>");
              </script>
<%          }
    }
    if (cmd.equals("edit"))
    {
            // Call edit wmiproxy
            int [] iRow = WmiselectionModel.getSelectedIndices();
            doEditRet = wmiproxyUI.DoEditWmiProxy(request,iRow[0]);
            if(doEditRet == 1)
            {
%>
              <script language="JAVASCRIPT">
                alert("<%=wmiproxyRes.getString("wmi.errmsg.edit")%>");
              </script>
<%          }
            else if(doEditRet ==2)
            {
              editErr = "true";
%>
              <script language="JAVASCRIPT">
                alert("<%=wmiproxyRes.getString("wmi.errmsg.duplicate")%>");
              </script>
<%          }
            else if(doEditRet ==3)
            {
              editErr = "true";
%>
              <script language="JAVASCRIPT">
                alert("<%=wmiproxyRes.getString("wmi.errmsg.invalidname")%>");
              </script>
<%          }
            else if(doEditRet ==4)
            {
              editErr = "true";
%>
              <script language="JAVASCRIPT">
                alert("<%=wmiproxyRes.getString("wmi.errmsg.dnslookup")%>");
              </script>
<%          }
            else if(doEditRet ==5)
            {
              editErr = "true";
%>
              <script language="JAVASCRIPT">
                alert("<%=wmiproxyRes.getString("wmi.errmsg.wasdeleted")%>");
              </script>
<%          }
    }
    if (cmd.equals("delete"))
    {
            // Call the delete method in the wmiproxy bean
            //System.out.println("Calling delete method");
//            int doDeleteRet = wmiproxyUI.DoDeleteWmiProxies(loginBean, request);
            int [] iRow = WmiselectionModel.getSelectedIndices();
            int doDeleteRet = wmiproxyUI.DoDeleteWmiProxies(iRow);
            if(doDeleteRet == 1)
            {
%>
              <script language="JAVASCRIPT">
                alert("<%=wmiproxyRes.getString("wmi.ermsg.delete")%>");
              </script>
<%          }
    }

        if(applyFlag != null && applyFlag.equals("true"))
        { %>
          <% wmiproxyUI.resetBean(); %>
          <jsp:setProperty name="wmiproxyUI" property="*" />
          <script language="JAVASCRIPT">
              MxPortalRefreshNavigationArea();
              parent.document.location.href = "WmiProxyStart.jsp?apply=true";
          </script> <%
        }
        else if(editErr.equals("true"))
        { %>
          <script language="JAVASCRIPT">
                document.location.href = "EditWmiProxy.jsp?wmiName=" + "<%=wmiproxyUI.getWmiName() %>";
          </script> <%
        }
        else
        { %>
          <script language="JAVASCRIPT">
            MxPortalRefreshNavigationArea();
            parent.document.location.href = "WmiProxyStart.jsp";
          </script> <%
        }
        %>

        <% MxHtmlUtil.dumpBodyEnd(out); %>
</body>
</html>
