function handleError(desc, fileName, lineNum)
{
    return true;
}

// Tie our error handler to the document that includes this file
window.onerror = handleError

/////////////////////////////////////////////////
// enableButton()
/////////////////////////////////////////////////
function enableButton(btn, enable)
{
    if (btn == null)
    {
        return;
    }
    if (enable == true)
    {
        btn.disabled  = false;
        btn.className = 'action-button';
    }
    else
    {
        btn.disabled  = true;
        btn.className = 'disabled-button';
    }
}

/////////////////////////////////////////////////
// enableSelect()
/////////////////////////////////////////////////
function enableSelect(select, enable)
{
    if (select == null)
    {
        return;
    }
    if (enable == true)
    {
        select.disabled  = false;
    }
    else
    {
        select.disabled  = true;
    }
}


// Determine whether function exists in current window
// Note: fcnName must be string argument
function functionExists(fcnName)
{
    return (typeof window[fcnName] == "function")
}

// Determine whether function exists in specified window
// Note: wndName and fcnName must be string argument
function functionExists(wndName, fcnName)
{
    wnd = eval(wndName)
    return (typeof wnd[fcnName] == "function")
}


// Check character to see if it is a valid character for a device name
function isValidDvcNameChar(charCode)
{
    if (((charCode >= 48) && (charCode <= 57))  ||  // 0-9
        ((charCode >= 65) && (charCode <= 90))  ||  // A-Z
        ((charCode >= 97) && (charCode <= 122)) ||  // a-z
         (charCode == 126) ||                       // ~
         (charCode == 45) ||                        // -
         (charCode == 95) ||                        // _
         (charCode == 46) ||                        // .
         (charCode == 39) ||                        // '
         (charCode == 32) )                         // [space]
    {
        return true;
    }
    else
    {
        return false;
    }
}

function  noSpaces( str )
{
    for ( var i =0; i < str.length; i++ )
    {
        if ( str.charAt(i) == ' ' )
            return false;
    }
    return true;  // There are no spaces
}

/**
 * Provides a level of indirection required by IE6 SP1b (or later)
 * in order to support writing OBJECT tags.
 */
function XeGlobalWriteLine(sz)
{
    document.writeln(sz);
}
