<%@ page import="com.hp.mx.core.utilities.cache.*,
                 java.util.*,
                 com.hp.mx.core.nodemanager.*,
                 com.hp.mx.startup.*"
                 %>
<%@ page import="com.hp.mx.core.subjects.*" %>
<%@ page import="com.hp.mx.core.alertmanager.AlertManager" %>
<%@ page import="com.hp.mx.core.authorizationmanager.MxAuthorizationManager" %>
<%@ page import="com.hp.mx.core.collectionmanager.MxCollectionManager" %>
<%@ page import="com.hp.mx.core.querymanager.QueryManager" %>
<%@ page import="com.hp.mx.core.subjects.usermanager.MxUserManager" %>
<%@ page import="com.hp.mx.core.taskmanager.TaskManager" %>
<%@ page import="com.hp.mx.core.toolmanager.MxToolManager"%>
<%@ page import="com.hp.mx.core.objectmodel.MxObject"%>
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<%@ page import="com.hp.mx.portal.ui.*" %>



<%
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    //
    // if the user isn't authorized.
    if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.DEBUG_PRIVILEGE))
    {
%>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
<%
    }

    // end required section.
%>
<html>
<head>
</head>
<body>
<LINK REL=STYLESHEET TYPE="text/css" HREF="../StyleSheets/XeBaseStyles.css">
    <script language="JavaScript" src="../javascript/XeGlobalFunctions.js"></script>
    <script language="JavaScript" src="../javascript/layout.js"></script>
<%

    String cacheName = request.getParameter("cacheName");
    String cacheAction = request.getParameter("cacheAction");

    try
    {

        if (cacheName != null && cacheAction != null)
        {
            if (cacheAction.equals("uncache"))
            {
                Vector allCaches = ItemCacher.getAllCaches();
                Enumeration e = allCaches.elements();
                while(e.hasMoreElements())
                {
                    ItemCacher cache = (ItemCacher) e.nextElement();
                    if (cache.getCacheName().equals(cacheName))
                    {
                        cache.uncacheAll();
                    }
                }
                out.println("<script LANGUAGE=\"JavaScript\">history.go(-2);</SCRIPT></body> ");
                return;

            }
            if (cacheAction.equals("dumpDevice"))
            {
                // handle device cache data...
                %>

                <table width=100% border=1 cellspacing=0 cellpadding=1 align=CENTER bgcolor=#CCCCCC bordercolor=#000000>
                    <tr valign="top" style="font-size:10pt;background:#66ccff;">
                        <th>KEY ID</th>
                        <th>Device</th>
                    </tr>
                    <%
                    if (cacheName.equals("MxName"))
                    {
                        MxNodeManager.getDefaultManager().getNodeHash(1, out);
                    }
                    if (cacheName.equals("MxGuid"))
                    {
                        MxNodeManager.getDefaultManager().getNodeHash(2, out);
                    }
                    if (cacheName.equals("name"))
                    {
                        MxNodeManager.getDefaultManager().getNodeHash(4, out);
                    }
                    if (cacheName.equals("dnsname"))
                    {
                        MxNodeManager.getDefaultManager().getNodeHash(8, out);
                    }
                    if (cacheName.equals("devId"))
                    {
                        MxNodeManager.getDefaultManager().getNodeHash(7, out);
                    }
                    if (cacheName.equals("guid"))
                    {
                        MxNodeManager.getDefaultManager().getNodeHash(3, out);
                    }
                    if (cacheName.equals("ip"))
                    {
                        MxNodeManager.getDefaultManager().getNodeHash(5, out);
                    }
                    if (cacheName.equals("ipx"))
                    {
                        MxNodeManager.getDefaultManager().getNodeHash(6, out);
                    }

                    %>

                </table>
</html>
<%
return;

}
            if (cacheAction.equals("dumpMxObjects"))
            {
                List itemsInMxCache = null;
                if (cacheName.equals("collection"))
                    {
                        itemsInMxCache = MxCollectionManager.getDefaultCollectionManager().listObjects();
                    }
                else if (cacheName.equals("query"))
                    {
                        itemsInMxCache = QueryManager.getDefaultManager().listObjects();
                    }
                else if (cacheName.equals("user"))
                    {
                        itemsInMxCache = MxUserManager.getDefaultManager().listObjects();
                    }

                else if (cacheName.equals("task"))
                    {
                        itemsInMxCache = TaskManager.getDefaultManager().listObjects();
                    }
                else if (cacheName.equals("tool"))
                    {
                        itemsInMxCache = MxToolManager.getDefaultManager().listObjects();
                    }


                    if (itemsInMxCache != null)
                    {
                        Iterator iter = itemsInMxCache.iterator();
                        out.write("<table border=1> ");
                        out.write("<tr><td>count is </td><td>");
                        out.write(""+itemsInMxCache.size());
                        out.write("</td></tr>");
                        out.write("<tr><td>Object ID</td><td>");
                        out.write("toString()");
                        out.write("</td></tr>");

                        while (iter.hasNext())
                        {
                            MxObject curObj = (MxObject)iter.next();
                            out.write("<tr><td>");
                            out.write(curObj.getObjectID().logString());
                            out.write("</td><td>");
                            out.write(curObj.toString());
                            out.write("</td></tr>");
                        }

                         out.write("</table>");
                    }
                    return;
            }
else if (cacheAction.equals("dumpcache"))
{
    Vector allCaches = ItemCacher.getAllCaches();
    Enumeration e = allCaches.elements();
    while(e.hasMoreElements())
    {
        ItemCacher cache = (ItemCacher) e.nextElement();
        if (cache.getCacheName().equals(cacheName))
        {
            Enumeration eCache = cache.getAllElements();
            %>
            <table width=100% border=1 cellspacing=0 cellpadding=1 align=CENTER bgcolor=#CCCCCC bordercolor=#000000>
                <tr bgcolor=#006699>
                    <th colspan=11 style='font-family:verdana; font-size:12pt; color:white'>
                        <%
                        out.println("Cache dump for "+cacheName);
                        %>
                        </th>
                </tr>
                <tr valign="top" style="font-size:10pt;background:#66ccff;">
                    <th>KEY ID</th>
                    <th>Data</th>
                    <th>Last touched (sec ago)</th>
                    <th>touch count</th>
                </tr>
                <%
                while (eCache.hasMoreElements())
                {
                    ItemCacher.cachedItem item = (ItemCacher.cachedItem) eCache.nextElement();
                    out.println("<tr><td>"+item.getKey()+"</td>");
                    out.println("<td>"+item.getData().toString()+"</td>");
                    out.println("<td>"+((System.currentTimeMillis()-item.getLastAccessed())/1000)+"</td>");
                    out.println("<td>"+item.getTouchedCount()+"</td>");
                    out.println("</tr>");

                }
                %>
                </table>
                <%
                }
            }
            out.println("</body>");
            return;
        }
        //

    }
    %>
    <tr bgcolor=#006699>
        <th colspan=11 style='font-family:verdana; font-size:12pt; color:white'>
            Cache Information
        </th>
    </tr>
    <table width=100% border=1 cellspacing=0 cellpadding=1 align=CENTER bgcolor=#CCCCCC bordercolor=#000000>
        <tr valign="top" style="font-size:10pt;background:#66ccff;">
            <th>CACHE NAME</th>
            <th>MISSES</th>
            <th>HITS</th>
            <th>TOTAL MISSES</th>
            <th>TOTAL HITS</th>
            <th>% HITS</th>
            <th>% MISSES</th>
            <th>COUNT</th>
            <th>ALGORITHM</th>
            <th>UNCACHED (click to uncache all)</th>
            <th>LAST RUN</th>
        </tr>

        <tr bgcolor='#FFFFFF'>
            <td>&nbsp;<a HREF="cacheInfo.jsp?cacheAction=dumpDevice&cacheName=MxName">Devices by MxNameCache </a></td>
            <td colspan=6>na</td>
            <td>
                <%= MxNodeManager.getDefaultManager().getNodeHashCount(1) %>
            </td>
            <td colspan=3>na</td>
        </tr>
        <tr bgcolor='#CCCCCC'>
            <td>&nbsp;<a HREF="cacheInfo.jsp?cacheAction=dumpDevice&cacheName=MxGuid">Devices MxGUID Cache </a></td>
            <td colspan=6>na</td>
            <td>
                <%= MxNodeManager.getDefaultManager().getNodeHashCount(2) %>
            </td>
            <td colspan=3>na</td>

        </tr>
        <tr bgcolor='#FFFFFF'>
            <td>&nbsp;<a HREF="cacheInfo.jsp?cacheAction=dumpDevice&cacheName=devId">Devices by DeviceKey Cache </a></td>
            <td colspan=6>na</td>
            <td>
                <%= MxNodeManager.getDefaultManager().getNodeHashCount(7) %>
            </td>
            <td colspan=3>na</td>

        </tr>
        <tr bgcolor='#CCCCCC'>
            <td>&nbsp;<a HREF="cacheInfo.jsp?cacheAction=dumpDevice&cacheName=name">Devices Name Cache </a></td>
            <td colspan=6>na</td>
            <td>
                <%= MxNodeManager.getDefaultManager().getNodeHashCount(4) %>
            </td>
            <td colspan=3>na</td>

        </tr>
        <tr bgcolor='#CCCCCC'>
            <td>&nbsp;<a HREF="cacheInfo.jsp?cacheAction=dumpDevice&cacheName=dnsname">Devices DNS Name Cache </a></td>
            <td colspan=6>na</td>
            <td>
                <%= MxNodeManager.getDefaultManager().getNodeHashCount(8) %>
            </td>
            <td colspan=3>na</td>

        </tr>
        <tr bgcolor='#FFFFFF'>
            <td>&nbsp;<a HREF="cacheInfo.jsp?cacheAction=dumpDevice&cacheName=guid">Devices UUID/Guid Cache </a></td>
            <td colspan=6>na</td>
            <td>
                <%= MxNodeManager.getDefaultManager().getNodeHashCount(3) %>
            </td>
            <td colspan=3>na</td>

        </tr>
        <tr bgcolor='#FFFFFF'>
            <td>&nbsp;<a HREF="cacheInfo.jsp?cacheAction=dumpDevice&cacheName=ip">Devices IP address Cache </a></td>
            <td colspan=6>na</td>
            <td>
                <%= MxNodeManager.getDefaultManager().getNodeHashCount(5) %>
            </td>
            <td colspan=3>na</td>

        </tr>
        <tr bgcolor='#FFFFFF'>
            <td>&nbsp;<a HREF="cacheInfo.jsp?cacheAction=dumpDevice&cacheName=ipx">Devices IPX Cache </a></td>
            <td colspan=6>na</td>
            <td>
                <%= MxNodeManager.getDefaultManager().getNodeHashCount(6) %>
            </td>
            <td colspan=3>na</td>

        </tr>

        <tr bgcolor='#FFFFFF'>
            <td>&nbsp;<a HREF="cacheInfo.jsp?cacheAction=dumpMxObjects&cacheName=collection">Collection Cache </a></td>
            <td colspan=6>na</td>
            <td>
                <%= MxCollectionManager.getDefaultCollectionManager().getObjectCount() %>
            </td>
            <td colspan=3>na</td>
        </tr>

        <tr bgcolor='#FFFFFF'>
            <td>&nbsp;<a HREF="cacheInfo.jsp?cacheAction=dumpMxObjects&cacheName=query">Query Cache </a></td>
            <td colspan=6>na</td>
            <td>
                <%= QueryManager.getDefaultManager().getObjectCount() %>
            </td>
            <td colspan=3>na</td>
        </tr>
        <tr bgcolor='#FFFFFF'>
            <td>&nbsp;Dynamic Query Cache</td>
            <td colspan=6>na</td>
            <td>
                <%= QueryManager.getDefaultManager().getDynamicQueryCount()%>
            </td>
            <td colspan=3>na</td>
        </tr>
        <tr bgcolor='#FFFFFF'>
            <td>&nbsp;<a HREF="cacheInfo.jsp?cacheAction=dumpMxObjects&cacheName=user">Users Cache </a></td>
            <td colspan=6>na</td>
            <td>
                <%= MxUserManager.getDefaultManager().getObjectCount() %>
            </td>
            <td colspan=3>na</td>
        </tr>
        <tr bgcolor='#FFFFFF'>
            <td>&nbsp;<a HREF="cacheInfo.jsp?cacheAction=dumpMxObjects&cacheName=task">Tasks Cache </a></td>
            <td colspan=6>na</td>
            <td>
                <%= TaskManager.getDefaultManager().getObjectCount() %>
            </td>
            <td colspan=3>na</td>
        </tr>
        <tr bgcolor='#FFFFFF'>
            <td>&nbsp;<a HREF="cacheInfo.jsp?cacheAction=dumpMxObjects&cacheName=tool">Tools Cache </a></td>
            <td colspan=6>na</td>
            <td>
                <%= MxToolManager.getDefaultManager().getObjectCount() %>
            </td>
            <td colspan=3>na</td>
        </tr>

        <%
        String bgColor = "";
        int elCount = 0;
        Vector allCaches = ItemCacher.getAllCaches();
        Enumeration e = allCaches.elements();
        while(e.hasMoreElements())
        {
            elCount++;
            bgColor = (elCount%2 == 0) ? "#FFFFFF" : "#CCCCCC";
            ItemCacher cache = (ItemCacher) e.nextElement();
            cache.saveProperties();   // save the settings now
            %>
            <tr bgcolor='<%= bgColor %>'>
                <td>&nbsp;<%    out.println("<a HREF=\"cacheInfo.jsp?cacheAction=dumpcache&cacheName="+cache.getCacheName()+"\">" + cache.getCacheName()+"</a>" ); %></td>
                <td align=CENTER><%= cache.getCacheMisses() %></td>
                <td align=CENTER><%= cache.getCacheHits() %></td>
                <td align=CENTER><%= cache.getTotalCacheMisses() %></td>
                <td align=CENTER><%= cache.getTotalCacheHits() %></td>
                <%
                int total = cache.getTotalCacheMisses() + cache.getTotalCacheHits();
                if (total == 0)
                total = 1;
                %>
                <td align=CENTER><%= (cache.getTotalCacheHits()*100)/total  %></td>
                <td align=CENTER><%= (cache.getTotalCacheMisses()*100)/total %></td>
                <td align=CENTER><%= cache.getCacheSize()                    %></td>
                <td align=CENTER><%= cache.getAlgorithm().toString()         %></td>
                <td align=CENTER><% out.println("<a HREF=\"cacheInfo.jsp?cacheAction=uncache&cacheName="+cache.getCacheName()+"\">" + cache.getTotalUncaches()+"</a>");                %></td>
                <%
                Date d = cache.getAlgorithmRun();
                if (d != null)
                {
                    %>
                    <td align=CENTER><%= d %></td>
                    <%
                    }
                    else
                    {
                        %>
                        <td align=CENTER><% out.println("Hasn't"); %></td>
                        <%
                        }
                        %>

            </tr>
            <%
            }
        }
        catch(Exception ex)
        {
            out.print(ex.getMessage());
        }

%>
</table>
</body>
</html>
