<%@page info="HP Systems Insight Manager Debug Page" import="java.util.*,
      com.hp.mx.startup.*,
    java.sql.Statement,
    java.sql.Connection,
    java.sql.ResultSet,
    java.sql.DatabaseMetaData,
    java.sql.SQLException,
    com.hp.mx.database.*,
    com.hp.mx.portal.applet.utilities.XeJspUtil,
    com.hp.mx.utilities.version.MxVersion,
    com.hp.mx.portal.applet.utilities.CimXeDebugInfo"%>
<%@page import="com.hp.mx.core.subjects.*"%>
<%@page import="com.hp.mx.portal.ui.*"%>
<jsp:useBean id="XEUtil" scope="session" class="com.hp.mx.portal.applet.utilities.XeJspUtil"/>
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<%
  MxBean.jspInit(request, response);
  // REQUIRED: This aborts the page if the session is invalid.
  if (loginBean.checkLogoutConditionForWebPage(pageContext))
    return;
  //
  // if the user isn't authorized.
  if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.DEBUG_PRIVILEGE)) {
%>
<jsp:forward page="<%=MxOptions.getNotPrivUrl()%>"/>
<%
  }
      // end required section.
      if (request.getParameter("gc") != null) {
    Runtime rt = Runtime.getRuntime();
    rt.gc();
  }
  Connection myConnection = null;
  try {
    // Begin Database setup
    myConnection = DatabaseManager.getDefaultDatabase().getConnection("JSP Page: dbgMain.jsp");
    // Get database metadata to display table names later
    DatabaseMetaData dbmd = myConnection.getMetaData();
%>
<html>
<head></head>
<body>
<table>
  <tr valign='top'>
    <td width='50%'>
      <strong>Debugging links</strong>
      <br>
      <br>
      <a HREF="constructionList.jsp">Automation Engine</A>
      <br>
      <a HREF="cacheInfo.jsp">Cache Information</A>
      <BR>
      <a HREF="connectionDebug.jsp">Database Connections in use</A>
      <BR>
      <a HREF="debugMultiView.jsp">Debug Logger Settings</A>
      <BR>
      <a HREF="dbgLogFile.jsp">Debug Log File, domainmgr</A>
      (need to enable server File debug )
      <BR>
      <a HREF="/jmx-console" target="_new">JBoss Jmx Console</A>
      <BR>
      <a HREF="/web-console" target="_new">JBoss Web Console</A>
      <BR>
      <a HREF="testDeviceStatus.jsp">Node Status Information</A>
      <BR>
      <a HREF="nodeObjectDump.jsp">Node Object Information (has MPO)</A>
      <BR>
      <a HREF="dbgEmailEventParsing.jsp">Email Event parsing</A>
      <br>
      <a HREF="dbgGenXmlForStringTable.jsp">Generate resource properties from db Stringtable</A>
      <BR>
      <a HREF="dbgGlobalSettings.jsp">Global Settings</A>
      <BR>
      <a HREF="snmpgetNext.jsp">SNMP GetNext List</A>
      <br>
      <A HREF="sessionList.jsp">Session List</A>
      <br>
      <A HREF="dbgSqlQuery.jsp">SQL Query</A>
      <BR>
      <a HREF="dbgPerformance.jsp">Performance tests</A>
      <BR>
      <a HREF="threadInfo.jsp">Show Thread dump</a>
      <br>
      <a HREF="dbgTimeZoneInfo.jsp">Time Zone Information</A>
      <BR>
      <a HREF="testBannerData.jsp">Test Banner page data, queries</a>
      <br>
      <a HREF="testCustomFields.jsp">Test custom fields</a>
      <br>
      <a HREF="testSearchNodes.jsp">Test node search api</a>
      <br>
      <a HREF="dbgDcPluginTest.jsp">Test Data Collection Plug-ins</a>
      <br>
    </td>
    <td>
      <h2>Database information</h2>
    <%try {    %>
      <table cellspacing="0" cellpadding="2" border="0">
        <tr valign="top">
          <td>
            <b>URL:</b>
          </td>
          <td><%= XeJspUtil.breakUpLongString( dbmd.getURL(),44) %>          </td>
        </tr>
        <tr valign="top">
          <td>
            <b>Driver Name:</b>
          </td>
          <td><%= dbmd.getDriverName() %>          </td>
        </tr>
        <tr valign="top">
          <td>
            <b>Driver Version:</b>
          </td>
          <td><%= dbmd.getDriverVersion() %>          </td>
        </tr>
        <tr valign="top">
          <td>
            <b>Database Product Name:</b>
          </td>
          <td><%= dbmd.getDatabaseProductName() %>          </td>
        </tr>
        <tr valign="top">
          <td>
            <b>Database Product Version:</b>
          </td>
          <td><%= dbmd.getDatabaseProductVersion() %>          </td>
        </tr>
        <tr valign="top">
          <td>
            <b>User Name:</b>
          </td>
          <td><%= dbmd.getUserName() %>          </td>
        </tr>
      </table>
    <%
      } catch (Exception ex) {
        out.println("<span class=errorText>Exception occurred while trying to access the database..Bummer!</span>");
      }
      finally {
        DatabaseManager.getDefaultDatabase().releaseConnection(myConnection);
      }
    %>
      <br>
      <h2>HP SIM Server / OS  Info</h2>
    <%
      CimXeDebugInfo xeInfo = new CimXeDebugInfo();
      xeInfo.init();
    %>
      <table cellspacing="0" cellpadding="2" border="0">
        <tr valign="top">
          <td nowrap>
            <b>Date/Time:</b>
          </td>
          <td><%= xeInfo.getDateAndTime() %>          </td>
        </tr>
        <tr valign="top">
          <td nowrap>
            <b>Version:</b>
          </td>
          <td><%= MxVersion.getProperty("SimExternalName", MxVersion.REVISION) %>          </td>
        </tr>
        <tr valign="top">
          <td nowrap>
            <b>Build version:</b>
          </td>
          <td><%= MxVersion.getProperty("SimInternalRevision", MxVersion.REVISION) %>          </td>
        </tr>
        <tr valign="top">
          <td nowrap>
            <b>Build date:</b>
          </td>
          <td><%= MxVersion.getProperty("SimBuildDate", MxVersion.TIMESTAMP) %>          </td>
        </tr>
        <tr valign="top">
          <td nowrap>
            <b>CMS Startup Time:</b>
          </td>
          <td>
          <%out.println(" " + InsightXE.GetMapleStartTimeDate().toLocaleString());          %>
          </td>
        </tr>
        <tr valign="top">
          <td nowrap>
            <b>Locale:</b>
          </td>
          <td><%= xeInfo.getMyLocale() %>;<%= xeInfo.getMyLocale().toString() %>          </td>
        </tr>
        <tr valign="top">
          <td nowrap>
            <b>Java Virtual Machine:</b>
          </td>
          <td><%= xeInfo.getJvmLongDesc() %>          </td>
        </tr>
        <tr valign="top">
          <td nowrap>
            <b>JVM Memory:</b>
          </td>
          <td>            TOTAL:
<%= xeInfo.getJvmMemTotal() %>            &nbsp;&nbsp;
            FREE:
<%= xeInfo.getJvmMemFree() %>            &nbsp;&nbsp;
            Max=
<%= Runtime.getRuntime().maxMemory() %>          </td>
        </tr>
        <tr valign="top">
          <td nowrap>
            <b>Operating System:</b>
          </td>
          <td><%= xeInfo.getOsLongDesc() %>          </td>
        </tr>
        <tr valign="top">
          <td nowrap>
            <b>JVM Garbage Collection:</b>
          </td>
          <td>
            <A HREF="dbgMain.jsp?gc=yes">Run Garbage Collection</A>
          </td>
        </tr>
      </table>
    </td>
  </tr>
</table>
<%
  } catch (Exception ex2) {
    ex2.printStackTrace();
  }
%>
</body>
</html>
