<jsp:useBean id="XEUtil" scope="session" class="com.hp.mx.portal.applet.utilities.XeJspUtil"/>
<jsp:useBean id="mxdev" scope="session" class="com.hp.mx.portal.device.MxDeviceBean"/>
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>

<%@ page import="com.hp.mx.core.nodemanager.*,
                 java.util.*,
                 com.hp.mx.core.controllers.MxNodeController,
                 com.hp.mx.core.controllers.MpoController,
                com.hp.mx.core.daemon.MxCoreTransaction,
                java.sql.Statement,
                java.sql.Connection,
                java.sql.ResultSet,
                java.sql.DatabaseMetaData,
                java.sql.SQLException,
                 com.hp.mx.database.*,
                 com.hp.mx.core.taskmanager.*,
                 com.hp.mx.portal.applet.utilities.resources.*,
                 com.hp.mx.portal.help.*, com.hp.mx.core.utilities.*,com.hp.mx.utilities.*"
%>
<%@ page import="com.hp.mx.core.subjects.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.portal.device.*" %>

<%
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    //
    // if the user isn't authorized.
    if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.DEBUG_PRIVILEGE))
    {
%>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
<%
    }
%>

<HTML>
<head>
<title>All devices status info</title>
<LINK REL=STYLESHEET TYPE="text/css" HREF="../StyleSheets/XeBaseStyles.css">
    <script language="JavaScript" src="../javascript/XeGlobalFunctions.js"></script>
    <script language="JavaScript" src="../javascript/XeHelp.js"></script>
    <script language="JavaScript" src="../javascript/layout.js"></script>

  <STYLE TYPE="text/css">
    .dbgSettingsTable{font-size:10pt; font-family:arial; font-weight:normal; color:black; }
    .dbgTableHdr{font-size:10pt; font-family:arial; font-weight:bold; color:black; }
  </STYLE>
</head>

<body>
<P>
<%--<%= session.getValue("Body.Description") %> --%>
This is a list of all the current device status information in the system.
</p>
<hr size=4 width="100%" color="#006699">

<table class="dbgSettingsTable" BORDER="1" CELLSPACING="0" CELLPADDING="1" >
<tr class="dbgTableHdr">
  <td>Name </td>
  <td>Address</td>
  <td>Get MPO list</td>
  <td>
Get URL List

  </td>
  <td>DC_Output Dump</td>
  <td>Delete</td>
  </tr>

<%
MxNode d=null;

Connection myConnection=null;
Statement p =null;
ResultSet  rSet = null;
int  devkey=0;


try
{
    myConnection=DatabaseManager.getDefaultDatabase().getConnection("testDeviceStatus");

    p = myConnection.createStatement();
    rSet = p.executeQuery("select devices.deviceKey, name from devices order by name ");
    MpoController mpoCtrl = MpoController.getDefaultController();

    while(rSet.next())
    {
        devkey     = rSet.getInt(1);

        d = MxNodeController.getDefaultControllerNoEx().getNodeByKey(devkey);
        if(d==null)
        {
            out.print("<tr><td>null dev for id "+devkey+ " </td>");
            out.print("<td><a href=testDeviceStatus.jsp?delDevId=");
            out.println(devkey+">delete</a></td>");

            out.print("</tr>");
            continue;
        }

        out.println("<td align=left valign=top><A href=\"/mxportal/DevicePage/devicepage.jsp?nodeId=");
        out.println(d.getGUID().toString());
        out.println("\"><B>");

        out.println(d.getDeviceName());
        out.println("</B></A></td>");
        out.println("<td>"+d.getWorkingAddress()+" ["+(d.getIPAddressCount()+d.getIPXAddressCount())+"]</td>");


        List allMpos = mpoCtrl.getListofManagementPaths(new MxCoreTransaction(), d.getGUID());
        List allMros = mpoCtrl.getListofManagementPathsManaged(new MxCoreTransaction(), d.getGUID());
        if (allMpos.size() + allMros.size() >0)
        {
            out.print("<td valign=top><a href=nodeObjectList.jsp?devId=");
            out.print(d.getDeviceKey());
            out.print("&mode=MPO>List MPOs (");
            out.print((allMpos.size() + allMros.size()));
            out.print(")</a></td>");
        }
        else
        {
            out.println("<td>no mpos</td>");
        }

        out.println("<td>tbd</td>");

        out.println("<td><a href=XeHdr.jsp?PageName=DataCollectionRep&dId="+d.getDeviceKey()+">Dc Report</a></td>");
        out.print("<td><a href=testDeviceStatus.jsp?delDevId=");
        out.print(d.getDeviceKey()+">delete</a></td>");
        out.println("</tr>\n");


    }
}
catch(SQLException e)
{
    System.out.println("testdevstate "+e);
    e.printStackTrace();
}
catch(Exception e)
{
    System.out.println("testdevstate "+e);
    e.printStackTrace();
}
finally
{
    try
    {
        if (rSet != null)
        {
            rSet.close();
        }
        if (p != null)
        {
            p.close();
        }
    }
    catch(SQLException s)
    {
    }
    try
    {
        DatabaseManager.getDefaultDatabase().releaseConnection(myConnection);
    }
    catch(SQLException s)
    {
    }
}
%>
</table>
</body>
</html>
