<%@ page import="com.hp.mx.portal.ui.*" %>

<jsp:useBean id="deviceBean" class="com.hp.mx.portal.device.MxDeviceBean" scope="session" />
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="xmlParsingBean" class="com.hp.mx.portal.device.MxXmlParsingBean" scope="session" />
<jsp:useBean id="genSystemPage" class="com.hp.mx.portal.device.MxGenSystemPage"  scope="session" />
<jsp:useBean id="deviceBundle" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="actionList" class="com.hp.mx.portal.core.MxActionList" scope="session" />

<%
    MxBean.jspInit(request, response);
    if (loginBean.checkLogoutConditionForWebPage(pageContext) == true)
    {
        return;
    }

    deviceBundle.init(loginBean, "MxDeviceBundle");
    String sIndex = request.getParameter("index");

    int tabIndex = 0;
    if ( sIndex != null )
    {
        Integer tempIndex = new Integer(sIndex);
        tabIndex = tempIndex.intValue();
    }

    //if ( !xmlParsingBean.doneGroups )
    // now we always calculate groups every time the page is requested
    xmlParsingBean.calculateGroups(deviceBean, tabIndex);

%>

<html>
    <head>
        <jsp:include flush="true" page="SystemPageHeader.jsp" />
        <script language="javascript" type="text/javascript">

        function LaunchHWStatus()
        {
            szHWStatusUrl = "<%=deviceBean.getHWStatusUrl(loginBean)%>";
            window.open(szHWStatusUrl, "hw_status");
        }

        </script>

    </head>
    <body onLoad='myOnLoad()' >
    <div id="GEN_ID_PAGE">
    <%
        String szGroupToOpen = request.getParameter("opengroup");
        genSystemPage.dumpStatusInfo(deviceBean, deviceBundle, out, loginBean, actionList);
        genSystemPage.dumpGroups(xmlParsingBean.finalGroupList, szGroupToOpen, loginBean.getLocale(), out);
    %>
    </div>
    </body>
</html>
