<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" />
<%@ page import="com.hp.mx.html.table.GUIDOTable,
                 com.hp.mx.html.table.TreeTable,
                 com.hp.mx.html.table.AttributeValueTable,
                 com.hp.mx.portal.ui.MxBean,
                 com.hp.mx.core.nodemanager.MxNode,
                 com.hp.mx.core.persistence.databean.CIM_ComputerSystem,
                 com.hp.mx.core.persistence.databean.CIM_NetworkPort,
                 com.hp.mx.core.persistence.util.storage.BeanFinder,
                 com.hp.mx.core.persistence.util.storage.InterconnectDevice,
                 java.awt.*,
                 java.util.*,
                 java.util.List,
                 com.hp.mx.core.persistence.util.storage.FCPort,
                 com.hp.mx.core.persistence.util.storage.Debug,
                 com.hp.mx.core.persistence.dataaccess.DataAccessException"
%>

<jsp:useBean id="deviceBean" class="com.hp.mx.portal.device.MxDeviceBean" scope="session" />
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="resource" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="genSystemPage" class="com.hp.mx.portal.device.MxGenSystemPage"  scope="session" />
<jsp:useBean id="deviceBundle" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<div class="systemPageGroup">
<%

    /**
     * This panel will display status summary information for a given interconnect device.
     */

    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    // setup resources.
    resource.init(loginBean, "StorageRelatedDevicePages");

    genSystemPage.dumpDataCollectionLine(deviceBean, deviceBundle, loginBean, out);

    // find system
    MxNode node = deviceBean.getMxNode();
    String durableName = node.getDurableName();
    int id = node.getDeviceKey();

    GUIDOTable gt = new GUIDOTable(request.getLocale());
    String headers[] = { resource.getString("columnHeader.status"),         // summary description
                         resource.getString("columnHeader.count") };         // count
    gt.setHeaders(headers);

    try {
        InterconnectDevice ic = new InterconnectDevice(id, durableName);

        // display status rows for every type of status set for a device port
        ArrayList rows = new ArrayList(ic.getStatusSummary().size());
        Iterator it = ic.getStatusSummary().iterator();
        while (it.hasNext()) {
            InterconnectDevice.StatSummary ss = (InterconnectDevice.StatSummary) it.next();
            String[] tableRow = new String[2];          // row has 2 columns
            tableRow[0] = ss.getStatusHTML(resource.getString(ss.getStatusString()));
            Integer val = new Integer(ss.getCount());
            tableRow[1] = val.toString();
            rows.add(tableRow);
        }

        gt.setRows(rows);

    } catch(DataAccessException dae) {
        Debug.trace("No Data Found for Switch with NodeID = " + id + "  Name = " + durableName);
    } catch(RuntimeException re) {
        Debug.getDebugSubsystem().panic(re);
    } catch(Error e) {
        Debug.getDebugSubsystem().panic(e);
        throw e;
    } finally {
        out.print(gt.getHTML().toString());
    }

%>
</div>
