<%@ page import="com.hp.mx.html.table.GUIDOTable,
                 com.hp.mx.html.table.TreeTable,
                 com.hp.mx.html.table.AttributeValueTable,
                 com.hp.mx.core.persistence.dataaccess.DataOperations,
                 com.hp.mx.core.persistence.databean.CIM_ComputerSystem,
                 java.util.*,
                 com.hp.mx.core.controllers.MpoController,
                 java.sql.Connection,
                 java.sql.Statement,
                 java.sql.ResultSet,
                 com.hp.mx.core.persistence.databean.CIM_NetworkPort,
                 com.hp.mx.core.persistence.dataaccess.IdentityProvider,
                 java.io.PrintStream,
                 java.io.PrintWriter,
                 java.io.File,
                 com.hp.mx.core.persistence.util.storage.StorageDevice,
                 com.hp.mx.core.persistence.util.storage.Controller,
                 com.hp.mx.core.persistence.util.storage.FCPort,
                 com.hp.mx.portal.ui.MxBean,
                 com.hp.mx.portal.res.MxResourceBean,
                 com.hp.mx.html.core.MxHtmlUtil,
                 com.hp.mx.core.persistence.util.storage.Debug,
                 com.hp.mx.core.persistence.dataaccess.DataAccessException"%>
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="resource" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="genSystemPage" class="com.hp.mx.portal.device.MxGenSystemPage"  scope="session" />
<jsp:useBean id="deviceBean" class="com.hp.mx.portal.device.MxDeviceBean" scope="session" />
<jsp:useBean id="deviceBundle" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<%
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    // setup resources.
    resource.init(loginBean, "StorageRelatedDevicePages");

    // -- Get the durableName, either from the device bean or from a request parameter --
    String durableName = null;

    durableName = deviceBean.getMxNode().getDurableName();
    int nodeID = deviceBean.getMxNode().getDeviceKey();

    %><div class="systemPageGroup"><%

    genSystemPage.dumpDataCollectionLine(deviceBean, deviceBundle, loginBean, out);

    GUIDOTable table = new TreeTable(loginBean.getLocale());
    MxResourceBean res = new MxResourceBean(loginBean.getLocale(), "com.hp.mx.html.table.resource.TableResources");
    table.setResourceBundle(res.getBundle());

    String profile = request.getParameter("profile");
    boolean isTapeDevice = false;
    if(profile != null) {
        if(profile.equals("TapeLibrary")) {
            isTapeDevice = true;
        }
    }


    String headers[] = null;
    if(isTapeDevice) {
        headers = new String[] { resource.getString("columnHeader.elementName"),        // element name
                                 resource.getString("columnHeader.worldWideName"),      // WWN
                                 resource.getString("columnHeader.portType"),           // port type
                                 resource.getString("columnHeader.status"),             // status
        };
    } else {
        headers = new String[] { resource.getString("columnHeader.elementName"),        // element name
                                 resource.getString("columnHeader.worldWideName"),      // WWN
                                 resource.getString("columnHeader.portType"),           // port type
                                 resource.getString("columnHeader.lunCount"),           // LUN Count
                                 resource.getString("columnHeader.status"),             // status
        };
    }

    try {
        StorageDevice sd = new StorageDevice(nodeID, durableName);

        if(sd != null) {
            try {

                String[] row;

                if(sd.hasControllerPorts()) {
                    List controllers = sd.getControllers();

                    Iterator it = controllers.iterator();
                    while(it.hasNext()) {
                        Controller controller = (Controller) it.next();


                        if(controller.hasPorts()) {
                            if(isTapeDevice) {
                                row = new String[] {
                                    controller.getName(),
                                    "",
                                    "",
                                    controller.getStatusHTML(resource.getString(controller.getOperationalStatusResourceKey())),
                                };
                            } else {
                                row = new String[] {
                                    controller.getName(),
                                    "",
                                    "",
                                    ""+controller.getLUNCount(),
                                    controller.getStatusHTML(resource.getString(controller.getOperationalStatusResourceKey()))
                                };
                            }
                            ((TreeTable)table).addRow(row);
                        }

                        List ports = new ArrayList(controller.getPorts());

                        if(ports.size() > 0) {
                            ((TreeTable)table).beginChildren();

                            Iterator pit = ports.iterator();

                            while(pit.hasNext()) {
                                FCPort port = (FCPort) pit.next();

                                if(isTapeDevice) {
                                    row = new String[] {
                                        MxHtmlUtil.encodeHtmlEntities(port.getName()),
                                        MxHtmlUtil.encodeHtmlEntities(port.getWWN()),
                                        port.getPortTypeDisplayString(resource.getBundle()),
                                        port.getStatusHTML(resource.getString(port.getOperationalStatusResourceKey())),
                                    };
                                } else {
                                    row = new String[] {
                                        MxHtmlUtil.encodeHtmlEntities(port.getName()),
                                        MxHtmlUtil.encodeHtmlEntities(port.getWWN()),
                                        port.getPortTypeDisplayString(resource.getBundle()),
                                        ""+port.getLUNCount(),
                                        port.getStatusHTML(resource.getString(port.getOperationalStatusResourceKey())),
                                    };
                                }
                                ((TreeTable)table).addRow(row);

                            }

                            ((TreeTable)table).endChildren();
                        }

                    }
                } else if(sd.hasPorts()) {
                    table = new GUIDOTable(loginBean.getLocale());
                    List ports = new ArrayList(sd.getPorts());

                    ArrayList rows = new ArrayList(ports.size());
                    Iterator it = ports.iterator();

                    while(it.hasNext()) {
                        FCPort port = (FCPort) it.next();


                        if(isTapeDevice) {
                            row = (new String[] {
                                MxHtmlUtil.encodeHtmlEntities(port.getName()),
                                MxHtmlUtil.encodeHtmlEntities(port.getWWN()),
                                port.getPortTypeDisplayString(resource.getBundle()),
                                port.getStatusHTML(resource.getString(port.getOperationalStatusResourceKey())),
                            });
                        } else {
                            row = (new String[] {
                                MxHtmlUtil.encodeHtmlEntities(port.getName()),
                                MxHtmlUtil.encodeHtmlEntities(port.getWWN()),
                                port.getPortTypeDisplayString(resource.getBundle()),
                                ""+port.getLUNCount(),
                                port.getStatusHTML(resource.getString(port.getOperationalStatusResourceKey())),
                            });
                        }
                        rows.add(row);
                    }
                    table.setRows(rows);

                } else {
                    Debug.trace(" *** Storage device (id="+deviceBean.getDeviceKey()+") does not have controllers or ports!");
                }

             } catch(NoSuchElementException nsee) {
                Debug.getDebugSubsystem().panic(nsee);
            }
        }
    } catch(DataAccessException dae) {
        Debug.trace("No Data Found for Storage Device with NodeID = " + nodeID + "  Name = " + durableName);
    } catch(RuntimeException re) {
        Debug.getDebugSubsystem().panic(re);
    } catch(Error e) {
        Debug.getDebugSubsystem().panic(e);
        throw e;
    } finally {
        table.setHeaders(headers);
        out.print(table.getHTML().toString());
    }

%>
</div>
