<%--
//$Source: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/actiononevents/ActionOnEvents_SelectList.jsp,v $
//$Revision: 1.6 $
//$Date: 2005/05/13 17:37:04 $
--%>

<%@ page import="com.hp.mx.html.core.*" %>
<%@page import="com.hp.mx.core.subjects.*"%>
<%@page import="com.hp.mx.portal.ui.*"%>
<%@page import="com.hp.mx.portal.actiononevents.*"%>
<%@page import="com.hp.mx.portal.search.MxActionOnEventSearchUI"%>
<%@page import="java.util.*"%>

<%@page import="com.hp.mx.core.client.MxQueryClient"%>
<%@page import="com.hp.mx.core.querymanager.Query"%>


<jsp:useBean id="aoneUIbean" scope="session" class="com.hp.mx.portal.actiononevents.ActionOnEventsUIBean" />
<jsp:useBean id="aoneTaskBean" class="com.hp.mx.portal.actiononevents.ActionOnEventsManageBean" scope="session"/>
<jsp:useBean id="aoneSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session"/>
<jsp:useBean id="aoEventSearchUI" class="com.hp.mx.portal.search.MxActionOnEventSearchUI" scope="session" />
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<%
    // REQUIRED: This line is required by Tomcat for i18n support.
    MxBean.jspInit(request, response);

    aoneUIbean.getResBundles(loginBean);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
    {
        return;
    }

    // Abort if the user isn't authorized.
    if ((!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.NOTIFICATION_SETTINGS_MODIFICATION_PRIVILEGE))
        || (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.EVENT_MODIFICATION_PRIVILEGE))
        || (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.TOOL_MODIFICATION_PRIVILEGE))
        || (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.SUBJECT_MODIFICATION_PRIVILEGE))
        )
    {
        %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
        <%
    }

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();
    buttons.addMxTag(new MxDefaultTag("btnBack", aoneUIbean.getResString("BUTTON_PREV_LABEL"), "prevPage()"));
    buttons.addMxTag(new MxDefaultTag("btnNext", aoneUIbean.getResString("BUTTON_NEXT_LABEL"), "nextPage()"));

    MxButtons buttons2 = new MxButtons();
    buttons2.clearMxTags();
    buttons2.setSecondary();
    buttons2.setLeftAligned(true);
    buttons2.addMxTag(new MxDefaultTag("btnView", aoneUIbean.getResString("BUTTON_VIEW_LABEL"), "viewQuery()"));
%>
<jsp:setProperty name="aoneUIbean" property="*"/>
<HTML>
<HEAD>
    <TITLE>
        ActionOnEvents_SelectList
    </TITLE>
    <LINK type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
    <LINK type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/actiononevents/css/ActionOnEvents.css'>
    <SCRIPT type='text/javascript' language='JavaScript' src='<%=MxOptions.URL_BASE%>/actiononevents/js/ActionOnEventsUtil.js'></SCRIPT>
    <SCRIPT src="/mxportal/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></SCRIPT>
    <SCRIPT>MxPortalWorkspaceSetHelpTopic("<%=aoneUIbean.getResString("NAME_PAGE_HELP")%>")</SCRIPT>
<%

    int wizardMode = ActionOnEventsUIBean.WIZARD_MODE_SELECT_EVENT_LIST;

    if (null == request.getParameter("wizardMode"))
    {
        wizardMode = ActionOnEventsUIBean.WIZARD_MODE_SELECT_EVENT_LIST;
    }
    else
    {
        try
        {
            wizardMode = Integer.parseInt(request.getParameter("wizardMode"));
        }
        catch(Exception e)
        {
            wizardMode = ActionOnEventsUIBean.WIZARD_MODE_SELECT_EVENT_LIST;
        }

        if ((wizardMode != ActionOnEventsUIBean.WIZARD_MODE_SELECT_EVENT_LIST) &&
            (wizardMode != ActionOnEventsUIBean.WIZARD_MODE_SPECIFY_EVENT_AND_SYSTEM_CRITERIA))
            {
                wizardMode = ActionOnEventsUIBean.WIZARD_MODE_SELECT_EVENT_LIST;
            }
    }

    String reqType = "";

    if (null == request.getParameter("reqType"))
    {
        reqType = aoneUIbean.REQUEST_TYPE_NEW;
    }
    else
    {
        reqType = request.getParameter("reqType");
    }

    String botframe = request.getParameter("botframe");

    if (botframe == null)
    {
        botframe = "false";
    }
%>
    <SCRIPT language="javascript">
    function myOnLoadHandler()
    {
        <%
        if (reqType.equalsIgnoreCase(aoneUIbean.REQUEST_TYPE_EDIT)
                    || botframe.equalsIgnoreCase("true"))
        {
            %>
            var pageHeight  = document.body.scrollHeight;
            var pageWidth  = document.body.scrollWidth;
            parent.setFrmDisplayHeight(pageHeight);
            parent.setFrmDisplayWidth(pageWidth);
            <%
        }
        %>
    }
    </SCRIPT>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% buttons.dumpHeadContent(out); %>
<% buttons2.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

<SCRIPT language="javascript">
    function iframeLoaded()
    {
       var iframe = document.getElementById("frmDisplay");
       var h = iframe.contentWindow.document.body.scrollHeight;
       iframe.style.height = h;
       var w = iframe.contentWindow.document.body.scrollWidth;
       iframe.style.width = w;
        <%
            if (reqType.equalsIgnoreCase(aoneUIbean.REQUEST_TYPE_EDIT)
                        || botframe.equalsIgnoreCase("true"))
            {
                %>
                var pageHeight  = document.body.scrollHeight;
                var pageWidth  = document.body.scrollWidth;
                parent.setFrmDisplayHeight(pageHeight);
                parent.setFrmDisplayWidth(pageWidth);
                parent.scrollBy(0, h);
                <%
            }
            else
            {
                %>
                scrollBy(0, h);
                <%
            }
        %>
    }
    function viewQuery()
    {
        var iframe = document.getElementById("frmDisplay");
        var queryId = document.getElementById("queryId").value;
        var idx = document.getElementById("queryId").selectedIndex;
        var queryName = document.getElementById("queryId").options[idx].text;

        iframe.src = "<%=aoneUIbean.getResString("VIEW_QUERY_PAGE_URL")%>?queryId="
                        + queryId + "&queryName=" + encodeURIComponent(queryName);
    }
    function selectionChanged()
    {
        var iframe = document.getElementById("frmDisplay");
        iframe.src = "<%=aoneUIbean.getResString("BLANK_PAGE_URL")%>";
    }
</SCRIPT>
</HEAD>
<BODY LEFTMARGIN=0 onload="myOnLoadHandler()">
<%
    if (reqType.equalsIgnoreCase(aoneUIbean.REQUEST_TYPE_EDIT))
    {
        %>
         <SPAN class='mxPageSubTitle'>
            <STRONG>
                <%=aoneUIbean.getResString("EDIT_RULE_LABEL")%>
                    &nbsp;<%=aoneUIbean.getTaskName()%>
            </STRONG>
        </SPAN>
        <P>
        <%
    }
    else
    {
        if (botframe.equalsIgnoreCase("true"))
        {
            %>
             <SPAN class='mxPageSubTitle'>
                <STRONG>
                    <%=aoneUIbean.getResString("NEW_RULE_LABEL")%>
                </STRONG>
            </SPAN>
            <P>
            <%
        }
    }
%>
<FORM ID="frmNotification" NAME="frmNotification" METHOD="POST"
    class="mxForm" width="100%">
    <TABLE width='100%' border='0' cellspacing='0' cellpadding='0'>
    <TR valign='top'>
        <TD>
            <%
            int currentTab = 2;
            %>
            <%@include file="ActionOnEvents_DrawTabs.txt"%>
        </TD>
        <TD style='padding-left:12px;' align='left' width='100%'>
            <TABLE  class="top-border-table"
                    WIDTH="100%">
                <TR><TD>
                    <B>
                        <FONT class="mxPageSubTitle">
                            <%=aoneUIbean.getResString("SELECT_EVENT_LIST_LABEL")%>
                        </FONT>
                    </B>
                </TD></TR>
                <TR><TD>
                    <!--HR class='rule' -->
                    <P>
                    <BR>
                    <BR>
                    <BR>
                    <P>
                    <TABLE border="0"
                        cellspacing="2" cellpadding="2"
                        style="border:0px;background:white;margin:5;">
                        <!--Next Segment-->
                        <TR>
                            <TD nowrap>
                                <%=aoneUIbean.getResString("EVENT_LIST_LABEL")%>
                            </TD>
                            <TD nowrap>
                                <SELECT size=1 width=35
                                    onchange="selectionChanged()"
                                    id='queryId' name='queryId'>
                                    <%ActionOnEventsUtil.getEventQueryList(out, loginBean, aoneUIbean.getQueryId());%>
                                </SELECT>
                            </TD>
                            <td nowrap>
                                <% buttons2.dumpButtons(out); %>
                            </td>
                        </tr>
                    </TABLE>
                </TD></TR>
            </TABLE>
        </TD>
    </TR>
    </TABLE>
    <!-- End Data -->
    <SCRIPT>
        function nextPage()
        {
            document.getElementById('frmNotification').action='<%=aoneUIbean.getResString("ACTIONS_PAGE_URL")%>?botframe=<%=botframe%>&reqType=' + '<%=request.getParameter("reqType")%>' + '&wizardMode=' + '<%=wizardMode%>';
            document.getElementById('frmNotification').submit();
        }
        function prevPage()
        {
            document.getElementById('frmNotification').action='<%=aoneUIbean.getResString("NAME_PAGE_URL")%>?botframe=<%=botframe%>&reqType=' + '<%=reqType%>' + '&wizardMode=' + '<%=wizardMode%>';
            document.getElementById('frmNotification').submit();
        }
    </SCRIPT>
</FORM>
<div style="margin-top:15px">
    <% buttons.dumpButtons(out); %>
</div>
<BR>
    <iframe id="frmDisplay"
            style="width:100%; height:25; position:relative; visibility:visible"
            scrolling="auto" marginwidth="0"
            frameborder="0"
            onload="iframeLoaded()"
            src="<%=aoneUIbean.getResString("BLANK_PAGE_URL")%>">
    </iframe>
<%-- need the following <BR> tags to display the full page in mozilla
---- ommitting these causes the bottom buttons to be truncated when
---- the page is rendered in the iframe on the manage page
--%>
<BR>
<BR>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</BODY>
</HTML>
