<%--
//$Source: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/actiononevents/ActionOnEvents_UpdateCore.jsp,v $
//$Revision: 1.33 $
//$Date: 2005/05/07 03:20:13 $
--%>

<%@page import="com.hp.mx.core.controllers.*"%>
<%@page import="com.hp.mx.core.daemon.MxCoreTransaction"%>


<%@page import="com.hp.mx.core.subjects.*"%>
<%@page import="com.hp.mx.portal.actiononevents.*"%>
<%@page import="com.hp.mx.portal.search.MxActionOnEventSearchUI"%>
<%@page import="com.hp.mx.html.table.*"%>
<%@page import="com.hp.mx.portal.ui.*"%>
<%@page import="java.net.URLEncoder"%>

<jsp:useBean id="aoEventSearchUI" class="com.hp.mx.portal.search.MxActionOnEventSearchUI" scope="session" />
<jsp:useBean id="aoneUIbean" scope="session" class="com.hp.mx.portal.actiononevents.ActionOnEventsUIBean" />
<jsp:useBean id="aoneTaskBean" scope="session" class="com.hp.mx.portal.actiononevents.ActionOnEventsManageBean" />
<jsp:useBean id="aoneSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session"/>
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<%
    // REQUIRED: This line is required by Tomcat for i18n support.
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
    {
        return;
    }

    // Abort if the user isn't authorized.
    if ((!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.NOTIFICATION_SETTINGS_MODIFICATION_PRIVILEGE))
        || (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.EVENT_MODIFICATION_PRIVILEGE))
        || (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.TOOL_MODIFICATION_PRIVILEGE))
        || (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.SUBJECT_MODIFICATION_PRIVILEGE))
        )
    {
        %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
        <%
    }
%>
<%
    aoneUIbean.getResBundles(loginBean);

    int wizardMode = ActionOnEventsUIBean.WIZARD_MODE_SELECT_EVENT_LIST;

    if (null == request.getParameter("wizardMode"))
    {
        wizardMode = ActionOnEventsUIBean.WIZARD_MODE_SELECT_EVENT_LIST;
    }
    else
    {
        try
        {
            wizardMode = Integer.parseInt(request.getParameter("wizardMode"));
        }
        catch(Exception e)
        {
            wizardMode = ActionOnEventsUIBean.WIZARD_MODE_SELECT_EVENT_LIST;
        }

        if ((wizardMode != ActionOnEventsUIBean.WIZARD_MODE_SELECT_EVENT_LIST) &&
            (wizardMode != ActionOnEventsUIBean.WIZARD_MODE_SPECIFY_EVENT_AND_SYSTEM_CRITERIA))
            {
                wizardMode = ActionOnEventsUIBean.WIZARD_MODE_SELECT_EVENT_LIST;
            }
    }

    String reqType = "";
    if (null == request.getParameter("reqType"))
    {
        aoneUIbean.alert(out, aoneUIbean.getResString("INVALID_REQUEST"));
    }
    else
    {
        reqType = request.getParameter("reqType");
    }

    String botframe = request.getParameter("botframe");

    if (botframe == null)
    {
        botframe = "false";
    }

    if (reqType.equalsIgnoreCase(aoneUIbean.REQUEST_TYPE_NEW))
    {
        try
        {
            if (wizardMode == ActionOnEventsUIBean.WIZARD_MODE_SPECIFY_EVENT_AND_SYSTEM_CRITERIA)
            {
                int qid = aoEventSearchUI.saveActionOnEventsSearch();

                if (qid <= 0)
                {
                    // error saving query
                    aoneUIbean.alert(out, aoneUIbean.getResString("ERR_SAVE_QUERY"));
                    aoneUIbean.replaceLocation(out, aoneUIbean.getResString("SUMMARY_PAGE_URL")
                                + "?botframe=" + botframe
                                + "&reqType=" + aoneUIbean.REQUEST_TYPE_NEW + "&wizardMode=" + wizardMode);
                    return;
                }
                aoneUIbean.setQueryId(Integer.toString(qid));
            }

            if (!aoneUIbean.createActionOnEventsTask(out))
            {
                aoneUIbean.replaceLocation(out, aoneUIbean.getResString("SUMMARY_PAGE_URL")
                            + "?botframe=" + botframe
                            + "&reqType=" + aoneUIbean.REQUEST_TYPE_NEW + "&wizardMode=" + wizardMode);
                return;
            }
            aoneUIbean.removeInprogressTaskName(aoneUIbean.getTaskName(), pageContext.getSession().getId());
        }
        catch (Throwable t)
        {
            aoneUIbean.replaceLocation(out, aoneUIbean.getResString("SUMMARY_PAGE_URL")
                        + "?botframe=" + botframe
                        + "&reqType=" + aoneUIbean.REQUEST_TYPE_NEW + "&wizardMode=" + wizardMode);
            return;
        }
    }
    else if (reqType.equalsIgnoreCase(aoneUIbean.REQUEST_TYPE_EDIT))
    {
        try
        {
            try
            {

                int qid = aoEventSearchUI.saveActionOnEventsSearch(aoneUIbean.getQueryId());

                if (qid <= 0)
                {
                    // error saving query
                    aoneUIbean.alert(out, aoneUIbean.getResString("ERR_SAVE_QUERY"));
                    aoneUIbean.replaceLocation(out, aoneUIbean.getResString("SUMMARY_PAGE_URL")
                            + "?botframe=" + botframe
                            + "&reqType=" + aoneUIbean.REQUEST_TYPE_EDIT + "&wizardMode=" + wizardMode);
                    return;
                }

                aoneUIbean.setQueryId(Integer.toString(qid));
            }
            catch(Exception e)
            {
                e.printStackTrace();
            }
            int result = aoneUIbean.modifyActionOnEventsTask(out);
           // task delete failure (result == 1) - refresh Manage page
            if (result == 1)
            {
             out.write("<SCRIPT>"
                  + "parent.document.location='" + aoneUIbean.getResString("MANAGE_PAGE_URL")
                  + "';"
                  + "document.location='" + aoneUIbean.getResString("BLANK_PAGE_URL")
                  + "';"
                  + "</SCRIPT>");

            return;
            }
            if (result == 2)// any other failure
            {
                aoneUIbean.replaceLocation(out, aoneUIbean.getResString("SUMMARY_PAGE_URL")
                        + "?botframe=" + botframe
                        + "&reqType=" + aoneUIbean.REQUEST_TYPE_EDIT + "&wizardMode=" + wizardMode);
                return;
            }
        }
        catch (Throwable t)
        {
            t.printStackTrace();
            aoneUIbean.replaceLocation(out, aoneUIbean.getResString("SUMMARY_PAGE_URL")
                        + "?botframe=" + botframe
                        + "&reqType=" + aoneUIbean.REQUEST_TYPE_EDIT + "&wizardMode=" + wizardMode);
            return;
        }
        out.write("<SCRIPT>"
                  + "parent.document.location='" + aoneUIbean.getResString("MANAGE_PAGE_URL")
                  + "?highlightTask=" + URLEncoder.encode(aoneUIbean.getTaskName(), "UTF-8")
                  + "';"
                  + "document.location='" + aoneUIbean.getResString("BLANK_PAGE_URL")
                  + "';"
                  + "</SCRIPT>");
        return;
    }
    else if (reqType.equalsIgnoreCase(aoneUIbean.REQUEST_TYPE_DELETE))
    {
        try
        {
            /*
            * Get the row number of the selected task from the selection model object
            */
            if (!aoneTaskBean.deleteActionOnEventsTask(aoneSelectionModel.getSelectedIndices()[0], out))
            {
                aoneUIbean.replaceLocation(out, aoneUIbean.getResString("MANAGE_PAGE_URL"));
                return;
            }
        }
        catch (Throwable t)
        {
            aoneUIbean.replaceLocation(out, aoneUIbean.getResString("MANAGE_PAGE_URL"));
            return;
        }
    }
    else if (reqType.equalsIgnoreCase(aoneUIbean.REQUEST_TYPE_ENABLE_DISABLE))
    {
        try
        {
            /*
            * Get the row number of the selected task from the selection model object
            */
            if (!aoneTaskBean.enableDisableActionOnEventsTask(aoneSelectionModel.getSelectedIndices()[0], out))
            {
                aoneUIbean.replaceLocation(out, aoneUIbean.getResString("MANAGE_PAGE_URL"));
                return;
            }
        }
        catch (Throwable t)
        {
            aoneUIbean.replaceLocation(out, aoneUIbean.getResString("MANAGE_PAGE_URL"));
            return;
        }
    }
    else if (reqType.equalsIgnoreCase(aoneUIbean.REQUEST_TYPE_COPY))
    {
        try
        {
            String newTaskName = request.getParameter("newTaskName");

            if ((newTaskName == null) || newTaskName.trim().equals(""))
            {
                aoneUIbean.alert(out, aoneUIbean.getResString("INVALID_TASK_NAME"));
                aoneUIbean.replaceLocation(out, aoneUIbean.getResString("COPY_PAGE_URL")
                            + "?botframe=" + botframe
                            + "&reqType=" + aoneUIbean.REQUEST_TYPE_COPY);
                return;
            }
            /*
            * Get the row number of the selected task from the selection model object
            */
            if (!aoneTaskBean.copyActionOnEventsTask(aoneSelectionModel.getSelectedIndices()[0], newTaskName, out))
            {
                aoneUIbean.replaceLocation(out, aoneUIbean.getResString("COPY_PAGE_URL")
                            + "?botframe=" + botframe
                            + "&reqType=" + aoneUIbean.REQUEST_TYPE_COPY);
                return;
            }
        }
        catch (Throwable t)
        {
            aoneUIbean.replaceLocation(out, aoneUIbean.getResString("COPY_PAGE_URL")
                        + "?botframe=" + botframe
                        + "&reqType=" + aoneUIbean.REQUEST_TYPE_COPY);
            return;
        }
    }

    if (reqType.equalsIgnoreCase(aoneUIbean.REQUEST_TYPE_EDIT)
        || botframe.equalsIgnoreCase("true"))
    {
        out.write("<SCRIPT>"
                  + "parent.document.location='" + aoneUIbean.getResString("MANAGE_PAGE_URL")
                  + "?highlightTask=" + URLEncoder.encode(aoneUIbean.getTaskName(), "UTF-8")
                  + "';"
                  + "document.location='" + aoneUIbean.getResString("BLANK_PAGE_URL")
                  + "';"
                  + "</SCRIPT>");
        return;
    }

    String manage_page_params = "highlightTask="
                            + URLEncoder.encode(aoneUIbean.getTaskName(), "UTF-8");
%>
<HEAD>
    <SCRIPT src="/mxportal/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></SCRIPT>
    <SCRIPT>MxPortalActionStart("MANAGE_AUTOMATIC_EVENT_HANDLING", "<%=manage_page_params%>")</SCRIPT>
</HEAD>
<BODY>
</BODY>
