<%-- This is to include the MxBean Class--%>
<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.portal.ui.MxDateAndTime" %>
<%@ page import="com.hp.mx.portal.help.*" %>

<%-- Used to deal with parramaters--%>
<%@ page import="com.hp.mx.portal.clustermonitor.CMUtility" %>

<%-- Creates Various beans --%>


<%-- Used for the recource file that contains all the text--%>
<jsp:useBean id="rb" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="mscsProps"      class="com.hp.clustermonitor.portal.clusterResource.ClusterProperty" scope="session" />


<%--  Used to check if the current session is vaild--%>
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>


<%
    //Static Function That sets up some encoding stuff
    MxBean.jspInit(request, response);

    // check to see if the loginBean session has timed out
    if ( loginBean.checkLogoutConditionForWebPage(pageContext) == true){
        //This will create a blank html page
        return;
    }
    //loads the properties file
    rb.init(loginBean, "CmCRSP");

    String szMin = request.getParameter("Min");
    String szSec = request.getParameter("Sec");
    boolean bVaild = true;
    boolean bSavedWorked = true;

    //Not saving just loading
    if (szMin == null && szSec == null){
      //Return False if there was an error
      if(!mscsProps.getMscsPollingInfo(loginBean.getXeUserSession() ) ){
        return;
      }
    }
    //Trying to save
    else{
      //validate
      bVaild = mscsProps.isPollingDataValid(szMin,szSec);
      if(bVaild){
        mscsProps.setMinutes(szMin);
        mscsProps.setSeconds(szSec);
        bSavedWorked = mscsProps.startSave();
      }
    }

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();

    MxTag okBtnTag = new MxDefaultTag("okBtn", rb.getString("OK"), "okclick()");
    okBtnTag.setAttr(MxTag.TYPE, "submit");
    buttons.addMxTag(okBtnTag);
%>

<html>
  <head>
    <!-- This stuff adds some java script functions to the jsp page-->
    <SCRIPT src="/mxportal/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></SCRIPT>
    <script src="/mxportal/js/MxBrowser.js" language="JavaScript" type="text/javascript"></script>
    <script language="javascript" type="text/javascript">

    MxPortalWorkspaceSetHelpTopic("admin_cluster_clusterCmxSettings");


      function myOnLoad(){
         ourButtonManager.disableButtonById('okBtn');
       <%if(szMin == null){%>
//        document.getElementById('Resource').disabled=true;
        document.getElementById('Resource').disabled=false;
//        document.getElementById('Polling').style.visibility = "hidden";

      <%}else{%>
        document.getElementById('ClusterType').value=1;
        document.getElementById('Resource').value=1;
      <%}if(szMin != null){%>
        document.getElementById('min').value = "<%=szMin%>";
      <%}if(szSec != null){%>
        document.getElementById('sec').value = "<%=szSec%>";
      <%}%>
      }
      function detectChange(){
        ourButtonManager.enableButtonById('okBtn');
      }

     function enableResource(){
       box = document.getElementById("ClusterType");
       destination = box.options[box.selectedIndex].value;
       if (destination){
        document.getElementById("Resource").disabled=false;
       }
       else{
         document.getElementById("Resource").disabled=true;
         document.getElementById('Polling').style.visibility = "hidden";
         document.getElementById('Resource').value="";
       }
     }

     function displayPolling(){
       box = document.getElementById("Resource");
       destination = box.options[box.selectedIndex].value;
       if (destination){
         document.getElementById('Polling').style.visibility = "visible";
          }
       else{
         document.getElementById('Polling').style.visibility = "hidden";
       }
     }

     function okclick(){
       var curMin = document.getElementById('min').value;
       var curSec = document.getElementById('sec').value;
       if((curMin != <%=mscsProps.getMinutes()%>) || (curSec != <%=mscsProps.getSeconds()%>)){
         var url ="";
         url ="CmClusterResource.jsp?Min="+curMin+"&Sec="+curSec;
         document.location.href = url;
       }
       else{
          ourButtonManager.disableButtonById('okBtn');
       }
     }

    </script>
   <link type='text/css' rel='stylesheet' href='/mxportal/DevicePage/css/MxDevice.css'>
   <link type='text/css' rel='stylesheet' href='/mxportal/css/MxPortalEx.css'>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxButton.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

  </head>

  <body onLoad='myOnLoad();'>
    <div>
      <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" bordercolor="#111111" width="100%">
        <tr>
          <td width="100%">
            <% if (!bVaild){%>
              <script language="javascript" type="text/javascript">
              alert("<%=rb.getString("INVALID_DATA")%> <%=rb.getString("NOT_CHANGED")%>");
              </script>
            <%}%>
           <% if (!bSavedWorked){%>
              <script language="javascript" type="text/javascript">
              alert("<%=rb.getString("UNABLETOSAVEPROPERTIES")%>");
              </script>
            <%}%>
            <B><%=rb.getString("CLUCMXSELTEXT")%>:</B>
          </td>
        </tr>
        <tr>
          <td width="100%">&nbsp;</td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" bordercolor="#111111">
              <tr align="left" valign="middle">
                <td>&nbsp;&nbsp;</td>
                <td><%=rb.getString("CLUSTERTYPE")%></td>
                <td>&nbsp;&nbsp;</td>
                <td><%=rb.getString("RESOURCE")%></td>
              </tr>
              <tr align="left" valign="middle">
                <td>&nbsp;&nbsp;</td>
                <td>
                  <select id="ClusterType" name="ClusterType" size="1" STYLE="width:150px" name="D1" onChange="enableResource()">
                    <option value="">&nbsp;</option>
                    <option selected value="1"><%=rb.getString("ALL_MSCS")%></option>
                  </select>
                </td>
                <td>&nbsp;&nbsp;</td>
                <td>
                    <select id="Resource" name="Resource" size="1" STYLE="width:150px" name="D2" onChange="displayPolling()">
                      <option value="">&nbsp;</option>
                      <option selected value="1"><%=rb.getString("MSCS")%></option>
                    </select>
                </td>
              </tr>
            </table>
            <br>
            <br>
            <div id="Polling" name="Polling" >
              <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" bordercolor="#111111">
                <tr>
                  <td><b><%=rb.getString("POLLING")%>:</b></td>
                  <td>&nbsp;&nbsp;</td>
                </tr>
                <tr>
                  <td>&nbsp;&nbsp;</td>
                  <td>
                       <%=rb.getString("SETPOLL")%>
                       <input type="text" name="min" id="min" size="1" maxlength="3" ONKEYDOWN="detectChange()" value="<%=mscsProps.getMinutes()%>">
                       <%=rb.getString("MINUTES")%>&nbsp;
                       <input type="text" name="sec" id="sec" size="1" maxlength="3" ONKEYDOWN="detectChange()" value="<%=mscsProps.getSeconds()%>">
                       <%=rb.getString("SECONDS")%>&nbsp;
                  </td>
                </tr>
              </table>
            <hr class='mx-hr'>
            <div align="right">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" bordercolor="#111111" width="100%" id="AutoNumber3">
                  <tr>
                    <td align="left" valign="middle">
                        <p><%=mscsProps.getSaved(rb,loginBean.getLocale())%>
                    </td>
                    <td align="right" valign="middle">
                        <% buttons.dumpButtons(out); %>
                    </td>
                  </tr>
                </table>
            </div>
            </td>
         </tr>
      </div>
    </table>
  </center>
  </div>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</body>
</html>
