<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.core.nodemanager.*"  %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="drillDown" class="com.hp.mx.portal.core.MxDrillDown" scope="session" />
<jsp:useBean id="rbDrillDown" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="deviceBundle" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<%
    MxBean.jspInit(request, response);
    rbDrillDown.init(loginBean, "MxDrillDown");

    String szDeviceId = request.getParameter("deviceId");
    String szDeviceGUID = request.getParameter("deviceGUID");
    String szDrillDownType = request.getParameter("drillDownType");
    String szMemberDeviceId = request.getParameter("memberDeviceId");

    boolean bSetGlobalSelection = false;
    if (request.getParameter("globalselection") != null &&
        request.getParameter("globalselection").equalsIgnoreCase("true"))
    {
        bSetGlobalSelection = true;
    }

    int deviceId = -1;

    String szDrillDownUrl = null;
    String szTitle = null;
    String szSubTitle = null;

    deviceBundle.init(loginBean, "MxDeviceBundle");
    NodeTypeMapper nodeTypeMapper = NodeTypeMapper.getDefaultMapper();
%>

<HTML>
<HEAD>
<TITLE></TITLE>
<script src="/SessionReset.js" language="JavaScript" type="text/javascript"></script>
<script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
<script language="JavaScript" type="text/javascript">
<%
    String szName=null;
    String szType=null;
    if (szDeviceGUID != null)
    {
        deviceId = drillDown.getDeviceKeyForGUID(loginBean, szDeviceGUID);
    }
    else if (szDeviceId != null)
    {
        deviceId = new Integer(szDeviceId).intValue();
    }

    if (deviceId != -1)
    {
        if ( !drillDown.isNodeAuthorized(loginBean, deviceId) )
            return;

        if (szMemberDeviceId != null)
        {
            int memberDeviceId = new Integer(szMemberDeviceId).intValue();
            drillDown.searchForDrillDownTool(loginBean, deviceId, memberDeviceId, szDrillDownType);
        }
        else
        {
            drillDown.searchForDrillDownTool(loginBean, deviceId, szDrillDownType);
        }

        if (bSetGlobalSelection)
        {
            drillDown.setSelection(loginBean, deviceId);
        }

        szName =loginBean.getNodeClient().getNodeByKey(deviceId, false).getNameString();
        szType = loginBean.getNodeClient().getNodeByKey(deviceId,false).getDeviceType();
    }

    if (drillDown.drillDownToolFound())
    {
        szTitle = drillDown.getTheDrillDownToolName(loginBean.getLocale());
        szType = nodeTypeMapper.getLocalizedDisplayString(szType, loginBean.getLocale());
        szSubTitle = szName+" ("+szType+")";
        szDrillDownUrl = drillDown.getTheDrillDownURL();
    }
    else if (drillDown.urlOnlyToolFound())
    {
        szDrillDownUrl = drillDown.getTheDrillDownURL();
        String tempTitle = drillDown.getUrlTitle();

        if ( tempTitle != null )
        {
            if ( tempTitle.equals("System Page") )
            {
                if ( drillDown.canUseSystemPage() )
                {
                	szTitle = deviceBundle.getString("SYSTEM_PAGE");
	                szType = nodeTypeMapper.getLocalizedDisplayString(szType, loginBean.getLocale());
    	            szSubTitle = szName+" ("+szType+")";
                }
                else
                	szDrillDownUrl = null ;
            }
            else
            {
                szTitle = tempTitle;
                szSubTitle = null;
            }
        }
    }

    if (szDrillDownUrl != null)
    {
        if (drillDown.launchInSeparateWindow())
        {
            if (bSetGlobalSelection)
            {
                out.println("MxPortalManageMenuRefreshSelections();");
            }

            out.println("reportWindow = window.open(\"" + szDrillDownUrl + "\", \"_blank\", \"\")");
            out.println("reportWindow.focus()");
        }
        else
        {
            if (szTitle != null)
            {
                if (szSubTitle != null)
                {
                  out.println("MxPortalWorkspaceCreateUrlEx(\"" + szTitle+ "\", \"" +
                                 szSubTitle + "\", \"" + szDrillDownUrl + "\");");
                }
                else
                {
                    out.println("MxPortalWorkspaceCreateUrl(\"" + szTitle+ "\",\"" + szDrillDownUrl + "\");");
                }
            }
            else
            {
                out.println("MxPortalWorkspaceCreateUrl(\"NA\",\"" + szDrillDownUrl + "\");");
            }
        }
    }
%>
</script>
</HEAD>
</HTML>
