<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.utilities.DebugOutput" %>
<%@ page import="com.hp.mx.utilities.DebugSubsystem" %>
<%@ page import="com.hp.mx.core.subjects.usermanager.MxUser" %>
<%@ page import="com.hp.mx.core.controllers.MxUserController" %>
<%@ page import="java.util.*" %>
<%@ page import="com.hp.mx.core.controllers.MxQueryController" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="bannerSettings" class="com.hp.mx.portal.custom.MxBannerSettings" scope="session" />

<%
    // REQUIRED: This line is rquired by Tomcat for i18n support.
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    // Bean initialization
    bannerSettings.initialize(loginBean);

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();

    buttons.addMxTag(new MxDefaultTag("restoreBtn", bannerSettings.getResourceString("RESTORE_DEFAULTS"), "restoreDefaults()"));
    buttons.addMxTag(new MxDefaultTag("okBtn", bannerSettings.getResourceString("OK_BTN"), "preSubmit()"));

%>

<html>

<head>
<title></title>
<link type='text/css' rel='stylesheet' href='/mxportal/css/MxPortalEx.css'>
<script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
<script src="<%=MxOptions.URL_BASE%>/js/utilities.js" language="JavaScript" type="text/javascript"></script>
<script language="JavaScript" type="text/javascript">
        MxPortalWorkspaceSetHelpTopic("start_customize_banner");

        // For a given option list, and list id, return the index of that particular list.
        // For example, in the combo box for the first status list, what is the index of "All Systems"?
        function getDefaultIndex(elementId, id)
        {
            el = document.getElementById(elementId);
            index = 0;
            count = el.length;
            for (index = 0; index < count; index++) {
                testValue = el.options[index].value;
                if (isNaN(testValue) == true) {
                    params   = testValue.split(";");
                    listID   = params[0].split("=");
                    listName = params[1].split("=");
                    if (listID[1] == id){
                        return index;
                    }
                }
            }
            return 1; //if no match, just take the first one
        }

        // set all values to their default values
        function restoreDefaults()
        {
            myForm = document.getElementById("bannerForm");
            document.getElementById('firstStatus').checked = ("<%=bannerSettings.DEFAULT_SHOW_STATUS1%>"=="checked");
            document.getElementById('firstStatusType').value = "<%=bannerSettings.DEFAULT_STATUS1_TYPE%>";
            document.getElementById('firstStatusList').selectedIndex = getDefaultIndex('firstStatusList', "<%=bannerSettings.getDefaultObjId()%>");
            document.getElementById('firstStatusLabel').value = "<%=bannerSettings.DEFAULT_STATUS1_LABEL%>";
            enableElement('firstStatusType');
            enableElement('firstStatusList')
            enableElement('firstStatusLabel');

            document.getElementById('secondStatus').checked = ("<%=bannerSettings.DEFAULT_SHOW_STATUS2%>"=="checked");
            document.getElementById('secondStatusType').value = "<%=bannerSettings.DEFAULT_STATUS2_TYPE%>";
            document.getElementById('secondStatusList').selectedIndex = getDefaultIndex('secondStatusList', "<%=bannerSettings.getDefaultObjId()%>");
            document.getElementById('secondStatusLabel').value = "<%=bannerSettings.DEFAULT_STATUS2_LABEL%>";
            disableElement('secondStatusType');
            disableElement('secondStatusList');
            disableElement('secondStatusLabel');

            document.getElementById('alarm').checked = ("<%=bannerSettings.DEFAULT_SHOW_ALARM%>"=="checked");
            document.getElementById('alarmType').value = "<%=bannerSettings.DEFAULT_ALARM_TYPE%>";
            document.getElementById('alarmList').selectedIndex = getDefaultIndex('alarmList', "<%=bannerSettings.getDefaultObjId()%>");
            document.getElementById('alarmLabel').value = "<%=bannerSettings.DEFAULT_ALARM_LABEL%>";
            disableElement('alarmType');
            disableElement('alarmList');
            disableElement('alarmLabel');

            checkListSelection();
        }

        // enable all the elements so that they get processed
        function preSubmit()
        {
            enableElement('firstStatusType');
            enableElement('firstStatusList');
            enableElement('firstStatusLabel');

            enableElement('secondStatusType');
            enableElement('secondStatusList');
            enableElement('secondStatusLabel');

            enableElement('alarmType');
            enableElement('alarmList');
            enableElement('alarmLabel');

            var myForm = document.getElementById("bannerForm");
            myForm.submit();
        }

        // if first status checkbox is enabled/disabled, enable/disable everything that goes with it
        function enableStatus1Options(elCheckbox)
        {
            document.getElementById('firstStatusType').disabled = !elCheckbox.checked;
            document.getElementById('firstStatusList').disabled = !elCheckbox.checked;
            document.getElementById('firstStatusLabel').disabled = !elCheckbox.checked;
        }

        // if second status checkbox is enabled/disabled, enable/disable everything that goes with it
        function enableStatus2Options(elCheckbox)
        {
            document.getElementById('secondStatusType').disabled = !elCheckbox.checked;
            document.getElementById('secondStatusList').disabled = !elCheckbox.checked;
            document.getElementById('secondStatusLabel').disabled = !elCheckbox.checked;
        }

        // if alarm checkbox is enabled/disabled, enable/disable everything that goes with it
        function enableAlarmOptions(elCheckbox)
        {
            document.getElementById('alarmType').disabled = !elCheckbox.checked;
            document.getElementById('alarmList').disabled = !elCheckbox.checked;
            document.getElementById('alarmLabel').disabled = !elCheckbox.checked;
        }

        // Verify that the user selected a list, not a folder. If they do choose
        // a folder, for any of the lists, put up an error message and disable
        // the OK button.
        function checkListSelection()
        {
/*            var list1Index = document.getElementById("firstStatusList").value;
            var list2Index = document.getElementById("secondStatusList").value;
            var list3Index = document.getElementById("alarmList").value;
            var list1Type = "list";
            var list2Type = "list";
            var list3Type = "list";
            var msg = "";

            // DID THE USER SELECT A LIST?
            var list1WasSelected = isNaN(list1Index);
            var list2WasSelected = isNaN(list2Index);
            var list3WasSelected = isNaN(list3Index);
            if (!list1WasSelected)
            {
                // NO!  User selected a folder
                // strip out all &nbsp; (blank space)
                var folder1 = document.getElementById("firstStatusList").options[list1Index].text;

                // display error - please select a list
                msg = "<%=bannerSettings.getResourceString("customize.beginError")%>" + folder1 + "<%=bannerSettings.getResourceString("customize.endError")%>" + "<BR>";

                list1Type = "category";
            }
            else if (!list2WasSelected)
            {
                // NO!  User selected a folder
                // strip out all &nbsp; (blank space)
                var folder2 = document.getElementById("secondStatusList").options[list2Index].text;

                // display error - please select a list
                msg = "<%=bannerSettings.getResourceString("customize.beginError")%>" + folder2 + "<%=bannerSettings.getResourceString("customize.endError")%>" + "<BR>";

                list2Type = "category";
            }
            else if (!list3WasSelected)
            {
                // NO!  User selected a folder
                // strip out all &nbsp; (blank space)
                var folder3 = document.getElementById("alarmList").options[list3Index].text;

                // display error - please select a list
                msg = "<%=bannerSettings.getResourceString("customize.beginError")%>" + folder3 + "<%=bannerSettings.getResourceString("customize.endError")%>" + "<BR>";

                list3Type = "category";
            }

            // Display any error messages and enable/disable OK button
            document.getElementById("listError").innerHTML = msg;
            var oOKButton = document.getElementById("okBtn");
            if ((!list1WasSelected) || (!list2WasSelected) || (!list3WasSelected))
            {
                ourButtonManager.disableButton(oOKButton);
            }
            else
            {
                ourButtonManager.enableButton(oOKButton);
            }

            // Save the selection type
            var el1 = document.getElementById("firstStatusListType");
            if (el1 != null)
            {
                el1.value = list1Type;
            }
            var el2 = document.getElementById("secondStatusListType");
            if (el2 != null)
            {
                el2.value = list2Type;
            }
            var el3 = document.getElementById("alarmListType");
            if (el3 != null)
            {
                el3.value = list3Type;
            }
*/        }


    </script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxButton.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</head>

<body>
    <%
    ///////////////////////////////////////////////////////////////////////////
    // IS THIS A POST?  Check data validity and redirect
    ///////////////////////////////////////////////////////////////////////////
    if (request.getMethod().equals("POST"))
    {
        // Set the user's choices
        bannerSettings.processPost(request);
%>
    <script>
        MxPortalRefreshLeftSide();
    </script>
<%
    }
    ///////////////////////////////////////////////////////////////////////////
    // Either not a post, or a refresh after a post (drop through)
    ///////////////////////////////////////////////////////////////////////////
%>
<div style="margin-left:20px">
<form action="MxBannerCustomize.jsp" method="post" id="bannerForm" name="bannerForm">
  <div class="errorTextBold" id="listError"></div>
  <table cellpadding=3 cellspacing=0>
    <tr>
      <td>
        <input TYPE="CHECKBOX" NAME="firstStatus" ID="firstStatus" value="checked" <%= bannerSettings.getShowStatus1() ? "checked" : ""%> onClick="enableStatus1Options(this)">
      </td>
      <td nowrap>
        <strong><%=bannerSettings.getResourceString("customize.prompt.showSummaryOf")%></strong>
      </td>
      <td>
        <select name="firstStatusType" id="firstStatusType" <%=bannerSettings.getShowStatus1() ? "enabled" : "disabled" %>>
            <option value="<%=MxQueryController.BANNER_HARDWARE_STATUS_RESULTS%>" <%= bannerSettings.getStatus1TypeSelected(MxQueryController.BANNER_HARDWARE_STATUS_RESULTS) ? "selected" : "" %>><%=bannerSettings.getResourceString("customize.statustype.hardware")%></option>
            <option value="<%=MxQueryController.BANNER_UNCLEAREDEV_STATUS_RESULTS%>" <%= bannerSettings.getStatus1TypeSelected(MxQueryController.BANNER_UNCLEAREDEV_STATUS_RESULTS) ? "selected" : "" %>><%=bannerSettings.getResourceString("customize.statustype.events")%></option>
        </select>
      </td>
    </tr>
    <tr>
      <td>
        &nbsp;
      </td>
      <td nowrap>
        <strong>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<%=bannerSettings.getResourceString("customize.prompt.forTheList")%></strong>
      </td>
      <td>
        <select id="firstStatusList" size="1" name="firstStatusList" onChange="checkListSelection()" <%=bannerSettings.getShowStatus1() ? "enabled" : "disabled" %>>
                <%
                    // Display the selection box of all queries
                    bannerSettings.displayListOptionTags(bannerSettings.getStatus1List(),out);
                %>
        </select>
      </td>
    </tr>
    <tr>
      <td>
        &nbsp;
      </td>
      <td nowrap>
        <strong>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<%=bannerSettings.getResourceString("customize.prompt.labelIt")%></strong>
      </td>
      <td>
        <input type="text" name="firstStatusLabel" id="firstStatusLabel" size="30" maxlength=30" value="<%= MxHtmlUtil.encodeHtmlEntities(bannerSettings.getStatus1Label()) %>" <%=bannerSettings.getShowStatus1() ? "enabled" : "disabled" %>>
      </td>
    </tr>
  </table>
  <p>
  <table cellpadding=3 cellspacing=0>
    <tr>
      <td>
        <input TYPE="CHECKBOX" NAME="secondStatus" ID="secondStatus" value="checked" <%= bannerSettings.getShowStatus2() ? "checked" : "" %> onClick="enableStatus2Options(this)">
      </td>
      <td nowrap>
        <strong><%=bannerSettings.getResourceString("customize.prompt.showSummaryOf")%></strong>
      </td>
      <td>
        <select name="secondStatusType" id="secondStatusType" <%=bannerSettings.getShowStatus2() ? "enabled" : "disabled" %>>
            <option value="<%=MxQueryController.BANNER_HARDWARE_STATUS_RESULTS%>" <%= bannerSettings.getStatus2TypeSelected(MxQueryController.BANNER_HARDWARE_STATUS_RESULTS) ? "selected" : "" %>><%=bannerSettings.getResourceString("customize.statustype.hardware")%></option>
            <option value="<%=MxQueryController.BANNER_UNCLEAREDEV_STATUS_RESULTS%>" <%= bannerSettings.getStatus2TypeSelected(MxQueryController.BANNER_UNCLEAREDEV_STATUS_RESULTS) ? "selected" : "" %>><%=bannerSettings.getResourceString("customize.statustype.events")%></option>
        </select>
      </td>
    </tr>
    <tr>
      <td>
        &nbsp;
      </td>
      <td nowrap>
        <strong>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<%=bannerSettings.getResourceString("customize.prompt.forTheList")%></strong>
      </td>
      <td>
        <select id="secondStatusList" size="1" name="secondStatusList" onChange="checkListSelection()" <%=bannerSettings.getShowStatus2() ? "enabled" : "disabled" %>>
                <%
                    // Display the selection box of all queries
                    bannerSettings.displayListOptionTags(bannerSettings.getStatus2List(),out);
                %>
        </select>
      </td>
    </tr>
    <tr>
      <td>
        &nbsp;
      </td>
      <td nowrap>
        <strong>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<%=bannerSettings.getResourceString("customize.prompt.labelIt")%></strong>
      </td>
      <td>
        <input type="text" name="secondStatusLabel" id="secondStatusLabel" size="30" maxlength="30" value="<%= MxHtmlUtil.encodeHtmlEntities(bannerSettings.getStatus2Label()) %>" <%=bannerSettings.getShowStatus2() ? "enabled" : "disabled" %>>
      </td>
    </tr>
  </table>
  <p>
  <table cellpadding=3 cellspacing=0>
    <tr>
      <td>
        <input TYPE="CHECKBOX" NAME="alarm" ID="alarm" value="checked" <%= bannerSettings.getShowAlarm() ? "checked" : "" %> onClick="enableAlarmOptions(this)">
      </td>
      <td colspan="2" nowrap>
        <strong><%=bannerSettings.getResourceString("customize.prompt.showAlarmWhen")%></strong>
      </td>
    </tr>
    <tr>
      <td>
        &nbsp;
      </td>
      <td nowrap>
        <strong>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<%=bannerSettings.getResourceString("customize.prompt.alarmCondition")%></strong>
      </td>
      <td>
        <select size="1" name="alarmType" id="alarmType" <%=bannerSettings.getShowAlarm() ? "enabled" : "disabled" %>>
            <option value="<%=bannerSettings.BANNER_ANY_CRITICAL%>" <%= bannerSettings.getAlarmTypeSelected(bannerSettings.BANNER_ANY_CRITICAL) ? "selected" : "" %>><%=bannerSettings.getResourceString("customize.alarmtype.anyCritical")%></option>
            <option value="<%=bannerSettings.BANNER_ANY_MAJOR%>" <%= bannerSettings.getAlarmTypeSelected(bannerSettings.BANNER_ANY_MAJOR) ? "selected" : "" %>><%=bannerSettings.getResourceString("customize.alarmtype.anyMajor")%></option>
            <option value="<%=bannerSettings.BANNER_ANY_CRITICAL_OR_MAJOR%>" <%= bannerSettings.getAlarmTypeSelected(bannerSettings.BANNER_ANY_CRITICAL_OR_MAJOR) ? "selected" : "" %>><%=bannerSettings.getResourceString("customize.alarmtype.anyCriticalOrMajor")%></option>
            <option value="<%=bannerSettings.BANNER_HARDWARE_CRITICAL%>" <%= bannerSettings.getAlarmTypeSelected(bannerSettings.BANNER_HARDWARE_CRITICAL) ? "selected" : "" %>><%=bannerSettings.getResourceString("customize.alarmtype.anyHardwareCritical")%></option>
            <option value="<%=bannerSettings.BANNER_HARDWARE_MAJOR%>" <%= bannerSettings.getAlarmTypeSelected(bannerSettings.BANNER_HARDWARE_MAJOR) ? "selected" : "" %>><%=bannerSettings.getResourceString("customize.alarmtype.anyHardwareMajor")%></option>
            <option value="<%=bannerSettings.BANNER_HARDWARE_CRITICAL_OR_MAJOR%>" <%= bannerSettings.getAlarmTypeSelected(bannerSettings.BANNER_HARDWARE_CRITICAL_OR_MAJOR) ? "selected" : "" %>><%=bannerSettings.getResourceString("customize.alarmtype.anyHardwareCriticalOrMajor")%></option>
            <option value="<%=bannerSettings.BANNER_EVENTS_CRITICAL%>" <%= bannerSettings.getAlarmTypeSelected(bannerSettings.BANNER_EVENTS_CRITICAL) ? "selected" : "" %>><%=bannerSettings.getResourceString("customize.alarmtype.anyEventCritical")%></option>
            <option value="<%=bannerSettings.BANNER_EVENTS_MAJOR%>" <%= bannerSettings.getAlarmTypeSelected(bannerSettings.BANNER_EVENTS_MAJOR) ? "selected" : "" %>><%=bannerSettings.getResourceString("customize.alarmtype.anyEventMajor")%></option>
            <option value="<%=bannerSettings.BANNER_EVENTS_CRITICAL_OR_MAJOR%>" <%= bannerSettings.getAlarmTypeSelected(bannerSettings.BANNER_EVENTS_CRITICAL_OR_MAJOR) ? "selected" : "" %>><%=bannerSettings.getResourceString("customize.alarmtype.anyEventCriticalOrMajor")%></option>
        </select>
      </td>
    </tr>
    <tr>
      <td>
        &nbsp;
      </td>
      <td nowrap>
        <strong>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<%=bannerSettings.getResourceString("customize.prompt.forTheList")%></strong>
      </td>
      <td>
        <select id="alarmList" size="1" name="alarmList" onChange="checkListSelection()" <%=bannerSettings.getShowAlarm() ? "enabled" : "disabled" %>>
                <%
                    // Display the selection box of all queries
                    bannerSettings.displayListOptionTags(bannerSettings.getAlarmList(),out);
                %>
        </select>
      </td>
    </tr>
    <tr>
      <td>
        &nbsp;
      </td>
      <td nowrap>
        <strong>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<%=bannerSettings.getResourceString("customize.prompt.labelIt")%></strong>
      </td>
      <td>
        <input type="text" name="alarmLabel" id="alarmLabel" size="30" maxlength="30" value="<%= MxHtmlUtil.encodeHtmlEntities(bannerSettings.getAlarmLabel()) %>" <%=bannerSettings.getShowAlarm() ? "enabled" : "disabled" %>>
      </td>
    </tr>
   </table>
   <br>
   <i><%=bannerSettings.getResourceString("customize.warning")%></i>
            <!-- BUTTONS -->
            <div style="margin-top:15px">
                <% buttons.dumpButtons(out); %>
            </div>

            <input type="hidden" value="list" name="firstStatusListType" id="firstStatusListType">
            <input type="hidden" value="list" name="secondStatusListType" id="secondStatusListType">
            <input type="hidden" value="list" name="alarmListType" id="alarmListType">

</form>
</div>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</body>

</html>
