<%@ page import="com.hp.mx.core.client.MxQueryClient" %>
<%@ page import="com.hp.mx.core.controllers.MxQueryController" %>
<%@ page import="com.hp.mx.portal.ui.*" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />

<%
    MxBean.jspInit(request, response);
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    MxQueryClient queryClient = loginBean.getQueryClient();

    String severity = request.getParameter("severity");
    String listType = request.getParameter("listType");
    String query = request.getParameter("query");
    int iSeverity = Integer.parseInt(severity);
    int iListType = Integer.parseInt(listType);
    long lQuery = Long.parseLong(query);

    String szViewType = "";
    String szPageName = "";
    if (iListType == MxQueryController.BANNER_HARDWARE_STATUS_RESULTS) {
        szViewType = "DeviceViews";
        szPageName = "viewContentsDevices";
    }
    else if (iListType == MxQueryController.BANNER_UNCLEAREDEV_STATUS_RESULTS) {
        szViewType = "EventViews";
        szPageName = "viewContentsEvents";
    }
%>

<html>

<head>
<title></title>
<script>
    var viewId       = <%=queryClient.createHotLinkQuery(iSeverity, iListType, lQuery)%>;
    var viewType     = "<%=szViewType%>";
    var pageName     = "<%=szPageName%>";

    var innerUrl = "/ui/jsp/XeHdr.jsp";

    var params  = "PageName=" + pageName;
    params     += "&parentmenu=ManageDevices";
    params     += "&viewid=" + viewId;
    params     += "&ViewType=" + viewType;
    params     += "&suppressCustomize=1";

    url = innerUrl + "?" + params;
    document.location.replace(url);
</script>
</head>

<body>
</body>
</html>
