<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="rbPortal" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<%
    MxBean.jspInit(request, response);
    rbPortal.init(loginBean, "MxPortal");

    String szCritical = MxStatusIcon.CRITICAL.getLabel(loginBean.getLocale());
    String szMajor = MxStatusIcon.MAJOR.getLabel(loginBean.getLocale());
    String szMinor = MxStatusIcon.MINOR.getLabel(loginBean.getLocale());
    String szWarning = MxStatusIcon.WARNING.getLabel(loginBean.getLocale());
    String szNormal = MxStatusIcon.NORMAL.getLabel(loginBean.getLocale());
    String szDisabled = MxStatusIcon.DISABLED.getLabel(loginBean.getLocale());
    String szUnknown = MxStatusIcon.UNKNOWN.getLabel(loginBean.getLocale());
    String szInformational = MxStatusIcon.INFORMATIONAL.getLabel(loginBean.getLocale());
%>

<html>
<head>
<title><%=rbPortal.get("legend.title")%></title>
<link type='text/css' rel='stylesheet' href='/mxportal/css/MxPortalEx.css'>
<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>
</head>
<body BGCOLOR="#CCCCCC">
    <TABLE BGCOLOR="#CCCCCC" WIDTH="100%" BORDER="0" CELLPADDING="2" CELLSPACING="1">
        <TR>
            <TD class="portal-legend-img"><img src="<%=MxStatusIcon.CRITICAL.getIconWithBorder()%>"></TD>
            <TD class="portal-legend-txt">&nbsp;<%=szCritical%>&nbsp;&nbsp;&nbsp;</TD>
            <TD class="portal-legend-img"><img src="<%=MxStatusIcon.NORMAL.getIconWithBorder()%>"></TD>
            <TD class="portal-legend-txt">&nbsp;<%=szNormal%></TD>
        </TR>
        <TR>
            <TD class="portal-legend-img"><img src="<%=MxStatusIcon.MAJOR.getIconWithBorder()%>"></TD>
            <TD class="portal-legend-txt">&nbsp;<%=szMajor%>&nbsp;&nbsp;&nbsp;</TD>
            <TD class="portal-legend-img"><img src="<%=MxStatusIcon.DISABLED.getIconWithBorder()%>"></TD>
            <TD class="portal-legend-txt">&nbsp;<%=szDisabled%></TD>
        </TR>
        <TR>
            <TD class="portal-legend-img"><img src="<%=MxStatusIcon.MINOR.getIconWithBorder()%>"></TD>
            <TD class="portal-legend-txt">&nbsp;<%=szMinor%>&nbsp;&nbsp;&nbsp;</TD>
            <TD class="portal-legend-img"><img src="<%=MxStatusIcon.UNKNOWN.getIconWithBorder()%>"></TD>
            <TD class="portal-legend-txt">&nbsp;<%=szUnknown%></TD>
        </TR>
        <TR>
            <TD class="portal-legend-img"><img src="<%=MxStatusIcon.WARNING.getIconWithBorder()%>"></TD>
            <TD class="portal-legend-txt">&nbsp;<%=szWarning%>&nbsp;&nbsp;&nbsp;</TD>
            <TD class="portal-legend-img"><img src="<%=MxStatusIcon.INFORMATIONAL.getIconWithBorder()%>"></TD>
            <TD class="portal-legend-txt">&nbsp;<%=szInformational%></TD>
        </TR>
    </TABLE>
</BODY>
</HTML>
