<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.security.SsoManager" %>
<%@ page import="com.hp.mx.core.client.*" %>
<%@ page import="com.hp.mx.core.nodemanager.*" %>
<%@ page import="java.text.MessageFormat" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="rbPortal" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="rbManagementURLLaunch" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<%
    MxBean.jspInit(request, response);
    rbPortal.init(loginBean, "MxPortal");
    rbManagementURLLaunch.init(loginBean, "MxManagementURLLaunch");
%>

<html>
<head>
<script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
<script src="/SessionReset.js" language="JavaScript" type="text/javascript"></script>

<script language="JavaScript" type="text/javascript">

function myOnLoad()
{
    MxPortalWorkspaceSetHelpTopic("useTools_systemInfo_smhp");
}

</script>

<link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
<title>
<%=rbManagementURLLaunch.getString("title")%>
</title>
<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>
<%
    boolean doneOK = false;
    String urlParameter = "";
    try
    {
        //
        // Were we passed a "URL" parameter?
        //
        urlParameter = request.getParameter("URL");
        if (urlParameter != null && !urlParameter.equals(""))
        {
            //
            // Yes.  Is it different than the local host?
            //

            // This could throw MalformedURLException;
            // let it since we can't use it if it's malformed.
            java.net.URL url = new java.net.URL(urlParameter);

            String host = url.getHost();
            int destPort = url.getPort();
            int rxPort = request.getServerPort();
            MxNodeClient nodeClient = loginBean.getNodeClient();
            MxNode node = nodeClient.getNodeByNodeOrHostName(host, false);

            boolean isLocalCMS = false;
            java.net.InetAddress inetAddress = null;
            try
            {
                inetAddress = java.net.InetAddress.getByName(host);
            }
            // Likely UnknownHostException, but catch all
            catch (Exception e)
            {
                inetAddress = null;
            }

            if (inetAddress != null)
            {
                if (inetAddress.equals(java.net.InetAddress.getLocalHost())
                && ((destPort==280) || (destPort==rxPort)) )
                {
                    isLocalCMS = true;
                }
            }
            else
            {
                //
                // Couldn't resolve host name in URL;
                // Still need to make sure it's not the local CMS.
                //

                String localHost = java.net.InetAddress.getLocalHost().getHostName();

                // If host names are equal, or one is the system name component
                // of the FQDN specified by the other, then consider hosts equal.
                if ( host.equalsIgnoreCase( localHost)
                  || localHost.toLowerCase().startsWith( host.toLowerCase() + "." )
                  || host.toLowerCase().startsWith( localHost.toLowerCase() + "." ) )
                {
                    // Now check the port
                    if ((destPort==280) || (destPort==rxPort))
                    {
                        isLocalCMS = true;
                    }
                }
            }

            if ( !isLocalCMS )
            {
                //
                // Redirect to the URL that was passed.
                //
                int port = url.getPort();
                // convert name to correct link name format
                java.net.URL newUrl = new java.net.URL( url.getProtocol(), node.getNameForLink(), port, url.getFile());
                urlParameter = newUrl.toString();

                // Convert to SSO if elm-based agent
                if ((port==2301)||(port==2381))
                    urlParameter = SsoManager.createCmsPageSsoUrl( urlParameter, node);

                out.println ("<script language=\"JavaScript\" type=\"text/javascript\">");
                out.println ("window.location.replace(\"" + urlParameter + "\");");
                out.println ("</script>");
                out.println ("</head>");
            }
            else
            {
                //
                // Can't redirect to the local host, since that would just recurse in the
                // frame and cause problems.
                //
                String message = MessageFormat.format(rbManagementURLLaunch.getString("error.IsLocalHost"),
                                                      new Object[] {request.getParameter("target"),
                                                                    rbPortal.getString("global.product")});
                out.println ("</head>");
                out.println ("<body onLoad=\"myOnLoad()\">");
                out.println ("<br><br><center><font color=\"#cc0000\">" + message + "</font></center>");
                out.println ("</body>");
            }
            doneOK = true;
        }
    }
    catch (Exception e)
    {
        //
        // An error occurred related to the given URL.
        //
        String message = MessageFormat.format(rbManagementURLLaunch.getString("error.InvalidURL"),
                                              new Object[] {rbPortal.getString("global.product"),
                                                            urlParameter});

        out.println ("</head>");
        out.println ("<body onLoad=\"myOnLoad()\">");
        out.println ("<br><br><center><font color=\"#cc0000\">");
        out.println ( message );
        // display the exception, it's all we can do for now.
        out.println ( e.toString() );
        out.println ("</font></center>");
        out.println ("</body>");
        doneOK = true;
    }

    if (!doneOK)
    {
        String message = MessageFormat.format(rbManagementURLLaunch.getString("error.NoManagementHomePage"),
                                              new Object[] {request.getParameter("target")});
        out.println ("</head>");
        out.println ("<body onLoad=\"myOnLoad()\">");
        out.println ("<br><br><center><font color=\"#cc0000\">" + message + "</font></center>");
        out.println ("</body>");
    }
%>
<% MxHtmlUtil.dumpBodyEnd(out); %>
</html>
