<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="javax.swing.tree.*" %>

<%@ taglib uri="/com/hp/mx/taglibs/" prefix="mxtag" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="portalBean" class="com.hp.mx.portal.ui.MxPortalBean" scope="session" />
<jsp:useBean id="rbPortal" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="actionList" class="com.hp.mx.portal.core.MxActionList" scope="session" />

<%
    MxBean.jspInit(request, response);
    rbPortal.init(loginBean, "MxPortal");

    int iPanel = 0;

    try {
        iPanel = Integer.parseInt(request.getParameter("panel"));
    } catch (Throwable e) { }

    String szClass = "body-flush-fit-inner-" + iPanel;
    if (iPanel == 0 && portalBean.isSomethingSetAside())
       szClass = "body-set-aside";

    if (iPanel == 1)
    {
        actionList.populate(loginBean);

        TreeModel model = actionList.getTreeModel();

        portalBean.getManageMenu().setId(MxPortalRender.ID_MANAGE_MENU);
        portalBean.getManageMenu().setTreeModel(model);
        portalBean.getManageMenu().setBrowserIsIe(MxHtmlUtil.isBrowserIe(request));
        portalBean.getManageMenu().setLeftMargin(7);
    }
%>

<HTML>
<HEAD>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxPortalRender.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

<!-- This is here just as a "keep-alive" on MxTagLibs -->
<mxtag:MxLink dumpHeadContent="true" />

<%
    if (iPanel == 1)
        portalBean.getManageMenu().dumpHeadContent(out);
%>

<TITLE></TITLE>

<script src="/SessionReset.js" language="JavaScript" type="text/javascript"></script>
<script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
<script src="<%=MxOptions.URL_BASE%>/js/MxSizingMoving.js" language="JavaScript" type="text/javascript"></script>

<script language="JavaScript" type="text/javascript">

/////////////////////////////////////////////////////////////
// Loading and sizing

var g_iPanel = <%=iPanel%>
var g_nWidth = 0;
var g_nCount = -2;

function myOnLoad()
{
    if (typeof search_onLoad == "function")
        search_onLoad();

    g_nWidth = MxBrowserGetBodyWidth(0, 0);
    setTimeout("myOnResize();MxBrowserLoadIframes()", 100);
}

function myOnResize()
{
    var h = Math.max(0, MxBrowserGetBodyHeight(0, 0));

    if (g_iPanel == 0)
        resizePanel_0(h);

    if (g_iPanel == 1)
        resizePanel_1(h);

    // Re-layout the menus
    if ((g_iPanel == 1) && MxBrowserIsGecko())
    {
        collapseMenusToLevel(MxMenuItem.TOP_LEVEL_IDX);
        menuItemRoot.repositionMenu();
        frameContentShow();
    }
}

function resizePanel_0(h)
{
    setTimeout("changeDelay(" + ++g_nCount + ")", 1000);

    if (!<%=portalBean.isSomethingSetAside()%>)
    {
        var hStatus = 0;
        var oStatus = document.getElementById("ID_STATUS");
        if (oStatus != null)
           hStatus = oStatus.offsetHeight + 5;

        var hSearch = 0;
        var oSearch = document.getElementById("ID_SEARCH");
        if (oSearch != null)
           hSearch = oSearch.offsetHeight + 5;

        var hTitle = 0;
        var oTitle = document.getElementById("TITLE_ID_ORGANIZER");
        if (oTitle != null)
           hTitle = oTitle.offsetHeight;

        var oFrame = document.getElementById("FRAME_ID_ORGANIZER");
        if (oFrame != null)
            oFrame.style.height = Math.max(0, h - 14 - hStatus - hSearch - hTitle);
    }
}

function resizePanel_1(h)
{
    var hBorders = 13;
    if (MxBrowserIsGecko())
        hBorders = 2;

    // resize the iframe to fill to the bottom (regardless of what is on top)
    var oFrame = document.getElementById("FRAME_" + szWorkspaceId);
    if (oFrame != null)
        oFrame.style.height = Math.max(0, h - oFrame.offsetTop - hBorders);

    if (MxBrowserIsGecko())
        window.scrollTo(0, 0);
}

/////////////////////////////////////////////////////////////
// Other

function changeDelay(n)
{
    if (n <= 0) return;
    if (n != g_nCount) return;

    var w = MxBrowserGetBodyWidth(0, 0);
    if (w != g_nWidth)
    {
        g_nWidth = w;
        MxPortalSplitterMoved(w);
    }
}

function MxToolLaunch(szId)
{
    setTimeout("MxPortalWorkspaceCreate('" + szId + "')", 100);
}

function p_MxPortalManageMenuRefresh()
{
    var oFrame = document.getElementById("<%=MxPortalRender.ID_MANAGE_MENU_FRAME%>");
    var location = oFrame.contentWindow.document.location;
    if (MxBrowserIsGecko())
        location.replace("<%=MxOptions.URL_BASE%>/home/MxMenuRefresh.jsp");
    else
    {
        if (typeof oFrame.contentWindow.disableAll == "function")
            oFrame.contentWindow.disableAll();

        location.replace("<%=MxOptions.URL_BASE%>/home/MxIeMenuFrame.jsp?refresh=true");
    }
}

</script>

</HEAD>

<body class="<%=szClass%>" onLoad='myOnLoad()' onResize='myOnResize()'>
<div class="body-proxy" id="ID_BODY_PROXY">

<% portalBean.dumpHtmlPanel(iPanel, loginBean, request, response, out); %>

<% MxHtmlUtil.dumpBodyEnd(out); %>
</div></body>
</HTML>
