<%@ page import="com.hp.mx.html.tree.MxTreeSelectionModel" %>
<%@ page import="com.hp.mx.portal.tree.MxCollectionTreeModel" %>
<%@ page import="com.hp.mx.portal.tree.MxCollectionTreeInstance" %>
<%@ page import="com.hp.mx.portal.ui.*" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="collectionTreeInstanceManager" class="com.hp.mx.portal.tree.MxCollectionTreeInstanceManager" scope="session" />

<%
    // check to see if the loginBean session has timed out
    if (loginBean.checkLogoutConditionForWebPage(pageContext) == true)
    {
        return;
    }
    MxBean.jspInit(request, response);

    // Get the tree instance by timestamp
    String timeStamp = request.getParameter("timeStamp");
    String szDisabled = request.getParameter("disableChildren");
    boolean bDisabled = false;
    if (szDisabled != null)
        bDisabled = true;
    MxCollectionTreeInstance collectionTreeInstance = collectionTreeInstanceManager.getTreeInstance(timeStamp);
    MxTreeSelectionModel selectionModel = collectionTreeInstance.getDefaultTreeSelectionModel();
    MxCollectionTreeModel treeModel = collectionTreeInstance.getTreeDataModel();
%>

<html>

<head>

<title></title>
<script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>

</head>

<body>

<%
    try
    {
        selectionModel.clearAllSelections(treeModel.getTreeRoot(), bDisabled);
    }
    catch (Throwable e)
    {
        out.println("    clear selections error");
    }
%>

</body>

</html>
