<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="swStatusResourceSettings" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<%
    MxBean.jspInit(request, response);

    // set up the resource file
    swStatusResourceSettings.init(loginBean, "SWStatusPanels");

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();

    buttons.addMxTag(new MxDefaultTag("", swStatusResourceSettings.getString("CloseButton"), "window.close()"));
%>

<html>
<head>
    <link type="text/css" rel="stylesheet" href="<%=MxOptions.URL_BASE%>/css/MxMessageBox.css">
    <link href="<%= MxOptions.URL_BASE %>/css/MxPortalEx.css" rel="stylesheet" type="text/css">
    <style type="text/css">
      .msgbox-title
      {
        cursor: default;
      }
    </style>

    <script>
    function linkToParent(id)
    {
        window.opener.MxPortalWorkspaceCreate(id);
        window.close();
    }
    </script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxButton.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</head>
<body style="font-style:normal;">
<h2 class="msgbox-title"><%= swStatusResourceSettings.getString("SWNoSwitchStatus.Title") %></h2>
<script>window.resizeTo(700, 700);</script>
<p>
<%= swStatusResourceSettings.getString("SWNoSwitchStatus.Paragraph1") %>
</p>

<div style="margin-top:15px">
    <% buttons.dumpButtons(out); %>
</div>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</body>
</html>
