<%@ page import="com.hp.mx.html.tree.MxTreeController" %>
<%@ page import="com.hp.mx.portal.tree.MxCollectionTreeInstance" %>
<%@ page import="com.hp.mx.portal.tree.MxCollectionTreeModel" %>
<%@ page import="com.hp.mx.portal.ui.*" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="collectionTreeInstanceManager" class="com.hp.mx.portal.tree.MxCollectionTreeInstanceManager" scope="session" />

<%
    // check to see if the loginBean session has timed out
    if (loginBean.checkLogoutConditionForWebPage(pageContext) == true)
    {
        return;
    }
    MxBean.jspInit(request, response);

    // Get the tree instance by timestamp
    String timeStamp = request.getParameter("timeStamp");
    MxCollectionTreeInstance collectionTreeInstance = collectionTreeInstanceManager.getTreeInstance(timeStamp);
    MxCollectionTreeModel collectionTreeData = collectionTreeInstance.getTreeDataModel();
    MxTreeController collectionTreeController = collectionTreeInstance.getTreeController();
%>

<html>

<head>

<title></title>
<script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>

</head>

<body>

<%
    try
    {
        // Run the update
        collectionTreeData.updateTreeView(out);

        // Set the empty span
        out.println("<script language=\"JAVASCRIPT\">");
        out.println("    parent.setEmptyString(" + (collectionTreeData.getNumChildren() > 0) + ");");
        out.println("</script>");

        // Dump the html and script for updating the tree
        collectionTreeData.getStatusUpdateList(out);
        collectionTreeData.getDeletedNodes(out);
        collectionTreeData.getNewNodes(out);
    }
    catch (Throwable e)
    {
        out.println("    // update error");
    }
%>

<script language="JAVASCRIPT">
    // Restart the clock and call the update function again
    setTimeout("parent.updateTreeView()", 33000);
</script>
</body>

</html>
