<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.html.table.*"%>
<%@ page import="com.hp.mx.portal.ui.*"%>

<jsp:useBean id="lmShowSelectionModel"  class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session"/>
<jsp:useBean id="lmShowTableView"       class="com.hp.mx.html.table.MxTableView2"                 scope="session"/>
<jsp:useBean id="lmShowTableController" class="com.hp.mx.html.table.MxTableController"            scope="session"/>
<jsp:useBean id="lmShowTableModel"      class="javax.swing.table.DefaultTableModel"               scope="session"/>
<jsp:useBean id="loginBean"  class="com.hp.mx.portal.ui.MxLoginBean"    scope="session" />
<jsp:useBean id="lmBean" class="com.hp.mx.portal.lm.lmBean" scope="session" />

<% MxBean.jspInit(request, response); %>
<jsp:setProperty name="lmBean" property="*" />

<%
    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    lmBean.initBean(out, loginBean);

    if (lmShowTableController.isFirstTime())
    {
        lmBean.getColumnNamesShow(lmShowTableModel);

        // set to only allow 1 row to be selected
        lmShowSelectionModel.setSelectionMode(MxTableSelectionModel.NO_SELECTION);

        lmShowTableView.setId("ID_LMMKSHOW_TABLE");
        lmShowTableView.setUrlHandler(request.getRequestURI());
        lmShowTableController.setTableModelWithSorting(lmShowTableModel);

        // get the sorting table and tell it to sort
        MxTableSortingModel sortingModel = lmShowTableController.getSortingModelOrNull();

        // column #1, sortUp == true
        sortingModel.sortTable(0, true);
        lmShowTableController.setSelectionModel(lmShowSelectionModel);
        lmShowTableController.setTableView(lmShowTableView);
    }

    // do we need to abort?
    if (lmShowTableController.checkUrlForControllerMessages(request, out))
    {
        //out.write("<script>alert('controller msg');</script>");
        //System.out.println("UPDATE_PERIOD_MS=" + lmTableController.UPDATE_PERIOD_MS);
        return;
    }

    lmShowTableModel.setRowCount(0); // clear data
    lmShowTableModel.fireTableDataChanged();

    lmBean.refreshKeysShow(lmShowTableModel);
    int numKeys = lmShowTableModel.getRowCount();

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();

    buttons.addMxTag(new MxDefaultTag("btnAdd", lmBean.getResString("LBL_ADD","Add Key"), "addKeyPage()"));
%>

   <html>
   <head>
      <title>
         LM Manage Keys - Show Key
      </title>

      <link href="<%=MxOptions.URL_BASE%>/css/MxPortalEx.css" rel="stylesheet" type="text/css">
      <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxBrowser.js'></script>
      <script language="javascript" type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxPortalApi.js' ></script>
      <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/lm/js/lm.js'></script>

      <script>
        <%@include file="js/lm.js"%>

        var REFRESH_TIMEOUT              = 10000; // 10 seconds
        var SELECTED_ROW_COLOR           = "66CCFF";
        var NETSCAPE_SCROLLBAR_WIDTH     = 36;
      </script>

      <script language='javascript' type='text/javascript'>

           // set the help context.
           MxPortalWorkspaceSetHelpTopic('useTools_license_manageKeys_addKeyIndividually');

           var numKeys = <%=numKeys%>;

           function addKeyPage()
           {
              var keyString = '<%=lmBean.getKeyString()%>' ;
              if ( null == keyString ) keyString = "";
              if (checkKey(keyString))
              {
                 document.location = '<%=lmBean.getResString("URL_UPDATE_CORE_PAGE","lm_mkUpdateCore.jsp")%>?reqType=<%=lmBean.REQUEST_TYPE_ADD%>';
              }
              return ;
           }

           function cancelShowPage()
           {
               document.location = '<%=lmBean.getResString("URL_ADD_KEY_PAGE","lm_mkAddKey.jsp")%>';
           }

            function loadPage()
            {
            }

            // resize the MxTable to be flush with the right browser edge
            function myResize()
            {
                var w = Math.max(0, MxBrowserGetBodyWidth(0, 0));
                MxTableSetWidth('ID_LMMKSHOW_TABLE', w);
            }

           function setTableHeight()
           {
              var iframe    = document.getElementById('DPI');
              var rowHeight     = iframe.contentWindow.getCellHeight();
              var titleHeight   = iframe.contentWindow.getTitleHeight();
              // add 1 to the "numKeys" because the horizontal scroll bar will take 1 row
              var tableHeight = (rowHeight * (numKeys + 1)) + titleHeight;
              MxTableSetHeight('ID_LMMKSHOW_TABLE', tableHeight);
           }

   </script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxButton.dumpHeadContent(out); %>
<% lmShowTableView.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

   </head>

   <body onLoad='setTableHeight(), loadPage(), myResize()' onResize='myResize()'>
    <A NAME='SHOW_PAGE_TOP'></A>
    <HR class='mx-hr'>
    <table border='0' cellpadding='0' cellspacing='0' style='width:100%'>
       <tr>
         <td align='left'>
            <span class='mx-subheader-nosep'>
               <b><%=lmBean.getResString("TXT_SHOW_KEY_COLON","Key details:")%></b>
            </span>
         </td>
      </tr>
   </table>
   <br>

<%
    if (numKeys > 0)
    {
       lmShowTableView.dumpWholeTable(out);
    }
    else
    {
%>
       <table>
          <tr>
            <td nowrap align='center'>
               <b><i><font color='red'>
                 <%=lmBean.getResString("TXT_NO_KEYS","There are no keys to display.")%>
               </font></i></b>
            </td>
          </tr>
       </table>
<%
    }
%>

    <div style="margin-top:15px">
        <% buttons.dumpButtons(out); %>
    </div>

   <iframe id='DPI' name='DPI' style='position:relative; visibility:hidden; width:100%; height:100'
             scrolling='no' marginwidth='0' frameborder='1' src='<%=MxOptions.URL_BASE%>/taskandjob/DPI.html'>
   </iframe>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</body>
</html>
