<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.core.subjects.*" %>
<%@ page import="com.hp.mx.portal.ui.MxBean" %>
<%@ page import="com.hp.mx.portal.ui.MxOptions" %>
<%@ page import="com.hp.mx.portal.ui.MxDateAndTime" %>
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="rbAuditLog" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="auditLogBean" class="com.hp.mx.portal.log.MxAuditLogBean" scope="session" />



<%
    MxBean.jspInit(request, response);

    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.AUDIT_LOG_VIEW_PRIVILEGE))
    { %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
 <% }

  rbAuditLog.init(loginBean, "AuditLog");
  //auditLogBean.setLoginLocale(loginBean.getLocale());
  //System.out.println("auditlogviewerStart loginLocale="+loginBean.getLocale().toString());

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();
    MxTag viewButtonTag = new MxDefaultTag("viewButton", rbAuditLog.getString("view.button"), "");
    viewButtonTag.setAttr(MxTag.TYPE, "submit");
    buttons.addMxTag(viewButtonTag);
  %>

<script language=javascript>
function enableLastLines(){
  document.auditForm.linecount.disabled=false
  document.auditForm.upperline.disabled=true
  document.auditForm.lowerline.disabled=true
}
function enableBetweenLines(){
  document.auditForm.linecount.disabled=true
  document.auditForm.upperline.disabled=false
  document.auditForm.lowerline.disabled=false
}

</script>

<html>

<head>
<title>Required Field</title>
<link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>

<script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
<script src="<%=MxOptions.URL_BASE%>/js/globals.js" language="JavaScript" type="text/javascript"></script>
<script src="/SessionReset.js" language="JavaScript" type="text/javascript"></script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% buttons.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</head>
<script language="JavaScript" type="text/javascript">
MxPortalWorkspaceSetHelpTopic("admin_audit_logView");
</script>


<BODY>

<%
  int type = auditLogBean.getDisplayType();
  boolean latestChecked = true;
  boolean betweenChecked = false;
  if( type == 1 ){
    betweenChecked = true;
    latestChecked = false;
  }

  if( request.getParameter("inputError") != null ){

    if( request.getParameter("inputError").equals("nan"))
    {
      out.write("<FONT COLOR=RED>" + rbAuditLog.getString("not.a.number") + "</FONT>");
    }
    else if( request.getParameter("inputError").equals("outOfRange"))
    {
      out.write("<FONT COLOR=RED>" + rbAuditLog.getString("outOfRange") + "</FONT>");
    }
    else if( request.getParameter("inputError").equals("lessThan"))
    {
      out.write("<FONT COLOR=RED>" + rbAuditLog.getString("entriesReversed") +"</FONT>");
    }
   else if( request.getParameter("inputError").equals("outOfBound")) //4/13/2005 JCW fix bug 230357
    {
      out.write("<FONT COLOR=RED>" + rbAuditLog.getString("outOfBound") +"</FONT>");
    }

  }


%>

<form method="post" autocomplete="off" style="border:0px;padding:0px;margin:0px" action="AuditLogViewerServer.jsp" name="auditForm">
  <div style="margin-left:20px;">
    <table id="auditViewControl" border="0" cellpadding="1" width="100%" >
      <tr><td><%=rbAuditLog.getString("view")%></td></tr>
      <tr>
        <td valign="top" align="left" width="100%" >
          <input type="radio" id="viewChoice" name="choice" value="latest"
<%
if(latestChecked){
  out.write("checked");
}
%> onClick="enableLastLines()" >
            <%=rbAuditLog.getString("most.recent")%> <input type="text" name="linecount" size="5"
<%

if(latestChecked){
  out.write("value=\"" + auditLogBean.getLastEntries() + "\"");
}else{
  out.write("disabled=true");
}

%> > <%=rbAuditLog.getString("entries")%>
        </td>
        <td>
        </td>
      </tr>
      <tr>
        <td>
          <input type="radio" id="viewChoice" name="choice" value="betweenlines"
<%
if(betweenChecked){
  out.write("checked");
}
%> onClick="enableBetweenLines()"  >
            <%=rbAuditLog.getString("from.entry")%> <input type="text" name="lowerline" size="5"
<%
if(betweenChecked){
  out.write("value=\"" + auditLogBean.getLowerEntry() + "\"");
}else{
  out.write("disabled=true");
}
%>
>
            <%=rbAuditLog.getString("to.entry")%> <input type="text" name="upperline" size="5"
<%
if(betweenChecked){
  out.write("value=\"" + auditLogBean.getUpperEntry() + "\"");
}else{
  out.write("disabled=true");
}

%>

>
        </td>
      </tr>
    </table>
  </div>
  <div style="margin-top:15px">
    <% buttons.dumpButtons(out); %>
  </div>

</form>

<hr class='mx-hr'>
<table border="0" cellpadding=0 width=100% >
  <tr>
    <td align="left">
      <font class="mx-subheader-nosep">
<%
        if(betweenChecked){
          out.write(rbAuditLog.getString("entries.capital") + " " + auditLogBean.getLowerEntry() + " " + rbAuditLog.getString("to.capital") + " " + auditLogBean.getUpperEntry() );
        }else{
          out.write(rbAuditLog.getString("last.capital") + " " + auditLogBean.getLastEntries() + " " + rbAuditLog.getString("entries.capital") );
        }
%>
      </font>
    </td>
    <td align="right">
<%
   MxDateAndTime dateAndTime = new MxDateAndTime(loginBean.getLocale(), loginBean.getTimeZone());
   String currentTime = dateAndTime.getCurrentDateTimeFormatString(dateAndTime.DATE_TIME_FULL_FORMAT);
   out.write(currentTime);
%>
    </td>
  </tr>
</table>
<BR>


<div style="BACKGROUND:CCCCCC;">
<PRE>
<%
  auditLogBean.printEntries(out);
%>
</PRE>
</div>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</BODY>

</html>
