<%@ page import="com.hp.mx.portal.ui.MxOptions"%>
<%@ page import="com.hp.mx.portal.ui.MxBean" %>
<%@ page import="com.hp.mx.core.collectionmanager.MxCollectionConstants_t" %>
<%@ page import="com.hp.mx.portal.monitor.MxCustomizeCollectionConstants_t" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="rbMonitor" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<%
    MxBean.jspInit(request, response);

    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    rbMonitor.init(loginBean, "MxMonitor");
%>

<!--script type="text/javascript" language="javascript"-->

var noEdit=<%=MxCollectionConstants_t.COLLECTION_EDIT_FLAG_CANNOT_EDIT%>;
var noDelete=<%=MxCollectionConstants_t.COLLECTION_EDIT_FLAG_CANNOT_DELETE%>;
//======================================================================
//
// FOLDERS FUNCTIONS
//
//======================================================================
var theSelectedMenuItem = null;
var theSelectedMenuItemId = null;
var theSelectedMenuItemName = null;
var theSelectedMenuItemType = null;
var theSelectedMenuItemEditFlag =-1;
var theParentId =null;

var theSelectedMenuItemFgColor = "#000000";

//======================================================================
// function to print Alerts
//======================================================================
function printAlert(myStr, myVal) {
    if(myVal != null) {
        alert(myStr+ " = "+ myVal);
    }
    else {
        alert(myStr + " is null");
    }
}

//======================================================================
// Function used to clear the two options [members
// attributes [ radio buttons] that is shown by the new button.
//======================================================================
function removeSelectionSpace() {

    var oTableBody = document.getElementById("tabSelectionBody");
    var c = oTableBody.hasChildNodes();
    var aNodeList = oTableBody.childNodes;
    var len = aNodeList.length;

    for (var i =len-1; i >=0 ; i--)  {
        oTableBody.removeChild(aNodeList[i]);
    }

    var d = oTableBody.hasChildNodes();
    var oSeldivBody = document.getElementById("selectionHeadingDiv");
    oSeldivBody.innerHTML= "";
    document.getElementById('id').style.display = 'none';
}

//======================================================================
// Function to replace the sub-panel with blank.html.  It is
// called from the onClick handler of the Cancel button.
//======================================================================
function clearSubwindow()
{
    document.getElementById("operationSpace").contentWindow.document.location.replace("<%=MxOptions.URL_BASE%>/home/MxBlank.html");
    document.getElementById("operationSpace").style.height = 1;
    removeSelectionSpace();
}
// ======================================================================
// Selecting the element in the tree table.
//======================================================================
function nodeSelected(srcId)
{
    theSelectedMenuItem         = null;
    theSelectedMenuItemId       = null;
    theSelectedMenuItemType     = null;
    theSelectedMenuItemName     = null;
    theSelectedMenuItemEditFlag = -1;
    theParentId                 = null;

    clearSubwindow();

    if (null != srcId)
    {
        //printAlert("srcId == ", srcId);

        theSelectedMenuItem = document.getElementById(srcId);

        if (theSelectedMenuItem == null)
        {
            return;
        }

        var oAttrColl = theSelectedMenuItem.attributes;

        theSelectedMenuItemId       = oAttrColl.getNamedItem("collID").value;
        theSelectedMenuItemType     = oAttrColl.getNamedItem("collType").value;
        theSelectedMenuItemName     = oAttrColl.getNamedItem("collName").value;
        theSelectedMenuItemEditFlag = oAttrColl.getNamedItem("collEditFlag").value;
        theParentId                 = oAttrColl.getNamedItem("collParentID").value;

        //printAlert("Collection Id", theSelectedMenuItemId);
        //printAlert("Collection Parent Id", theParentId);
        //printAlert("Collection Name", theSelectedMenuItemName);
        //printAlert("Collection Type", theSelectedMenuItemType);
        //printAlert("Collection Edit Flag", theSelectedMenuItemEditFlag);
    }
    else
    {
        return;
    }

    if (null != theSelectedMenuItemType)
    {
        if (theSelectedMenuItemType == "COLLECTION")
        {
            configCustomizeBtnsForCollections();
        }
        else if (theSelectedMenuItemType == "QUERY" || theSelectedMenuItemType == "clusterlist" ||
                 theSelectedMenuItemType == "syslist" || theSelectedMenuItemType == "evlist")
        {
            configCustomizeBtnsForLists();
        }
        else if (theSelectedMenuItemType == "NODE")
        {
            configCustomizeBtnsForNodes();
        }
    }
}

//======================================================================
// Enable and disable buttons when no list or collection is selected
//======================================================================
function configDefCustomizeBtns()
{
    if (branchtype == "sysbranch" || branchtype == "evbranch")
    {
        ourButtonManager.enableButtonById('newbtn');
        ourButtonManager.disableButtonById('editbtn');
        ourButtonManager.disableButtonById('setpropertiesbtn');
        ourButtonManager.disableButtonById('deletebtn');;
    }

}

//======================================================================
// Enable and disable buttons for the selected list item
//======================================================================
function configCustomizeBtnsForLists()
{
    ourButtonManager.enableButtonById('newbtn');
    ourButtonManager.enableButtonById('editbtn');
    ourButtonManager.enableButtonById('setpropertiesbtn');


    if( (theSelectedMenuItemEditFlag & noDelete) == noDelete) {
        ourButtonManager.disableButtonById('deletebtn');
    } else {
        ourButtonManager.enableButtonById('deletebtn');
    }

}

//======================================================================
// Enable and disable buttons for the selected folder item
//======================================================================
function configCustomizeBtnsForCollections()
{
    ourButtonManager.enableButtonById('newbtn');
    ourButtonManager.enableButtonById('editbtn');
    ourButtonManager.enableButtonById('setpropertiesbtn');
    if(theSelectedMenuItemName == "Private" || ( (theSelectedMenuItemEditFlag & noDelete) == noDelete) ) {
        ourButtonManager.disableButtonById('deletebtn');
    } else {
        ourButtonManager.enableButtonById('deletebtn');
    }
}

//======================================================================
//
//======================================================================
function configCustomizeBtnsForNodes() {
    ourButtonManager.enableButtonById('newbtn');
    ourButtonManager.disableButtonById('editbtn');
    ourButtonManager.disableButtonById('deletebtn');
    ourButtonManager.enableButtonById('setpropertiesbtn');

}

function disableAllBtns() {
    ourButtonManager.disableButtonById('newbtn');
    ourButtonManager.disableButtonById('editbtn');
    ourButtonManager.disableButtonById('deletebtn');
    ourButtonManager.disableButtonById('setpropertiesbtn');

}
//
// works only in Netscape..
//
function openCentered (url, name, width, height) {
    if (document.all) {
    var x = window.screeLeft;
    var y = window.screenTop;
    var w = window.document.body.offsetWidth;
    var h = window.document.body.offsetHeight;
    }
    else {
    var x = window.screenX;
    var y = window.screenY;
    var w = window.outerWidth;
    var h = window.outerHeight;
    }
    var cx = (MxPortalGetWorkspaceFrame().offsetWidth - width) / 2;
    var cy = (MxPortalGetWorkspaceFrame().offsetHeight - height) / 2;

    return open (url, null, 'left=' + cx + ',top=' + cy + ',width=' + width + ',height=' + height);
}
