<%@ page import="com.hp.mx.portal.ui.MxOptions"%>
<%@ page import="com.hp.mx.portal.ui.MxBean" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="rbMonitor" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<%
    MxBean.jspInit(request, response);

    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    rbMonitor.init(loginBean, "MxMonitor");
%>

<!--script type="text/javascript" language="javascript"-->

//======================================================================
//
// FOLDERS FUNCTIONS
//
//======================================================================
//======================================================================

var theSelectedMenuItem = null;
var theSelectedMenuItemFgColor = "#000000";

//======================================================================
// function to be called for expanding or collapsing menus in the
// customization lists page.
//======================================================================
function expandAllMenus(bShow)
{
    if (branchtype == null)
        return;
    if (branchtype == "sysbranch")
        szRootId = "ID_CUST_SYSLIST";
    else if (branchtype == "evbranch")
        szRootId = "ID_CUST_EVLIST";
    else
        szRootId = "ID_CUST_FAVLIST";

    var URL;
    var szAllFolders;

    if (bShow)
    {
        MxMenuExpandAll(szRootId);
        if (theSelectedMenuItem != null)
        {
            savedSelectionId = theSelectedMenuItem.getAttribute("id");
            setTimeout('setSelectedIdInView()', 150);
        }
        szAllFolders = MxMenuGetState(szRootId, "mxmenu-show");
        URL = "<%=MxOptions.URL_BASE%>/monitor/DoToggleExpansionForCustomize.jsp?htmltagid=all" + "&bshow=true";
    }
    else
    {
        MxMenuCollapseAll(szRootId);
        if (theSelectedMenuItem != null)
        {
            unSelectMenu();
            theSelectedMenuItem = null;
            configDefCustomizeBtns();
        }

        szAllFolders = MxMenuGetState(szRootId, "mxmenu-hide");
        URL = "<%=MxOptions.URL_BASE%>/monitor/DoToggleExpansionForCustomize.jsp?htmltagid="+ szAllFolders + "&bshow=false";
    }

    document.getElementById("operationSpace").contentWindow.document.location.replace(URL);
}

//======================================================================
// Function to be called from the onClick event. Menu item will be selected,
// and expanded/collapsed.
//======================================================================
function menuSelectToggle(event, szFn, szIdRoot, szId, nShow)
{
    var srcEl = getEventSrc(event);

    // do the toggle
    MxMenuToggle(szFn, szIdRoot, szId, nShow)

    // do the selection
    menuSelected(srcEl);

    var oDiv = document.getElementById('MXMENU_' + szId);

    if (oDiv != null)
    {
        if (oDiv.className == "mxmenu-show")
            URL = "<%=MxOptions.URL_BASE%>/monitor/DoToggleExpansionForCustomize.jsp?htmltagid=" + szId + "&bshow=true";
        else
            URL = "<%=MxOptions.URL_BASE%>/monitor/DoToggleExpansionForCustomize.jsp?htmltagid=" + szId + "&bshow=false";

        document.getElementById("operationSpace").contentWindow.document.location.replace(URL);
    }
}

//======================================================================
// The onClick handler
//======================================================================
function menuSelect(event)
{
    var selectedEl = getEventSrc(event);
    menuSelected(selectedEl);
}

//======================================================================
// Unselect the selected menu item
//======================================================================
function unSelectMenu()
{
    var selId=theSelectedMenuItem.getAttribute("id");
    var oSelectedItem = document.getElementById(selId);
    oSelectedItem.style.background="#FFFFFF"
    oSelectedItem.style.color = theSelectedMenuItemFgColor;

}

//======================================================================
// Selecting the element
//======================================================================
function menuSelected(srcEl)
{
    if (null != theSelectedMenuItem)
    {
       // change the background color
        theSelectedMenuItem.style.background="#FFFFFF"
        theSelectedMenuItem.style.color = theSelectedMenuItemFgColor;
    }

    // Clear out the lower page
    document.getElementById("operationSpace").contentWindow.document.location.replace(oBlankHtml);
    document.getElementById("operationSpace").style.height = 1;

    if (null != srcEl)
    {
        if ( srcEl.getAttribute("id").indexOf("IMXMENU") != -1)
        {
            theSelectedMenuItem = null;
            configDefCustomizeBtns();
            return;
        }
        srcEl.style.background = "#66CCFF";
        theSelectedMenuItemFgColor = srcEl.style.color;
        theSelectedMenuItem = srcEl;
    }

    var menuItemType;
    if ( null !=theSelectedMenuItem)
    {
        menuItemType = theSelectedMenuItem.getAttribute("name");
    }
    else
        menuItemType = null;

    if (menuItemType == null)
    {
        configDefCustomizeBtns();
    }
    else if (menuItemType == "favfolder" || menuItemType == "listfolder")
    {
        configCustomizeBtnsForFolders(menuItemType);
    }
    else if (menuItemType == "syslist" ||
            menuItemType == "evlist" ||
            menuItemType == "clusterlist" ||
            menuItemType == "favlist")
    {
        configCustomizeBtnsForLists(menuItemType);
    }
    else
        configDefCustomizeBtns();
}

//======================================================================
// Enable and disable buttons when no list or folder is selected
//======================================================================
function configDefCustomizeBtns()
{
    if (branchtype == "sysbranch" || branchtype == "evbranch")
    {
        ourButtonManager.enableButtonById('newlistbtn');
        ourButtonManager.disableButtonById('editlistbtn');
        ourButtonManager.disableButtonById('addtofavbtn');

        // need to be deleted after this function works
        ourButtonManager.enableButtonById('newfolderbtn');

        ourButtonManager.disableButtonById('deletebtn');
    }
    else if (branchtype == "favbranch")
    {
        ourButtonManager.enableButtonById('newfolderbtn');
        ourButtonManager.disableButtonById('deletebtn');

        // need to be modified after M5
        ourButtonManager.disableButtonById('showstatusbtn');
    }
}

//======================================================================
// Enable and disable buttons for the selected list item
//======================================================================
function configCustomizeBtnsForLists(menuitemtype)
{
    if (menuitemtype != "favlist")
    {
        ourButtonManager.enableButtonById('newlistbtn');
        ourButtonManager.enableButtonById('editlistbtn');
        ourButtonManager.enableButtonById('addtofavbtn');

        // need to be deleted after this function works
        ourButtonManager.enableButtonById('newfolderbtn');

        ourButtonManager.enableButtonById('deletebtn');
    }
    else
    {
        ourButtonManager.enableButtonById('newfolderbtn');
        ourButtonManager.enableButtonById('deletebtn');

        // can't show status for event lists
        if (theSelectedMenuItem.className == "fav-evhidestatus")
        {
            ourButtonManager.disableButtonById('showstatusbtn');
        }
        else
        {
            ourButtonManager.enableButtonById('showstatusbtn');
            if (theSelectedMenuItem.className == "fav-showstatus")
                ourButtonManager.setButtonLabelById('showstatusbtn', '<%=rbMonitor.getString("customize.showstatusbtn.hide")%>' );
            else
                ourButtonManager.setButtonLabelById('showstatusbtn', '<%=rbMonitor.getString("customize.showstatusbtn.display")%>');
        }
    }
}

//======================================================================
// Enable and disable buttons for the selected folder item
//======================================================================
function configCustomizeBtnsForFolders(menuitemtype)
{

    if (menuitemtype != "favfolder")
    {
        ourButtonManager.enableButtonById('newlistbtn');
        ourButtonManager.disableButtonById('editlistbtn');
        ourButtonManager.disableButtonById('addtofavbtn');

        // need to be deleted after this function works
        ourButtonManager.enableButtonById('newfolderbtn');

        ourButtonManager.enableButtonById('deletebtn');
    }
    else
    {
        ourButtonManager.enableButtonById('newlistbtn');
        ourButtonManager.enableButtonById('deletebtn');

        // need to be modified after M5
        ourButtonManager.disableButtonById('showstatusbtn');
    }
}
