<%--
//+
//
// Copyright 2002 Compaq Information Technologies Group, L.P.
//
// Author: Virginia Payne
//
// Description: ReportsResult.jsp (Reports Result Page)
//
// $ProjectName: j:/maple/coreWap.pj $
// $Header: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/reporting/ReportsResult.jsp,v 1.51 2005/05/20 05:00:36 farley Exp $
//-
--%>

<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*"%>
<%@ page import="com.hp.mx.portal.help.*"%>
<%@ page import="com.hp.mx.portal.session.*"%>
<%@ page import="com.hp.mx.utilities.*"%>
<%@ page import="com.hp.mx.startup.*"%>
<%@ page import="com.hp.mx.database.*"%>
<%@ page import="com.hp.mx.security.*"%>
<%@ page import="com.hp.mx.portal.reporting.*"%>
<%@ page import="com.hp.mx.core.tools.reporting.*"%>
<%@ page import="com.hp.mx.core.subjects.*"%>
<%@ page import="com.hp.mx.core.subjects.usermanager.*"%>
<%@ page import="com.hp.mx.core.client.MxQueryClient"%>
<%@ page import="com.hp.mx.core.client.MxCollectionClient"%>
<%@ page import="com.hp.mx.core.querymanager.Query"%>
<%@ page import="javax.servlet.jsp.*"%>
<%@ page import="java.sql.*"%>
<%@ page import="java.io.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.net.URLEncoder"%>
<%@ page import="com.hp.mx.core.objectmodel.MxObjectID"%>
<%@ page import="com.hp.mx.core.objectmodel.MxGUID"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxSystemListCreator"%>
<%@ page import=" com.hp.mx.core.tools.reporting.format.*"%>
<%@ page import=" com.hp.mx.core.tools.reporting.ErrorObject"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxCollectionCreator"%>
<%@ page import="com.hp.mx.core.client.MxReportClient"%>
<%@ page import="com.hp.mx.core.client.MxGroupClient"%>
<%@ page import=" com.hp.mx.core.nodemanager.MxNode"%>
<%@ page import=" com.hp.mx.core.reportmanager.*"%>
<%@ page import=" com.hp.mx.core.reportmanager.MxReport"%>
<%@ page import=" com.hp.mx.core.reportmanager.MxDuplicateReportException"%>
<%@ page import=" com.hp.mx.core.reportmanager.MxInvalidReportException"%>
<%@ page import=" com.hp.mx.core.reportmanager.MxInvalidReportOperationException"%>
<%@ page import=" com.hp.mx.core.reportmanager.MxReportPersistenceException"%>
<%@ page import=" com.hp.mx.core.reportmanager.MxUndefinedReportException"%>
<%@ page import=" com.hp.mx.core.reportmanager.MxInvalidReportNameException"%>
<%@ page import=" com.hp.mx.core.reportmanager.MxUndefinedItemException"%>
<%@ page import=" com.hp.mx.core.querymanager.UndefinedQueryException"%>
<%@ page import=" com.hp.mx.utilities.DebugOutput"%>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="ReportsManage" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="ReportsDisplayNames" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<%
    DebugSubsystem reportDebug = DebugOutput.getDebugSubsystem("Reports");
    // REQUIRED: This line is required by Tomcat for i18n support.
    MxBean.jspInit(request, response);

   // REQUIRED: This aborts the page if the session is invalid.
   if (loginBean.checkLogoutConditionForWebPage(pageContext))
       return;

   // setup resources.
   ReportsManage.init(loginBean, "ReportsManage");
   ReportsDisplayNames.init(loginBean, "ReportsDefaultNames");

   String queryIdStr = request.getParameter("qID");
   // if there is no query ID, set it to 9999
   if ((queryIdStr == null) ||  (queryIdStr.equals("")))
      queryIdStr = "9999";
   int queryId = Integer.parseInt(queryIdStr);

   String templateName = request.getParameter("rName");
   // Get the display name in case the name is a default report name (therefore could be localized)
   String displayName = null;
   if ((templateName == null) || (templateName.equals("")))
   {
      templateName = ReportsManage.getString("UNNAMED_REPORT_LABEL");
      displayName = templateName;
   }
   else
   {
       displayName = ReportsDisplayNames.getDisplayName(templateName);
   }
%>
<html>
<HEAD>
<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxPortalRender.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>
    <TITLE><%=ReportsManage.getString("REPORTS_RESULT_TITLE")%></TITLE>
    <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxPortalApi.js'></script>
    <STYLE TYPE="text/css">
<!--
TR { font-size:8pt; vertical-align:text-top}
-->
    </STYLE>
    <SCRIPT language="javascript">
    function myOnload()
    {
         //alert("page loaded");
         document.getElementById("links").style.visibility="visible";
    }
    </SCRIPT>
</HEAD>

<body class="body-flush-fit-scrolling-nobackground" onload="myOnload()">
<%MxPortalRender.dumpTitleHtml(displayName, out);%>

<%
    String progressBar = com.hp.mx.portal.ui.MxOptions.MXHTML_BASE + File.separator + "images" + File.separator + "progress_bar_large.gif";
%>

    <DIV id='divMsg' align=center>
        <br>
        <strong>
        <%=ReportsManage.getString("MSG_WAIT_FOR_GENERATING_REPORT")%>
        </strong>
    </DIV>
    <%out.flush();%>
    <DIV id='divProgressBar' align=center>
        <br>
        <img src="<%=progressBar %>" align='center'>
    </DIV>
    <%out.flush();%>
<table style="margin:10">

<tr>
<td>


<SCRIPT language="JavaScript">
    MxPortalWorkspaceSetHelpTopic("feature_report_run");
</SCRIPT>

<%
   String queryGUID = request.getParameter("qG");
   String queryType = request.getParameter("qT");
   String templateId = request.getParameter("rId");
   String itemsList = request.getParameter("itms");
   String itemListType = request.getParameter("itmT");
   String viewOption = request.getParameter("vO");
   String strReportFormat = request.getParameter("rF");
   int reportFormat = Integer.parseInt(strReportFormat);
   String sortOrders = request.getParameter("s");
   String sortColumns = request.getParameter("sC");
   if ((templateId == null) || (templateId.equals("")))
      templateId = "-1";
   // out.print("<DIV  id='links' style='visibility:visible'>");     // DIV section for Export and SQL query links
   // Encode the string before passing it to the URL
   String encodedTemplateName = URLEncoder.encode(templateName, "UTF-8");
%>


<%
   try
   {
   MxUser loginUser = loginBean.getMxUser();

   MxReport rObj = new MxReport();
   rObj.setReportId(Integer.parseInt(templateId));
   rObj.setName(templateName);
   rObj.setReportName(templateName);
   rObj.setQueryId(queryId);
   // rObj.setQueryType(reportConstant.QUERYTYPE_MXQUERY_GUID);

   rObj.setQueryType(Integer.parseInt(queryType));
       rObj.setQueryName(queryGUID);

   rObj.setViewOption(Integer.parseInt(viewOption));
   rObj.setItemListType(Integer.parseInt(itemListType));
//   rObj.setItemListType(reportConstant.TYPE_MXGUID_STR);
   rObj.setItemList(itemsList);

   // Generate the report tables
   reportGenerator reportG = null;

   DebugOutput.log(reportDebug, 15, "ReportResult: templateId = "+templateId+"  Name= "+templateName+ "formatType=" + reportFormat);
   DebugOutput.log(reportDebug, 15, "ReportResult: before generate report table");

   reportG = new reportGenerator(rObj, reportFormat, loginBean.getMxUser(), loginBean.getLocale(), loginBean.getTimeZone());

   if (sortColumns ==null || sortColumns.equals(""))
       reportG.setOrderList(null);
   else
       reportG.setOrderList(sortColumns);
   if (sortOrders ==null || sortOrders.equals(""))
       reportG.setAscList(null);
   else
       reportG.setAscList(sortOrders);

   reportG.setOutputWriter(out);
   reportG.setJspMessageWriter(out);

   DebugOutput.log(reportDebug, 15, "ReportResult: after generate report table");

   boolean isDcReport = (rObj.getItemList().length() == 0) ? true : false;
   DebugOutput.log(reportDebug, 15, "ReportResult: before runReport");
   // Create the report
      reportG.processReport();
      List list = reportG.getFailureCatList();
      if (list !=null && list.size() >0)
      {
          StringBuffer buf = new StringBuffer("");
          Iterator itr = list.iterator();
          while (itr.hasNext()) {
              ErrorObject errObj = (ErrorObject) itr.next();
              buf.append(errObj.getCatDispName());
              buf.append(": ");
              buf.append(errObj.getLocalizedMessage());
          }
          out.print("<script>alert('"+    buf.toString()+ "');</script>");
      }
   }
   catch (MxInvalidReportNameException e) {
      DebugOutput.log(reportDebug, 15, "reportGenerator.processReport error: " + e.getMessage());
      out.print("<script>alert('"+    e.getLocalizedMessage()+ "');</script>");
   }
   catch (Exception e)
   {
      out.print("<script>alert('"+   e.getLocalizedMessage()+ "');</script>");
      DebugOutput.log(reportDebug, 15, "reportGenerator.processReport error: " + e.getMessage());
   }
   // Hide the SQL and CSV Report links.
   // out.println("<script> document.all.links.style.visibility = 'hidden' </script>");
   DebugOutput.log(reportDebug, 15, "ReportResult: Done.");
%>

</td></tr>
</table>
    <SCRIPT>
        document.getElementById("divMsg").innerHTML='';
        document.getElementById("divMsg").visible = false;
        document.getElementById("divProgressBar").innerHTML='';
        document.getElementById("divProgressBar").visible = false;
    </SCRIPT>
<% out.flush(); %>
</body>
</html>

