<%--
//$Source: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/reporting/selectTargets.jsp,v $
//$Revision: 1.25 $
//$Date: 2005/05/05 19:22:44 $
--%>

<%--
// Displays the first page in the sequence for snapshot comparison.
// This page will list all selected systems. If there are more than maxForCompare systems
// an error message is shown. The help page used for this does not seem like the best.
--%>
<%@ page import="com.hp.mx.portal.ui.MxLoginBean" %>
<%@ page import="com.hp.mx.portal.ui.MxOptions" %>
<%@ page import="com.hp.mx.portal.ui.MxBean" %>
<%@ page import="com.hp.mx.core.objectmodel.MxObjectID" %>
<%@ page import="com.hp.mx.core.objectmodel.MxGUID" %>
<%@ page import="com.hp.mx.core.subjects.usermanager.MxUser" %>
<%@ page import="com.hp.mx.core.subjects.MxSubjectPrivilege" %>
<%@ page import="java.net.URLEncoder"%>
<%@ page import="com.hp.mx.html.core.MxButton"%>
<%@ page import="com.hp.mx.html.core.MxHtmlUtil"%>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="snapshotComparisonRes" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="snapshotComparisonBean" class="com.hp.mx.portal.reporting.SnapshotComparisonBean" scope="session"/>
<jsp:useBean id="taskWizardBean" class="com.hp.mx.portal.taskandjob.MxTaskWizard" scope="session"/>

<%  // Set Necessary HTTP header attributes (for localization and caching)
    MxBean.jspInit(request, response);

    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.REPORT_VIEW_SECURED_DATA_PRIVILEGE))
    {
%>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>"/>
<%  }

    snapshotComparisonRes.init(loginBean, "SnapshotComparison");

    String timeStamp = taskWizardBean.getNewTimeStamp();
    if ( ! snapshotComparisonBean.getIsRunning() )
     {
     System.out.println(" bean is not running");
     snapshotComparisonBean.initialize(loginBean);
     snapshotComparisonBean.initBean(out,loginBean);
     snapshotComparisonBean.setIsRunning(true);
     int sessionID = (int) Math.abs(loginBean.getXeUserSession().getSessionId());
     snapshotComparisonBean.setSessionID(sessionID);
     }
%>

<html>
    <head>
        <title></title>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
        <script language='javascript' type='text/javascript' src='/SessionReset.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/targetSelection.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxPortalApi.js'></script>
        <script language='javascript' type='text/javascript'>
            function selectSnapshots()
            {
                var url = "<%=MxOptions.URL_BASE%>/reporting/selectSnapshots.jsp?timeStamp=<%=timeStamp%>";
                var iframe = document.getElementById('targetSelection');
                iframe.contentWindow.document.location.replace(url);
            }
            function selectionFull(bSelected)
            {
              // alwasys send false flag, 6/6/2003
              //alert("ReportsWizard SelectionFull bSelect="+bSelected);
              var stepObj = document.getElementById("wizStep");
              if ( stepObj != null )
              {
                  if (bSelected)
                  {
                       stepObj.innerHTML = "<%=snapshotComparisonRes.getString("DIFF_REPORT_STEP1_V")%>";
                  }
                  else
                       stepObj.innerHTML = "<%=snapshotComparisonRes.getString("DIFF_REPORT_STEP1_S")%>";
               }
            }
        </script>
<%
    MxHtmlUtil.dumpHeadBegin(out);
    MxButton.dumpHeadContent(out);
    MxHtmlUtil.dumpHeadEnd(out);
%>
    </head>

    <body onUnload='removeInstance(<%=timeStamp%>)'>

        <script language='javascript' type='text/javascript'>
            MxPortalWorkspaceSetHelpTopic("manageTasks_create");
            MxPortalWorkspaceSetSubtitleHtml('<%=snapshotComparisonRes.getString("DESCRIPTION")%>:&nbsp;<%=snapshotComparisonRes.getString("ACTION_DESCRIPTION")%>');
        </script>

        <table>
            <tr>
                <td>
                    <font id='wizStep' class='mx-subheader-nosep'></font>
                </td>
            </tr>
        </table>

        <br>
<%
    String       snapOff = request.getParameter("snapoff");
    // build URL string for target selection page
    StringBuffer url     = new StringBuffer(100);

    url.append(MxOptions.URL_BASE);
    url.append("/taskandjob/targetSelection.jsp");
    url.append("?max-targets="+snapshotComparisonBean.getMaxCompareAsString());
    url.append("&btn2Text=");
    url.append(URLEncoder.encode( snapshotComparisonRes.getString("BUTTON_NEXT"), "UTF-8"));
    url.append("&btn2Function=parent.selectSnapshots()");
    url.append("&listType=systemLists");
    url.append("&timeStamp=");
    url.append(timeStamp);
    url.append("&snapoff=");
    url.append(snapOff);
    url.append("&fromSelectTargets=1");

    System.out.println(url.toString());
%>
        <iframe id='targetSelection' name='targetSelection' style='position:relative; visibility:visible; width:100%; height:1100'
                scrolling='no' marginwidth='0' frameborder='0' src='<%= url.toString() %>'>
        </iframe>
        <iframe id='action' name='action' style='position:relative; visibility:hidden; width:0; height:0'
                scrolling='no' marginwidth='0' frameborder='0' src='<%=MxOptions.URL_BASE%>/home/MxBlank.html'>
        </iframe>
<%
    MxHtmlUtil.dumpBodyEnd(out);
%>
    </body>
</html>
