<%
//
// $Source: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/security/serverCertImport.jsp,v $
// $Revision: 1.18 $
// $Date: 2005/01/19 06:18:00 $
//
%>

<!-- ---------------------------------------------------------------------- -->
<!--  Put all your Java imports here -->
<!-- ---------------------------------------------------------------------- -->

<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.portal.ui.MxBean" %>
<%@ page import="com.hp.mx.core.subjects.usermanager.MxUser" %>
<%@ page import="com.hp.mx.core.subjects.MxSubjectPrivilege" %>

<!-- ---------------------------------------------------------------------- -->
<!--  Put all your taglib imports here -->
<!-- ---------------------------------------------------------------------- -->

<!-- ---------------------------------------------------------------------- -->
<!--  Create all your beans here -->
<!-- ---------------------------------------------------------------------- -->

<!--  REQUIRED: This bean is used (later) to verify that this page is allowed to run -->
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />

<!-- My uniquely named beans -->
<jsp:useBean id="security_serverCertBean" class="com.hp.mx.portal.security.ServerCertificateBean" scope="session"/>
<jsp:useBean id="security_serverCertBundle" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<!-- ---------------------------------------------------------------------- -->
<!--  Put one block of initialization Java code here -->
<!--  In general, keep Java code to a minimum. Put Java code into JavaBeans. -->
<!-- ---------------------------------------------------------------------- -->
<%
    // REQUIRED: Set necessary HTTP header attributes (for localization and page caching)
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    // This aborts the page if the user isn't authorized.
    if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.SECURITY_MODIFICATION_PRIVILEGE))
    {%>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
  <%}

    // Set up the resource file
    security_serverCertBundle.init(loginBean, "ServerCertificate");
    security_serverCertBean.initBean(out, loginBean);
%>
<%!
  boolean isPostImport = false;
  String importResult = null;
%>
<%
  if ( request.getMethod().equalsIgnoreCase("POST") && (request.getParameter("import") != null) )
  {
    isPostImport = true;
    importResult = security_serverCertBean.importServerCert(request);
  }
  else
  {
    isPostImport = false;
    importResult = null;
  }

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();
    buttons.addMxTag(new MxDefaultTag("btnImport", security_serverCertBundle.getString("servercert.button.import0"), "doImport();"));
%>

<!-- ---------------------------------------------------------------------- -->
<!--  From here on, this is a well-formed HTML file -->
<!-- ---------------------------------------------------------------------- -->

<html>

<!-- ---------------------------------------------------------------------- -->
<!--  The HEAD block contains meta tags, the TITLE, style sheet links, -->
<!--  JavaScript links, and JavaScript code. -->
<!-- ---------------------------------------------------------------------- -->

<head>

<!-- ---------------------------------------------------------------------- -->
<!--  Most pages can get away with no title, because they are displayed -->
<!--  inside of a frame. -->
<!-- ---------------------------------------------------------------------- -->
    <TITLE></TITLE>

<!-- ---------------------------------------------------------------------- -->
<!--  Any additional style sheets links go here -->
<!-- ---------------------------------------------------------------------- -->
    <STYLE TYPE="text/css">
    <!--
        .required{color:#FF0000; font-weight:bold; }
    -->
    </STYLE>

<!-- ---------------------------------------------------------------------- -->
<!--  Any additional JavaScript links go here -->
<!-- ---------------------------------------------------------------------- -->

<!--  COMMONLY USED: This includes the browser-based portal API -->
<script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>

<!-- ---------------------------------------------------------------------- -->
<!--  Put all additional JavaScript here -->
<!-- ---------------------------------------------------------------------- -->
<script language='JavaScript' type='text/javascript'>

   function isEmpty( s)
   {
      if ( (s==null) || (s.value==null) || (s.value=="") )
         return true;
      else
         return false;
   }

   function doImport()
   {
      if ( isEmpty( document.getElementById("fileReply")))
      {
          document.getElementById("globalResult").innerHTML = "<%= security_serverCertBean.getResString("servercert.error.param.empty") %>";
          document.getElementById("fileReply").focus();
          return;
      }

      answer=confirm( <% security_serverCertBean.showWarning( out); %> );
      if (answer)
      {
         document.getElementById("btnImport").disabled = true;
         document.getElementById("btnImport").className="mx-button-disabled";
         document.ImportReplyForm.submit();
      }
   }

<%
  if (isPostImport && (importResult == null))
      out.println("parent.parent.location.replace('serverCertificate.jsp');");
%>

</script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxPortalRender.dumpHeadContent(out); %>
<% buttons.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</head>

<!-- ---------------------------------------------------------------------- -->
<!--  The BODY block begins here -->
<!-- ---------------------------------------------------------------------- -->
<body>

<font class='mx-subheader-nosep'><%= security_serverCertBundle.getString("servercert.reply.title") %></font>
<p><%= security_serverCertBundle.getString( "servercert.reply.instructions") %></p>

<P class='errorTextBold' id="globalResult"></P>

<FORM action="serverCertImport.jsp?import=yes" name="ImportReplyForm" method="POST" ENCTYPE="multipart/form-data">
  <table border=0 borderColor='#000000' marginwidth=0 marginheight=0 cellPadding=1 cellSpacing=0 width="100%">
    <tr><td align="right">
      <%=security_serverCertBundle.getString("servercert.reply.filename")%>:
    </td><td align="left">
      <input type="file" name="fileReply" id="fileReply"></input>
    </td></tr>
    <tr><td colspan=2>&nbsp;</td></tr>
    <tr align="right"><td colspan=2>
        <% buttons.dumpButtons(out); %>
    </td></tr>
  </table>
</form>


<script>
  document.getElementById("fileReply").focus();
<%
  if (isPostImport && (importResult != null))
      out.println("document.getElementById('globalResult').innerHTML=\""+importResult+"\";");
%>
</script>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</body>
</html>
