<%
//
// $Source: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/security/serverCertImportWiz.jsp,v $
// $Revision: 1.12 $
// $Date: 2005/04/18 22:56:29 $
//
%>

<!-- ---------------------------------------------------------------------- -->
<!--  Put all your Java imports here -->
<!-- ---------------------------------------------------------------------- -->

<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.core.subjects.usermanager.MxUser" %>
<%@ page import="com.hp.mx.core.subjects.MxSubjectPrivilege" %>

<!-- ---------------------------------------------------------------------- -->
<!--  Put all your taglib imports here -->
<!-- ---------------------------------------------------------------------- -->

<!-- ---------------------------------------------------------------------- -->
<!--  Create all your beans here -->
<!-- ---------------------------------------------------------------------- -->

<!--  REQUIRED: This bean is used (later) to verify that this page is allowed to run -->
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />

<!-- My uniquely named beans -->
<jsp:useBean id="security_serverCertBean" class="com.hp.mx.portal.security.ServerCertificateBean" scope="session"/>
<jsp:useBean id="security_serverCertBundle" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<!-- ---------------------------------------------------------------------- -->
<!--  Put one block of initialization Java code here -->
<!--  In general, keep Java code to a minimum. Put Java code into JavaBeans. -->
<!-- ---------------------------------------------------------------------- -->
<%
    // REQUIRED: Set necessary HTTP header attributes (for localization and page caching)
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    // This aborts the page if the user isn't authorized.
    if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.SECURITY_MODIFICATION_PRIVILEGE))
    {%>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
  <%}

    // Set up the resource file
    security_serverCertBundle.init(loginBean, "ServerCertificate");
    security_serverCertBean.initBean(out, loginBean);

    //if (request.getMethod().equals("POST"))
    //    security_serverCertBean.processDetailsPost(request, out);
%>

<!-- ---------------------------------------------------------------------- -->
<!--  From here on, this is a well-formed HTML file -->
<!-- ---------------------------------------------------------------------- -->

<html>

<!-- ---------------------------------------------------------------------- -->
<!--  The HEAD block contains meta tags, the TITLE, style sheet links, -->
<!--  JavaScript links, and JavaScript code. -->
<!-- ---------------------------------------------------------------------- -->

<head>

<!-- ---------------------------------------------------------------------- -->
<!--  Most pages can get away with no title, because they are displayed -->
<!--  inside of a frame. -->
<!-- ---------------------------------------------------------------------- -->
    <TITLE></TITLE>

<!-- ---------------------------------------------------------------------- -->
<!--  Put all UI component head blocks here (these consist of style sheets -->
<!--  and JavaScript links) -->
<!-- ---------------------------------------------------------------------- -->

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxPortalRender.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

<!-- ---------------------------------------------------------------------- -->
<!--  Any additional style sheets links go here -->
<!-- ---------------------------------------------------------------------- -->
    <STYLE TYPE="text/css">
    <!--
        .more-link{ cursor:pointer; color:#0000FF; text-decoration:underline }
    -->
    </STYLE>

<!-- ---------------------------------------------------------------------- -->
<!--  Any additional JavaScript links go here -->
<!-- ---------------------------------------------------------------------- -->

<!--  COMMONLY USED: This includes the browser-based portal API -->
<script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>

<!-- ---------------------------------------------------------------------- -->
<!--  Put all additional JavaScript here -->
<!-- ---------------------------------------------------------------------- -->
<script language='JavaScript' type='text/javascript'>

function doClick(p)
{
  document.getElementById('rulerdiv').style.display="block";
  document.getElementById('importDisplay').src=p;
}

</script>
</head>

<!-- ---------------------------------------------------------------------- -->
<!--  The BODY block begins here -->
<!-- ---------------------------------------------------------------------- -->
<body>

<hr class="mx-hr">

<font class='mx-subheader-nosep'><%= security_serverCertBundle.getString("servercert.import.title") %></font>
<p><%= security_serverCertBundle.getString( "servercert.import.instructions") %></p>

<blockquote>

   <%= security_serverCertBundle.getString("servercert.import.instructions1") %>&nbsp;[
   <a onclick="doClick('serverCertCSR.jsp')" class='more-link'>
   <%= security_serverCertBundle.getString("servercert.import.more") %>...</a> ]

   <br>

   <%= security_serverCertBundle.getString("servercert.import.instructions2") %>&nbsp;[
   <a onclick="doClick('serverCertCA.jsp')" class='more-link'>
   <%= security_serverCertBundle.getString("servercert.import.more") %>...</a> ]

   <br>

   <%= security_serverCertBundle.getString("servercert.import.instructions3") %>&nbsp;[
   <a onclick="doClick('serverCertImport.jsp')" class='more-link'>
   <%= security_serverCertBundle.getString("servercert.import.more") %>...</a> ]

   <br><br>
</blockquote>

<div id="rulerdiv" name="rulerdiv" style="display:none">
<hr class="mx-hr" id="ruler">
</div>

<blockquote>
   <iframe id="importDisplay" style="width:90%; height:700; position:relative; visibility:visible"
           scrolling="no" marginwidth="0" frameborder="0" src="<%=MxOptions.URL_BASE%>/home/MxBlank.html">
   </iframe>

</blockquote>

<% MxHtmlUtil.dumpBodyEnd(out); %>
</body>
</html>
