<%
//
// $Source: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/security/trustedCertificateList.jsp,v $
// $Revision: 1.34 $
// $Date: 2005/06/24 23:56:05 $
//
%>
<%@ page import="com.hp.mx.html.core.*" %>
<%@ page info="Trusted System Certificate List"%>
<%@ page import="com.hp.mx.utilities.MxKeystore" %>
<%@ page import="com.hp.mx.html.table.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.utilities.DebugOutput" %>
<%@ page import="com.hp.mx.utilities.DebugSubsystem" %>
<%@ page import="java.util.*" %>
<%@ page import="javax.swing.table.AbstractTableModel" %>
<%@ page import="com.hp.mx.portal.security.TrustedCertificateTableModel" %>
<%@ page import="com.hp.mx.core.subjects.usermanager.MxUser" %>
<%@ page import="com.hp.mx.core.subjects.MxSubjectPrivilege" %>
<%@ page import="com.hp.mx.portal.ui.MxBean" %>
<%@ page import="com.hp.mx.database.GlobalSettings" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="myTableSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session"/>
<jsp:useBean id="myBean" class="com.hp.mx.portal.security.TrustedCertificateBean" scope="session"/>
<jsp:useBean id="myTableView" class="com.hp.mx.html.table.MxTableView2" scope="session"/>
<jsp:useBean id="myController" class="com.hp.mx.html.table.MxTableController" scope="session"/>
<jsp:useBean id="myBundle" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<%!
    /** **********************************************************************
     * The debug object
     ************************************************************************ */
    public DebugSubsystem groupConfigurationDebug =
        DebugOutput.getDebugSubsystem("Keystore");
    public String srcTableDomId = "ID_MY_SRC_CERTIFICATE_TABLE";
%>

<%
    // REQUIRED: This line is required by Tomcat for i18n support.
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    // This aborts the page if the user isn't authorized.
    if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.SECURITY_MODIFICATION_PRIVILEGE))
    {%>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
  <%}

    // Do we need to abort?
    if (myController.checkUrlForControllerMessages(request, out)) return;

    int status=0;
    // Set up the resource file
    myBundle.init(loginBean, "TrustedCertificate");
    myBean.initBean(out, loginBean, myTableSelectionModel);
       TrustedCertificateTableModel tableModel = myBean.getTableModel();
       if (request.getParameter("delete") != null)
       {
          //  status=MxKeystore.xeKey.deleteCert(certAlias);
            status=myBean.delete(request, out);
            if (status!=0)
            {
                out.print("<script>alert('"+session.getValue("tcert.error.deletecert")+"');</script>");
            }
        }
        String reqTrustedCert = request.getParameter("checkvalue");
        if ((reqTrustedCert!=null))
        {
    //  out.print("<script>alert('Got trust cert val is '"+"+'"+reqTrustedCert+"');</script>");
            if (reqTrustedCert.equals("checked"))
            {
                GlobalSettings.setProperty("RequireCertificates","true");
            }
            else
            {
                GlobalSettings.setProperty("RequireCertificates","false");
            }
        }
      //  else
      //  {
      //      GlobalSettings.setProperty("RequireCertificates","false");
      //  }

   String gsReqCerts = GlobalSettings.getProperty("RequireCertificates", "false");
   String formSelReqCerts = "";
  // out.print("<script>alert('Globalsetting is '"+"+'"+gsReqCerts+"');</script>");
   if (gsReqCerts.equals("true"))
   {
       formSelReqCerts = "checked";
   }
        %>

        <script>
               function openCert()
               {
    <%
       if (request.getParameter("export") != null)
       {
            status=myBean.export(request, out);
            if (status>0)
            {
               out.print("<script>alert('"+session.getValue("tcert.error.exportcert")+"');</script>");
            }
            else
            {
                %>
               if ( navigator.userAgent.toLowerCase().indexOf("msie") > 0 )
                {
                   var iFrame = document.getElementById("trustedDetails");
                   if (iFrame != null)
                   {
                      iFrame.contentWindow.document.location.replace("trstcert.cer");
                   }
               }
               else
                {
                     window.open("./trstcert.txt", "expcert", "scrollbars,resizable,width=600,height=300");
                }

                //history.go(-1);
                // return;
               <%
            //   return;
            }
      }
      %>
      }

     </script>
    <%
      if (myController.isFirstTime())
    {
        myBean.getColumnNames(tableModel);
        // Initialize the bean
        myTableView.setId(srcTableDomId);
        myTableView.setOnSelectionChange("mySelectionChanged");
        myTableView.setUrlHandler(request.getRequestURI());
        myTableView.setHeight("15");
       // myTableView.setTableModel(tableModel);
        myTableSelectionModel.setSelectionMode(MxTableSelectionModel.MULTIPLE_INTERVAL_SELECTION);
        myController.setLocale(loginBean.getLocale());
        myController.setTableModelWithSorting(tableModel);
        myController.setSelectionModel(myTableSelectionModel);
        myController.setTableView(myTableView);
    }

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();
    buttons.addMxTag(new MxDefaultTag("btnImport", myBundle.getString("tcert.import.button"), "doImport();"));
    buttons.addMxTag(new MxDefaultTag("btnExport", myBundle.getString("tcert.export.button"), "doExport();"));
    buttons.addMxTag(new MxDefaultTag("btnDelete", myBundle.getString("tcert.delete.button"), "doDelete();"));
%>
<HTML>
<HEAD>
    <TITLE><%= myBundle.getString("page.tcert.title") %></TITLE>
    <%
        // Generate the JavaScript functions used to support the HTML table
        myBean.refreshTableModel(tableModel);
        tableModel.fireTableDataChanged();
        myBean.refreshTableModel(tableModel);
        myBean.getTableWidth();
    %>
    <script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
    <script src="<%=MxOptions.URL_BASE%>/js/MxBrowser.js" language="JavaScript" type="text/javascript"></script>
    <script src="<%=MxOptions.URL_BASE%>/js/utilities.js" language="JavaScript" type="text/javascript"></script>

 <script language='JavaScript' type='text/javascript'>
   MxPortalWorkspaceSetHelpTopic("admin_cert_trusted");
   function doImport()
   {
       var iFrame = document.getElementById("trustedDetails");
       if (iFrame != null)
       {
           iFrame.contentWindow.document.location.replace("trustedCertificateListDetails.jsp");
       }
       return;
   }

   function doExport()
   {
      document.location.replace("trustedCertificateList.jsp?export=yes");
   }
   function doDelete()
   {
     var answer=confirm("<%=myBundle.getString("tcert.delete.warning")%>");
     if (answer)
     {
      //  var iFrame = document.getElementById("trustedCertificateDetails");
      //  if (iFrame)
       // {
            document.location.replace("trustedCertificateList.jsp?delete=yes");
       // }
     }
    //return;
   }
   function displayWarning()
   {
        if (document.getElementById('RTC').checked)
        {
           answer=confirm(
                <% StringBuffer sb = new StringBuffer(1024);
            sb.append("\"");
            sb.append(myBundle.getString("tcert.require.warning1"));
            sb.append("\\n\\n");
            sb.append(myBundle.getString("tcert.require.warning2"));
            sb.append("  ");
            sb.append(myBundle.getString("tcert.require.warning3"));
            sb.append("  ");
            sb.append(myBundle.getString("tcert.require.warning4"));
            sb.append("\\n\\n");
            sb.append(myBundle.getString("tcert.require.warningDTS"));
            sb.append("\\n\\n");
            sb.append(myBundle.getString("tcert.require.warningOK"));
            sb.append("\"");
            out.write(sb.toString()); %>
                          );
           if (!answer)
           {
              document.getElementById('RTC').checked=false;
           }
           else
           {
              document.location.replace("trustedCertificateList.jsp?checkvalue=checked");
           }
        }
        else
        {
            answer=confirm(
            <% StringBuffer sb2 = new StringBuffer(1024);
            sb2.append("\"");
            sb2.append(myBundle.getString("tcert.require2.warning1"));
            sb2.append("\\n\\n");
            sb2.append(myBundle.getString("tcert.require2.warning2"));
            sb2.append("  ");
            sb2.append(myBundle.getString("tcert.require2.warning3"));
            sb2.append("  ");
            sb2.append(myBundle.getString("tcert.require2.warning4"));
            sb2.append("\\n\\n");
            sb2.append(myBundle.getString("tcert.require.warningDTS"));
            sb2.append("\\n\\n");
            sb2.append(myBundle.getString("tcert.require.warningOK"));
            sb2.append("\"");
            out.write(sb2.toString()); %>
           );
           if (!answer)
           {
              document.getElementById('RTC').checked=true;
           }
           else
           {

               document.location.replace("trustedCertificateList.jsp?checkvalue=notchecked");
           }
        }
   }

        function mySelectionChanged(szIdTable, iRow, bSelected)
        {
            checkButtonStates();
        }

        function checkButtonStates()
        {
            // import button is always enabled.
           var aSel = MxTableGetSelections("<%= srcTableDomId %>");
            if (!aSel)
            {
                return;
            }
            if (aSel.length <1)
            {
                ourButtonManager.disableButtonById('btnExport');
                ourButtonManager.disableButtonById('btnDelete');
                return;
            }
            if (aSel.length == 1)
            {
                ourButtonManager.enableButtonById('btnExport');
                ourButtonManager.enableButtonById('btnDelete');
                return;
            }
            ourButtonManager.disableButtonById('btnExport');
            ourButtonManager.enableButtonById('btnDelete');
        }

        function myOnLoad()
        {
            checkButtonStates();
            openCert();
            setTimeout("myOnResize2()", 500);
        }
        function myOnResize()
        {
            resize_w2();
            resize_h();
        }
        function resize_w()
        {
            var w = Math.max(0, MxBrowserGetBodyWidth(0, 0));
            MxTableSetWidth("<%= srcTableDomId %>", w);
        }
        function myOnResize2()
        {
            resize_w2();
            resize_h();
        }
        function resize_w2()
        {
            var w = <%= myBean.getTableWidth() %>;
            MxTableSetWidth("<%= srcTableDomId %>", w);
        }
        function resize_h()
        {
            var h_total = Math.max(0, MxBrowserGetBodyHeight(0, 0));
            var h = Math.max(0, h_total);
            MxTableSetHeight("<%= srcTableDomId %>", 180);
        }
        /*
        function myOnLoad()
        {
            setTimeout("myOnResize()", 500);
        }

        function myOnResize()
        {
            resize_w();
               resize_h();
        }

        function resize_w()
        {
            var w = Math.max(0, MxBrowserGetBodyWidth(0, 0));
            MxTableSetWidth("<%= srcTableDomId %>", w);
        }
        function resize_h()
        {
            var h_total = Math.max(0, MxBrowserGetBodyHeight(0, 0));
            var h = Math.max(0, h_total);
            MxTableSetHeight("<%= srcTableDomId %>", 180);
        }
*/
        MxPortalWorkspaceSetSubtitleHtml("<%= myBundle.getString("page.general.description") %>")
    </script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% buttons.dumpHeadContent(out); %>
<% myTableView.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</HEAD>
<BODY onLoad="myOnLoad()" onResize="myOnResize2()">
<%
    ///////////////////////////////////////////////////////////////////////////
    // IS THIS A POST?  Check data validity and redirect
    ///////////////////////////////////////////////////////////////////////////
    if (request.getMethod().equals("POST"))
    {
    }
        %>
    <TABLE>
    <tr><td>
      <p><%= myBundle.getString("page.tcert.instructions") %></p>
    </td></tr>
        <TR>
            <TD>
            <form name="Require">
            <input id="RTC" name="RTC" value="checked" type=checkbox <%=formSelReqCerts%> onclick="javascript:displayWarning()">
            <label for="RTC"><%= myBundle.getString("tcert.required.checkbox") %></label>
            </form>
            </TD>
        </TR>
    </TABLE>
    <div id="trustedCertificateDetails" style="width:100%;">
            <%
    myTableView.dumpWholeTable(out);
%>
    </div>
    <br>
    <div style="margin-top:15px">
        <% buttons.dumpButtons(out); %>
    </div>

<iframe id="trustedDetails" style="width:100%; height:100%; position:relative; visibility:visible"
       scrolling="no" marginwidth="0" frameborder="0" src="<%=MxOptions.URL_BASE%>/home/MxBlank.html"></iframe>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</BODY>
</HTML>
