<%
//
// $Source: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/settings/AutoDiscoveryList.jsp,v $
// $Revision: 1.29 $
// $Date: 2005/07/14 21:17:02 $
//
%>
<%@page import="com.hp.mx.html.core.*" %>
<%@page import="com.hp.mx.html.core.MxHtmlUtil"%>
<%@page import="com.hp.mx.core.subjects.*"%>
<%@page import="com.hp.mx.portal.actiononevents.*"%>
<%@page import="com.hp.mx.portal.ui.*"%>
<%@page import="com.hp.mx.portal.discovery.AutoDiscoveryTaskListMgr"%>
<%@page import="com.hp.mx.utilities.DebugOutput" %>
<%@page import="com.hp.mx.utilities.DebugSubsystem" %>
<%@page import="com.hp.mx.utilities.MxCMS"%>
<%@page import="com.hp.mx.html.table.*"%>
<%@page import="java.util.*"%>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="rbListSettings" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="discTableView" class="com.hp.mx.html.table.MxTableView2" scope="session"/>
<jsp:useBean id="discController" class="com.hp.mx.html.table.MxTableController" scope="session"/>
<jsp:useBean id="discTableModel" class="com.hp.mx.portal.discovery.DiscoveryTableModel" scope="session"/>
<jsp:useBean id="discTabModel" class="com.hp.mx.portal.discovery.DiscoveryTabModel" scope="session" />
<jsp:useBean id="autoDiscoveryListBean" class="com.hp.mx.portal.discovery.AutoDiscoveryList" scope="session"/>

<%!
    /** **********************************************************************
     * The debug object
     ************************************************************************ */
    public DebugSubsystem groupConfigurationDebug =
        DebugOutput.getDebugSubsystem("AutoDiscoveryList");

    public String srcTableDomId = "ID_MY_DISCOVERY_LIST";

    final int GUTTER_SPACING = 10;
%>
<%
    // REQUIRED: This line is required by Tomcat for i18n support.
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
    {
        return;
    }

    // if this page was loaded just to give the table controller a message
    // (usually in a hidden frame), then don't continue processing this page

    autoDiscoveryListBean.initialize(loginBean);
    AutoDiscoveryTaskListMgr inst = autoDiscoveryListBean.initializeAllTasks();

    // Stop processing if this page is just refreshing as part of
    // normal table maintenance
    MxTableController tasksTableController = inst.getTasksTableController();
    if (tasksTableController.checkUrlForControllerMessages(request, out) == true)
    {
        return;
    }

    // Abort if the user isn't authorized.
    if ((!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.NOTIFICATION_SETTINGS_MODIFICATION_PRIVILEGE))
        || (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.EVENT_MODIFICATION_PRIVILEGE))
        || (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.TOOL_MODIFICATION_PRIVILEGE))
        || (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.SUBJECT_MODIFICATION_PRIVILEGE))
        )
    {
        %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
        <%
    }

    // Refresh the task list if requested
    if (request.getParameter("refresh") != null)
    {
        autoDiscoveryListBean.refreshNow();
    }

    // Initialize the table view
    MxTableView2 tasksTableView = inst.getTasksTableView();

    int numTasks = inst.getNumTasks();

    // Set up the Discovery Tabs
    rbListSettings.init(loginBean, "Discovery");
    discTabModel.load(rbListSettings);
    discTabModel.setMxTagSelectionId(discTabModel.DISC_AUTOMATIC);

    // Set up the Discovery Buttons
    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();
    buttons.addMxTag(new MxDefaultTag("btnNew", autoDiscoveryListBean.getResourceString("auto.btn.new"), "showAddPage()"));
    buttons.addMxTag(new MxDefaultTag("btnEdit", autoDiscoveryListBean.getResourceString("auto.btn.edit"), "showEditPage()"));
    buttons.addMxTag(new MxDefaultTag("btnEnableDisable", autoDiscoveryListBean.getResourceString("auto.btn.disable"), "enableDisableDiscoveryTask()"));
    buttons.addMxTag(new MxDefaultTag("btnDelete", autoDiscoveryListBean.getResourceString("auto.btn.delete"), "deleteDiscoveryTask()"));
    buttons.addMxTag(new MxDefaultTag("btnRunNowStop", autoDiscoveryListBean.getResourceString("auto.btn.runNow"), "runNowStop()"));
%>

<html>
<head>
    <title>Discovery List</title>
    <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
    <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/actiononevents/css/ActionOnEvents.css'>
    <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js'></script>
    <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxBrowser.js'></script>
    <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxPortalApi.js'></script>
    <script language="JavaScript" type="text/javascript">
        var REFRESH_TIMEOUT              = 10000; // 10 seconds
        var NETSCAPE_SCROLLBAR_WIDTH     = 36;
        var ACTION_TIMEOUT               = 250;
    </script>
    <script language='javascript' type='text/javascript'>
        MxPortalWorkspaceSetHelpTopic("admin_discovery_configAuto");

        // the function called when the selection changes
        function mySelectionChanged(szIdTable, iRow, bSelected)
        {
            var iframe = document.getElementById("discoveryDetailsFrame");
            iframe.contentWindow.document.location.replace("<%=MxOptions.URL_BASE%>/home/MxBlank.html");

            document.getElementById("listUpdaterFrame").src = "<%=MxOptions.URL_BASE%>/settings/AutoDiscoveryListUpdater.jsp?mode=<%= autoDiscoveryListBean.MODE_REFRESH %>";

            <% // handle buttons based on selection %>
            document.getElementById("selectTask").src = "<%=MxOptions.URL_BASE%>/settings/AutoDiscoveryListSelectTask.jsp";

            MxPortalWorkspaceSetHelpTopic("admin_discovery_configAuto");
        }

        function enableAllButtons()
        {
            enableDisableButtons(true);
        }

        function disableAllButtons()
        {
            enableDisableButtons(false);
        }

        function enableDisableButtons(enableFlag)
        {
            enableDisableButtonsById('btnNew', enableFlag);
            enableDisableButtonsById('btnEdit', enableFlag);
            enableDisableButtonsById('btnEnableDisable', enableFlag);
            enableDisableButtonsById('btnDelete', enableFlag);
            enableDisableButtonsById('btnRunNowStop', enableFlag);
        }

        function enableDisableButtonsById(btnId, enableFlag)
        {
            if (enableFlag)
            {
                ourButtonManager.enableButtonById(btnId);
            }
            else
            {
                ourButtonManager.disableButtonById(btnId);
            }
        }

        function showAddPage()
        {
            MxPortalWorkspaceSetHelpTopic("admin_discovery_newTask");
            document.getElementById("discoveryDetailsFrame").src = "<%=MxOptions.URL_BASE%>/settings/AutoDiscovery.jsp?mode=new";
        }

        function showEditPage()
        {
            MxPortalWorkspaceSetHelpTopic("admin_discovery_editTask");
            document.getElementById("discoveryDetailsFrame").src = "<%=MxOptions.URL_BASE%>/settings/AutoDiscovery.jsp?mode=edit&discoveryId=";
        }

        function showConfigPage()
        {
            MxPortalWorkspaceSetHelpTopic("admin_discovery_configAuto");
            document.getElementById("discoveryDetailsFrame").src = "<%=MxOptions.URL_BASE%>/settings/AutoDiscoveryGlobals.jsp";
        }

        function showTemplatesPage()
        {
            MxPortalWorkspaceSetHelpTopic("admin_discovery_template");
            document.getElementById("discoveryDetailsFrame").src = "<%=MxOptions.URL_BASE%>/settings/AutoDiscoveryTemplates.jsp";
        }

        function runNowStop()
        {
            disableAllButtons();
            document.getElementById("listUpdaterFrame").src = "<%=MxOptions.URL_BASE%>/settings/AutoDiscoveryListUpdater.jsp?mode=<%= autoDiscoveryListBean.MODE_TOGGLE_RUN %>";

        }

        function deleteDiscoveryTask()
        {
            if (confirm('<%=autoDiscoveryListBean.getResourceString("auto.msg.confirm.delete")%>'))
            {
                disableAllButtons();
                document.getElementById("listUpdaterFrame").src = "<%=MxOptions.URL_BASE%>/settings/AutoDiscoveryListUpdater.jsp?mode=<%= autoDiscoveryListBean.MODE_DELETE %>";
            }
        }

        function enableDisableDiscoveryTask()
        {
            disableAllButtons();
            document.getElementById("listUpdaterFrame").src = "<%=MxOptions.URL_BASE%>/settings/AutoDiscoveryListUpdater.jsp?mode=<%= autoDiscoveryListBean.MODE_TOGGLE_ENABLE %>";
        }

        function setFrmDisplayHeight(pageHeight)
        {
            document.getElementById('discoveryDetailsFrame').style.height =  pageHeight;
        }

        function setFrmDisplayWidth(pageWidth)
        {
            var w = Math.max(pageWidth, MxPortalGetWorkspaceFrame().scrollWidth);
            var marginWidth = document.getElementById('discoveryDetailsFrame').marginWidth;
            document.getElementById('discoveryDetailsFrame').style.width =  (w - marginWidth);
        }

        // Resize the MxTable to be flush with the right browser edge
        function myResize()
        {
            var w = Math.max(0, MxBrowserGetBodyWidth(-NETSCAPE_SCROLLBAR_WIDTH, 0));
            MxTableSetWidth('<%= srcTableDomId %>', (w - <%=GUTTER_SPACING%>));
        }

        // Set the height of the MxTable based on the number of rules
        function resize_h()
        {
            var titleHeight  = 0;
            var rowHeight    = 0;
            var maxDisplayed = 10;
            var numRules = <%=numTasks%>;
            var divHeight    = 0;

            if (numRules > 0)
            {
                rowHeight = MxTableGetRowHeight('<%= srcTableDomId %>', 0);
                titleHeight = MxTableGetHeadHeight('<%= srcTableDomId %>');
            }

            divHeight    = titleHeight;

            if (numRules < maxDisplayed)
            {
                divHeight += (rowHeight * (numRules+1));
            }
            else
            {
                divHeight += (rowHeight * maxDisplayed);
            }
            MxTableSetHeight('<%= srcTableDomId %>', divHeight);
        }

        // we won't request another refresh until the previous request was answered
        var refreshed  = true;
        function autoRefresh(reset)
        {
            // set the timer to go off again
            if ((reset != null) && (reset == true))
            {
                setTimeout("autoRefresh(true)", REFRESH_TIMEOUT);
            }
            // don't send another request until the previous request has completed
            if (refreshed == false)
            {
                return;
            }
            // set to false, the refresh page sets this back to true when it is complete
            refreshed = false;

            // set mouse to hourglass - so that the user cannot make a selection
            // change while we are updating the page
            setMouseCursor(MOUSE_CURSOR_HOURGLASS);

            // tell the table to update its content
            MxTableRefreshInPlace('<%= srcTableDomId %>');

            // update the Number of Jobs displayed & divHeight of MxTable
            var iframe    = document.getElementById('listRefreshFrame');
            var updateURL = '<%=MxOptions.URL_BASE%>/settings/AutoDiscoveryListRefresh.jsp';
            iframe.contentWindow.document.location.replace(updateURL);

            // change the mouse back to a pointer
            setMouseCursor(MOUSE_CURSOR_POINTER);
        }

        function loadPage()
        {
            // Ensure Mozilla page resize
            setTimeout("reallyLoadPage()", 100);
        }

        function reallyLoadPage()
        {
            // handle buttons based on selection
            document.getElementById("selectTask").src = "<%=MxOptions.URL_BASE%>/settings/AutoDiscoveryListSelectTask.jsp";
            myResize();
            setTimeout("autoRefresh(true)", REFRESH_TIMEOUT);
        }
    </script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% buttons.dumpHeadContent(out); %>
<% tasksTableView.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>
</head>
<body onload="loadPage()" onresize="myResize(), resize_h()">
    <% discTabModel.dumpTabs(out); %>
    <br><br>
    <p><%= autoDiscoveryListBean.getResourceString("auto.description") %></p>
    <b><%= autoDiscoveryListBean.getResourceString("auto.label.other.options") %></b></br>
    &nbsp;&nbsp;&nbsp;&nbsp;<a href="javascript:void(0)" onclick="showConfigPage()"><%= autoDiscoveryListBean.getResourceString("auto.link.general.settings") %></a></br>
    &nbsp;&nbsp;&nbsp;&nbsp;<a href="javascript:void(0)" onclick="showTemplatesPage()"><%= autoDiscoveryListBean.getResourceString("auto.link.manage.templates") %></a></br>
    &nbsp;&nbsp;&nbsp;&nbsp;<a href='javascript:MxPortalActionStart("PROTOCOLS", "fromDiscovery=true")' ><%= autoDiscoveryListBean.getResourceString("global.page.protoSettings")%></a></br>
<%
    if (autoDiscoveryListBean.isStoragePluginInstalled())
    {
%>
        </br></br>
        <b><%= autoDiscoveryListBean.getResourceString("auto.se.header") %></b>
        <p><%= autoDiscoveryListBean.getResourceString("auto.se.description") %></p>
        &nbsp;&nbsp;&nbsp;&nbsp;<a href="javascript:MxPortalActionStart('EDIT_SE_GLOBAL_APPLICATION_SETTINGS', '')"><%= autoDiscoveryListBean.getResourceString("auto.se.link.applicationsettings")%></a></br>
        &nbsp;&nbsp;&nbsp;&nbsp;<a href="javascript:MxPortalActionStart('EDIT_SE_GET_DETAILS', '')"><%= autoDiscoveryListBean.getResourceString("auto.se.link.getdetails")%></a></br>
        &nbsp;&nbsp;&nbsp;&nbsp;<a href="javascript:MxPortalActionStart('EDIT_SE_SCHEDULE_GET_DETAILS', '')"><%= autoDiscoveryListBean.getResourceString("auto.se.link.schedulegetdetails")%></a></br>
        </br>
<%
    }
%>
    </br>

    <%
    if (numTasks > 0)
    {
        tasksTableView.dumpWholeTable(out);
    }
    else
    {
        %><div class="errorTextBold"><%=autoDiscoveryListBean.getResourceString("auto.table.noTasks")%></div><%
    }
    %>

    <div style="margin-top:15px">
        <% buttons.dumpButtons(out); %>
    </div>

    <iframe id="discoveryDetailsFrame"
            name="discoveryDetailsFrame"
            style="width:100%; height:800; position:relative; visibility:visible"
            scrolling="no" marginwidth="0"
            frameborder="0"
            src="<%=MxOptions.URL_BASE%>/home/MxBlank.html">
    </iframe>
    <iframe id="listUpdaterFrame" name="listUpdaterFrame" style="position:relative; visibility:hidden; width:0; height:0;"
            scrolling="no" marginwidth="0" frameborder="0" src="<%=MxOptions.URL_BASE%>/home/MxBlank.html">
    </iframe>
    <iframe id="listRefreshFrame" name="listRefreshFrame" style="position:relative; visibility:hidden; width:0; height:0;"
            scrolling="no" marginwidth="0" frameborder="0" src="<%=MxOptions.URL_BASE%>/home/MxBlank.html">
    </iframe>
    <iframe id='selectTask' name='selectTask' style='position:relative; visibility:hidden; width:0; height:0;'
            scrolling='no' marginwidth='0' frameborder='0' src='<%=MxOptions.URL_BASE%>/home/MxBlank.html'>
    </iframe>

    <% MxHtmlUtil.dumpBodyEnd(out); %>
</body>
</html>
