<%--
//$Source: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/settings/AutoDiscoveryListUpdater.jsp,v $
//$Revision: 1.9 $
//$Date: 2005/02/08 23:33:05 $
--%>
<%@page import="com.hp.mx.core.subjects.*"%>
<%@page import="com.hp.mx.portal.ui.*"%>
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="autoDiscoveryBean" class="com.hp.mx.portal.discovery.AutoDiscoveryBean" scope="session" />
<jsp:useBean id="autoDiscoveryListBean" class="com.hp.mx.portal.discovery.AutoDiscoveryList" scope="session"/>
<%
    // REQUIRED: This line is required by Tomcat for i18n support.
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
    {
        return;
    }

    // Abort if the user isn't authorized.
    if ((!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.NOTIFICATION_SETTINGS_MODIFICATION_PRIVILEGE))
        || (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.EVENT_MODIFICATION_PRIVILEGE))
        || (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.TOOL_MODIFICATION_PRIVILEGE))
        || (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.SUBJECT_MODIFICATION_PRIVILEGE))
        )
    {
        %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
        <%
    }
%>
<html>
    <HEAD>
    <%
        String mode = "";
        if (request.getParameter("mode") != null)
        {
            mode = request.getParameter("mode");
        }

        if (mode.equalsIgnoreCase(autoDiscoveryListBean.MODE_DELETE))
        {
            if (autoDiscoveryListBean.isDefaultDiscoveryTask())
            {
                out.println("<script language='JavaScript' type='text/javascript'>");
                out.println("alert('" + autoDiscoveryListBean.getResourceString("auto.list.error.cannotDeleteDefaultTask") + "');");
                out.println("parent.loadPage()");
                out.println("</script>");
            }
            else
            {
                try
                {
                    // Get the row number of the selected task from the selection model object
                    if (autoDiscoveryListBean.deleteDiscoveryTask())
                    {
                        // Update the list (in the parent frame)
                        %> <script language='javascript' type='text/javascript'>parent.location.replace("AutoDiscoveryList.jsp");</script> <%
                        return;
                    }
                }
                catch (Throwable t)
                {
                    out.println("<script language='javascript' type='text/javascript'>alert('" + autoDiscoveryListBean.getResourceString("auto.list.error.cannotRefresh") + "');</script>");
                    return;
                }
            }
        }
        else if (mode.equalsIgnoreCase(autoDiscoveryListBean.MODE_TOGGLE_ENABLE))
        {
            try
            {
                // Get the row number of the selected task from the selection model object
                if (autoDiscoveryListBean.enableDisableDiscoveryTask(out))
                {
                    // Update the list (in the parent frame)
                    %> <script language='javascript' type='text/javascript'>parent.location.replace("AutoDiscoveryList.jsp");</script> <%
                    return;
                }
            }
            catch (Throwable t)
            {
                out.println("<script language='javascript' type='text/javascript'>alert('" + autoDiscoveryListBean.getResourceString("auto.list.error.cannotRefresh") + "');</script>");
                return;
            }
        }
        else if (mode.equalsIgnoreCase(autoDiscoveryListBean.MODE_TOGGLE_RUN))
        {
            if (autoDiscoveryListBean.isTaskRunning())
            {
                // Task is running, STOP it.
                autoDiscoveryBean.initialize(autoDiscoveryListBean.getTaskID().toString(), loginBean);
                if (!autoDiscoveryBean.stopTaskJob(false))
                {
                    // Alert user that task did not stop
                    %>
                    <script language='javascript' type='text/javascript'>
                        alert('<%= autoDiscoveryListBean.getResourceString("auto.list.error.stop") %>');
                    </script>
                    <%
                }
            }
            else
            {
                // Task is not running, RUN it.
                if (!autoDiscoveryListBean.runTaskNow())
                {
                    // Alert user that task did not execute
                    %>
                    <script language='javascript' type='text/javascript'>
                        alert('<%= autoDiscoveryListBean.getResourceString("auto.list.error.run") %>');
                    </script>
                    <%
                }
            }

            // Update the list (in the parent frame) for immediate update
            %>
            <script language='javascript' type='text/javascript'>
                parent.location.replace("AutoDiscoveryList.jsp?refresh=1");
            </script>
            <%
            return;
        }
        else if (mode.equalsIgnoreCase(autoDiscoveryListBean.MODE_REFRESH))
        {
            boolean success = autoDiscoveryListBean.getMyTaskListManager().selectTask();
            return;
        }
    %>
    <!-- mode:  <%= mode %> -->
    </HEAD>
    <BODY>
    </BODY>
</html>
