<%--
//$Source: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/settings/DeviceListUrlLauncher.jsp,v $
//$Revision: 1.7 $
//$Date: 2005/02/01 21:02:14 $
--%>
<!-- ---------------------------------------------------------------------- -->
<!--  Put all your Java imports here -->
<!-- ---------------------------------------------------------------------- -->
<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.utilities.DebugOutput" %>
<%@ page import="com.hp.mx.utilities.DebugSubsystem" %>
<%@ page import="com.hp.mx.core.nodemanager.*" %>
<%@ page import="com.hp.mx.core.controllers.*" %>
<%@ page import="com.hp.mx.core.alertmanager.AlertObject" %>

<!-- ---------------------------------------------------------------------- -->
<!--  Create all your beans here -->
<!-- ---------------------------------------------------------------------- -->
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="debugBean" class="com.hp.mx.portal.ui.MxBean" scope="session" />
<jsp:useBean id="deviceBundle" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<!-- ---------------------------------------------------------------------- -->
<!--  Put one block of initialization Java code here -->
<!--  In general, keep Java code to a minimum. Put Java code into JavaBeans. -->
<!-- ---------------------------------------------------------------------- -->
<%!
    DebugSubsystem devicePageDebugLevel = DebugOutput.getDebugSubsystem("DevicePage");
%>
<%
    // REQUIRED: This line is required by Tomcat for i18n support.
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    deviceBundle.init(loginBean, "MxDeviceBundle");
%>

<HTML>
<HEAD>
    <link href="<%=MxOptions.URL_BASE%>/css/MxPortalEx.css" rel="stylesheet" type="text/css">

    <STYLE TYPE="text/css">
    <!--
        .indented{margin-left:12px;}
    -->
    </STYLE>
    <script src="<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js" type="text/javascript" language="JavaScript"></script>
    <script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
    <script type='text/javascript' language='JavaScript' src='<%=MxOptions.URL_BASE%>/js/utilities.js'></script>
    <% MxHtmlUtil.dumpHeadBegin(out); %>
    <% MxHtmlUtil.dumpHeadEnd(out); %>
</HEAD>
<BODY>
  <%
    ///////////////////////////////////////////////////////////////////////////
    // IS THIS A POST?  Check data validity and redirect
    ///////////////////////////////////////////////////////////////////////////
    //debugBean.displayJspParamsHtml(request, out);
    //debugBean.displayJspParamsToConsole(request);

    try
   {
      // Query the database to get product name, contact, location
      MxNode d = null;

      /////////////////////////////////////////////////////////
      // WAS "Id" PASSED AS A PARAMETER?
      /////////////////////////////////////////////////////////
      DebugOutput.log(devicePageDebugLevel, 10, "Parameter Check: Id = " + request.getParameter("Id"));
      int NoticeId = 0;
      if (request.getParameter("Id") != null)
      {
           DebugOutput.log(devicePageDebugLevel, 10, "Yes it comes here");
           NoticeId = Integer.parseInt(request.getParameter("Id"));
           DebugOutput.log(devicePageDebugLevel, 10," Notice ID " + NoticeId);
           AlertObject n = null;
           try
           {
              AlertController myAlertController = AlertController.getDefaultController();

              n = myAlertController.getAlert(NoticeId);
           }
           catch (Exception ex)
           {
           }

           if (n != null)
           {
               d = n.getDevice();
           }

           DebugOutput.log(devicePageDebugLevel, 10, "The Device Name : " + d);

           if (d == null || d.isDeviceDeleted() == true)
           {
%>
            <p class=errorTextBold><%=deviceBundle.getString("INVALID_NODE")%> </p>
<%
              return;
           }
       }

       /////////////////////////////////////////////////////////
       // WAS "Device Name" PASSED AS A PARAMETER?
       /////////////////////////////////////////////////////////
       DebugOutput.log(devicePageDebugLevel, 10, "Parameter Check: deviceName = " + request.getParameter("deviceName"));
       boolean alreadyDisplayed = false;
       if (d == null)
       {
         String devName;
         if ((devName = request.getParameter("deviceName")) != null)
         {
             try
             {
              d = MxNodeController.getDefaultControllerNoEx().getNodeByNodeOrHostName(devName);
             }
             catch (Exception ex)
             {
                 ex.printStackTrace();
             }


              if (d == null)
             {
                 out.println("<B>The device named "+devName+" was not found <B>");
                 alreadyDisplayed = true;
             }
          }
        }
        if (d == null)
        {
            if (alreadyDisplayed != true)
            out.println("<B>The device was not found <B>");
            return;
        }

        if (d.isDeviceDeleted() == true)
        {
%>
            <p class=errorTextBold><%=deviceBundle.getString("INVALID_NODE")%> </p>
<%
           return;
        }


         // Really need to open a new browser to launch the remote insight url

         // Get the address or the device name based on user settings.
         String linkName = d.getDeviceLinkName();
         String url = null;

       // try to find the correct mgmt proc URL.
          DeviceUrl mgmtProcUrl = null;
          mgmtProcUrl = NodeUrlManager.getDefaultManager().getDeviceUrlByBase(d.getDeviceKey(), NodeUrlTypeManager.getDefaultManager().getUrlTypeByRootName(DeviceUrlNamesIfc.DEVICE_URLTYPE_MGMTPROCESSOR));
          if (mgmtProcUrl == null)
          {
             mgmtProcUrl = NodeUrlManager.getDefaultManager().getDeviceUrlByBase(d.getDeviceKey(), NodeUrlTypeManager.getDefaultManager().getUrlTypeByRootName(DeviceUrlNamesIfc.DEVICE_URLTYPE_WEBSERVER_PREFIX+"80"));
          }
          if (mgmtProcUrl == null)
          {
             mgmtProcUrl = NodeUrlManager.getDefaultManager().getDeviceUrlByBase(d.getDeviceKey(), NodeUrlTypeManager.getDefaultManager().getUrlTypeByRootName(DeviceUrlNamesIfc.DEVICE_URLTYPE_WEBSERVER_PREFIX+"443"));
          }
          if (mgmtProcUrl == null)
          {
             mgmtProcUrl = NodeUrlManager.getDefaultManager().getDeviceUrlByBase(d.getDeviceKey(), NodeUrlTypeManager.getDefaultManager().getUrlTypeByRootName(DeviceUrlNamesIfc.DEVICE_URLTYPE_DEFMGMTURL));
          }
          if (mgmtProcUrl == null)
          {
              mgmtProcUrl = NodeUrlManager.getDefaultManager().getDeviceUrlByBase(d.getDeviceKey(), NodeUrlTypeManager.getDefaultManager().getUrlTypeByRootName(DeviceUrlNamesIfc.DEVICE_URLTYPE_WEBAGENT));
          }

          if (mgmtProcUrl != null)
          {
              url = mgmtProcUrl.getUrl();
              DebugOutput.log(devicePageDebugLevel,15,"Regular Link for Remote Insight : " + url);
              %>
               <script>
                 document.location.replace("<%= url %>");
               </script>
              <%
          }
          else
          {
              String deviceGuid = d.getGUID().toString();
              devicePageDebugLevel.log(15, "Going to the device page for node with id " + deviceGuid);
              %>
              <script>
                MxPortalWorkspaceCreateUrl("<%= deviceBundle.get("SYSTEM_PAGE") %>", "/mxportal/DevicePage/devicepage.jsp?nodeId=<%= deviceGuid %>");
               </script>
              <%
          }

    } // End try block
    catch (Exception e)
    {
       // WHY??
       System.out.println("Exception occurred" + e);
       e.printStackTrace();
    }
%>

<% MxHtmlUtil.dumpBodyEnd(out); %>
</BODY>
</HTML>
