<%--
//$Source: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/settings/DeviceProtocolSettings.jsp,v $
//$Revision: 1.39.4.2 $
//$Date: 2005/10/14 14:07:48 $
--%>

<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.core.subjects.*" %>
<%@ page import="com.hp.mx.html.core.MxHtmlUtil" %>
<%@ page import="com.hp.mx.portal.settings.DeviceProtocolSettingsBean" %>
<%@ page import="com.hp.mx.portal.ui.*" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="protSetResBndll" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="devProtoSettings" class="com.hp.mx.portal.settings.DeviceProtocolSettingsBean" scope="session" />
<jsp:useBean id="deviceBundle" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="daBean" class="com.hp.mx.portal.device.DeviceAttributesBean" scope="page" />

<%
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    // if the user isn't authorized.
    if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.SECURITY_MODIFICATION_PRIVILEGE))
    { %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
 <% }

    // Initialize daBean & deviceBundle to enable returning back to the systemPage (20050114 enhancement req. rQm243284)
    boolean initSuccess = daBean.initialize(loginBean, Integer.parseInt(request.getParameter("devId")), request.getMethod().equals("POST"));
    deviceBundle.init(loginBean, "MxDeviceBundle");

    String devKey = request.getParameter("devId");

    // setup resources.
    protSetResBndll.init(loginBean, "DeviceProtocolSettings");

    // and my databean -- it'll determine if POST or not
    devProtoSettings.idJSP("fromSystemPage");
    devProtoSettings.initialize(loginBean, protSetResBndll, devKey, request);
    devProtoSettings.clearAllErrorMessages();

    boolean icmpUseValue = true;
    boolean snmpUseValue = true;
    boolean wbemUseValue = true;
    boolean sshUseValue  = true;

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();

    MxTag btnApplyTag = new MxDefaultTag("btnApply", protSetResBndll.getString("protocols.btn.apply"), "");
    btnApplyTag.setAttr(MxTag.TYPE, "submit");
    buttons.addMxTag(btnApplyTag);
 %>

<html>
<head>
     <title><%= protSetResBndll.getString("page.title") %></title>
     <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxPortalApi.js'></script>
     <link type='text/css' rel='stylesheet' href='/mxportal/DevicePage/css/MxDevice.css'>
     <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/devProtocolSettingsUtils.js'></script>
     <script language='javascript' type='text/javascript'>

        ////////////////////////////////////////////////////////////////
        // Set the help page
        ////////////////////////////////////////////////////////////////
        MxPortalWorkspaceSetHelpTopic("admin_protocols_set_singleSys");

        ///////////////////////////////////////////////////////////////////////////// swc 20040426
        // btnsDisabled is used to keep track of state of "schedule" & "run" buttons
        /////////////////////////////////////////////////////////////////////////////
        var btnsDisabled = false;

        /////////////////////////////////////////////////////////////////////////////
        // resource bundle values
        /////////////////////////////////////////////////////////////////////////////
        var radioUseValueLabel   = "<%= protSetResBndll.getString("protocols.radio.useValue")%>&nbsp;";
        var radioUseValueTooltip = "<%= protSetResBndll.getString("protocols.radio.useValueToolTip")%>";
        var radioDefaultLabel    = "<%= protSetResBndll.getString("protocols.radio.default")%>";
        var radioDefaultTooltip  = "<%= protSetResBndll.getString("protocols.radio.defaultToolTip")%>";
        var timeoutStr = "(<%= protSetResBndll.getString("timeout")%> ";
        var secStr     = " <%= protSetResBndll.getString("seconds")%>); ";
        var retriesStr = "(<%= protSetResBndll.getString("retries")%> ";
        var portStr      = "<%= protSetResBndll.getString("portnum")%>";
        var userStr      = "<%= protSetResBndll.getString("username")%> ";
        var pwStr        = "<%= protSetResBndll.getString("password")%>";
        var pwConfirmStr = "<%= protSetResBndll.getString("confirmPW")%>";
        var icmpTitle      = "<%= protSetResBndll.getString("protocols.icmp.title")%>";
        var icmpTimeoutStr = "<%= protSetResBndll.getString("protocols.icmp.timeout")%>";
        var icmpRetriesStr = "<%= protSetResBndll.getString("protocols.icmp.retries")%>";
        var wbemTitle   = "<%= protSetResBndll.getString("protocols.wbem.title")%>";
        var wbemPortStr = "(<%= protSetResBndll.getString("portnum")%> ); (";
        var num1Str = "<%= protSetResBndll.getString("num1")%>";
        var num2Str = "<%= protSetResBndll.getString("num2")%>";
        var num3Str = "<%= protSetResBndll.getString("num3")%>";
        var num4Str = "<%= protSetResBndll.getString("num4")%>";
        var num5Str = "<%= protSetResBndll.getString("num5")%>";
        var snmpTitle      = "<%= protSetResBndll.getString("protocols.snmp.title")%>";
        var snmpTimeoutStr = "<%= protSetResBndll.getString("protocols.snmp.timeout")%>";
        var snmpRetriesStr = "<%= protSetResBndll.getString("protocols.snmp.retries")%>";
        var snmpRdCommStr  = "<%= protSetResBndll.getString("protocols.snmp.commlist")%>";
        var snmpWrCommStr  = "<%= protSetResBndll.getString("protocols.snmp.writecomm")%>";
        var sshTitle                  = "<%= protSetResBndll.getString("protocols.ssh.title")%>";
        var radioNatApplicableLabel   = "<%= protSetResBndll.getString("protocols.radio.notapplicable")%>";
        var radioNatApplicableTooltip = "<%= protSetResBndll.getString("protocols.radio.notapplicableToolTip")%>";
        var identTitle = "<%= protSetResBndll.getString("protocols.id.title")%>";
        var identStr   = "<%=protSetResBndll.getString("protocols.id.runIdentification")%>";
        var setGroupLabel   = "<%= protSetResBndll.getString("setGroup")%>&nbsp;";
        var setGroupTooltip = "<%= protSetResBndll.getString("setGroupToolTip")%>";

        /////////////////////////////////////////////////////////////////////////////
        // error msg values
        /////////////////////////////////////////////////////////////////////////////
        var genProbErr = "<B><font color='red'><%=protSetResBndll.getString("err.genProblem")%></font></B>";
        var selectErr  = "<B><font color='red'><%=protSetResBndll.getString("err.noProtocol")%></font></B>";
        var wbemPortErr  = "<B><font color='red'><<< <%=protSetResBndll.getString("err.portnum")%> <%=protSetResBndll.getString("protocols.error.mustbenumb")%></font></B>";
        var wbemFieldErr = "<B><font color='red'><<< <%=protSetResBndll.getString("protocols.error.wbemfieldsnoblank")%></font></B>";
        var wbemPwErr    = "<B><font color='red'><<< <%=protSetResBndll.getString("err.pwmismatch")%></font></B>";
        var fieldErr = "<B><font color='red'><<< <%=protSetResBndll.getString("protocols.error.fieldsnoblank")%></font></B>";
        var pwErr    = "<B><font color='red'><<< <%=protSetResBndll.getString("err.pwmismatch")%></font></B>";
        var noBlankErr = " <%=protSetResBndll.getString("protocols.error.notblank")%></font></B>";
        var rangeStr   = " <%=protSetResBndll.getString("protocols.error.range")%> ";
        var andStr = " <%=protSetResBndll.getString("protocols.error.rangeand")%> ";
        var genErr = "<%= protSetResBndll.getString("err.general")%> ";
        var icmpTimeoutErr = "<%=protSetResBndll.getString("protocols.error.icmptimeout")%>";
        var icmpTimeoutMin = <%= devProtoSettings.ICMP_TIMEOUT_MIN %>;
        var icmpTimeoutMax = <%= devProtoSettings.ICMP_TIMEOUT_MAX%>;
        var icmpRetriesErr = "<%=protSetResBndll.getString("protocols.error.icmpretries")%>";
        var icmpRetriesMin = <%= devProtoSettings.ICMP_RETRIES_MIN %>;
        var icmpRetriesMax = <%= devProtoSettings.ICMP_RETRIES_MAX%>;
        var snmpTimeoutErr = "<%=protSetResBndll.getString("protocols.error.snmptimeout")%>";
        var snmpTimeoutMin = <%=devProtoSettings.SNMP_TIMEOUT_MIN%>;
        var snmpTimeoutMax = <%=devProtoSettings.SNMP_TIMEOUT_MAX%>;
        var snmpRetriesErr = "<%=protSetResBndll.getString("protocols.error.snmpretries")%>";
        var snmpRetriesMin = <%=devProtoSettings.SNMP_RETRIES_MIN%>;
        var snmpRetriesMax = <%=devProtoSettings.SNMP_RETRIES_MAX%>;

        /////////////////////////////////////////////////////////////////////////////
        // data values
        /////////////////////////////////////////////////////////////////////////////
        var refPw = g("<%=devProtoSettings.getUntouchedPwMarker()%>"); // to facilitate preventing plain-text pw in viewSource
        var setIcmpToggle  = q("<jsp:getProperty name="devProtoSettings" property="icmpEnabledState" />");
        var icmpToggle     = q("<jsp:getProperty name="devProtoSettings" property="icmpUseCustom" />");
        var icmpTimeoutDef = q("<jsp:getProperty name="devProtoSettings" property="icmpTimeOutDefault" />");
        var icmpTimeout    = q("<%=devProtoSettings.getIcmpTimeOut()%>");
        var icmpRetriesDef = q("<jsp:getProperty name="devProtoSettings" property="icmpRetriesDefault" />)");
        var icmpRetries    = q("<jsp:getProperty name="devProtoSettings" property="icmpRetries" />");
        var setWbemToggle = q("<jsp:getProperty name="devProtoSettings" property="wbemEnabledState" />");
        var wbemUserDef   = q("<%=MxHtmlUtil.encodeJScriptSafeEntities(devProtoSettings.getWbemUserDefaults())%>)");
        var wbemToggle   = q("<jsp:getProperty name="devProtoSettings" property="wbemUseCustom" />");
        var wbemPort0    = q("<%=MxHtmlUtil.encodeJScriptSafeEntities(devProtoSettings.getWbemPort(0))%>");
        var wbemUser0    = q("<%=MxHtmlUtil.encodeJScriptSafeEntities(devProtoSettings.getWbemUser(0))%>");
        if ("" == wbemUser0)
        {
            var wbemPw0 = "";
        }
        else
        {
            var wbemPw0 = refPw; // to facilitate preventing plain-text pw in viewSource
        }
        var wbemPort1    = q("<%=MxHtmlUtil.encodeJScriptSafeEntities(devProtoSettings.getWbemPort(1))%>");
        var wbemUser1    = q("<%=MxHtmlUtil.encodeJScriptSafeEntities(devProtoSettings.getWbemUser(1))%>");
        if ("" == wbemUser1)
        {
            var wbemPw1 = "";
        }
        else
        {
            var wbemPw1 = refPw; // to facilitate preventing plain-text pw in viewSource
        }
        var wbemPort2    = q("<%=MxHtmlUtil.encodeJScriptSafeEntities(devProtoSettings.getWbemPort(2))%>");
        var wbemUser2    = q("<%=MxHtmlUtil.encodeJScriptSafeEntities(devProtoSettings.getWbemUser(2))%>");
        if ("" == wbemUser2)
        {
            var wbemPw2 = "";
        }
        else
        {
            var wbemPw2 = refPw; // to facilitate preventing plain-text pw in viewSource
        }
        var wbemPort3    = q("<%=MxHtmlUtil.encodeJScriptSafeEntities(devProtoSettings.getWbemPort(3))%>");
        var wbemUser3    = q("<%=MxHtmlUtil.encodeJScriptSafeEntities(devProtoSettings.getWbemUser(3))%>");
        if ("" == wbemUser3)
        {
            var wbemPw3 = "";
        }
        else
        {
            var wbemPw3 = refPw; // to facilitate preventing plain-text pw in viewSource
        }
        var wbemPort4    = q("<%=MxHtmlUtil.encodeJScriptSafeEntities(devProtoSettings.getWbemPort(4))%>");
        var wbemUser4    = q("<%=MxHtmlUtil.encodeJScriptSafeEntities(devProtoSettings.getWbemUser(4))%>");
        if ("" == wbemUser4)
        {
            var wbemPw4 = "";
        }
        else
        {
            var wbemPw4 = refPw; // to facilitate preventing plain-text pw in viewSource
        }
        var setSnmpToggle  = q("<jsp:getProperty name="devProtoSettings" property="snmpEnabledState" />");
        var snmpToggle     = q("<jsp:getProperty name="devProtoSettings" property="snmpUseCustom" />");
        var snmpTimeoutDef = q("<jsp:getProperty name="devProtoSettings" property="snmpTimeOutDefault" />");
        var snmpTimeout    = q("<jsp:getProperty name="devProtoSettings" property="snmpTimeOut" />");
        var snmpRetriesDef = q("<jsp:getProperty name="devProtoSettings" property="snmpRetriesDefault" />);");
        var snmpRetries    = q("<jsp:getProperty name="devProtoSettings" property="snmpRetries" />");
        var snmpRdCommDef  = q("(<%= protSetResBndll.getString("protocols.snmp.commlist")%> <%=MxHtmlUtil.encodeJScriptSafeEntities(devProtoSettings.getSnmpReadCommStringDefaults())%>); ");
        var snmpRdComm     = q("<%=MxHtmlUtil.encodeJScriptSafeEntities(devProtoSettings.getSnmpReadCommString())%>");
        var snmpWrCommDef  = q("(<%= protSetResBndll.getString("protocols.snmp.writecomm")%> <%=MxHtmlUtil.encodeJScriptSafeEntities(devProtoSettings.getSnmpWriteCommStringDefault())%>)");
        var snmpWrComm     = q("<%=MxHtmlUtil.encodeJScriptSafeEntities(devProtoSettings.getSnmpWriteCommString())%>");
        var setSshToggle = q("<jsp:getProperty name="devProtoSettings" property="sshEnabledState" />");
        var sshToggle    = q("<jsp:getProperty name="devProtoSettings" property="sshUseCustom" />");
        var sshUser      = q("<%=MxHtmlUtil.encodeJScriptSafeEntities(devProtoSettings.getSshUser())%>");
        if ("" == sshUser)
        {
            var sshPw = "";
        }
        else
        {
            var sshPw = refPw; // to facilitate preventing plain-text pw in viewSource
        }
        var setIdentToggle = q("<jsp:getProperty name="devProtoSettings" property="runIdentification" />");

        ////////////////////////////////////////////////////////////////////////
        // disableBtns()
        // -- disables the "schedule" & "run" buttons
        ////////////////////////////////////////////////////////////////////////
        function disableBtns(errMsg)
        {
            document.getElementById("OVERALL_ERR_MSG").innerHTML = errMsg;
            ourButtonManager.disableButtonById('btnApply');
            btnsDisabled = true;
            return true; // for problems
        }

        ////////////////////////////////////////////////////////////////////////
        // enableBtns()
        // -- enables the "schedule" & "run" buttons
        ////////////////////////////////////////////////////////////////////////
        function enableBtns()
        {
            document.getElementById("OVERALL_ERR_MSG").innerHTML = "";
            ourButtonManager.enableButtonById('btnApply');
            btnsDisabled = false;
        }

        ////////////////////////////////////////////////////////////////////////
        // updateDatabean()
        ////////////////////////////////////////////////////////////////////////
        function updateDatabean()
        {
            <jsp:setProperty name="devProtoSettings" property="untouchedPwMarker"/> // to ensure that this is always set before any PW values that ref it
            <jsp:setProperty name="devProtoSettings" property="*"/>

            // uncomment the next statement if it is desired to return to the System Page Links Tab right away when all input are valid ..
            returnToSystemPageLinksTab();
        }

        /////////////////////////////////////////////////////////
        // returnToSystemPageLinksTab()
        /////////////////////////////////////////////////////////
        function returnToSystemPageLinksTab()
        {
            MxPortalWorkspaceCreateUrl("<%=deviceBundle.get("SYSTEM_PAGE")%>", "../DevicePage/devicepage.jsp?nodeId=<%=daBean.getNodeGuid()%>&selection=ID_LINKS&index=1");
        } // end of returnToSystemPageLinksTab()

    </script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxPortalRender.dumpHeadContent(out); %>
<% buttons.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</head>

<body onload="setParameters()">

    <jsp:setProperty name="daBean" property="*" />

    <jsp:setProperty name="devProtoSettings" property="untouchedPwMarker"/>
    <jsp:setProperty name='devProtoSettings' property='*' />
    <%=devProtoSettings.getPropertyStatusMsg() %>

  <form METHOD="post" ACTION="" onSubmit=" return validateProtocols(this)" id=form1 name=form1>
   <!-- return to the SystemPage Links Tab (20050114 enhancement req. rQm243284) -->
   <%= protSetResBndll.getString("returnto")%><a href='javascript:returnToSystemPageLinksTab()'>&nbsp;<%=deviceBundle.get("SYSTEM_PAGE")%></a>
   <!-- -->
   <jsp:include page="DeviceProtocolSettingsForm.jsp" flush="true"/>
   <!-- return to the SystemPage Links Tab (20050114 enhancement req. rQm243284) -->
   <%= protSetResBndll.getString("returnto")%><a href='javascript:returnToSystemPageLinksTab()'>&nbsp;<%=deviceBundle.get("SYSTEM_PAGE")%></a>

<div style="margin-top:15px" class=sizeTen>
    <% buttons.dumpButtons(out); %>
        <!-- removed "cancel" button per rQm242468 -->
</div>

</form>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</body>
</html>
