<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.MxLoginBean" %>
<%@ page import="com.hp.mx.portal.ui.MxOptions" %>
<%@ page import="com.hp.mx.portal.ui.MxBean" %>
<%@ page import="com.hp.mx.portal.ui.MxDateAndTime" %>
<%@ page import="com.hp.mx.html.table.MxTableSortingModel" %>
<%@ page import="com.hp.mx.core.subjects.usermanager.MxUser" %>
<%@ page import="com.hp.mx.core.subjects.MxSubjectPrivilege" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="rbsettings" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="groupUI" class="com.hp.mx.portal.settings.MxGroupUI" scope="session" />
<jsp:useBean id="authUI" class="com.hp.mx.portal.settings.MxAuthUI" scope="session" />
<jsp:useBean id="authGroupReportTableModel" class="com.hp.mx.portal.settings.MxAuthTableModel" scope="session" />
<jsp:useBean id="authGroupReportTableView" class="com.hp.mx.html.table.MxTableView2" scope="session" />
<jsp:useBean id="authTableGroupReportController" class="com.hp.mx.html.table.MxTableController" scope="session" />
<jsp:useBean id="authGroupReportSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session" />

<%  // Set Necessary HTTP header attributes (for localization and caching)
    MxBean.jspInit(request, response);
    if(loginBean.checkLogoutConditionForWebPage(pageContext))
        return;
%>
<%  if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.TOOL_AUTHORIZATION_PRIVILEGE))
    { %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
<%  } %>
<%
    String allGroups     = request.getParameter("allGroups");
    String selectedGroup = request.getParameter("selectedGroup");
    String printable     = request.getParameter("printable");
    boolean reportAll    = false;
    if( ( allGroups != null && allGroups.equals("true") ) ||
        ( selectedGroup != null && selectedGroup.equals("none") ) )
    {
        reportAll = true;
    }

    rbsettings.init(loginBean, "MxSettings");
%>
<%
    if ( authTableGroupReportController.isFirstTime() )
    {
        authGroupReportTableView.setId("ID_AUTH_GROUP_REPORT_TABLE");
        authGroupReportTableView.setUrlHandler(request.getRequestURI());
        authTableGroupReportController.setTableModelWithSorting(authGroupReportTableModel);
        authTableGroupReportController.setTableView(authGroupReportTableView);
    }
    if ( authTableGroupReportController.checkUrlForControllerMessages(request, out) )
    {
        return;
    }
    // Get the date and time when report is generated.
    MxDateAndTime currentTime = new MxDateAndTime( loginBean.getLocale(),
                                                   loginBean.getTimeZone()
                                                 );
    String currentTimeOfDay = currentTime.getCurrentDateTimeFormatString(
                                          MxDateAndTime.DATE_TIME_FULL_FORMAT);
    // Load the table
    authGroupReportTableModel.setAddUrlHref(false);
    if (reportAll)
    {
        authGroupReportTableModel.loadAllNodeGroupAuths(loginBean,rbsettings);
    }
    else
    {
        authGroupReportTableModel.loadNodeGroupAuths(selectedGroup,loginBean,rbsettings);
    }
    MxTableSortingModel sortable = authTableGroupReportController.getSortingModelOrNull();
    if (null != sortable)
    {
        // Sort on the system groups (third column)
        sortable.sortTable(2,true);
    }

    if (printable == null)
    {
        authGroupReportTableView.setHeight("150px");
        authGroupReportTableView.setWidth("600px");
    }
    else
    {
        authGroupReportTableView.setHeight(null);
        authGroupReportTableView.setWidth(null);
    }

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();
    buttons.addMxTag(new MxDefaultTag("B6", rbsettings.getString("button.viewprintable") + "...", "openPrintable()"));
%>
<html>

<head>
<title><%=rbsettings.getString("auth.report")%></title>
<link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
<link type='text/css' rel='stylesheet' href='css/MxAuth.css'>
<script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
<script src="/SessionReset.js" language="JavaScript" type="text/javascript"></script>
<script language="JAVASCRIPT">
MxPortalWorkspaceSetHelpTopic("admin_auth_reportAuth");

function loadAllTable()
{
    document.location.replace("ReportGroupAuth.jsp?allGroups=true&selectedGroup=<%=selectedGroup%>");
}

function loadGroupTable()
{
    document.location.replace("ReportGroupAuth.jsp?selectedGroup=<%=selectedGroup%>");
}

function openPrintable()
{
    var url;
    if(document.authForm.reportoption[0].checked == true)
    {
      url = "ReportGroupAuth.jsp?printable=yes&allGroups=true&selectedGroup=<%=selectedGroup%>";
    }
    else
    {
      url = "ReportGroupAuth.jsp?printable=yes&selectedGroup=<%=selectedGroup%>";
    }
    reportWindow = window.open(url, "groupAuthReport", "menubar=1, titlebar=1, toolbar=1, scrollbars=1, resizable=1");
    reportWindow.focus();
}

</script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% buttons.dumpHeadContent(out); %>
<% authGroupReportTableView.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</head>

<body>

<form method="POST" action="AuthServer.jsp" name="authForm">
<%  if (printable == null)
    {
%>
    <hr>
    <table border="0" width="100%" cellpadding=0>
<%
    }
    else
    {
%>
    <table border="0" cellpadding=0>
    <tr><td align="right">
        <br><br>
    </td></tr>
<%
    }
%>
    <tr>
    <td><font class="subwindow-header"><%=rbsettings.getString("auth.report")%>
<%  if (printable != null)
    {
        if (reportAll)
        {
%>
        <%=rbsettings.getString("authgroup.reportforall")%></td>
<%
        }
        else
        {
%>
        <%=rbsettings.getString("authgroup.reportforone")%> &quot;<%=groupUI.nameForID(loginBean,selectedGroup) %>&quot;</td>
<%
        }
    }
%>
    </font>

<%  if (printable != null)
    {
%>
    </tr><tr><td align="left"><br>
<%
    }
    else
    {
%>
    <td align="right">
<%
    }
    out.print( "<font class='section-header'>" );
    out.print( rbsettings.getString("auth.report.asof") );
    out.print( "</font> " );
    out.println( currentTimeOfDay );
%>
    </td>
    </tr>
    </table>
    <br>
<%  if (printable == null)
    {
%>
    <table border="0" width="100%" cellpadding=0>
      <tr>
        <td valign="middle" align="left" width="20%"><%=rbsettings.getString("auth.for")%></td>
        <td align="left" width="80%">
<%      if (reportAll)
        {
%>
             <input type="radio" name="reportoption" value="V1" onClick="loadAllTable()" checked><%=rbsettings.getString("authgroup.reportall")%></td>
<%      }
        else
        {
%>
             <input type="radio" name="reportoption" value="V1" onClick="loadAllTable()"><%=rbsettings.getString("authgroup.reportall")%></td>
<%
        }
%>
      </tr>
      <tr>
        <td></td>
        <td>
<%      if (reportAll)
        {
%>
             <input type="radio" name="reportoption" value="V2" onClick="loadGroupTable()"><%=rbsettings.getString("authgroup.reportone")%> &quot;<%=groupUI.nameForID(loginBean, selectedGroup) %>&quot;</td>
<%      }
        else
        {
%>
             <input type="radio" name="reportoption" value="V2" onClick="loadGroupTable()" checked><%=rbsettings.getString("authgroup.reportone")%> &quot;<%=groupUI.nameForID(loginBean, selectedGroup) %>&quot;</td>
<%
        }
%>
        <td>
        </td>
      </tr>
    </table>
    <br>
<%
    }
    if (authGroupReportTableModel.getRowCount() > 0)
    {
%>
    <div id="reportTable">
    <% authGroupReportTableView.dumpTableVisiblePart(out); %>
    </div>
<%  }
    else
    {
%>
    <div id="reportTable" align="center" style="width=600px;height=150px">
    <br><br><br><b><%=rbsettings.getString("auth.no.auths.match")%></b><br>
    </div>
<%  }
    if (printable == null)
    {
%>
    <hr>
    <div style="margin-top:15px">
        <% buttons.dumpButtons(out); %>
    </div>
<%
    }
%>

</form>
<% authGroupReportTableView.dumpTableHiddenPart(out); %>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</body>

</html>
