<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.MxLoginBean" %>
<%@ page import="com.hp.mx.portal.ui.MxOptions" %>
<%@ page import="com.hp.mx.portal.ui.MxBean" %>
<%@ page import="com.hp.mx.portal.ui.MxDateAndTime" %>
<%@ page import="com.hp.mx.html.table.MxTableSortingModel" %>
<%@ page import="com.hp.mx.core.subjects.usermanager.MxUser" %>
<%@ page import="com.hp.mx.core.subjects.MxSubjectPrivilege" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="rbsettings" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="userUI" class="com.hp.mx.portal.settings.MxUserUI" scope="session" />
<jsp:useBean id="authUI" class="com.hp.mx.portal.settings.MxAuthUI" scope="session" />
<jsp:useBean id="authUserReportTableModel" class="com.hp.mx.portal.settings.MxAuthTableModel" scope="session" />
<jsp:useBean id="authUserReportTableView" class="com.hp.mx.html.table.MxTableView2" scope="session" />
<jsp:useBean id="authTableUserReportController" class="com.hp.mx.html.table.MxTableController" scope="session" />
<jsp:useBean id="authUserReportSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session" />

<%  // Set Necessary HTTP header attributes (for localization and caching)
    MxBean.jspInit(request, response);
    if(loginBean.checkLogoutConditionForWebPage(pageContext))
        return;
%>
<%  if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.TOOL_AUTHORIZATION_PRIVILEGE))
    { %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
<%  } %>
<%
    String allUsers     = request.getParameter("allUsers");
    String selectedUser = request.getParameter("selectedUser");
    String printable    = request.getParameter("printable");
    String userGroup    = request.getParameter("userGroup");
    boolean reportAll   = false;
    if( ( allUsers != null && allUsers.equals("true") ) ||
        ( selectedUser != null && selectedUser.equals("none") ) )
    {
        reportAll = true;
    }
    boolean isUserGroup = false;
    if ( (userGroup!=null) && userGroup.equals("true") )
        isUserGroup = true;

    rbsettings.init(loginBean, "MxSettings");
%>
<%
    if ( authTableUserReportController.isFirstTime() )
    {
        authUserReportTableView.setId("ID_AUTH_USER_REPORT_TABLE");
        authUserReportTableView.setUrlHandler(request.getRequestURI());
        authTableUserReportController.setTableModelWithSorting(authUserReportTableModel);
        authTableUserReportController.setTableView(authUserReportTableView);
    }
    if ( authTableUserReportController.checkUrlForControllerMessages(request, out) )
    {
        return;
    }
    // Get the date and time when report is generated.
    MxDateAndTime currentTime = new MxDateAndTime( loginBean.getLocale(),
                                                   loginBean.getTimeZone()
                                                 );
    String currentTimeOfDay = currentTime.getCurrentDateTimeFormatString(
                                          MxDateAndTime.DATE_TIME_FULL_FORMAT);
    // Load the table
    authUserReportTableModel.setAddUrlHref(false);
    if (reportAll)
    {
        authUserReportTableModel.loadAllAuths(loginBean,rbsettings);
    }
    else
    {
        authUserReportTableModel.loadUserAuths(selectedUser,loginBean,rbsettings);
    }
    MxTableSortingModel sortable = authTableUserReportController.getSortingModelOrNull();
    if (null != sortable)
    {
        // Sort on the users (first column)
        sortable.sortTable(0,true);
    }

    if (printable == null)
    {
        authUserReportTableView.setHeight("150px");
        authUserReportTableView.setWidth("600px");
    }
    else
    {
        authUserReportTableView.setHeight(null);
        authUserReportTableView.setWidth(null);
    }

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();
    buttons.addMxTag(new MxDefaultTag("B6", rbsettings.getString("button.viewprintable") + "...", "openPrintable()"));
%>
<html>

<head>
<title><%=rbsettings.getString("authuser.reporttitle")%></title>
<link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
<link type='text/css' rel='stylesheet' href='css/MxAuth.css'>
<script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
<script src="/SessionReset.js" language="JavaScript" type="text/javascript"></script>
<script language="JAVASCRIPT">
MxPortalWorkspaceSetHelpTopic("admin_auth_reportAuth");

function loadAllTable()
{
    document.location.replace("ReportUserAuth.jsp?allUsers=true&selectedUser=<%=selectedUser%>");
}

function loadUserTable()
{
    document.location.replace("ReportUserAuth.jsp?selectedUser=<%=selectedUser%>");
}

function openPrintable()
{
    var url;
    if(document.authForm.reportoption[0].checked == true)
    {
      url = "ReportUserAuth.jsp?printable=yes&allUsers=true&selectedUser=<%=selectedUser%>";
    }
    else
    {
      url = "ReportUserAuth.jsp?printable='yes'&selectedUser=<%=selectedUser%>";
    }
    reportWindow = window.open(url, "userAuthReport", "menubar=1, titlebar=1, toolbar=1, scrollbars=1, resizable=1");
    reportWindow.focus();
}

</script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% buttons.dumpHeadContent(out); %>
<% authUserReportTableView.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</head>

<body>

<form method="POST" action="AuthServer.jsp" name="authForm">
<%  if (printable == null)
    {
%>
    <hr>
    <table border="0" width="100%" cellpadding=0>
<%
    }
    else
    {
%>
    <table border="0" cellpadding=0>
    <tr><td align="right">
        &nbsp;<br><br>
    </td></tr>
<%
    }
%>

    <tr>
    <td><font class="subwindow-header"><%=rbsettings.getString("authuser.reporttitle")%>
<%  if (printable != null)
    {
        if (reportAll)
        {
            if (isUserGroup)
            {
%>
        <%=rbsettings.getString("authusergroup.reportforall")%>
<%
            }
            else
            {
%>
        <%=rbsettings.getString("authuser.reportforall")%>
<%
            }
        }
        else // report for single user or group
        {
            if (isUserGroup)
            {
%>
        <%=rbsettings.getString("authusergroup.reportforone")%> &quot;<%=userUI.nameForID(loginBean,selectedUser,isUserGroup) %>&quot;
<%
            }
            else
            {
%>
        <%=rbsettings.getString("authuser.reportforone")%> &quot;<%=userUI.nameForID(loginBean,selectedUser) %>&quot;
<%
            }
        }
    }
%>
    </font></td>

<%  if (printable != null)
    {
%>
    </tr><tr><td align="left"><br>
<%
    }
    else
    {
%>
    <td align="right">
<%
    }
    out.print( "<font class='section-header'>" );
    out.print( rbsettings.getString("auth.report.asof") );
    out.print( "</font> " );
    out.println( currentTimeOfDay );
%>
    </td>
    </tr>
    </table>
    <br>
<%  if (printable == null)
    {
%>
    <table border="0" width="100%" cellpadding=0>
      <tr>
        <td valign="middle" align="left" width="20%"><%=rbsettings.getString("auth.for")%></td>
        <td align="left" width="80%">
<%      if (reportAll)
        {
%>
             <input type="radio" name="reportoption" value="V1" onClick="loadAllTable()" checked><%=rbsettings.getString("authuser.reportall")%></td>
<%      }
        else
        {
%>
             <input type="radio" name="reportoption" value="V1" onClick="loadAllTable()"><%=rbsettings.getString("authuser.reportall")%></td>
<%
        }
%>
      </tr>
      <tr>
        <td></td>
        <td>
<%      if (reportAll)
        {
%>
             <input type="radio" name="reportoption" value="V2" onClick="loadUserTable()"><%=rbsettings.getString("authuser.reportone")%> &quot;<%=userUI.nameForID(loginBean,selectedUser,isUserGroup) %>&quot;</td>
<%      }
        else
        {
%>
             <input type="radio" name="reportoption" value="V2" onClick="loadUserTable()" checked><%=rbsettings.getString("authuser.reportone")%> &quot;<%=userUI.nameForID(loginBean,selectedUser,isUserGroup) %>&quot;</td>
<%
        }
%>
        <td>
        </td>
      </tr>
    </table>
    <br>
<%
    }
    if (authUserReportTableModel.getRowCount() > 0)
    {
%>
    <div id="reportTable">
    <% authUserReportTableView.dumpTableVisiblePart(out); %>
    </div>
<%  }
    else
    {
%>
    <div id="reportTable" align="center" style="width=600px;height=150px">
    <br><br><br><b><%=rbsettings.getString("auth.no.auths.match")%></b><br>
    </div>
<%  }
    if (printable == null)
    {
%>
    <hr>
    <div style="margin-top:15px">
        <% buttons.dumpButtons(out); %>
    </div>
<%
    }
%>

</form>
<% authUserReportTableView.dumpTableHiddenPart(out); %>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</body>

</html>
