<%@ page import="java.util.*" %>
<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.core.subjects.*" %>

<%@ page import="com.hp.mx.portal.settings.StatusChangeSettingsBean" %>
<%@ page import="com.hp.mx.portal.ui.*" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="statusChangeResBndl" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="statusSettings" class="com.hp.mx.portal.settings.StatusChangeSettingsBean"  />

<%
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    //
    // if the user isn't authorized.
    if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.NOTIFICATION_SETTINGS_MODIFICATION_PRIVILEGE ))
    { %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" />
 <% }

    // setup resources.
    statusChangeResBndl.init(loginBean, "StatusChangeSettings");

    // and my bean
    statusSettings.initialize(loginBean, statusChangeResBndl);

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();
    buttons.addMxTag(new MxDefaultTag("btnApply", statusChangeResBndl.getString("btn.apply"), "submitForm()"));;

    %>
<html>
    <head>
        <script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>

        <script language='javascript' type='text/javascript'>
        MxPortalWorkspaceSetHelpTopic("admin_events_statusChange");

        function setChecksState()
        {
            if (document.form1.cbEnableStatusChange.checked == false)
            {
                document.form1.cbEnableStatusClear.disabled = true;
            }
            else
            {
                document.form1.cbEnableStatusClear.disabled = false;
            }
        }

        function submitForm()
        {
            document.getElementById('form1').submit();
        }

        </script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxPortalRender.dumpHeadContent(out); %>
<% buttons.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

    </head>

    <body onLoad="setChecksState()">

        <jsp:setProperty name="statusSettings" property="*" />

        <jsp:getProperty name="statusSettings" property="propertyStatusMsg" />
        <br>

        <form METHOD="post" ACTION="StatusChangeSettings.jsp"  id=form1 name=form1>
        <div style="margin-left:12px">
           <input type="checkbox" id="cbEnableStatusChange"  name="statChangeEnabledState" value="true" onClick="setChecksState()"
                <jsp:getProperty name="statusSettings" property="statChangeEnabledState" /> >
                <LABEL for="cbEnableStatusChange"><%= statusChangeResBndl.getString("enableStatusChangeEvents")%></LABEL><br>
           <div style="margin-left:24px">
           <input type="checkbox" id="cbEnableStatusClear"  name="statClearEnabledState" value="true"
                <jsp:getProperty name="statusSettings" property="statClearEnabledState" /> >
                <LABEL for="cbEnableStatusClear"><%= statusChangeResBndl.getString("enableStatusClearEvents")%></LABEL><br>
           </div>
        </div>

        <input type="hidden" name="postSent" value="yes" >

        <!-- BUTTONS -->
        <div style="margin-top:15px">
            <% buttons.dumpButtons(out); %>
        </div>

    </form>

<% MxHtmlUtil.dumpBodyEnd(out); %>

  </body>
</html>

