<%@ page import="com.hp.mx.html.core.*" %>
<%@page import="com.hp.mx.core.subjects.*"%>
<%@page import="com.hp.mx.portal.ui.*"%>
<%@page import="com.hp.mx.database.GlobalSettings"%>
<%@page import="java.util.*"%>
<%@page import="java.net.*"%>

<jsp:useBean id="ftwUIbean" scope="session" class="com.hp.mx.portal.settings.FirstTimeWizardUIBean" />
<jsp:useBean id="ftwConfigNotiSettingsBean" scope="session" class="com.hp.mx.portal.settings.ConfigNotificationSettings" />
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<%

    // REQUIRED: This line is required by Tomcat for i18n support.
    MxBean.jspInit(request, response);

    ftwUIbean.getResBundles(loginBean);
    ftwConfigNotiSettingsBean.initBean(out, loginBean);


    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
    {
        return;
    }

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();
    MxTag btnBackTag = new MxDefaultTag("btnBack", ftwUIbean.getResString("BUTTON_PREV_LABEL"), "prevPage()");
    MxTag btnNextTag = new MxDefaultTag("btnNext", ftwUIbean.getResString("BUTTON_NEXT_LABEL"), "nextPage()");
    buttons.addMxTag(btnBackTag);
    buttons.addMxTag(btnNextTag);

%>


<HTML>
<HEAD>
    <meta http-equiv="content-type" content="text/html; charset=UTF-8">
    <TITLE>
        <%=ftwUIbean.getResString("EMAIL_LABEL")%>
    </TITLE>
    <LINK type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
    <LINK type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/actiononevents/css/ActionOnEvents.css'>
    <SCRIPT src="/mxportal/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></SCRIPT>
    <SCRIPT>MxPortalWorkspaceSetHelpTopic("admin_events_emailSettings")</SCRIPT>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% buttons.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

    <SCRIPT language="javascript">
    function thisPageOnLoad()
    {
        document.location="#SMTP_PAGE_TOP";
        togglePasswordFields();
    }

    function togglePasswordFields()
    {
        var bRequiresAuth = false;
        bRequiresAuth = document.getElementById("svrRequiresAuth").checked;

        if (bRequiresAuth)
        {
            document.getElementById("lblLogin").disabled = false;
            document.getElementById("lblPassword").disabled = false;
            document.getElementById("lblSecureAuth").disabled = false;

            document.getElementById("emailLogin").disabled = false;
            document.getElementById("emailPassword").disabled = false;
            document.getElementById("useSecurePwdAuth").disabled = false;
        }
        else
        {
            document.getElementById("emailLogin").value = "";
            document.getElementById("emailPassword").value = "";
            document.getElementById("useSecurePwdAuth").checked = false;

            document.getElementById("lblLogin").disabled = true;
            document.getElementById("lblPassword").disabled = true;
            document.getElementById("lblSecureAuth").disabled = true;

            document.getElementById("emailLogin").disabled = true;
            document.getElementById("emailPassword").disabled = true;
            document.getElementById("useSecurePwdAuth").disabled = true;
        }
    }

    </SCRIPT>

</HEAD>
<BODY LEFTMARGIN=0 onload="thisPageOnLoad()">

<%

    ///////////////////////////////////////////////////////////////////////////
    // IS THIS A REQUEST FROM THE SAME EMAIL PAGE?
    ///////////////////////////////////////////////////////////////////////////
    String referer = request.getHeader("referer");
    String emailHostName = "";
    String emailFromAddress  = "";
    boolean goNextPage = true;

    if (referer.indexOf(ftwUIbean.getResString("EMAIL_PAGE_URL")) != -1)
    {
         //clear EMAIL variables
        ftwUIbean.setEmailHostName("");
        ftwUIbean.setEmailFromAddress("");
        ftwUIbean.setSvrRequiresAuth("false");
        ftwUIbean.setEmailLogin("");
        ftwUIbean.setEmailPassword("");

        %>
        <jsp:setProperty name="ftwUIbean" property="*"/>
        <%

       if (null != request.getParameter("emailHostName"))
        {
            emailHostName = request.getParameter("emailHostName");
            if (emailHostName.length()>0)
            {
               try
               {
                   InetAddress [] ips = InetAddress.getAllByName(emailHostName);

                   for (int i=0; i < ips.length; i++)
                   {
                       String name = ips[i].getCanonicalHostName();
                       if (name.toUpperCase().startsWith(emailHostName.toUpperCase()))
                       {
                           emailHostName = name;
                       }
                   }
               }
               catch (Throwable t)
               {
                   goNextPage=false;
                   ftwConfigNotiSettingsBean.alert(out, ftwConfigNotiSettingsBean.getResString("MSG_INVALID_HOST"));
               }
            }
        }
        if ((goNextPage==true) && (null != request.getParameter("emailFromAddress")))
        {
            emailFromAddress = request.getParameter("emailFromAddress");
            if (emailFromAddress.length()>0)
            {
               if (!emailFromAddress.matches(".+@.+"))
               {
                   ftwConfigNotiSettingsBean.alert(out, ftwConfigNotiSettingsBean.getResString("MSG_INVALID_EMAIL_ADDRESS"));
                   goNextPage=false;
               }
            }
        }

        //valid hostname and email, so go to next page by changing location.ref.
        if (goNextPage==true)
        {
        %>
            <script language='JavaScript' type='text/javascript'>
            location.href="<%=ftwUIbean.getResString("EVENTS_PAGE_URL")%>";
            </script>
            </body>
            return;
        <%
        }
    }
%>


<A NAME="NAME_PAGE_TOP"></A>

<FORM action="ftw_Email.jsp" ID="frmNotification" NAME="frmNotification" METHOD="POST" width="100%">
    <TABLE width='100%' border='0' cellspacing='0' cellpadding='0'>
    <TR valign='top'>
        <TD>
            <%int currentTab = 6;%>
            <%@include file="FirstTimeWizard_DrawTabs.txt"%>
        </TD>
        <TD style='padding-left:12px;' align='left' width='100%'>
            <TABLE  class="top-border-table" WIDTH="100%">
            <TR><TD>
                <FONT class="mxPageSubTitle">
                   <%=ftwUIbean.getResString("EMAIL_LABEL")%>
                </FONT>
                <br>
                <%=ftwUIbean.getResString("EMAIL_LINK")%>
                <p>
                <%=ftwUIbean.getResString("EMAIL_MAIN_TEXT")%>
                <p>
                <TABLE cellSpacing=1 cellPadding=0>
                <TR>
                    <TD noWrap><%=ftwConfigNotiSettingsBean.getResString("LBL_SMTP_HOST")%>:&nbsp;</TD>
                    <TD noWrap>
                        <INPUT  id="emailHostName"
                                name="emailHostName"
                                size=35
                                value="<%=ftwUIbean.getEmailHostName()%>">
                    </TD>
                </TR>
                <TR>
                    <TD noWrap><%=ftwConfigNotiSettingsBean.getResString("LBL_MGMT_SERVER_EMAIL")%>:</TD>
                    <TD noWrap>
                        <INPUT  id="emailFromAddress"
                                name="emailFromAddress"
                                size=35
                                value="<%=ftwUIbean.getEmailFromAddress()%>">
                   </TD>
                </TR>
                </TABLE>
                <br>
                <table style="margin:0px;border:0px;padding:0px">
                    <TR>
                        <TD noWrap><%=ftwConfigNotiSettingsBean.getResString("LBL_SERVER_REQUIRES_AUTH")%>:
                        </TD>
                        <TD noWrap>
                            <%
                            if (ftwUIbean.getSvrRequiresAuth().equalsIgnoreCase("true"))
                            {
                                %>
                                <INPUT  checked type=checkbox id="svrRequiresAuth"
                                <%
                            }
                            else
                            {
                                %>
                                <INPUT  type=checkbox id="svrRequiresAuth"
                                <%
                            }
                            %>
                                name="svrRequiresAuth" value="true"
                                onclick="togglePasswordFields()"
                                >
                        </TD>
                    </TR>
                </table>
                <blockquote>
                    <table style="margin:0px;border:0px;padding:0px">
                        <tr>
                            <TD id="lblLogin" noWrap><%=ftwConfigNotiSettingsBean.getResString("LBL_EMAIL_AUTH_ACCOUNT_NAME")%>:
                            </TD>
                            <TD noWrap>
                                <INPUT  id="emailLogin"
                                        name="emailLogin"
                                        size=35
                                        value="<%=ftwUIbean.getEmailLogin()%>">
                            </TD>
                        </TR>
                        <TR>
                            <TD id="lblPassword" noWrap><%=ftwConfigNotiSettingsBean.getResString("LBL_EMAIL_AUTH_PASSWORD")%>:
                            </TD>
                            <TD noWrap>
                                <INPUT  id="emailPassword"
                                        name="emailPassword"
                                        type="password"
                                        size=35
                                        value="<%=ftwUIbean.getEmailPassword()%>">
                            </TD>
                        </TR>
                    </table>
                    <table>
                        <TR>
                            <TD id="lblSecureAuth" style="visibility:hidden" noWrap><%=ftwConfigNotiSettingsBean.getResString("LBL_USE_SECURE_PWD_AUTH")%>:</TD>
                            <TD noWrap>
                                <INPUT  style="visibility:hidden"
                                        type=checkbox
                                        id="useSecurePwdAuth"
                                        name="useSecurePwdAuth"
                                        value="<%=ftwUIbean.getUseSecurePwdAuth()%>">
                            </TD>
                        </TR>
                    </table>
                </blockquote>
            </TD></TR>
            </TABLE>
        </TD>
    </TR>
    </TABLE>
    <!-- End Data -->

    <SCRIPT>
    function validateAll()
    {
        var mailHost = document.getElementById('emailHostName').value;
        var mailFrom = document.getElementById('emailFromAddress').value;
        var emailLogin = document.getElementById('emailLogin').value;
        var emailPassword = document.getElementById('emailPassword').value;
        var svrRequiresAuth = document.getElementById("svrRequiresAuth").checked;

        mailHost = mailHost.replace(/^\s*/, '').replace(/\s*$/, ''); // trim string
        mailFrom = mailFrom.replace(/^\s*/, '').replace(/\s*$/, ''); // trim string

        if ( 0 == mailHost.length )
        {
            return confirm("<%=ftwUIbean.getResString("MSG_EMAIL_INVALID_SMTP_HOST")%>");
        }

        if ( 0 == mailFrom.length )
        {
            return confirm("<%=ftwUIbean.getResString("MSG_EMAIL_INVALID_SENDER")%>");
        }

        if ( -1 == mailFrom.indexOf("@") )
        {
            alert( "<%=ftwConfigNotiSettingsBean.getResString("MSG_INVALID_EMAIL_ADDRESS")%>" );
            return false;
        }

        if (svrRequiresAuth)
        {
            if ( 0 == emailLogin.length )
            {
                alert( "<%=ftwConfigNotiSettingsBean.getResString("MSG_INVALID_EMAIL_LOGIN")%>" );
                return false;
            }
            if ( 0 == emailPassword.length )
            {
                alert( "<%=ftwConfigNotiSettingsBean.getResString("MSG_INVALID_EMAIL_PASSWORD")%>" );
                return false;
            }
        }
        return true;
    }

    function nextPage()
    {
        if(validateAll())
        {
            document.getElementById('frmNotification').submit();
        }
    }

    function prevPage()
    {
        document.getElementById('frmNotification').action='<%=ftwUIbean.getResString("USERS_PAGE_URL")%>';
        document.getElementById('frmNotification').submit();
    }
    </SCRIPT>

</FORM>

<div style="margin-top:15px">
    <% buttons.dumpButtons(out); %>
</div>

<%-- need the following <BR> tags to display the full page in mozilla
---- ommitting these causes the bottom buttons to be truncated when
---- the page is rendered in the iframe on the manage page
--%>
<BR>
<BR>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</BODY>
</HTML>
