<%@page import="com.hp.mx.html.core.*" %>
<%@page import="com.hp.mx.core.subjects.*"%>
<%@page import="com.hp.mx.portal.ui.*"%>
<%@page import="com.hp.mx.portal.actiononevents.*"%>
<%@page import="com.hp.mx.portal.search.MxActionOnEventSearchUI"%>
<%@page import="java.util.*"%>
<%@page import="com.hp.mx.core.taskmanager.*" %>
<%@page import="java.util.Calendar"%>
<%@page import="com.hp.mx.portal.ui.MxDateAndTime"%>
<%@page import="com.hp.mx.core.protocol.reachable.Reachable" %>

<jsp:useBean id="protSetResBndl" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="rbsettings" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="ftwProtoSettings" class="com.hp.mx.portal.settings.ProtocolSettingsBean" scope="session" />
<jsp:useBean id="ftwAoneUIbean" scope="session" class="com.hp.mx.portal.actiononevents.ActionOnEventsUIBean" />
<jsp:useBean id="ftwUIbean" scope="session" class="com.hp.mx.portal.settings.FirstTimeWizardUIBean" />
<jsp:useBean id="ftwAoEventSearchUI" class="com.hp.mx.portal.search.MxActionOnEventSearchUI" scope="session" />
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="rbsearch" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="ftwAutoDiscoveryBean" class="com.hp.mx.portal.discovery.AutoDiscoveryBean" scope="session" />
<jsp:useBean id="ftwUserUI" class="com.hp.mx.portal.settings.MxUserUI" scope="session" />
<jsp:useBean id="ftwConfigNotiSettingsBean" scope="session" class="com.hp.mx.portal.settings.ConfigNotificationSettings" />

<%
    // REQUIRED: This line is required by Tomcat for i18n support.
    MxBean.jspInit(request, response);
    rbsearch.init(loginBean, "MxSearch");
    rbsettings.init(loginBean, "MxSettings");

    ftwUIbean.getResBundles(loginBean);

    Calendar cal = Calendar.getInstance(loginBean.getTimeZone(), loginBean.getLocale());

    MxDateAndTime dateAndTime = new MxDateAndTime(loginBean.getLocale(),
                                                  loginBean.getTimeZone(),
                                                  cal.getTime());

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
    {
        return;
    }

    // Abort if the user isn't authorized.
    if ((!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.NOTIFICATION_SETTINGS_MODIFICATION_PRIVILEGE))
        || (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.EVENT_MODIFICATION_PRIVILEGE))
        || (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.TOOL_MODIFICATION_PRIVILEGE))
        || (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.SUBJECT_MODIFICATION_PRIVILEGE))
        )
    {
        %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>"/>
        <%
    }

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();
    MxTag btnBackTag = new MxDefaultTag("btnBack", ftwUIbean.getResString("BUTTON_PREV_LABEL"), "prevPage()");
    MxTag btnNextTag = new MxDefaultTag("btnNext", ftwUIbean.getResString("BUTTON_FINISH_LABEL"), "nextPage()");
    btnBackTag.setAttr(MxTag.DISABLED, "false");
    btnNextTag.setAttr(MxTag.DISABLED, "false");
    buttons.addMxTag(btnBackTag);
    buttons.addMxTag(btnNextTag);

   //initialize sendMail to off.
   ftwAoneUIbean.setSendMail("off");
   ftwAoneUIbean.setMailTo("");

%>

<jsp:setProperty name="ftwUIbean" property="*"/>
<jsp:setProperty name="ftwAoneUIbean" property="*"/>

<HTML>
<HEAD>
    <meta http-equiv="content-type" content="text/html; charset=UTF-8">
    <TITLE>
    </TITLE>
    <LINK type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
    <LINK type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/actiononevents/css/ActionOnEvents.css'>
    <SCRIPT type='text/javascript' language='JavaScript' src='<%=MxOptions.URL_BASE%>/actiononevents/js/ActionOnEventsUtil.js'></SCRIPT>

    <SCRIPT src="/mxportal/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></SCRIPT>
    <SCRIPT>MxPortalWorkspaceSetHelpTopic("admin_firstTimeWizard")</SCRIPT>


    <SCRIPT language="javascript">
    function myOnLoadHandler()
    {
    }
    </SCRIPT>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% buttons.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</HEAD>
<BODY LEFTMARGIN=0 onload="myOnLoadHandler()">
<A NAME="NAME_PAGE_TOP"></A>

    <TABLE width='100%' border='0' cellspacing='0' cellpadding='0'>
    <TR valign='top'>
        <TD>
            <%int currentTab = 8;%>
            <%@include file="FirstTimeWizard_DrawTabs.txt"%>
        </TD>
        <TD style='padding-left:12px;' align='left' width='100%'>
            <TABLE  class="top-border-table"
                    WIDTH="100%">
            <TR><TD>
                <FONT class="mxPageSubTitle">
                    <%=ftwUIbean.getResString("SUMMARY_LABEL")%>
                </FONT>
                <p>
                <%=ftwUIbean.getResString("SUMMARY_MAIN_TEXT")%>
                <p>
                <table>
                <tr align="left" valign="center">
                    <td>
                        &nbsp;&nbsp;&nbsp;
                    </td>
                    <td valign="top">
                        <b><%=ftwUIbean.getResString("WBEM_LABEL")%>:</b>
                    </td>
                    <td>
                        &nbsp;&nbsp;&nbsp;
                    </td>
                    <td>
                        <%=protSetResBndl.getString("default1")%> <%=ftwProtoSettings.getWbemUser1()%> <br>
                        <%=protSetResBndl.getString("default2")%> <%=ftwProtoSettings.getWbemUser2()%> <br>
                        <%=protSetResBndl.getString("default3")%> <%=ftwProtoSettings.getWbemUser3()%> <br>
                        <%=protSetResBndl.getString("default4")%> <%=ftwProtoSettings.getWbemUser4()%> <br>
                        <%=protSetResBndl.getString("default5")%> <%=ftwProtoSettings.getWbemUser5()%>
                    </td>
                </tr>
                <tr align="left" valign="center">
                    <td>
                        &nbsp;&nbsp;&nbsp;
                    </td>
                    <td valign="top">
                        <b><%=ftwUIbean.getResString("SNMP_LABEL")%>:</b>
                    </td>
                    <td>
                        &nbsp;&nbsp;&nbsp;
                    </td>
                    <td>
                        <%=protSetResBndl.getString("default1")%> <%=ftwProtoSettings.getSnmpReadCommString1()%> <br>
                        <%=protSetResBndl.getString("default2")%> <%=ftwProtoSettings.getSnmpReadCommString2()%> <br>
                        <%=protSetResBndl.getString("default3")%> <%=ftwProtoSettings.getSnmpReadCommString3()%> <br>
                        <%=protSetResBndl.getString("default4")%> <%=ftwProtoSettings.getSnmpReadCommString4()%>
                    </td>
                </tr>
                <tr align="left" valign="center">
                    <td>
                        &nbsp;&nbsp;&nbsp;
                    </td>
                    <td valign="top">
                        <b><%=ftwUIbean.getResString("DISCOVERY_LABEL")%>:</b>
                    </td>
                    <td>
                        &nbsp;&nbsp;&nbsp;
                    </td>
                    <td>
                        <%=ftwAutoDiscoveryBean.getResourceString("auto.page.label.name")%>
                        <%=ftwAutoDiscoveryBean.getDiscoveryName()%>
                        <br>
                        <%=ftwAutoDiscoveryBean.getResourceString("auto.page.cb.enableSchedule")%>
                        <%
                        if ( ftwAutoDiscoveryBean.getTaskDisabled() )
                        {
                        %>
                           <%=ftwUIbean.getResString("MSG_PERIODIC_TASK_DISABLED")%>
                        <%
                        }
                        else
                        {
                        %>
                            <%=ftwAutoDiscoveryBean.getInterval()%>
                            <%
                            switch (ftwAutoDiscoveryBean.getIntervalType())
                            {
                                case ScheduleIntervals.INTERVAL_MINUTES:
                                %>
                                  <%=ftwUIbean.getResString("MSG_MINUTES")%>                                <%
                                  break;
                                case ScheduleIntervals.INTERVAL_HOURS:
                                %>
                                  <%=ftwUIbean.getResString("MSG_HOURS")%>
                                <%
                                  break;
                                case ScheduleIntervals.INTERVAL_DAYS:
                                %>
                                  <%=ftwUIbean.getResString("MSG_DAYS")%> <%=ftwAutoDiscoveryBean.getIntervalTimeStr()%>
                                <%
                                  break;
                                case ScheduleIntervals.INTERVAL_WEEKLY:
                                %>
                                  <%=ftwUIbean.getResString("MSG_WEEKS")%> <%=ftwAutoDiscoveryBean.getIntervalTimeStr()%>
                                <%
                                  break;
                                case ScheduleIntervals.INTERVAL_MONTHLY:
                                %>
                                  <%=ftwUIbean.getResString("MSG_MONTHS_ON_DAY")%> <%=ftwAutoDiscoveryBean.getIntervalDOM()%> <%=ftwAutoDiscoveryBean.getIntervalTimeStr()%>
                                <%
                                  break;
                                default:
                                  break;
                            }
                            if (ftwAutoDiscoveryBean.getIntervalType() > ScheduleIntervals.INTERVAL_HOURS)
                            {
                                if (ftwAutoDiscoveryBean.getIsAmChecked().equals(""))
                                {
                                    %>PM<%
                                }
                                else
                                {
                                    %>AM<%
                                }
                            }
                        }
                        %>
                        <br>
                        <%=ftwAutoDiscoveryBean.getResourceString("auto.page.label.ping")%>
                        <%=ftwAutoDiscoveryBean.getIpInclusionRangeStr()%>
                    </td>

                </tr>
                <tr align="left" valign="center">
                    <td>
                        &nbsp;&nbsp;&nbsp;
                    </td>
                    <td valign="top">
                        <b><%=ftwUIbean.getResString("USERS_LABEL")%>:</b>
                    </td>
                    <td>
                        &nbsp;&nbsp;&nbsp;
                    </td>
                    <td>
                    <%
                    ftwUIbean.listUsers(out, loginBean);
                    %>
                    </td>
                </tr>
                <tr align="left" valign="center">
                    <td>
                        &nbsp;&nbsp;&nbsp;
                    </td>
                    <td valign="top">
                        <b><%=ftwUIbean.getResString("EMAIL_LABEL")%>:</b>
                    </td>
                    <td>
                        &nbsp;&nbsp;&nbsp;
                    </td>
                    <td>
                        <%=ftwConfigNotiSettingsBean.getResString("LBL_SMTP_HOST")%>: <%=ftwUIbean.getEmailHostName()%> <br>
                        <%=ftwConfigNotiSettingsBean.getResString("LBL_MGMT_SERVER_EMAIL")%>: <%=ftwUIbean.getEmailFromAddress()%> <br>
                        <%
                        if (ftwUIbean.getSvrRequiresAuth().equalsIgnoreCase("true"))
                        {
                        %>
                            <%=ftwConfigNotiSettingsBean.getResString("LBL_SERVER_REQUIRES_AUTH")%> <br>
                            <%=ftwConfigNotiSettingsBean.getResString("LBL_EMAIL_AUTH_ACCOUNT_NAME")%>: <%=ftwUIbean.getEmailLogin()%> <br>
                        <%
                        }
                        %>
                    </td>
                </tr>
                <tr align="left" valign="center">
                    <td>
                        &nbsp;&nbsp;&nbsp;
                    </td>
                    <td valign="top">
                        <b><%=ftwUIbean.getResString("EVENT_HANDLING_LABEL")%>:</b>
                    </td>
                    <td>
                        &nbsp;&nbsp;&nbsp;
                    </td>
                    <td>
                        <%
                        if (ftwAoneUIbean.getSendMail().equalsIgnoreCase("off"))
                        {
                        %>
                            <%=ftwUIbean.getResString("MSG_SUMMARY_NO_ACTION")%> <br>
                        <%
                        }
                        else if (ftwAoneUIbean.getMailTo().length() == 0)
                        {
                        %>
                            <%=ftwUIbean.getResString("MSG_SUMMARY_EMPTY_TO")%> <br>
                        <%
                        }
                        else
                        {
                        %>
                           <%=ftwAoneUIbean.getResString("TASK_NAME_LABEL")%> <%=ftwAoneUIbean.getTaskName()%> <br>
                           <%=ftwAoneUIbean.getResString("EVENT_LIST_LABEL")%> <%=loginBean.getQueryClient().getQuery(Integer.parseInt(ftwAoneUIbean.getQueryId())).getDisplayName(loginBean.getLocale())%><br>
                           <%=ftwUIbean.getResString("MSG_ACTION_SEND_EMAIL")%> <br>
                           <%=ftwAoneUIbean.getResString("MAIL_TO_LABEL")%> <%=ftwAoneUIbean.getMailTo()%> <br>
                           <%=ftwAoneUIbean.getResString("MAIL_CC_LABEL")%> <%=ftwAoneUIbean.getMailCC()%> <br>
                           <%=ftwAoneUIbean.getResString("MAIL_SUBJECT_LABEL")%> <%=ftwAoneUIbean.getMailSubject()%> <br>
                           <%=ftwAoneUIbean.getResString("MAIL_FORMAT_LABEL")%> <%=ftwAoneUIbean.getMailFormat()%> <br>
                           <%=ftwAoneUIbean.getResString("MAIL_ENCODING_LABEL")%> <%=ftwAoneUIbean.getMailEncoding()%> <br>
                        <%
                        }
                        %>
                    </td>
                </tr>
                </table>
            </TD></TR>
            </TABLE>
        </TD>
    </TR>
    </TABLE>
    <!-- End Data -->

    <SCRIPT>
    function nextPage()
    {
        document.getElementById('frmNotification').action='ftw_UpdateCore.jsp';
        document.getElementById('frmNotification').submit();
    }
    function prevPage()
    {
        document.getElementById('frmNotification').action='<%=ftwUIbean.getResString("EVENTS_PAGE_URL")%>';
        document.getElementById('frmNotification').submit();
    }
    </SCRIPT>

<FORM ID="frmNotification" NAME="frmNotification"  TYPE="hidden" METHOD="POST"  class="mxForm" width="100%">

<div style="margin-top:15px">
    <% buttons.dumpButtons(out); %>
</div>

</FORM>

<%-- need the following <BR> tags to display the full page in mozilla
---- ommitting these causes the bottom buttons to be truncated when
---- the page is rendered in the iframe on the manage page
--%>
<BR>
<BR>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</BODY>
</HTML>
