<%@page import="com.hp.mx.html.core.*" %>
<%@page import="com.hp.mx.core.subjects.*"%>
<%@page import="com.hp.mx.portal.actiononevents.*"%>
<%@page import="com.hp.mx.portal.ui.*"%>
<%@page import="com.hp.mx.database.GlobalSettings"%>
<%@page import="com.hp.mx.portal.search.MxEventSearchUI"%>
<%@page import="com.hp.mx.html.table.*"%>
<%@page import="java.net.URLEncoder"%>
<%@page import="java.util.*"%>
<%@page import="com.hp.mx.core.client.MxUserClient"%>
<%@page import="com.hp.mx.core.subjects.usermanager.MxUser"%>
<%@page import="com.hp.mx.exceptions.MxException"%>
<%@page import="com.hp.mx.utilities.MxCMS" %>
<%@page import="java.util.Calendar"%>
<%@page import="com.hp.mx.portal.ui.MxDateAndTime"%>
<%@page import="com.hp.mx.portal.actiononevents.*"%>
<%@page import="com.hp.mx.core.taskmanager.*" %>
<%@page import="com.hp.mx.core.protocol.reachable.Reachable" %>

<jsp:useBean id="ftwProtoSettings" class="com.hp.mx.portal.settings.ProtocolSettingsBean" scope="session" />
<jsp:useBean id="protSetResBndl" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="ftwAoEventSearchUI" class="com.hp.mx.portal.search.MxActionOnEventSearchUI" scope="session" />
<jsp:useBean id="ftwAoneUIbean" scope="session" class="com.hp.mx.portal.actiononevents.ActionOnEventsUIBean" />
<jsp:useBean id="ftwUIbean" scope="session" class="com.hp.mx.portal.settings.FirstTimeWizardUIBean" />
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="ftwAutoDiscoveryBean" class="com.hp.mx.portal.discovery.AutoDiscoveryBean" scope="session" />
<jsp:useBean id="ftwAutoDiscoveryListBean" class="com.hp.mx.portal.discovery.AutoDiscoveryList" scope="session"/>
<jsp:useBean id="ftwConfigNotiSettingsBean" scope="session" class="com.hp.mx.portal.settings.ConfigNotificationSettings" />

<%
    // REQUIRED: This line is required by Tomcat for i18n support.
    MxBean.jspInit(request, response);
    ftwUIbean.getResBundles(loginBean);
    ftwAoneUIbean.getResBundles(loginBean);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
    {
        return;
    }

    // Abort if the user isn't authorized.
    if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.FULL_RIGHTS))
    {
        %>
        <jsp:forward page="<%=MxOptions.getNotPrivUrl()%>"/>
        <%
    }

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();
    buttons.addMxTag( new MxDefaultTag("okButton", ftwUIbean.getResString("BUTTON_CLOSE_LABEL"), "MxPortalWorkspaceClose()") );
%>

<jsp:setProperty name="ftwUIbean" property="*"/>

<HTML>
<HEAD>
    <meta http-equiv="content-type" content="text/html; charset=UTF-8">
    <TITLE>
        <%=ftwUIbean.getResString("FINISH_LABEL")%>
    </TITLE>
    <LINK type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
    <LINK type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/actiononevents/css/ActionOnEvents.css'>
    <SCRIPT type='text/javascript' language='JavaScript' src='<%=MxOptions.URL_BASE%>/actiononevents/js/ActionOnEventsUtil.js'></SCRIPT>
    <SCRIPT src="/mxportal/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></SCRIPT>
    <SCRIPT>MxPortalWorkspaceSetHelpTopic("admin_firstTimeWizard")</SCRIPT>

<%
    String errMessage = "none";
    boolean retVal = false;

    //**********************************************
    //updating Protocol settings
    //**********************************************
    try
    {
        ftwProtoSettings.setPostSent("POST");
        GlobalSettings.setProperty("wbemEnableState", "enabled");
        GlobalSettings.setProperty("snmp_check_state", "checked");
        ftwProtoSettings.getFtwPropertyStatusMsg();
    }
    catch(Throwable t)
    {
        errMessage = "Failed updating global protocol settings";
    }

    //**********************************************
    //updating Discovery settings
    //**********************************************
    //we're initializing this bean so that setFirstVisit() would be called.
    ftwAutoDiscoveryListBean.initialize(loginBean);

    //save discovery task
    retVal = ftwAutoDiscoveryBean.saveDiscoveryTaskInfo("edit");

    // run task if task not already running
    if ((ftwAutoDiscoveryBean.getExeNowButtonState()) && (!ftwAutoDiscoveryBean.getTaskDisabled()))
    {
        ftwAutoDiscoveryBean.runTaskNow();
    }

    //**********************************************
    //updating Users settings
    //**********************************************
    ftwUIbean.updateUsersSetting();

    //**********************************************
    //updating Email settings
    //**********************************************
    try
    {
        GlobalSettings.setProperty("EmailHostName", ftwUIbean.getEmailHostName());
        GlobalSettings.setProperty("EmailFromAddress", ftwUIbean.getEmailFromAddress());
        if (ftwUIbean.getSvrRequiresAuth().equalsIgnoreCase("true"))
        {
            GlobalSettings.setProperty("EmailRequiresAuth", "true");
            GlobalSettings.setProperty("EmailLogin", ftwUIbean.getEmailLogin());
            ftwConfigNotiSettingsBean.updateEmailPassword(ftwUIbean.getEmailPassword());
        }
        else
        {
            GlobalSettings.setProperty("EmailRequiresAuth", "false");
            GlobalSettings.setProperty("EmailLogin", "");
            ftwConfigNotiSettingsBean.removeEmailPassword();
        }
    }
    catch(Throwable t)
    {
        errMessage = "Failed updating email settings";
    }

    //**********************************************
    //updating Event Handling settings
    //**********************************************
    try
    {
        if ((ftwAoneUIbean.getSendMail().equalsIgnoreCase("on")) && (ftwAoneUIbean.getMailTo().length() > 0))
        {
            if (ftwAoneUIbean.isTaskNameExist(loginBean, "System Event Handler"))
            {
               //task already exist, so modify task
               ftwAoneUIbean.modifyActionOnEventsTask(out);
            }
            else
            {
               //task does not exist, create new one
               ftwAoneUIbean.createActionOnEventsTask(out);
            }
        }
    }
    catch (Throwable t)
    {
        errMessage = "Failed updating event handling settings.";
    }

    //**********************************************
    //updating showFtw flag settings
    //**********************************************
    try
    {
        GlobalSettings.setProperty("showFtw", "false");
    }
    catch(Throwable t)
    {
       errMessage = "Failed updating First Time Wizard auto launch flag.";
    }
%>

    <SCRIPT language="javascript">
    function myOnLoadHandler()
    {
    }
    </SCRIPT>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% buttons.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>


</HEAD>
<BODY LEFTMARGIN=0 onload="myOnLoadHandler()">
<A NAME="NAME_PAGE_TOP"></A>

<FORM ID="frmNotification" NAME="frmNotification" METHOD="POST" width="100%">
    <TABLE width='100%' border='0' cellspacing='0' cellpadding='0'>
    <TR valign='top'>
        <TD style='padding-left:12px;' align='left' width='100%'>
            <TABLE  class="top-border-table" WIDTH="100%">
            <TR><TD>
                <B>
                <FONT class="mxPageSubTitle">
                <%=ftwUIbean.getResString("FINISH_LABEL")%>
                </FONT>
                </B>
                <br>
                <p>
                <%=ftwUIbean.getResString("FINISH_MAIN_TEXT")%>
                <p>
                <br>
                <br>
            </TD></TR>
            </TABLE>
        </TD>
    </TR>
    </TABLE>
    <!-- End Data -->

</FORM>

<div style="margin-top:15px">
    <% buttons.dumpButtons(out); %>
</div>

<%-- need the following <BR> tags to display the full page in mozilla
---- ommitting these causes the bottom buttons to be truncated when
---- the page is rendered in the iframe on the manage page
--%>
<BR>
<BR>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</BODY>
</HTML>
