<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.MxLoginBean" %>
<%@ page import="com.hp.mx.portal.ui.MxOptions" %>
<%@ page import="com.hp.mx.portal.ui.MxBean" %>

<jsp:useBean id="ftwUserUI" class="com.hp.mx.portal.settings.MxUserUI" scope="session" />
<jsp:useBean id="ftwUserTableModel" class="com.hp.mx.portal.settings.MxUserTableModel" scope="session" />
<jsp:useBean id="ftwUserSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session" />
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="rbsettings" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="ftwUIbean" scope="session" class="com.hp.mx.portal.settings.FirstTimeWizardUIBean" />

<%  // Set Necessary HTTP header attributes (for localization and caching)
    MxBean.jspInit(request, response);

    if(loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    rbsettings.init(loginBean, "MxSettings");
%>
<html>

<head>
<meta http-equiv="content-type" content="text/html;charset=UTF-8">
<title>Required Field</title>
<link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
<link type='text/css' rel='stylesheet' href='css/MxAuth.css'>
<script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
<script src="/SessionReset.js" language="JavaScript" type="text/javascript"></script>
</head>

<body>
<%  String cmd = new String(request.getParameter("command"));

    int doAddRet = 0;
    int doEditRet = 0;

    // If the apply button was pushed from the add page,
    // load up the field values using the node bean properties
    // and reload the page
    // If there is an edit error, tell the start page to reload
    // the edit page
    String applyFlag = request.getParameter("apply");
    boolean editErr       = false;
    boolean addErr        = false;

    if (cmd.equals("add"))
    {
        //System.out.println("Calling user add method");
        // Call Add user
        doAddRet = ftwUserUI.DoAddUser(loginBean, request, rbsettings.getBundle(), ftwUIbean);
        if(doAddRet != 0)
        {
            addErr = true;
        }
    }
    if (cmd.equals("edit"))
    {
        //System.out.println("Calling user edit method");
        // Call Edit user
        doEditRet = ftwUserUI.DoEditUser(loginBean, request, ftwUIbean);
        if(doEditRet != 0)
        {
            editErr = true;
        }
        else
        {
%>
            <script language="JAVASCRIPT">
            alert("<%=rbsettings.getString("user.editok")%>");
            </script>
<%      }
    }
    if (cmd.equals("delete"))
    {
        // Call the delete method in the user bean
        //System.out.println("Calling delete method");
        int doDeleteRet = ftwUserUI.DoDeleteUsers(loginBean, ftwUserSelectionModel, ftwUserTableModel, ftwUIbean);
        if(doDeleteRet == 1)
        {
%>
            <script language="JAVASCRIPT">
            alert("<%=rbsettings.getString("user.deleteerr")%>");
            </script>
<%      }
        else if(doDeleteRet == 2)
        {
%>
            <script language="JAVASCRIPT">
            alert("<%=rbsettings.getString("user.deletelasterr")%>");
            </script>
<%      }
        else if(doDeleteRet == 3)
        {
%>
            <script language="JAVASCRIPT">
            alert("<%=rbsettings.getString("user.invaliderr")%>");
            </script>
<%      }
        else if(doDeleteRet == 4)
        {
%>
            <script language="JAVASCRIPT">
            alert("<%=rbsettings.getString("user.delete.self.err")%>");
            </script>
<%      }
        else
        {
%>
            <script language="JAVASCRIPT">
            MxPortalRefreshNavigationArea();
            </script>
<%      }
    }

    if(addErr)
    {
%>
        <script language="JAVASCRIPT">
        document.location.href = "ftw_AddUser.jsp?error=true&errorCode=<%=doAddRet%>&apply=true";
        </script>
<%  }
    else if(applyFlag != null && applyFlag.equals("true"))
    {
%>
        <jsp:setProperty name="ftwUserUI" property="*" />
        <script language="JAVASCRIPT">
        parent.document.location.href = "ftw_Users.jsp?apply=true";
        </script>
<%
    }
    else if(editErr)
    {
%>
        <script language="JAVASCRIPT">
        document.location.href = "ftw_EditUser.jsp?error=true&errorCode=<%=doEditRet%>";
        </script>
<%  }
    else
    {
        ftwUserUI.resetBean();
%>
        <script language="JAVASCRIPT">
        parent.document.location.href = "ftw_Users.jsp";
        </script>
<%  }
%>

</body>
</html>
