<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*"%>
<%@ page import="java.util.*"%>
<%@ page import="com.hp.mx.utilities.MxCMS" %>
<%@ page import="com.hp.mx.portal.settings.ProtocolSettingsBean" %>

<jsp:useBean id="protSetResBndl" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="ftwProtoSettings" class="com.hp.mx.portal.settings.ProtocolSettingsBean" scope="session" />
<jsp:useBean id="ftwUIbean" scope="session" class="com.hp.mx.portal.settings.FirstTimeWizardUIBean" />
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>

<%
    // REQUIRED: This line is required by Tomcat for i18n support.
    MxBean.jspInit(request, response);

    // setup resources.
    protSetResBndl.init(loginBean, "ProtocolSettings");
    ftwUIbean.getResBundles(loginBean);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
    {
        return;
    }

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();
    MxTag btnBackTag = new MxDefaultTag("btnBack", ftwUIbean.getResString("BUTTON_PREV_LABEL"), "prevPage()");
    MxTag btnNextTag = new MxDefaultTag("btnNext", ftwUIbean.getResString("BUTTON_NEXT_LABEL"), "nextPage()");
    buttons.addMxTag(btnBackTag);
    buttons.addMxTag(btnNextTag);

    String referer = request.getHeader("referer");

    if (referer.indexOf(ftwUIbean.getResString("INTRODUCTION_PAGE_URL")) != -1)
    {
        //clear the wbem variables
        ftwUIbean.setDoNotLaunch("off");
    }



%>
<jsp:setProperty name="ftwUIbean" property="*"/>

<HTML>
<HEAD>
    <meta http-equiv="content-type" content="text/html; charset=UTF-8">
    <TITLE>
        <%=ftwUIbean.getResString("WBEM_LABEL")%>
    </TITLE>
    <LINK type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
    <LINK type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/actiononevents/css/ActionOnEvents.css'>
    <SCRIPT type='text/javascript' language='JavaScript' src='<%=MxOptions.URL_BASE%>/actiononevents/js/ActionOnEventsUtil.js'></SCRIPT>
    <SCRIPT src="/mxportal/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></SCRIPT>
    <SCRIPT>MxPortalWorkspaceSetHelpTopic("admin_protocols_setting")</SCRIPT>

    <SCRIPT language="javascript">

    function hilite( editWindow )
    {
        editWindow.focus();
        editWindow.select();
        return true;
    }

    function validateProtocols()
    {
        // validate the wbem passwords
        if ((document.frmNotification.wbemUser1.value == null || document.frmNotification.wbemUser1.value.length == 0) &&
            (document.frmNotification.wbemPass1.value != null && document.frmNotification.wbemPass1.value.length > 0))
        {
            alert("<%=protSetResBndl.getString("wbempass1NoUser") %>");
            hilite(document.frmNotification.wbemUser1);
            return false;
        }

        if ((document.frmNotification.wbemUser1.value != null && document.frmNotification.wbemUser1.value.length > 0) &&
            (document.frmNotification.wbemPass1.value == null || document.frmNotification.wbemPass1.value.length == 0) )
        {
            alert("<%=protSetResBndl.getString("wbempass1NoPass") %>");
            hilite(document.frmNotification.wbemPass1);
            return false;
        }

        if (document.frmNotification.wbemPass1.value != document.frmNotification.wbemPassConf1.value)
        {
            alert("<%=protSetResBndl.getString("wbempass1NoMatch") %>");
            hilite(document.frmNotification.wbemPass1);
            return false;
        }

        // validate the wbem passwords
        if ((document.frmNotification.wbemUser2.value == null || document.frmNotification.wbemUser2.value.length == 0) &&
            (document.frmNotification.wbemPass2.value != null && document.frmNotification.wbemPass2.value.length > 0))
        {
            alert("<%=protSetResBndl.getString("wbempass2NoUser") %>");
            hilite(document.frmNotification.wbemUser2);
            return false;
        }

        if ((document.frmNotification.wbemUser2.value != null && document.frmNotification.wbemUser2.value.length > 0) &&
            (document.frmNotification.wbemPass2.value == null || document.frmNotification.wbemPass2.value.length == 0) )
        {
            alert("<%=protSetResBndl.getString("wbempass2NoPass") %>");
            hilite(document.frmNotification.wbemPass2);
            return false;
        }

        if (document.frmNotification.wbemPass2.value != document.frmNotification.wbemPassConf2.value)
        {
             alert("<%=protSetResBndl.getString("wbempass2NoMatch") %>");
            hilite(document.frmNotification.wbemPass2);
            return false;
        }

        // validate the wbem passwords
        if ((document.frmNotification.wbemUser3.value == null || document.frmNotification.wbemUser3.value.length == 0) &&
            (document.frmNotification.wbemPass3.value != null && document.frmNotification.wbemPass3.value.length > 0))
        {
            alert("<%=protSetResBndl.getString("wbempass3NoUser") %>");
            hilite(document.frmNotification.wbemUser3);
            return false;
        }

        if ((document.frmNotification.wbemUser3.value != null && document.frmNotification.wbemUser3.value.length > 0) &&
            (document.frmNotification.wbemPass3.value == null || document.frmNotification.wbemPass3.value.length == 0) )
        {
            alert("<%=protSetResBndl.getString("wbempass3NoPass") %>");
            hilite(document.frmNotification.wbemPass3);
            return false;
        }

        if (document.frmNotification.wbemPass3.value != document.frmNotification.wbemPassConf3.value)
        {
             alert("<%=protSetResBndl.getString("wbempass3NoMatch") %>");
            hilite(document.frmNotification.wbemPass3);
            return false;
        }

        if ((document.frmNotification.wbemUser4.value == null || document.frmNotification.wbemUser4.value.length == 0) &&
            (document.frmNotification.wbemPass4.value != null && document.frmNotification.wbemPass4.value.length > 0))
        {
            alert("<%=protSetResBndl.getString("wbempass4NoUser") %>");
            hilite(document.frmNotification.wbemUser4);
            return false;
        }

        if ((document.frmNotification.wbemUser4.value != null && document.frmNotification.wbemUser4.value.length > 0) &&
            (document.frmNotification.wbemPass4.value == null || document.frmNotification.wbemPass4.value.length == 0) )
        {
            alert("<%=protSetResBndl.getString("wbempass4NoPass") %>");
            hilite(document.frmNotification.wbemPass4);
            return false;
        }

        if (document.frmNotification.wbemPass4.value != document.frmNotification.wbemPassConf4.value)
        {
            alert("<%=protSetResBndl.getString("wbempass4NoMatch") %>");
            hilite(document.frmNotification.wbemPass4);
            return false;
        }

        if ((document.frmNotification.wbemUser5.value == null || document.frmNotification.wbemUser5.value.length == 0) &&
            (document.frmNotification.wbemPass5.value != null && document.frmNotification.wbemPass5.value.length > 0))
        {
            alert("<%=protSetResBndl.getString("wbempass5NoUser") %>");
            hilite(document.frmNotification.wbemUser5);
            return false;
        }

        if ((document.frmNotification.wbemUser5.value != null && document.frmNotification.wbemUser5.value.length > 0) &&
            (document.frmNotification.wbemPass5.value == null || document.frmNotification.wbemPass5.value.length == 0) )
        {
            alert("<%=protSetResBndl.getString("wbempass5NoPass") %>");
            hilite(document.frmNotification.wbemPass5);
            return false;
        }

        if (document.frmNotification.wbemPass5.value != document.frmNotification.wbemPassConf5.value)
        {
            alert("<%=protSetResBndl.getString("wbempass5NoMatch") %>");
            hilite(document.frmNotification.wbemPass5);
            return false;
        }
        return true;
    }

    function clearPw(wbemPass, wbemPassConf)
    {
        wbemPass.value = "";
        wbemPassConf.value = "";
    }

    function myOnLoadHandler()
    {
    }
    </SCRIPT>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% buttons.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</HEAD>
<BODY LEFTMARGIN=0 onload="myOnLoadHandler()">
<A NAME="NAME_PAGE_TOP"></A>

<FORM ID="frmNotification" NAME="frmNotification" METHOD="GET">
    <TABLE width='100%' border='0' cellspacing='0' cellpadding='0'>
    <TR valign='top'>
        <TD>
            <%int currentTab = 2;%>
            <%@include file="FirstTimeWizard_DrawTabs.txt"%>
        </TD>
        <TD style='padding-left:12px;' align='left' width='100%'>
            <TABLE  class="top-border-table" WIDTH="100%">
            <TR><TD>
                <FONT class="mxPageSubTitle">
                <%=ftwUIbean.getResString("WBEM_LABEL")%>
                </FONT>
                <br>
                <b><%=ftwUIbean.getResString("WBEM_LINK")%></b>
                <p>
                <%=ftwUIbean.getResString("WBEM_MAIN_TEXT")%>
                <p>
                <table>
                <tr align="left" valign="center">
                    <td>
                        &nbsp;
                    </td>
                    <td>
                        <%= protSetResBndl.getString("userName")%>
                    </td>
                    <td>
                        <%= protSetResBndl.getString("passWord")%>
                    </td>
                    <td>
                        <%= protSetResBndl.getString("confPassWord")%>
                    </td>
                </tr>
                <tr align="left" valign="center">
                    <td>
                        <%= protSetResBndl.getString("default1")%>
                    </td><td>
                        <input TYPE="text" NAME="wbemUser1" MAXLENGTH="70" onChange="clearPw(frmNotification.wbemPass1,frmNotification.wbemPassConf1)"
                        VALUE="<jsp:getProperty name="ftwProtoSettings" property="wbemUser1" />"
                        SIZE="20">
                    </td>
                    <td>
                        <input TYPE="password" NAME="wbemPass1" MAXLENGTH="70"
                        VALUE="<jsp:getProperty name="ftwProtoSettings" property="wbemPass1" />"
                        SIZE="20">
                    </td>
                    <td>
                        <input TYPE="password" NAME="wbemPassConf1" MAXLENGTH="70"
                        VALUE="<jsp:getProperty name="ftwProtoSettings" property="wbemPass1" />"
                        SIZE="20">
                    </td>
                </tr>
                <tr align="left" valign="center">
                    <td>
                        <%= protSetResBndl.getString("default2")%>
                    </td>
                    <td>
                         <input TYPE="text" NAME="wbemUser2" MAXLENGTH="70" onChange="clearPw(frmNotification.wbemPass2,frmNotification.wbemPassConf2)"
                         VALUE="<jsp:getProperty name="ftwProtoSettings" property="wbemUser2" />"
                         SIZE="20">
                    </td>
                    <td>
                         <input TYPE="password" NAME="wbemPass2" MAXLENGTH="70"
                         VALUE="<jsp:getProperty name="ftwProtoSettings" property="wbemPass2" />"
                         SIZE="20">
                    </td>
                    <td>
                         <input TYPE="password" NAME="wbemPassConf2" MAXLENGTH="70"
                         VALUE="<jsp:getProperty name="ftwProtoSettings" property="wbemPass2" />"
                         SIZE="20">
                    </td>
                </tr>
                <tr align="left" valign="center">
                    <td>
                        <%= protSetResBndl.getString("default3")%>
                    </td>
                    <td>
                        <input TYPE="text" NAME="wbemUser3" MAXLENGTH="70" onChange="clearPw(frmNotification.wbemPass3,frmNotification.wbemPassConf3)"
                        VALUE="<jsp:getProperty name="ftwProtoSettings" property="wbemUser3" />"
                        SIZE="20">
                    </td>
                    <td>
                        <input TYPE="password" NAME="wbemPass3" MAXLENGTH="70"
                        VALUE="<jsp:getProperty name="ftwProtoSettings" property="wbemPass3" />"
                        SIZE="20">
                    </td>
                    <td>
                        <input TYPE="password" NAME="wbemPassConf3" MAXLENGTH="70"
                        VALUE="<jsp:getProperty name="ftwProtoSettings" property="wbemPass3" />"
                        SIZE="20">
                    </td>
                </tr>
                <tr align="left" valign="center">
                    <td>
                        <%= protSetResBndl.getString("default4")%>
                    </td>
                    <td>
                        <input TYPE="text" NAME="wbemUser4" MAXLENGTH="70" onChange="clearPw(frmNotification.wbemPass4,frmNotification.wbemPassConf4)"
                        VALUE="<jsp:getProperty name="ftwProtoSettings" property="wbemUser4" />"
                        SIZE="20">
                    </td>
                    <td>
                        <input TYPE="password" NAME="wbemPass4" MAXLENGTH="70"
                        VALUE="<jsp:getProperty name="ftwProtoSettings" property="wbemPass4" />"
                        SIZE="20">
                    </td>
                    <td>
                        <input TYPE="password" NAME="wbemPassConf4" MAXLENGTH="70"
                        VALUE="<jsp:getProperty name="ftwProtoSettings" property="wbemPass4" />"
                        SIZE="20">
                    </td>
                </tr>
                <tr align="left" valign="center">
                    <td>
                        <%= protSetResBndl.getString("default5")%>
                    </td>
                    <td>
                        <input TYPE="text" NAME="wbemUser5" MAXLENGTH="70" onChange="clearPw(frmNotification.wbemPass5,frmNotification.wbemPassConf5)"
                        VALUE="<jsp:getProperty name="ftwProtoSettings" property="wbemUser5" />"
                        SIZE="20">
                    </td>
                    <td>
                        <input TYPE="password" NAME="wbemPass5" MAXLENGTH="70"
                        VALUE="<jsp:getProperty name="ftwProtoSettings" property="wbemPass5" />"
                        SIZE="20">
                    </td>
                    <td>
                        <input TYPE="password" NAME="wbemPassConf5" MAXLENGTH="70"
                        VALUE="<jsp:getProperty name="ftwProtoSettings" property="wbemPass5" />"
                        SIZE="20">
                    </td>
                    </tr>
                </table>
            </TD></TR>
            </TABLE>
        </TD>
    </TR>
    </TABLE>
    <!-- End Data -->

    <SCRIPT>
    function nextPage()
    {
        if(validateProtocols() == true)
        {
           document.getElementById('frmNotification').action='<%=ftwUIbean.getResString("SNMP_PAGE_URL")%>';
           document.getElementById('frmNotification').submit();
        }
        else
        {
           return false;
        }
    }
    function prevPage()
    {
        document.getElementById('frmNotification').action='<%=ftwUIbean.getResString("INTRODUCTION_PAGE_URL")%>';
        document.getElementById('frmNotification').submit();

    }
    </SCRIPT>
</FORM>

<div style="margin-top:15px">
    <% buttons.dumpButtons(out); %>
</div>

<%-- need the following <BR> tags to display the full page in mozilla
---- ommitting these causes the bottom buttons to be truncated when
---- the page is rendered in the iframe on the manage page
--%>
<BR>
<BR>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</BODY>
</HTML>
