<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="taskWizardBean" class="com.hp.mx.portal.taskandjob.MxTaskWizard" scope="session"/>
<jsp:useBean id="rbDC" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />

<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*"%>
<%@ page import="com.hp.mx.portal.help.*"%>
<%@ page import="com.hp.mx.core.tools.datacollection.DCTaskModel"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskWizardInstance"%>

<%

    MxBean.jspInit(request, response);
    rbDC.init(loginBean,"DCTask");

    if (loginBean.checkLogoutConditionForWebPage(pageContext))
    {
        return;
    }

    // Get the Instance Data for this Task Wizard Instance
    String               timeStamp = request.getParameter("timeStamp");
    MxTaskWizardInstance inst      = (MxTaskWizardInstance)taskWizardBean.getInstance(timeStamp);

    DCTaskModel dcTask = (DCTaskModel)inst.getTaskUserParameters();

    if (null == dcTask)
    {
        dcTask = new DCTaskModel();
        dcTask.initialize();
    }

    if (request.getMethod().equals("POST"))
    {
        String dcState = request.getParameter("dcState");
        boolean isHistoricalState = (dcState.equals("true"))?true:false;
        dcTask.setCollectHistoricalDataState(isHistoricalState);
        inst.setTaskUserParameters(dcTask);
    }

    boolean historicalState = dcTask.getCollectHistoricalDataState();
%>

<html>
    <head>
        <title><%=rbDC.getString("DCParameter.title")%></title>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/taskandjob/css/taskAndJob.css'>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/taskWizard.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxPortalApi.js'></script>
        <script language='javascript' type='text/javascript'>
            // Set the help page
            MxPortalWorkspaceSetHelpTopic("admin_dataCollect_createSingleHistoricalTask");
            //
            var dcHistorical = <%=historicalState%>;
            ////////////////////////////////
            function saveHistorical()
            {
                document.getElementById("dcState").value = true;
            }
            ////////////////////////////////
            function saveSingle()
            {
                document.getElementById("dcState").value = false;
            }
            ////////////////////////////////
            function checkParameter()
            {
                if ( dcHistorical )
                {
                    document.getElementById("btnHistorical").checked = true;
                }
                else
                {
                    document.getElementById("btnSingle").checked = true;
                }
            }
        </script>
<%
    MxHtmlUtil.dumpHeadBegin(out);
    MxButton.dumpHeadContent(out);
    MxHtmlUtil.dumpHeadEnd(out);
%>
    </head>

    <body onload='checkParameter()'>
<%
    if (request.getMethod().equals("POST"))
    {
%>
            <script language='javascript' type='text/javascript'>
                setFormSubmitName('');
                loadWizardNextStep();
            </script>
<%
    }
    else
    {
%>
            <script language='javascript' type='text/javascript'>
                setFormSubmitName('DCParameter');
            </script>
<%
    }
%>
        <form method="post" id="DCParameter" name="DCParameter" action="DCParameter.jsp">

            <script language='javascript' type='text/javascript'>
                setWizardStepText("<%=rbDC.getString("DCParameter.steptext")%>");
            </script>

            <table border='0' cellspacing='0' cellpadding='1' style='width:100%'>
                <tr>
                    <td nowrap>&nbsp;
                        <input type='radio' name='dcMode' id='btnSingle' onClick='saveSingle()' value=''>&nbsp;
                        <%=rbDC.getString("DCParameter.singlemode")%>
                    </td>
                </tr>
                <tr>
                    <td nowrap>&nbsp;
                        <input type='radio' name='dcMode' id='btnHistorical' onClick='saveHistorical()' value=''>&nbsp;
                        <%=rbDC.getString("DCParameter.historicalmode")%>
                    </td>
                </tr>
            </table>

            <script language='javascript' type='text/javascript'>
                displayTaskWizardButtons()
            </script>

            <input type="hidden" id="dcState" name="dcState" value="">

            <br>

            <input type='hidden' id='timeStamp' name='timeStamp' value='<%=timeStamp%>'>
        </form>

    </body>
<%
    MxHtmlUtil.dumpBodyEnd(out);
%>
</html>
