<%
//
// $Source: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/taskandjob/DeviceAttributeTool.jsp,v $
// $Revision: 1.8 $
// $Date: 2005/04/30 00:46:20 $
//
%>
<%@ page info="System Attribute Tool"%>

<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.core.nodemanager.MxNode" %>
<%@ page import="com.hp.mx.core.controllers.MxNodeController" %>
<%@ page import="com.hp.mx.core.subjects.*" %>
<%@ page import="com.hp.mx.core.tools.systemattributes.SystemAttributesTaskModel" %>
<%@ page import="com.hp.mx.html.table.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.utilities.DebugOutput" %>
<%@ page import="com.hp.mx.utilities.DebugSubsystem" %>
<%@ page import="com.hp.mx.core.nodemanager.MxNodeName" %>
<%@ page import="java.util.*" %>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskWizardInstance"%>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="taskWizardBean" class="com.hp.mx.portal.taskandjob.MxTaskWizard" scope="session" />
<jsp:useBean id="daBean" class="com.hp.mx.portal.device.DeviceAttributesBean" scope="session" />
<%!
    /** **********************************************************************
     * The debug object
     ************************************************************************ */
    public DebugSubsystem daToolDebug = DebugOutput.getDebugSubsystem("daBean");

%>
<%
    // REQUIRED: This line is required by Tomcat for i18n support.
    MxBean.jspInit(request, response);

    daToolDebug.log(5, "[DeviceAttributeTool.jsp] Page loading ****************************************");

    // REQUIRED: Abort the page & redirect if the session has timed out
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
    {
        return;
    }

    // This aborts the page if the user isn't authorized.
    if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.NODE_MODIFICATION_PRIVILEGE))
    {
        %><jsp:forward page="<%=MxOptions.getNotPrivUrl()%>" /><%
    }

    // Get the Instance Data for this Task Wizard Instance
    String               timeStamp = request.getParameter("timeStamp");
    MxTaskWizardInstance inst      = (MxTaskWizardInstance)taskWizardBean.getInstance(timeStamp);

    // Initialize beans
    daToolDebug.log(5, "[DeviceAttributeTool.jsp] Initialize the Bean (Mmmmm....Beans....)");
    daBean.initializeForSysAttribTool(loginBean, (SystemAttributesTaskModel)inst.getTaskUserParameters());

%>
<HTML>
<HEAD>
    <TITLE><%= daBean.getResourceString("dvcAttribTool.pageTitle") %></TITLE>
    <link href="<%= MxOptions.URL_BASE %>/taskandjob/css/taskAndJob.css" rel="stylesheet" type="text/css">
    <link href="<%= MxOptions.URL_BASE %>/css/MxPortalEx.css" rel="stylesheet" type="text/css">
    <script src='<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js' language='JavaScript' type='text/javascript'></script>
    <script src='<%=MxOptions.URL_BASE%>/taskandjob/js/taskWizard.js' language='JavaScript' type='text/javascript'></script>
    <script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
    <script src="<%=MxOptions.URL_BASE%>/js/MxBrowser.js" language="JavaScript" type="text/javascript"></script>
    <script src="<%=MxOptions.URL_BASE%>/js/utilities.js" language="JavaScript" type="text/javascript"></script>
    <script language="JavaScript" type="text/javascript">
        MxPortalWorkspaceSetHelpTopic("admin_sysProperties_setMultiple");
    </script>
    <%
    //JavaScript functions to make sure that a user enters valid characaters
    // for a device search.
    %>
    <script language="JavaScript" type="text/javascript">
        function myOnLoad()
        {
            setTimeout("myOnResize()", 500);
        }

        function myOnResize()
        {
            resize_w();
        }

        function resize_w()
        {
            var w = Math.max(0, MxBrowserGetBodyWidth(0, 0));
        }

        function autoSelectCb(id)
        {
            var cb = document.getElementById(id);
            if (cb != null)
            {
                cb.checked = true;
            }
        }
    </script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxButton.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</HEAD>

<BODY onLoad="myOnLoad()" onResize="myOnResize()">
    <%
    // DISPLAY BEAN AND JSP PROPERTIES
    if (daToolDebug.check(20))
    {
        daBean.displayBeanPropsHtml(out);
        out.println("<BR>");
        daBean.displayJspParamsHtml(request, out);
        daBean.displayJspParamsToConsole(request);
    }

    ///////////////////////////////////////////////////////////////////////////
    // IS THIS A POST?  Check data validity and redirect
    ///////////////////////////////////////////////////////////////////////////
    if (request.getMethod().equals("POST"))
    {
        daToolDebug.log(5, "[DeviceAttributeTool.jsp] PROCESSING HTTP POST");
        daBean.clearAllErrorMessages();

        // Device subtypes (an indexed property) need to be set by hand
        for (int i = 0; i < daBean.NUM_SUBTYPES; i++)
        {
            daBean.setSystemSubtype(request.getParameter("systemSubtype" + i), i);
        }

        // Save the user settings (sets the data model in the Bean)
        daBean.saveSystemAttributesForTool(request);

        // PASS THE DATA MODEL TO THE TASK WIZARD
        SystemAttributesTaskModel myTaskModel = daBean.getSystemAttributesTaskModel();
        inst.setTaskUserParameters(myTaskModel);

        // Let the task wizard continue with the running or scheduling
        %><script>loadWizardNextStep();</script><%
    }
    else
    {
        ///////////////////////////////////////////////////////////////////////////
        // THIS IS NOT A POST - Display normally
        ///////////////////////////////////////////////////////////////////////////
        daToolDebug.log(5, "[DeviceAttributeTool.jsp] PROCESSING HTTP GET (Page displaying normally)");
        %>
        <script language="JavaScript" type="text/javascript">setWizardStepText("<%= daBean.getResourceString("dvcAttribTool.wizard.subtitle") %>");</script>

        <table border="0" cellpadding="0" cellspacing="0" style="width:100%">
            <tr><td><%= daBean.getResourceString("dvcAttribTool.instructions")%></td></tr>
        </table>
        <br>
        <br>
        <form action="DeviceAttributeTool.jsp?devId=<%= request.getParameter("devId") %>" method="post" name="dvcAttribsForm" id="dvcAttribsForm">

        <table cellspacing="0" cellpadding="1" border="0">
        <% // IDENTIFICATION BLOCK  %>
        <tr>
            <td nowrap colspan="3"><b><%= daBean.getResourceString("attrib.sectionHeader.Identification")%></b></td>
        </tr>
        <tr>
            <td>&nbsp;&nbsp;&nbsp;&nbsp;<input type="checkbox" name="resetSystemName"  id="cbNameLock" <%= daBean.propertyToBeConfigured(daBean.IDX_SYSTEM_NAME) %>></td>
            <td colspan="2"><label for="cbNameLock"><%= daBean.getResourceString("dvcAttribTool.systemname.restore")%></label></td>
        </tr>
        <% // PRODUCT DESCRIPTION BLOCK  %>
        <tr>
            <td nowrap colspan="3">&nbsp;</td>
        </tr>
        <tr>
            <td nowrap colspan="3"><b><%= daBean.getResourceString("attrib.sectionHeader.ProductDescription")%></b></td>
        </tr>
        <tr>
            <td>&nbsp;&nbsp;&nbsp;&nbsp;<input type="checkbox" value="systemType" name="actOnProperty" id="cbSystemType" <%= daBean.propertyToBeConfigured(daBean.IDX_SYSTEM_TYPE) %>></td>
            <td><%= daBean.getResourceString("attrib.systemType")%>:</td>
            <td>
                <select name="systemType" onChange="autoSelectCb('cbSystemType')">
                    <% daBean.displaySystemTypeTags(out); %>
                </select>
            </td>
        </tr>
        <%
            for (int i = 0; i < daBean.NUM_SUBTYPES; i++)
            {
        %>
        <tr>
            <td>&nbsp;&nbsp;&nbsp;&nbsp;<input type="checkbox" value="systemSubtype<%= i %>" name="actOnProperty" id="cbSystemSubtype<%= i %>" <%= daBean.propertyToBeConfigured(daBean.IDX_SYSTEM_SUBTYPE0 + i) %>></td>
            <td><%= daBean.getResourceString("attrib.systemSubtype")%> <%= (i + 1) %>:</td>
            <td>
                <select name="systemSubtype<%= i %>" onChange="autoSelectCb('cbSystemSubtype<%= i %>')">
                    <% daBean.displaySystemSubTypeTags(out, i); %>
                </select>
            </td>
        </tr>
        <%
            }
        %>
        <tr>
            <td>&nbsp;&nbsp;&nbsp;&nbsp;<input type="checkbox" value="productModel" name="actOnProperty" id="cbProductModel" <%= daBean.propertyToBeConfigured(daBean.IDX_PRODUCT_MODEL) %>></td>
            <td><%= daBean.getResourceString("attrib.productModel")%>:</td>
            <td><input type="text" maxlength="255" name="productModel" value="<jsp:getProperty name="daBean" property="productModel" />" SIZE="40" onKeyDown="autoSelectCb('cbProductModel')"></td>
        </tr>
        <tr>
            <td>&nbsp;&nbsp;&nbsp;&nbsp;<input type="checkbox" value="hwDescription" name="actOnProperty" id="cbHwDescription" <%= daBean.propertyToBeConfigured(daBean.IDX_HW_DESCRIPTION) %>></td>
            <td><%= daBean.getResourceString("attrib.hwDescription")%>:</td>
            <td><input type="text" maxlength="255" name="hwDescription" value="<jsp:getProperty name="daBean" property="hwDescription" />" SIZE="40" onKeyDown="autoSelectCb('cbHwDescription')"></td>
        </tr>
        <tr>
            <td>&nbsp;&nbsp;&nbsp;&nbsp;<input type="checkbox" value="osDescription" name="actOnProperty" id="cbOsDescription" <%= daBean.propertyToBeConfigured(daBean.IDX_OS_DESCRIPTION) %>></td>
            <td><%= daBean.getResourceString("attrib.osDescription")%>:</td>
            <td><input type="text" maxlength="255" name="osDescription" value="<jsp:getProperty name="daBean" property="osDescription" />" SIZE="40" onKeyDown="autoSelectCb('cbOsDescription')"></td>
        </tr>
        <tr>
            <td>&nbsp;&nbsp;&nbsp;&nbsp;<input type="checkbox" value="osType" name="actOnProperty" id="cbOsType" <%= daBean.propertyToBeConfigured(daBean.IDX_OS_NAME) %>></td>
            <td><%= daBean.getResourceString("attrib.osType")%>:</td>
            <td>
                <select name="osType" onChange="autoSelectCb('cbOsType')">
                    <% daBean.displayOSTypeTags(out); %>
                </select>
            </td>
        </tr>
        <tr>
            <td>&nbsp;&nbsp;&nbsp;&nbsp;<input type="checkbox" value="osVersion" name="actOnProperty" id="cbOsVersion" <%= daBean.propertyToBeConfigured(daBean.IDX_OS_VERSION) %>></td>
            <td><%= daBean.getResourceString("attrib.osversion")%>:</td>
            <td><input type="text" maxlength="80" name="osVersion" value="<jsp:getProperty name="daBean" property="osVersion" />" SIZE="40" onKeyDown="autoSelectCb('cbOsVersion')"></td>
        </tr>
        <% // ASSET INFORMATION BLOCK  %>
        <tr>
            <td nowrap colspan="3">&nbsp;</td>
        </tr>
        <tr>
            <td nowrap colspan="3"><b><%= daBean.getResourceString("attrib.sectionHeader.AssetInformation")%></b></td>
        </tr>
        <tr>
            <td>&nbsp;&nbsp;&nbsp;&nbsp;<input type="checkbox" value="assetNumber" name="actOnProperty"  id="cbAssetNumber" <%= daBean.propertyToBeConfigured(daBean.IDX_ASSET_NUMBER) %>></td>
            <td><%= daBean.getResourceString("attrib.assetNumber")%>:</td>
            <td><input type="text" maxlength="255" name="assetNumber" value="<jsp:getProperty name="daBean" property="assetNumber" />" SIZE="40" onKeyDown="autoSelectCb('cbAssetNumber')"></td>
        </tr>
        <% // CONTACT INFORMATION BLOCK  %>
        <tr>
            <td nowrap colspan="3">&nbsp;</td>
        </tr>
        <tr>
            <td nowrap colspan="3"><b><%= daBean.getResourceString("attrib.sectionHeader.ContactInformation")%></b></td>
        </tr>
        <tr>
            <td>&nbsp;&nbsp;&nbsp;&nbsp;<input type="checkbox" value="contact" name="actOnProperty" id="cbContact" <%= daBean.propertyToBeConfigured(daBean.IDX_CONTACT) %>></td>
            <td><%= daBean.getResourceString("attrib.contact")%>:</td>
            <td><input type="text" maxlength="255" name="contact" value="<jsp:getProperty name="daBean" property="contact" />" SIZE="40" onKeyDown="autoSelectCb('cbContact')"></td>
        </tr>
        <tr>
            <td>&nbsp;&nbsp;&nbsp;&nbsp;<input type="checkbox" value="location" name="actOnProperty"  id="cbLocation" <%= daBean.propertyToBeConfigured(daBean.IDX_LOCATION) %>></td>
            <td><%= daBean.getResourceString("attrib.location")%>:</td>
            <td><input type="text" maxlength="255" name="location" value="<jsp:getProperty name="daBean" property="location" />" SIZE="40" onKeyDown="autoSelectCb('cbLocation')"></td>
        </tr>
        <% // LOCK CONTROLS  %>
        <tr>
            <td nowrap colspan="3">&nbsp;</td>
        </tr>
        <tr>
            <td nowrap colspan="3"><b><%= daBean.getResourceString("attrib.sectionHeader.propertyLock")%></b></td>
        </tr>
        <tr>
            <td>&nbsp;&nbsp;&nbsp;&nbsp;<input type="radio" name="propertyLock"  value="lock" id="rbLock" <%= daBean.getAttributeLockForTool().equalsIgnoreCase("lock") ? "checked" : "" %>></td>
            <td colspan="2"><label for="rbLock"><%= daBean.getResourceString("dvcAttribTool.propertyLock.lock")%></label></td>
        </tr>
        <tr>
            <td>&nbsp;&nbsp;&nbsp;&nbsp;<input type="radio" name="propertyLock"  value="unlock" id="rbUnlock" <%= daBean.getAttributeLockForTool().equalsIgnoreCase("unlock") ? "checked" : "" %>></td>
            <td colspan="2"><label for="rbUnlock"><%= daBean.getResourceString("dvcAttribTool.propertyLock.unlock")%></label></td>
        </tr>
        <tr>
            <td>&nbsp;&nbsp;&nbsp;&nbsp;<input type="radio" name="propertyLock"  value="ignore" id="rbIgnore" <%= daBean.getAttributeLockForTool().equalsIgnoreCase("ignore") ? "checked" : "" %>></td>
            <td colspan="2"><label for="rbIgnore"><%= daBean.getResourceString("dvcAttribTool.propertyLock.ignore")%></label></td>
        </tr>
        </table>
        <input type='hidden' id='timeStamp' name='timeStamp' value='<%=timeStamp%>'>
        </form>

        <script language="javascript" type="text/javascript">
            setFormSubmitName("dvcAttribsForm");
            displayTaskWizardButtons();
        </script>

        <%
    }
        %>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</BODY>
</HTML>
