<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.core.querymanager.components.SWTreeEventData" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="pspResourceSettings" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="initialPSPInstallBean" class="com.hp.mx.portal.taskandjob.InitialPSPInstall.InitialPSPInstallBean" scope="session" />
<jsp:useBean id="vcRepositoryBean" class="com.hp.mx.portal.settings.VCRepositorySetup" scope="session"/>


<%
    MxBean.jspInit(request, response);
    String cleanSweepURL = initialPSPInstallBean.getSupportPackConfigureURL("hpsmhd.exe");
    String vcaURL = initialPSPInstallBean.getSupportPackConfigureURL("vcagent.exe");
%>

<html>
    <head>
        <title><%= pspResourceSettings.getString("panel3.title") %></title>
        </title>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/taskandjob/css/taskAndJob.css'>
        <link href="<%= MxOptions.URL_BASE %>/css/MxPortalEx.css" rel="stylesheet" type="text/css">
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/taskWizard.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxPortalApi.js'></script>
        <script language='javascript'> MxPortalWorkspaceSetHelpTopic("useTools_psp_install");</script>
        <script language='javascript' type='text/javascript'>

        function configureCleanSweep()
        {
            var szUrl = "<%= cleanSweepURL %>";
            var configWindow = window.open(szUrl, "SupportPackConfig", "menubar=0, titlebar=0, toolbar=0, scrollbars=1, resizable=1, height=300, width=400");
            configWindow.focus();
        }

        function configureVCA()
        {
            var szUrl = "<%= vcaURL %>";
            var configWindow = window.open(szUrl, "SupportPackConfig", "menubar=0, titlebar=0, toolbar=0, scrollbars=1, resizable=1, height=300, width=400");
            configWindow.focus();
        }
        </script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxButton.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

    </head>

    <body>
        <script>
            setWizardStepText('<%= pspResourceSettings.getString("panel3.title") %>');
        </script>

    <%
        SWTreeEventData swTree = vcRepositoryBean.returnSelectedRepository();
        if (swTree != null)
        {
            // We have a tree, check for a repository version
            String reposVer = swTree.getRepositoryVersion();
            if (reposVer != null)
            {
                // We have a repository version, check that the
                // version is at least 2.0
                int majorVerNum = Integer.parseInt(reposVer.substring(0, 1));
                if (majorVerNum >= 2)
                {
                    // It's at least 2.0, display the Configure button(s). Check if
                    // Cleansweep is in the selected PSP. If so, then add a button
                    // to configure CleanSweep.
                    if (cleanSweepURL != null)
                    {
                        MxButtons cleanSweepButtons = new MxButtons();
                        cleanSweepButtons.clearMxTags();
                        cleanSweepButtons.addMxTag(new MxDefaultTag("configCleanSweepButton", pspResourceSettings.getString("panel3.configCleanSweepButton"),"configureCleanSweep()"));

                        // Cleansweep present. Display a Cleansweep button and the
                        // appropriate explanatory text
    %>
                        <%=pspResourceSettings.getString("panel3.explainCleanSweep") %><br><br>
                        <% cleanSweepButtons.dumpButtons(out);%><br>
    <%
                        if (vcaURL != null)
                        {
                            MxButtons configVCAButtons = new MxButtons();
                            configVCAButtons.clearMxTags();
                            configVCAButtons.addMxTag(new MxDefaultTag("configVCAButton", pspResourceSettings.getString("panel3.configVCAButton"),"configureVCA()"));

    %>
                            <%=pspResourceSettings.getString("panel3.explainVCAConfigure") %><br><br>
                            <% configVCAButtons.dumpButtons(out);%><br>
    <%
                        }
                    }
                    else if (vcaURL != null)
                    {
                        MxButtons configButtons = new MxButtons();
                        configButtons.clearMxTags();
                        configButtons.addMxTag(new MxDefaultTag("configButton", pspResourceSettings.getString("panel3.configButton"), "configureVCA()"));

                        // Cleansweep not present - display just the single configure button,
                        // and appropriate text
    %>
                        <%=pspResourceSettings.getString("panel3.explain") %><br><br>
                        <% configButtons.dumpButtons(out);%><br>
    <%
                    }
                    else
                    {
    %>
                        <%=pspResourceSettings.getString("panel3.noVCAExplain") %><br><br>
    <%
                    }
                }
                else
                {
                    // It's not at least 2.0, display upgrade text
    %>
                    <%=pspResourceSettings.getString("panel3.badVCRVersionExplain1") %></p>
                    <%=pspResourceSettings.getString("panel3.badVCRVersionExplain2") %></p>
                    <%=pspResourceSettings.getString("panel3.badVCRVersionExplain3") %></p>
    <%
                }
            }
        }
    %>

        <script language='javascript' type='text/javascript'>
            displayTaskWizardButtons(); // display Previous/Next
            // if we are arriving at this page as a result of "Prev" button being clicked, then
            // we have to clear the setFormSubmitName() set in CPP4.
            if (<%=request.getParameter("prev")%> != null)
            {
                setFormSubmitName("");
            }
        </script>

<% MxHtmlUtil.dumpBodyEnd(out); %>

    </body>
</html>
