<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="MpControlSettingsBean" class="com.hp.mx.portal.taskandjob.MpTools.MpControlSettings.MxMpControlSettings" scope="session"/>
<jsp:useBean id="taskWizardBean" class="com.hp.mx.portal.taskandjob.MxTaskWizard" scope="session"/>


<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*"%>

<%@ page import="com.hp.mx.portal.res.MxResourceBean"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskWizardInstance"%>
<%@ page import="com.hp.mx.portal.taskandjob.MpTools.MpControlSettings.MxMpControlSettingsCommandToolParameters"%>
<%@ page import="com.hp.mx.portal.ui.MxBean"%>
<%@ page import="com.hp.mx.portal.ui.MxOptions"%>

<%
    // set header info
    MxBean.jspInit(request, response);

    // check to see if the loginBean session has timed out
    if (loginBean.checkLogoutConditionForWebPage(pageContext) == true)
    {
        return;
    }

    String timeStamp=request.getParameter("timeStamp");
    MxTaskWizardInstance inst=(MxTaskWizardInstance) taskWizardBean.getInstance(timeStamp);
    // is this a task edit?
    boolean editTask = (request.getParameter("edit") != null);

    if ((MpControlSettingsBean.isFirstTime() == true) || (editTask == true))
    {
        // initialize the Bean (resource bundle, etc)
        MpControlSettingsBean.initialize(loginBean, (MxMpControlSettingsCommandToolParameters)inst.getTaskUserParameters());
    }

    // get the resource bundle for localized string display
    MxResourceBean rb = MpControlSettingsBean.getRB();

    // use this value to populate the password fields.  If it is the default, "abfd98%"
    // we don't set the value.  This default value is used to disguise the length
    String passwordValue = "";

%>
<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC
    "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
    <title></title>
    <link rel="stylesheet" type="text/css" href='<%=MxOptions.URL_BASE%>/taskandjob/css/taskAndJob.css'/>
    <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/taskWizard.js'>
    </script>
    <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js'>
    </script>
    <script src="../../js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
    </script>
    <script language='javascript' type='text/javascript'>


     var requiredItems=0;
     var checkedItems=0;

     function changeWizardButtonEnabled(state){
         if(state==true)
         {
             checkedItems++;
         }
         else
         {
             checkedItems--;
         }

         if(checkedItems>requiredItems)
         {
             enableWizardButtons(true);
         } else
         {
             enableWizardButtons(false);
         }

     }

     function clearLogsChanged(){
             changeWizardButtonEnabled(document.getElementById("clearLogs").checked);

     }

     function restoreDefsChanged(){
             changeWizardButtonEnabled(document.getElementById("restoreDefaults").checked);

     }

     function resetChanged(){
             changeWizardButtonEnabled(document.getElementById("resetILO").checked);

     }

    /////////////////////////////////////
    // checkRequiredFields()
    /////////////////////////////////////
    function checkRequiredFields()
    {
        enableWizardButtons(checkedItems>requiredItems);
    }
    /////////////////////////////////////
    // enableWizardButtons()
    /////////////////////////////////////
    function enableWizardButtons(enable)
    {
        // enable or disable the "Schedule" button
        enableButton(document.getElementById("scheduleBtn"), enable);
        // enable or disable the "Run Now" button
        enableButton(document.getElementById("runNowBtn"), enable);
    }
    /////////////////////////////////////
    // scheduleButtonFunction()
    /////////////////////////////////////
    function scheduleButtonFunction()
    {
        if ( document.getElementById("resetILO").checked)
        {
                var return_value = confirm('<%=rb.getString("MPCTRL_RESET_CONFIRM")%>'+'\n'+ '<%=rb.getString("PROMPT_CONTINUE")%>');
                if ( return_value == false ){
                    setReloadOnError(false);
                    checkRequiredFields();
                    return false;
                }
         }


            setReloadOnError(false);
            return true;

    }
    /////////////////////////////////////
    // runNowButtonFunction()
    /////////////////////////////////////
    function runNowButtonFunction()
    {
        return scheduleButtonFunction();
    }
    /////////////////////////////////////
    // setFocus()
    /////////////////////////////////////
    function setFocus()
    {
        var field = document.getElementById('clearLogs');

        if ((field != null) && (field.disabled == false))
        {
            field.focus();
        }
    }
    </script>
<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxButton.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>
</head>

    <body>
<%
    ///////////////////////////////////////////////////////////////////////////
    // IS THIS A post?  Check data validity and redirect
    ///////////////////////////////////////////////////////////////////////////
    if (request.getMethod().equals("POST") == true)
    {
        StringBuffer clearLogsAction = new StringBuffer("");
        if(request.getParameter("clearLogs")!=null)
                clearLogsAction.append(request.getParameter("clearLogs"));

        StringBuffer restoreDefsAction = new StringBuffer("");
        if(request.getParameter("restoreDefaults")!=null)
                restoreDefsAction.append(request.getParameter("restoreDefaults"));

        StringBuffer resetILOAction = new StringBuffer("");
        if(request.getParameter("resetILO")!=null)
                resetILOAction.append(request.getParameter("resetILO"));

 %>

    <jsp:setProperty name="MpControlSettingsBean" property="clearLogs" value="<%=clearLogsAction.toString()%>"/>
    <jsp:setProperty name="MpControlSettingsBean" property="restoreDefaults" value="<%=restoreDefsAction.toString()%>"/>
    <jsp:setProperty name="MpControlSettingsBean" property="resetILO" value="<%=resetILOAction.toString()%>"/>
<%

        if (MpControlSettingsBean.isControlSettingsInfoValid() == true)
        {

            MpControlSettingsBean.setArgumentValues();
            MxMpControlSettingsCommandToolParameters params = MpControlSettingsBean.getToolParameters();
            inst.setTaskUserParameters(params);

            // User data is valid, go to the next wizard step
            %>

    <script language='javascript' type='text/javascript'>
    loadWizardNextStep();
    </script>
            <%
        }
        else
        {
            // User data is invalid, redisplay the same wizard step
            %>

    <script language='javascript' type='text/javascript'>
    loadWizardCurrentStep();
    </script>
            <%
        }
    }

    ///////////////////////////////////////////////////////////////////////////
    // THIS IS NOT A post - Display normally
    ///////////////////////////////////////////////////////////////////////////
    else
    {
 %>

    <script language='javascript' type='text/javascript'>
    setWizardStepText('<%=rb.getString("WIZARD_TITLE_MP_CONTROL")%>');
    </script>
    <script language="JavaScript">
            MxPortalWorkspaceSetHelpTopic("useTools_mgmtProc_iLOControl") ;
    </script>

    <form id="controlForm" name="controlForm" action="MpControlCPP1.jsp" method="post">
        <table border="0"  cellspacing="0" cellpadding="0" style="white-space: nowrap;">
            <tr>
                <td rowspan='40'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                <td > <input type="checkbox" name="clearLogs" id="clearLogs" value="on" onclick="clearLogsChanged();" /><%=rb.getString("MPCTRL_CLEAR_LOGS")%><br /></td>
            </tr>

            <tr>
                <td > <input type="checkbox" name="resetILO" id="resetILO" value="on" onclick="resetChanged();" /><%=rb.getString("MPCTRL_RESET_ILO")%><br /></td>
            </tr>
        </table>
        <input type='hidden' id='timeStamp' name='timeStamp' value='<%=timeStamp%>' />
    </form>
    <br/>
    <br/>

    <script language='javascript' type='text/javascript'>
    setFormSubmitName("controlForm")
    // display Previous/Next
    displayTaskWizardButtons();
    // set the focus to the 'username' field
    setFocus();
    // check required fieldsto allow page advancement
    checkRequiredFields();
    </script>
<%
    }
%>

    </body>
<% MxHtmlUtil.dumpBodyEnd(out); %>
</html>
