<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="MpInstallSSHKeyBean" class="com.hp.mx.portal.taskandjob.MpTools.MpInstallSSHKey.MxMpInstallSSHKey" scope="session"/>
<jsp:useBean id="taskWizardBean" class="com.hp.mx.portal.taskandjob.MxTaskWizard" scope="session"/>

<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*"%>

<%@ page import="com.hp.mx.portal.res.MxResourceBean"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskWizardInstance"%>
<%@ page import="com.hp.mx.portal.taskandjob.MpTools.MpInstallSSHKey.MxMpInstallSSHKeyCommandToolParameters"%>
<%@ page import="com.hp.mx.portal.ui.MxBean"%>
<%@ page import="com.hp.mx.portal.ui.MxOptions"%>

<%
    // set header info
    MxBean.jspInit(request, response);

    // check to see if the loginBean session has timed out
    if (loginBean.checkLogoutConditionForWebPage(pageContext) == true)
    {
        return;
    }

    String timeStamp=request.getParameter("timeStamp");
    MxTaskWizardInstance inst=(MxTaskWizardInstance) taskWizardBean.getInstance(timeStamp);
    // is this a task edit?
    boolean editTask = (request.getParameter("edit") != null);

    if ((MpInstallSSHKeyBean.isFirstTime() == true) || (editTask == true))
    {
        // initialize the Bean (resource bundle, etc)
        MpInstallSSHKeyBean.initialize(loginBean, (MxMpInstallSSHKeyCommandToolParameters)inst.getTaskUserParameters());
    }

    // get the resource bundle for localized string display
    MxResourceBean rb = MpInstallSSHKeyBean.getRB();

    // use this value to populate the password fields.  If it is the default, "abfd98%"
    // we don't set the value.  This default value is used to disguise the length
    String passwordValue = "";

%>
<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC
    "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
    <title></title>
    <link rel="stylesheet" type="text/css" href='<%=MxOptions.URL_BASE%>/taskandjob/css/taskAndJob.css'/>
    <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/taskWizard.js'>
    </script>
    <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js'>
    </script>

    <script src="../../js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
    </script>
    <script language='javascript' type='text/javascript'>
    // username and password values
    var loginid        = null;
    var password        = null;
    var passwordConfirm = null;



    /////////////////////////////////////
    // checkRequiredFields()
    /////////////////////////////////////
    function checkRequiredFields()
    {
        var enableButton = true;
        if (document.getElementById("username").value == '' ||
            document.getElementById("password").value == '' ||
            document.getElementById("passwordConfirm").value == '')
        {
            enableButton = false;
        }

        // if all passes, then enable the Next button
        // else, disable it
        enableWizardButtons(enableButton);
    }
    /////////////////////////////////////
    // enableWizardButtons()
    /////////////////////////////////////
    function enableWizardButtons(enable)
    {
        // enable or disable the "Schedule" button
        enableButton(document.getElementById("scheduleBtn"),false);
        // enable or disable the "Run Now" button
        enableButton(document.getElementById("runNowBtn"), enable);
    }
    /////////////////////////////////////
    // scheduleButtonFunction()
    /////////////////////////////////////
    function scheduleButtonFunction()
    {
        password        = document.getElementById("password").value;
        passwordConfirm = document.getElementById("passwordConfirm").value;
/*
        if(document.getElementById("username").value !="Admin"){
            var return_value = confirm('<%=rb.getString("KEY_OTHER_CONFIRM")%>'+'\n'+'<%=rb.getString("PROMPT_CONTINUE")%>');
            if ( return_value == false ){
                setReloadOnError(false);
                checkRequiredFields();
                return false;
            }
        }
*/
        if(password!=''){
            if ((password == passwordConfirm))
            {

                setReloadOnError(false);
                return true;
            }else{

            setReloadOnError(false);
            alert('<%=rb.getString("PASSWORD_MISMATCH")%>');
            return false;
            }


        }

        setReloadOnError(false);
        return true;

    }
    /////////////////////////////////////
    // runNowButtonFunction()
    /////////////////////////////////////
    function runNowButtonFunction()
    {
        return scheduleButtonFunction();
    }
    /////////////////////////////////////
    // setFocus()
    /////////////////////////////////////
    function setFocus()
    {
        var field = document.getElementById('loginid');

        if ((field != null) && (field.disabled == false))
        {
            field.focus();
        }
    }

    </script>
<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxButton.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>
</head>

    <body>
<%
    ///////////////////////////////////////////////////////////////////////////
    // IS THIS A post?  Check data validity and redirect
    ///////////////////////////////////////////////////////////////////////////
    if (request.getMethod().equals("POST") == true)
    {


 %>

    <jsp:setProperty name="MpInstallSSHKeyBean" property="password" value="<%=request.getParameter(\"password\")%>"/>
    <jsp:setProperty name="MpInstallSSHKeyBean" property="username" value="<%=request.getParameter(\"username\")%>"/>
<%

        if (MpInstallSSHKeyBean.isInstallSSHKeyInfoValid() == true)
        {

            MpInstallSSHKeyBean.setArgumentValues();
            MxMpInstallSSHKeyCommandToolParameters params = MpInstallSSHKeyBean.getToolParameters();
            inst.setTaskUserParameters(params);

            // User data is valid, go to the next wizard step
            %>
    <script language='javascript' type='text/javascript'>
    loadWizardNextStep();
    </script>
            <%
        }
        else
        {
            // User data is invalid, redisplay the same wizard step
            %>

    <script language='javascript' type='text/javascript'>
    loadWizardCurrentStep();
    </script>
            <%
        }
    }

    ///////////////////////////////////////////////////////////////////////////
    // THIS IS NOT A post - Display normally
    ///////////////////////////////////////////////////////////////////////////
    else
    {
 %>

    <script language='javascript' type='text/javascript'>
    setWizardStepText('<%=rb.getString("WIZARD_TITLE_KEY")%>');
    </script>
    <script language="JavaScript">
            MxPortalWorkspaceSetHelpTopic("useTools_mgmtProc_deploySSHPublicKey") ;
    </script>

    <form id="InstallSSHKeyForm" name="InstallSSHKeyForm" action="MpInstallSSHKeyCPP1.jsp" method="post">

        <table cellspacing='0' cellpadding='0' border='0' style="white-space: nowrap;">
            <tr>
                <td><%=rb.getString("ENTER_CREDS")%></td>
            </tr>
        </table>

        <br/>
        <table cellpadding='0' cellspacing='0' border='0' style="white-space: nowrap;">
            <tr>
                <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>

                <td>
                     <rowspan style="color:#000000; font-size:10px;"><%=rb.getString("REQUIRED_FIELD")%>&nbsp;*</span>
                </td>
            </tr>
        </table>



        <table border="0"  cellspacing="0" cellpadding="0" style="white-space: nowrap;">
            <tr>
                <td rowspan="40">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                <td height="17px" colspan="3" ></td>
            </tr>

       <!--     <tr>
                <td  height="10px" colspan="3"></td>
            </tr>-->

            <tr>
                <td height="17px" colspan="2">&nbsp;&nbsp;&nbsp;<%=rb.getString("USERNAME")%><span style="color:#000000;">&nbsp;*</span>&nbsp;&nbsp;</td>
                <td><input type="text" id="username" name="username" value="Admin" size="20" onkeyup='checkRequiredFields()' /></td>
            </tr>

             <tr>
                <td height="17px" colspan="2">&nbsp;&nbsp;&nbsp;<%=rb.getString("PASSWORD")%><span style="color:#000000;">&nbsp;*</span>&nbsp;&nbsp;</td>
                <td><input type="password" id="password" name="password" value="" size="20"  onkeyup='checkRequiredFields()' /></td>
            </tr>

            <tr>
                <td height="17px" colspan="2">&nbsp;&nbsp;&nbsp;<%=rb.getString("CONFIRM_PASSWORD")%><span style="color:#000000;">&nbsp;*</span>&nbsp;&nbsp;</td>
                <td><input type="password" id="passwordConfirm" name="passwordConfirm" value="" size="20"  onkeyup='checkRequiredFields()' /></td>
            </tr>

        </table>
       <input type='hidden' id='timeStamp' name='timeStamp' value='<%=timeStamp%>' />
      </form>
    <br/>
    <br/>

    <script language='javascript' type='text/javascript'>
    setFormSubmitName("InstallSSHKeyForm")
    // display Previous/Next
    displayTaskWizardButtons();
    // set the focus to the 'username' field
    setFocus();
    // check required fieldsto allow page advancement
    checkRequiredFields();
    </script>
<%
    }
%>

    </body>
<% MxHtmlUtil.dumpBodyEnd(out); %>
</html>
