<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.core.tools.swmaintenance.SWDeploymentDataModel" %>
<%@ page import="com.hp.mx.portal.taskandjob.InitialPSPInstall.InitialPSPInstallCommandToolParameters" %>
<%@ page import="com.hp.mx.core.controllers.MxNodeController" %>
<%@ page import="com.hp.mx.core.nodemanager.MxNode" %>
<%@ page import="com.hp.mx.exceptions.MxException" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="java.util.Enumeration" %>
<%@ page import="javax.swing.table.AbstractTableModel" %>
<%@ page import="com.hp.mx.html.table.*" %>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskWizardInstance"%>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="ussResourceSettings" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="pspResourceSettings" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="updateSystemSoftwareBean" class="com.hp.mx.core.tools.swmaintenance.UpdateSystemSoftwareBean" scope="session" />
<jsp:useBean id="taskWizardBean" class="com.hp.mx.portal.taskandjob.MxTaskWizard" scope="session"/>

<%
    MxBean.jspInit(request, response);

    // Get the Instance Data for this Task Wizard Instance
    String               timeStamp = request.getParameter("timeStamp");
    MxTaskWizardInstance inst      = (MxTaskWizardInstance)taskWizardBean.getInstance(timeStamp);

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();

    buttons.addMxTag(new MxDefaultTag("", ussResourceSettings.getString("componentTable.moveUp"), "moveComponentButton('up')"));
    buttons.addMxTag(new MxDefaultTag("", ussResourceSettings.getString("componentTable.moveDown"), "moveComponentButton('down')"));

    buttons.setSecondary();
%>

<html>
    <head>
        <title><%= ussResourceSettings.getString("panel2.title") %></title>
        </title>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/taskandjob/css/taskAndJob.css'>
        <link href="<%= MxOptions.URL_BASE %>/css/MxPortalEx.css" rel="stylesheet" type="text/css">
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/taskWizard.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxPortalApi.js'></script>
        <script language='javascript'> MxPortalWorkspaceSetHelpTopic("useTools_uss_install");</script>
        <script language='javascript' type='text/javascript'>

            function myResize()
            {
                var iframe = document.getElementById("componentTable");
            }

            function moveComponentButton(direction)
            {
                var iframe = document.getElementById("componentTable");
                iframe.contentWindow.document.location.replace("UpdateSystemSoftwareComponentTable.jsp?direction="+direction);
            }

            function runNowButtonFunction()
            {
                //document.ussOptionsForm.submit();
                return true;
            }

            function scheduleButtonFunction()
            {
                return runNowButtonFunction();
            }

        </script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxButton.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

    </head>

    <body onLoad='myResize()' onResize='myResize()'>
    <%
    ///////////////////////////////////////////////////////////////////////////
    // IS THIS A POST?  Check data validity and redirect
    ///////////////////////////////////////////////////////////////////////////
    if (request.getMethod().equals("POST"))
    {
        // Set force, reboot and wakeUp
        String param = request.getParameter("force");
        updateSystemSoftwareBean.setForce(param == null ? false : param.equals("on"));
        param = request.getParameter("reboot");
        updateSystemSoftwareBean.setReboot(param == null ? false : param.equals("on"));
        param = request.getParameter("wakeUp");
        updateSystemSoftwareBean.setWakeUp(param == null ? false : param.equals("on"));

        // Set the task user parameters
        SWDeploymentDataModel ctp = updateSystemSoftwareBean.getTaskUserParameters();
        inst.setTaskUserParameters(ctp);
    %>
        <script>loadWizardNextStep();</script>
    <%
    }
    ///////////////////////////////////////////////////////////////////////////
    // THIS IS NOT A POST - Display normally
    ///////////////////////////////////////////////////////////////////////////
    else
    {
        %>
        <script>
            setWizardStepText('<%= ussResourceSettings.getString("panel2.title") %>');
        </script>

        <!-- <iframe> for component table -->
        <%=ussResourceSettings.getString("panel2.moveComponents") %>
        <iframe id='componentTable' name='componentTree' style='width:100%; height:100' scrolling='yes' marginwidth='0' frameborder='1' src="UpdateSystemSoftwareComponentTable.jsp?direction=none">
        </iframe>

        <div style="margin-top:15px">
            <% buttons.dumpButtons(out); %>
        </div>

        <br>

        <%=ussResourceSettings.getString("panel2.explain") %><br><br>

        <form id="ussOptionsForm" name="ussOptionsForm" action="UpdateSystemSoftwareCPP2.jsp" method="post">
            <input type="checkbox" name="force" id="force" <% if (updateSystemSoftwareBean.getForce()) out.print("checked"); %>><b><%= pspResourceSettings.getString("panel2.forceDowngrade") %></b><br>
            <input type="checkbox" name="wakeUp" id="wakeUp" <% if (updateSystemSoftwareBean.getWakeUp()) out.print("checked"); %>><b><%= ussResourceSettings.getString("panel2.wakeUp") %></b><br>
            <input type="checkbox" name="reboot" id="reboot" <% if (updateSystemSoftwareBean.getReboot()) out.print("checked"); %>><b><%= pspResourceSettings.getString("panel2.reboot") %></b><br>
            <input type='hidden' id='timeStamp' name='timeStamp' value='<%=timeStamp%>'>
        </form>
        <script>
            setFormSubmitName("ussOptionsForm")
        </script>

        <script language='javascript' type='text/javascript'>
            displayTaskWizardButtons(); // display Previous/Next
        </script>

    <%
    }
    %>

<% MxHtmlUtil.dumpBodyEnd(out); %>

    </body>
</html>
