<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="tasksBean" class="com.hp.mx.portal.taskandjob.MxTaskAndJob" scope="session"/>

<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobResourceBundle"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobInstance"%>
<%@ page import="com.hp.mx.portal.ui.MxBean"%>
<%@ page import="com.hp.mx.portal.ui.MxOptions"%>

<%
    // set header info
    MxBean.jspInit(request, response);

    // check to see if the loginBean session has timed out
    if (loginBean.checkLogoutConditionForWebPage(pageContext) == true)
    {
        return;
    }

    String               taskAndJobTimeStamp = request.getParameter("taskAndJobTimeStamp");
    MxTaskAndJobInstance inst                = (MxTaskAndJobInstance)tasksBean.getInstance(taskAndJobTimeStamp);

    String                     taskName = inst.getSelectedTaskName();
    int                        numJobs  = inst.getTotalNumJobs();
    MxTaskAndJobResourceBundle rb       = inst.getRB();

    StringBuffer msgRunning = new StringBuffer(200);
    StringBuffer msgDelete  = new StringBuffer(200);

    msgRunning.append(rb.getString("DELETE_TASK_1"));
    msgRunning.append(" '");
    msgRunning.append(taskName);
    msgRunning.append("' ");
    msgRunning.append(rb.getString("DELETE_TASK_2"));
    msgRunning.append("  ");
    msgRunning.append(rb.getString("DELETE_TASK_3"));

    msgDelete.append(rb.getString("DELETE_TASK_4"));
    msgDelete.append(" '");
    msgDelete.append(taskName);
    msgDelete.append("' ");
    msgDelete.append(rb.getString("DELETE_TASK_5"));

    if (numJobs > 0)
    {
        msgDelete.append("  ");
        msgDelete.append(rb.getString("DELETE_TASK_6"));
        msgDelete.append(" ");
        msgDelete.append(numJobs);
        msgDelete.append(" ");
        msgDelete.append(rb.getString("DELETE_TASK_7"));
    }

    boolean taskRunning = inst.isSelectedTaskRunning();
%>

<html>
    <head>
        <title></title>
        <script language='javascript' type='text/javascript' src='/SessionReset.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js'></script>
        <script language='javascript' type='text/javascript'>
            // ask confirm question or display error message
            if (<%=taskRunning%> == true)
            {
                alert("<%=msgRunning.toString()%>");
                parent.ourButtonManager.enableButtonById('btnDelete');
                parent.deleteOpen = false;
            }
            else
            {
                var answer = confirm("<%=msgDelete.toString()%>");

                if (answer == true)
                {
                    parent.ourButtonManager.disableButtonById('btnRun');
                    parent.ourButtonManager.disableButtonById('btnEdit');
                    parent.ourButtonManager.disableButtonById('btnDelete');

                    // set taskResult & taskInstanceResults iframe to MxBlank.html
                    var iframe = parent.document.getElementById('taskResults');
                    iframe.contentWindow.document.location.replace('<%=MxOptions.URL_BASE%>/home/MxBlank.html');
                    iframe.style.visibility = 'hidden';

                    iframe = parent.document.getElementById('taskInstanceResults');
                    iframe.contentWindow.document.location.replace('<%=MxOptions.URL_BASE%>/home/MxBlank.html');
                    iframe.style.visibility = 'hidden';

                    // do the delete
                    document.location.replace('deleteTask.jsp?taskAndJobTimeStamp=<%= taskAndJobTimeStamp %>');
                }
                else
                {
                    parent.ourButtonManager.enableButtonById('btnDelete');
                    parent.deleteOpen = false;
                }
            }
        </script>
    </head>

    <body>
    </body>
</html>
