<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="taskWizardBean" class="com.hp.mx.portal.taskandjob.MxTaskWizard" scope="session"/>

<%@ page import="com.hp.mx.core.client.MxCollectionClient"%>
<%@ page import="com.hp.mx.core.collectionmanager.MxCollection"%>
<%@ page import="com.hp.mx.core.collectionmanager.MxCollectionConstants_t"%>
<%@ page import="com.hp.mx.html.tree.MxTreeController"%>
<%@ page import="com.hp.mx.html.tree.MxTreeSelectionModel"%>
<%@ page import="com.hp.mx.html.tree.MxTreeView"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobResourceBundle"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskWizardInstance"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTreeBuilder"%>
<%@ page import="com.hp.mx.portal.ui.MxBean"%>
<%@ page import="com.hp.mx.portal.ui.MxOptions"%>

<%
    // if we've made it this far, we're going to be rendering this page
    // set header info
    MxBean.jspInit(request, response);

    // check to see if the loginBean session has timed out
    if (loginBean.checkLogoutConditionForWebPage(pageContext) == true)
    {
        return;
    }

    // generate timeStamp for this TimeFilters instance
    String               timeStamp = request.getParameter("timeStamp");
    MxTaskWizardInstance inst      = (MxTaskWizardInstance)taskWizardBean.getInstance(timeStamp);

    if (inst == null)
    {
        return;
    }

    MxTreeController controller = inst.getTreeViewController();

    // check for controller messages
    if (controller.checkUrlForControllerMessages(request, out) == true)
    {
       return;
    }

    // get the tree view object
    MxTreeView treeView = inst.getTreeView();

    // for localized strings
    MxTaskAndJobResourceBundle rb = inst.getRB();

    String     selectionType = request.getParameter("selectionType");
    String     listType      = request.getParameter("listType");
    String     height        = request.getParameter("height");
    String     GUID          = request.getParameter("collectionID");

    // if we have the "noAuth" parameter, then pass that onto our
    // collectionEnumerator so we get all unfiltered Collection.Query and Node.
    boolean    noAuth        = (request.getParameter("noAuth") != null);

    MxTreeBuilder treeBuilder = inst.getTreeBuilder();

    // set selectionType in tree builder and set selectionModel
    treeBuilder.setSelectionType(selectionType);
    treeBuilder.setListType(listType);
    treeBuilder.setCollectionGUID(GUID);

    treeBuilder.buildTree(noAuth);

    boolean showTreeView = false;

    if (treeBuilder.getNumChildren() > 0)
    {
        showTreeView = true;
        controller.setTreeModel(treeBuilder.getTreeModel());
    }

    // clear the set() call in the TreeBuilder for the next time it is used
    treeBuilder.clearSets();
%>

<html>
    <head>
        <title></title>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/taskandjob/css/taskAndJob.css'>
        <script language='javascript' type='text/javascript' src='/SessionReset.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxPortalApi.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/targetSelection.js'></script>
        <script language='javascript' type='text/javascript'>
            ///////////////////////
            // applyFunction()
            // the target selection page looks for this function and calls it if it is found.
            // if done, we have to complete the real apply function afterour processing
            ///////////////////////
            function applyFunction()
            {
                // replace self with the selectItems.jsp, and that page
                // calls the applyChangeTargets() on the TSP
                var url = "<%=MxOptions.URL_BASE%>/taskandjob/selectItems.jsp?timeStamp=<%=timeStamp%>";
                location.replace(url);
            }
            //////////////////////
            // myOnSelectionChange()
            // this is called when the treeView selection changes
            //////////////////////
            function myOnSelectionChange(treeID, spanID, selected)
            {
                var url = "<%=MxOptions.URL_BASE%>/taskandjob/checkTreeSelection.jsp?timeStamp=<%=timeStamp%>";
                // call method in twInstance to count selections in selection model
                // and enable|disable the apply button accordingly
                document.getElementById("action").contentWindow.document.location.replace(url);
            }
            ////////////////////////////////////////////////
            // myIframeSet()
            ////////////////////////////////////////////////
            function myIframeSet()
            {
                var minWidth    = getIframeTop(this).minWidth;
                var windowWidth = MxPortalGetWorkspaceFrame().offsetWidth - NETSCAPE_SCROLLBAR_WIDTH;
                var newWidth    = (minWidth >= windowWidth) ? minWidth : '100%';
                // set width of our <iframe>
                parent.document.getElementById(this.name).style.width = newWidth;

                setTimeout('myIframeSet()', RESIZE_TIMEOUT);
            }
            ////////////////////////////////////////////////
            // myOnLoad()
            ////////////////////////////////////////////////
            function myOnLoad()
            {
                // get the width our element takes up
                var element1   = document.getElementById('treeTable');
                var myMinWidth = element1.offsetWidth;
                // attempt to set this as the minimum (there may
                // already be a larger value that is the minimum)
                setMinWidth(myMinWidth);
                // normal startup procedures
                myIframeSet();
                // now call parent function to display the "entire" checkbox
                parent.nodeListDoneLoading();
            }
        </script>
<%
    if (showTreeView == true)
    {
        treeView.dumpHeadContent(out);
    }
%>
    </head>

    <body onload="myOnLoad()">

        <table id='treeTable' border='0' cellspacing='0' cellpadding='0' style="width:420">
            <tr>
                <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                <td>
<%
    if (showTreeView == true)
    {
        treeView.dumpExpansionButtons(out);
    }
%>
                </td>
            </tr>
            <tr><td>&nbsp;</td></tr>
            <tr>
                <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
                <td nowrap>
                    <div id='collectionDiv' style='overflow:auto; height:<%=height%>; width:375'>
<%
    if (showTreeView == true)
    {
        treeView.dumpTree(out);
    }
    else
    {
        out.println(rb.getString("EMPTY_GROUP"));
    }
%>
                    </div>
                </td>
            </tr>
        </table>

        <iframe id='action' name='action' style='width:0; height:0; position:relative; visibility:hidden'
                scrolling='no' marginwidth='0' frameborder='0' src='<%=MxOptions.URL_BASE%>/home/MxBlank.html'>
        </iframe>

    </body>
</html>
