<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="tasksBean" class="com.hp.mx.portal.taskandjob.MxTaskAndJob" scope="session"/>

<%@ page import="com.hp.mx.portal.ui.MxBean"%>
<%@ page import="com.hp.mx.portal.ui.MxOptions"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobInstance"%>

<%@ page import="com.hp.mx.core.authorizationmanager.MxAuthorizationManager"%>
<%@ page import="com.hp.mx.core.objectmodel.MxObjectID"%>
<%@ page import="com.hp.mx.core.objectmodel.MxGUID"%>
<%@ page import="com.hp.mx.core.toolmanager.MxTool"%>
<%@ page import="com.hp.mx.core.client.MxToolClient"%>

<%
    // set header info
    MxBean.jspInit(request, response);

    // check to see if the loginBean session has timed out
    if (loginBean.checkLogoutConditionForWebPage(pageContext) == true)
    {
        return;
    }

    String                 taskAndJobTimeStamp = request.getParameter("taskAndJobTimeStamp");
    MxTaskAndJobInstance   inst                = (MxTaskAndJobInstance)tasksBean.getInstance(taskAndJobTimeStamp);

    MxToolClient           toolClient          = loginBean.getToolClient();
    MxGUID                 toolGUID            = new MxGUID(inst.getSelectedTaskToolID());
    MxObjectID             toolID              = new MxObjectID(toolGUID);
    MxTool                 tool                = toolClient.getTool(toolID);
    boolean                auth                = true;
    MxAuthorizationManager authMgr             = MxAuthorizationManager.getDefaultManager();
    String                 noAuthMsg           = inst.getRB().getString("NO_AUTH_ERROR_0");

    if (authMgr.isUserAuthorizedForTool(tool, loginBean.getMxUser()) == false)
    {
        auth = false;
    }
%>

<html>
    <head>
        <title></title>
        <script language='javascript' type='text/javascript' src='/SessionReset.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxPortalApi.js'></script>
        <script language='javascript' type='text/javascript'>
            if (<%=auth%> == false)
            {
                alert("<%=noAuthMsg%>");
                parent.ourButtonManager.enableButtonById('btnEdit');
            }
            else
            {
                MxPortalWorkspaceCreate('<%=inst.getSelectedTaskToolID()%>', 'edit=1&taskID=<%=inst.getSelectedTaskID()%>');
            }
        </script>
    </head>

    <body>
    </body>
</html>
