<%--
//$Source: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/taskandjob/myToolsCustomEnvVars.jsp,v $
//$Revision: 1.20 $
//$Date: 2005/02/01 21:02:18 $
--%>
<!-- ---------------------------------------------------------------------- -->
<!--  Put all your Java imports here -->
<!-- ---------------------------------------------------------------------- -->
<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.utilities.DebugOutput" %>
<%@ page import="com.hp.mx.utilities.DebugSubsystem" %>
<%@ page import="javax.swing.table.AbstractTableModel" %>
<%@ page import="com.hp.mx.html.table.*" %>



<!-- ---------------------------------------------------------------------- -->
<!--  Create all your beans here -->
<!-- ---------------------------------------------------------------------- -->
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="myToolsRbSettings" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="myCustomToolsUIBean" class="com.hp.mx.portal.taskandjob.MyCustomToolsUIBean" scope="session" />
<jsp:useBean id="debugBean" class="com.hp.mx.portal.ui.MxBean" scope="session" />
<jsp:useBean id="myCustomEnvVarsSelectionModel" class="com.hp.mx.html.table.MxDefaultTableSelectionModel" scope="session" />
<jsp:useBean id="myCustomEnvVarsTableView" class="com.hp.mx.html.table.MxTableView2" scope="session" />
<jsp:useBean id="myCustomEnvVarsTableController" class="com.hp.mx.html.table.MxTableController" scope="session" />

<!-- ---------------------------------------------------------------------- -->
<!--  Put one block of initialization Java code here -->
<!--  In general, keep Java code to a minimum. Put Java code into JavaBeans. -->
<!-- ---------------------------------------------------------------------- -->
<%!
    public DebugSubsystem myDebug = DebugOutput.getDebugSubsystem("AppLaunch");
    public boolean newFromList=true;
    public boolean editMode = false;
    public String  toolGUID = null;
    public String myCustomEnvVarsTableDomId = "ID_MY_APPLICATIONLAUNCH_CUSTOM_ENVVARS_TABLE";
%>
<%
    // REQUIRED: This line is required by Tomcat for i18n support.
    MxBean.jspInit(request, response);

    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    // Do we need to abort?
    if (myCustomEnvVarsTableController.checkUrlForControllerMessages(request, out)) return;

    // EXAMPLE: follow references to this bean for i18n support using resource bundles
    myToolsRbSettings.init(loginBean, "MyCustomTools");

    AbstractTableModel tableModel = null;

    //if (myCustomEnvVarsTableController.isFirstTime() ||
    //    myCustomToolsUIBean.isTimeToReinitTableModel())
    if (myCustomEnvVarsTableController.isFirstTime())
    {
        // Initialize the bean
        if (myCustomToolsUIBean.isFirstTime())
        {
          myCustomToolsUIBean.initialize(loginBean, myToolsRbSettings);
        }
        tableModel = myCustomToolsUIBean.getMyCustomEnvVarsTableModel();
        myCustomEnvVarsSelectionModel.setSelectionMode(MxTableSelectionModel.MULTIPLE_INTERVAL_SELECTION);

        myCustomEnvVarsTableView.setId(myCustomEnvVarsTableDomId);
        myCustomEnvVarsTableView.setOnSelectionChange("mySelectionChanged");
        myCustomEnvVarsTableView.setUrlHandler(request.getRequestURI());

        myCustomEnvVarsTableController.setTableModelWithSorting(tableModel);
        myCustomEnvVarsTableController.setSelectionModel(myCustomEnvVarsSelectionModel);
        myCustomEnvVarsTableController.setTableView(myCustomEnvVarsTableView);

        //myCustomToolsUIBean.setIsTimeToReinitTableModel(false);
    }
    else
    {
         tableModel = myCustomToolsUIBean.getMyCustomEnvVarsTableModel();
    }

    toolGUID = request.getParameter("toolID");

    MxButtons buttons = new MxButtons();
    MxButtons buttons2 = new MxButtons();
    buttons.clearMxTags();
    buttons2.clearMxTags();
    MxTag evAddTag = new MxDefaultTag("evAdd", myToolsRbSettings.getString("myCustomTools.new.ADD_BTN") + " >>", "finishedAdd()");
    MxTag evDeleteTag = new MxDefaultTag("evDelete", myToolsRbSettings.getString("myCustomTools.manage.DELETE_BTN"), "finishedDelete()");
    evAddTag.setAttr(MxTag.DISABLED, "true");
    evDeleteTag.setAttr(MxTag.DISABLED, "true");

    buttons.addMxTag(evAddTag);
    buttons2.addMxTag(evDeleteTag);
    buttons.setSecondary();
    buttons2.setSecondary();


%>

<HTML>
<HEAD>
    <link href="<%=MxOptions.URL_BASE%>/css/MxPortalEx.css" rel="stylesheet" type="text/css">
    <STYLE TYPE="text/css">
    <!--
        .indented{margin-left:12px;}
    -->
    </STYLE>
    <script src="<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js" type="text/javascript" language="JavaScript"></script>
    <script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
    <script type='text/javascript' language='JavaScript' src='<%=MxOptions.URL_BASE%>/js/utilities.js'></script>


    <script language='javascript'>
        function finishedAdd()
        {
            var myToolsForm = document.getElementById("myCustomEnvVarsForm");
            if (myToolsForm != null)
               myToolsForm.action="myToolsCustomEnvVars.jsp?mode=add&toolID=<%=toolGUID%>";
            document.myCustomEnvVarsForm.submit();
        }

        function finishedDelete()
        {
            var myToolsForm = document.getElementById("myCustomEnvVarsForm");
            if (myToolsForm != null)
               myToolsForm.action="myToolsCustomEnvVars.jsp?mode=delete&toolID=<%=toolGUID%>";
            document.myCustomEnvVarsForm.submit();
        }

        function isSpace(evValue)
        {
           for (var i=0; i < evValue.length; i++)
           {
               var evChar = evValue.charAt(i);
               if (evChar != ' ')
                 return false;
           }
           return true;
        }

        function checkRequiredFields()
        {
            if ((document.myCustomEnvVarsForm.envVariable.value.length > 0) &&
                 (document.myCustomEnvVarsForm.envValue.value.length > 0) &&
                  !isSpace(document.myCustomEnvVarsForm.envVariable.value) &&
                  !isSpace(document.myCustomEnvVarsForm.envValue.value))
            {
                ourButtonManager.enableButtonById('evAdd');
            }
            else
            {
                ourButtonManager.disableButtonById('evAdd');
            }
        }


        // The function called to perform selection change
        function mySelectionChanged(szIdTable, iRow, bSelected)
        {
            selectedRow = iRow;
            var aSel = MxTableGetSelections(szIdTable);

            // Set the buttons:
            if (aSel.length > 0)
            {
                ourButtonManager.enableButtonById('evDelete');
            }
            else
            {
                ourButtonManager.disableButtonById('evDelete');
            }
        }
    </script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% buttons.dumpHeadContent(out); %>
<% myCustomEnvVarsTableView.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</HEAD>
<BODY>
  <%
    ///////////////////////////////////////////////////////////////////////////
    // IS THIS A POST?  Check data validity and redirect
    ///////////////////////////////////////////////////////////////////////////
    //debugBean.displayJspParamsHtml(request, out);
    //debugBean.displayJspParamsToConsole(request);

    if (request.getMethod().equals("POST"))
    {
        String postMode = "";

        // YES! Read the source system name from the user entry field
        postMode = request.getParameter("mode");
        if (postMode.equalsIgnoreCase("add"))
        {
            myCustomToolsUIBean.setEnvVariable(request.getParameter("envVariable"));
            myCustomToolsUIBean.setEnvValue(request.getParameter("envValue"));
            myCustomToolsUIBean.createNewCustomEnvVar();
        }
        else if (postMode.equalsIgnoreCase("delete"))
        {
           // Figure out the selected row tool id
           int selectedRow [] = myCustomEnvVarsSelectionModel.getSelectedIndices();
           myCustomToolsUIBean.deleteCustomEnvVar(selectedRow);
        }
    }
    ///////////////////////////////////////////////////////////////////////////
    // THIS IS NOT A POST - Display normally
    ///////////////////////////////////////////////////////////////////////////

        %>
        <!-- EV INFORMATION -->
        <table width="60%" border="0" cellpadding="4" style="margin-left:50px;">
        <tr align="left" valign="top">
          <td>
            <form id="myCustomEnvVarsForm" name="myCustomEnvVarsForm" method="post">
              <table border="0">
                <tr>
                  <td nowrap><%=myToolsRbSettings.getString("myCustomTools.new.param7")%>:</td>
                  <td><INPUT name="envVariable" size=24 onMouseUp="checkRequiredFields()" onKeyUp="checkRequiredFields()" onChange="checkRequiredFields()" value="<%=myCustomToolsUIBean.getEnvVariable()%>"></td>
                </tr>
                <tr>
                  <td><%=myToolsRbSettings.getString("myCustomTools.new.param8")%>:</td>
                  <td><INPUT name="envValue" size=24 onMouseUp="checkRequiredFields()" onKeyUp="checkRequiredFields()" onChange="checkRequiredFields()" value="<%=myCustomToolsUIBean.getEnvValue()%>"></td>
                </tr>
              </table>
            </form>
          </td>
          <td align="center" valign="middle">
            <% buttons.dumpButtons(out); %>
          </td>

               <!-- EV LIST -->
               <%
                 if (myCustomToolsUIBean.getEnvVarsRowCount() > 0)
                 {
                    // DISPLAY THE LIST OF CUSTOM ENVIRONMENT VARIABLES FOR THIS TOOL
                    myCustomEnvVarsTableView.setHeight("100");
                    myCustomEnvVarsTableView.setWidth("230");
                    %>
                      <td align="center">
                    <%
                      myCustomEnvVarsTableView.dumpWholeTable(out);
                    %>
                      </td>
                    <%
                 }
                 else if (myCustomToolsUIBean.getEnvVarsRowCount() == 0)
                 {
                   %>
                     <div class="A">
                     <i><%=myToolsRbSettings.getString("myCustomTools.emptyEnvVarsTable.text1")%></i>
                     </div>
                   <%
                 }
               %>
               <!-- END EV TABLE -->
        </tr>

        <tr align="left" valign="top">
          <td></td>
          <td></td>
          <td align="center">
            <% buttons2.dumpButtons(out); %>
          </td>
       </tr>
       </table>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</BODY>
</HTML>
