<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="tasksBean" class="com.hp.mx.portal.taskandjob.MxTaskAndJob" scope="session"/>

<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobMessages"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobResourceBundle"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobInstance"%>
<%@ page import="com.hp.mx.portal.ui.MxBean"%>
<%@ page import="com.hp.mx.portal.ui.MxOptions"%>

<%
    // set header info
    MxBean.jspInit(request, response);

    // OK/CANCEL option question

    // check to see if the loginBean session has timed out
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
    {
        return;
    }

    String                     taskAndJobTimeStamp = request.getParameter("taskAndJobTimeStamp");
    MxTaskAndJobInstance       inst                = (MxTaskAndJobInstance)tasksBean.getInstance(taskAndJobTimeStamp);
    MxTaskAndJobResourceBundle rb                  = inst.getRB();
    MxTaskAndJobMessages       messages            = inst.getMessages();
    int                        numMessages         = messages.getNumMessages();

    MxButtons buttons = new MxButtons();
    buttons.clearMxTags();

    buttons.addMxTag(new MxDefaultTag("okBtn", rb.getString("OK_BUTTON"), "okButtonClicked()"));
    buttons.addMxTag(new MxDefaultTag("cancelBtn", rb.getString("CANCEL_BUTTON"), "window.close()"));
%>

<html>
    <head>
        <title></title>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/taskandjob/css/taskAndJob.css'>
        <script language='javascript' type='text/javascript' src='/SessionReset.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js'></script>
        <script language='javascript' type='text/javascript'>
            // this signals if the "OK" or "CANCEL" button has been clicked
            var buttonClicked  = false;
            var optionSelected = 0;
            // focusMe()
            function focusMe()
            {
                setTimeout('self.focus()', SELF_FOCUS_CHECK_TIMEOUT);
            }
            // okButtonClicked()
            function okButtonClicked()
            {
                buttonClicked = true;
            }
            // isOkButtonClicked()
            function isOkButtonClicked()
            {
                return buttonClicked;
            }
            // getSelectedOption()
            function getSelectedOption()
            {
                return optionSelected;
            }
            // setSelectedOption()
            function setSelectedOption(optionID)
            {
                for (var i = 0; i < <%=numMessages%>; i++)
                {
                    if (optionID.getAttribute('id') == ('option' + i))
                    {
                        optionSelected = i;
                    }
                }
            }
        </script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxButton.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

    </head>

    <body onload='focusMe()' onblur='focusMe()' marginwidth='4'
                                                marginheight='4'
                                                topmargin='4'
                                                bottommargin='4'
                                                leftmargin='4'
                                                rightmargin='4'>

        <table border='0' cellpadding='0' cellspacing='0' style='width:100%'>
            <tr>
                <td rowspan='<%=numMessages * 2%>'>&nbsp;&nbsp;</td>
                <td rowspan='<%=numMessages * 2%>'><img src='<%=MxOptions.URL_BASE%>/taskandjob/img/msg_help.jpg'></td>
                <td rowspan='<%=numMessages * 2%>'>&nbsp;&nbsp;&nbsp;</td>
            </tr>
<%
    for (int i = 0; i < messages.getNumMessages(); i++)
    {
%>
            <tr>
                <td valign='top'>
                    <input type='radio' id='option<%=i%>' name='options' onClick='setSelectedOption(this)'
<%
        if (i == 0)  // select the first option
        {
%>
            checked
<%
        }
%>
                    >
                </td>
                <td>
                    <%= messages.getMessage(i) %>
                </td>
            </tr>
            <tr>
                <td colspan='2'>&nbsp;</td>
            </tr>
<%
    }
%>
            <tr>
                <td colspan='5' align='right'>
                    <% buttons.dumpButtons(out); %>
                </td>
            </tr>
        </table>

<% MxHtmlUtil.dumpBodyEnd(out); %>

    </body>
</html>

<%
    // after displaying the error message, clear
    // out the error object.
    messages.clear();
%>
