<%--
//$Source: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/taskandjob/protocolParameters.jsp,v $
//$Revision: 1.44.4.2 $
//$Date: 2005/09/27 15:32:06 $
--%>
<!--  -->
<!--  Java imports                                                          -->
<!--  -->
<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.help.*"%>
<%@ page import="com.hp.mx.core.tools.protocolsettings.ProtocolSettingsConfigObject"%>
<%@ page import="com.hp.mx.core.tools.protocolsettings.ProtocolSettingsComponent"%>
<%@ page import="com.hp.mx.core.subjects.*" %>
<%@ page import="com.hp.mx.portal.core.MxObjList" %>
<%@ page import="com.hp.mx.core.objectmodel.MxGUID" %>
<%@ page import="com.hp.mx.core.nodemanager.MxNode" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.html.core.MxHtmlUtil" %>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskWizardInstance"%>
<!--  -->
<!--  Create all beans                                                      -->
<!--  -->
<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="selectionBean" class="com.hp.mx.portal.core.MxObjSelections" scope="session" />
<jsp:useBean id="taskWizardBean" class="com.hp.mx.portal.taskandjob.MxTaskWizard" scope="session"/>
<jsp:useBean id="rbCP" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="protSetResBndll" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="devProtoSettings" class="com.hp.mx.portal.settings.DeviceProtocolSettingsBean" scope="page" />

<%
    MxBean.jspInit(request, response);
    rbCP.init(loginBean, "ProtocolParameters");
    // REQUIRED: This aborts the page if the session is invalid.
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
        return;

    // Get the Instance Data for this Task Wizard Instance
    String               timeStamp = request.getParameter("timeStamp");
    MxTaskWizardInstance inst      = (MxTaskWizardInstance)taskWizardBean.getInstance(timeStamp);

    // Check the user authorization
    if (!loginBean.getMxUser().hasPrivilege(MxSubjectPrivilege.SECURITY_MODIFICATION_PRIVILEGE))
    {
        // Special error page instead of the standard not-authorized one
%>
        <jsp:forward page="MxNotAuthorizedProtocols.jsp" />
<%
    }

    String devKey = null;
    devKey = request.getParameter("devId");
    if ((null == devKey) || devKey.equals(""))
    {
        devKey = "-1";
    }

    ProtocolSettingsConfigObject taskArgs = (ProtocolSettingsConfigObject) inst.getTaskUserParameters();
    if (inst.isFirstTime())
    {
        if (taskArgs == null)
        {
            taskArgs = new ProtocolSettingsConfigObject();
            taskArgs.initialize();
            inst.setTaskUserParameters(taskArgs);

            MxObjList devs = selectionBean.getNodes();
            if (1 == devs.size())
            {
                MxGUID dev0Guid = devs.get(0).getGuidObj();
                devKey = ""+dev0Guid.getKey();
            }
        }
    }

    // else this is return from "prev", and no need to gen the devKey
    // such that the current configObj content are to be used

    // setup resources.
    protSetResBndll.init(loginBean, "DeviceProtocolSettings");

    // setup bean
    devProtoSettings.idJSP("fromTaskPage");
    devProtoSettings.setConfigObj(taskArgs);
    devProtoSettings.initialize(loginBean, protSetResBndll, devKey, request);

    boolean icmpUseValue = true;
    boolean snmpUseValue = true;
    boolean wbemUseValue = true;

%>

<html>
  <head>
    <title><%=rbCP.getString("ProtocolParameters.title")%></title>

    <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/taskandjob/css/taskAndJob.css'>
    <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxPortalApi.js'></script>
    <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js'></script>
    <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/taskWizard.js'></script>
    <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxBrowser.js'></script>
    <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/devProtocolSettingsUtils.js'></script>
    <script language='javascript' type='text/javascript'>

        ////////////////////////////////////////////////////////////////
        // Set the help page
        ////////////////////////////////////////////////////////////////
        MxPortalWorkspaceSetHelpTopic("admin_protocols_set_sysGroup");

        ///////////////////////////////////////////////////////////////////////////// swc 20040426
        // btnsDisabled is used to keep track of state of "schedule" & "run" buttons
        /////////////////////////////////////////////////////////////////////////////
        var btnsDisabled = false;

        /////////////////////////////////////////////////////////////////////////////
        // resource bundle values
        /////////////////////////////////////////////////////////////////////////////
        var radioUseValueLabel   = "<%= protSetResBndll.getString("protocols.radio.useValue")%>&nbsp;";
        var radioUseValueTooltip = "<%= protSetResBndll.getString("protocols.radio.useValueToolTip")%>";
        var radioDefaultLabel    = "<%= protSetResBndll.getString("protocols.radio.default")%>";
        var radioDefaultTooltip  = "<%= protSetResBndll.getString("protocols.radio.defaultToolTip")%>";
        var timeoutStr = "(<%= protSetResBndll.getString("timeout")%> ";
        var secStr     = " <%= protSetResBndll.getString("seconds")%>); ";
        var retriesStr = "(<%= protSetResBndll.getString("retries")%> ";
        var portStr      = "<%= protSetResBndll.getString("portnum")%>";
        var userStr      = "<%= protSetResBndll.getString("username")%> ";
        var pwStr        = "<%= protSetResBndll.getString("password")%>";
        var pwConfirmStr = "<%= protSetResBndll.getString("confirmPW")%>";
        var icmpTitle      = "<%= protSetResBndll.getString("protocols.icmp.title")%>";
        var icmpTimeoutStr = "<%= protSetResBndll.getString("protocols.icmp.timeout")%>";
        var icmpRetriesStr = "<%= protSetResBndll.getString("protocols.icmp.retries")%>";
        var wbemTitle   = "<%= protSetResBndll.getString("protocols.wbem.title")%>";
        var wbemPortStr = "(<%= protSetResBndll.getString("portnum")%> ); (";
        var num1Str = "<%= protSetResBndll.getString("num1")%>";
        var num2Str = "<%= protSetResBndll.getString("num2")%>";
        var num3Str = "<%= protSetResBndll.getString("num3")%>";
        var num4Str = "<%= protSetResBndll.getString("num4")%>";
        var num5Str = "<%= protSetResBndll.getString("num5")%>";
        var snmpTitle      = "<%= protSetResBndll.getString("protocols.snmp.title")%>";
        var snmpTimeoutStr = "<%= protSetResBndll.getString("protocols.snmp.timeout")%>";
        var snmpRetriesStr = "<%= protSetResBndll.getString("protocols.snmp.retries")%>";
        var snmpRdCommStr  = "<%= protSetResBndll.getString("protocols.snmp.commlist")%>";
        var snmpWrCommStr  = "<%= protSetResBndll.getString("protocols.snmp.writecomm")%>";
        var sshTitle                  = "<%= protSetResBndll.getString("protocols.ssh.title")%>";
        var radioNatApplicableLabel   = "<%= protSetResBndll.getString("protocols.radio.notapplicable")%>";
        var radioNatApplicableTooltip = "<%= protSetResBndll.getString("protocols.radio.notapplicableToolTip")%>";
        var identTitle = "<%= protSetResBndll.getString("protocols.id.title")%>";
        var identStr   = "<%=protSetResBndll.getString("protocols.id.runIdentification")%>";
        var setGroupLabel   = "<%= protSetResBndll.getString("setGroup")%>&nbsp;";
        var setGroupTooltip = "<%= protSetResBndll.getString("setGroupToolTip")%>";

        /////////////////////////////////////////////////////////////////////////////
        // error msg values
        /////////////////////////////////////////////////////////////////////////////
        var genProbErr = "<B><font color='red'><%=protSetResBndll.getString("err.genProblem")%></font></B>";
        var selectErr  = "<B><font color='red'><%=protSetResBndll.getString("err.noProtocol")%></font></B>";
        var wbemPortErr  = "<B><font color='red'><<< <%=protSetResBndll.getString("err.portnum")%> <%=protSetResBndll.getString("protocols.error.mustbenumb")%></font></B>";
        var wbemFieldErr = "<B><font color='red'><<< <%=protSetResBndll.getString("protocols.error.wbemfieldsnoblank")%></font></B>";
        var wbemPwErr    = "<B><font color='red'><<< <%=protSetResBndll.getString("err.pwmismatch")%></font></B>";
        var fieldErr = "<B><font color='red'><<< <%=protSetResBndll.getString("protocols.error.fieldsnoblank")%></font></B>";
        var pwErr    = "<B><font color='red'><<< <%=protSetResBndll.getString("err.pwmismatch")%></font></B>";
        var noBlankErr = " <%=protSetResBndll.getString("protocols.error.notblank")%></font></B>";
        var rangeStr   = " <%=protSetResBndll.getString("protocols.error.range")%> ";
        var andStr = " <%=protSetResBndll.getString("protocols.error.rangeand")%> ";
        var genErr = "<%= protSetResBndll.getString("err.general")%> ";
        var icmpTimeoutErr = "<%=protSetResBndll.getString("protocols.error.icmptimeout")%>";
        var icmpTimeoutMin = <%= devProtoSettings.ICMP_TIMEOUT_MIN %>;
        var icmpTimeoutMax = <%= devProtoSettings.ICMP_TIMEOUT_MAX%>;
        var icmpRetriesErr = "<%=protSetResBndll.getString("protocols.error.icmpretries")%>";
        var icmpRetriesMin = <%= devProtoSettings.ICMP_RETRIES_MIN %>;
        var icmpRetriesMax = <%= devProtoSettings.ICMP_RETRIES_MAX%>;
        var snmpTimeoutErr = "<%=protSetResBndll.getString("protocols.error.snmptimeout")%>";
        var snmpTimeoutMin = <%=devProtoSettings.SNMP_TIMEOUT_MIN%>;
        var snmpTimeoutMax = <%=devProtoSettings.SNMP_TIMEOUT_MAX%>;
        var snmpRetriesErr = "<%=protSetResBndll.getString("protocols.error.snmpretries")%>";
        var snmpRetriesMin = <%=devProtoSettings.SNMP_RETRIES_MIN%>;
        var snmpRetriesMax = <%=devProtoSettings.SNMP_RETRIES_MAX%>;

        /////////////////////////////////////////////////////////////////////////////
        // data values
        /////////////////////////////////////////////////////////////////////////////
        var refPw = g("<%=devProtoSettings.getUntouchedPwMarker()%>"); // to facilitate preventing plain-text pw in viewSource
        var setIcmpToggle  = q("<jsp:getProperty name="devProtoSettings" property="icmpEnabledState" />");
        var icmpToggle     = q("<jsp:getProperty name="devProtoSettings" property="icmpUseCustom" />");
        var icmpTimeoutDef = q("<jsp:getProperty name="devProtoSettings" property="icmpTimeOutDefault" />");
        var icmpTimeout    = q("<%=devProtoSettings.getIcmpTimeOut()%>");
        var icmpRetriesDef = q("<jsp:getProperty name="devProtoSettings" property="icmpRetriesDefault" />)");
        var icmpRetries    = q("<jsp:getProperty name="devProtoSettings" property="icmpRetries" />");
        var setWbemToggle = q("<jsp:getProperty name="devProtoSettings" property="wbemEnabledState" />");
        var wbemUserDef   = q("<%=MxHtmlUtil.encodeJScriptSafeEntities(devProtoSettings.getWbemUserDefaults())%>)");
        var wbemToggle   = q("<jsp:getProperty name="devProtoSettings" property="wbemUseCustom" />");
        var wbemPort0    = q("<%=MxHtmlUtil.encodeJScriptSafeEntities(devProtoSettings.getWbemPort(0))%>");
        var wbemUser0    = q("<%=MxHtmlUtil.encodeJScriptSafeEntities(devProtoSettings.getWbemUser(0))%>");
        if ("" == wbemUser0)
        {
            var wbemPw0 = "";
        }
        else
        {
            var wbemPw0 = refPw; // to facilitate preventing plain-text pw in viewSource
        }
        var wbemPort1    = q("<%=MxHtmlUtil.encodeJScriptSafeEntities(devProtoSettings.getWbemPort(1))%>");
        var wbemUser1    = q("<%=MxHtmlUtil.encodeJScriptSafeEntities(devProtoSettings.getWbemUser(1))%>");
        if ("" == wbemUser1)
        {
            var wbemPw1 = "";
        }
        else
        {
            var wbemPw1 = refPw; // to facilitate preventing plain-text pw in viewSource
        }
        var wbemPort2    = q("<%=MxHtmlUtil.encodeJScriptSafeEntities(devProtoSettings.getWbemPort(2))%>");
        var wbemUser2    = q("<%=MxHtmlUtil.encodeJScriptSafeEntities(devProtoSettings.getWbemUser(2))%>");
        if ("" == wbemUser2)
        {
            var wbemPw2 = "";
        }
        else
        {
            var wbemPw2 = refPw; // to facilitate preventing plain-text pw in viewSource
        }
        var wbemPort3    = q("<%=MxHtmlUtil.encodeJScriptSafeEntities(devProtoSettings.getWbemPort(3))%>");
        var wbemUser3    = q("<%=MxHtmlUtil.encodeJScriptSafeEntities(devProtoSettings.getWbemUser(3))%>");
        if ("" == wbemUser3)
        {
            var wbemPw3 = "";
        }
        else
        {
            var wbemPw3 = refPw; // to facilitate preventing plain-text pw in viewSource
        }
        var wbemPort4    = q("<%=MxHtmlUtil.encodeJScriptSafeEntities(devProtoSettings.getWbemPort(4))%>");
        var wbemUser4    = q("<%=MxHtmlUtil.encodeJScriptSafeEntities(devProtoSettings.getWbemUser(4))%>");
        if ("" == wbemUser4)
        {
            var wbemPw4 = "";
        }
        else
        {
            var wbemPw4 = refPw; // to facilitate preventing plain-text pw in viewSource
        }
        var setSnmpToggle  = q("<jsp:getProperty name="devProtoSettings" property="snmpEnabledState" />");
        var snmpToggle     = q("<jsp:getProperty name="devProtoSettings" property="snmpUseCustom" />");
        var snmpTimeoutDef = q("<jsp:getProperty name="devProtoSettings" property="snmpTimeOutDefault" />");
        var snmpTimeout    = q("<jsp:getProperty name="devProtoSettings" property="snmpTimeOut" />");
        var snmpRetriesDef = q("<jsp:getProperty name="devProtoSettings" property="snmpRetriesDefault" />);");
        var snmpRetries    = q("<jsp:getProperty name="devProtoSettings" property="snmpRetries" />");
        var snmpRdCommDef  = q("(<%= protSetResBndll.getString("protocols.snmp.commlist")%> <%=MxHtmlUtil.encodeJScriptSafeEntities(devProtoSettings.getSnmpReadCommStringDefaults())%>); ");
        var snmpRdComm     = q("<%=MxHtmlUtil.encodeJScriptSafeEntities(devProtoSettings.getSnmpReadCommString())%>");
        var snmpWrCommDef  = q("(<%= protSetResBndll.getString("protocols.snmp.writecomm")%> <%=MxHtmlUtil.encodeJScriptSafeEntities(devProtoSettings.getSnmpWriteCommStringDefault())%>)");
        var snmpWrComm     = q("<%=MxHtmlUtil.encodeJScriptSafeEntities(devProtoSettings.getSnmpWriteCommString())%>");
        var setSshToggle = q("<jsp:getProperty name="devProtoSettings" property="sshEnabledState" />");
        var sshToggle    = q("<jsp:getProperty name="devProtoSettings" property="sshUseCustom" />");
        var sshUser      = q("<%=MxHtmlUtil.encodeJScriptSafeEntities(devProtoSettings.getSshUser())%>");
        if ("" == sshUser)
        {
            var sshPw = "";
        }
        else
        {
            var sshPw = refPw; // to facilitate preventing plain-text pw in viewSource
        }
        var setIdentToggle = q("<jsp:getProperty name="devProtoSettings" property="runIdentification" />");

        ////////////////////////////////////////////////////////////////////////
        // disableBtns()
        // -- disables the "schedule" & "run" buttons
        ////////////////////////////////////////////////////////////////////////
        function disableBtns(errMsg)
        {
            document.getElementById("OVERALL_ERR_MSG").innerHTML = errMsg;
            ourButtonManager.disableButtonById('scheduleBtn');
            ourButtonManager.disableButtonById('runNowBtn');
            btnsDisabled = true;
            return true; // for problems
        }

        ////////////////////////////////////////////////////////////////////////
        // enableBtns()
        // -- enables the "schedule" & "run" buttons
        ////////////////////////////////////////////////////////////////////////
        function enableBtns()
        {
            document.getElementById("OVERALL_ERR_MSG").innerHTML = "";
            ourButtonManager.enableButtonById('scheduleBtn');
            ourButtonManager.enableButtonById('runNowBtn');
            btnsDisabled = false;
        }

        ////////////////////////////////////////////////////////////////////////
        // updateDatabean()
        ////////////////////////////////////////////////////////////////////////
        function updateDatabean()
        {
            <jsp:setProperty name="devProtoSettings" property="untouchedPwMarker"/> // to ensure that this is always set before any PW values that ref it
            <jsp:setProperty name="devProtoSettings" property="*"/>
        }

     </script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxPortalRender.dumpHeadContent(out); %>
<% MxButton.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

  </head>

  <body onload='setParameters()'>

<%
    ///////////////////////////////////////////////////////////////////////////
    // IS THIS A POST?  Check data validity and redirect
    ///////////////////////////////////////////////////////////////////////////
    if (request.getMethod().equalsIgnoreCase("POST"))
    {
        // Pull data from parameters and store in taskArgs...
%>
        <jsp:setProperty name="devProtoSettings" property="untouchedPwMarker"/>
        <jsp:setProperty name="devProtoSettings" property="*" />
<%
        String uniqueId = inst.getUniqueTaskName() + "_" + System.currentTimeMillis(); // Better ID?
        taskArgs.setUniqueId(uniqueId);

        if (devProtoSettings.updateConfigObj())
        {
            // User data is valid, go to the next wizard step
            inst.setTaskUserParameters(devProtoSettings.getConfigObj());
%>
            <script>
                loadWizardNextStep();
            </script>
<%
        }
        else
        {
            inst.setTaskUserParameters(devProtoSettings.getConfigObj());
            // User data is invalid, redisplay the same wizard step
            // note that this point can only be reached on mozilla, which is buggy
            int tmp1 = devProtoSettings.getIcmpTimeoutError();
            int tmp2 = devProtoSettings.getIcmpRetriesError();
            int tmp3 = devProtoSettings.getSnmpTimeoutError();
            int tmp4 = devProtoSettings.getSnmpRetriesError();
            int tmp5 = devProtoSettings.getWbemCredentialError();
            int tmp6 = devProtoSettings.getSshCredentialError();
            if (1 == tmp1)
            {
%>
            <script>
                loadWizardCurrentStep();
                alert("<%= protSetResBndll.getString("protocols.error.icmptimeout")%> " + "<%=protSetResBndll.getString("protocols.error.mustbenumb")%>");
                if (document.icmpTimeOut != null) // fix for rQm ISSUE 256822, per M. Kubota
                {
                   hilite(document.icmpTimeOut);
                }
            </script>
<%
            }
            else if (2 == tmp1)
            {
%>
            <script>
                loadWizardCurrentStep();
                alert("<%= protSetResBndll.getString("protocols.error.icmptimeout")%> " + "<%=protSetResBndll.getString("protocols.error.range")%>" + " <%= devProtoSettings.ICMP_TIMEOUT_MIN %>" +
                      " <%=protSetResBndll.getString("protocols.error.rangeand")%>" + " <%= devProtoSettings.ICMP_TIMEOUT_MAX %>");
                if (document.icmpTimeOut != null) // fix for rQm ISSUE 256822, per M. Kubota
                {
                   hilite(document.icmpTimeOut);
                }
            </script>
<%
            }
            else if (1 == tmp2)
            {
%>
            <script>
                loadWizardCurrentStep();
                alert("<%= protSetResBndll.getString("protocols.error.icmpretries")%> " +  "<%=protSetResBndll.getString("protocols.error.mustbenumb")%>");
                if (document.icmpRetries != null) // fix for rQm ISSUE 256822, per M. Kubota
                {
                   hilite(document.icmpRetries);
                }
            </script>
<%
             }
             else if (2 == tmp2)
             {
%>
            <script>
                loadWizardCurrentStep();
                alert("<%= protSetResBndll.getString("protocols.error.icmpretries")%> " + "<%=protSetResBndll.getString("protocols.error.range")%>" + " <%= devProtoSettings.ICMP_RETRIES_MIN %>" +
                      " <%=protSetResBndll.getString("protocols.error.rangeand")%>" + " <%= devProtoSettings.ICMP_RETRIES_MAX %>");
                if (document.icmpRetries != null) // fix for rQm ISSUE 256822, per M. Kubota
                {
                   hilite(document.icmpRetries);
                }
            </script>
<%
            }
            else if (1 == tmp3)
            {
%>
            <script>
                loadWizardCurrentStep();
                alert("<%= protSetResBndll.getString("protocols.error.snmptimeout")%> " + "<%=protSetResBndll.getString("protocols.error.mustbenumb")%>");
                if (document.snmpTimeOut != null) // fix for rQm ISSUE 256822, per M. Kubota
                {
                   hilite(document.snmpTimeOut);
                }
            </script>
<%
            }
            else if (2 == tmp3)
            {
%>
            <script>
                loadWizardCurrentStep();
                alert("<%= protSetResBndll.getString("protocols.error.snmptimeout")%> " + "<%=protSetResBndll.getString("protocols.error.range")%>" + " <%= devProtoSettings.SNMP_TIMEOUT_MIN %>" +
                      " <%=protSetResBndll.getString("protocols.error.rangeand")%>" + " <%= devProtoSettings.SNMP_TIMEOUT_MAX %>");
                if (document.snmpTimeOut != null) // fix for rQm ISSUE 256822, per M. Kubota
                {
                   hilite(document.snmpTimeOut);
                }
            </script>
<%
            }
            else if (1 == tmp4)
            {
%>
            <script>
                loadWizardCurrentStep();
                alert("<%= protSetResBndll.getString("protocols.error.snmpretries")%> " + "<%=protSetResBndll.getString("protocols.error.mustbenumb")%>");
                if (document.snmpRetries != null) // fix for rQm ISSUE 256822, per M. Kubota
                {
                   hilite(document.snmpRetries);
                }
            </script>
<%
            }
            else if (2 == tmp4)
            {
%>
            <script>
                loadWizardCurrentStep();
                alert("<%= protSetResBndll.getString("protocols.error.snmpretries")%> " + "<%=protSetResBndll.getString("protocols.error.range")%>" + " <%= devProtoSettings.SNMP_RETRIES_MIN %>" +
                      " <%=protSetResBndll.getString("protocols.error.rangeand")%>" + " <%= devProtoSettings.SNMP_RETRIES_MAX %>");
                if (document.snmpRetries != null) // fix for rQm ISSUE 256822, per M. Kubota
                {
                   hilite(document.snmpRetries);
                }
            </script>
<%
            }
            else if (1 == tmp5)
            {
                // removed check for WBEM_USER nullness, as it can now be null, swc 20040415 fix for 255628
                // re-instated check for WBEM_USER nullness, swc 20040423 fix for 256548
%>
            <script>
                loadWizardCurrentStep();
                alert("<%= protSetResBndll.getString("protocols.error.wbemnouser")%>");
            </script>
<%
            }
            else if (2 == tmp5)
            {
%>
            <script>
                loadWizardCurrentStep();
                alert("<%= protSetResBndll.getString("protocols.error.wbemnopass")%>");
            </script>
<%
            }
            else if (3 == tmp5)
            {
%>
            <script>
                loadWizardCurrentStep();
                alert("<%= protSetResBndll.getString("protocols.error.wbempwmismatch")%>");
            </script>
<%
            }
            else if (4 == tmp5)
            {
%>
            <script>
                loadWizardCurrentStep();
                alert("WBEM <%= protSetResBndll.getString("err.portnum")%> <%=protSetResBndll.getString("protocols.error.mustbenumb")%>");
            </script>
<%
            }
            else if (1 == tmp6)
            {
%>
            <script>
                loadWizardCurrentStep();
                alert("<%= protSetResBndll.getString("protocols.error.sshnouser")%>");
            </script>
<%
            }
            else if (2 == tmp6)
            {
%>
            <script>
                loadWizardCurrentStep();
                alert("<%= protSetResBndll.getString("protocols.error.sshnopass")%>");
            </script>
<%
            }
            else if (3 == tmp6)
            {
%>
            <script>
                loadWizardCurrentStep();
                alert("<%= protSetResBndll.getString("protocols.error.sshpwmismatch")%>");
            </script>
<%
            }
        }
    }
    ///////////////////////////////////////////////////////////////////////////
    // THIS IS NOT A POST - Display normally
    ///////////////////////////////////////////////////////////////////////////
    else
    {
%>
        <form method="post" id="ProtocolParameters" name="ProtocolParameters">

<!-- -->
        <jsp:include page="/mxportal/settings/DeviceProtocolSettingsForm.jsp" />
<!-- -->

            <input type='hidden' id='timeStamp' name='timeStamp' value='<%=timeStamp%>'>
        </form>
        <script language='javascript' type='text/javascript'>
            setWizardStepText("<%=rbCP.getString("ProtocolParameters.steptext")%>");
            displayTaskWizardButtons()
            setFormSubmitName('ProtocolParameters');
        </script>
<%
    }
%>

<% MxHtmlUtil.dumpBodyEnd(out); %>

  </body>
</html>
