<%
//
// $Source: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/mxportal/taskandjob/replicateAgentCfgParams.jsp,v $
// $Revision: 1.31 $
// $Date: 2005/06/02 19:31:31 $
//
%>
<%@ pageinfo="Replicate Agent Settings - Parameter Tree Page" %>

<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.core.tools.groupconfiguration.GCTaskModel" %>
<%@ page import="com.hp.mx.html.table.*" %>
<%@ page import="com.hp.mx.html.tree.MxTreeSelectionModel" %>
<%@ page import="com.hp.mx.portal.ui.*" %>
<%@ page import="com.hp.mx.utilities.DebugOutput" %>
<%@ page import="com.hp.mx.utilities.DebugSubsystem" %>
<%@ page import="java.util.*" %>
<%@ page import="javax.swing.table.AbstractTableModel" %>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskWizardInstance"%>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="taskWizardBean" class="com.hp.mx.portal.taskandjob.MxTaskWizard" scope="session" />
<jsp:useBean id="gcBean" class="com.hp.mx.portal.taskandjob.GroupCfgBean" scope="session"/>
<jsp:useBean id="gcBundle" class="com.hp.mx.portal.res.MxResourceBean" scope="session" />
<jsp:useBean id="gcTreeView" class="com.hp.mx.html.tree.MxTreeView" scope="session" />
<jsp:useBean id="gcTreeExpansionModel" class="com.hp.mx.html.tree.MxDefaultTreeExpansionModel" scope="session" />
<jsp:useBean id="gcTreeComponent" class="com.hp.mx.html.tree.MxTreeController" scope="session" />
<jsp:useBean id="gcTreeSelectionModel" class="com.hp.mx.html.tree.MxTreeSelectionModel" scope="session" />
<%!
    /** ****************************************************************************************
     * The debug object
     **************************************************************************************** */
    public DebugSubsystem groupConfigurationDebug =
        DebugOutput.getDebugSubsystem("gcBean");
%>
<%
    // Avoid the browser cache for this page because if we set an error and
    // then redirect back here, the cached page loads without showing any error
    response.setDateHeader("expires", 0);

    // REQUIRED: This line is required by Tomcat for i18n support.
    MxBean.jspInit(request, response);

    // REQUIRED: Abort the page & redirect if the session has timed out
    if (loginBean.checkLogoutConditionForWebPage(pageContext))
    {
        return;
    }

    // Get the Instance Data for this Task Wizard Instance
    String               timeStamp = request.getParameter("timeStamp");
    MxTaskWizardInstance inst      = (MxTaskWizardInstance)taskWizardBean.getInstance(timeStamp);

    // set up the resource file
    gcBundle.init(loginBean, "ReplicateAgentSettings");

    if (gcTreeComponent.checkUrlForControllerMessages(request, out))
        return;
%>
<HTML>
<HEAD>
    <TITLE><%= gcBundle.getString("page.paramPick.title") %></TITLE>
    <link href='<%= MxOptions.URL_BASE %>/taskandjob/css/taskAndJob.css' rel='stylesheet' type='text/css'>
    <link href="<%=MxOptions.URL_BASE%>/css/MxPortalEx.css" rel="stylesheet" type="text/css">
    <script src='<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js' language='JavaScript' type='text/javascript'></script>
    <script src='<%=MxOptions.URL_BASE%>/taskandjob/js/taskWizard.js' language='JavaScript' type='text/javascript'></script>
    <script src="<%=MxOptions.URL_BASE%>/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
    <script src="<%=MxOptions.URL_BASE%>/js/utilities.js" language="JavaScript" type="text/javascript"></script>
    <script language="JavaScript" type="text/javascript">
        MxPortalWorkspaceSetHelpTopic("useTools_replicateAgentSettings");
    </script>
    <script language="JavaScript" type="text/javascript">
        var treeError         = false;
        var numTreeSelections = 0;
        //
        function initPage()
        {
            if (treeError == true)
            {
                enableTaskWizBtn("scheduleBtn", false);
                enableTaskWizBtn("runNowBtn", false);
            }
        }
        // this function is only accurate after the page has been loaded
        function treeNodeSelected(treeID, itemId, selectionState)
        {
            if (selectionState == true)
            {
                numTreeSelections++;
            }
            else
            {
                numTreeSelections--;
            }

            // Highlight buttons accordingly (enable if at least one selection)
            enableTaskWizBtn("scheduleBtn", (numTreeSelections > 0));
            enableTaskWizBtn("runNowBtn", (numTreeSelections > 0));
        }
        //
        function enableTaskWizBtn(btnId, enableState)
        {
            var el = document.getElementById(btnId);
            if (el!= null)
            {
                if (enableState)
                    ourButtonManager.enableButton(el);
                else
                    ourButtonManager.disableButton(el);
            }
        }
        //
        function refreshTree()
        {
            location.replace(location.href + "&refresh=1");
        }
    </script>

<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxButton.dumpHeadContent(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>

</HEAD>

<BODY onload="initPage()">
<%
    // Display any error messages
    if (gcBean.hasErrorMessages())
    {
        // Display plurally-correct label
        if (gcBean.getErrorMessageList().size() == 1)
        {
            %><div class="errorTextBold"><%= gcBundle.getString("treeError.label.single")%>:</div><%
        }
        else
        {
            %><div class="errorTextBold"><%= gcBundle.getString("treeError.label.multiple")%>:</div><%
        }

        // Finally, display the error message(s)
        gcBean.displayErrorMessagesInHtml(out);
    }

    // DISPLAY BEAN AND JSP PROPERTIES
    if (groupConfigurationDebug.check(20))
    {
        gcBean.displayBeanPropsHtml(out);
        out.println("<BR>");
        gcBean.displayJspParamsHtml(request, out);
        gcBean.displayJspParamsToConsole(request);
    }

    ///////////////////////////////////////////////////////////////////////////
    // IS THIS A POST?  Check data validity and redirect
    ///////////////////////////////////////////////////////////////////////////
    if (request.getMethod().equals("POST"))
    {
        gcBean.clearAllErrorMessages();  // Reset errors

        // SET THE WAKE SYSTEM SETTING
        gcBean.setWakeSystem(request.getParameter("wakeOnLan") != null);

        // EXTRACT THE USER'S PARAMETER CHOICES
        // Can we succesfully do this?
        if (gcBean.setParamSelectionFromUiTree(gcTreeSelectionModel.getSelectionPaths()))
        {
            // YES!  Continue processing
            // Since the gcTreeSelectionModel session bean remembers its selections
            // but does not preselect based on those selections, we need to clear
            // the selections here for the next time the page is displayed (either
            // as part of the same task creation instance via the PREV button or
            // as part of a new task creation instance done later on this session)
            gcTreeSelectionModel.clearSelection();

            // PASS THE DATA MODEL TO THE TASK WIZARD
            GCTaskModel myTaskModel = gcBean.getGcTaskModel();

            // Did we get a good value?
            if (myTaskModel == null)
            {
                gcBean.addErrorMessage(gcBundle.getString("treeError.dataModel.none"));
                gcBean.setDataValid(false);
            }
            else
            {
                // Pass it to the task Wizard
                inst.setTaskUserParameters(myTaskModel);

                // Let the task wizard continue with the running or scheduling
                %><script>loadWizardNextStep();</script><%
            }
        }

        // Are we good to go?
        if (!gcBean.isDataValid())
        {
            %><script>window.history.go(-1);</script><%
        }
    }
    ///////////////////////////////////////////////////////////////////////////
    // THIS IS NOT A POST - Display normally
    ///////////////////////////////////////////////////////////////////////////
    else
    {
    %>
        <script>setWizardStepText("<%= gcBundle.getString("page.paramPick.taskWizHeader") %>");</script>
        <%= gcBundle.getString("page.paramPick.instructions") %>
        <BR><BR>
        <b><%= gcBundle.getString("page.paramPick.label.srcSystem") %></b>: <%= gcBean.getSourceSystemName() %>
        <BR><BR>

        <!-- INSERT TREE HERE -->
        <jsp:include page="replicateAgentCfgParamTree.jsp?timeStamp=<%=timeStamp%>" flush="true" />

        <script language="javascript" type="text/javascript">
            setFormSubmitName("gcTreeForm");
            displayTaskWizardButtons();

            // this properly enable/disabled the buttons upon this pages first loading
            // "numSelected" is obtained from the "replicateAgentCfgParamTree.jsp" file
            numTreeSelections = numSelected;

            enableTaskWizBtn("scheduleBtn", (numTreeSelections > 0));
            enableTaskWizBtn("runNowBtn", (numTreeSelections > 0));
        </script>
    <%
    }
    %>

<% MxHtmlUtil.dumpBodyEnd(out); %>

</BODY>
</HTML>
