<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="taskWizardBean" class="com.hp.mx.portal.taskandjob.MxTaskWizard" scope="session"/>
<jsp:useBean id="actionList" class="com.hp.mx.portal.core.MxActionList" scope="session"/>
<jsp:useBean id="selectionBean" class="com.hp.mx.portal.core.MxObjSelections" scope="session"/>

<%@ page import="com.hp.mx.portal.ui.MxBean"%>
<%@ page import="com.hp.mx.portal.ui.MxOptions"%>

<%
    // set header info
    MxBean.jspInit(request, response);

    // check to see if the loginBean session has timed out
    if (loginBean.checkLogoutConditionForWebPage(pageContext) == true)
    {
        return;
    }

    String  edit = request.getParameter("edit");
    boolean init = false;

    // create new "timestamp" for this instance
    String timeStamp  = taskWizardBean.getNewTimeStamp( request.getParameter("timeStamp") );
    String forwardUrl = MxOptions.URL_BASE + "/taskandjob/taskWizard.jsp?" + request.getQueryString() + "&timeStamp=" + timeStamp;
    String errorUrl   = MxOptions.URL_BASE + "/taskandjob/errorTaskWizard.jsp?timeStamp=" + timeStamp;

    // if "edit" is not found on the URL, then we are creating a new Task
    //   get "toolGUID" from the URL
    // else we are editing an existing Task
    //   get "taskName" from the URL
    if (edit == null)
    {
        // the "actionList" is used for Web Launch Tasks - the Action within the ActionList
        // must be set with the WLA Runnable Task and passed back to the Portal
        init = taskWizardBean.initializeNewTask(loginBean, actionList, selectionBean, request, timeStamp);
    }
    else
    {
        init = taskWizardBean.initializeEditTask(loginBean, selectionBean, request, timeStamp);
    }

    if (init == false)
    {
        %>
        <jsp:forward page="<%= errorUrl %>"/>
        <%
    }
    else
    {
        // I'm leaving this as a branch in case there is a need to do
        // something special for edit/non-edit tasks
        if (edit == null)
        {
            // since we forward this page, all the parameters from this page
            // are pass along to the next page
            %>
            <jsp:forward page="<%= forwardUrl %>"/>
            <%
        }
        else
        {
            // since we forward this page, all the parameters from this page
            // are pass along to the next page
            %>
            <jsp:forward page="<%= forwardUrl %>"/>
            <%
        }
    }
%>
