<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="timeFiltersBean" class="com.hp.mx.portal.taskandjob.MxTimeFilters" scope="session"/>

<%@ page import="com.hp.mx.portal.taskandjob.MxTimeFiltersInstance"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobMessages"%>
<%@ page import="com.hp.mx.portal.ui.MxBean"%>
<%@ page import="com.hp.mx.portal.ui.MxOptions"%>

<%
    // set header info
    MxBean.jspInit(request, response);

    // check to see if the loginBean session has timed out
    if (loginBean.checkLogoutConditionForWebPage(pageContext) == true)
    {
        return;
    }

    String                timeStamp = request.getParameter("timeStamp");
    MxTimeFiltersInstance inst      = (MxTimeFiltersInstance)timeFiltersBean.getInstance(timeStamp);

    int days[] = new int[inst.DAYS_IN_WEEK];

    for (int i = 0; i < inst.DAYS_IN_WEEK; i++)
    {
        days[i] = Integer.parseInt(request.getParameter("day" + i));
    }

    boolean leaveOpen = (request.getParameter("open") != null);
    String  name      = request.getParameter("name");

    boolean success   = inst.saveTimeFilter(name, days);
%>

<html>
    <head>
        <title></title>
        <link type='text/css' rel='stylesheet' href='<%= MxOptions.URL_BASE %>/taskandjob/css/taskAndJob.css'>
        <script language='javascript' type='text/javascript' src='/SessionReset.js'></script>
        <script language='javascript' type='text/javascript' src='<%= MxOptions.URL_BASE %>/taskandjob/js/globals.js'></script>
        <script language='javascript' type='text/javascript' src='<%= MxOptions.URL_BASE %>/taskandjob/js/timeFilters.js'></script>
    </head>

    <body>

        <table id='miniGrid' border='0' cellspacing='0' cellpadding='0' style='visibility:hidden'>
            <tr>
                <td id='filtersSelect'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                    <select style='width:165' id='timeFilters' size='1' onChange='selectFilter(SELECT_PAGE, <%= timeStamp %>)'>
<%
    inst.dumpTimeFilterList(out, name, inst.MANAGE_PAGE);
%>
                    </select>
                </td>
                <td id='filtersManage'>
                    <select style='width:165' id='timeFilters' size='11' onClick='selectFilter(MANAGE_PAGE, <%= timeStamp %>)'>
<%
    inst.dumpTimeFilterList(out, name, inst.MANAGE_PAGE);
%>
                    </select>
                </td>
            </tr>
        </table>

        <script language='javascript' type='text/javascript'>
<%
    inst.dumpDeletableFilterArray(out);
%>
            if (<%= success %> == true)
            {
                var tdDest = parent.document.getElementById('filters');
                var tdSrc  = document.getElementById('filtersManage');
                tdDest.innerHTML = tdSrc.innerHTML;

                // copy the updated filter list to the Select Time Filter page
                var iframe = parent.parent.document.getElementById('displayTimeFilters');
                tdDest     = iframe.contentWindow.document.getElementById('filters');
                tdSrc      = document.getElementById('filtersSelect');
                tdDest.innerHTML = tdSrc.innerHTML;

                // copy over new Deleteable Array
                parent.builtIns = builtIns;

                // select the Filter on the Select Filter page
                iframe.contentWindow.selectFilter(SELECT_PAGE, <%= timeStamp %>);

                parent.selectFilter(BLANK_PAGE, <%= timeStamp %>);
                // only scroll to top of page if the manage filter page is going to close
                parent.closeTimeFilter(<%= leaveOpen %>);

                var select    = parent.document.getElementById('timeFilters');
                var selection = select.value;
                parent.checkBuiltIns(selection);

                if (<%= leaveOpen %> == false)
                {
                    parent.openManageFilters();
                }
            }
            else
            {
<%
                MxTaskAndJobMessages msg = inst.getMessages();
%>
                alert("<%= msg.getMessage() %>");
            }
        </script>

    </body>
</html>
