<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="tasksBean" class="com.hp.mx.portal.taskandjob.MxTaskAndJob" scope="session"/>

<%@ page import="com.hp.mx.html.core.MxButton"%>
<%@ page import="com.hp.mx.html.core.MxHtmlUtil"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobResourceBundle"%>
<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobInstance"%>
<%@ page import="com.hp.mx.portal.ui.MxBean"%>
<%@ page import="com.hp.mx.portal.ui.MxOptions"%>

<%
    // set header info
    MxBean.jspInit(request, response);

    // check to see if the loginBean session has timed out
    if (loginBean.checkLogoutConditionForWebPage(pageContext) == true)
    {
        return;
    }

    String                     taskAndJobTimeStamp = request.getParameter("taskAndJobTimeStamp");
    MxTaskAndJobInstance       inst                = (MxTaskAndJobInstance)tasksBean.getInstance(taskAndJobTimeStamp);
    MxTaskAndJobResourceBundle rb                  = inst.getRB();

    // if the Selected Job is no longer "RUNNING", then there is no need to reload
    // the taskInstanceFormatter.jsp file
    boolean jobRunning = inst.isSelectedJobRunning();
%>

<html>
    <head>
        <title></title>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/css/MxPortalEx.css'>
        <link type='text/css' rel='stylesheet' href='<%=MxOptions.URL_BASE%>/taskandjob/css/taskAndJob.css'>
        <script language='javascript' type='text/javascript' src='/AutoRefreshingSessionReset.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/js/MxPortalApi.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js'></script>
        <script language='javascript' type='text/javascript'>
            // we will only perform a reload if the Job is still running
            //////////////////////////////
            var jobRunning             = <%=jobRunning%>;
            var refreshStoppedJobCount = 0;
            //////////////////////////////
            // setJobRunning()
            //////////////////////////////
            function setJobRunning(running)
            {
                if (running == true)
                {
                    refreshStoppedJobCount = 0;
                    jobRunning = running;
                }
                else
                {
                    if (refreshStoppedJobCount >= REFRESH_STOPPED_JOB_COUNT)
                    {
                        jobRunning = running;
                    }
                    else
                    {
                        refreshStoppedJobCount++;
                    }
                }
            }
            //////////////////////////////
            var currentFormatFrame = FORMAT_FRAME_1;
            //////////////////////////////
            // autoRefresh()
            //////////////////////////////
            function autoRefresh()
            {
                if (jobRunning == true)
                {
                    // needs to update the "jobRunning" variable
                    var url = '<%=MxOptions.URL_BASE%>/taskandjob/updateTaskInstanceResults.jsp?taskAndJobTimeStamp=<%=taskAndJobTimeStamp%>';
                    document.getElementById('update').contentWindow.document.location.replace(url);

                    // load the "taskInstanceFormatter.jsp" in the "jobFormatter" iframe
                    url = '<%=MxOptions.URL_BASE%>/taskandjob/taskInstanceFormatter.jsp?taskAndJobTimeStamp=<%=taskAndJobTimeStamp%>';

                    // we draw the newer results in the hidden window, then 2.25 seconds
                    // later we switch which <iframe> is displaying
                    if (currentFormatFrame == FORMAT_FRAME_1)
                    {
                        document.getElementById('jobFormatter2').contentWindow.document.location.replace(url);
                    }
                    else
                    {
                        document.getElementById('jobFormatter').contentWindow.document.location.replace(url);
                    }

                    setTimeout('switchFrames()', IFRAME_SWITCH_TIMEOUT);
                }
            }
            ////////////////////////////////////////////////
            // displayInstanceFormatter()
            ////////////////////////////////////////////////
            function displayInstanceFormatter()
            {
                url = '<%=MxOptions.URL_BASE%>/taskandjob/taskInstanceFormatter.jsp?taskAndJobTimeStamp=<%=taskAndJobTimeStamp%>&firstTime=1';
                document.getElementById('jobFormatter').contentWindow.document.location.replace(url);
            }
            //////////////////////////////
            // setOurIFrameHeight()
            //////////////////////////////
            function setOurIFrameHeight()
            {
                var iframe = parent.document.getElementById(this.name);

                if (iframe == null)
                {
                    return;
                }

                iframe.style.height = document.getElementById('scrollDiv').scrollHeight + 10;
                redrawElement(iframe);
            }
            ////////////////////////////////////////////////
            // setOurIFrameWidth()
            ////////////////////////////////////////////////
            function setOurIFrameWidth()
            {
                var minWidth    = getIframeTop(this).minWidth;
                var windowWidth = MxPortalGetWorkspaceFrame().offsetWidth - NETSCAPE_SCROLLBAR_WIDTH;
                var newWidth    = (minWidth >= windowWidth) ? minWidth : '100%';
                // set width of our <iframe>
                parent.document.getElementById(this.name).style.width = newWidth;

                setTimeout('setOurIFrameWidth()', RESIZE_TIMEOUT);
            }
            ////////////////////////////////////////////////
            // myOnLoad()
            ////////////////////////////////////////////////
            function myOnLoad()
            {
                // get the width our element takes up
                var element    = document.getElementById('taskInstanceResultTable');
                var myMinWidth = element.offsetWidth;
                // attempt to set this as the minimum (there may
                // already be a larger value that is the minimum)
                setMinWidth(myMinWidth);
                // set our results table to 100% to use all available space
                element.style.width = '100%';
                // normal startup procedures
                setOurIFrameWidth();
                setOurIFrameHeight();
                displayInstanceFormatter();
            }
        </script>
<%
    MxHtmlUtil.dumpHeadBegin(out);
    MxButton.dumpHeadContent(out);
    MxHtmlUtil.dumpHeadEnd(out);
%>
    </head>

    <body onLoad='myOnLoad()'>

        <div id='scrollDiv'>

            <hr>

            <table id='taskInstanceResultHeader' border='0' cellspacing='0' cellpadding='0'>
                <tr>
                    <td><font class='mx-subheader-nosep'><%=rb.getString("RESULTS_TITLE")%></font></td>
                </tr>
            </table>

            <br id='br'>

            <table id='taskInstanceResultTable' border='0' cellpadding='0' cellspacing='0'>
                <tr>
                    <td id='taskInstanceResultInfo' nowrap>
<%
    inst.dumpTaskInstanceResultInfo(out);
%>
                    </td>
                </tr>
            </table>

            <iframe id='jobFormatter' name='jobFormatter' style='position:relative; visibility:visible; width:100%; height:0'
                    scrolling='no' marginwidth='0' frameborder='0' src='<%=MxOptions.URL_BASE%>/home/MxBlank.html'>
            </iframe>
            <iframe id='jobFormatter2' name='jobFormatter2' style='position:relative; visibility:hidden; width:100%; height:0'
                    scrolling='no' marginwidth='0' frameborder='0' src='<%=MxOptions.URL_BASE%>/home/MxBlank.html'>
            </iframe>

        </div> <!-- end scroll height -->

        <iframe id='update' name='update' style='position:relative; visibility:hidden; width:100%; height:0'
                scrolling='no' marginwidth='0' frameborder='0' src='<%=MxOptions.URL_BASE%>/home/MxBlank.html'>
        </iframe>
<%
    MxHtmlUtil.dumpBodyEnd(out);
%>
    </body>
</html>
