<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>
<jsp:useBean id="tasksBean" class="com.hp.mx.portal.taskandjob.MxTaskAndJob" scope="session"/>

<%@ page import="com.hp.mx.portal.taskandjob.MxTaskAndJobInstance"%>
<%@ page import="com.hp.mx.portal.ui.MxBean"%>
<%@ page import="com.hp.mx.portal.ui.MxOptions"%>

<%
    // set header info
    MxBean.jspInit(request, response);

    // check to see if the loginBean session has timed out
    if (loginBean.checkLogoutConditionForWebPage(pageContext) == true)
    {
        return;
    }

    String               taskAndJobTimeStamp = request.getParameter("taskAndJobTimeStamp");
    MxTaskAndJobInstance inst                = (MxTaskAndJobInstance)tasksBean.getInstance(taskAndJobTimeStamp);

    // if the Selected Job is no longer "RUNNING", then there is no need to reload
    // the taskInstanceFormatter.jsp file (in parent)
    boolean jobRunning = inst.isSelectedJobRunning();
%>

<html>
    <head>
        <title></title>
        <script language='javascript' type='text/javascript' src='/AutoRefreshingSessionReset.js'></script>
        <script language='javascript' type='text/javascript' src='<%=MxOptions.URL_BASE%>/taskandjob/js/globals.js'></script>
        <script language='javascript' type='text/javascript'>
            // update in the parent, Number of Tasks and divHeight (MxTable)
            function updateInfo()
            {
                parent.setJobRunning(<%=jobRunning%>);

                // update Task Result <table> info
                var tdSrc  = document.getElementById('fullTaskResultsInfo');
                var tdDest = parent.document.getElementById('fullTaskResultsInfo');

                if ((tdSrc != null) && (tdDest != null))
                {
                    tdDest.innerHTML = tdSrc.innerHTML;
                }
            }
        </script>
    </head>

    <body onLoad='updateInfo()'>

        <table border='0' cellpadding='0' cellspacing='0' style='width:100%'>
            <tr>
                <td id='fullTaskResultsInfo' nowrap>
<%
    inst.dumpTaskInstanceResultInfo(out);
%>
                </td>
            </tr>
        </table>

    </body>
</html>
