<%@ taglib uri="/com/hp/mx/taglibs/" prefix="mxtag" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />
<jsp:useBean id="demoBean" class="com.hp.mx.portal.test.MxDemoBean" scope="session" />

<%
    String jobid = request.getParameter("job");
    String szUser = request.getParameter("user");
    if (szUser != null
        && !com.hp.mx.portaljob.MxPortalJobManager.isAuthorized(jobid, szUser, request))
    {
        pageContext.forward("../home/MxNotAuthorized.jsp");
        return;
    }

    if (request.getParameter("PortalSetAside") != null)
    {
        pageContext.forward("MxProperties-2.jsp");
        return;
    }

    if (request.getParameter("reset") != null)
        demoBean.reset(jobid);

    String szSelection = request.getParameter("selection");
    if (szSelection != null)
        demoBean.setSelectedTab(jobid, szSelection);
%>

<HTML>
<HEAD>
<mxtag:MxTabs dumpHeadContent="true"/>
<TITLE></TITLE>
<style type="text/css">
    BODY {
        BACKGROUND-COLOR: #003366;
        FONT-FAMILY: arial,sans-serif;
    }

    TD.dark {
        BACKGROUND-COLOR: #003366;
        COLOR: white;
        FONT-FAMILY: arial,sans-serif;
    }

    TD.light {
        BACKGROUND-COLOR: white;
        FONT-FAMILY: arial,sans-serif;
    }
</style>

<script src="/SessionReset.js" language="JavaScript" type="text/javascript"></script>
<script src="/mxportal/js/MxMessageBox.js" language="JavaScript" type="text/javascript"></script>
<script src="/mxportal/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>

<script language="JavaScript" type="text/javascript">

function MsgBox()
{
    var b1 = new Array("&nbsp;&nbsp;OK&nbsp;&nbsp;", null);

    var s = "" + document.getElementById("ID_NOTE").innerHTML;

    MxPortalMessageBox(150, 150, 400, MSGBOX_INFO, "hp test", s, new Array(b1));
}

function TestNavFrame()
{
    var oFrame = MxPortalGetNavigationFrame();
    oFrame.src = "http://www.hp.com/";
}

</script>

</HEAD>

<BODY>

<table border=0 cellpadding=0 cellspacing=0>
<tr><td class="dark"><%=demoBean.getSelectedNodeName(loginBean, jobid)%><br><br></td></tr>
<tr><td class="dark">
<mxtag:MxTabs selection="<%=demoBean.getSelectedTab(jobid)%>" style="tt">
    <selectors>
        <selector id="IDENTITY">
            <label>identity</label>
            <url>
                <![CDATA[
                <%=request.getRequestURI()%>?job=<%=jobid%>&selection=IDENTITY
                ]]>
            </url>
        </selector>

        <selector id="STATUS">
            <label>
                <![CDATA[
                <img align="absbottom" src="/mxtaglibs/images/status_critical_sm_dk.gif" border="0">&nbsp;status
                ]]>
            </label>
            <url>
                <![CDATA[
                <%=request.getRequestURI()%>?job=<%=jobid%>&selection=STATUS
                ]]>
            </url>
        </selector>

        <selector id="CONFIG">
            <label>configuration</label>
            <url>
                <![CDATA[
                <%=request.getRequestURI()%>?job=<%=jobid%>&selection=CONFIG
                ]]>
            </url>
        </selector>

        <selector id="REPORTS">
            <label>reports</label>
            <url>
                <![CDATA[
                <%=request.getRequestURI()%>?job=<%=jobid%>&selection=REPORTS
                ]]>
            </url>
        </selector>

        <selector id="SUPPORT">
            <label>support</label>
            <url>
                <![CDATA[
                <%=request.getRequestURI()%>?job=<%=jobid%>&selection=SUPPORT
                ]]>
            </url>
        </selector>
    </selectors>
</mxtag:MxTabs>
</td></tr>

<tr><td class="light">
    <br><% demoBean.dumpHtmlContent(jobid, out); %>
</td></tr>

<tr><td class="light">
    <a href="javascript:MxPortalWorkspaceClose()">Close workspace</a><br>
<br>
    <a href="javascript:MxPortalWorkspaceSetHelpUrl('http://www.yahoo.com/')">Set help URL to Yahoo</a><br>
    <a href="javascript:MxPortalWorkspaceSetHelpTopic('admin_auth_add')">Help: adding authorizations</a><br>
    <a href="javascript:MxPortalWorkspaceSetHelpTopic('use_tool')">Help: using tools</a><br>
    <a href="javascript:MxPortalOpenHelpTopic('use_tool')">Open topic: using tools</a><br>
    <a href="javascript:MxPortalWorkspaceSetHelpTopicEx('mxportal', 'use_tool')">HelpEx: using tools</a><br>
    <a href="javascript:alert(MxPortalWorkspaceGetHelpUrl())">Display help URL</a><br>
<br>
    <a href="javascript:MsgBox()">MessageBox</a><br>
<br>
    <a href="javascript:MxPortalRefreshNavigationArea()">Refresh Navigation Area</a><br>
    <a href="javascript:MxPortalManageMenuRefresh()">Refresh the Manage Menu</a><br>
    <a href="javascript:MxPortalRefreshLeftSide()">Refresh Left Side</a><br>
    <a href="javascript:MxPortalRefreshRightSide()">Refresh Right Side</a><br>
    <a href="javascript:MxPortalRefreshStatusOverview()">Refresh Status Overview</a><br>
<br>
    <a href="javascript:MxPortalLogout()">Log out</a><br>
    <a href="/mxportal/home/MxNotAuthorized.jsp">Not authorized message</a><br>
    <a href="javascript:TestNavFrame()">Blow away the navigation frame</a><br>
<br>
    <a href="javascript:alert(MxPortalWorkspaceGetTitleHtml())">Get title</a><br>
    <a href="javascript:MxPortalWorkspaceSetTitleHtml('Is this not <script> special?')">Set title</a><br>
    <a href="javascript:MxPortalWorkspaceSetSubtitleHtml('Hello: world')">Set subtitle #1</a><br>
    <a href="javascript:MxPortalWorkspaceSetSubtitleHtml('<u>Howdy</u>: world<br>Line 2')">Set subtitle #2</a><br>
    <a href="javascript:MxPortalWorkspaceSetSubtitleHtml('&nbsp;')">Set subtitle #3</a><br>
<br>
    <a href="javascript:MxPortalWorkspaceCreate('HOME_PAGE_SETTINGS', 'extra=true')">Extra params: HOME_PAGE_SETTINGS</a><br>
    <a href="javascript:MxPortalWorkspaceCreate('UPDATE_SW_FW', 'extra=true')">Extra params: UPDATE_SW_FW</a><br>
    <a href="javascript:MxPortalWorkspaceCreate('ID_PING', 'extra=true')">Extra params: ID_PING</a><br>
<br>
    <a href="javascript:MxPortalWorkspaceCreateUrl('My Special Title', 'http://www.hp.com/')">Create URL</a><br>
    <a href="javascript:MxPortalWorkspaceCreateUrlEx('My Special Title', 'And this is my special subtitle', 'http://www.hp.com/')">Create URL with subtitle</a><br>
<br>
    <a href="javascript:MxPortalSnapOffCreate('HOME_PAGE_SETTINGS', '_blank')">Snap off: HOME_PAGE_SETTINGS</a><br>
    <a href="javascript:MxPortalSnapOffCreate('UPDATE_SW_FW', '_blank')">Snap off: UPDATE_SW_FW</a><br>
    <a href="javascript:MxPortalSnapOffCreate('ID_PING')">Snap off: ID_PING</a><br>
    <a href="javascript:MxPortalSnapOffCreate('ID_PING', 'FRAME_PING')">Snap off (re-use): ID_PING</a><br>
</td></tr>

</table>

<div id="ID_NOTE" style="position:absolute; visibility:hidden;">
    This is a test.
    <br><br>
    This is a test of the emergency broadcast system.
    <br><br>
    This is only a test.
    <br><br>
    <input id="XXX_ID_XXX" type="checkbox">Never display this message again.
</div>

</BODY>
</HTML>
