<%@ page import="java.io.*" %>
<%@ page import="java.util.*" %>
<%@ page import="com.hp.mx.core.alertmanager.*" %>
<%@ page import="com.hp.mx.core.nodemanager.*" %>
<%@ page import="com.hp.mx.core.jobmanager.*" %>
<%@ page import="com.hp.mx.html.core.*" %>
<%@ page import="com.hp.mx.portal.ui.*" %>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session" />

<%!

void dumpTableMxStatusIcon(JspWriter out, Locale locale)
    throws IOException
{
    MxStatusIcon[] icons = {
        MxStatusIcon.CRITICAL,
        MxStatusIcon.MAJOR,
        MxStatusIcon.MINOR,
        MxStatusIcon.WARNING,
        MxStatusIcon.NORMAL,
        MxStatusIcon.DISABLED,
        MxStatusIcon.UNKNOWN,
        MxStatusIcon.INFORMATIONAL,
        MxStatusIcon.TRANSPARENT,
        MxStatusIcon.NONE,
    };

    out.println("<table cellpadding='2' callspacing='2'>");

    for (int i = 0; i < icons.length; i++)
    {
        out.println("<tr>");
            out.println("<td>");
                out.println(icons[i].getLabel(locale));
            out.println("</td>");
            out.println("<td><img src='");
                out.println(icons[i].getIcon());
            out.println("'></td>");
            out.println("<td style='background-color:#ccc'><img src='");
                out.println(icons[i].getIconWithBorder());
            out.println("'></td>");
       out.println("</tr>");
    }

    out.println("</table>");
}

void dumpTableAlertSeverity(JspWriter out, Locale locale)
    throws IOException
{
    AlertSeverity[] icons = {
        AlertSeverity.CRITICAL,
        AlertSeverity.MAJOR,
        AlertSeverity.MINOR,
        AlertSeverity.WARNING,
        AlertSeverity.NORMAL,
        AlertSeverity.DISABLED,
        AlertSeverity.UNKNOWN,
        AlertSeverity.INFORMATIONAL,
    };

    out.println("<table cellpadding='2' callspacing='2'>");

    for (int i = 0; i < icons.length; i++)
    {
        out.println("<tr>");
            out.println("<td>");
                out.println(icons[i].getLabel(locale));
            out.println("</td>");
            out.println("<td><img src='");
                out.println(icons[i].getIcon());
            out.println("'></td>");
            out.println("<td style='background-color:#ccc'><img src='");
                out.println(icons[i].getIconWithBorder());
            out.println("'></td>");
       out.println("</tr>");
    }

    out.println("</table>");
}

void dumpTableDeviceStatusType(JspWriter out, Locale locale)
    throws IOException
{
    DeviceStatusType[] icons = {
        DeviceStatusType.CRITICAL,
        DeviceStatusType.MAJOR,
        DeviceStatusType.MINOR,
        DeviceStatusType.WARNING,
        DeviceStatusType.NORMAL,
        DeviceStatusType.DISABLED,
        DeviceStatusType.UNKNOWN,
    };

    out.println("<table cellpadding='2' callspacing='2'>");

    for (int i = 0; i < icons.length; i++)
    {
        out.println("<tr>");
            out.println("<td>");
                out.println(icons[i].getLabel(locale));
            out.println("</td>");
            out.println("<td><img src='");
                out.println(icons[i].getIcon());
            out.println("'></td>");
            out.println("<td style='background-color:#ccc'><img src='");
                out.println(icons[i].getIconWithBorder());
            out.println("'></td>");
       out.println("</tr>");
    }

    out.println("</table>");
}

void dumpTableMxJobState_t(JspWriter out, Locale locale)
    throws IOException
{
    MxJobState_t[] icons = {
        MxJobState_t.Values.CANCELLED,
        MxJobState_t.Values.COMPLETE,
        MxJobState_t.Values.FAILED,
        MxJobState_t.Values.INVALID,
        MxJobState_t.Values.LAUNCHED,
        MxJobState_t.Values.PENDING,
        MxJobState_t.Values.RUNNING,
        MxJobState_t.Values.SOME_FAILURES,
    };

    out.println("<table cellpadding='2' callspacing='2'>");

    for (int i = 0; i < icons.length; i++)
    {
        out.println("<tr>");
            out.println("<td>");
                out.println(icons[i].getLabel(locale));
            out.println("</td>");
            out.println("<td><img src='");
                out.println(icons[i].getIcon());
            out.println("'></td>");
            out.println("<td style='background-color:#ccc'><img src='");
                out.println(icons[i].getIconWithBorder());
            out.println("'></td>");
       out.println("</tr>");
    }

    out.println("</table>");
}

%>

<%
    MxBean.jspInit(request, response);
%>

<html>

<head>
<title></title>
<% MxHtmlUtil.dumpHeadBegin(out); %>
<% MxHtmlUtil.dumpHeadEnd(out); %>
</head>

<body>

<table border="1" cellpadding="5" cellspacing="0">
<tr>
    <td valign="top">
        MxStatusIcon (English)
        <br><br>
        <% dumpTableMxStatusIcon(out, Locale.ENGLISH); %>
    </td>
    <td valign="top">
        AlertSeverity (English)
        <br><br>
        <% dumpTableAlertSeverity(out, Locale.ENGLISH); %>
    </td>
    <td valign="top">
        DeviceStatusType (English)
        <br><br>
        <% dumpTableDeviceStatusType(out, Locale.ENGLISH); %>
    </td>
    <td valign="top">
        MxJobState_t (English)
        <br><br>
        <% dumpTableMxJobState_t(out, Locale.ENGLISH); %>
    </td>
</tr>
<tr>
    <td valign="top">
        MxStatusIcon (Japanese)
        <br><br>
        <% dumpTableMxStatusIcon(out, Locale.JAPANESE); %>
    </td>
    <td valign="top">
        AlertSeverity (Japanese)
        <br><br>
        <% dumpTableAlertSeverity(out, Locale.JAPANESE); %>
    </td>
    <td valign="top">
        DeviceStatusType (Japanese)
        <br><br>
        <% dumpTableDeviceStatusType(out, Locale.JAPANESE); %>
    </td>
    <td valign="top">
        MxJobState_t (Japanese)
        <br><br>
        <% dumpTableMxJobState_t(out, Locale.JAPANESE); %>
    </td>
</tr>
</table>

</BODY>
</HTML>
