//**********************************************************************************************
//  Functions for <Assign To> button
//**********************************************************************************************

function assignEvents()
{
    document.getElementById("ID_EDIT_EVENT_SPACE").contentWindow.document.location.replace("AssignEventTo.jsp?iframe=true");
    MxPortalWorkspaceSetHelpTopic( "monitor_event_assign" );
}

function enableInputBox()
{
    document.getElementById( "newAssigneeRadioID" ).checked = true;
    document.getElementById( "newAssigneeInputID" ).disabled = false;
    document.getElementById( "newAssigneeInputID" ).focus();
    document.getElementById( "existingAssigneeRadioID" ).checked = false;
    document.getElementById( "existingAssigneeSelectID" ).disabled = true;

    isNewAssignee = true;
}

function enableSelectBox()
{
    document.getElementById( "newAssigneeRadioID" ).checked = false;
    document.getElementById( "newAssigneeInputID" ).disabled = true;
    document.getElementById( "existingAssigneeRadioID" ).checked = true;
    document.getElementById( "existingAssigneeSelectID" ).disabled = false;
    document.getElementById( "existingAssigneeSelectID" ).focus();
    ourButtonManager.enableButtonById('okButtonID');

    isNewAssignee = false;
}

//**********************************************************************************************
//  Functions for <Enter Comments> button
//**********************************************************************************************

function enterEventComments()
{
    document.getElementById("ID_EDIT_EVENT_SPACE").contentWindow.document.location.replace("EnterEventComments.jsp?iframe=true");
    MxPortalWorkspaceSetHelpTopic( "monitor_event_addComments" );
}

//**********************************************************************************************
//  Functions for <View Printable Report> button
//**********************************************************************************************

function loadEventPrintReport( subTitle )
{
    document.getElementById("ID_EDIT_EVENT_SPACE").contentWindow.document.location.replace("EmptyFrame.jsp?iframe=true");
}

function loadPrintPreviewEventDetails( alertId )
{
    window.parent.document.getElementById("ID_EDIT_EVENT_SPACE").contentWindow.document.location.replace("EmptyFrame.jsp?iframe=true");

    var jspURLParam = ( "PrintPreviewEventDetails.jsp?alertID=" );
    jspURLParam += alertId ;
    window.open( jspURLParam, "PrintPreviewEventDetails",
                "toolbar=yes, location=no, directories=no,status=no,menubar=yes,scrollbars=yes,resizable=yes,copyhistory=no, width=750,height=800" );
}

//**********************************************************************************************
//  Functions to automatically resize the Edit Event space iframe
//**********************************************************************************************
function OnLoadForAssignToSpace()
{
    OnResizeForNewEditEventSpace( 50 );
    setTimeout("setFocusToNewEditEventSpace( 'cancelButtonID' )", 250);
    setTimeout("enableInputBox()", 500);
}

function OnLoadForViewEventDetailsSpace()
{
    OnResizeForNewEditEventSpace( );
    setTimeout("setFocusToNewEditEventSpace( 'printEventDetailsButtonID' )", 500);
}

function OnLoadForEnterEventCommentSpace()
{
    OnResizeForNewEditEventSpace( );
    setTimeout("setFocusToNewEditEventSpace( 'cancelButtonID' )", 250);
    setTimeout("setTextFocus()", 500);
}

function OnResizeForNewEditEventSpace()
{
    resizeNewEditEventSpaceHeight( 50 );
}

function resizeNewEditEventSpaceHeight( offsetValue )
{
    var myIframeElement = window.parent.document.getElementById( "ID_EDIT_EVENT_SPACE" );
    var newHeight = document.getElementById( "NewEditEventSpaceID" ).offsetHeight;
    myIframeElement.style.height = newHeight + offsetValue ;

    var advanceSearchIframe = window.parent.parent.document.getElementById( "resultSpace" );
    if ( advanceSearchIframe != null )
        advanceSearchIframe.style.height = newHeight + 420;
}

function OnUnloadForNewEditEventSpace()
{
    var advanceSearchIframe = window.parent.parent.document.getElementById( "resultSpace" );
    if ( advanceSearchIframe != null )
    {
        advanceSearchIframe.style.height = 420;
    }
}

function setFocusToNewEditEventSpace( elementID )
{
    document.getElementById( elementID ).focus();
}

function setTextFocus()
{
    document.getElementById( "newEventCommentsID" ).focus();
}

function resetEditEventSpaceHeight()
{
    var editEventSpaceElement = window.parent.document.getElementById( "ID_EDIT_EVENT_SPACE" );
    if ( editEventSpaceElement != null )
    {
        editEventSpaceElement.style.height = 1;
    }
}

//**********************************************************************************************
//  General functions
//**********************************************************************************************
function enableEventButtons( buttonState )
{
    var anyButton = document.getElementById( "ID_CLEAR_BUTTON" );

    if (anyButton)
    {
        if (buttonState)
        {
            ourButtonManager.enableButtonById('ID_CLEAR_BUTTON');
            ourButtonManager.enableButtonById('ID_DELETE_BUTTON');
            ourButtonManager.enableButtonById('ID_ASSIGN_TO_BUTTON');
            ourButtonManager.enableButtonById('ID_ENTER_COMMENT');
        }
        else
        {
            ourButtonManager.disableButtonById('ID_CLEAR_BUTTON');
            ourButtonManager.disableButtonById('ID_DELETE_BUTTON');
            ourButtonManager.disableButtonById('ID_ASSIGN_TO_BUTTON');
            ourButtonManager.disableButtonById('ID_ENTER_COMMENT');
        }
    }
}

function enableOKButton( inputID )
{
    if ( eval( "document.getElementById( inputID ).value.length" ) == 0 )
    {
        ourButtonManager.disableButtonById('okButtonID');
    }
    else
    {
        ourButtonManager.enableButtonById('okButtonID');
    }
}
