<%--
//-------------------------------------------------------------------------------
//---- © 2003 Hewlett-Packard Development Group, L.P.
//-------------------------------------------------------------------------------
// Author: George Chuang
//
// Description: Load Ping Result Page
//-------------------------------------------------------------------------------
// $ProjectName: j:/maple/coreWap.pj $
// $Header: /var/cvs/nimbus/src/hpwebadmin/webapps/ROOT/ui/jsp/pingResultLoader.jsp,v 1.26 2005/04/01 23:24:07 chuangg Exp $
//-------------------------------------------------------------------------------
--%>

<jsp:useBean id="loginBean" class="com.hp.mx.portal.ui.MxLoginBean" scope="session"/>

<%@ page import="com.hp.mx.portal.ui.*,
           com.hp.mx.core.nodemanager.*,
           com.hp.mx.core.controllers.MxNodeController,
           com.hp.mx.core.protocol.reachable.Reachable,
           com.hp.mx.core.protocol.ipx.*,
           java.util.*"
%>

<!-- process parameter and execute chores  -->
<%
    MxBean.jspInit(request, response);
    Locale locale = loginBean.getLocale();
    String devName = request.getParameter("nodeName");
    if ( devName==null )
        devName = "";
    String dName = devName;
    String curIp = "";
    String type = "";
    NodeTypeMapper nodeTypeMapper = null;
    //NodeSubTypeMapper nodeSubTypeMapper = null;
    String devType = "";
    String devProductName = "";
    String osName = "";
    String sResult = null;  //0: replied, 1: timed out, 2:device is deleted, 3:device has no address
    long elapseTime = 0;

    if ( devName.equals("") )
    {
        MxDateAndTime theTime = new MxDateAndTime(loginBean.getLocale(),loginBean.getTimeZone());
        String currentTime = theTime.getDateAndTimeFormatString(theTime.DATE_TIME_FULL_FORMAT);
%>

<script language='javascript' type='text/javascript'>
    parent.resultTable.updateStatus("<%=currentTime%>");
</SCRIPT>

<%
    }
    else
    {
        boolean bRet = false;
        int retries = 4;
        int timeout = 2;
        MxNode dev = null;
        try
        {
            dev =  MxNodeController.getDefaultControllerNoEx().getNodeByNodeOrHostName(devName);
            dName = dev.getNameString();
            osName = dev.getOSNameStr();
            type = dev.getDeviceType();
            nodeTypeMapper = NodeTypeMapper.getDefaultMapper();
            devType = nodeTypeMapper.getLocalizedDisplayString(type,locale);
            //type = dev.getDeviceSubType();
            //if ( (!type.equals("None")) && (type!=null) )   //this device has a sub-type
            //{
            //    nodeSubTypeMapper = NodeSubTypeMapper.getDefaultMapper();
            //    devType += " " + nodeSubTypeMapper.getLocalizedDisplayString(type,locale);
            //}
            devProductName = dev.getModel();
        }
        catch(Exception ex)
        {
            dev = null;
        }

        //
        // If the device exists in the job list but no longer in the device list
        // then it has been deleted.
        // Or, if the device still exists in the device list, but has been marked
        // as deleted then it is deleted.
        if ( ( null == dev ) || ( dev.isDeviceDeleted() ) )
        {
            sResult = "2";
%>

<script language='javascript' type='text/javascript'>
    parent.resultTable.addRow("<%=dName%>","<%=devType%>","<%=curIp%>","<%=devProductName%>","<%=osName%>","<%=sResult%>","");
</SCRIPT>

<%
        }
        else            //the device still exists
        {
            Calendar rightNow = Calendar.getInstance();
            long startTime = 0;
            long endingTime = 0;
            retries = dev.getSnmpRetry();
            timeout = dev.getSnmpTimeOut();

            // Ping IP address(es)
            boolean hasOneAddr = false;
            Iterator iter = dev.getIPAddressList().iterator();

                while (iter.hasNext())
                {
                    hasOneAddr = true;
                    curIp = (String)iter.next();
                    rightNow = Calendar.getInstance();
                    startTime = rightNow.getTimeInMillis();
                    bRet = Reachable.isAddressReachable(curIp, timeout, retries);
                    rightNow = Calendar.getInstance();
                    endingTime = rightNow.getTimeInMillis();
                    if ( bRet )
                    {
                        sResult = "0";
                    }
                    else
                    {
                        sResult = "1";
                    }
                    elapseTime = endingTime - startTime;

%>

<script language='javascript' type='text/javascript'>
    parent.resultTable.addRow("<%=dName%>","<%=devType%>","<%=curIp%>","<%=devProductName%>","<%=osName%>","<%=sResult%>","<%=(int)elapseTime%>");
</SCRIPT>

<%
                }


            // Ping IPX address(es)
            iter = dev.getIPXAddressList().iterator();

                IpxConfigRequest ipxConfigReq;

                while(iter.hasNext())
                {
                    hasOneAddr = true;
                    String curIpx = (String)iter.next();

                    ipxConfigReq = new IpxConfigRequest(curIpx, retries, timeout);
                    rightNow = Calendar.getInstance();
                    startTime = rightNow.getTimeInMillis();
                    bRet = ipxConfigReq.SendRequest();
                    rightNow = Calendar.getInstance();
                    endingTime = rightNow.getTimeInMillis();
                    if ( bRet )
                    {
                        sResult = "0";
                    }
                    else
                    {
                        sResult = "1";
                    }
                    elapseTime = endingTime - startTime;
%>

<script language='javascript' type='text/javascript'>
    parent.resultTable.addRow("<%=dName%>","<%=devType%>","<%=curIpx%>","<%=devProductName%>","<%=osName%>","<%=sResult%>","<%=(int)elapseTime%>");
</SCRIPT>

<%
                }

            if ( hasOneAddr == false )  //there are no IP or IPX address
            {
                sResult = "3";
%>

<script language='javascript' type='text/javascript'>
    parent.resultTable.addRow("<%=dName%>","<%=devType%>","<%=curIp%>","<%=devProductName%>","<%=osName%>","<%=sResult%>","");
</SCRIPT>

<%
            }
        }

%>

<script language='javascript' type='text/javascript'>
    parent.pingNextDevice();
</SCRIPT>

<%
    }
%>
